/**
 * 
 */
package com.ejie.ab60.adaptadores;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ejie.ab60.adaptadores.service.ab61WebServiceService;
import com.ejie.ab60.clientesWS.ab61WebService.Ab61Exception;
import com.ejie.ab60.clientesWS.ab61WebService.BusquedasWS;
import com.ejie.ab60.clientesWS.ab61WebService.Origen;

/**
 *  
 * 
 */
@Service(value = "ab61WebServiceAdaptadorServiceImpl")
public class ab61WebServiceAdaptadorServiceImpl implements ab61WebServiceAdaptadorService {

	public static final Logger logger = LoggerFactory.getLogger(ab61WebServiceAdaptadorServiceImpl.class);

	@Autowired()
	private ab61WebServiceService ab61WebServiceService;

	public String generarExcelListados(int idListado, List<BusquedasWS> listaBusquedas, String codAplic,
			Integer idProcedimiento) throws Ab61Exception {
		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.generarExcelListados - Inicio");
		String respuesta = this.ab61WebServiceService.generarExcelListados(idListado, listaBusquedas, codAplic,
				idProcedimiento);

		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.generarExcelListados - Return: " + respuesta);
		return respuesta;
	}

	@Override
	public String descargarDocumento(Integer idPlantilla, String procedureId, String foderId,
			String identificadorInspeccion, String codAplic) throws Ab61Exception {
		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.descargarDocumento - Inicio");
		return this.ab61WebServiceService.descargarDocumento(idPlantilla, procedureId, foderId, identificadorInspeccion,
				codAplic);
	}

	@Override
	public String descargarDocumentoNegocio(Integer idPlantilla, String identificador, Origen origen, String codAplic)
			throws Ab61Exception {
		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.descargarDocumentoNegocio - Inicio");
		return this.ab61WebServiceService.descargarDocumentoNegocio(idPlantilla, identificador, origen, codAplic);
	}

	@Override
	public String generarDocumento(Integer idPlantilla, String procedureId, String foderId,
			String identificadorInspeccion, String usuario) throws Ab61Exception {
		ab61WebServiceAdaptadorServiceImpl.logger.info("ab61WebServiceAdaptadorServiceImpl.generarDocumento - Inicio");
		return this.ab61WebServiceService.generarDocumento(idPlantilla, procedureId, foderId, identificadorInspeccion,
				usuario);
	}

	@Override
	public String generarDocumentoNegocio(Integer idPlantilla, String identificador, Origen origen, String usuario)
			throws Ab61Exception {
		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.generarDocumentoNegocio - Inicio");
		return this.ab61WebServiceService.generarDocumentoNegocio(idPlantilla, identificador, origen, usuario);
	}

	@Override
	public String modificarDocumento(Integer idPlantilla, String procedureId, String foderId,
			String identificadorInspeccion, String usuario) throws Ab61Exception {
		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.modificarDocumento - Inicio");
		String respuesta = this.ab61WebServiceService.modificarDocumento(idPlantilla, procedureId, foderId,
				identificadorInspeccion, usuario);

		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.modificarDocumento - Return: " + respuesta);
		return respuesta;
	}

	@Override
	public String modificarDocumentoNegocio(Integer idPlantilla, String identificador, String usuario)
			throws Ab61Exception {
		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.modificarDocumentoNegocio - Inicio");
		String respuesta = this.ab61WebServiceService.modificarDocumentoNegocio(idPlantilla, identificador, usuario);

		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.modificarDocumentoNegocio - Return: " + respuesta);
		return respuesta;
	}

	/**
	 * llama al webService que realiza la tarea indicada
	 * 
	 * @param idPlantilla
	 *            Integer
	 * @param procedureId
	 *            String
	 * @param folderId
	 *            String
	 * @param n38Login
	 *            String
	 * @return String
	 * @throws Ab61Exception
	 */
	@Override
	public String aportarDocumento(Integer idPlantilla, String procedureId, String folderId, String n38Login,
			String usuario) throws Ab61Exception {
		ab61WebServiceAdaptadorServiceImpl.logger.info("ab61WebServiceAdaptadorServiceImpl.aportarDocumento - Inicio");
		String respuesta = this.ab61WebServiceService.aportarDocumento(idPlantilla, procedureId, folderId, n38Login,
				usuario);

		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.aportarDocumento - Return: " + respuesta);
		return respuesta;
	}

	@Override
	public String aportarDocumentoNegocio(Integer idPlantilla, String procedureId, String folderId, String n38Login,
			String usuario) throws Ab61Exception {
		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.aportarDocumentoNegocio - Inicio");
		String respuesta = this.ab61WebServiceService.aportarDocumentoNegocio(idPlantilla, procedureId, folderId,
				n38Login, usuario);

		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.aportarDocumentoNegocio - Return: " + respuesta);
		return respuesta;
	}

	public String eliminarDocumento(Integer idPlantilla, String folderId, String procedureId,
			String identificadorInspeccion) throws Ab61Exception {
		ab61WebServiceAdaptadorServiceImpl.logger.info("ab61WebServiceAdaptadorServiceImpl.eliminarDocumento - Inicio");
		String respuesta = this.ab61WebServiceService.eliminarDocumento(idPlantilla, folderId, procedureId,
				identificadorInspeccion);

		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.eliminarDocumento - Return: " + respuesta);
		return respuesta;
	}

	@Override
	public String eliminarDocumentoNegocio(Integer idPlantilla, String identificador) throws Ab61Exception {
		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.eliminarDocumentoNegocio - Inicio");
		String respuesta = this.ab61WebServiceService.eliminarDocumentoNegocio(idPlantilla, identificador);

		ab61WebServiceAdaptadorServiceImpl.logger
				.info("ab61WebServiceAdaptadorServiceImpl.eliminarDocumentoNegocio - Return: " + respuesta);
		return respuesta;
	}

}
