/**
 * 
 */
package com.ejie.ab60.adaptadores;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ejie.ab60.adaptadores.service.ab79WebServiceService;
import com.ejie.ab60.clientesWS.ab79WebService.Ab79Exception;
import com.ejie.ab60.clientesWS.ab79WebService.InspeccionWS;
import com.ejie.ab60.clientesWS.ab79WebService.PreguntasExpedienteWS;
import com.ejie.ab60.model.usuario.Usuario;

/**
 *  
 * 
 */
@Service(value = "ab79WebServiceAdaptadorServiceImpl")
public class ab79WebServiceAdaptadorServiceImpl implements ab79WebServiceAdaptadorService {

	public static final Logger logger = LoggerFactory.getLogger(ab79WebServiceAdaptadorServiceImpl.class);

	@Autowired()
	private ab79WebServiceService ab79WebServiceService;

	@Override
	public String crearInspeccion(String folderId, InspeccionWS inspeccion,
			List<PreguntasExpedienteWS> preguntasExpedienteWS, Usuario usuario, Integer idOrigenInspeccion,
			Integer idTerceroTitular, Integer idDireccionUbicacionActividad, String procedureId, String numDenuncia,
			String procedureIdOrigen) throws Ab79Exception {
		ab79WebServiceAdaptadorServiceImpl.logger.info("ab79WebServiceAdaptadorServiceImpl.eliminarDocumento - Inicio");
		String respuesta = this.ab79WebServiceService.crearInspeccion(folderId, inspeccion, preguntasExpedienteWS,
				usuario, idOrigenInspeccion, idTerceroTitular, idDireccionUbicacionActividad, procedureId, numDenuncia,
				procedureIdOrigen);

		ab79WebServiceAdaptadorServiceImpl.logger
				.info("ab79WebServiceAdaptadorServiceImpl.crearInspeccion - Return: " + respuesta);
		return respuesta;
	}

	@Override
	public String eliminarInspeccion(String identificadorInspeccion, String usuario) throws Ab79Exception {
		ab79WebServiceAdaptadorServiceImpl.logger
				.info("ab79WebServiceAdaptadorServiceImpl.eliminarInspeccion - Inicio");
		String respuesta = this.ab79WebServiceService.eliminarInspeccion(identificadorInspeccion, usuario);
		ab79WebServiceAdaptadorServiceImpl.logger
				.info("ab79WebServiceAdaptadorServiceImpl.eliminarInspeccion - Return: " + respuesta);
		return respuesta;
	}
}
