package com.ejie.ab60.dao.BEC;

import com.ejie.ab60.model.BEC.Caracteristicas;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * CaracteristicasDao  
 *  
 */

public interface CaracteristicasDao {
    
    /**
     * Inserts a single row in the Caracteristicas table.
     *
     * @param caracteristicas Caracteristicas
     * @return Caracteristicas
     */
    Caracteristicas add(Caracteristicas caracteristicas);

    /**
     * Updates a single row in the Caracteristicas table.
     *
     * @param caracteristicas Caracteristicas
     * @return Caracteristicas
     */
    Caracteristicas update(Caracteristicas caracteristicas);

    /**
     * Finds a single row in the Caracteristicas table.
     *
     * @param caracteristicas Caracteristicas
     * @return Caracteristicas
     */
    Caracteristicas find(Caracteristicas caracteristicas);

    /**
     * Removes a single row in the Caracteristicas table.
     *
     * @param caracteristicas Caracteristicas
     */
    void remove(Caracteristicas caracteristicas);

    /**
     * Finds a List of rows in the Caracteristicas table.
     *
     * @param caracteristicas Caracteristicas
     * @param jqGridRequestDto JQGridRequestDto
     * @return List
     */
    List<Caracteristicas> findAll(Caracteristicas caracteristicas, JQGridRequestDto jqGridRequestDto);

	/**
     * Finds rows in the Caracteristicas table using like.
     *
     * @param caracteristicas Caracteristicas
     * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean
     * @return List
     */
	List<Caracteristicas> findAllLike(Caracteristicas caracteristicas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Filter in the Caracteristicas table.
	 *
	 * @param filterCaracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	 void removeMultiple(Caracteristicas filterCaracteristicas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
    /**
     * Counts rows in the Caracteristicas table using like.
     *
     * @param caracteristicas Caracteristicas
     * @param startsWith Boolean
     * @return Long
     */
    Long findAllLikeCount(Caracteristicas caracteristicas, Boolean startsWith);
    
    /**
     * Counts rows in the Caracteristicas table.
     *
     * @param caracteristicas Caracteristicas
     * @return Long
     */
    Long findAllCount(Caracteristicas caracteristicas);
    
    /**
	 * Reorder selection.
	 *
	 * @param filterCaracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<Caracteristicas>>
	 */	
    List<TableRowDto<Caracteristicas>> reorderSelection(Caracteristicas filterCaracteristicas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
     /**
	 * Searches in the Usuario table.
	 *
	 * @param filterCaracteristicas Caracteristicas
	 * @param searchCaracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<Caracteristicas>>	 
	 */	
    List<TableRowDto<Caracteristicas>> search(Caracteristicas filterCaracteristicas, Caracteristicas searchCaracteristicas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
    
    /**
	 * Filter in the hierarchical Caracteristicas table.
	 *
	 * @param filterCaracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<JerarquiaDto<Caracteristicas>>
	 */	
	List<JerarquiaDto<Caracteristicas>> findAllLikeJerarquia(Caracteristicas filterCaracteristicas, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Count rows in hierarchy
	 *
	 * @param filterCaracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return Long
	 */	
	Long findAllLikeCountJerarquia(Caracteristicas filterCaracteristicas, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterCaracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<TableRowDto<Caracteristicas>>
	 */	
	List<TableRowDto<Caracteristicas>> findAllChild(Caracteristicas filterCaracteristicas, JQGridRequestDto jqGridRequestDto);
	
	
}

