package com.ejie.ab60.dao.BEC;

import com.ejie.ab60.model.BEC.ExperienciaLaboral;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * ExperienciaLaboralDao  
 *  
 */

public interface ExperienciaLaboralDao {
    
    /**
     * Inserts a single row in the ExperienciaLaboral table.
     *
     * @param experiencialaboral ExperienciaLaboral
     * @return ExperienciaLaboral
     */
    ExperienciaLaboral add(ExperienciaLaboral experiencialaboral);

    /**
     * Updates a single row in the ExperienciaLaboral table.
     *
     * @param experiencialaboral ExperienciaLaboral
     * @return ExperienciaLaboral
     */
    ExperienciaLaboral update(ExperienciaLaboral experiencialaboral);

    /**
     * Finds a single row in the ExperienciaLaboral table.
     *
     * @param experiencialaboral ExperienciaLaboral
     * @return ExperienciaLaboral
     */
    ExperienciaLaboral find(ExperienciaLaboral experiencialaboral);

    /**
     * Removes a single row in the ExperienciaLaboral table.
     *
     * @param experiencialaboral ExperienciaLaboral
     */
    void remove(ExperienciaLaboral experiencialaboral);

    /**
     * Finds a List of rows in the ExperienciaLaboral table.
     *
     * @param experiencialaboral ExperienciaLaboral
     * @param jqGridRequestDto JQGridRequestDto
     * @return List
     */
    List<ExperienciaLaboral> findAll(ExperienciaLaboral experiencialaboral, JQGridRequestDto jqGridRequestDto);

	/**
     * Finds rows in the ExperienciaLaboral table using like.
     *
     * @param experiencialaboral ExperienciaLaboral
     * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean
     * @return List
     */
	List<ExperienciaLaboral> findAllLike(ExperienciaLaboral experiencialaboral, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Filter in the ExperienciaLaboral table.
	 *
	 * @param filterExperienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	 void removeMultiple(ExperienciaLaboral filterExperienciaLaboral, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
    /**
     * Counts rows in the ExperienciaLaboral table using like.
     *
     * @param experiencialaboral ExperienciaLaboral
     * @param startsWith Boolean
     * @return Long
     */
    Long findAllLikeCount(ExperienciaLaboral experiencialaboral, Boolean startsWith);
    
    /**
     * Counts rows in the ExperienciaLaboral table.
     *
     * @param experiencialaboral ExperienciaLaboral
     * @return Long
     */
    Long findAllCount(ExperienciaLaboral experiencialaboral);
    
    /**
	 * Reorder selection.
	 *
	 * @param filterExperienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<ExperienciaLaboral>>
	 */	
    List<TableRowDto<ExperienciaLaboral>> reorderSelection(ExperienciaLaboral filterExperienciaLaboral, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
     /**
	 * Searches in the Usuario table.
	 *
	 * @param filterExperienciaLaboral ExperienciaLaboral
	 * @param searchExperienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<ExperienciaLaboral>>	 
	 */	
    List<TableRowDto<ExperienciaLaboral>> search(ExperienciaLaboral filterExperienciaLaboral, ExperienciaLaboral searchExperienciaLaboral, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
    
    /**
	 * Filter in the hierarchical ExperienciaLaboral table.
	 *
	 * @param filterExperienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<JerarquiaDto<ExperienciaLaboral>>
	 */	
	List<JerarquiaDto<ExperienciaLaboral>> findAllLikeJerarquia(ExperienciaLaboral filterExperienciaLaboral, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Count rows in hierarchy
	 *
	 * @param filterExperienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return Long
	 */	
	Long findAllLikeCountJerarquia(ExperienciaLaboral filterExperienciaLaboral, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterExperienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<TableRowDto<ExperienciaLaboral>>
	 */	
	List<TableRowDto<ExperienciaLaboral>> findAllChild(ExperienciaLaboral filterExperienciaLaboral, JQGridRequestDto jqGridRequestDto);
	
	
}

