package com.ejie.ab60.dao.BEC;

import com.ejie.ab60.model.BEC.OtrosTitulos;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * OtrosTitulosDao  
 *  
 */

public interface OtrosTitulosDao {
    
    /**
     * Inserts a single row in the OtrosTitulos table.
     *
     * @param otrostitulos OtrosTitulos
     * @return OtrosTitulos
     */
    OtrosTitulos add(OtrosTitulos otrostitulos);

    /**
     * Updates a single row in the OtrosTitulos table.
     *
     * @param otrostitulos OtrosTitulos
     * @return OtrosTitulos
     */
    OtrosTitulos update(OtrosTitulos otrostitulos);

    /**
     * Finds a single row in the OtrosTitulos table.
     *
     * @param otrostitulos OtrosTitulos
     * @return OtrosTitulos
     */
    OtrosTitulos find(OtrosTitulos otrostitulos);

    /**
     * Removes a single row in the OtrosTitulos table.
     *
     * @param otrostitulos OtrosTitulos
     */
    void remove(OtrosTitulos otrostitulos);

    /**
     * Finds a List of rows in the OtrosTitulos table.
     *
     * @param otrostitulos OtrosTitulos
     * @param jqGridRequestDto JQGridRequestDto
     * @return List
     */
    List<OtrosTitulos> findAll(OtrosTitulos otrostitulos, JQGridRequestDto jqGridRequestDto);

	/**
     * Finds rows in the OtrosTitulos table using like.
     *
     * @param otrostitulos OtrosTitulos
     * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean
     * @return List
     */
	List<OtrosTitulos> findAllLike(OtrosTitulos otrostitulos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Filter in the OtrosTitulos table.
	 *
	 * @param filterOtrosTitulos OtrosTitulos
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	 void removeMultiple(OtrosTitulos filterOtrosTitulos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
    /**
     * Counts rows in the OtrosTitulos table using like.
     *
     * @param otrostitulos OtrosTitulos
     * @param startsWith Boolean
     * @return Long
     */
    Long findAllLikeCount(OtrosTitulos otrostitulos, Boolean startsWith);
    
    /**
     * Counts rows in the OtrosTitulos table.
     *
     * @param otrostitulos OtrosTitulos
     * @return Long
     */
    Long findAllCount(OtrosTitulos otrostitulos);
    
    /**
	 * Reorder selection.
	 *
	 * @param filterOtrosTitulos OtrosTitulos
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<OtrosTitulos>>
	 */	
    List<TableRowDto<OtrosTitulos>> reorderSelection(OtrosTitulos filterOtrosTitulos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
     /**
	 * Searches in the Usuario table.
	 *
	 * @param filterOtrosTitulos OtrosTitulos
	 * @param searchOtrosTitulos OtrosTitulos
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<OtrosTitulos>>	 
	 */	
    List<TableRowDto<OtrosTitulos>> search(OtrosTitulos filterOtrosTitulos, OtrosTitulos searchOtrosTitulos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
    
    /**
	 * Filter in the hierarchical OtrosTitulos table.
	 *
	 * @param filterOtrosTitulos OtrosTitulos
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<JerarquiaDto<OtrosTitulos>>
	 */	
	List<JerarquiaDto<OtrosTitulos>> findAllLikeJerarquia(OtrosTitulos filterOtrosTitulos, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Count rows in hierarchy
	 *
	 * @param filterOtrosTitulos OtrosTitulos
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return Long
	 */	
	Long findAllLikeCountJerarquia(OtrosTitulos filterOtrosTitulos, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterOtrosTitulos OtrosTitulos
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<TableRowDto<OtrosTitulos>>
	 */	
	List<TableRowDto<OtrosTitulos>> findAllChild(OtrosTitulos filterOtrosTitulos, JQGridRequestDto jqGridRequestDto);
	
	
}

