package com.ejie.ab60.dao.BEC;

import com.ejie.ab60.model.BEC.Puntuaciones;
import com.ejie.ab60.model.pagos.PagosExpediente;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * PuntuacionesDao  
 * 
 *  
 */

public interface PuntuacionesDao {

	/**
	 * Inserts a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones add(Puntuaciones puntuaciones);

	/**
	 * Inserts a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones addRequisitos(Puntuaciones puntuacion);

	/**
	 * Inserts a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones addConocimientos(Puntuaciones puntuacion);

	/**
	 * Inserts a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones addCurso(Puntuaciones puntuacion);

	/**
	 * Inserts a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones addResolucion(Puntuaciones puntuacion);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateCurriculum(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateConocimientos(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateCurso(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateRequisitos(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateResolucion(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateBecarios(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateSuplentes(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateFasePuntuacion(Puntuaciones puntuaciones);

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones find(Puntuaciones puntuaciones);

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones findRequisitos(Puntuaciones puntuaciones);

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones findConocimientos(Puntuaciones puntuaciones);

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones findCurso(Puntuaciones puntuaciones);

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param idProcedimiento
	 *            Integer
	 * @return Puntuaciones
	 */
	Puntuaciones findPuntuacionMaxSuplentes(Integer idProcedimiento);

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones findResolucion(Puntuaciones puntuaciones);

	/**
	 * Removes a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 */
	void remove(Puntuaciones puntuaciones);

	/**
	 * Finds a List of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Puntuaciones> findAll(Puntuaciones puntuaciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a List of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return List
	 */
	List<Puntuaciones> findExpedientesParaConocimientos(Puntuaciones puntuaciones, Integer idConvocatoria);

	/**
	 * Finds a List of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return List
	 */
	List<Puntuaciones> findExpedientesParaCurso(Puntuaciones puntuaciones, Integer idConvocatoria);

	/**
	 * Finds a List of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return List
	 */
	List<Puntuaciones> findExpedientesParaBecarios(Puntuaciones puntuaciones, Integer idConvocatoria);

	/**
	 * Finds a List of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return List
	 */
	List<Puntuaciones> findExpedientesParaSuplentes(Puntuaciones puntuaciones, Integer idConvocatoria);

	/**
	 * Finds a List of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return List
	 */
	List<Puntuaciones> findFaseCurriculum(Puntuaciones puntuaciones);

	/**
	 * Finds a List of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return List
	 */
	List<Puntuaciones> findFaseConocimientos(Puntuaciones puntuaciones);

	/**
	 * Finds a List of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return List
	 */
	List<Puntuaciones> findFaseCurso(Puntuaciones puntuaciones);

	/**
	 * Finds a List of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return List
	 */
	List<Puntuaciones> findFaseBecasBecarios(Puntuaciones puntuaciones);

	/**
	 * Finds a List of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return List
	 */
	List<Puntuaciones> findFaseBecasSuplentes(Puntuaciones puntuaciones);

	/**
	 * Finds a List of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return List
	 */
	List<Puntuaciones> findFaseBecasBecariosSuplentes(Puntuaciones puntuaciones);

	/**
	 * Finds rows in the Puntuaciones table using like.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Puntuaciones> findAllLike(Puntuaciones puntuaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Puntuaciones filterPuntuaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the Puntuaciones table using like.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Puntuaciones puntuaciones, Boolean startsWith);

	/**
	 * Counts rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Long
	 */
	Long findAllCount(Puntuaciones puntuaciones);

	/**
	 * Reorder selection.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Puntuaciones>>
	 */
	List<TableRowDto<Puntuaciones>> reorderSelection(Puntuaciones filterPuntuaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param searchPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Puntuaciones>>
	 */
	List<TableRowDto<Puntuaciones>> search(Puntuaciones filterPuntuaciones, Puntuaciones searchPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<Puntuaciones>>
	 */
	List<JerarquiaDto<Puntuaciones>> findAllLikeJerarquia(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(Puntuaciones filterPuntuaciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<Puntuaciones>>
	 */
	List<TableRowDto<Puntuaciones>> findAllChild(Puntuaciones filterPuntuaciones, JQGridRequestDto jqGridRequestDto);
}
