package com.ejie.ab60.dao.BEC;

import com.ejie.ab60.model.BEC.TiposCertificacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * TiposCertificacionDao  
 * 
 *  
 */

public interface TiposCertificacionDao {

	/**
	 * Inserts a single row in the TiposCertificacion table.
	 *
	 * @param tiposcertificacion
	 *            TiposCertificacion
	 * @return TiposCertificacion
	 */
	TiposCertificacion add(TiposCertificacion tiposcertificacion);

	/**
	 * Updates a single row in the TiposCertificacion table.
	 *
	 * @param tiposcertificacion
	 *            TiposCertificacion
	 * @return TiposCertificacion
	 */
	TiposCertificacion update(TiposCertificacion tiposcertificacion);

	/**
	 * Finds a single row in the TiposCertificacion table.
	 *
	 * @param tiposcertificacion
	 *            TiposCertificacion
	 * @return TiposCertificacion
	 */
	TiposCertificacion find(TiposCertificacion tiposcertificacion);

	/**
	 * findCertificaciones
	 * 
	 * @param tiposCertificacion
	 * 
	 * @return listaTiposCertificacion
	 */
	List<TiposCertificacion> findCertificaciones(TiposCertificacion tiposCertificacion);

	/**
	 * Removes a single row in the TiposCertificacion table.
	 *
	 * @param tiposcertificacion
	 *            TiposCertificacion
	 */
	void remove(TiposCertificacion tiposcertificacion);

	/**
	 * Finds a List of rows in the TiposCertificacion table.
	 *
	 * @param tiposcertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<TiposCertificacion> findAll(TiposCertificacion tiposcertificacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposCertificacion table using like.
	 *
	 * @param tiposcertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<TiposCertificacion> findAllLike(TiposCertificacion tiposcertificacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the TiposCertificacion table.
	 *
	 * @param filterTiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposCertificacion filterTiposCertificacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the TiposCertificacion table using like.
	 *
	 * @param tiposcertificacion
	 *            TiposCertificacion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(TiposCertificacion tiposcertificacion, Boolean startsWith);

	/**
	 * Counts rows in the TiposCertificacion table.
	 *
	 * @param tiposcertificacion
	 *            TiposCertificacion
	 * @return Long
	 */
	Long findAllCount(TiposCertificacion tiposcertificacion);

	/**
	 * Reorder selection.
	 *
	 * @param filterTiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposCertificacion>>
	 */
	List<TableRowDto<TiposCertificacion>> reorderSelection(TiposCertificacion filterTiposCertificacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterTiposCertificacion
	 *            TiposCertificacion
	 * @param searchTiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposCertificacion>>
	 */
	List<TableRowDto<TiposCertificacion>> search(TiposCertificacion filterTiposCertificacion,
			TiposCertificacion searchTiposCertificacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical TiposCertificacion table.
	 *
	 * @param filterTiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<TiposCertificacion>>
	 */
	List<JerarquiaDto<TiposCertificacion>> findAllLikeJerarquia(TiposCertificacion filterTiposCertificacion,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(TiposCertificacion filterTiposCertificacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<TiposCertificacion>>
	 */
	List<TableRowDto<TiposCertificacion>> findAllChild(TiposCertificacion filterTiposCertificacion,
			JQGridRequestDto jqGridRequestDto);

}
