package com.ejie.ab60.dao.CTP;

import java.util.List;

import com.ejie.ab60.model.CTP.AsociacionesSectoriales;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * AsociacionesSectorialesDao  
 * 
 *  
 */

public interface AsociacionesSectorialesDao {

	/**
	 * Inserts a single row in the AsociacionesSectoriales table.
	 *
	 * @param asociacionessectoriales
	 *            AsociacionesSectoriales
	 * @return AsociacionesSectoriales
	 */
	AsociacionesSectoriales add(AsociacionesSectoriales asociacionessectoriales);

	/**
	 * Updates a single row in the AsociacionesSectoriales table.
	 *
	 * @param asociacionessectoriales
	 *            AsociacionesSectoriales
	 * @return AsociacionesSectoriales
	 */
	AsociacionesSectoriales update(AsociacionesSectoriales asociacionessectoriales);

	/**
	 * Finds a single row in the AsociacionesSectoriales table.
	 *
	 * @param asociacionessectoriales
	 *            AsociacionesSectoriales
	 * @return AsociacionesSectoriales
	 */
	AsociacionesSectoriales find(AsociacionesSectoriales asociacionessectoriales);

	/**
	 * Lista de asociones sectoriales para cargar el combo del select
	 */

	List<AsociacionesSectoriales> findAsociacionesSectoriales();

	/**
	 * Removes a single row in the AsociacionesSectoriales table.
	 *
	 * @param asociacionessectoriales
	 *            AsociacionesSectoriales
	 */
	void remove(AsociacionesSectoriales asociacionessectoriales);

	/**
	 * Finds a List of rows in the AsociacionesSectoriales table.
	 *
	 * @param asociacionessectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<AsociacionesSectoriales> findAll(AsociacionesSectoriales asociacionessectoriales,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the AsociacionesSectoriales table using like.
	 *
	 * @param asociacionessectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<AsociacionesSectoriales> findAllLike(AsociacionesSectoriales asociacionessectoriales,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the AsociacionesSectoriales table.
	 *
	 * @param filterAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(AsociacionesSectoriales filterAsociacionesSectoriales, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the AsociacionesSectoriales table using like.
	 *
	 * @param asociacionessectoriales
	 *            AsociacionesSectoriales
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(AsociacionesSectoriales asociacionessectoriales, Boolean startsWith);

	/**
	 * Counts rows in the AsociacionesSectoriales table.
	 *
	 * @param asociacionessectoriales
	 *            AsociacionesSectoriales
	 * @return Long
	 */
	Long findAllCount(AsociacionesSectoriales asociacionessectoriales);

	/**
	 * Reorder selection.
	 *
	 * @param filterAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AsociacionesSectoriales>>
	 */
	List<TableRowDto<AsociacionesSectoriales>> reorderSelection(AsociacionesSectoriales filterAsociacionesSectoriales,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param searchAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AsociacionesSectoriales>>
	 */
	List<TableRowDto<AsociacionesSectoriales>> search(AsociacionesSectoriales filterAsociacionesSectoriales,
			AsociacionesSectoriales searchAsociacionesSectoriales, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical AsociacionesSectoriales table.
	 *
	 * @param filterAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<AsociacionesSectoriales>>
	 */
	List<JerarquiaDto<AsociacionesSectoriales>> findAllLikeJerarquia(
			AsociacionesSectoriales filterAsociacionesSectoriales, JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(AsociacionesSectoriales filterAsociacionesSectoriales,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<AsociacionesSectoriales>>
	 */
	List<TableRowDto<AsociacionesSectoriales>> findAllChild(AsociacionesSectoriales filterAsociacionesSectoriales,
			JQGridRequestDto jqGridRequestDto);

}
