package com.ejie.ab60.dao.CTP;

import java.util.List;

import com.ejie.ab60.model.CTP.Proyectos;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ProyectosDao  
 * 
 *  
 */

public interface ProyectosDao {

	/**
	 * Inserts a single row in the Proyectos table.
	 *
	 * @param proyectos
	 *            Proyectos
	 * @return Proyectos
	 */
	Proyectos add(Proyectos proyectos);

	/**
	 * Updates a single row in the Proyectos table.
	 *
	 * @param proyectos
	 *            Proyectos
	 * @return Proyectos
	 */
	Proyectos update(Proyectos proyectos);

	/**
	 * Updates idAsociacion en la tabla in the Proyectos
	 *
	 * @param proyectos
	 *            Proyectos
	 * @return Proyectos
	 */
	Proyectos updateIdAsociacion(Proyectos proyectos);

	/**
	 * Finds a single row in the Proyectos table.
	 *
	 * @param proyectos
	 *            Proyectos
	 * @return Proyectos
	 */
	Proyectos find(Proyectos proyectos);

	/**
	 * Removes a single row in the Proyectos table.
	 *
	 * @param proyectos
	 *            Proyectos
	 */
	void remove(Proyectos proyectos);

	/**
	 * Finds a List of rows in the Proyectos table.
	 *
	 * @param proyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Proyectos> findAll(Proyectos proyectos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Proyectos table using like.
	 *
	 * @param proyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Proyectos> findAllLike(Proyectos proyectos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the Proyectos table.
	 *
	 * @param filterProyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Proyectos filterProyectos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the Proyectos table using like.
	 *
	 * @param proyectos
	 *            Proyectos
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Proyectos proyectos, Boolean startsWith);

	/**
	 * Counts rows in the Proyectos table.
	 *
	 * @param proyectos
	 *            Proyectos
	 * @return Long
	 */
	Long findAllCount(Proyectos proyectos);

	/**
	 * Reorder selection.
	 *
	 * @param filterProyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Proyectos>>
	 */
	List<TableRowDto<Proyectos>> reorderSelection(Proyectos filterProyectos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterProyectos
	 *            Proyectos
	 * @param searchProyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Proyectos>>
	 */
	List<TableRowDto<Proyectos>> search(Proyectos filterProyectos, Proyectos searchProyectos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical Proyectos table.
	 *
	 * @param filterProyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<Proyectos>>
	 */
	List<JerarquiaDto<Proyectos>> findAllLikeJerarquia(Proyectos filterProyectos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterProyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(Proyectos filterProyectos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterProyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<Proyectos>>
	 */
	List<TableRowDto<Proyectos>> findAllChild(Proyectos filterProyectos, JQGridRequestDto jqGridRequestDto);

}
