package com.ejie.ab60.dao.CTP;

import java.util.List;

import com.ejie.ab60.model.CTP.Solicitantes;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * SolicitantesDao  
 * 
 *  
 */

public interface SolicitantesDao {

	/**
	 * Inserts a single row in the Solicitantes table.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 * @return Solicitantes
	 */
	Solicitantes add(Solicitantes solicitantes);

	/**
	 * Updates a single row in the Solicitantes table.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 * @return Solicitantes
	 */
	Solicitantes update(Solicitantes solicitantes);

	/**
	 * Finds a single row in the Solicitantes table.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 * @return Solicitantes
	 */
	Solicitantes find(Solicitantes solicitantes);

	/**
	 * Removes a single row in the Solicitantes table.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 */
	void remove(Solicitantes solicitantes);

	/**
	 * Finds a List of rows in the Solicitantes table.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Solicitantes> findAll(Solicitantes solicitantes, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Solicitantes table using like.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Solicitantes> findAllLike(Solicitantes solicitantes, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the Solicitantes table.
	 *
	 * @param filterSolicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Solicitantes filterSolicitantes, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the Solicitantes table using like.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Solicitantes solicitantes, Boolean startsWith);

	/**
	 * Counts rows in the Solicitantes table.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 * @return Long
	 */
	Long findAllCount(Solicitantes solicitantes);

	/**
	 * Reorder selection.
	 *
	 * @param filterSolicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Solicitantes>>
	 */
	List<TableRowDto<Solicitantes>> reorderSelection(Solicitantes filterSolicitantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterSolicitantes
	 *            Solicitantes
	 * @param searchSolicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Solicitantes>>
	 */
	List<TableRowDto<Solicitantes>> search(Solicitantes filterSolicitantes, Solicitantes searchSolicitantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical Solicitantes table.
	 *
	 * @param filterSolicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<Solicitantes>>
	 */
	List<JerarquiaDto<Solicitantes>> findAllLikeJerarquia(Solicitantes filterSolicitantes,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterSolicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(Solicitantes filterSolicitantes, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterSolicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<Solicitantes>>
	 */
	List<TableRowDto<Solicitantes>> findAllChild(Solicitantes filterSolicitantes, JQGridRequestDto jqGridRequestDto);

}
