package com.ejie.ab60.dao.DEC;

import java.util.List;

import com.ejie.ab60.model.DEC.ActAsociacion;
import com.ejie.ab60.model.DEC.AsociacionesComerciantes;
import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ActAsociacionDao  
 * 
 *  
 */

public interface ActAsociacionDao {

	/**
	 * Inserts a single row in the ActAsociacion table.
	 *
	 * @param actasociacion
	 *            ActAsociacion
	 * @return ActAsociacion
	 */
	ActAsociacion add(ActAsociacion actasociacion);

	/**
	 * Updates a single row in the ActAsociacion table.
	 *
	 * @param actasociacion
	 *            ActAsociacion
	 * @return ActAsociacion
	 */
	RelExpActSub update(RelExpActSub relExpActSub);

	/**
	 * Finds a single row in the ActAsociacion table.
	 *
	 * @param actasociacion
	 *            ActAsociacion
	 * @return ActAsociacion
	 */
	ActAsociacion find(ActAsociacion actasociacion);

	/**
	 * Removes a single row in the ActAsociacion table.
	 *
	 * @param Integer
	 *            idRelExpActSub
	 */
	void remove(Integer idRelExpActSub);

	/**
	 * Removes a single row in the ActAsociacion table.
	 *
	 * @param actasociacion
	 *            ActAsociacion
	 */
	void remove(ActAsociacion actasociacion);

	/**
	 * Finds a List of rows in the ActAsociacion table.
	 *
	 * @param actasociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<ActAsociacion> findAll(ActAsociacion actasociacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ActAsociacion table using like.
	 *
	 * @param actasociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<ActAsociacion> findAllLike(ActAsociacion actasociacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the ActAsociacion table.
	 *
	 * @param filterActAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ActAsociacion filterActAsociacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the ActAsociacion table using like.
	 *
	 * @param actasociacion
	 *            ActAsociacion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(ActAsociacion actasociacion, Boolean startsWith);

	/**
	 * Counts rows in the ActAsociacion table.
	 *
	 * @param actasociacion
	 *            ActAsociacion
	 * @return Long
	 */
	Long findAllCount(ActAsociacion actasociacion);

	/**
	 * Reorder selection.
	 *
	 * @param filterActAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ActAsociacion>>
	 */
	List<TableRowDto<ActAsociacion>> reorderSelection(ActAsociacion filterActAsociacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterActAsociacion
	 *            ActAsociacion
	 * @param searchActAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ActAsociacion>>
	 */
	List<TableRowDto<ActAsociacion>> search(ActAsociacion filterActAsociacion, ActAsociacion searchActAsociacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical ActAsociacion table.
	 *
	 * @param filterActAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<ActAsociacion>>
	 */
	List<JerarquiaDto<ActAsociacion>> findAllLikeJerarquia(ActAsociacion filterActAsociacion,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterActAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(ActAsociacion filterActAsociacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterActAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<ActAsociacion>>
	 */
	List<TableRowDto<ActAsociacion>> findAllChild(ActAsociacion filterActAsociacion, JQGridRequestDto jqGridRequestDto);

}
