package com.ejie.ab60.dao.DEC;

import java.util.List;

import com.ejie.ab60.model.DEC.ActAyuntamiento;
import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ActAyuntamientoDao  
 * 
 *  
 */

public interface ActAyuntamientoDao {

	/**
	 * Inserts a single row in the ActAyuntamiento table.
	 *
	 * @param actayuntamiento
	 *            ActAyuntamiento
	 * @return ActAyuntamiento
	 */
	ActAyuntamiento add(ActAyuntamiento actayuntamiento);

	/**
	 * Updates a single row in the ActAyuntamiento table.
	 *
	 * @param actayuntamiento
	 *            ActAyuntamiento
	 * @return ActAyuntamiento
	 */
	RelExpActSub update(RelExpActSub relExpActSub);

	/**
	 * Finds a single row in the ActAyuntamiento table.
	 *
	 * @param actayuntamiento
	 *            ActAyuntamiento
	 * @return ActAyuntamiento
	 */
	ActAyuntamiento find(RelExpActSub relExpActSub);

	/**
	 * Finds a single row in the ActAyuntamiento table.
	 *
	 * @param actayuntamiento
	 *            ActAyuntamiento
	 * @return ActAyuntamiento
	 */
	ActAyuntamiento findidRelacion(ActAyuntamiento actayuntamiento);

	/**
	 * Removes a single row in the ActAyuntamiento table.
	 *
	 * @param actayuntamiento
	 *            ActAyuntamiento
	 */
	void remove(ActAyuntamiento actayuntamiento);

	/**
	 * Updates a single row in the ActAyuntamiento table.
	 *
	 * @param actayuntamiento
	 *            ActAyuntamiento
	 * @return ActAyuntamiento
	 */
	ActAyuntamiento updateTotal(ActAyuntamiento actayuntamiento);

	/**
	 * Finds a List of rows in the ActAyuntamiento table.
	 *
	 * @param actayuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<ActAyuntamiento> findAll(ActAyuntamiento actayuntamiento, JQGridRequestDto jqGridRequestDto);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the ActAyuntamiento table.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ActAyuntamiento filterActAyuntamiento, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the ActAyuntamiento table using like.
	 *
	 * @param actayuntamiento
	 *            ActAyuntamiento
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(ActAyuntamiento actayuntamiento, Boolean startsWith);

	/**
	 * Counts rows in the ActAyuntamiento table.
	 *
	 * @param actayuntamiento
	 *            ActAyuntamiento
	 * @return Long
	 */
	Long findAllCount(ActAyuntamiento actayuntamiento);

	/**
	 * Reorder selection.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ActAyuntamiento>>
	 */
	List<TableRowDto<ActAyuntamiento>> reorderSelection(ActAyuntamiento filterActAyuntamiento,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param searchActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ActAyuntamiento>>
	 */
	List<TableRowDto<ActAyuntamiento>> search(ActAyuntamiento filterActAyuntamiento,
			ActAyuntamiento searchActAyuntamiento, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical ActAyuntamiento table.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<ActAyuntamiento>>
	 */
	List<JerarquiaDto<ActAyuntamiento>> findAllLikeJerarquia(ActAyuntamiento filterActAyuntamiento,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(ActAyuntamiento filterActAyuntamiento, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<ActAyuntamiento>>
	 */
	List<TableRowDto<ActAyuntamiento>> findAllChild(ActAyuntamiento filterActAyuntamiento,
			JQGridRequestDto jqGridRequestDto);

	RelExpActSub updateEMCO(RelExpActSub relExpActSub);

	ActAyuntamiento findEMCO(RelExpActSub relExpActSub);

	void removeEMCO(ActAyuntamiento actAyuntamiento);

	ActAyuntamiento addEMCO(ActAyuntamiento actAyuntamiento);

}
