package com.ejie.ab60.dao.DEC;

import java.util.List;

import com.ejie.ab60.model.CTP.AsociacionesSectoriales;
import com.ejie.ab60.model.DEC.AsociacionesComerciantes;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * AsociacionesComerciantesDao  
 * 
 *  
 */

public interface AsociacionesComerciantesDao {

	/**
	 * Inserts a single row in the AsociacionesComerciantes table.
	 *
	 * @param asociacionescomerciantes
	 *            AsociacionesComerciantes
	 * @return AsociacionesComerciantes
	 */
	AsociacionesComerciantes add(AsociacionesComerciantes asociacionescomerciantes);

	/**
	 * Updates a single row in the AsociacionesComerciantes table.
	 *
	 * @param asociacionescomerciantes
	 *            AsociacionesComerciantes
	 * @return AsociacionesComerciantes
	 */
	AsociacionesComerciantes update(AsociacionesComerciantes asociacionescomerciantes);

	/**
	 * Finds a single row in the AsociacionesComerciantes table.
	 *
	 * @param asociacionescomerciantes
	 *            AsociacionesComerciantes
	 * @return AsociacionesComerciantes
	 */
	AsociacionesComerciantes find(AsociacionesComerciantes asociacionescomerciantes);

	/**
	 * Removes a single row in the AsociacionesComerciantes table.
	 *
	 * @param asociacionescomerciantes
	 *            AsociacionesComerciantes
	 */
	void remove(AsociacionesComerciantes asociacionescomerciantes);

	/**
	 * Finds a List of rows in the AsociacionesComerciantes table.
	 *
	 * @param asociacionescomerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<AsociacionesComerciantes> findAll(AsociacionesComerciantes asociacionescomerciantes,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the AsociacionesComerciantes table using like.
	 *
	 * @param asociacionescomerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<AsociacionesComerciantes> findAllLike(AsociacionesComerciantes asociacionescomerciantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the AsociacionesComerciantes table.
	 *
	 * @param filterAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(AsociacionesComerciantes filterAsociacionesComerciantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the AsociacionesComerciantes table using like.
	 *
	 * @param asociacionescomerciantes
	 *            AsociacionesComerciantes
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(AsociacionesComerciantes asociacionescomerciantes, Boolean startsWith);

	/**
	 * Counts rows in the AsociacionesComerciantes table.
	 *
	 * @param asociacionescomerciantes
	 *            AsociacionesComerciantes
	 * @return Long
	 */
	Long findAllCount(AsociacionesComerciantes asociacionescomerciantes);

	/**
	 * Reorder selection.
	 *
	 * @param filterAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AsociacionesComerciantes>>
	 */
	List<TableRowDto<AsociacionesComerciantes>> reorderSelection(
			AsociacionesComerciantes filterAsociacionesComerciantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param searchAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AsociacionesComerciantes>>
	 */
	List<TableRowDto<AsociacionesComerciantes>> search(AsociacionesComerciantes filterAsociacionesComerciantes,
			AsociacionesComerciantes searchAsociacionesComerciantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical AsociacionesComerciantes table.
	 *
	 * @param filterAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<AsociacionesComerciantes>>
	 */
	List<JerarquiaDto<AsociacionesComerciantes>> findAllLikeJerarquia(
			AsociacionesComerciantes filterAsociacionesComerciantes, JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(AsociacionesComerciantes filterAsociacionesComerciantes,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<AsociacionesComerciantes>>
	 */
	List<TableRowDto<AsociacionesComerciantes>> findAllChild(AsociacionesComerciantes filterAsociacionesComerciantes,
			JQGridRequestDto jqGridRequestDto);

}
