package com.ejie.ab60.dao.DEC;

import java.util.List;

import com.ejie.ab60.model.DEC.LimiteAsociaciones;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * LimiteAsociacionesDao  
 * 
 *  
 */

public interface LimiteAsociacionesDao {

	/**
	 * Inserts a single row in the LimiteAsociaciones table.
	 *
	 * @param limiteasociaciones
	 *            LimiteAsociaciones
	 * @return LimiteAsociaciones
	 */
	LimiteAsociaciones add(LimiteAsociaciones limiteasociaciones);

	/**
	 * Updates a single row in the LimiteAsociaciones table.
	 *
	 * @param limiteasociaciones
	 *            LimiteAsociaciones
	 * @return LimiteAsociaciones
	 */
	LimiteAsociaciones update(LimiteAsociaciones limiteasociaciones);

	/**
	 * Finds a single row in the LimiteAsociaciones table.
	 *
	 * @param limiteasociaciones
	 *            LimiteAsociaciones
	 * @return LimiteAsociaciones
	 */
	LimiteAsociaciones find(LimiteAsociaciones limiteasociaciones);

	/**
	 * Removes a single row in the LimiteAsociaciones table.
	 *
	 * @param limiteasociaciones
	 *            LimiteAsociaciones
	 */
	void remove(LimiteAsociaciones limiteasociaciones);

	/**
	 * Finds a List of rows in the LimiteAsociaciones table.
	 *
	 * @param limiteasociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<LimiteAsociaciones> findAll(LimiteAsociaciones limiteasociaciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the LimiteAsociaciones table using like.
	 *
	 * @param limiteasociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<LimiteAsociaciones> findAllLike(LimiteAsociaciones limiteasociaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(LimiteAsociaciones filterLimiteAsociaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the LimiteAsociaciones table using like.
	 *
	 * @param limiteasociaciones
	 *            LimiteAsociaciones
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(LimiteAsociaciones limiteasociaciones, Boolean startsWith);

	/**
	 * Counts rows in the LimiteAsociaciones table.
	 *
	 * @param limiteasociaciones
	 *            LimiteAsociaciones
	 * @return Long
	 */
	Long findAllCount(LimiteAsociaciones limiteasociaciones);

	/**
	 * Reorder selection.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<LimiteAsociaciones>>
	 */
	List<TableRowDto<LimiteAsociaciones>> reorderSelection(LimiteAsociaciones filterLimiteAsociaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param searchLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<LimiteAsociaciones>>
	 */
	List<TableRowDto<LimiteAsociaciones>> search(LimiteAsociaciones filterLimiteAsociaciones,
			LimiteAsociaciones searchLimiteAsociaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<LimiteAsociaciones>>
	 */
	List<JerarquiaDto<LimiteAsociaciones>> findAllLikeJerarquia(LimiteAsociaciones filterLimiteAsociaciones,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(LimiteAsociaciones filterLimiteAsociaciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<LimiteAsociaciones>>
	 */
	List<TableRowDto<LimiteAsociaciones>> findAllChild(LimiteAsociaciones filterLimiteAsociaciones,
			JQGridRequestDto jqGridRequestDto);

}
