package com.ejie.ab60.dao.DEC;

import java.util.List;

import com.ejie.ab60.model.DEC.LimiteAyuntamientos;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * LimiteAyuntamientosDao  
 * 
 *  
 */

public interface LimiteAyuntamientosDao {

	/**
	 * Inserts a single row in the LimiteAyuntamientos table.
	 *
	 * @param limiteayuntamientos
	 *            LimiteAyuntamientos
	 * @return LimiteAyuntamientos
	 */
	LimiteAyuntamientos add(LimiteAyuntamientos limiteayuntamientos);

	/**
	 * Updates a single row in the LimiteAyuntamientos table.
	 *
	 * @param limiteayuntamientos
	 *            LimiteAyuntamientos
	 * @return LimiteAyuntamientos
	 */
	LimiteAyuntamientos update(LimiteAyuntamientos limiteayuntamientos);

	/**
	 * Finds a single row in the LimiteAyuntamientos table.
	 *
	 * @param limiteayuntamientos
	 *            LimiteAyuntamientos
	 * @return LimiteAyuntamientos
	 */
	LimiteAyuntamientos find(LimiteAyuntamientos limiteayuntamientos);

	/**
	 * Removes a single row in the LimiteAyuntamientos table.
	 *
	 * @param limiteayuntamientos
	 *            LimiteAyuntamientos
	 */
	void remove(LimiteAyuntamientos limiteayuntamientos);

	/**
	 * Finds a List of rows in the LimiteAyuntamientos table.
	 *
	 * @param limiteayuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<LimiteAyuntamientos> findAll(LimiteAyuntamientos limiteayuntamientos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the LimiteAyuntamientos table using like.
	 *
	 * @param limiteayuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<LimiteAyuntamientos> findAllLike(LimiteAyuntamientos limiteayuntamientos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(LimiteAyuntamientos filterLimiteAyuntamientos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the LimiteAyuntamientos table using like.
	 *
	 * @param limiteayuntamientos
	 *            LimiteAyuntamientos
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(LimiteAyuntamientos limiteayuntamientos, Boolean startsWith);

	/**
	 * Counts rows in the LimiteAyuntamientos table.
	 *
	 * @param limiteayuntamientos
	 *            LimiteAyuntamientos
	 * @return Long
	 */
	Long findAllCount(LimiteAyuntamientos limiteayuntamientos);

	/**
	 * Reorder selection.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<LimiteAyuntamientos>>
	 */
	List<TableRowDto<LimiteAyuntamientos>> reorderSelection(LimiteAyuntamientos filterLimiteAyuntamientos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param searchLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<LimiteAyuntamientos>>
	 */
	List<TableRowDto<LimiteAyuntamientos>> search(LimiteAyuntamientos filterLimiteAyuntamientos,
			LimiteAyuntamientos searchLimiteAyuntamientos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<LimiteAyuntamientos>>
	 */
	List<JerarquiaDto<LimiteAyuntamientos>> findAllLikeJerarquia(LimiteAyuntamientos filterLimiteAyuntamientos,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(LimiteAyuntamientos filterLimiteAyuntamientos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<LimiteAyuntamientos>>
	 */
	List<TableRowDto<LimiteAyuntamientos>> findAllChild(LimiteAyuntamientos filterLimiteAyuntamientos,
			JQGridRequestDto jqGridRequestDto);

}
