package com.ejie.ab60.dao.DEC;

import java.util.List;

import com.ejie.ab60.model.DEC.RelMunAsoCom;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelMunAsoComDao  
 * 
 *  
 */

public interface RelMunAsoComDao {

	/**
	 * Inserts a single row in the RelMunAsoCom table.
	 *
	 * @param relmunasocom
	 *            RelMunAsoCom
	 * @return RelMunAsoCom
	 */
	RelMunAsoCom add(RelMunAsoCom relmunasocom);

	/**
	 * Updates a single row in the RelMunAsoCom table.
	 *
	 * @param relmunasocom
	 *            RelMunAsoCom
	 * @return RelMunAsoCom
	 */
	RelMunAsoCom update(RelMunAsoCom relmunasocom);

	/**
	 * Finds a single row in the RelMunAsoCom table.
	 *
	 * @param relmunasocom
	 *            RelMunAsoCom
	 * @return RelMunAsoCom
	 */
	RelMunAsoCom find(RelMunAsoCom relmunasocom);

	/**
	 * Removes a single row in the RelMunAsoCom table.
	 *
	 * @param relmunasocom
	 *            RelMunAsoCom
	 */
	void remove(RelMunAsoCom relmunasocom);

	/**
	 * Finds a List of rows in the RelMunAsoCom table.
	 *
	 * @param relmunasocom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelMunAsoCom> findAll(RelMunAsoCom relmunasocom, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelMunAsoCom table using like.
	 *
	 * @param relmunasocom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelMunAsoCom> findAllLike(RelMunAsoCom relmunasocom, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelMunAsoCom table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelMunAsoCom filterRelMunAsoCom, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelMunAsoCom table using like.
	 *
	 * @param relmunasocom
	 *            RelMunAsoCom
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelMunAsoCom relmunasocom, Boolean startsWith);

	/**
	 * Counts rows in the RelMunAsoCom table.
	 *
	 * @param relmunasocom
	 *            RelMunAsoCom
	 * @return Long
	 */
	Long findAllCount(RelMunAsoCom relmunasocom);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelMunAsoCom>>
	 */
	List<TableRowDto<RelMunAsoCom>> reorderSelection(RelMunAsoCom filterRelMunAsoCom, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param searchRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelMunAsoCom>>
	 */
	List<TableRowDto<RelMunAsoCom>> search(RelMunAsoCom filterRelMunAsoCom, RelMunAsoCom searchRelMunAsoCom,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelMunAsoCom table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelMunAsoCom>>
	 */
	List<JerarquiaDto<RelMunAsoCom>> findAllLikeJerarquia(RelMunAsoCom filterRelMunAsoCom,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelMunAsoCom filterRelMunAsoCom, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelMunAsoCom>>
	 */
	List<TableRowDto<RelMunAsoCom>> findAllChild(RelMunAsoCom filterRelMunAsoCom, JQGridRequestDto jqGridRequestDto);

	RelMunAsoCom findById(Integer idExpediente);

}
