package com.ejie.ab60.dao.DIV;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.DIV.Acciones;

/**
 * AccionesDao  
 * 
 *  
 */

public interface AccionesDao {

	/**
	 * Inserts a single row in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 * @return Acciones
	 */
	Acciones add(Acciones acciones);

	/**
	 * Updates a single row in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 * @return Acciones
	 */
	Acciones update(Acciones acciones);

	/**
	 * Finds a single row in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 * @return Acciones
	 */
	Acciones find(Acciones acciones);

	/**
	 * Removes a single row in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 */
	void remove(Acciones acciones);

	/**
	 * Finds a List of rows in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Acciones> findAll(Acciones acciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Acciones table using like.
	 *
	 * @param acciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Acciones> findAllLike(Acciones acciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the Acciones table.
	 *
	 * @param filterAcciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Acciones filterAcciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the Acciones table using like.
	 *
	 * @param acciones
	 *            Acciones
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Acciones acciones, Boolean startsWith);

	/**
	 * Counts rows in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 * @return Long
	 */
	Long findAllCount(Acciones acciones);

	/**
	 * Reorder selection.
	 *
	 * @param filterAcciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Acciones>>
	 */
	List<TableRowDto<Acciones>> reorderSelection(Acciones filterAcciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterAcciones
	 *            Acciones
	 * @param searchAcciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Acciones>>
	 */
	List<TableRowDto<Acciones>> search(Acciones filterAcciones, Acciones searchAcciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical Acciones table.
	 *
	 * @param filterAcciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<Acciones>>
	 */
	List<JerarquiaDto<Acciones>> findAllLikeJerarquia(Acciones filterAcciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterAcciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(Acciones filterAcciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterAcciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<Acciones>>
	 */
	List<TableRowDto<Acciones>> findAllChild(Acciones filterAcciones, JQGridRequestDto jqGridRequestDto);

}
