package com.ejie.ab60.dao.DIV;

import java.util.List;

import com.ejie.ab60.model.DIV.EntidadesSolicitantes;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * EntidadesSolicitantesDao  
 * 
 *  
 */

public interface EntidadesSolicitantesDao {

	/**
	 * Inserts a single row in the EntidadesSolicitantes table.
	 *
	 * @param entidadessolicitantes
	 *            EntidadesSolicitantes
	 * @return EntidadesSolicitantes
	 */
	EntidadesSolicitantes add(EntidadesSolicitantes entidadessolicitantes);

	/**
	 * Updates a single row in the EntidadesSolicitantes table.
	 *
	 * @param entidadessolicitantes
	 *            EntidadesSolicitantes
	 * @return EntidadesSolicitantes
	 */
	EntidadesSolicitantes update(EntidadesSolicitantes entidadessolicitantes);

	/**
	 * Finds a single row in the EntidadesSolicitantes table.
	 *
	 * @param entidadessolicitantes
	 *            EntidadesSolicitantes
	 * @return EntidadesSolicitantes
	 */
	EntidadesSolicitantes find(EntidadesSolicitantes entidadessolicitantes);

	/**
	 * Removes a single row in the EntidadesSolicitantes table.
	 *
	 * @param entidadessolicitantes
	 *            EntidadesSolicitantes
	 */
	void remove(EntidadesSolicitantes entidadessolicitantes);

	/**
	 * Finds a List of rows in the EntidadesSolicitantes table.
	 *
	 * @param entidadessolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<EntidadesSolicitantes> findAll(EntidadesSolicitantes entidadessolicitantes, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the EntidadesSolicitantes table using like.
	 *
	 * @param entidadessolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<EntidadesSolicitantes> findAllLike(EntidadesSolicitantes entidadessolicitantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(EntidadesSolicitantes filterEntidadesSolicitantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the EntidadesSolicitantes table using like.
	 *
	 * @param entidadessolicitantes
	 *            EntidadesSolicitantes
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(EntidadesSolicitantes entidadessolicitantes, Boolean startsWith);

	/**
	 * Counts rows in the EntidadesSolicitantes table.
	 *
	 * @param entidadessolicitantes
	 *            EntidadesSolicitantes
	 * @return Long
	 */
	Long findAllCount(EntidadesSolicitantes entidadessolicitantes);

	/**
	 * Reorder selection.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<EntidadesSolicitantes>>
	 */
	List<TableRowDto<EntidadesSolicitantes>> reorderSelection(EntidadesSolicitantes filterEntidadesSolicitantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param searchEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<EntidadesSolicitantes>>
	 */
	List<TableRowDto<EntidadesSolicitantes>> search(EntidadesSolicitantes filterEntidadesSolicitantes,
			EntidadesSolicitantes searchEntidadesSolicitantes, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<EntidadesSolicitantes>>
	 */
	List<JerarquiaDto<EntidadesSolicitantes>> findAllLikeJerarquia(EntidadesSolicitantes filterEntidadesSolicitantes,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(EntidadesSolicitantes filterEntidadesSolicitantes,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<EntidadesSolicitantes>>
	 */
	List<TableRowDto<EntidadesSolicitantes>> findAllChild(EntidadesSolicitantes filterEntidadesSolicitantes,
			JQGridRequestDto jqGridRequestDto);

}
