package com.ejie.ab60.dao.DIV;

import java.util.List;

import com.ejie.ab60.model.DIV.RelExpEntSol;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpEntSolDao  
 * 
 *  
 */

public interface RelExpEntSolDao {

	/**
	 * Inserts a single row in the RelExpEntSol table.
	 *
	 * @param relexpentsol
	 *            RelExpEntSol
	 * @return RelExpEntSol
	 */
	RelExpEntSol add(RelExpEntSol relexpentsol);

	/**
	 * Updates a single row in the RelExpEntSol table.
	 *
	 * @param relexpentsol
	 *            RelExpEntSol
	 * @return RelExpEntSol
	 */
	RelExpEntSol update(RelExpEntSol relexpentsol);

	/**
	 * Finds a single row in the RelExpEntSol table.
	 *
	 * @param relexpentsol
	 *            RelExpEntSol
	 * @return RelExpEntSol
	 */
	RelExpEntSol find(RelExpEntSol relexpentsol);

	/**
	 * Removes a single row in the RelExpEntSol table.
	 *
	 * @param relexpentsol
	 *            RelExpEntSol
	 */
	void remove(RelExpEntSol relexpentsol);

	/**
	 * Finds a List of rows in the RelExpEntSol table.
	 *
	 * @param relexpentsol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelExpEntSol> findAll(RelExpEntSol relexpentsol, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelExpEntSol table using like.
	 *
	 * @param relexpentsol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelExpEntSol> findAllLike(RelExpEntSol relexpentsol, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelExpEntSol table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpEntSol filterRelExpEntSol, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelExpEntSol table using like.
	 *
	 * @param relexpentsol
	 *            RelExpEntSol
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelExpEntSol relexpentsol, Boolean startsWith);

	/**
	 * Counts rows in the RelExpEntSol table.
	 *
	 * @param relexpentsol
	 *            RelExpEntSol
	 * @return Long
	 */
	Long findAllCount(RelExpEntSol relexpentsol);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpEntSol>>
	 */
	List<TableRowDto<RelExpEntSol>> reorderSelection(RelExpEntSol filterRelExpEntSol, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param searchRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpEntSol>>
	 */
	List<TableRowDto<RelExpEntSol>> search(RelExpEntSol filterRelExpEntSol, RelExpEntSol searchRelExpEntSol,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelExpEntSol table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelExpEntSol>>
	 */
	List<JerarquiaDto<RelExpEntSol>> findAllLikeJerarquia(RelExpEntSol filterRelExpEntSol,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelExpEntSol filterRelExpEntSol, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelExpEntSol>>
	 */
	List<TableRowDto<RelExpEntSol>> findAllChild(RelExpEntSol filterRelExpEntSol, JQGridRequestDto jqGridRequestDto);

}
