package com.ejie.ab60.dao.DIV;

import java.util.List;

import com.ejie.ab60.model.DIV.TiposActividad;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * TiposActividadDao  
 * 
 *  
 */

public interface TiposActividadDao {

	/**
	 * Inserts a single row in the TiposActividad table.
	 *
	 * @param tiposactividad
	 *            TiposActividad
	 * @return TiposActividad
	 */
	TiposActividad add(TiposActividad tiposactividad);

	/**
	 * Updates a single row in the TiposActividad table.
	 *
	 * @param tiposactividad
	 *            TiposActividad
	 * @return TiposActividad
	 */
	TiposActividad update(TiposActividad tiposactividad);

	/**
	 * Finds a single row in the TiposActividad table.
	 *
	 * @param tiposactividad
	 *            TiposActividad
	 * @return TiposActividad
	 */
	TiposActividad find(TiposActividad tiposactividad);

	/**
	 * Removes a single row in the TiposActividad table.
	 *
	 * @param tiposactividad
	 *            TiposActividad
	 */
	void remove(TiposActividad tiposactividad);

	/**
	 * Finds a List of rows in the TiposActividad table.
	 *
	 * @param tiposactividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<TiposActividad> findAll(TiposActividad tiposactividad, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposActividad table using like.
	 *
	 * @param tiposactividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<TiposActividad> findAllLike(TiposActividad tiposactividad, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the TiposActividad table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposActividad filterTiposActividad, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the TiposActividad table using like.
	 *
	 * @param tiposactividad
	 *            TiposActividad
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(TiposActividad tiposactividad, Boolean startsWith);

	/**
	 * Counts rows in the TiposActividad table.
	 *
	 * @param tiposactividad
	 *            TiposActividad
	 * @return Long
	 */
	Long findAllCount(TiposActividad tiposactividad);

	/**
	 * Reorder selection.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposActividad>>
	 */
	List<TableRowDto<TiposActividad>> reorderSelection(TiposActividad filterTiposActividad,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param searchTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposActividad>>
	 */
	List<TableRowDto<TiposActividad>> search(TiposActividad filterTiposActividad, TiposActividad searchTiposActividad,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical TiposActividad table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<TiposActividad>>
	 */
	List<JerarquiaDto<TiposActividad>> findAllLikeJerarquia(TiposActividad filterTiposActividad,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(TiposActividad filterTiposActividad, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<TiposActividad>>
	 */
	List<TableRowDto<TiposActividad>> findAllChild(TiposActividad filterTiposActividad,
			JQGridRequestDto jqGridRequestDto);

}
