package com.ejie.ab60.dao.DIV;

import java.util.List;

import com.ejie.ab60.model.DIV.TiposAsociacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * TiposAsociacionDao  
 * 
 *  
 */

public interface TiposAsociacionDao {

	/**
	 * Inserts a single row in the TiposAsociacion table.
	 *
	 * @param tiposasociacion
	 *            TiposAsociacion
	 * @return TiposAsociacion
	 */
	TiposAsociacion add(TiposAsociacion tiposasociacion);

	/**
	 * Updates a single row in the TiposAsociacion table.
	 *
	 * @param tiposasociacion
	 *            TiposAsociacion
	 * @return TiposAsociacion
	 */
	TiposAsociacion update(TiposAsociacion tiposasociacion);

	/**
	 * Finds a single row in the TiposAsociacion table.
	 *
	 * @param tiposasociacion
	 *            TiposAsociacion
	 * @return TiposAsociacion
	 */
	TiposAsociacion find(TiposAsociacion tiposasociacion);

	/**
	 * Removes a single row in the TiposAsociacion table.
	 *
	 * @param tiposasociacion
	 *            TiposAsociacion
	 */
	void remove(TiposAsociacion tiposasociacion);

	/**
	 * Finds a List of rows in the TiposAsociacion table.
	 *
	 * @param tiposasociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<TiposAsociacion> findAll(TiposAsociacion tiposasociacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposAsociacion table using like.
	 *
	 * @param tiposasociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<TiposAsociacion> findAllLike(TiposAsociacion tiposasociacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the TiposAsociacion table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposAsociacion filterTiposAsociacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the TiposAsociacion table using like.
	 *
	 * @param tiposasociacion
	 *            TiposAsociacion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(TiposAsociacion tiposasociacion, Boolean startsWith);

	/**
	 * Counts rows in the TiposAsociacion table.
	 *
	 * @param tiposasociacion
	 *            TiposAsociacion
	 * @return Long
	 */
	Long findAllCount(TiposAsociacion tiposasociacion);

	/**
	 * Reorder selection.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposAsociacion>>
	 */
	List<TableRowDto<TiposAsociacion>> reorderSelection(TiposAsociacion filterTiposAsociacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param searchTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposAsociacion>>
	 */
	List<TableRowDto<TiposAsociacion>> search(TiposAsociacion filterTiposAsociacion,
			TiposAsociacion searchTiposAsociacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical TiposAsociacion table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<TiposAsociacion>>
	 */
	List<JerarquiaDto<TiposAsociacion>> findAllLikeJerarquia(TiposAsociacion filterTiposAsociacion,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(TiposAsociacion filterTiposAsociacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<TiposAsociacion>>
	 */
	List<TableRowDto<TiposAsociacion>> findAllChild(TiposAsociacion filterTiposAsociacion,
			JQGridRequestDto jqGridRequestDto);

}
