package com.ejie.ab60.dao;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.EntidadesBancarias;

/**
 * EntidadesBancariasDao  
 * 
 *  
 */

public interface EntidadesBancariasDao {

	/**
	 * Inserts a single row in the EntidadesBancarias table.
	 *
	 * @param entidadesbancarias
	 *            EntidadesBancarias
	 * @return EntidadesBancarias
	 */
	EntidadesBancarias add(EntidadesBancarias entidadesbancarias);

	/**
	 * Updates a single row in the EntidadesBancarias table.
	 *
	 * @param entidadesbancarias
	 *            EntidadesBancarias
	 * @return EntidadesBancarias
	 */
	EntidadesBancarias update(EntidadesBancarias entidadesbancarias);

	/**
	 * Finds a single row in the EntidadesBancarias table.
	 *
	 * @param entidadesbancarias
	 *            EntidadesBancarias
	 * @return EntidadesBancarias
	 */
	EntidadesBancarias find(EntidadesBancarias entidadesbancarias);

	/**
	 * Removes a single row in the EntidadesBancarias table.
	 *
	 * @param entidadesbancarias
	 *            EntidadesBancarias
	 */
	void remove(EntidadesBancarias entidadesbancarias);

	/**
	 * Finds a List of rows in the EntidadesBancarias table.
	 *
	 * @param entidadesbancarias
	 *            EntidadesBancarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<EntidadesBancarias> findAll(EntidadesBancarias entidadesbancarias, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the EntidadesBancarias table using like.
	 *
	 * @param entidadesbancarias
	 *            EntidadesBancarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<EntidadesBancarias> findAllLike(EntidadesBancarias entidadesbancarias, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the EntidadesBancarias table.
	 *
	 * @param filterEntidadesBancarias
	 *            EntidadesBancarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(EntidadesBancarias filterEntidadesBancarias, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the EntidadesBancarias table using like.
	 *
	 * @param entidadesbancarias
	 *            EntidadesBancarias
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(EntidadesBancarias entidadesbancarias, Boolean startsWith);

	/**
	 * Counts rows in the EntidadesBancarias table.
	 *
	 * @param entidadesbancarias
	 *            EntidadesBancarias
	 * @return Long
	 */
	Long findAllCount(EntidadesBancarias entidadesbancarias);

	/**
	 * Reorder selection.
	 *
	 * @param filterEntidadesBancarias
	 *            EntidadesBancarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<EntidadesBancarias>>
	 */
	List<TableRowDto<EntidadesBancarias>> reorderSelection(EntidadesBancarias filterEntidadesBancarias,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterEntidadesBancarias
	 *            EntidadesBancarias
	 * @param searchEntidadesBancarias
	 *            EntidadesBancarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<EntidadesBancarias>>
	 */
	List<TableRowDto<EntidadesBancarias>> search(EntidadesBancarias filterEntidadesBancarias,
			EntidadesBancarias searchEntidadesBancarias, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical EntidadesBancarias table.
	 *
	 * @param filterEntidadesBancarias
	 *            EntidadesBancarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<EntidadesBancarias>>
	 */
	List<JerarquiaDto<EntidadesBancarias>> findAllLikeJerarquia(EntidadesBancarias filterEntidadesBancarias,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterEntidadesBancarias
	 *            EntidadesBancarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(EntidadesBancarias filterEntidadesBancarias, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterEntidadesBancarias
	 *            EntidadesBancarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<EntidadesBancarias>>
	 */
	List<TableRowDto<EntidadesBancarias>> findAllChild(EntidadesBancarias filterEntidadesBancarias,
			JQGridRequestDto jqGridRequestDto);

	EntidadesBancarias findByIdRelExpActSub(EntidadesBancarias entidadesBancarias);

}
