package com.ejie.ab60.dao.MEC;

import java.util.List;

import com.ejie.ab60.model.MEC.Iae;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * IaeDao  
 * 
 *  
 */

public interface IaeDao {

	/**
	 * Inserts a single row in the Iae table.
	 *
	 * @param iae
	 *            Iae
	 * @return Iae
	 */
	Iae add(Iae iae);

	/**
	 * Updates a single row in the Iae table.
	 *
	 * @param iae
	 *            Iae
	 * @return Iae
	 */
	Iae update(Iae iae);

	/**
	 * Finds a single row in the Iae table.
	 *
	 * @param iae
	 *            Iae
	 * @return Iae
	 */
	Iae find(Iae iae);

	/**
	 * Removes a single row in the Iae table.
	 *
	 * @param iae
	 *            Iae
	 */
	void remove(Iae iae);

	/**
	 * Finds a List of rows in the Iae table.
	 *
	 * @param iae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Iae> findAll(Iae iae, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Iae table using like.
	 *
	 * @param iae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Iae> findAllLike(Iae iae, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the Iae table.
	 *
	 * @param filterIae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Iae filterIae, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the Iae table using like.
	 *
	 * @param iae
	 *            Iae
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Iae iae, Boolean startsWith);

	/**
	 * Counts rows in the Iae table.
	 *
	 * @param iae
	 *            Iae
	 * @return Long
	 */
	Long findAllCount(Iae iae);

	/**
	 * Reorder selection.
	 *
	 * @param filterIae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Iae>>
	 */
	List<TableRowDto<Iae>> reorderSelection(Iae filterIae, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterIae
	 *            Iae
	 * @param searchIae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Iae>>
	 */
	List<TableRowDto<Iae>> search(Iae filterIae, Iae searchIae, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical Iae table.
	 *
	 * @param filterIae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<Iae>>
	 */
	List<JerarquiaDto<Iae>> findAllLikeJerarquia(Iae filterIae, JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterIae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(Iae filterIae, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterIae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<Iae>>
	 */
	List<TableRowDto<Iae>> findAllChild(Iae filterIae, JQGridRequestDto jqGridRequestDto);

}
