package com.ejie.ab60.dao.MEC;

import com.ejie.ab60.model.MEC.RelFacMotDen;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelFacMotDenDao  
 * 
 *  
 */

public interface RelFacMotDenDao {

	/**
	 * Inserts a single row in the RelFacMotDen table.
	 *
	 * @param relfacmotden
	 *            RelFacMotDen
	 * @return RelFacMotDen
	 */
	RelFacMotDen add(RelFacMotDen relfacmotden);

	/**
	 * Updates a single row in the RelFacMotDen table.
	 *
	 * @param relfacmotden
	 *            RelFacMotDen
	 * @return RelFacMotDen
	 */
	RelFacMotDen update(RelFacMotDen relfacmotden);

	/**
	 * Finds a single row in the RelFacMotDen table.
	 *
	 * @param relfacmotden
	 *            RelFacMotDen
	 * @return RelFacMotDen
	 */
	RelFacMotDen find(RelFacMotDen relfacmotden);

	/**
	 * Saca los ids de motivos de denegacion
	 *
	 * @param idFactura
	 *            Integer
	 * 
	 * @return List<RelActSubMotDen>
	 */

	List<RelFacMotDen> findIdsFacturaMotivosDenegaciones(Integer idFactura);

	/**
	 * Removes a single row in the RelFacMotDen table.
	 *
	 * @param relfacmotden
	 *            RelFacMotDen
	 */
	void remove(RelFacMotDen relfacmotden);

	/**
	 * Finds a List of rows in the RelFacMotDen table.
	 *
	 * @param relfacmotden
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelFacMotDen> findAll(RelFacMotDen relfacmotden, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelFacMotDen table using like.
	 *
	 * @param relfacmotden
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelFacMotDen> findAllLike(RelFacMotDen relfacmotden, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelFacMotDen table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelFacMotDen filterRelFacMotDen, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelFacMotDen table using like.
	 *
	 * @param relfacmotden
	 *            RelFacMotDen
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelFacMotDen relfacmotden, Boolean startsWith);

	/**
	 * Counts rows in the RelFacMotDen table.
	 *
	 * @param relfacmotden
	 *            RelFacMotDen
	 * @return Long
	 */
	Long findAllCount(RelFacMotDen relfacmotden);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelFacMotDen>>
	 */
	List<TableRowDto<RelFacMotDen>> reorderSelection(RelFacMotDen filterRelFacMotDen, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param searchRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelFacMotDen>>
	 */
	List<TableRowDto<RelFacMotDen>> search(RelFacMotDen filterRelFacMotDen, RelFacMotDen searchRelFacMotDen,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelFacMotDen table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelFacMotDen>>
	 */
	List<JerarquiaDto<RelFacMotDen>> findAllLikeJerarquia(RelFacMotDen filterRelFacMotDen,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelFacMotDen filterRelFacMotDen, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelFacMotDen>>
	 */
	List<TableRowDto<RelFacMotDen>> findAllChild(RelFacMotDen filterRelFacMotDen, JQGridRequestDto jqGridRequestDto);

}
