package com.ejie.ab60.dao.MEC;

import com.ejie.ab60.model.MEC.RelFacMotMin;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelFacMotMinDao  
 * 
 *  
 */

public interface RelFacMotMinDao {

	/**
	 * Inserts a single row in the RelFacMotMin table.
	 *
	 * @param relfacmotmin
	 *            RelFacMotMin
	 * @return RelFacMotMin
	 */
	RelFacMotMin add(RelFacMotMin relfacmotmin);

	/**
	 * Updates a single row in the RelFacMotMin table.
	 *
	 * @param relfacmotmin
	 *            RelFacMotMin
	 * @return RelFacMotMin
	 */
	RelFacMotMin update(RelFacMotMin relfacmotmin);

	/**
	 * Finds a single row in the RelFacMotMin table.
	 *
	 * @param relfacmotmin
	 *            RelFacMotMin
	 * @return RelFacMotMin
	 */
	RelFacMotMin find(RelFacMotMin relfacmotmin);

	/**
	 * Saca los ids de motivos de minoracion de facturas
	 *
	 * @param idFactura
	 *            Integer
	 * @param origenMotivosMinoracion
	 * 
	 * @return List<RelActSubMotDen>
	 */

	List<RelFacMotMin> findIdsFacturaMotivosMinoraciones(Integer idFactura, Integer origenMotivosMinoracion);

	/**
	 * Removes a single row in the RelFacMotMin table.
	 *
	 * @param relfacmotmin
	 *            RelFacMotMin
	 */
	void remove(RelFacMotMin relfacmotmin);

	/**
	 * Finds a List of rows in the RelFacMotMin table.
	 *
	 * @param relfacmotmin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelFacMotMin> findAll(RelFacMotMin relfacmotmin, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelFacMotMin table using like.
	 *
	 * @param relfacmotmin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelFacMotMin> findAllLike(RelFacMotMin relfacmotmin, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelFacMotMin table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelFacMotMin filterRelFacMotMin, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelFacMotMin table using like.
	 *
	 * @param relfacmotmin
	 *            RelFacMotMin
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelFacMotMin relfacmotmin, Boolean startsWith);

	/**
	 * Counts rows in the RelFacMotMin table.
	 *
	 * @param relfacmotmin
	 *            RelFacMotMin
	 * @return Long
	 */
	Long findAllCount(RelFacMotMin relfacmotmin);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelFacMotMin>>
	 */
	List<TableRowDto<RelFacMotMin>> reorderSelection(RelFacMotMin filterRelFacMotMin, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param searchRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelFacMotMin>>
	 */
	List<TableRowDto<RelFacMotMin>> search(RelFacMotMin filterRelFacMotMin, RelFacMotMin searchRelFacMotMin,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelFacMotMin table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelFacMotMin>>
	 */
	List<JerarquiaDto<RelFacMotMin>> findAllLikeJerarquia(RelFacMotMin filterRelFacMotMin,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelFacMotMin filterRelFacMotMin, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelFacMotMin>>
	 */
	List<TableRowDto<RelFacMotMin>> findAllChild(RelFacMotMin filterRelFacMotMin, JQGridRequestDto jqGridRequestDto);

}
