package com.ejie.ab60.dao.OTC;

import java.util.List;

import com.ejie.ab60.model.OTC.OficinasTecnicas;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * OficinasTecnicasDao  
 * 
 *  
 */

public interface OficinasTecnicasDao {

	/**
	 * Inserts a single row in the OficinasTecnicas table.
	 *
	 * @param oficinastecnicas
	 *            OficinasTecnicas
	 * @return OficinasTecnicas
	 */
	OficinasTecnicas add(OficinasTecnicas oficinastecnicas);

	/**
	 * Updates a single row in the OficinasTecnicas table.
	 *
	 * @param oficinastecnicas
	 *            OficinasTecnicas
	 * @return OficinasTecnicas
	 */
	OficinasTecnicas update(OficinasTecnicas oficinastecnicas);

	/**
	 * Finds a single row in the OficinasTecnicas table.
	 *
	 * @param oficinastecnicas
	 *            OficinasTecnicas
	 * @return OficinasTecnicas
	 */
	OficinasTecnicas find(OficinasTecnicas oficinastecnicas);

	/**
	 * Removes a single row in the OficinasTecnicas table.
	 *
	 * @param oficinastecnicas
	 *            OficinasTecnicas
	 */
	void remove(OficinasTecnicas oficinastecnicas);

	/**
	 * Finds a List of rows in the OficinasTecnicas table.
	 *
	 * @param oficinastecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<OficinasTecnicas> findAll(OficinasTecnicas oficinastecnicas, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the OficinasTecnicas table using like.
	 *
	 * @param oficinastecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<OficinasTecnicas> findAllLike(OficinasTecnicas oficinastecnicas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the OficinasTecnicas table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(OficinasTecnicas filterOficinasTecnicas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the OficinasTecnicas table using like.
	 *
	 * @param oficinastecnicas
	 *            OficinasTecnicas
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(OficinasTecnicas oficinastecnicas, Boolean startsWith);

	/**
	 * Counts rows in the OficinasTecnicas table.
	 *
	 * @param oficinastecnicas
	 *            OficinasTecnicas
	 * @return Long
	 */
	Long findAllCount(OficinasTecnicas oficinastecnicas);

	/**
	 * Reorder selection.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OficinasTecnicas>>
	 */
	List<TableRowDto<OficinasTecnicas>> reorderSelection(OficinasTecnicas filterOficinasTecnicas,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param searchOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OficinasTecnicas>>
	 */
	List<TableRowDto<OficinasTecnicas>> search(OficinasTecnicas filterOficinasTecnicas,
			OficinasTecnicas searchOficinasTecnicas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical OficinasTecnicas table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<OficinasTecnicas>>
	 */
	List<JerarquiaDto<OficinasTecnicas>> findAllLikeJerarquia(OficinasTecnicas filterOficinasTecnicas,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(OficinasTecnicas filterOficinasTecnicas, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<OficinasTecnicas>>
	 */
	List<TableRowDto<OficinasTecnicas>> findAllChild(OficinasTecnicas filterOficinasTecnicas,
			JQGridRequestDto jqGridRequestDto);

}
