package com.ejie.ab60.dao.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.AmbitosTerritoriales;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * AmbitosTerritorialesDao  
 * 
 *  
 */

public interface AmbitosTerritorialesDao {

	/**
	 * Inserts a single row in the AmbitosTerritoriales table.
	 *
	 * @param ambitosterritoriales
	 *            AmbitosTerritoriales
	 * @return AmbitosTerritoriales
	 */
	AmbitosTerritoriales add(AmbitosTerritoriales ambitosterritoriales);

	/**
	 * Updates a single row in the AmbitosTerritoriales table.
	 *
	 * @param ambitosterritoriales
	 *            AmbitosTerritoriales
	 * @return AmbitosTerritoriales
	 */
	AmbitosTerritoriales update(AmbitosTerritoriales ambitosterritoriales);

	/**
	 * Finds a single row in the AmbitosTerritoriales table.
	 *
	 * @param ambitosterritoriales
	 *            AmbitosTerritoriales
	 * @return AmbitosTerritoriales
	 */
	AmbitosTerritoriales find(AmbitosTerritoriales ambitosterritoriales);

	/**
	 * Removes a single row in the AmbitosTerritoriales table.
	 *
	 * @param ambitosterritoriales
	 *            AmbitosTerritoriales
	 */
	void remove(AmbitosTerritoriales ambitosterritoriales);

	/**
	 * Finds a List of rows in the AmbitosTerritoriales table.
	 *
	 * @param ambitosterritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<AmbitosTerritoriales> findAll(AmbitosTerritoriales ambitosterritoriales, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the AmbitosTerritoriales table using like.
	 *
	 * @param ambitosterritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<AmbitosTerritoriales> findAllLike(AmbitosTerritoriales ambitosterritoriales, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(AmbitosTerritoriales filterAmbitosTerritoriales, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the AmbitosTerritoriales table using like.
	 *
	 * @param ambitosterritoriales
	 *            AmbitosTerritoriales
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(AmbitosTerritoriales ambitosterritoriales, Boolean startsWith);

	/**
	 * Counts rows in the AmbitosTerritoriales table.
	 *
	 * @param ambitosterritoriales
	 *            AmbitosTerritoriales
	 * @return Long
	 */
	Long findAllCount(AmbitosTerritoriales ambitosterritoriales);

	/**
	 * Reorder selection.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AmbitosTerritoriales>>
	 */
	List<TableRowDto<AmbitosTerritoriales>> reorderSelection(AmbitosTerritoriales filterAmbitosTerritoriales,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param searchAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AmbitosTerritoriales>>
	 */
	List<TableRowDto<AmbitosTerritoriales>> search(AmbitosTerritoriales filterAmbitosTerritoriales,
			AmbitosTerritoriales searchAmbitosTerritoriales, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<AmbitosTerritoriales>>
	 */
	List<JerarquiaDto<AmbitosTerritoriales>> findAllLikeJerarquia(AmbitosTerritoriales filterAmbitosTerritoriales,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(AmbitosTerritoriales filterAmbitosTerritoriales, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<AmbitosTerritoriales>>
	 */
	List<TableRowDto<AmbitosTerritoriales>> findAllChild(AmbitosTerritoriales filterAmbitosTerritoriales,
			JQGridRequestDto jqGridRequestDto);

}
