package com.ejie.ab60.dao.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.Competitividad;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * CompetitividadDao  
 * 
 *  
 */

public interface CompetitividadDao {

	/**
	 * Inserts a single row in the Competitividad table.
	 *
	 * @param competitividad
	 *            Competitividad
	 * @return Competitividad
	 */
	Competitividad add(Competitividad competitividad);

	/**
	 * Updates a single row in the Competitividad table.
	 *
	 * @param competitividad
	 *            Competitividad
	 * @return Competitividad
	 */
	Competitividad update(Competitividad competitividad);

	/**
	 * Finds a single row in the Competitividad table.
	 *
	 * @param competitividad
	 *            Competitividad
	 * @return Competitividad
	 */
	Competitividad find(Competitividad competitividad);

	/**
	 * Removes a single row in the Competitividad table.
	 *
	 * @param competitividad
	 *            Competitividad
	 */
	void remove(Competitividad competitividad);

	/**
	 * Finds a List of rows in the Competitividad table.
	 *
	 * @param competitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Competitividad> findAll(Competitividad competitividad, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Competitividad table using like.
	 *
	 * @param competitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Competitividad> findAllLike(Competitividad competitividad, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the Competitividad table.
	 *
	 * @param filterCompetitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Competitividad filterCompetitividad, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the Competitividad table using like.
	 *
	 * @param competitividad
	 *            Competitividad
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Competitividad competitividad, Boolean startsWith);

	/**
	 * Counts rows in the Competitividad table.
	 *
	 * @param competitividad
	 *            Competitividad
	 * @return Long
	 */
	Long findAllCount(Competitividad competitividad);

	/**
	 * Reorder selection.
	 *
	 * @param filterCompetitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Competitividad>>
	 */
	List<TableRowDto<Competitividad>> reorderSelection(Competitividad filterCompetitividad,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterCompetitividad
	 *            Competitividad
	 * @param searchCompetitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Competitividad>>
	 */
	List<TableRowDto<Competitividad>> search(Competitividad filterCompetitividad, Competitividad searchCompetitividad,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical Competitividad table.
	 *
	 * @param filterCompetitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<Competitividad>>
	 */
	List<JerarquiaDto<Competitividad>> findAllLikeJerarquia(Competitividad filterCompetitividad,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterCompetitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(Competitividad filterCompetitividad, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterCompetitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<Competitividad>>
	 */
	List<TableRowDto<Competitividad>> findAllChild(Competitividad filterCompetitividad,
			JQGridRequestDto jqGridRequestDto);

}
