package com.ejie.ab60.dao.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.ContratacionesPersonal;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ContratacionesPersonalDao  
 * 
 *  
 */

public interface ContratacionesPersonalDao {

	/**
	 * Inserts a single row in the ContratacionesPersonal table.
	 *
	 * @param contratacionespersonal
	 *            ContratacionesPersonal
	 * @return ContratacionesPersonal
	 */
	ContratacionesPersonal add(ContratacionesPersonal contratacionespersonal);

	/**
	 * Updates a single row in the ContratacionesPersonal table.
	 *
	 * @param contratacionespersonal
	 *            ContratacionesPersonal
	 * @return ContratacionesPersonal
	 */
	ContratacionesPersonal update(ContratacionesPersonal contratacionespersonal);

	/**
	 * Finds a single row in the ContratacionesPersonal table.
	 *
	 * @param contratacionespersonal
	 *            ContratacionesPersonal
	 * @return ContratacionesPersonal
	 */
	ContratacionesPersonal find(ContratacionesPersonal contratacionespersonal);

	/**
	 * Finds a List of rows in the ContratacionesPersonal table.
	 *
	 * @param Integer
	 *            idRelExpActSub
	 * @return List
	 */
	List<ContratacionesPersonal> findContratacionesPersonalPorRelExpActSub(Integer idRelExpActSub);

	/**
	 * Removes a single row in the ContratacionesPersonal table.
	 *
	 * @param contratacionespersonal
	 *            ContratacionesPersonal
	 */
	void remove(ContratacionesPersonal contratacionespersonal);

	/**
	 * Finds a List of rows in the ContratacionesPersonal table.
	 *
	 * @param contratacionespersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<ContratacionesPersonal> findAll(ContratacionesPersonal contratacionespersonal,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ContratacionesPersonal table using like.
	 *
	 * @param contratacionespersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<ContratacionesPersonal> findAllLike(ContratacionesPersonal contratacionespersonal,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the ContratacionesPersonal table.
	 *
	 * @param filterContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ContratacionesPersonal filterContratacionesPersonal, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the ContratacionesPersonal table using like.
	 *
	 * @param contratacionespersonal
	 *            ContratacionesPersonal
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(ContratacionesPersonal contratacionespersonal, Boolean startsWith);

	/**
	 * Counts rows in the ContratacionesPersonal table.
	 *
	 * @param contratacionespersonal
	 *            ContratacionesPersonal
	 * @return Long
	 */
	Long findAllCount(ContratacionesPersonal contratacionespersonal);

	/**
	 * Reorder selection.
	 *
	 * @param filterContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ContratacionesPersonal>>
	 */
	List<TableRowDto<ContratacionesPersonal>> reorderSelection(ContratacionesPersonal filterContratacionesPersonal,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param searchContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ContratacionesPersonal>>
	 */
	List<TableRowDto<ContratacionesPersonal>> search(ContratacionesPersonal filterContratacionesPersonal,
			ContratacionesPersonal searchContratacionesPersonal, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical ContratacionesPersonal table.
	 *
	 * @param filterContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<ContratacionesPersonal>>
	 */
	List<JerarquiaDto<ContratacionesPersonal>> findAllLikeJerarquia(ContratacionesPersonal filterContratacionesPersonal,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(ContratacionesPersonal filterContratacionesPersonal,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<ContratacionesPersonal>>
	 */
	List<TableRowDto<ContratacionesPersonal>> findAllChild(ContratacionesPersonal filterContratacionesPersonal,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Removes a single row in the ContratacionesPersonal table.
	 *
	 * @param idRelExpActSub
	 *            Integer
	 * @return
	 */
	void removeByIdRelExpActSub(Integer idRelExpActSub);

}
