package com.ejie.ab60.dao.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.GastosTuristicos;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * GastosTuristicosDao  
 * 
 *  
 */

public interface GastosTuristicosDao {

	/**
	 * Inserts a single row in the GastosTuristicos table.
	 *
	 * @param gastosturisticos
	 *            GastosTuristicos
	 * @return GastosTuristicos
	 */
	GastosTuristicos add(GastosTuristicos gastosturisticos);

	/**
	 * Updates a single row in the GastosTuristicos table.
	 *
	 * @param gastosturisticos
	 *            GastosTuristicos
	 * @return GastosTuristicos
	 */
	GastosTuristicos update(GastosTuristicos gastosturisticos);

	/**
	 * Updates a single row in the GastosTuristicos table.
	 *
	 * @param gastosturisticos
	 *            GastosTuristicos
	 * @return GastosTuristicos
	 */
	GastosTuristicos updateGastosTuristicos(GastosTuristicos gastosturisticos);

	/**
	 * Finds a single row in the GastosTuristicos table.
	 *
	 * @param gastosturisticos
	 *            GastosTuristicos
	 * @return GastosTuristicos
	 */
	GastosTuristicos find(GastosTuristicos gastosturisticos);

	/**
	 * Removes a single row in the GastosTuristicos table.
	 *
	 * @param gastosturisticos
	 *            GastosTuristicos
	 */
	void remove(GastosTuristicos gastosturisticos);

	/**
	 * Finds a List of rows in the GastosTuristicos table.
	 *
	 * @param gastosturisticos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<GastosTuristicos> findAll(GastosTuristicos gastosturisticos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the GastosTuristicos table using like.
	 *
	 * @param gastosturisticos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<GastosTuristicos> findAllLike(GastosTuristicos gastosturisticos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the GastosTuristicos table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(GastosTuristicos filterGastosTuristicos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the GastosTuristicos table using like.
	 *
	 * @param gastosturisticos
	 *            GastosTuristicos
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(GastosTuristicos gastosturisticos, Boolean startsWith);

	/**
	 * Counts rows in the GastosTuristicos table.
	 *
	 * @param gastosturisticos
	 *            GastosTuristicos
	 * @return Long
	 */
	Long findAllCount(GastosTuristicos gastosturisticos);

	/**
	 * Reorder selection.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<GastosTuristicos>>
	 */
	List<TableRowDto<GastosTuristicos>> reorderSelection(GastosTuristicos filterGastosTuristicos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param searchGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<GastosTuristicos>>
	 */
	List<TableRowDto<GastosTuristicos>> search(GastosTuristicos filterGastosTuristicos,
			GastosTuristicos searchGastosTuristicos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical GastosTuristicos table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<GastosTuristicos>>
	 */
	List<JerarquiaDto<GastosTuristicos>> findAllLikeJerarquia(GastosTuristicos filterGastosTuristicos,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(GastosTuristicos filterGastosTuristicos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<GastosTuristicos>>
	 */
	List<TableRowDto<GastosTuristicos>> findAllChild(GastosTuristicos filterGastosTuristicos,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * findGastosTuristicosPorRelExpActSub
	 * 
	 * @param idRelExpActSub
	 *            Integer
	 */
	GastosTuristicos findGastosTuristicosPorRelExpActSub(Integer idRelExpActSub);

}
