package com.ejie.ab60.dao.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.ModalidadesContrato;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ModalidadesContratoDao  
 * 
 *  
 */

public interface ModalidadesContratoDao {

	/**
	 * Finds a list of rows in the ModalidadesContrato table.
	 * 
	 * @param modalidadesContrato
	 *
	 * 
	 * @return List<ModalidadesContrato>
	 */
	List<ModalidadesContrato> findModalidadesContrato();

	/**
	 * Inserts a single row in the ModalidadesContrato table.
	 *
	 * @param modalidadescontrato
	 *            ModalidadesContrato
	 * @return ModalidadesContrato
	 */
	ModalidadesContrato add(ModalidadesContrato modalidadescontrato);

	/**
	 * Updates a single row in the ModalidadesContrato table.
	 *
	 * @param modalidadescontrato
	 *            ModalidadesContrato
	 * @return ModalidadesContrato
	 */
	ModalidadesContrato update(ModalidadesContrato modalidadescontrato);

	/**
	 * Finds a single row in the ModalidadesContrato table.
	 *
	 * @param modalidadescontrato
	 *            ModalidadesContrato
	 * @return ModalidadesContrato
	 */
	ModalidadesContrato find(ModalidadesContrato modalidadescontrato);

	/**
	 * Removes a single row in the ModalidadesContrato table.
	 *
	 * @param modalidadescontrato
	 *            ModalidadesContrato
	 */
	void remove(ModalidadesContrato modalidadescontrato);

	/**
	 * Finds a List of rows in the ModalidadesContrato table.
	 *
	 * @param modalidadescontrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<ModalidadesContrato> findAll(ModalidadesContrato modalidadescontrato, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ModalidadesContrato table using like.
	 *
	 * @param modalidadescontrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<ModalidadesContrato> findAllLike(ModalidadesContrato modalidadescontrato, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the ModalidadesContrato table.
	 *
	 * @param filterModalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ModalidadesContrato filterModalidadesContrato, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the ModalidadesContrato table using like.
	 *
	 * @param modalidadescontrato
	 *            ModalidadesContrato
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(ModalidadesContrato modalidadescontrato, Boolean startsWith);

	/**
	 * Counts rows in the ModalidadesContrato table.
	 *
	 * @param modalidadescontrato
	 *            ModalidadesContrato
	 * @return Long
	 */
	Long findAllCount(ModalidadesContrato modalidadescontrato);

	/**
	 * Reorder selection.
	 *
	 * @param filterModalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ModalidadesContrato>>
	 */
	List<TableRowDto<ModalidadesContrato>> reorderSelection(ModalidadesContrato filterModalidadesContrato,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterModalidadesContrato
	 *            ModalidadesContrato
	 * @param searchModalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ModalidadesContrato>>
	 */
	List<TableRowDto<ModalidadesContrato>> search(ModalidadesContrato filterModalidadesContrato,
			ModalidadesContrato searchModalidadesContrato, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical ModalidadesContrato table.
	 *
	 * @param filterModalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<ModalidadesContrato>>
	 */
	List<JerarquiaDto<ModalidadesContrato>> findAllLikeJerarquia(ModalidadesContrato filterModalidadesContrato,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterModalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(ModalidadesContrato filterModalidadesContrato, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterModalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<ModalidadesContrato>>
	 */
	List<TableRowDto<ModalidadesContrato>> findAllChild(ModalidadesContrato filterModalidadesContrato,
			JQGridRequestDto jqGridRequestDto);

}
