package com.ejie.ab60.dao.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.ContratacionesPersonal;
import com.ejie.ab60.model.PTT.PersonasContratadas;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * PersonasContratadasDao  
 * 
 *  
 */

public interface PersonasContratadasDao {

	/**
	 * Inserts a single row in the PersonasContratadas table.
	 *
	 * @param personascontratadas
	 *            PersonasContratadas
	 * @return PersonasContratadas
	 */
	PersonasContratadas add(PersonasContratadas personascontratadas);

	/**
	 * Updates a single row in the PersonasContratadas table.
	 *
	 * @param personascontratadas
	 *            PersonasContratadas
	 * @return PersonasContratadas
	 */
	PersonasContratadas update(PersonasContratadas personascontratadas);

	/**
	 * Finds a single row in the PersonasContratadas table.
	 *
	 * @param personascontratadas
	 *            PersonasContratadas
	 * @return PersonasContratadas
	 */
	PersonasContratadas find(PersonasContratadas personascontratadas);

	/**
	 * Finds a List of rows in the PersonasContratadas table.
	 *
	 * @param Integer
	 *            idRelExpActSub
	 * @return List
	 */
	List<PersonasContratadas> findPersonasContratadasPorRelExpActSub(Integer idRelExpActSub);

	/**
	 * Removes a single row in the PersonasContratadas table.
	 *
	 * @param personascontratadas
	 *            PersonasContratadas
	 */
	void remove(PersonasContratadas personascontratadas);

	/**
	 * Finds a List of rows in the PersonasContratadas table.
	 *
	 * @param personascontratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<PersonasContratadas> findAll(PersonasContratadas personascontratadas, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the PersonasContratadas table using like.
	 *
	 * @param personascontratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<PersonasContratadas> findAllLike(PersonasContratadas personascontratadas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the PersonasContratadas table.
	 *
	 * @param filterPersonasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(PersonasContratadas filterPersonasContratadas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the PersonasContratadas table using like.
	 *
	 * @param personascontratadas
	 *            PersonasContratadas
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(PersonasContratadas personascontratadas, Boolean startsWith);

	/**
	 * Counts rows in the PersonasContratadas table.
	 *
	 * @param personascontratadas
	 *            PersonasContratadas
	 * @return Long
	 */
	Long findAllCount(PersonasContratadas personascontratadas);

	/**
	 * Reorder selection.
	 *
	 * @param filterPersonasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<PersonasContratadas>>
	 */
	List<TableRowDto<PersonasContratadas>> reorderSelection(PersonasContratadas filterPersonasContratadas,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterPersonasContratadas
	 *            PersonasContratadas
	 * @param searchPersonasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<PersonasContratadas>>
	 */
	List<TableRowDto<PersonasContratadas>> search(PersonasContratadas filterPersonasContratadas,
			PersonasContratadas searchPersonasContratadas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical PersonasContratadas table.
	 *
	 * @param filterPersonasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<PersonasContratadas>>
	 */
	List<JerarquiaDto<PersonasContratadas>> findAllLikeJerarquia(PersonasContratadas filterPersonasContratadas,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterPersonasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(PersonasContratadas filterPersonasContratadas, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterPersonasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<PersonasContratadas>>
	 */
	List<TableRowDto<PersonasContratadas>> findAllChild(PersonasContratadas filterPersonasContratadas,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Removes a single row in the PersonasContratadas table.
	 *
	 * @param idRelExpActSub
	 *            Integer
	 * @return
	 */
	void removeByIdRelExpActSub(Integer idRelExpActSub);

}
