package com.ejie.ab60.dao.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.PertenenciasRedes;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * PertenenciasRedesDao  
 * 
 *  
 */

public interface PertenenciasRedesDao {

	/**
	 * Inserts a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasredes
	 *            PertenenciasRedes
	 * @return PertenenciasRedes
	 */
	PertenenciasRedes add(PertenenciasRedes pertenenciasredes);

	/**
	 * Updates a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasredes
	 *            PertenenciasRedes
	 * @return PertenenciasRedes
	 */
	PertenenciasRedes update(PertenenciasRedes pertenenciasredes);

	/**
	 * Updates a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasredes
	 *            PertenenciasRedes
	 * @return PertenenciasRedes
	 */
	PertenenciasRedes updateDenominacionRedes(PertenenciasRedes pertenenciasredes);

	/**
	 * Finds a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasredes
	 *            PertenenciasRedes
	 * @return PertenenciasRedes
	 */
	PertenenciasRedes find(PertenenciasRedes pertenenciasredes);

	/**
	 * Removes a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasredes
	 *            PertenenciasRedes
	 */
	void remove(PertenenciasRedes pertenenciasredes);

	/**
	 * Finds a List of rows in the PertenenciasRedes table.
	 *
	 * @param pertenenciasredes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<PertenenciasRedes> findAll(PertenenciasRedes pertenenciasredes, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the PertenenciasRedes table using like.
	 *
	 * @param pertenenciasredes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<PertenenciasRedes> findAllLike(PertenenciasRedes pertenenciasredes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the PertenenciasRedes table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(PertenenciasRedes filterPertenenciasRedes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the PertenenciasRedes table using like.
	 *
	 * @param pertenenciasredes
	 *            PertenenciasRedes
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(PertenenciasRedes pertenenciasredes, Boolean startsWith);

	/**
	 * Counts rows in the PertenenciasRedes table.
	 *
	 * @param pertenenciasredes
	 *            PertenenciasRedes
	 * @return Long
	 */
	Long findAllCount(PertenenciasRedes pertenenciasredes);

	/**
	 * Reorder selection.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<PertenenciasRedes>>
	 */
	List<TableRowDto<PertenenciasRedes>> reorderSelection(PertenenciasRedes filterPertenenciasRedes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param searchPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<PertenenciasRedes>>
	 */
	List<TableRowDto<PertenenciasRedes>> search(PertenenciasRedes filterPertenenciasRedes,
			PertenenciasRedes searchPertenenciasRedes, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical PertenenciasRedes table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<PertenenciasRedes>>
	 */
	List<JerarquiaDto<PertenenciasRedes>> findAllLikeJerarquia(PertenenciasRedes filterPertenenciasRedes,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(PertenenciasRedes filterPertenenciasRedes, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<PertenenciasRedes>>
	 */
	List<TableRowDto<PertenenciasRedes>> findAllChild(PertenenciasRedes filterPertenenciasRedes,
			JQGridRequestDto jqGridRequestDto);

}
