package com.ejie.ab60.dao.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.ProductosTuristicos;
import com.ejie.ab60.model.estudioTecnico.TiposGasto;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ProductosTuristicosDao  
 * 
 *  
 */

public interface ProductosTuristicosDao {

	/**
	 * Inserts a single row in the ProductosTuristicos table.
	 *
	 * @param productosturisticos
	 *            ProductosTuristicos
	 * @return ProductosTuristicos
	 */
	ProductosTuristicos add(ProductosTuristicos productosturisticos);

	/**
	 * Updates a single row in the ProductosTuristicos table.
	 *
	 * @param productosturisticos
	 *            ProductosTuristicos
	 * @return ProductosTuristicos
	 */
	ProductosTuristicos update(ProductosTuristicos productosturisticos);

	/**
	 * Finds a single row in the ProductosTuristicos table.
	 *
	 * @param productosturisticos
	 *            ProductosTuristicos
	 * @return ProductosTuristicos
	 */
	ProductosTuristicos find(ProductosTuristicos productosturisticos);

	/**
	 * Removes a single row in the ProductosTuristicos table.
	 *
	 * @param productosturisticos
	 *            ProductosTuristicos
	 */
	void remove(ProductosTuristicos productosturisticos);

	/**
	 * Finds a List of rows in the ProductosTuristicos table.
	 *
	 * @param productosturisticos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<ProductosTuristicos> findAll(ProductosTuristicos productosturisticos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the ProductosTuristicos table.
	 * 
	 * @param productosTuristicos
	 *
	 * 
	 * @return List<ProductosTuristicos>
	 */
	List<ProductosTuristicos> findProductosTuristicos(ProductosTuristicos productosTuristicos);

	/**
	 * Finds rows in the ProductosTuristicos table using like.
	 *
	 * @param productosturisticos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<ProductosTuristicos> findAllLike(ProductosTuristicos productosturisticos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ProductosTuristicos filterProductosTuristicos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the ProductosTuristicos table using like.
	 *
	 * @param productosturisticos
	 *            ProductosTuristicos
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(ProductosTuristicos productosturisticos, Boolean startsWith);

	/**
	 * Counts rows in the ProductosTuristicos table.
	 *
	 * @param productosturisticos
	 *            ProductosTuristicos
	 * @return Long
	 */
	Long findAllCount(ProductosTuristicos productosturisticos);

	/**
	 * Reorder selection.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ProductosTuristicos>>
	 */
	List<TableRowDto<ProductosTuristicos>> reorderSelection(ProductosTuristicos filterProductosTuristicos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param searchProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ProductosTuristicos>>
	 */
	List<TableRowDto<ProductosTuristicos>> search(ProductosTuristicos filterProductosTuristicos,
			ProductosTuristicos searchProductosTuristicos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<ProductosTuristicos>>
	 */
	List<JerarquiaDto<ProductosTuristicos>> findAllLikeJerarquia(ProductosTuristicos filterProductosTuristicos,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(ProductosTuristicos filterProductosTuristicos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<ProductosTuristicos>>
	 */
	List<TableRowDto<ProductosTuristicos>> findAllChild(ProductosTuristicos filterProductosTuristicos,
			JQGridRequestDto jqGridRequestDto);

}
