package com.ejie.ab60.dao.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.RelExpAmbTer;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpAmbTerDao  
 * 
 *  
 */

public interface RelExpAmbTerDao {

	/**
	 * Inserts a single row in the RelExpAmbTer table.
	 *
	 * @param relexpambter
	 *            RelExpAmbTer
	 * @return RelExpAmbTer
	 */
	RelExpAmbTer add(RelExpAmbTer relexpambter);

	/**
	 * Updates a single row in the RelExpAmbTer table.
	 *
	 * @param relexpambter
	 *            RelExpAmbTer
	 * @return RelExpAmbTer
	 */
	RelExpAmbTer update(RelExpAmbTer relexpambter);

	/**
	 * Finds a single row in the RelExpAmbTer table.
	 *
	 * @param relexpambter
	 *            RelExpAmbTer
	 * @return RelExpAmbTer
	 */
	RelExpAmbTer find(RelExpAmbTer relexpambter);

	/**
	 * Removes a single row in the RelExpAmbTer table.
	 *
	 * @param relexpambter
	 *            RelExpAmbTer
	 */
	void remove(RelExpAmbTer relexpambter);

	/**
	 * Finds a List of rows in the RelExpAmbTer table.
	 *
	 * @param relexpambter
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelExpAmbTer> findAll(RelExpAmbTer relexpambter, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelExpAmbTer table using like.
	 *
	 * @param relexpambter
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelExpAmbTer> findAllLike(RelExpAmbTer relexpambter, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelExpAmbTer table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpAmbTer filterRelExpAmbTer, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelExpAmbTer table using like.
	 *
	 * @param relexpambter
	 *            RelExpAmbTer
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelExpAmbTer relexpambter, Boolean startsWith);

	/**
	 * Counts rows in the RelExpAmbTer table.
	 *
	 * @param relexpambter
	 *            RelExpAmbTer
	 * @return Long
	 */
	Long findAllCount(RelExpAmbTer relexpambter);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpAmbTer>>
	 */
	List<TableRowDto<RelExpAmbTer>> reorderSelection(RelExpAmbTer filterRelExpAmbTer, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param searchRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpAmbTer>>
	 */
	List<TableRowDto<RelExpAmbTer>> search(RelExpAmbTer filterRelExpAmbTer, RelExpAmbTer searchRelExpAmbTer,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelExpAmbTer table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelExpAmbTer>>
	 */
	List<JerarquiaDto<RelExpAmbTer>> findAllLikeJerarquia(RelExpAmbTer filterRelExpAmbTer,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelExpAmbTer filterRelExpAmbTer, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelExpAmbTer>>
	 */
	List<TableRowDto<RelExpAmbTer>> findAllChild(RelExpAmbTer filterRelExpAmbTer, JQGridRequestDto jqGridRequestDto);

}
