package com.ejie.ab60.dao;

import java.util.List;

import com.ejie.ab60.model.RelExpIns;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpInsDao  
 * 
 * 
 *  
 */

public interface RelExpInsDao {

	/**
	 * Inserts a single row in the RelExpIns table.
	 *
	 * @param relexpins
	 *            RelExpIns
	 * @return RelExpIns
	 */
	RelExpIns add(RelExpIns relexpins);

	/**
	 * Updates a single row in the RelExpIns table.
	 *
	 * @param relexpins
	 *            RelExpIns
	 * @return RelExpIns
	 */
	RelExpIns update(RelExpIns relexpins);

	/**
	 * Finds a single row in the RelExpIns table.
	 *
	 * @param relexpins
	 *            RelExpIns
	 * @return RelExpIns
	 */
	RelExpIns find(RelExpIns relexpins);

	/**
	 * Removes a single row in the RelExpIns table.
	 *
	 * @param relexpins
	 *            RelExpIns
	 */
	void remove(RelExpIns relexpins);

	/**
	 * Finds a List of rows in the RelExpIns table.
	 *
	 * @param relexpins
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelExpIns> findAll(RelExpIns relexpins, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelExpIns table using like.
	 *
	 * @param relexpins
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelExpIns> findAllLike(RelExpIns relexpins, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelExpIns table.
	 *
	 * @param filterRelExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpIns filterRelExpIns, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelExpIns table using like.
	 *
	 * @param relexpins
	 *            RelExpIns
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelExpIns relexpins, Boolean startsWith);

	/**
	 * Counts rows in the RelExpIns table.
	 *
	 * @param relexpins
	 *            RelExpIns
	 * @return Long
	 */
	Long findAllCount(RelExpIns relexpins);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpIns>>
	 */
	List<TableRowDto<RelExpIns>> reorderSelection(RelExpIns filterRelExpIns, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelExpIns
	 *            RelExpIns
	 * @param searchRelExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpIns>>
	 */
	List<TableRowDto<RelExpIns>> search(RelExpIns filterRelExpIns, RelExpIns searchRelExpIns,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelExpIns table.
	 *
	 * @param filterRelExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelExpIns>>
	 */
	List<JerarquiaDto<RelExpIns>> findAllLikeJerarquia(RelExpIns filterRelExpIns, JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelExpIns filterRelExpIns, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelExpIns>>
	 */
	List<TableRowDto<RelExpIns>> findAllChild(RelExpIns filterRelExpIns, JQGridRequestDto jqGridRequestDto);

	RelExpIns findTipoInspeccion(RelExpIns relexpins);

	RelExpIns findByIdExpediente(RelExpIns relExpIns);

	Integer obtenerID(String identificadorInspeccion);

	List<RelExpIns> findIdentificadorInspeccionByIdExpediente(RelExpIns relExpIns);

	RelExpIns findByIdentificadorInspeccion(RelExpIns relExpIns);

	RelExpIns findByIdInspeccion(RelExpIns relExpIns);

}
