package com.ejie.ab60.dao;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.VExpInfContable;

/**
 * VExpInfContableDao  
 *  
 */

public interface VExpInfContableDao {
    
    /**
     * Inserts a single row in the VExpInfContable table.
     *
     * @param vexpinfcontable VExpInfContable
     * @return VExpInfContable
     */
    VExpInfContable add(VExpInfContable vexpinfcontable);

    /**
     * Updates a single row in the VExpInfContable table.
     *
     * @param vexpinfcontable VExpInfContable
     * @return VExpInfContable
     */
    VExpInfContable update(VExpInfContable vexpinfcontable);

    /**
     * Finds a single row in the VExpInfContable table.
     *
     * @param vexpinfcontable VExpInfContable
     * @return VExpInfContable
     */
    VExpInfContable find(VExpInfContable vexpinfcontable);

    /**
     * Removes a single row in the VExpInfContable table.
     *
     * @param vexpinfcontable VExpInfContable
     */
    void remove(VExpInfContable vexpinfcontable);

    /**
     * Finds a List of rows in the VExpInfContable table.
     *
     * @param vexpinfcontable VExpInfContable
     * @param jqGridRequestDto JQGridRequestDto
     * @return List
     */
    List<VExpInfContable> findAll(VExpInfContable vexpinfcontable, JQGridRequestDto jqGridRequestDto);

	/**
     * Finds rows in the VExpInfContable table using like.
     *
     * @param vexpinfcontable VExpInfContable
     * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean
     * @return List
     */
	List<VExpInfContable> findAllLike(VExpInfContable vexpinfcontable, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Filter in the VExpInfContable table.
	 *
	 * @param filterVExpInfContable VExpInfContable
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	 void removeMultiple(VExpInfContable filterVExpInfContable, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
    /**
     * Counts rows in the VExpInfContable table using like.
     *
     * @param vexpinfcontable VExpInfContable
     * @param startsWith Boolean
     * @return Long
     */
    Long findAllLikeCount(VExpInfContable vexpinfcontable, Boolean startsWith);
    
    /**
     * Counts rows in the VExpInfContable table.
     *
     * @param vexpinfcontable VExpInfContable
     * @return Long
     */
    Long findAllCount(VExpInfContable vexpinfcontable);
    
    /**
	 * Reorder selection.
	 *
	 * @param filterVExpInfContable VExpInfContable
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<VExpInfContable>>
	 */	
    List<TableRowDto<VExpInfContable>> reorderSelection(VExpInfContable filterVExpInfContable, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
     /**
	 * Searches in the Usuario table.
	 *
	 * @param filterVExpInfContable VExpInfContable
	 * @param searchVExpInfContable VExpInfContable
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<VExpInfContable>>	 
	 */	
    List<TableRowDto<VExpInfContable>> search(VExpInfContable filterVExpInfContable, VExpInfContable searchVExpInfContable, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
    
    /**
	 * Filter in the hierarchical VExpInfContable table.
	 *
	 * @param filterVExpInfContable VExpInfContable
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<JerarquiaDto<VExpInfContable>>
	 */	
	List<JerarquiaDto<VExpInfContable>> findAllLikeJerarquia(VExpInfContable filterVExpInfContable, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Count rows in hierarchy
	 *
	 * @param filterVExpInfContable VExpInfContable
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return Long
	 */	
	Long findAllLikeCountJerarquia(VExpInfContable filterVExpInfContable, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterVExpInfContable VExpInfContable
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<TableRowDto<VExpInfContable>>
	 */	
	List<TableRowDto<VExpInfContable>> findAllChild(VExpInfContable filterVExpInfContable, JQGridRequestDto jqGridRequestDto);
	
	
}

