package com.ejie.ab60.dao.actuacionesSubvencionables;

import java.util.List;

import com.ejie.ab60.model.actuacionesSubvencionables.ActSubvencionable;
import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.ab60.model.estudioTecnico.RelExpErrCal;
import com.ejie.ab60.model.expedientes.MarcarInspeccionableAct;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ActSubvencionableDao  
 * 
 *  
 */

public interface ActSubvencionableDao {

	/**
	 * Inserts a single row in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable add(ActSubvencionable actsubvencionable);

	/**
	 * Updates a single row in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable update(ActSubvencionable actsubvencionable);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable find(ActSubvencionable actsubvencionable);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable findImporteDisponible(ActSubvencionable actsubvencionable);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable findIdActSub(Integer idActSub);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable findPorcentaje(ActSubvencionable actsubvencionable);

	/**
	 * Busca las act. subvencionables de una convocatoria segun el padre de la
	 * actuacion subvencionable
	 *
	 * @param Idconvocatoria
	 *            Integer
	 * @param idCriterio
	 *            Integer
	 * @return actSubvencionableList
	 */
	List<ActSubvencionable> findActSubporConvocatoriaPorActSubPadre(Integer Idconvocatoria, Integer idCriterio);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findAccionSubvencionablePadre(Integer idExpediente, Integer idConvocatoria);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findAccionSubvencionableDEC(Integer idExpediente, Integer idConvocatoria);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findAccionSubvencionableEMCO(Integer idExpediente, Integer idConvocatoria);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findAccionSubvencionablePadrePTT(Integer idConvocatoria);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findAccionSubvencionableNieto(Integer idActSub);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param idActSubAgrupacion
	 *            Integer
	 * @param existe_Pertenencia_Redes
	 *            Boolean
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findAccionSubvencionableHijoPTT(Integer idActSubAgrupacion,
			Boolean existe_Pertenencia_Redes);

	List<ActSubvencionable> findComboMEC(Integer idConvocatoria);

	/**
	 * Removes a single row in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 */
	void remove(ActSubvencionable actsubvencionable);

	/**
	 * Finds a List of rows in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<ActSubvencionable> findAll(ActSubvencionable actsubvencionable, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ActSubvencionable table using like.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<ActSubvencionable> findAllLike(ActSubvencionable actsubvencionable, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finds rows in the ActSubvencionable table using like.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<ActSubvencionable> findAllLikePorcentaje(ActSubvencionable actsubvencionable,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ActSubvencionable filterActSubvencionable, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the ActSubvencionable table using like.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(ActSubvencionable actsubvencionable, Boolean startsWith);

	/**
	 * Counts rows in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @return Long
	 */
	Long findAllCount(ActSubvencionable actsubvencionable);

	/**
	 * Reorder selection.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ActSubvencionable>>
	 */
	List<TableRowDto<ActSubvencionable>> reorderSelection(ActSubvencionable filterActSubvencionable,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param searchActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ActSubvencionable>>
	 */
	List<TableRowDto<ActSubvencionable>> search(ActSubvencionable filterActSubvencionable,
			ActSubvencionable searchActSubvencionable, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<ActSubvencionable>>
	 */
	List<JerarquiaDto<ActSubvencionable>> findAllLikeJerarquia(ActSubvencionable filterActSubvencionable,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(ActSubvencionable filterActSubvencionable, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<ActSubvencionable>>
	 */
	List<TableRowDto<ActSubvencionable>> findAllChild(ActSubvencionable filterActSubvencionable,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Updatea el importe disponible
	 * 
	 * @param actSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable updateImporteDisponible(ActSubvencionable actSubvencionable);

	/**
	 * Updates Importe en acciones subencionables table.
	 *
	 * @param actSubvencionable
	 *            actSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable updateImporte(ActSubvencionable actSubvencionable);

	/**
	 * recupera el importe disponible para cada accion subencionable de una
	 * convocatoria.
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findImporteActSubvencionable(Integer idConvocatoria);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actsubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findImporteImporteDisponibleActSub(Integer idActSub);

	RelExpErrCal obtenerDescripcionActSub(RelExpErrCal relExpErrCal);

	Integer obtenerIdentificadorAgrupacion(Integer idActuacionSubvencionable);

	List<MarcarInspeccionableAct> findSubActMarcarInspeccionable(Integer idExpediente, Convocatorias convocatoria);

	Long findAllLikeCountSubAct(Integer idExpediente, boolean b);

	List<MarcarInspeccionableAct> findSubActMarcarInspeccionableEMCO(Integer idExpediente);

	Long findAllLikeCountSubActEMCO(Integer idExpediente, boolean b);

	List<ActSubvencionable> findComboEMCO(Integer idConvocatoria, Integer idRelExpActSub);

	List<ActSubvencionable> findAccionSubvencionableAsoEMCO(Integer idExpediente, Integer idConvocatoria);

	List<ActSubvencionable> getAccionSubvencionableAsoEMCONieto(Integer idActSub, Integer idExpediente);

	List<MarcarInspeccionableAct> findSubActMarcarInspeccionableDEC(Integer idExpediente, Convocatorias convocatoria,
			Integer idActSubPadre);
}