package com.ejie.ab60.dao.actuacionesSubvencionables;

import com.ejie.ab60.model.actuacionesSubvencionables.RelActSubMotDen;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelActSubMotDenDao  
 * 
 *  
 */

public interface RelActSubMotDenDao {

	/**
	 * Inserts a single row in the RelActSubMotDen table.
	 *
	 * @param relactsubmotden
	 *            RelActSubMotDen
	 * @return RelActSubMotDen
	 */
	RelActSubMotDen add(RelActSubMotDen relactsubmotden);

	/**
	 * Updates a single row in the RelActSubMotDen table.
	 *
	 * @param relactsubmotden
	 *            RelActSubMotDen
	 * @return RelActSubMotDen
	 */
	RelActSubMotDen update(RelActSubMotDen relactsubmotden);

	/**
	 * Finds a single row in the RelActSubMotDen table.
	 *
	 * @param relactsubmotden
	 *            RelActSubMotDen
	 * @return RelActSubMotDen
	 */
	RelActSubMotDen find(RelActSubMotDen relactsubmotden);

	/**
	 * Saca los ids de motivos de denegacion
	 *
	 * @param idRelActSubMotDen
	 *            Integer
	 * 
	 * @return List<RelActSubMotDen>
	 */

	List<RelActSubMotDen> findIdsMotivosDenegaciones(Integer idRelActSubMotDen);

	/**
	 * Removes a single row in the RelActSubMotDen table.
	 *
	 * @param relactsubmotden
	 *            RelActSubMotDen
	 */
	void remove(RelActSubMotDen relactsubmotden, Integer origen);

	/**
	 * Finds a List of rows in the RelActSubMotDen table.
	 *
	 * @param relactsubmotden
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelActSubMotDen> findAll(RelActSubMotDen relactsubmotden, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelActSubMotDen table using like.
	 *
	 * @param relactsubmotden
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelActSubMotDen> findAllLike(RelActSubMotDen relactsubmotden, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelActSubMotDen table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelActSubMotDen filterRelActSubMotDen, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelActSubMotDen table using like.
	 *
	 * @param relactsubmotden
	 *            RelActSubMotDen
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelActSubMotDen relactsubmotden, Boolean startsWith);

	/**
	 * Counts rows in the RelActSubMotDen table.
	 *
	 * @param relactsubmotden
	 *            RelActSubMotDen
	 * @return Long
	 */
	Long findAllCount(RelActSubMotDen relactsubmotden);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActSubMotDen>>
	 */
	List<TableRowDto<RelActSubMotDen>> reorderSelection(RelActSubMotDen filterRelActSubMotDen,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param searchRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActSubMotDen>>
	 */
	List<TableRowDto<RelActSubMotDen>> search(RelActSubMotDen filterRelActSubMotDen,
			RelActSubMotDen searchRelActSubMotDen, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelActSubMotDen table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelActSubMotDen>>
	 */
	List<JerarquiaDto<RelActSubMotDen>> findAllLikeJerarquia(RelActSubMotDen filterRelActSubMotDen,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelActSubMotDen filterRelActSubMotDen, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelActSubMotDen>>
	 */
	List<TableRowDto<RelActSubMotDen>> findAllChild(RelActSubMotDen filterRelActSubMotDen,
			JQGridRequestDto jqGridRequestDto);

}
