package com.ejie.ab60.dao.actuacionesSubvencionables;

import com.ejie.ab60.model.actuacionesSubvencionables.RelActSubMotMin;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelActSubMotMinDao  
 * 
 *  
 */

public interface RelActSubMotMinDao {

	/**
	 * Inserts a single row in the RelActSubMotMin table.
	 *
	 * @param relactsubmotmin
	 *            RelActSubMotMin
	 * @return RelActSubMotMin
	 */
	RelActSubMotMin add(RelActSubMotMin relactsubmotmin);

	/**
	 * Updates a single row in the RelActSubMotMin table.
	 *
	 * @param relactsubmotmin
	 *            RelActSubMotMin
	 * @return RelActSubMotMin
	 */
	RelActSubMotMin update(RelActSubMotMin relactsubmotmin);

	/**
	 * Finds a single row in the RelActSubMotMin table.
	 *
	 * @param relactsubmotmin
	 *            RelActSubMotMin
	 * @return RelActSubMotMin
	 */
	RelActSubMotMin find(RelActSubMotMin relactsubmotmin);

	/**
	 * Removes a single row in the RelActSubMotMin table.
	 *
	 * @param relactsubmotmin
	 *            RelActSubMotMin
	 */
	void remove(RelActSubMotMin relactsubmotmin, Integer origen);

	/**
	 * Saca los id de motivos de minoracion
	 *
	 * @param idRelActSubMotMin
	 *            Integer
	 * @param origenMotivosMinoracion
	 * 
	 * @return List<RelActSubMotMin>
	 */

	List<RelActSubMotMin> findIdsMotivosMinoraciones(Integer idRelActSubMotMin, Integer origenMotivosMinoracion);

	/**
	 * Finds a List of rows in the RelActSubMotMin table.
	 *
	 * @param relactsubmotmin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelActSubMotMin> findAll(RelActSubMotMin relactsubmotmin, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelActSubMotMin table using like.
	 *
	 * @param relactsubmotmin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelActSubMotMin> findAllLike(RelActSubMotMin relactsubmotmin, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelActSubMotMin table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelActSubMotMin filterRelActSubMotMin, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelActSubMotMin table using like.
	 *
	 * @param relactsubmotmin
	 *            RelActSubMotMin
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelActSubMotMin relactsubmotmin, Boolean startsWith);

	/**
	 * Counts rows in the RelActSubMotMin table.
	 *
	 * @param relactsubmotmin
	 *            RelActSubMotMin
	 * @return Long
	 */
	Long findAllCount(RelActSubMotMin relactsubmotmin);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActSubMotMin>>
	 */
	List<TableRowDto<RelActSubMotMin>> reorderSelection(RelActSubMotMin filterRelActSubMotMin,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param searchRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActSubMotMin>>
	 */
	List<TableRowDto<RelActSubMotMin>> search(RelActSubMotMin filterRelActSubMotMin,
			RelActSubMotMin searchRelActSubMotMin, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelActSubMotMin table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelActSubMotMin>>
	 */
	List<JerarquiaDto<RelActSubMotMin>> findAllLikeJerarquia(RelActSubMotMin filterRelActSubMotMin,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelActSubMotMin filterRelActSubMotMin, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelActSubMotMin>>
	 */
	List<TableRowDto<RelActSubMotMin>> findAllChild(RelActSubMotMin filterRelActSubMotMin,
			JQGridRequestDto jqGridRequestDto);

}
