package com.ejie.ab60.dao.actuacionesSubvencionables;

import com.ejie.ab60.model.actuacionesSubvencionables.RelActSubSubact;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelActSubSubactDao  
 * 
 *  
 */

public interface RelActSubSubactDao {

	/**
	 * Inserts a single row in the RelActSubSubact table.
	 *
	 * @param relactsubsubact
	 *            RelActSubSubact
	 * @return RelActSubSubact
	 */
	RelActSubSubact add(RelActSubSubact relactsubsubact);

	/**
	 * Updates a single row in the RelActSubSubact table.
	 *
	 * @param relactsubsubact
	 *            RelActSubSubact
	 * @return RelActSubSubact
	 */
	RelActSubSubact update(RelActSubSubact relactsubsubact);

	/**
	 * Finds a single row in the RelActSubSubact table.
	 *
	 * @param relactsubsubact
	 *            RelActSubSubact
	 * @return RelActSubSubact
	 */
	RelActSubSubact find(RelActSubSubact relactsubsubact);

	/**
	 * Removes a single row in the RelActSubSubact table.
	 *
	 * @param relactsubsubact
	 *            RelActSubSubact
	 */
	void remove(RelActSubSubact relactsubsubact);

	/**
	 * Encuentra los id de las actuaciones subvencionable dado un id
	 *
	 * @param Integer
	 *            idRelacion
	 * @return relactsubsubactList
	 */
	List<RelActSubSubact> findIdActSubSubact(Integer idRelacion);

	/**
	 * Finds a List of rows in the RelActSubSubact table.
	 *
	 * @param relactsubsubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelActSubSubact> findAll(RelActSubSubact relactsubsubact, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelActSubSubact table using like.
	 *
	 * @param relactsubsubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelActSubSubact> findAllLike(RelActSubSubact relactsubsubact, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelActSubSubact table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelActSubSubact filterRelActSubSubact, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelActSubSubact table using like.
	 *
	 * @param relactsubsubact
	 *            RelActSubSubact
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelActSubSubact relactsubsubact, Boolean startsWith);

	/**
	 * Counts rows in the RelActSubSubact table.
	 *
	 * @param relactsubsubact
	 *            RelActSubSubact
	 * @return Long
	 */
	Long findAllCount(RelActSubSubact relactsubsubact);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActSubSubact>>
	 */
	List<TableRowDto<RelActSubSubact>> reorderSelection(RelActSubSubact filterRelActSubSubact,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param searchRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActSubSubact>>
	 */
	List<TableRowDto<RelActSubSubact>> search(RelActSubSubact filterRelActSubSubact,
			RelActSubSubact searchRelActSubSubact, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelActSubSubact table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelActSubSubact>>
	 */
	List<JerarquiaDto<RelActSubSubact>> findAllLikeJerarquia(RelActSubSubact filterRelActSubSubact,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelActSubSubact filterRelActSubSubact, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelActSubSubact>>
	 */
	List<TableRowDto<RelActSubSubact>> findAllChild(RelActSubSubact filterRelActSubSubact,
			JQGridRequestDto jqGridRequestDto);

}
