package com.ejie.ab60.dao.convocatorias;

import com.ejie.ab60.model.convocatorias.AplicacionesPresupuestarias;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * AplicacionesPresupuestariasDao  
 * 
 *  
 */

public interface AplicacionesPresupuestariasDao {

	/**
	 * Inserts a single row in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionespresupuestarias
	 *            AplicacionesPresupuestarias
	 * @return AplicacionesPresupuestarias
	 */
	AplicacionesPresupuestarias add(AplicacionesPresupuestarias aplicacionespresupuestarias);

	/**
	 * Updates a single row in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionespresupuestarias
	 *            AplicacionesPresupuestarias
	 * @return AplicacionesPresupuestarias
	 */
	AplicacionesPresupuestarias update(AplicacionesPresupuestarias aplicacionespresupuestarias) throws Exception;

	AplicacionesPresupuestarias updateImporteDisponible(AplicacionesPresupuestarias aplicacionespresupuestarias);

	/**
	 * Finds a single row in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionespresupuestarias
	 *            AplicacionesPresupuestarias
	 * @return AplicacionesPresupuestarias
	 */
	AplicacionesPresupuestarias find(AplicacionesPresupuestarias aplicacionespresupuestarias);

	/**
	 * Removes a single row in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionespresupuestarias
	 *            AplicacionesPresupuestarias
	 */
	void remove(AplicacionesPresupuestarias aplicacionespresupuestarias);

	/**
	 * Finds a List of rows in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionespresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<AplicacionesPresupuestarias> findAll(AplicacionesPresupuestarias aplicacionespresupuestarias,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the AplicacionesPresupuestarias table using like.
	 *
	 * @param aplicacionespresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<AplicacionesPresupuestarias> findAllLike(AplicacionesPresupuestarias aplicacionespresupuestarias,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(AplicacionesPresupuestarias filterAplicacionesPresupuestarias,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the AplicacionesPresupuestarias table using like.
	 *
	 * @param aplicacionespresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(AplicacionesPresupuestarias aplicacionespresupuestarias, Boolean startsWith);

	/**
	 * Counts rows in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionespresupuestarias
	 *            AplicacionesPresupuestarias
	 * @return Long
	 */
	Long findAllCount(AplicacionesPresupuestarias aplicacionespresupuestarias);

	/**
	 * Reorder selection.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AplicacionesPresupuestarias>>
	 */
	List<TableRowDto<AplicacionesPresupuestarias>> reorderSelection(
			AplicacionesPresupuestarias filterAplicacionesPresupuestarias, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param searchAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AplicacionesPresupuestarias>>
	 */
	List<TableRowDto<AplicacionesPresupuestarias>> search(AplicacionesPresupuestarias filterAplicacionesPresupuestarias,
			AplicacionesPresupuestarias searchAplicacionesPresupuestarias, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<AplicacionesPresupuestarias>>
	 */
	List<JerarquiaDto<AplicacionesPresupuestarias>> findAllLikeJerarquia(
			AplicacionesPresupuestarias filterAplicacionesPresupuestarias, JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(AplicacionesPresupuestarias filterAplicacionesPresupuestarias,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<AplicacionesPresupuestarias>>
	 */
	List<TableRowDto<AplicacionesPresupuestarias>> findAllChild(
			AplicacionesPresupuestarias filterAplicacionesPresupuestarias, JQGridRequestDto jqGridRequestDto);

}
