package com.ejie.ab60.dao.convocatorias;

import java.util.List;

import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ConvocatoriasDao  
 * 
 *  
 */

public interface ConvocatoriasDao {

	/**
	 * Inserts a single row in the Convocatorias table.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @return Convocatorias
	 */
	Convocatorias add(Convocatorias convocatorias);

	/**
	 * Updates a single row in the Convocatorias table.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @return Convocatorias
	 */
	Convocatorias update(Convocatorias convocatorias);

	/**
	 * Updates a single row in the Convocatorias table.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @return Convocatorias
	 */
	Convocatorias updateFaseActiva(Convocatorias convocatorias);

	/**
	 * Updates a single row in the Convocatorias table.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @return Convocatorias
	 */
	Convocatorias updateBEC(Convocatorias convocatorias);

	/**
	 * Finds a single row in the Convocatorias table.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @return Convocatorias
	 */
	Convocatorias find(Convocatorias convocatorias);

	/**
	 * Finds a single row in the Convocatorias table.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @return Convocatorias
	 */
	Convocatorias findFaseActiva(Convocatorias convocatorias);

	/**
	 * Finds a single row in the Convocatorias table.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @return Convocatorias
	 */
	Convocatorias findWithProcedimiento(Integer idProcedimiento);

	/**
	 * Encuentra el nombre del pl-sql de calculo de ayuda correspondiente a cada
	 * convocatoria
	 *
	 * @param Integer
	 *            idConvocatorias
	 * @return convocatorias
	 */
	Convocatorias findNombrePLSQL(Integer idConvocatorias);

	/**
	 * Encuentra el nombre del pl-sql de ANULAR REPARTO de ayuda correspondiente
	 * a cada convocatoria
	 *
	 * @param Integer
	 *            idConvocatorias
	 * @return convocatorias
	 */

	Convocatorias findNombrePLSQLAnularReparto(Integer idConvocatoria);

	/**
	 * Encuentra el nombre del pl-sql de REPARTO de ayuda correspondiente a cada
	 * convocatoria
	 *
	 * @param Integer
	 *            idConvocatorias
	 * @return convocatorias
	 */

	Convocatorias findNombrePLSQLReparto(Integer idConvocatoria);

	/**
	 * Updates Importe_Disponible en Convocatorias table.
	 *
	 * @param idConvocatorias
	 *            Integer
	 * @return Convocatorias
	 */
	Convocatorias updateImportes(Convocatorias convocatorias);

	/**
	 * Updates Importes en Convocatorias table.
	 *
	 * @param idConvocatorias
	 *            Integer
	 * @return Convocatorias
	 */
	Convocatorias updateImporteDisponible(Convocatorias convocatorias);

	/**
	 * Finds a single row in the Convocatorias table.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @return Convocatorias
	 */
	Convocatorias findProc(Convocatorias convocatorias);

	/**
	 * Convocatorias Combo
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @return Convocatorias
	 */
	Convocatorias tipoConvo(Convocatorias convocatorias);

	/**
	 * Removes a single row in the Convocatorias table.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 */
	void remove(Convocatorias convocatorias);

	/**
	 * Finds a List of rows in the Convocatorias table.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Convocatorias> findAll(Convocatorias convocatorias, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Convocatorias table using like.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Convocatorias> findAllLike(Convocatorias convocatorias, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the Convocatorias table.
	 *
	 * @param filterConvocatorias
	 *            Convocatorias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Convocatorias filterConvocatorias, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the Convocatorias table using like.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Convocatorias convocatorias, Boolean startsWith);

	/**
	 * Counts rows in the Convocatorias table.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @return Long
	 */
	Long findAllCount(Convocatorias convocatorias);

	/**
	 * Reorder selection.
	 *
	 * @param filterConvocatorias
	 *            Convocatorias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Convocatorias>>
	 */
	List<TableRowDto<Convocatorias>> reorderSelection(Convocatorias filterConvocatorias,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterConvocatorias
	 *            Convocatorias
	 * @param searchConvocatorias
	 *            Convocatorias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Convocatorias>>
	 */
	List<TableRowDto<Convocatorias>> search(Convocatorias filterConvocatorias, Convocatorias searchConvocatorias,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical Convocatorias table.
	 *
	 * @param filterConvocatorias
	 *            Convocatorias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<Convocatorias>>
	 */
	List<JerarquiaDto<Convocatorias>> findAllLikeJerarquia(Convocatorias filterConvocatorias,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterConvocatorias
	 *            Convocatorias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(Convocatorias filterConvocatorias, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterConvocatorias
	 *            Convocatorias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<Convocatorias>>
	 */
	List<TableRowDto<Convocatorias>> findAllChild(Convocatorias filterConvocatorias, JQGridRequestDto jqGridRequestDto);

	Convocatorias updateFechas(Convocatorias convocatorias);

	Convocatorias findByIdExpediente(Integer idExpediente);

}
