package com.ejie.ab60.dao.convocatorias;

import com.ejie.ab60.model.convocatorias.ReferenciasIntervencion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * ReferenciasIntervencionDao  
 * 
 *  
 */

public interface ReferenciasIntervencionDao {

	/**
	 * Inserts a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasintervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	ReferenciasIntervencion add(ReferenciasIntervencion referenciasintervencion);

	/**
	 * Updates a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasintervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	ReferenciasIntervencion update(ReferenciasIntervencion referenciasintervencion);

	/**
	 * Finds a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasintervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	ReferenciasIntervencion find(ReferenciasIntervencion referenciasintervencion);

	/**
	 * Finds a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasintervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	ReferenciasIntervencion findByAplicPresu(ReferenciasIntervencion referenciasintervencion);

	/**
	 * Removes a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasintervencion
	 *            ReferenciasIntervencion
	 */
	void remove(ReferenciasIntervencion referenciasintervencion);

	/**
	 * Removes a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasintervencion
	 *            ReferenciasIntervencion
	 */
	void removeByAplicacionPresu(ReferenciasIntervencion referenciasintervencion);

	/**
	 * Finds a List of rows in the ReferenciasIntervencion table.
	 *
	 * @param referenciasintervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<ReferenciasIntervencion> findAll(ReferenciasIntervencion referenciasintervencion,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ReferenciasIntervencion table using like.
	 *
	 * @param referenciasintervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<ReferenciasIntervencion> findAllLike(ReferenciasIntervencion referenciasintervencion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ReferenciasIntervencion filterReferenciasIntervencion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the ReferenciasIntervencion table using like.
	 *
	 * @param referenciasintervencion
	 *            ReferenciasIntervencion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(ReferenciasIntervencion referenciasintervencion, Boolean startsWith);

	/**
	 * Counts rows in the ReferenciasIntervencion table.
	 *
	 * @param referenciasintervencion
	 *            ReferenciasIntervencion
	 * @return Long
	 */
	Long findAllCount(ReferenciasIntervencion referenciasintervencion);

	/**
	 * Reorder selection.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ReferenciasIntervencion>>
	 */
	List<TableRowDto<ReferenciasIntervencion>> reorderSelection(ReferenciasIntervencion filterReferenciasIntervencion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param searchReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ReferenciasIntervencion>>
	 */
	List<TableRowDto<ReferenciasIntervencion>> search(ReferenciasIntervencion filterReferenciasIntervencion,
			ReferenciasIntervencion searchReferenciasIntervencion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<ReferenciasIntervencion>>
	 */
	List<JerarquiaDto<ReferenciasIntervencion>> findAllLikeJerarquia(
			ReferenciasIntervencion filterReferenciasIntervencion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(ReferenciasIntervencion filterReferenciasIntervencion,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<ReferenciasIntervencion>>
	 */
	List<TableRowDto<ReferenciasIntervencion>> findAllChild(ReferenciasIntervencion filterReferenciasIntervencion,
			JQGridRequestDto jqGridRequestDto);

}
