package com.ejie.ab60.dao.convocatorias;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.convocatorias.TiposAyuda;

/**
 * TiposAyudaDao  
 * 
 *  
 */

public interface TiposAyudaDao {

	/**
	 * Inserts a single row in the TiposAyuda table.
	 *
	 * @param tiposayuda
	 *            TiposAyuda
	 * @return TiposAyuda
	 */
	TiposAyuda add(TiposAyuda tiposayuda);

	/**
	 * Updates a single row in the TiposAyuda table.
	 *
	 * @param tiposayuda
	 *            TiposAyuda
	 * @return TiposAyuda
	 */
	TiposAyuda update(TiposAyuda tiposayuda);

	/**
	 * Finds a single row in the TiposAyuda table.
	 *
	 * @param tiposayuda
	 *            TiposAyuda
	 * @return TiposAyuda
	 */
	TiposAyuda find(TiposAyuda tiposayuda);

	/**
	 * Removes a single row in the TiposAyuda table.
	 *
	 * @param tiposayuda
	 *            TiposAyuda
	 */
	void remove(TiposAyuda tiposayuda);

	/**
	 * Finds a List of rows in the TiposAyuda table.
	 *
	 * @param tiposayuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<TiposAyuda> findAll(TiposAyuda tiposayuda, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposAyuda table using like.
	 *
	 * @param tiposayuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<TiposAyuda> findAllLike(TiposAyuda tiposayuda, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the TiposAyuda table.
	 *
	 * @param filterTiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposAyuda filterTiposAyuda, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the TiposAyuda table using like.
	 *
	 * @param tiposayuda
	 *            TiposAyuda
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(TiposAyuda tiposayuda, Boolean startsWith);

	/**
	 * Counts rows in the TiposAyuda table.
	 *
	 * @param tiposayuda
	 *            TiposAyuda
	 * @return Long
	 */
	Long findAllCount(TiposAyuda tiposayuda);

	/**
	 * Reorder selection.
	 *
	 * @param filterTiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposAyuda>>
	 */
	List<TableRowDto<TiposAyuda>> reorderSelection(TiposAyuda filterTiposAyuda, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterTiposAyuda
	 *            TiposAyuda
	 * @param searchTiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposAyuda>>
	 */
	List<TableRowDto<TiposAyuda>> search(TiposAyuda filterTiposAyuda, TiposAyuda searchTiposAyuda,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical TiposAyuda table.
	 *
	 * @param filterTiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<TiposAyuda>>
	 */
	List<JerarquiaDto<TiposAyuda>> findAllLikeJerarquia(TiposAyuda filterTiposAyuda, JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(TiposAyuda filterTiposAyuda, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<TiposAyuda>>
	 */
	List<TableRowDto<TiposAyuda>> findAllChild(TiposAyuda filterTiposAyuda, JQGridRequestDto jqGridRequestDto);

	TiposAyuda findPLSQL(TiposAyuda tiposAyuda);

}
