package com.ejie.ab60.dao.criteriosPuntuacion;

import java.util.List;

import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.model.criteriosPuntuacion.CriteriosPuntuacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * CriteriosPuntuacionDao  
 * 
 *  
 */

public interface CriteriosPuntuacionDao {

	/**
	 * Inserts a single row in the CriteriosPuntuacion table.
	 *
	 * @param criteriospuntuacion
	 *            CriteriosPuntuacion
	 * @return CriteriosPuntuacion
	 */
	CriteriosPuntuacion add(CriteriosPuntuacion criteriospuntuacion);

	/**
	 * Updates a single row in the CriteriosPuntuacion table.
	 *
	 * @param criteriospuntuacion
	 *            CriteriosPuntuacion
	 * @return CriteriosPuntuacion
	 */
	CriteriosPuntuacion update(CriteriosPuntuacion criteriospuntuacion);

	/**
	 * Finds a single row in the CriteriosPuntuacion table.
	 *
	 * @param criteriospuntuacion
	 *            CriteriosPuntuacion
	 * @return CriteriosPuntuacion
	 */
	CriteriosPuntuacion find(CriteriosPuntuacion criteriospuntuacion);

	/**
	 * Lista de texto de criterios de puntuacion CriteriosPuntuacion table.
	 *
	 * @param Integer
	 *            idConvocatoria
	 * @return List
	 */
	List<CriteriosPuntuacion> findTextoCriterio(Integer idConvocatoria);

	/**
	 * Lista de texto de criterios de puntuacion CriteriosPuntuacion table.
	 *
	 * @param Integer
	 *            idConvocatoria
	 * @return List
	 */
	List<CriteriosPuntuacion> findTextoCriterioBEC(Integer idConvocatoria);

	/**
	 * Removes a single row in the CriteriosPuntuacion table.
	 *
	 * @param criteriospuntuacion
	 *            CriteriosPuntuacion
	 */
	void remove(CriteriosPuntuacion criteriospuntuacion);

	/**
	 * Finds a List of rows in the CriteriosPuntuacion table.
	 *
	 * @param criteriospuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<CriteriosPuntuacion> findAll(CriteriosPuntuacion criteriospuntuacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the CriteriosPuntuacion table using like.
	 *
	 * @param criteriospuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<CriteriosPuntuacion> findAllLike(CriteriosPuntuacion criteriospuntuacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the CriteriosPuntuacion table.
	 *
	 * @param filterCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(CriteriosPuntuacion filterCriteriosPuntuacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the CriteriosPuntuacion table using like.
	 *
	 * @param criteriospuntuacion
	 *            CriteriosPuntuacion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(CriteriosPuntuacion criteriospuntuacion, Boolean startsWith);

	/**
	 * Counts rows in the CriteriosPuntuacion table.
	 *
	 * @param criteriospuntuacion
	 *            CriteriosPuntuacion
	 * @return Long
	 */
	Long findAllCount(CriteriosPuntuacion criteriospuntuacion);

	/**
	 * Reorder selection.
	 *
	 * @param filterCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<CriteriosPuntuacion>>
	 */
	List<TableRowDto<CriteriosPuntuacion>> reorderSelection(CriteriosPuntuacion filterCriteriosPuntuacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param searchCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<CriteriosPuntuacion>>
	 */
	List<TableRowDto<CriteriosPuntuacion>> search(CriteriosPuntuacion filterCriteriosPuntuacion,
			CriteriosPuntuacion searchCriteriosPuntuacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical CriteriosPuntuacion table.
	 *
	 * @param filterCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<CriteriosPuntuacion>>
	 */
	List<JerarquiaDto<CriteriosPuntuacion>> findAllLikeJerarquia(CriteriosPuntuacion filterCriteriosPuntuacion,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(CriteriosPuntuacion filterCriteriosPuntuacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<CriteriosPuntuacion>>
	 */
	List<TableRowDto<CriteriosPuntuacion>> findAllChild(CriteriosPuntuacion filterCriteriosPuntuacion,
			JQGridRequestDto jqGridRequestDto);

}
