package com.ejie.ab60.dao.criteriosPuntuacion;

import java.util.List;

import com.ejie.ab60.model.criteriosPuntuacion.CriteriosPuntuacion;
import com.ejie.ab60.model.criteriosPuntuacion.RelExpCriPun;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpCriPunDao  
 * 
 *  
 */

public interface RelExpCriPunDao {

	/**
	 * Inserts a single row in the RelExpCriPun table.
	 *
	 * @param relexpcripun
	 *            RelExpCriPun
	 * @return RelExpCriPun
	 */
	RelExpCriPun add(RelExpCriPun relexpcripun);

	/**
	 * Updates a single row in the RelExpCriPun table.
	 *
	 * @param relexpcripun
	 *            RelExpCriPun
	 * @return RelExpCriPun
	 */
	RelExpCriPun update(RelExpCriPun relexpcripun);

	/**
	 * Updates a single row in the RelExpCriPun table.
	 *
	 * @param relexpcripun
	 *            RelExpCriPun
	 * @return RelExpCriPun
	 */
	RelExpCriPun updatePuntuacionAdmitida(RelExpCriPun relexpcripun);

	/**
	 * Finds a single row in the RelExpCriPun table.
	 *
	 * @param relexpcripun
	 *            RelExpCriPun
	 * @return RelExpCriPun
	 */
	RelExpCriPun find(RelExpCriPun relexpcripun);

	/**
	 * Finds a single row in the RelExpCriPun table.
	 *
	 * @param relexpcripun
	 *            RelExpCriPun
	 * @return RelExpCriPun
	 */
	RelExpCriPun findPuntTeorica(RelExpCriPun relexpcripun);

	/**
	 * Removes a single row in the RelExpCriPun table.
	 *
	 * @param relexpcripun
	 *            RelExpCriPun
	 */
	void remove(RelExpCriPun relexpcripun);

	/**
	 * Removes a single row in the RelExpCriPun table.
	 *
	 * @param Integer
	 *            IdExpediente
	 */
	void removeCriteriosPorExpediente(Integer IdExpediente);

	/**
	 * Finds a List of rows in the RelExpCriPun table.
	 *
	 * @param relexpcripun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelExpCriPun> findAll(RelExpCriPun relexpcripun, JQGridRequestDto jqGridRequestDto);

	/**
	 * Lista de id de criterios de puntuacion de la RelExpCriPun table.
	 *
	 * @param Integer
	 *            idExpediente
	 * @return List
	 */
	List<RelExpCriPun> findIdsCriterio(Integer idExpediente);

	/**
	 * Lista de criterios de puntuacion de la RelExpCriPun table.
	 * 
	 * @param jqGridRequestDto
	 *
	 * @param Integer
	 *            idExpediente
	 * @param Integer
	 *            idConvocatoria
	 * @return List
	 */
	List<RelExpCriPun> findDescCriterio(Integer idExpediente, Integer idConvocatoria);

	/**
	 * Finds rows in the RelExpCriPun table using like.
	 *
	 * @param relexpcripun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelExpCriPun> findAllLike(RelExpCriPun relexpcripun, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelExpCriPun table.
	 *
	 * @param filterRelExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpCriPun filterRelExpCriPun, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelExpCriPun table using like.
	 *
	 * @param relexpcripun
	 *            RelExpCriPun
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelExpCriPun relexpcripun, Boolean startsWith);

	/**
	 * Counts rows in the RelExpCriPun table.
	 *
	 * @param relexpcripun
	 *            RelExpCriPun
	 * @return Long
	 */
	Long findAllCount(RelExpCriPun relexpcripun);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpCriPun>>
	 */
	List<TableRowDto<RelExpCriPun>> reorderSelection(RelExpCriPun filterRelExpCriPun, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelExpCriPun
	 *            RelExpCriPun
	 * @param searchRelExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpCriPun>>
	 */
	List<TableRowDto<RelExpCriPun>> search(RelExpCriPun filterRelExpCriPun, RelExpCriPun searchRelExpCriPun,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelExpCriPun table.
	 *
	 * @param filterRelExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelExpCriPun>>
	 */
	List<JerarquiaDto<RelExpCriPun>> findAllLikeJerarquia(RelExpCriPun filterRelExpCriPun,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelExpCriPun filterRelExpCriPun, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelExpCriPun>>
	 */
	List<TableRowDto<RelExpCriPun>> findAllChild(RelExpCriPun filterRelExpCriPun, JQGridRequestDto jqGridRequestDto);

}
