package com.ejie.ab60.dao.criteriosPuntuacion;

import java.util.List;

import com.ejie.ab60.model.criteriosPuntuacion.TiposCriterio;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * TiposCriterioDao  
 * 
 *  
 */

public interface TiposCriterioDao {

	/**
	 * Inserts a single row in the TiposCriterio table.
	 *
	 * @param tiposcriterio
	 *            TiposCriterio
	 * @return TiposCriterio
	 */
	TiposCriterio add(TiposCriterio tiposcriterio);

	/**
	 * Updates a single row in the TiposCriterio table.
	 *
	 * @param tiposcriterio
	 *            TiposCriterio
	 * @return TiposCriterio
	 */
	TiposCriterio update(TiposCriterio tiposcriterio);

	/**
	 * Finds a single row in the TiposCriterio table.
	 *
	 * @param tiposcriterio
	 *            TiposCriterio
	 * @return TiposCriterio
	 */
	TiposCriterio find(TiposCriterio tiposcriterio);

	/**
	 * Removes a single row in the TiposCriterio table.
	 *
	 * @param tiposcriterio
	 *            TiposCriterio
	 */
	void remove(TiposCriterio tiposcriterio);

	/**
	 * Finds a List of rows in the TiposCriterio table.
	 *
	 * @param tiposcriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<TiposCriterio> findAll(TiposCriterio tiposcriterio, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposCriterio table using like.
	 *
	 * @param tiposcriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<TiposCriterio> findAllLike(TiposCriterio tiposcriterio, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the TiposCriterio table.
	 *
	 * @param filterTiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposCriterio filterTiposCriterio, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the TiposCriterio table using like.
	 *
	 * @param tiposcriterio
	 *            TiposCriterio
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(TiposCriterio tiposcriterio, Boolean startsWith);

	/**
	 * Counts rows in the TiposCriterio table.
	 *
	 * @param tiposcriterio
	 *            TiposCriterio
	 * @return Long
	 */
	Long findAllCount(TiposCriterio tiposcriterio);

	/**
	 * Reorder selection.
	 *
	 * @param filterTiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposCriterio>>
	 */
	List<TableRowDto<TiposCriterio>> reorderSelection(TiposCriterio filterTiposCriterio,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterTiposCriterio
	 *            TiposCriterio
	 * @param searchTiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposCriterio>>
	 */
	List<TableRowDto<TiposCriterio>> search(TiposCriterio filterTiposCriterio, TiposCriterio searchTiposCriterio,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical TiposCriterio table.
	 *
	 * @param filterTiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<TiposCriterio>>
	 */
	List<JerarquiaDto<TiposCriterio>> findAllLikeJerarquia(TiposCriterio filterTiposCriterio,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(TiposCriterio filterTiposCriterio, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<TiposCriterio>>
	 */
	List<TableRowDto<TiposCriterio>> findAllChild(TiposCriterio filterTiposCriterio, JQGridRequestDto jqGridRequestDto);

}
