package com.ejie.ab60.dao.estudioTecnico;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.estudioTecnico.DatosTerOmic;

/**
 * DatosTerOmicDao  
 * 
 *  
 */

public interface DatosTerOmicDao {

	/**
	 * Inserts a single row in the DatosTerOmic table.
	 *
	 * @param datosteromic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	DatosTerOmic add(DatosTerOmic datosteromic);

	/**
	 * Updates a single row in the DatosTerOmic table.
	 *
	 * @param datosteromic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	DatosTerOmic update(DatosTerOmic datosteromic);

	/**
	 * Updates a single row in the DatosTerOmic table.
	 *
	 * @param datosteromic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	DatosTerOmic updateByExpediente(DatosTerOmic datosteromic);

	/**
	 * Finds a single row in the DatosTerOmic table.
	 *
	 * @param datosteromic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	DatosTerOmic find(DatosTerOmic datosteromic);

	/**
	 * Finds a single row in the DatosTerOmic table.
	 *
	 * @param datosteromic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	DatosTerOmic findByExpediente(DatosTerOmic datosteromic);

	/**
	 * Removes a single row in the DatosTerOmic table.
	 *
	 * @param datosteromic
	 *            DatosTerOmic
	 */
	void remove(DatosTerOmic datosteromic);

	/**
	 * Finds a List of rows in the DatosTerOmic table.
	 *
	 * @param datosteromic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<DatosTerOmic> findAll(DatosTerOmic datosteromic, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the DatosTerOmic table using like.
	 *
	 * @param datosteromic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<DatosTerOmic> findAllLike(DatosTerOmic datosteromic, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the DatosTerOmic table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(DatosTerOmic filterDatosTerOmic, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the DatosTerOmic table using like.
	 *
	 * @param datosteromic
	 *            DatosTerOmic
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(DatosTerOmic datosteromic, Boolean startsWith);

	/**
	 * Counts rows in the DatosTerOmic table.
	 *
	 * @param datosteromic
	 *            DatosTerOmic
	 * @return Long
	 */
	Long findAllCount(DatosTerOmic datosteromic);

	/**
	 * Reorder selection.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DatosTerOmic>>
	 */
	List<TableRowDto<DatosTerOmic>> reorderSelection(DatosTerOmic filterDatosTerOmic, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param searchDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DatosTerOmic>>
	 */
	List<TableRowDto<DatosTerOmic>> search(DatosTerOmic filterDatosTerOmic, DatosTerOmic searchDatosTerOmic,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical DatosTerOmic table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<DatosTerOmic>>
	 */
	List<JerarquiaDto<DatosTerOmic>> findAllLikeJerarquia(DatosTerOmic filterDatosTerOmic,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(DatosTerOmic filterDatosTerOmic, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<DatosTerOmic>>
	 */
	List<TableRowDto<DatosTerOmic>> findAllChild(DatosTerOmic filterDatosTerOmic, JQGridRequestDto jqGridRequestDto);

}
