package com.ejie.ab60.dao.estudioTecnico;

import com.ejie.ab60.model.estudioTecnico.ErroresCalculo;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * ErroresCalculoDao  
 * 
 *  
 */

public interface ErroresCalculoDao {

	/**
	 * Inserts a single row in the ErroresCalculo table.
	 *
	 * @param errorescalculo
	 *            ErroresCalculo
	 * @return ErroresCalculo
	 */
	ErroresCalculo add(ErroresCalculo errorescalculo);

	/**
	 * Updates a single row in the ErroresCalculo table.
	 *
	 * @param errorescalculo
	 *            ErroresCalculo
	 * @return ErroresCalculo
	 */
	ErroresCalculo update(ErroresCalculo errorescalculo);

	/**
	 * Finds a single row in the ErroresCalculo table.
	 *
	 * @param errorescalculo
	 *            ErroresCalculo
	 * @return ErroresCalculo
	 */
	ErroresCalculo find(ErroresCalculo errorescalculo);

	/**
	 * Removes a single row in the ErroresCalculo table.
	 *
	 * @param errorescalculo
	 *            ErroresCalculo
	 */
	void remove(ErroresCalculo errorescalculo);

	/**
	 * Finds a List of rows in the ErroresCalculo table.
	 *
	 * @param errorescalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<ErroresCalculo> findAll(ErroresCalculo errorescalculo, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ErroresCalculo table using like.
	 *
	 * @param errorescalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<ErroresCalculo> findAllLike(ErroresCalculo errorescalculo, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the ErroresCalculo table.
	 *
	 * @param filterErroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ErroresCalculo filterErroresCalculo, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the ErroresCalculo table using like.
	 *
	 * @param errorescalculo
	 *            ErroresCalculo
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(ErroresCalculo errorescalculo, Boolean startsWith);

	/**
	 * Counts rows in the ErroresCalculo table.
	 *
	 * @param errorescalculo
	 *            ErroresCalculo
	 * @return Long
	 */
	Long findAllCount(ErroresCalculo errorescalculo);

	/**
	 * Reorder selection.
	 *
	 * @param filterErroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ErroresCalculo>>
	 */
	List<TableRowDto<ErroresCalculo>> reorderSelection(ErroresCalculo filterErroresCalculo,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterErroresCalculo
	 *            ErroresCalculo
	 * @param searchErroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ErroresCalculo>>
	 */
	List<TableRowDto<ErroresCalculo>> search(ErroresCalculo filterErroresCalculo, ErroresCalculo searchErroresCalculo,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical ErroresCalculo table.
	 *
	 * @param filterErroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<ErroresCalculo>>
	 */
	List<JerarquiaDto<ErroresCalculo>> findAllLikeJerarquia(ErroresCalculo filterErroresCalculo,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterErroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(ErroresCalculo filterErroresCalculo, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterErroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<ErroresCalculo>>
	 */
	List<TableRowDto<ErroresCalculo>> findAllChild(ErroresCalculo filterErroresCalculo,
			JQGridRequestDto jqGridRequestDto);

}
