package com.ejie.ab60.dao.estudioTecnico;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.estudioTecnico.Horarios;

/**
 * HorariosDao  
 * 
 *  
 */

public interface HorariosDao {

	/**
	 * Inserts a single row in the Horarios table.
	 *
	 * @param horarios
	 *            Horarios
	 * @return Horarios
	 */
	Horarios add(Horarios horarios);

	/**
	 * Updates a single row in the Horarios table.
	 *
	 * @param horarios
	 *            Horarios
	 * @return Horarios
	 */
	Horarios update(Horarios horarios);

	/**
	 * Finds a single row in the Horarios table.
	 *
	 * @param horarios
	 *            Horarios
	 * @return Horarios
	 */
	Horarios find(Horarios horarios);

	/**
	 * Removes a single row in the Horarios table.
	 *
	 * @param horarios
	 *            Horarios
	 */
	void remove(Horarios horarios);

	/**
	 * Finds a List of rows in the Horarios table.
	 *
	 * @param horarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Horarios> findAll(Horarios horarios, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a List of rows in the Horarios table.
	 *
	 * @param horarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Horarios> findByPoblacion(Integer idPoblacion, Integer idConvocatoria);

	/**
	 * Finds rows in the Horarios table using like.
	 *
	 * @param horarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Horarios> findAllLike(Horarios horarios, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the Horarios table.
	 *
	 * @param filterHorarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Horarios filterHorarios, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the Horarios table using like.
	 *
	 * @param horarios
	 *            Horarios
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Horarios horarios, Boolean startsWith);

	/**
	 * Counts rows in the Horarios table.
	 *
	 * @param horarios
	 *            Horarios
	 * @return Long
	 */
	Long findAllCount(Horarios horarios);

	/**
	 * Reorder selection.
	 *
	 * @param filterHorarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Horarios>>
	 */
	List<TableRowDto<Horarios>> reorderSelection(Horarios filterHorarios, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterHorarios
	 *            Horarios
	 * @param searchHorarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Horarios>>
	 */
	List<TableRowDto<Horarios>> search(Horarios filterHorarios, Horarios searchHorarios,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical Horarios table.
	 *
	 * @param filterHorarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<Horarios>>
	 */
	List<JerarquiaDto<Horarios>> findAllLikeJerarquia(Horarios filterHorarios, JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterHorarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(Horarios filterHorarios, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterHorarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<Horarios>>
	 */
	List<TableRowDto<Horarios>> findAllChild(Horarios filterHorarios, JQGridRequestDto jqGridRequestDto);

}
