package com.ejie.ab60.dao.estudioTecnico;

import java.util.List;

import com.ejie.ab60.model.estudioTecnico.MotivosDenegacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * MotivosDenegacionDao  
 * 
 *  
 */

public interface MotivosDenegacionDao {

	/**
	 * Inserts a single row in the MotivosDenegacion table.
	 *
	 * @param motivosdenegacion
	 *            MotivosDenegacion
	 * @return MotivosDenegacion
	 */
	MotivosDenegacion add(MotivosDenegacion motivosdenegacion);

	/**
	 * Updates a single row in the MotivosDenegacion table.
	 *
	 * @param motivosdenegacion
	 *            MotivosDenegacion
	 * @return MotivosDenegacion
	 */
	MotivosDenegacion update(MotivosDenegacion motivosdenegacion);

	/**
	 * Finds a single row in the MotivosDenegacion table.
	 *
	 * @param motivosdenegacion
	 *            MotivosDenegacion
	 * @return MotivosDenegacion
	 */
	MotivosDenegacion find(MotivosDenegacion motivosdenegacion);

	/**
	 * Removes a single row in the MotivosDenegacion table.
	 *
	 * @param motivosdenegacion
	 *            MotivosDenegacion
	 * 
	 */
	void remove(MotivosDenegacion motivosdenegacion);

	/**
	 * Finds a List of rows in the MotivosDenegacion table.
	 *
	 * @param motivosdenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<MotivosDenegacion> findAll(MotivosDenegacion motivosdenegacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the MotivosDenegacion table using like.
	 *
	 * @param motivosdenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<MotivosDenegacion> findAllLike(MotivosDenegacion motivosdenegacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finds a list of rows in the MotivosDenegacion table.
	 * 
	 * @param idConvocatoria
	 *            Integer
	 * @param origen
	 *            Integer
	 * @param idRelExpActSub
	 *            Integer
	 * 
	 * @return List<MotivosDenegacion>
	 */
	List<MotivosDenegacion> findDenegacionActSubvencionable(Integer idConvocatoria, Integer origen,
			Integer idRelExpActSub);

	/**
	 * Finds a list of rows in the MotivosDenegacion table.
	 * 
	 * @param idConvocatoria
	 *            Integer
	 * @param origen
	 *            Integer
	 * @param idFactura
	 *            Integer
	 * 
	 * @return List<MotivosDenegacion>
	 */
	List<MotivosDenegacion> findDenegacionFacturas(Integer idConvocatoria, Integer origen, Integer idFactura);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the MotivosDenegacion table.
	 *
	 * @param filterMotivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(MotivosDenegacion filterMotivosDenegacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the MotivosDenegacion table using like.
	 *
	 * @param motivosdenegacion
	 *            MotivosDenegacion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(MotivosDenegacion motivosdenegacion, Boolean startsWith);

	/**
	 * Counts rows in the MotivosDenegacion table.
	 *
	 * @param motivosdenegacion
	 *            MotivosDenegacion
	 * @return Long
	 */
	Long findAllCount(MotivosDenegacion motivosdenegacion);

	/**
	 * Reorder selection.
	 *
	 * @param filterMotivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosDenegacion>>
	 */
	List<TableRowDto<MotivosDenegacion>> reorderSelection(MotivosDenegacion filterMotivosDenegacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterMotivosDenegacion
	 *            MotivosDenegacion
	 * @param searchMotivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosDenegacion>>
	 */
	List<TableRowDto<MotivosDenegacion>> search(MotivosDenegacion filterMotivosDenegacion,
			MotivosDenegacion searchMotivosDenegacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical MotivosDenegacion table.
	 *
	 * @param filterMotivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<MotivosDenegacion>>
	 */
	List<JerarquiaDto<MotivosDenegacion>> findAllLikeJerarquia(MotivosDenegacion filterMotivosDenegacion,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterMotivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(MotivosDenegacion filterMotivosDenegacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterMotivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<MotivosDenegacion>>
	 */
	List<TableRowDto<MotivosDenegacion>> findAllChild(MotivosDenegacion filterMotivosDenegacion,
			JQGridRequestDto jqGridRequestDto);

}
