package com.ejie.ab60.dao.estudioTecnico;

import java.util.List;

import com.ejie.ab60.model.estudioTecnico.MotivosDesestimacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * MotivosDesestimacionDao  
 * 
 *  
 */

public interface MotivosDesestimacionDao {

	/**
	 * Inserts a single row in the MotivosDesestimacion table.
	 *
	 * @param motivosdesestimacion
	 *            MotivosDesestimacion
	 * @return MotivosDesestimacion
	 */
	MotivosDesestimacion add(MotivosDesestimacion motivosdesestimacion);

	/**
	 * Updates a single row in the MotivosDesestimacion table.
	 *
	 * @param motivosdesestimacion
	 *            MotivosDesestimacion
	 * @return MotivosDesestimacion
	 */
	MotivosDesestimacion update(MotivosDesestimacion motivosdesestimacion);

	/**
	 * Finds a single row in the MotivosDesestimacion table.
	 *
	 * @param motivosdesestimacion
	 *            MotivosDesestimacion
	 * @return MotivosDesestimacion
	 */
	MotivosDesestimacion find(MotivosDesestimacion motivosdesestimacion);

	/**
	 * Removes a single row in the MotivosDesestimacion table.
	 *
	 * @param motivosdesestimacion
	 *            MotivosDesestimacion
	 */
	void remove(MotivosDesestimacion motivosdesestimacion);

	/**
	 * Finds a List of rows in the MotivosDesestimacion table.
	 *
	 * @param motivosdesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<MotivosDesestimacion> findAll(MotivosDesestimacion motivosdesestimacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the MotivosDesestimacion table using like.
	 *
	 * @param motivosdesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<MotivosDesestimacion> findAllLike(MotivosDesestimacion motivosdesestimacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finds a list of rows in the Motivos table.
	 *
	 * 
	 * @return List<MotivosDesestimacion>
	 */
	List<MotivosDesestimacion> findMotivo();

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(MotivosDesestimacion filterMotivosDesestimacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the MotivosDesestimacion table using like.
	 *
	 * @param motivosdesestimacion
	 *            MotivosDesestimacion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(MotivosDesestimacion motivosdesestimacion, Boolean startsWith);

	/**
	 * Counts rows in the MotivosDesestimacion table.
	 *
	 * @param motivosdesestimacion
	 *            MotivosDesestimacion
	 * @return Long
	 */
	Long findAllCount(MotivosDesestimacion motivosdesestimacion);

	/**
	 * Reorder selection.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosDesestimacion>>
	 */
	List<TableRowDto<MotivosDesestimacion>> reorderSelection(MotivosDesestimacion filterMotivosDesestimacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param searchMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosDesestimacion>>
	 */
	List<TableRowDto<MotivosDesestimacion>> search(MotivosDesestimacion filterMotivosDesestimacion,
			MotivosDesestimacion searchMotivosDesestimacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<MotivosDesestimacion>>
	 */
	List<JerarquiaDto<MotivosDesestimacion>> findAllLikeJerarquia(MotivosDesestimacion filterMotivosDesestimacion,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(MotivosDesestimacion filterMotivosDesestimacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<MotivosDesestimacion>>
	 */
	List<TableRowDto<MotivosDesestimacion>> findAllChild(MotivosDesestimacion filterMotivosDesestimacion,
			JQGridRequestDto jqGridRequestDto);

}
