package com.ejie.ab60.dao.estudioTecnico;

import com.ejie.ab60.model.estudioTecnico.MotivosMinoracion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import org.springframework.transaction.annotation.Transactional;

/**
 * MotivosMinoracionDao  
 * 
 *  
 */

public interface MotivosMinoracionDao {

	/**
	 * Inserts a single row in the MotivosMinoracion table.
	 *
	 * @param motivosminoracion
	 *            MotivosMinoracion
	 * @return MotivosMinoracion
	 */
	MotivosMinoracion add(MotivosMinoracion motivosminoracion);

	/**
	 * Updates a single row in the MotivosMinoracion table.
	 *
	 * @param motivosminoracion
	 *            MotivosMinoracion
	 * @return MotivosMinoracion
	 */
	MotivosMinoracion update(MotivosMinoracion motivosminoracion);

	/**
	 * Finds a single row in the MotivosMinoracion table.
	 *
	 * @param motivosminoracion
	 *            MotivosMinoracion
	 * @return MotivosMinoracion
	 */
	MotivosMinoracion find(MotivosMinoracion motivosminoracion);

	/**
	 * Removes a single row in the MotivosMinoracion table.
	 *
	 * @param motivosminoracion
	 *            MotivosMinoracion
	 */
	void remove(MotivosMinoracion motivosminoracion);

	/**
	 * Finds a List of rows in the MotivosMinoracion table.
	 *
	 * @param motivosminoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<MotivosMinoracion> findAll(MotivosMinoracion motivosminoracion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the MotivosMinoracion table using like.
	 *
	 * @param motivosminoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<MotivosMinoracion> findAllLike(MotivosMinoracion motivosminoracion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finds a list of rows in the Motivos de minoracion table.
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @param origen
	 *            Integer
	 * @param idRelExpActSub
	 *            Integer
	 * 
	 * @return List<MotivosMinoracion>
	 */
	List<MotivosMinoracion> findMinoracionActSubvencionable(Integer idConvocatoria, Integer origen,
			Integer idRelExpActSub);

	/**
	 * Finds a list of rows in the Motivos de minoracion table.
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @param origen
	 *            Integer
	 * @param idFactura
	 *            Integer
	 * 
	 * @return List<MotivosMinoracion>
	 */
	List<MotivosMinoracion> findMinoracionFacturas(Integer idConvocatoria, Integer origen, Integer idFactura);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the MotivosMinoracion table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(MotivosMinoracion filterMotivosMinoracion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the MotivosMinoracion table using like.
	 *
	 * @param motivosminoracion
	 *            MotivosMinoracion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(MotivosMinoracion motivosminoracion, Boolean startsWith);

	/**
	 * Counts rows in the MotivosMinoracion table.
	 *
	 * @param motivosminoracion
	 *            MotivosMinoracion
	 * @return Long
	 */
	Long findAllCount(MotivosMinoracion motivosminoracion);

	/**
	 * Reorder selection.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosMinoracion>>
	 */
	List<TableRowDto<MotivosMinoracion>> reorderSelection(MotivosMinoracion filterMotivosMinoracion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param searchMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosMinoracion>>
	 */
	List<TableRowDto<MotivosMinoracion>> search(MotivosMinoracion filterMotivosMinoracion,
			MotivosMinoracion searchMotivosMinoracion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical MotivosMinoracion table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<MotivosMinoracion>>
	 */
	List<JerarquiaDto<MotivosMinoracion>> findAllLikeJerarquia(MotivosMinoracion filterMotivosMinoracion,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(MotivosMinoracion filterMotivosMinoracion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<MotivosMinoracion>>
	 */
	List<TableRowDto<MotivosMinoracion>> findAllChild(MotivosMinoracion filterMotivosMinoracion,
			JQGridRequestDto jqGridRequestDto);

}
