package com.ejie.ab60.dao.estudioTecnico;

import java.util.List;

import com.ejie.ab60.model.estudioTecnico.OtrasAyudas;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * OtrasAyudasDao  
 * 
 *  
 */

public interface OtrasAyudasDao {

	/**
	 * Inserts a single row in the OtrasAyudas table.
	 *
	 * @param otrasayudas
	 *            OtrasAyudas
	 * @return OtrasAyudas
	 */
	OtrasAyudas add(OtrasAyudas otrasayudas);

	/**
	 * Updates a single row in the OtrasAyudas table.
	 *
	 * @param otrasayudas
	 *            OtrasAyudas
	 * @return OtrasAyudas
	 */
	OtrasAyudas update(OtrasAyudas otrasayudas);

	/**
	 * Finds a single row in the OtrasAyudas table.
	 *
	 * @param otrasayudas
	 *            OtrasAyudas
	 * @return OtrasAyudas
	 */
	OtrasAyudas find(OtrasAyudas otrasayudas);

	/**
	 * Removes a single row in the OtrasAyudas table.
	 *
	 * @param otrasayudas
	 *            OtrasAyudas
	 */
	void remove(OtrasAyudas otrasayudas);

	/**
	 * Finds a List of rows in the OtrasAyudas table.
	 *
	 * @param otrasayudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<OtrasAyudas> findAll(OtrasAyudas otrasayudas, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the OtrasAyudas table using like.
	 *
	 * @param otrasayudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<OtrasAyudas> findAllLike(OtrasAyudas otrasayudas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the OtrasAyudas table.
	 *
	 * @param filterOtrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(OtrasAyudas filterOtrasAyudas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the OtrasAyudas table using like.
	 *
	 * @param otrasayudas
	 *            OtrasAyudas
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(OtrasAyudas otrasayudas, Boolean startsWith);

	/**
	 * Counts rows in the OtrasAyudas table.
	 *
	 * @param otrasayudas
	 *            OtrasAyudas
	 * @return Long
	 */
	Long findAllCount(OtrasAyudas otrasayudas);

	/**
	 * Reorder selection.
	 *
	 * @param filterOtrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OtrasAyudas>>
	 */
	List<TableRowDto<OtrasAyudas>> reorderSelection(OtrasAyudas filterOtrasAyudas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterOtrasAyudas
	 *            OtrasAyudas
	 * @param searchOtrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OtrasAyudas>>
	 */
	List<TableRowDto<OtrasAyudas>> search(OtrasAyudas filterOtrasAyudas, OtrasAyudas searchOtrasAyudas,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical OtrasAyudas table.
	 *
	 * @param filterOtrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<OtrasAyudas>>
	 */
	List<JerarquiaDto<OtrasAyudas>> findAllLikeJerarquia(OtrasAyudas filterOtrasAyudas,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterOtrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(OtrasAyudas filterOtrasAyudas, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterOtrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<OtrasAyudas>>
	 */
	List<TableRowDto<OtrasAyudas>> findAllChild(OtrasAyudas filterOtrasAyudas, JQGridRequestDto jqGridRequestDto);

}
