package com.ejie.ab60.dao.estudioTecnico;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.estudioTecnico.Poblaciones;

/**
 * PoblacionesDao  
 * 
 *  
 */

public interface PoblacionesDao {

	/**
	 * Inserts a single row in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @return Poblaciones
	 */
	Poblaciones add(Poblaciones poblaciones);

	/**
	 * Updates a single row in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @return Poblaciones
	 */
	Poblaciones update(Poblaciones poblaciones);

	/**
	 * Finds a single row in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @return Poblaciones
	 */
	Poblaciones find(Poblaciones poblaciones);

	/**
	 * Removes a single row in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 */
	void remove(Poblaciones poblaciones);

	/**
	 * Finds a List of rows in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Poblaciones> findAll(Poblaciones poblaciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a List of rows in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Poblaciones> findByConvocatoria(Integer idConvocatoria);

	/**
	 * Finds rows in the Poblaciones table using like.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Poblaciones> findAllLike(Poblaciones poblaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the Poblaciones table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Poblaciones filterPoblaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the Poblaciones table using like.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Poblaciones poblaciones, Boolean startsWith);

	/**
	 * Counts rows in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @return Long
	 */
	Long findAllCount(Poblaciones poblaciones);

	/**
	 * Reorder selection.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Poblaciones>>
	 */
	List<TableRowDto<Poblaciones>> reorderSelection(Poblaciones filterPoblaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param searchPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Poblaciones>>
	 */
	List<TableRowDto<Poblaciones>> search(Poblaciones filterPoblaciones, Poblaciones searchPoblaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical Poblaciones table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<Poblaciones>>
	 */
	List<JerarquiaDto<Poblaciones>> findAllLikeJerarquia(Poblaciones filterPoblaciones,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(Poblaciones filterPoblaciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<Poblaciones>>
	 */
	List<TableRowDto<Poblaciones>> findAllChild(Poblaciones filterPoblaciones, JQGridRequestDto jqGridRequestDto);

}
