package com.ejie.ab60.dao.estudioTecnico;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.estudioTecnico.RelExpErrCal;

/**
 * RelExpErrCalDao  
 * 
 *  
 */

public interface RelExpErrCalDao {

	/**
	 * Inserts a single row in the RelExpErrCal table.
	 *
	 * @param relexperrcal
	 *            RelExpErrCal
	 * @return RelExpErrCal
	 */
	RelExpErrCal add(RelExpErrCal relexperrcal);

	/**
	 * Updates a single row in the RelExpErrCal table.
	 *
	 * @param relexperrcal
	 *            RelExpErrCal
	 * @return RelExpErrCal
	 */
	RelExpErrCal update(RelExpErrCal relexperrcal);

	/**
	 * Finds a single row in the RelExpErrCal table.
	 *
	 * @param relexperrcal
	 *            RelExpErrCal
	 * @return RelExpErrCal
	 */
	RelExpErrCal find(RelExpErrCal relexperrcal);

	/**
	 * Finds a single row in the RelExpErrCal table.
	 *
	 * @param relexperrcal
	 *            RelExpErrCal
	 * @return RelExpErrCal
	 */
	List<RelExpErrCal> findLimites(RelExpErrCal relexperrcal);

	/**
	 * Removes a single row in the RelExpErrCal table.
	 *
	 * @param relexperrcal
	 *            RelExpErrCal
	 */
	void remove(RelExpErrCal relexperrcal);

	/**
	 * Finds a List of rows in the RelExpErrCal table.
	 *
	 * @param relexperrcal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelExpErrCal> findAll(RelExpErrCal relexperrcal, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelExpErrCal table using like.
	 *
	 * @param relexperrcal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelExpErrCal> findAllLike(RelExpErrCal relexperrcal, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelExpErrCal table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpErrCal filterRelExpErrCal, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelExpErrCal table using like.
	 *
	 * @param relexperrcal
	 *            RelExpErrCal
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelExpErrCal relexperrcal, Boolean startsWith);

	/**
	 * Counts rows in the RelExpErrCal table.
	 *
	 * @param relexperrcal
	 *            RelExpErrCal
	 * @return Long
	 */
	Long findAllCount(RelExpErrCal relexperrcal);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpErrCal>>
	 */
	List<TableRowDto<RelExpErrCal>> reorderSelection(RelExpErrCal filterRelExpErrCal, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param searchRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpErrCal>>
	 */
	List<TableRowDto<RelExpErrCal>> search(RelExpErrCal filterRelExpErrCal, RelExpErrCal searchRelExpErrCal,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelExpErrCal table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelExpErrCal>>
	 */
	List<JerarquiaDto<RelExpErrCal>> findAllLikeJerarquia(RelExpErrCal filterRelExpErrCal,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelExpErrCal filterRelExpErrCal, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelExpErrCal>>
	 */
	List<TableRowDto<RelExpErrCal>> findAllChild(RelExpErrCal filterRelExpErrCal, JQGridRequestDto jqGridRequestDto);

}
