package com.ejie.ab60.dao.estudioTecnico;

import java.util.List;

import com.ejie.ab60.model.estudioTecnico.TecnicosResponsables;
import com.ejie.x38.dto.JQGridRequestDto;

/**
 * TecnicosResponsablesDao  
 * 
 *  
 */

public interface TecnicosResponsablesDao {

	/**
	 * Inserts a single row in the TecnicosResponsables table.
	 *
	 * @param tecnicosresponsables
	 *            TecnicosResponsables
	 * @return TecnicosResponsables
	 */
	TecnicosResponsables add(TecnicosResponsables tecnicosresponsables);

	/**
	 * Updates a single row in the TecnicosResponsables table.
	 *
	 * @param tecnicosresponsables
	 *            TecnicosResponsables
	 * @return TecnicosResponsables
	 */
	TecnicosResponsables update(TecnicosResponsables tecnicosresponsables);

	/**
	 * Finds a single row in the TecnicosResponsables table.
	 *
	 * @param tecnicosresponsables
	 *            TecnicosResponsables
	 * @return TecnicosResponsables
	 */
	TecnicosResponsables find(TecnicosResponsables tecnicosresponsables);

	/**
	 * Removes a single row in the TecnicosResponsables table.
	 *
	 * @param tecnicosresponsables
	 *            TecnicosResponsables
	 * @return TecnicosResponsables
	 */
	TecnicosResponsables remove(TecnicosResponsables tecnicosresponsables);

	/**
	 * Finds a List of rows in the TecnicosResponsables table.
	 *
	 * @param tecnicosresponsables
	 *            TecnicosResponsables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<TecnicosResponsables> findAll(TecnicosResponsables tecnicosresponsables, JQGridRequestDto jqGridRequestDto);

	/*
	 * OPERACIONES RUP_TABLE
	 */
	/**
	 * Counts rows in the TecnicosResponsables table.
	 *
	 * @param tecnicosresponsables
	 *            TecnicosResponsables
	 * @return Long
	 */
	Long findAllCount(TecnicosResponsables tecnicosresponsables);

	/**
	 * Finds a list of rows in the TecnicosResponsables table.
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param justificacion
	 *            boolean
	 * 
	 * @return List<TecnicosResponsables>
	 */
	List<TecnicosResponsables> findTecnico(Integer idConvocatoria, Integer idExpediente, boolean justificacion);

}
