package com.ejie.ab60.dao.estudioTecnico;

import java.util.List;

import com.ejie.ab60.model.estudioTecnico.TiposResultado;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * TiposResultadoDao  
 * 
 *  
 */

public interface TiposResultadoDao {

	/**
	 * Inserts a single row in the TiposResultado table.
	 *
	 * @param tiposresultado
	 *            TiposResultado
	 * @return TiposResultado
	 */
	TiposResultado add(TiposResultado tiposresultado);

	/**
	 * Updates a single row in the TiposResultado table.
	 *
	 * @param tiposresultado
	 *            TiposResultado
	 * @return TiposResultado
	 */
	TiposResultado update(TiposResultado tiposresultado);

	/**
	 * Finds a single row in the TiposResultado table.
	 *
	 * @param tiposresultado
	 *            TiposResultado
	 * @return TiposResultado
	 */
	TiposResultado find(TiposResultado tiposresultado);

	/**
	 * Removes a single row in the TiposResultado table.
	 *
	 * @param tiposresultado
	 *            TiposResultado
	 */
	void remove(TiposResultado tiposresultado);

	/**
	 * Finds a List of rows in the TiposResultado table.
	 *
	 * @param tiposresultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<TiposResultado> findAll(TiposResultado tiposresultado, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposResultado table using like.
	 *
	 * @param tiposresultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<TiposResultado> findAllLike(TiposResultado tiposresultado, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finds a list of rows in the Resultados table.
	 *
	 * 
	 * @return List<TiposResultado>
	 */
	List<TiposResultado> findResultado();

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the TiposResultado table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposResultado filterTiposResultado, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the TiposResultado table using like.
	 *
	 * @param tiposresultado
	 *            TiposResultado
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(TiposResultado tiposresultado, Boolean startsWith);

	/**
	 * Counts rows in the TiposResultado table.
	 *
	 * @param tiposresultado
	 *            TiposResultado
	 * @return Long
	 */
	Long findAllCount(TiposResultado tiposresultado);

	/**
	 * Reorder selection.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposResultado>>
	 */
	List<TableRowDto<TiposResultado>> reorderSelection(TiposResultado filterTiposResultado,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param searchTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposResultado>>
	 */
	List<TableRowDto<TiposResultado>> search(TiposResultado filterTiposResultado, TiposResultado searchTiposResultado,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical TiposResultado table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<TiposResultado>>
	 */
	List<JerarquiaDto<TiposResultado>> findAllLikeJerarquia(TiposResultado filterTiposResultado,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(TiposResultado filterTiposResultado, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<TiposResultado>>
	 */
	List<TableRowDto<TiposResultado>> findAllChild(TiposResultado filterTiposResultado,
			JQGridRequestDto jqGridRequestDto);

}
