package com.ejie.ab60.dao.expedientes;

import com.ejie.ab60.model.expedientes.RelExpInsSinExp;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelExpInsSinExpDao  
 * 
 *  
 */

public interface RelExpInsSinExpDao {

	/**
	 * Inserts a single row in the RelExpInsSinExp table.
	 *
	 * @param relexpinssinexp
	 *            RelExpInsSinExp
	 * @return RelExpInsSinExp
	 */
	RelExpInsSinExp add(RelExpInsSinExp relexpinssinexp);

	/**
	 * Updates a single row in the RelExpInsSinExp table.
	 *
	 * @param relexpinssinexp
	 *            RelExpInsSinExp
	 * @return RelExpInsSinExp
	 */
	RelExpInsSinExp update(RelExpInsSinExp relexpinssinexp);

	/**
	 * Finds a single row in the RelExpInsSinExp table.
	 *
	 * @param relexpinssinexp
	 *            RelExpInsSinExp
	 * @return RelExpInsSinExp
	 */
	RelExpInsSinExp find(RelExpInsSinExp relexpinssinexp);

	/**
	 * Removes a single row in the RelExpInsSinExp table.
	 *
	 * @param relexpinssinexp
	 *            RelExpInsSinExp
	 */
	void remove(RelExpInsSinExp relexpinssinexp);

	/**
	 * Finds a List of rows in the RelExpInsSinExp table.
	 *
	 * @param relexpinssinexp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelExpInsSinExp> findAll(RelExpInsSinExp relexpinssinexp, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelExpInsSinExp table using like.
	 *
	 * @param relexpinssinexp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelExpInsSinExp> findAllLike(RelExpInsSinExp relexpinssinexp, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelExpInsSinExp table.
	 *
	 * @param filterRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpInsSinExp filterRelExpInsSinExp, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelExpInsSinExp table using like.
	 *
	 * @param relexpinssinexp
	 *            RelExpInsSinExp
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelExpInsSinExp relexpinssinexp, Boolean startsWith);

	/**
	 * Counts rows in the RelExpInsSinExp table.
	 *
	 * @param relexpinssinexp
	 *            RelExpInsSinExp
	 * @return Long
	 */
	Long findAllCount(RelExpInsSinExp relexpinssinexp);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpInsSinExp>>
	 */
	List<TableRowDto<RelExpInsSinExp>> reorderSelection(RelExpInsSinExp filterRelExpInsSinExp,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param searchRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpInsSinExp>>
	 */
	List<TableRowDto<RelExpInsSinExp>> search(RelExpInsSinExp filterRelExpInsSinExp,
			RelExpInsSinExp searchRelExpInsSinExp, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelExpInsSinExp table.
	 *
	 * @param filterRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelExpInsSinExp>>
	 */
	List<JerarquiaDto<RelExpInsSinExp>> findAllLikeJerarquia(RelExpInsSinExp filterRelExpInsSinExp,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelExpInsSinExp filterRelExpInsSinExp, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelExpInsSinExp>>
	 */
	List<TableRowDto<RelExpInsSinExp>> findAllChild(RelExpInsSinExp filterRelExpInsSinExp,
			JQGridRequestDto jqGridRequestDto);

	List<RelExpInsSinExp> findByIdExpediente(Integer idExpediente, JQGridRequestDto jqGridRequestDto);

	Long findByIdExpedienteCount(Integer idExpediente);

}
