package com.ejie.ab60.dao.justificacion;

import java.util.List;

import com.ejie.ab60.model.estudioTecnico.EstudioTecnico;
import com.ejie.ab60.model.expedientes.MarcarInspeccionable;
import com.ejie.ab60.model.justificacion.Justificacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * JustificacionDao  
 * 
 *  
 */

public interface JustificacionDao {

	/**
	 * Finds a single row in the Justificacion table.
	 *
	 * @param datosproyecto
	 *            Justificacion
	 * @return Justificacion
	 */
	Justificacion find(Justificacion datosproyecto);

	/**
	 * Removes a single row in the Justificacion table.
	 *
	 * @param datosproyecto
	 *            Justificacion
	 */
	void remove(Justificacion datosproyecto);

	/**
	 * Updates a single row in the Justificacion table.
	 *
	 * @param datosproyecto
	 *            Justificacion
	 * @return Justificacion
	 */
	Justificacion update(Justificacion datosproyecto);

	/**
	 * Select de todos los importes de Justificacion
	 *
	 * @param idExpediente
	 *            Integer
	 * @return Justificacion
	 */
	Justificacion refescarImportes(Integer idExpediente);

	/**
	 * Update importes de Estudio de tecnico
	 *
	 * @param datosproyecto
	 *            EstudioTecnico
	 * @return EstudioTecnico
	 */
	Justificacion updateImporte(Justificacion datosproyecto);

}
