package com.ejie.ab60.dao.justificacion;

import com.ejie.ab60.model.justificacion.MotivosIncumplimiento;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * MotivosIncumplimientoDao  
 * 
 *  
 */

public interface MotivosIncumplimientoDao {

	/**
	 * Inserts a single row in the MotivosIncumplimiento table.
	 *
	 * @param motivosincumplimiento
	 *            MotivosIncumplimiento
	 * @return MotivosIncumplimiento
	 */
	MotivosIncumplimiento add(MotivosIncumplimiento motivosincumplimiento);

	/**
	 * Updates a single row in the MotivosIncumplimiento table.
	 *
	 * @param motivosincumplimiento
	 *            MotivosIncumplimiento
	 * @return MotivosIncumplimiento
	 */
	MotivosIncumplimiento update(MotivosIncumplimiento motivosincumplimiento);

	/**
	 * Finds a single row in the MotivosIncumplimiento table.
	 *
	 * @param motivosincumplimiento
	 *            MotivosIncumplimiento
	 * @return MotivosIncumplimiento
	 */
	MotivosIncumplimiento find(MotivosIncumplimiento motivosincumplimiento);

	/**
	 * Removes a single row in the MotivosIncumplimiento table.
	 *
	 * @param motivosincumplimiento
	 *            MotivosIncumplimiento
	 */
	void remove(MotivosIncumplimiento motivosincumplimiento);

	/**
	 * Finds a List of rows in the MotivosIncumplimiento table.
	 *
	 * @param motivosincumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<MotivosIncumplimiento> findAll(MotivosIncumplimiento motivosincumplimiento, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the MotivosIncumplimiento table using like.
	 *
	 * @param motivosincumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<MotivosIncumplimiento> findAllLike(MotivosIncumplimiento motivosincumplimiento,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(MotivosIncumplimiento filterMotivosIncumplimiento, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the MotivosIncumplimiento table using like.
	 *
	 * @param motivosincumplimiento
	 *            MotivosIncumplimiento
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(MotivosIncumplimiento motivosincumplimiento, Boolean startsWith);

	/**
	 * Counts rows in the MotivosIncumplimiento table.
	 *
	 * @param motivosincumplimiento
	 *            MotivosIncumplimiento
	 * @return Long
	 */
	Long findAllCount(MotivosIncumplimiento motivosincumplimiento);

	/**
	 * Reorder selection.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosIncumplimiento>>
	 */
	List<TableRowDto<MotivosIncumplimiento>> reorderSelection(MotivosIncumplimiento filterMotivosIncumplimiento,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param searchMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosIncumplimiento>>
	 */
	List<TableRowDto<MotivosIncumplimiento>> search(MotivosIncumplimiento filterMotivosIncumplimiento,
			MotivosIncumplimiento searchMotivosIncumplimiento, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<MotivosIncumplimiento>>
	 */
	List<JerarquiaDto<MotivosIncumplimiento>> findAllLikeJerarquia(MotivosIncumplimiento filterMotivosIncumplimiento,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(MotivosIncumplimiento filterMotivosIncumplimiento,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<MotivosIncumplimiento>>
	 */
	List<TableRowDto<MotivosIncumplimiento>> findAllChild(MotivosIncumplimiento filterMotivosIncumplimiento,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the Motivos table.
	 *
	 * 
	 * @return List<MotivosIncumplimiento>
	 */
	List<MotivosIncumplimiento> findMotivo();

}
