package com.ejie.ab60.dao.justificacion;

import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.ab60.model.justificacion.RelFacActSubvencionables;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * VActuacionesSubvencionablesDao  
 * 
 *  
 */

public interface RelFacActSubvencionablesDao {

	/**
	 * Inserts a single row in the VActuacionesSubvencionables table.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @return VActuacionesSubvencionables
	 */
	RelFacActSubvencionables add(RelFacActSubvencionables vactuacionessubvencionables);

	/**
	 * Updates a single row in the VActuacionesSubvencionables table.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @return VActuacionesSubvencionables
	 */
	RelFacActSubvencionables update(RelFacActSubvencionables vactuacionessubvencionables);

	/**
	 * Finds a single row in the VActuacionesSubvencionables table.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @return VActuacionesSubvencionables
	 */
	RelFacActSubvencionables find(RelFacActSubvencionables vactuacionessubvencionables);

	/**
	 * Removes a single row in the VActuacionesSubvencionables table.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 */
	void remove(RelFacActSubvencionables vactuacionessubvencionables);

	/**
	 * Finds a List of rows in the VActuacionesSubvencionables table.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelFacActSubvencionables> findAll(RelFacActSubvencionables vactuacionessubvencionables,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the VActuacionesSubvencionables table using like.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelFacActSubvencionables> findAllLike(RelFacActSubvencionables vactuacionessubvencionables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the VActuacionesSubvencionables table.
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelFacActSubvencionables filterVActuacionesSubvencionables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the VActuacionesSubvencionables table using like.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelFacActSubvencionables vactuacionessubvencionables, Boolean startsWith);

	/**
	 * Counts rows in the VActuacionesSubvencionables table.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @return Long
	 */
	Long findAllCount(RelFacActSubvencionables vactuacionessubvencionables);

	/**
	 * Reorder selection.
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<VActuacionesSubvencionables>>
	 */
	List<TableRowDto<RelFacActSubvencionables>> reorderSelection(
			RelFacActSubvencionables filterVActuacionesSubvencionables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param searchVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<VActuacionesSubvencionables>>
	 */
	List<TableRowDto<RelFacActSubvencionables>> search(RelFacActSubvencionables filterVActuacionesSubvencionables,
			RelFacActSubvencionables searchVActuacionesSubvencionables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical VActuacionesSubvencionables table.
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<VActuacionesSubvencionables>>
	 */
	List<JerarquiaDto<RelFacActSubvencionables>> findAllLikeJerarquia(
			RelFacActSubvencionables filterVActuacionesSubvencionables, JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelFacActSubvencionables filterVActuacionesSubvencionables,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<VActuacionesSubvencionables>>
	 */
	List<TableRowDto<RelFacActSubvencionables>> findAllChild(RelFacActSubvencionables filterVActuacionesSubvencionables,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the VActuacionesSubvencionables table using like.
	 *
	 * Para cargar el combo de las actuaciones
	 *
	 * @return List
	 */
	List<RelFacActSubvencionables> findActuaciones(Integer idExpediente);

	void removeAdmitidoJus(Integer idExpediente, RelExpActSub relExpActSub);

	void removeAdmitido(Integer idExpediente, RelExpActSub relExpActSub);

}
