package com.ejie.ab60.dao.justificacion;

import com.ejie.ab60.model.MEC.Facturas;
import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.ab60.model.justificacion.RelFacActSubvencionables;
import com.ejie.ab60.model.justificacion.RelTipGasCon;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JQGridManager;
import com.ejie.x38.dto.JQGridManagerJerarquia;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;
import javax.sql.DataSource;
import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

/**
 * VActuacionesSubvencionablesDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class RelFacActSubvencionablesDaoImpl implements RelFacActSubvencionablesDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDRELEXPACTSUB" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<RelFacActSubvencionables> rwMap = new RowMapper<RelFacActSubvencionables>() {
		public RelFacActSubvencionables mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			RelFacActSubvencionables relFacActSubvencionables = new RelFacActSubvencionables();

			relFacActSubvencionables.setIdExpediente(resultSet.getInt("IDEXPEDIENTE"));
			relFacActSubvencionables.setFolderNumber(resultSet.getString("FOLDERNUMBER"));
			relFacActSubvencionables.setIdActSub(resultSet.getInt("IDACTSUB"));
			relFacActSubvencionables.setIdRelExpActSub(resultSet.getInt("IDRELEXPACTSUB"));
			relFacActSubvencionables.setDescripcionEs(resultSet.getString("DESCRIPCIONES"));
			relFacActSubvencionables.setDescripcionEu(resultSet.getString("DESCRIPCIONEU"));

			Facturas factura = new Facturas();
			factura.setIdFactura(resultSet.getInt("IDFACTURA"));
			factura.setNumeroFactura(resultSet.getString("NUMEROFACTURA"));
			factura.setDescripcion(resultSet.getString("DESCRIPCION"));
			factura.setProveedor(resultSet.getString("PROVEEDOR"));
			factura.setFechaFactura(resultSet.getDate("FECHAFACTURA"));
			factura.setFechaFacturaStr(resultSet.getString("FECHAFACTURASTR"));
			factura.setImporte(resultSet.getBigDecimal("IMPORTE"));
			factura.setImporteAdmitido(resultSet.getBigDecimal("IMPORTEADMITIDO"));
			factura.setFechaPagado(resultSet.getDate("FECHAPAGADO"));
			factura.setFechaPagadoStr(resultSet.getString("FECHAPAGADOSTR"));
			factura.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			factura.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			factura.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			factura.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));

			RelTipGasCon relTipGasCon = new RelTipGasCon();
			relTipGasCon.setIdTipoGastoFac(resultSet.getLong("IDTIPOGASTO"));
			relTipGasCon.setDescripcionCas(resultSet.getString("DESCCASTELLANO"));
			relTipGasCon.setDescripcionEus(resultSet.getString("DESCEUSKERA"));

			factura.setRelTipGasCon(relTipGasCon);

			// para que no de error al hacer el parseo en el jsp, es por
			// reutilizar el objeto Facturas
			RelExpActSub relExpActSub = new RelExpActSub();
			relExpActSub.setIdExpediente(relFacActSubvencionables.getIdExpediente());
			relExpActSub.setIdActSub(relFacActSubvencionables.getIdActSub());
			relExpActSub.setIdRelExpActSub(relFacActSubvencionables.getIdRelExpActSub());
			factura.setRelExpActSub(relExpActSub);

			relFacActSubvencionables.setFactura(factura);

			return relFacActSubvencionables;
		}
	};

	private RowMapper<RelFacActSubvencionables> rwMapPK = new RowMapper<RelFacActSubvencionables>() {
		public RelFacActSubvencionables mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			RelFacActSubvencionables relFacActSubvencionables = new RelFacActSubvencionables();

			relFacActSubvencionables.setIdExpediente(resultSet.getInt("IDEXPEDIENTE"));
			relFacActSubvencionables.setFolderNumber(resultSet.getString("FOLDERNUMBER"));
			relFacActSubvencionables.setIdActSub(resultSet.getInt("IDACTSUB"));
			relFacActSubvencionables.setIdRelExpActSub(resultSet.getInt("IDRELEXPACTSUB"));
			relFacActSubvencionables.setDescripcionEs(resultSet.getString("DESCRIPCIONES"));
			relFacActSubvencionables.setDescripcionEu(resultSet.getString("DESCRIPCIONEU"));

			Facturas factura = new Facturas();
			factura.setIdFactura(resultSet.getInt("IDFACTURA"));
			factura.setNumeroFactura(resultSet.getString("NUMEROFACTURA"));
			factura.setDescripcion(resultSet.getString("DESCRIPCION"));
			factura.setProveedor(resultSet.getString("PROVEEDOR"));
			factura.setFechaFactura(resultSet.getDate("FECHAFACTURA"));
			factura.setFechaFacturaStr(resultSet.getString("FECHAFACTURASTR"));
			factura.setImporte(resultSet.getBigDecimal("IMPORTE"));
			factura.setImporteAdmitido(resultSet.getBigDecimal("IMPORTEADMITIDO"));
			factura.setFechaPagado(resultSet.getDate("FECHAPAGADO"));
			factura.setFechaPagadoStr(resultSet.getString("FECHAPAGADOSTR"));
			factura.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			factura.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			factura.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			factura.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));

			return relFacActSubvencionables;
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<RelFacActSubvencionables>> rwMapJerarquia = new RowMapper<JerarquiaDto<RelFacActSubvencionables>>() {
		public JerarquiaDto<RelFacActSubvencionables> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			RelFacActSubvencionables relFacActSubvencionables = new RelFacActSubvencionables();

			relFacActSubvencionables.setIdExpediente(resultSet.getInt("IDEXPEDIENTE"));
			relFacActSubvencionables.setFolderNumber(resultSet.getString("FOLDERNUMBER"));
			relFacActSubvencionables.setIdActSub(resultSet.getInt("IDACTSUB"));
			relFacActSubvencionables.setIdRelExpActSub(resultSet.getInt("IDRELEXPACTSUB"));
			relFacActSubvencionables.setDescripcionEs(resultSet.getString("DESCRIPCIONES"));
			relFacActSubvencionables.setDescripcionEu(resultSet.getString("DESCRIPCIONEU"));

			Facturas factura = new Facturas();
			factura.setIdFactura(resultSet.getInt("IDFACTURA"));
			factura.setNumeroFactura(resultSet.getString("NUMEROFACTURA"));
			factura.setDescripcion(resultSet.getString("DESCRIPCION"));
			factura.setProveedor(resultSet.getString("PROVEEDOR"));
			factura.setFechaFactura(resultSet.getDate("FECHAFACTURA"));
			factura.setFechaFacturaStr(resultSet.getString("FECHAFACTURASTR"));
			factura.setImporte(resultSet.getBigDecimal("IMPORTE"));
			factura.setImporteAdmitido(resultSet.getBigDecimal("IMPORTEADMITIDO"));
			factura.setFechaPagado(resultSet.getDate("FECHAPAGADO"));
			factura.setFechaPagadoStr(resultSet.getString("FECHAPAGADOSTR"));
			factura.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			factura.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			factura.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			factura.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));

			JerarquiaDto<RelFacActSubvencionables> jerarquia = new JerarquiaDto<RelFacActSubvencionables>();
			jerarquia.setModel(relFacActSubvencionables);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/*
	 * Roe Mapper para cargar el combo de las actuaciones
	 */
	private RowMapper<RelFacActSubvencionables> rwMapComboActuaciones = new RowMapper<RelFacActSubvencionables>() {
		public RelFacActSubvencionables mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new RelFacActSubvencionables(resultSet.getInt("IDRELEXPACTSUB"),
					resultSet.getString("DESCRIPCIONES"), resultSet.getString("DESCRIPCIONEU"));
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the VActuacionesSubvencionables table.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @return VActuacionesSubvencionables
	 */
	public RelFacActSubvencionables add(RelFacActSubvencionables vactuacionessubvencionables) {
		String query = "INSERT INTO V_T_ACT_SUBVENCIONABLES (ID_EXPEDIENTE, FOLDER_NUMBER, ID_REL_EXP_ACT_SUB, DESCRIPCION_CASTELLANO, DESCRIPCION_EUSKERA) VALUES (?,?,?,?,?)";
		this.jdbcTemplate.update(query, vactuacionessubvencionables.getIdExpediente(),
				vactuacionessubvencionables.getFolderNumber(), vactuacionessubvencionables.getIdRelExpActSub(),
				vactuacionessubvencionables.getDescripcionEs(), vactuacionessubvencionables.getDescripcionEu());
		return vactuacionessubvencionables;
	}

	/**
	 * Updates a single row in the VActuacionesSubvencionables table.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @return VActuacionesSubvencionables
	 */
	public RelFacActSubvencionables update(RelFacActSubvencionables vactuacionessubvencionables) {
		String query = "UPDATE V_T_ACT_SUBVENCIONABLES SET  WHERE ID_EXPEDIENTE=? AND FOLDER_NUMBER=? AND ID_REL_EXP_ACT_SUB=? AND DESCRIPCION_CASTELLANO=? AND DESCRIPCION_EUSKERA=?";
		this.jdbcTemplate.update(query, vactuacionessubvencionables.getIdExpediente(),
				vactuacionessubvencionables.getFolderNumber(), vactuacionessubvencionables.getIdRelExpActSub(),
				vactuacionessubvencionables.getDescripcionEs(), vactuacionessubvencionables.getDescripcionEu());
		return vactuacionessubvencionables;
	}

	/**
	 * Finds a single row in the VActuacionesSubvencionables table.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @return VActuacionesSubvencionables
	 */
	@Transactional(readOnly = true)
	public RelFacActSubvencionables find(RelFacActSubvencionables vactuacionessubvencionables) {
		StringBuilder query = new StringBuilder(
				"SELECT T1.ID_EXPEDIENTE IDEXPEDIENTE, T1.PARAMETRO FOLDERNUMBER, T2.ID_ACT_SUB IDACTSUB, T1.VALOR IDRELEXPACTSUB, "
						+ "REPLACE(T1.DESCRIPCION_CASTELLANO, '[salto]', '') DESCRIPCIONES, REPLACE(T1.DESCRIPCION_EUSKERA, '[salto]', '') DESCRIPCIONEU, T3.ID_FACTURA IDFACTURA, T3.NUMERO_FACTURA NUMEROFACTURA, "
						+ "T3.DESCRIPCION DESCRIPCION, T3.PROVEEDOR PROVEEDOR, T3.FECHA_FACTURA FECHAFACTURA, TO_CHAR(T3.FECHA_FACTURA,'DD/MM/YYYY') FECHAFACTURASTR, T3.IMPORTE IMPORTE, "
						+ "T3.IMPORTE_ADMITIDO IMPORTEADMITIDO, T3.FECHA_PAGADO FECHAPAGADO, TO_CHAR(T3.FECHA_PAGADO,'DD/MM/YYYY') FECHAPAGADOSTR, T3.FECHA_REGISTRO FECHAREGISTRO, "
						+ "T3.USUARIO_REGISTRO USUARIOREGISTRO, T3.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, T3.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, "
						+ "T4.ID_TIPO_GASTO_FAC IDTIPOGASTO,T4.DESCRIPCION_CASTELLANO DESCCASTELLANO, T4.DESCRIPCION_EUSKERA DESCEUSKERA ");
		query.append("FROM AB61.V_T_ACT_SUBVENCIONABLES T1 "
				+ "INNER JOIN REL_EXP_ACT_SUB T2 ON T2.ID_EXPEDIENTE = T1.ID_EXPEDIENTE AND T2.ID_REL_EXP_ACT_SUB = T1.VALOR "
				+ "INNER JOIN FACTURAS T3  ON T3.ID_REL_EXP_ACT_SUB = T2.ID_REL_EXP_ACT_SUB "
				+ "INNER JOIN TIPOS_GASTO_FAC T4 ON T4.ID_TIPO_GASTO_FAC = T3.ID_TIPO_GASTO_FAC "
				+ "WHERE t1.ID_EXPEDIENTE = ? AND  T1.VALOR = ? AND T3.ID_FACTURA = ?");

		return DataAccessUtils.uniqueResult(this.jdbcTemplate.query(query.toString(), this.rwMap,
				vactuacionessubvencionables.getIdExpediente(), vactuacionessubvencionables.getIdRelExpActSub(),
				vactuacionessubvencionables.getFactura().getIdFactura()));
	}

	/**
	 * Removes a single row in the VActuacionesSubvencionables table.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @return
	 */
	public void remove(RelFacActSubvencionables vactuacionessubvencionables) {
		String query = "DELETE FROM V_T_ACT_SUBVENCIONABLES WHERE ID_EXPEDIENTE=? AND FOLDER_NUMBER=? AND ID_REL_EXP_ACT_SUB=? AND DESCRIPCION_CASTELLANO=? AND DESCRIPCION_EUSKERA=?";
		this.jdbcTemplate.update(query, vactuacionessubvencionables.getIdExpediente(),
				vactuacionessubvencionables.getFolderNumber(), vactuacionessubvencionables.getIdRelExpActSub(),
				vactuacionessubvencionables.getDescripcionEs(), vactuacionessubvencionables.getDescripcionEu());
	}

	/**
	 * Finds a list of rows in the VActuacionesSubvencionables table.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<VActuacionesSubvencionables>
	 */
	@Transactional(readOnly = true)
	public List<RelFacActSubvencionables> findAll(RelFacActSubvencionables vactuacionessubvencionables,
			JQGridRequestDto jqGridRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT T1.ID_EXPEDIENTE IDEXPEDIENTE, T1.PARAMETRO FOLDERNUMBER, T2.ID_ACT_SUB IDACTSUB, T1.VALOR IDRELEXPACTSUB, "
						+ "REPLACE(T1.DESCRIPCION_CASTELLANO, '[salto]', '') DESCRIPCIONES, REPLACE(T1.DESCRIPCION_EUSKERA, '[salto]', '') DESCRIPCIONEU, T3.ID_FACTURA IDFACTURA, T3.NUMERO_FACTURA NUMEROFACTURA, "
						+ "T3.DESCRIPCION DESCRIPCION, T3.PROVEEDOR PROVEEDOR, T3.FECHA_FACTURA FECHAFACTURA, TO_CHAR(T3.FECHA_FACTURA,'DD/MM/YYYY') FECHAFACTURASTR, T3.IMPORTE IMPORTE, "
						+ "T3.IMPORTE_ADMITIDO IMPORTEADMITIDO, T3.FECHA_PAGADO FECHAPAGADO, TO_CHAR(T3.FECHA_PAGADO,'DD/MM/YYYY') FECHAPAGADOSTR, T3.FECHA_REGISTRO FECHAREGISTRO, "
						+ "T3.USUARIO_REGISTRO USUARIOREGISTRO, T3.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, T3.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, "
						+ "T4.ID_TIPO_GASTO_FAC IDTIPOGASTO,T4.DESCRIPCION_CASTELLANO DESCCASTELLANO, T4.DESCRIPCION_EUSKERA DESCEUSKERA ");
		query.append("FROM AB61.V_T_ACT_SUBVENCIONABLES T1 "
				+ "INNER JOIN REL_EXP_ACT_SUB T2 ON T2.ID_EXPEDIENTE = T1.ID_EXPEDIENTE AND T2.ID_REL_EXP_ACT_SUB = T1.VALOR "
				+ "INNER JOIN FACTURAS T3  ON T3.ID_REL_EXP_ACT_SUB = T2.ID_REL_EXP_ACT_SUB "
				+ "INNER JOIN TIPOS_GASTO_FAC T4 ON T4.ID_TIPO_GASTO_FAC = T3.ID_TIPO_GASTO_FAC ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(vactuacionessubvencionables);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (jqGridRequestDto != null) {
			query = JQGridManager.getPaginationQuery(jqGridRequestDto, query,
					RelFacActSubvencionablesDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<RelFacActSubvencionables>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the VActuacionesSubvencionables table using like.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<VActuacionesSubvencionables>
	 */
	@Transactional(readOnly = true)
	public List<RelFacActSubvencionables> findAllLike(RelFacActSubvencionables relFacActSubvencionables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT T1.ID_EXPEDIENTE IDEXPEDIENTE, T1.PARAMETRO FOLDERNUMBER, T2.ID_ACT_SUB IDACTSUB, T1.VALOR IDRELEXPACTSUB, REPLACE(T1.DESCRIPCION_CASTELLANO, '[salto]', '') DESCRIPCIONES, "
						+ "REPLACE(T1.DESCRIPCION_EUSKERA, '[salto]', '') DESCRIPCIONEU, T3.ID_FACTURA IDFACTURA, T3.NUMERO_FACTURA NUMEROFACTURA, T3.DESCRIPCION DESCRIPCION, T3.PROVEEDOR PROVEEDOR, "
						+ "T3.FECHA_FACTURA FECHAFACTURA, TO_CHAR(T3.FECHA_FACTURA,'DD/MM/YYYY') FECHAFACTURASTR, T3.IMPORTE IMPORTE, T3.IMPORTE_ADMITIDO IMPORTEADMITIDO,T3.FECHA_PAGADO FECHAPAGADO, "
						+ "TO_CHAR(T3.FECHA_PAGADO,'DD/MM/YYYY') FECHAPAGADOSTR, T3.FECHA_REGISTRO FECHAREGISTRO, T3.USUARIO_REGISTRO USUARIOREGISTRO, T3.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, "
						+ "T3.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,T4.ID_TIPO_GASTO_FAC IDTIPOGASTO, T4.DESCRIPCION_CASTELLANO DESCCASTELLANO, T4.DESCRIPCION_EUSKERA DESCEUSKERA "
						+ "FROM AB61.V_T_ACT_SUBVENCIONABLES T1 "
						+ "INNER JOIN REL_EXP_ACT_SUB T2 ON T2.ID_EXPEDIENTE = T1.ID_EXPEDIENTE AND T2.ID_REL_EXP_ACT_SUB = T1.VALOR "
						+ "INNER JOIN FACTURAS T3 ON T3.ID_REL_EXP_ACT_SUB = T2.ID_REL_EXP_ACT_SUB "
						+ "INNER JOIN TIPOS_GASTO_FAC T4 ON T4.ID_TIPO_GASTO_FAC = T3.ID_TIPO_GASTO_FAC ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(relFacActSubvencionables, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");
		/*
		 * if (jqGridRequestDto != null) { query =
		 * JQGridManager.getPaginationQuery(jqGridRequestDto, query,
		 * RelFacActSubvencionablesDaoImpl.ORDER_BY_WHITE_LIST); }
		 */
		query.append(" ORDER BY ID_ACT_SUB,ID_FACTURA ");
		return (List<RelFacActSubvencionables>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the VActuacionesSubvencionables table.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(RelFacActSubvencionables vactuacionessubvencionables) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM V_T_ACT_SUBVENCIONABLES t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(vactuacionessubvencionables);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForLong(query.toString(), params.toArray());
	}

	/**
	 * Counts rows in the VActuacionesSubvencionables table using like.
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(RelFacActSubvencionables vactuacionessubvencionables, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) " + "FROM AB61.V_T_ACT_SUBVENCIONABLES T1 "
				+ "INNER JOIN REL_EXP_ACT_SUB T2 ON T2.ID_EXPEDIENTE = T1.ID_EXPEDIENTE AND T2.ID_REL_EXP_ACT_SUB = T1.VALOR "
				+ "INNER JOIN FACTURAS T3 ON T3.ID_REL_EXP_ACT_SUB = T2.ID_REL_EXP_ACT_SUB ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(vactuacionessubvencionables, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForLong(query.toString(), params.toArray());
	}

	/**
	 * Reorder the data list of VActuacionesSubvencionables selected for
	 * rup_table
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<VActuacionesSubvencionables>>
	 */
	@Override
	public List<TableRowDto<RelFacActSubvencionables>> reorderSelection(
			RelFacActSubvencionables vactuacionessubvencionables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_EXPEDIENTE IDEXPEDIENTE,t1.PARAMETRO FOLDERNUMBER,t1.VALOR IDRELEXPACTSUB,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		// FROM
		query.append("FROM V_T_ACT_SUBVENCIONABLES t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(vactuacionessubvencionables, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = JQGridManager.getReorderQuery(query, jqGridRequestDto,
				RelFacActSubvencionables.class, filterParamList,
				"ID_EXPEDIENTE,FOLDER_NUMBER,ID_REL_EXP_ACT_SUB,DESCRIPCION_CASTELLANO,DESCRIPCION_EUSKERA");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<RelFacActSubvencionables>(this.rwMapPK, jqGridRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            VActuacionesSubvencionables
	 * @param searchParams
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<VActuacionesSubvencionables>>
	 */
	@Override
	public List<TableRowDto<RelFacActSubvencionables>> search(RelFacActSubvencionables filterParams,
			RelFacActSubvencionables searchParams, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_EXPEDIENTE IDEXPEDIENTE,t1.PARAMETRO FOLDERNUMBER,t1.VALOR IDRELEXPACTSUB,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		// FROM
		query.append("FROM V_T_ACT_SUBVENCIONABLES t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = JQGridManager.getSearchQuery(query, jqGridRequestDto,
				RelFacActSubvencionables.class, filterParamList, searchSQL, searchParamList, from_alias,
				"ID_EXPEDIENTE,FOLDER_NUMBER,ID_REL_EXP_ACT_SUB,DESCRIPCION_CASTELLANO,DESCRIPCION_EUSKERA");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<RelFacActSubvencionables>(this.rwMapPK, jqGridRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filtervactuacionessubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(RelFacActSubvencionables filtervactuacionessubvencionables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_EXPEDIENTE IDEXPEDIENTE,t1.FOLDER_NUMBER FOLDERNUMBER,t1.ID_REL_EXP_ACT_SUB IDRELEXPACTSUB,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		// FROM
		query.append("FROM V_T_ACT_SUBVENCIONABLES t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filtervactuacionessubvencionables, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = JQGridManager.getRemoveMultipleQuery(jqGridRequestDto,
				RelFacActSubvencionables.class, query, params,
				"ID_EXPEDIENTE,FOLDER_NUMBER,ID_REL_EXP_ACT_SUB,DESCRIPCION_CASTELLANO,DESCRIPCION_EUSKERA");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical VActuacionesSubvencionables table.
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<VActuacionesSubvencionables>>
	 */
	@Override
	public List<JerarquiaDto<RelFacActSubvencionables>> findAllLikeJerarquia(
			RelFacActSubvencionables filterVActuacionesSubvencionables, JQGridRequestDto jqGridRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_EXPEDIENTE IDEXPEDIENTE,t1.FOLDER_NUMBER FOLDERNUMBER,t1.ID_REL_EXP_ACT_SUB IDRELEXPACTSUB,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM
		// V_T_ACT_SUBVENCIONABLES t1 ");
		List<String> from = new ArrayList<String>();
		from.add("V_T_ACT_SUBVENCIONABLES");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterVActuacionesSubvencionables, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = JQGridManagerJerarquia.getQuery(jqGridRequestDto, query, mapaWhere,
				"ID_EXPEDIENTE,FOLDER_NUMBER,ID_REL_EXP_ACT_SUB,DESCRIPCION_CASTELLANO,DESCRIPCION_EUSKERA", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = JQGridManagerJerarquia.getQuery(jqGridRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (jqGridRequestDto != null) {
			query = JQGridManagerJerarquia.getPaginationQuery(jqGridRequestDto, query,
					RelFacActSubvencionablesDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */

	@Override
	public void removeAdmitidoJus(Integer idExpediente, RelExpActSub relExpActSub) {
		String queryFacturas = "UPDATE FACTURAS SET IMPORTE_ADMITIDO = 0 WHERE ID_REL_EXP_ACT_SUB = ?";
		this.jdbcTemplate.update(queryFacturas, relExpActSub.getIdRelExpActSub());

		String queryRelExpActSub = "UPDATE REL_EXP_ACT_SUB SET IMPORTE_JUS_ADMITIDO = 0 WHERE ID_EXPEDIENTE = ? AND ID_REL_EXP_ACT_SUB = ?";
		this.jdbcTemplate.update(queryRelExpActSub, idExpediente, relExpActSub.getIdRelExpActSub());

	}

	@Override
	public void removeAdmitido(Integer idExpediente, RelExpActSub relExpActSub) {
		String queryFacturas = "UPDATE FACTURAS SET IMPORTE_ADMITIDO = 0 WHERE ID_REL_EXP_ACT_SUB = ?";
		this.jdbcTemplate.update(queryFacturas, relExpActSub.getIdRelExpActSub());

		String queryConceptos = "UPDATE CONCEPTOS SET IMPORTE_ADMITIDO = 0 WHERE ID_REL_EXP_ACT_SUB = ?";
		this.jdbcTemplate.update(queryConceptos, relExpActSub.getIdRelExpActSub());

		String queryRelExpActSub = "UPDATE REL_EXP_ACT_SUB SET IMPORTE_ADMITIDO = 0 WHERE ID_EXPEDIENTE = ? AND ID_REL_EXP_ACT_SUB = ?";
		this.jdbcTemplate.update(queryRelExpActSub, idExpediente, relExpActSub.getIdRelExpActSub());

	}

	@Override
	public Long findAllLikeCountJerarquia(RelFacActSubvencionables filterVActuacionesSubvencionables,
			JQGridRequestDto jqGridRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM
		// V_T_ACT_SUBVENCIONABLES t1 ");
		List<String> from = new ArrayList<String>();
		from.add("V_T_ACT_SUBVENCIONABLES");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterVActuacionesSubvencionables, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = JQGridManagerJerarquia.getQueryCount(jqGridRequestDto, mapaWhere,
				"ID_EXPEDIENTE,FOLDER_NUMBER,ID_REL_EXP_ACT_SUB,DESCRIPCION_CASTELLANO,DESCRIPCION_EUSKERA", "ID_PADRE",
				from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// JQGridManagerJerarquia.getQueryCount(jqGridRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForLong(query.toString(), params.toArray());
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<VActuacionesSubvencionables>>
	 */
	@Override
	public List<TableRowDto<RelFacActSubvencionables>> findAllChild(
			RelFacActSubvencionables filterVActuacionesSubvencionables, JQGridRequestDto jqGridRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM
		// V_T_ACT_SUBVENCIONABLES t1 ");
		List<String> from = new ArrayList<String>();
		from.add("V_T_ACT_SUBVENCIONABLES");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterVActuacionesSubvencionables, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = JQGridManagerJerarquia.getQueryChildren(jqGridRequestDto, mapaWhere,
				"ID_EXPEDIENTE,FOLDER_NUMBER,ID_REL_EXP_ACT_SUB,DESCRIPCION_CASTELLANO,DESCRIPCION_EUSKERA", "ID_PADRE",
				from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// JQGridManagerJerarquia.getQueryChildren(jqGridRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<RelFacActSubvencionables>(this.rwMapPK,
						"ID_EXPEDIENTE,FOLDER_NUMBER,ID_REL_EXP_ACT_SUB,DESCRIPCION_CASTELLANO,DESCRIPCION_EUSKERA"),
				params.toArray());
	}

	/**
	 * Lista de actuaciones
	 */
	@Override
	public List<RelFacActSubvencionables> findActuaciones(Integer idExpediente) {
		String query = "select t1.VALOR IDRELEXPACTSUB , REPLACE(t1.DESCRIPCION_CASTELLANO, '[salto]', '') DESCRIPCIONES, REPLACE(T1.DESCRIPCION_EUSKERA, '[salto]', '') DESCRIPCIONEU "
				+ "from AB61.V_T_ACT_SUBVENCIONABLES t1 WHERE id_expediente = " + idExpediente;

		return (List<RelFacActSubvencionables>) this.jdbcTemplate.query(query, this.rwMapComboActuaciones);

	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the VActuacionesSubvencionables entity
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables Bean with the criteria values to
	 *            filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(RelFacActSubvencionables vactuacionessubvencionables) {

		StringBuilder where = new StringBuilder(RelFacActSubvencionablesDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (vactuacionessubvencionables != null && vactuacionessubvencionables.getIdExpediente() != null) {
			where.append(" AND t1.ID_EXPEDIENTE = ?");
			params.add(vactuacionessubvencionables.getIdExpediente());
		}
		if (vactuacionessubvencionables != null && vactuacionessubvencionables.getFolderNumber() != null) {
			where.append(" AND t1.PARAMETRO = ?");
			params.add(vactuacionessubvencionables.getFolderNumber());
		}
		if (vactuacionessubvencionables != null && vactuacionessubvencionables.getIdRelExpActSub() != null) {
			where.append(" AND t1.VALOR = ?");
			params.add(vactuacionessubvencionables.getIdRelExpActSub());
		}
		if (vactuacionessubvencionables != null && vactuacionessubvencionables.getDescripcionEs() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(vactuacionessubvencionables.getDescripcionEs());
		}
		if (vactuacionessubvencionables != null && vactuacionessubvencionables.getDescripcionEu() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(vactuacionessubvencionables.getDescripcionEu());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the VActuacionesSubvencionables entity
	 *
	 * @param vactuacionessubvencionables
	 *            VActuacionesSubvencionables Bean with the criteria values to
	 *            filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(RelFacActSubvencionables vactuacionessubvencionables,
			Boolean startsWith) {

		StringBuilder where = new StringBuilder(RelFacActSubvencionablesDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (vactuacionessubvencionables != null && vactuacionessubvencionables.getIdExpediente() != null) {
			where.append(" AND t1.ID_EXPEDIENTE = ?");
			params.add(vactuacionessubvencionables.getIdExpediente());
		}
		if (vactuacionessubvencionables != null && vactuacionessubvencionables.getFolderNumber() != null) {
			where.append(" AND UPPER(t1.PARAMETRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(vactuacionessubvencionables.getFolderNumber().toUpperCase() + "%");
			} else {
				params.add("%" + vactuacionessubvencionables.getFolderNumber().toUpperCase() + "%");
			}
			where.append(" AND t1.PARAMETRO IS NOT NULL");
		}
		if (vactuacionessubvencionables != null && vactuacionessubvencionables.getIdRelExpActSub() != null) {
			where.append(" AND t1.VALOR = ?");
			params.add(vactuacionessubvencionables.getIdRelExpActSub());
		}
		if (vactuacionessubvencionables != null && vactuacionessubvencionables.getDescripcionEs() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_CASTELLANO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(vactuacionessubvencionables.getDescripcionEs().toUpperCase() + "%");
			} else {
				params.add("%" + vactuacionessubvencionables.getDescripcionEs().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_CASTELLANO IS NOT NULL");
		}
		if (vactuacionessubvencionables != null && vactuacionessubvencionables.getDescripcionEu() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_EUSKERA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(vactuacionessubvencionables.getDescripcionEu().toUpperCase() + "%");
			} else {
				params.add("%" + vactuacionessubvencionables.getDescripcionEu().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_EUSKERA IS NOT NULL");
		}
		if (vactuacionessubvencionables != null && vactuacionessubvencionables.getIdRelExpActSub() != null) {
			where.append(" AND t2.ID_REL_EXP_ACT_SUB = ?");
			params.add(vactuacionessubvencionables.getIdRelExpActSub());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
