package com.ejie.ab60.dao.justificacion;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.justificacion.RelTipGasCon;

/**
 * RelTipGasConDao  
 * 
 *  
 */

public interface RelTipGasConDao {

	/**
	 * Inserts a single row in the RelTipGasCon table.
	 *
	 * @param reltipgascon
	 *            RelTipGasCon
	 * @return RelTipGasCon
	 */
	RelTipGasCon add(RelTipGasCon reltipgascon);

	/**
	 * Updates a single row in the RelTipGasCon table.
	 *
	 * @param reltipgascon
	 *            RelTipGasCon
	 * @return RelTipGasCon
	 */
	RelTipGasCon update(RelTipGasCon reltipgascon);

	/**
	 * Finds a single row in the RelTipGasCon table.
	 *
	 * @param reltipgascon
	 *            RelTipGasCon
	 * @return RelTipGasCon
	 */
	RelTipGasCon find(RelTipGasCon reltipgascon);

	/**
	 * Removes a single row in the RelTipGasCon table.
	 *
	 * @param reltipgascon
	 *            RelTipGasCon
	 */
	void remove(RelTipGasCon reltipgascon);

	/**
	 * Finds a List of rows in the RelTipGasCon table.
	 *
	 * @param reltipgascon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelTipGasCon> findAll(RelTipGasCon reltipgascon, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelTipGasCon table using like.
	 *
	 * @param reltipgascon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelTipGasCon> findAllLike(RelTipGasCon reltipgascon, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelTipGasCon table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelTipGasCon filterRelTipGasCon, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelTipGasCon table using like.
	 *
	 * @param reltipgascon
	 *            RelTipGasCon
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelTipGasCon reltipgascon, Boolean startsWith);

	/**
	 * Counts rows in the RelTipGasCon table.
	 *
	 * @param reltipgascon
	 *            RelTipGasCon
	 * @return Long
	 */
	Long findAllCount(RelTipGasCon reltipgascon);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelTipGasCon>>
	 */
	List<TableRowDto<RelTipGasCon>> reorderSelection(RelTipGasCon filterRelTipGasCon, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param searchRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelTipGasCon>>
	 */
	List<TableRowDto<RelTipGasCon>> search(RelTipGasCon filterRelTipGasCon, RelTipGasCon searchRelTipGasCon,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelTipGasCon table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelTipGasCon>>
	 */
	List<JerarquiaDto<RelTipGasCon>> findAllLikeJerarquia(RelTipGasCon filterRelTipGasCon,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelTipGasCon filterRelTipGasCon, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelTipGasCon>>
	 */
	List<TableRowDto<RelTipGasCon>> findAllChild(RelTipGasCon filterRelTipGasCon, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the RelTipGasCon table.
	 *
	 * @return List<RelTipGasCon>
	 */
	List<RelTipGasCon> findTipos(Integer idConvocatoria);

}
