package com.ejie.ab60.dao.justificacion;

import com.ejie.ab60.model.estudioTecnico.TiposResultado;
import com.ejie.ab60.model.justificacion.TiposResJus;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * TiposResJusDao  
 * 
 *  
 */

public interface TiposResJusDao {

	/**
	 * Inserts a single row in the TiposResJus table.
	 *
	 * @param tiposresjus
	 *            TiposResJus
	 * @return TiposResJus
	 */
	TiposResJus add(TiposResJus tiposresjus);

	/**
	 * Updates a single row in the TiposResJus table.
	 *
	 * @param tiposresjus
	 *            TiposResJus
	 * @return TiposResJus
	 */
	TiposResJus update(TiposResJus tiposresjus);

	/**
	 * Finds a single row in the TiposResJus table.
	 *
	 * @param tiposresjus
	 *            TiposResJus
	 * @return TiposResJus
	 */
	TiposResJus find(TiposResJus tiposresjus);

	/**
	 * Removes a single row in the TiposResJus table.
	 *
	 * @param tiposresjus
	 *            TiposResJus
	 */
	void remove(TiposResJus tiposresjus);

	/**
	 * Finds a List of rows in the TiposResJus table.
	 *
	 * @param tiposresjus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<TiposResJus> findAll(TiposResJus tiposresjus, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposResJus table using like.
	 *
	 * @param tiposresjus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<TiposResJus> findAllLike(TiposResJus tiposresjus, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finds a list of rows in the Resultados table.
	 *
	 * 
	 * @return List<TiposResultado>
	 */
	List<TiposResJus> findResultado();

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the TiposResJus table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposResJus filterTiposResJus, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the TiposResJus table using like.
	 *
	 * @param tiposresjus
	 *            TiposResJus
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(TiposResJus tiposresjus, Boolean startsWith);

	/**
	 * Counts rows in the TiposResJus table.
	 *
	 * @param tiposresjus
	 *            TiposResJus
	 * @return Long
	 */
	Long findAllCount(TiposResJus tiposresjus);

	/**
	 * Reorder selection.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposResJus>>
	 */
	List<TableRowDto<TiposResJus>> reorderSelection(TiposResJus filterTiposResJus, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param searchTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposResJus>>
	 */
	List<TableRowDto<TiposResJus>> search(TiposResJus filterTiposResJus, TiposResJus searchTiposResJus,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical TiposResJus table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<TiposResJus>>
	 */
	List<JerarquiaDto<TiposResJus>> findAllLikeJerarquia(TiposResJus filterTiposResJus,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(TiposResJus filterTiposResJus, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<TiposResJus>>
	 */
	List<TableRowDto<TiposResJus>> findAllChild(TiposResJus filterTiposResJus, JQGridRequestDto jqGridRequestDto);

}
