package com.ejie.ab60.dao.moduloContable;

import java.util.List;

import com.ejie.ab60.model.moduloContable.DocContables;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * DocContablesDao  
 * 
 *  
 */

public interface DocContablesODao {
	/**
	 * Finds rows in the DocContables table using like.
	 *
	 * @param docContables
	 *            DocContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<DocContables> findAllLike(DocContables docContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the DocContables table using like.
	 *
	 * @param docContables
	 *            DocContables
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(DocContables docContables, Boolean startsWith);

	/**
	 * Reorder selection.
	 *
	 * @param filterDocContables
	 *            DocContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DocContables>>
	 */
	List<TableRowDto<DocContables>> reorderSelection(DocContables filterDocContables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);
}
