package com.ejie.ab60.dao.moduloContable;

import com.ejie.ab60.model.moduloContable.FicherosContables;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * FicherosContablesDao  
 * 
 *  
 */

public interface FicherosContablesDao {

	/**
	 * Inserts a single row in the FicherosContables table.
	 *
	 * @param ficheroscontables
	 *            FicherosContables
	 * @return FicherosContables
	 */
	FicherosContables add(FicherosContables ficheroscontables, Usuario usuario);

	/**
	 * Updates a single row in the FicherosContables table.
	 *
	 * @param ficheroscontables
	 *            FicherosContables
	 * @return FicherosContables
	 */
	FicherosContables update(FicherosContables ficheroscontables, Usuario usuario);

	/**
	 * Finds a single row in the FicherosContables table.
	 *
	 * @param ficheroscontables
	 *            FicherosContables
	 * @return FicherosContables
	 */
	FicherosContables find(FicherosContables ficheroscontables);

	/**
	 * Finds a single row in the FicherosContables table.
	 *
	 * @param ficheroscontables
	 *            FicherosContables
	 * @return FicherosContables
	 */
	FicherosContables findNew(FicherosContables ficheroscontables);

	/**
	 * Removes a single row in the FicherosContables table.
	 *
	 * @param ficheroscontables
	 *            FicherosContables
	 */
	void remove(FicherosContables ficheroscontables);

	/**
	 * Finds a List of rows in the FicherosContables table.
	 *
	 * @param ficheroscontables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<FicherosContables> findAll(FicherosContables ficheroscontables, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the FicherosContables table using like.
	 *
	 * @param ficheroscontables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<FicherosContables> findAllLike(FicherosContables ficheroscontables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the FicherosContables table.
	 *
	 * @param filterFicherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(FicherosContables filterFicherosContables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the FicherosContables table using like.
	 *
	 * @param ficheroscontables
	 *            FicherosContables
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(FicherosContables ficheroscontables, Boolean startsWith);

	/**
	 * Counts rows in the FicherosContables table.
	 *
	 * @param ficheroscontables
	 *            FicherosContables
	 * @return Long
	 */
	Long findAllCount(FicherosContables ficheroscontables);

	/**
	 * Reorder selection.
	 *
	 * @param filterFicherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<FicherosContables>>
	 */
	List<TableRowDto<FicherosContables>> reorderSelection(FicherosContables filterFicherosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterFicherosContables
	 *            FicherosContables
	 * @param searchFicherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<FicherosContables>>
	 */
	List<TableRowDto<FicherosContables>> search(FicherosContables filterFicherosContables,
			FicherosContables searchFicherosContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical FicherosContables table.
	 *
	 * @param filterFicherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<FicherosContables>>
	 */
	List<JerarquiaDto<FicherosContables>> findAllLikeJerarquia(FicherosContables filterFicherosContables,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterFicherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(FicherosContables filterFicherosContables, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterFicherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<FicherosContables>>
	 */
	List<TableRowDto<FicherosContables>> findAllChild(FicherosContables filterFicherosContables,
			JQGridRequestDto jqGridRequestDto);

}