package com.ejie.ab60.dao.moduloContable;

import com.ejie.ab60.model.moduloContable.TiposDocContables;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * TiposDocContablesDao  
 *  
 */

public interface TiposDocContablesDao {
    
    /**
     * Inserts a single row in the TiposDocContables table.
     *
     * @param tiposdoccontables TiposDocContables
     * @return TiposDocContables
     */
    TiposDocContables add(TiposDocContables tiposdoccontables);

    /**
     * Updates a single row in the TiposDocContables table.
     *
     * @param tiposdoccontables TiposDocContables
     * @return TiposDocContables
     */
    TiposDocContables update(TiposDocContables tiposdoccontables);

    /**
     * Finds a single row in the TiposDocContables table.
     *
     * @param tiposdoccontables TiposDocContables
     * @return TiposDocContables
     */
    TiposDocContables find(TiposDocContables tiposdoccontables);

    /**
     * Removes a single row in the TiposDocContables table.
     *
     * @param tiposdoccontables TiposDocContables
     */
    void remove(TiposDocContables tiposdoccontables);

    /**
     * Finds a List of rows in the TiposDocContables table.
     *
     * @param tiposdoccontables TiposDocContables
     * @param jqGridRequestDto JQGridRequestDto
     * @return List
     */
    List<TiposDocContables> findAll(TiposDocContables tiposdoccontables, JQGridRequestDto jqGridRequestDto);

	/**
     * Finds rows in the TiposDocContables table using like.
     *
     * @param tiposdoccontables TiposDocContables
     * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean
     * @return List
     */
	List<TiposDocContables> findAllLike(TiposDocContables tiposdoccontables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Filter in the TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	 void removeMultiple(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
    /**
     * Counts rows in the TiposDocContables table using like.
     *
     * @param tiposdoccontables TiposDocContables
     * @param startsWith Boolean
     * @return Long
     */
    Long findAllLikeCount(TiposDocContables tiposdoccontables, Boolean startsWith);
    
    /**
     * Counts rows in the TiposDocContables table.
     *
     * @param tiposdoccontables TiposDocContables
     * @return Long
     */
    Long findAllCount(TiposDocContables tiposdoccontables);
    
    /**
	 * Reorder selection.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<TiposDocContables>>
	 */	
    List<TableRowDto<TiposDocContables>> reorderSelection(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
     /**
	 * Searches in the Usuario table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param searchTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<TiposDocContables>>	 
	 */	
    List<TableRowDto<TiposDocContables>> search(TiposDocContables filterTiposDocContables, TiposDocContables searchTiposDocContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
    
    /**
	 * Filter in the hierarchical TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<JerarquiaDto<TiposDocContables>>
	 */	
	List<JerarquiaDto<TiposDocContables>> findAllLikeJerarquia(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return Long
	 */	
	Long findAllLikeCountJerarquia(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<TableRowDto<TiposDocContables>>
	 */	
	List<TableRowDto<TiposDocContables>> findAllChild(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto);
	
	
}

