package com.ejie.ab60.dao.nora;

/**
 * T17Comarca  
 */

import java.util.List;

import com.ejie.x38.dto.Pagination;
import com.ejie.ab60.model.nora.T17Comarca;

/**
 * T17ComarcaDao  
 * 
 *  
 */
public interface T17ComarcaDao {
	/**
	 * Inserts a single row in the T17Comarca table.
	 * 
	 * @param t17comarca
	 *            T17Comarca
	 * @return T17Comarca
	 */
	T17Comarca add(T17Comarca t17comarca);

	/**
	 * Updates a single row in the T17Comarca table.
	 * 
	 * @param t17comarca
	 *            T17Comarca
	 * @return T17Comarca
	 */
	T17Comarca update(T17Comarca t17comarca);

	/**
	 * Finds a single row in the T17Comarca table.
	 * 
	 * @param t17comarca
	 *            T17Comarca
	 * @return T17Comarca
	 */
	T17Comarca find(T17Comarca t17comarca);

	/**
	 * Deletes a single row in the T17Comarca table.
	 * 
	 * @param t17comarca
	 *            T17Comarca
	 * 
	 */
	void remove(T17Comarca t17comarca);

	/**
	 * Finds a List of rows in the T17Comarca table.
	 * 
	 * @param t17comarca
	 *            T17Comarca
	 * @param pagination
	 *            Pagination<Object>
	 * @return List<T17Comarca>
	 */
	List<T17Comarca> findAll(T17Comarca t17comarca, Pagination<Object> pagination);

	/**
	 * Counts rows in the T17Comarca table.
	 * 
	 * @param t17comarca
	 *            T17Comarca
	 * @return Long
	 */
	Long findAllCount(T17Comarca t17comarca);

	/**
	 * Finds rows in the T17Comarca table using like.
	 * 
	 * @param t17comarca
	 *            T17Comarca
	 * @param pagination
	 *            Pagination<Object>
	 * @param startsWith
	 *            Boolean
	 * 
	 * @return List<T17Comarca>
	 */
	List<T17Comarca> findAllLike(T17Comarca t17comarca, Pagination<Object> pagination, Boolean startsWith);
}
