package com.ejie.ab60.dao.preguntasExpediente;

import com.ejie.ab60.model.preguntasExpediente.PreguntasExpediente;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * PreguntasExpedienteDao  
 *  
 */

public interface PreguntasExpedienteDao {
    
    /**
     * Inserts a single row in the PreguntasExpediente table.
     *
     * @param preguntasexpediente PreguntasExpediente
     * @return PreguntasExpediente
     */
    PreguntasExpediente add(PreguntasExpediente preguntasexpediente);

    /**
     * Updates a single row in the PreguntasExpediente table.
     *
     * @param preguntasexpediente PreguntasExpediente
     * @return PreguntasExpediente
     */
    PreguntasExpediente update(PreguntasExpediente preguntasexpediente);

    /**
     * Finds a single row in the PreguntasExpediente table.
     *
     * @param preguntasexpediente PreguntasExpediente
     * @return PreguntasExpediente
     */
    PreguntasExpediente find(PreguntasExpediente preguntasexpediente);

    /**
     * Removes a single row in the PreguntasExpediente table.
     *
     * @param preguntasexpediente PreguntasExpediente
     */
    void remove(PreguntasExpediente preguntasexpediente);

    /**
     * Finds a List of rows in the PreguntasExpediente table.
     *
     * @param preguntasexpediente PreguntasExpediente
     * @param jqGridRequestDto JQGridRequestDto
     * @return List
     */
    List<PreguntasExpediente> findAll(PreguntasExpediente preguntasexpediente, JQGridRequestDto jqGridRequestDto);

	/**
     * Finds rows in the PreguntasExpediente table using like.
     *
     * @param preguntasexpediente PreguntasExpediente
     * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean
     * @return List
     */
	List<PreguntasExpediente> findAllLike(PreguntasExpediente preguntasexpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Filter in the PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	 void removeMultiple(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
    /**
     * Counts rows in the PreguntasExpediente table using like.
     *
     * @param preguntasexpediente PreguntasExpediente
     * @param startsWith Boolean
     * @return Long
     */
    Long findAllLikeCount(PreguntasExpediente preguntasexpediente, Boolean startsWith);
    
    /**
     * Counts rows in the PreguntasExpediente table.
     *
     * @param preguntasexpediente PreguntasExpediente
     * @return Long
     */
    Long findAllCount(PreguntasExpediente preguntasexpediente);
    
    /**
	 * Reorder selection.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<PreguntasExpediente>>
	 */	
    List<TableRowDto<PreguntasExpediente>> reorderSelection(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
     /**
	 * Searches in the Usuario table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param searchPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<PreguntasExpediente>>	 
	 */	
    List<TableRowDto<PreguntasExpediente>> search(PreguntasExpediente filterPreguntasExpediente, PreguntasExpediente searchPreguntasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
    
    /**
	 * Filter in the hierarchical PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<JerarquiaDto<PreguntasExpediente>>
	 */	
	List<JerarquiaDto<PreguntasExpediente>> findAllLikeJerarquia(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Count rows in hierarchy
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return Long
	 */	
	Long findAllLikeCountJerarquia(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<TableRowDto<PreguntasExpediente>>
	 */	
	List<TableRowDto<PreguntasExpediente>> findAllChild(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto);
	
	
}

