package com.ejie.ab60.dao.terceros;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

/**
 * DatosTerEmetDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class DatosTerEmetDaoImpl implements DatosTerEmetDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDDATOTEREMET", "IDTERCERO", "IDTIPOEMPRESA",
			"IDDATOEMPLEO", "DATEMPMESANT", "DATEMPANYOANT", "DATEMPEJEANT", "FECHAREGISTRO", "USUARIOREGISTRO",
			"FECHAULTMODIFICACION", "USUARIOULTMODIFICACION" };

	private JdbcTemplate jdbcTemplate;

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/**
	 * Removes a single row in the DatosTerEmet table.
	 *
	 * @param idTercero
	 *            Integer
	 * @return
	 */
	public void remove(Integer idTercero) {
		String query = "DELETE FROM DATOS_TER_EMET WHERE ID_DATO_TER_EMET=?";
		this.jdbcTemplate.update(query, idTercero);
	}

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

}
