package com.ejie.ab60.dao.terceros;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

/**
 * DatosTerMecDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class DatosTerMecDaoImpl implements DatosTerMecDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDDATOTERMEC", "PAGINAWEB", "IDIAE",
			"FECHAALTAEMPRESA", "FECHAALTAESTABL", "NUMEROSOCIOS", "NUMEROSOCIAS", "FECHAREGISTRO", "USUARIOREGISTRO",
			"FECHAULTMODIFICACION", "USUARIOULTMODIFICACION", "IDTERCERO" };

	private JdbcTemplate jdbcTemplate;

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/**
	 * Removes a single row in the DatosTerMec table.
	 *
	 * @param datostermec
	 *            DatosTerMec
	 * @return
	 */
	public void remove(Integer idTercero) {
		String query = "DELETE FROM DATOS_TER_MEC WHERE ID_DATO_TER_MEC =?";
		this.jdbcTemplate.update(query, idTercero);
	}

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
