package com.ejie.ab60.model.BEC;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.springframework.context.i18n.LocaleContextHolder;

/**
 * Caracteristicas  
 * 
 *  
 */

public class Caracteristicas implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idCaracteristica;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private String descripcion;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<OtrosTitulos> otrosTituloses = new ArrayList<OtrosTitulos>();
	private Integer idConvocatoria;

	/**
	 * Method 'Caracteristicas'.
	 */
	public Caracteristicas() {
	}

	/**
	 * Method 'Caracteristicas'.
	 * 
	 * @param idCaracteristica
	 *            Long
	 */
	public Caracteristicas(Long idCaracteristica) {
		this.idCaracteristica = idCaracteristica;
	}

	/**
	 * Method 'Caracteristicas'.
	 * 
	 * @param idCaracteristica
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public Caracteristicas(Long idCaracteristica, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro) {
		this.idCaracteristica = idCaracteristica;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'Caracteristicas'.
	 * 
	 * @param idCaracteristica
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param otrosTituloses
	 *            List<OtrosTitulos>
	 */
	public Caracteristicas(Long idCaracteristica, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro, List<OtrosTitulos> otrosTituloses) {

		this.idCaracteristica = idCaracteristica;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.otrosTituloses = otrosTituloses;
	}

	/**
	 * Method 'getIdCaracteristica'.
	 *
	 * @return Long
	 */

	public Long getIdCaracteristica() {
		return this.idCaracteristica;
	}

	/**
	 * Method 'setIdCaracteristica'.
	 *
	 * @param idCaracteristica
	 *            Long
	 * @return
	 */

	public void setIdCaracteristica(Long idCaracteristica) {
		this.idCaracteristica = idCaracteristica;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getOtrosTituloses'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<OtrosTitulos> getOtrosTituloses() {
		return this.otrosTituloses;
	}

	/**
	 * Method 'setOtrosTituloses'.
	 *
	 * @param otrosTituloses
	 *            List
	 * @return
	 */
	public void setOtrosTituloses(List<OtrosTitulos> otrosTituloses) {
		this.otrosTituloses = otrosTituloses;
	}

	/**
	 * @return the descripcion
	 */
	public String getDescripcion() {
		if (LocaleContextHolder.getLocale().toString().equals("es")) {
			return this.descripcionCastellano;
		} else {
			return this.descripcionEuskera;
		}
	}

	/**
	 * @param descripcion
	 *            the descripcion to set
	 */
	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
		if (LocaleContextHolder.getLocale().toString().equals("es")) {
			this.descripcion = this.descripcionCastellano;
		} else {
			this.descripcion = this.descripcionEuskera;
		}
	}

	/**
	 * @return the idConvocatoria
	 */
	public Integer getIdConvocatoria() {
		return idConvocatoria;
	}

	/**
	 * @param idConvocatoria
	 *            the idConvocatoria to set
	 */
	public void setIdConvocatoria(Integer idConvocatoria) {
		this.idConvocatoria = idConvocatoria;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idCaracteristica: ").append(this.idCaracteristica).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ idConvocatoria: ").append(this.idConvocatoria).append(" ]");
		result.append("}");
		return result.toString();
	}

}
