package com.ejie.ab60.model.BEC;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

/**
 * Curriculum  
 * 
 *  
 */

public class Curriculum implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idCurriculum;
	private TiposCertificacion tiposCertificacionByIdCertificacionIngles;
	private TiposCertificacion tiposCertificacionByIdCertificacionFrances;
	private TiposCertificacion tiposCertificacionByIdCertificacionItaliano;
	private TiposCertificacion tiposCertificacionByIdCertificacionEuskera;
	private Integer idExpediente;
	private String titulacion;
	private Long anyoInicio;
	private Long anyoFin;
	private Long matriculasHonor;
	private Long sobresalientes;
	private Long notables;
	private Long suficientes;
	private Integer euskera;
	private Integer frances;
	private Integer ingles;
	private Integer italiano;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private List<OtrosTitulos> otrosTituloses = new ArrayList<OtrosTitulos>();
	private List<ExperienciaLaboral> experienciaLaborals = new ArrayList<ExperienciaLaboral>();
	private Puntuaciones puntuaciones;

	private Integer[] criterios;
	private Integer bandera;

	/**
	 * Method 'Curriculum'.
	 */
	public Curriculum() {
	}

	/**
	 * Method 'Curriculum'.
	 * 
	 * @param idCurriculum
	 *            Integer
	 */
	public Curriculum(Integer idCurriculum) {
		this.idCurriculum = idCurriculum;
	}

	/**
	 * Method 'Curriculum'.
	 * 
	 * @param idCurriculum
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param titulacion
	 *            String
	 * @param anyoInicio
	 *            Long
	 * @param anyoFin
	 *            Long
	 * @param matriculasHonor
	 *            Long
	 * @param sobresalientes
	 *            Long
	 * @param notables
	 *            Long
	 * @param suficientes
	 *            Long
	 * @param euskera
	 *            Integer
	 * @param frances
	 *            Integer
	 * @param ingles
	 *            Integer
	 * @param italiano
	 *            Integer
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param tiposCertificacionByIdCertificacionIngles
	 *            TiposCertificacion
	 * @param tiposCertificacionByIdCertificacionFrances
	 *            TiposCertificacion
	 * @param tiposCertificacionByIdCertificacionItaliano
	 *            TiposCertificacion
	 * @param tiposCertificacionByIdCertificacionEuskera
	 *            TiposCertificacion
	 */
	public Curriculum(Integer idCurriculum, Integer idExpediente, String titulacion, Long anyoInicio, Long anyoFin,
			Long matriculasHonor, Long sobresalientes, Long notables, Long suficientes, Integer euskera,
			Integer frances, Integer ingles, Integer italiano, Date fechaRegistro, String usuarioRegistro,
			Date fechaUltmodificacion, String usuarioUltmodificacion,
			TiposCertificacion tiposCertificacionByIdCertificacionIngles,
			TiposCertificacion tiposCertificacionByIdCertificacionFrances,
			TiposCertificacion tiposCertificacionByIdCertificacionItaliano,
			TiposCertificacion tiposCertificacionByIdCertificacionEuskera) {
		this.idCurriculum = idCurriculum;
		this.tiposCertificacionByIdCertificacionIngles = tiposCertificacionByIdCertificacionIngles;
		this.tiposCertificacionByIdCertificacionFrances = tiposCertificacionByIdCertificacionFrances;
		this.tiposCertificacionByIdCertificacionItaliano = tiposCertificacionByIdCertificacionItaliano;
		this.tiposCertificacionByIdCertificacionEuskera = tiposCertificacionByIdCertificacionEuskera;
		this.idExpediente = idExpediente;
		this.titulacion = titulacion;
		this.anyoInicio = anyoInicio;
		this.anyoFin = anyoFin;
		this.matriculasHonor = matriculasHonor;
		this.sobresalientes = sobresalientes;
		this.notables = notables;
		this.suficientes = suficientes;
		this.euskera = euskera;
		this.frances = frances;
		this.ingles = ingles;
		this.italiano = italiano;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'Curriculum'.
	 * 
	 * @param idCurriculum
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param titulacion
	 *            String
	 * @param anyoInicio
	 *            Long
	 * @param anyoFin
	 *            Long
	 * @param matriculasHonor
	 *            Long
	 * @param sobresalientes
	 *            Long
	 * @param notables
	 *            Long
	 * @param suficientes
	 *            Long
	 * @param euskera
	 *            Integer
	 * @param frances
	 *            Integer
	 * @param ingles
	 *            Integer
	 * @param italiano
	 *            Integer
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param tiposCertificacionByIdCertificacionIngles
	 *            TiposCertificacion
	 * @param tiposCertificacionByIdCertificacionFrances
	 *            TiposCertificacion
	 * @param tiposCertificacionByIdCertificacionItaliano
	 *            TiposCertificacion
	 * @param tiposCertificacionByIdCertificacionEuskera
	 *            TiposCertificacion
	 * @param otrosTituloses
	 *            List<OtrosTitulos>
	 * @param experienciaLaborals
	 *            List<ExperienciaLaboral>
	 */
	public Curriculum(Integer idCurriculum, Integer idExpediente, String titulacion, Long anyoInicio, Long anyoFin,
			Long matriculasHonor, Long sobresalientes, Long notables, Long suficientes, Integer euskera,
			Integer frances, Integer ingles, Integer italiano, Date fechaRegistro, String usuarioRegistro,
			Date fechaUltmodificacion, String usuarioUltmodificacion,
			TiposCertificacion tiposCertificacionByIdCertificacionIngles,
			TiposCertificacion tiposCertificacionByIdCertificacionFrances,
			TiposCertificacion tiposCertificacionByIdCertificacionItaliano,
			TiposCertificacion tiposCertificacionByIdCertificacionEuskera, List<OtrosTitulos> otrosTituloses,
			List<ExperienciaLaboral> experienciaLaborals) {

		this.idCurriculum = idCurriculum;
		this.tiposCertificacionByIdCertificacionIngles = tiposCertificacionByIdCertificacionIngles;
		this.tiposCertificacionByIdCertificacionFrances = tiposCertificacionByIdCertificacionFrances;
		this.tiposCertificacionByIdCertificacionItaliano = tiposCertificacionByIdCertificacionItaliano;
		this.tiposCertificacionByIdCertificacionEuskera = tiposCertificacionByIdCertificacionEuskera;
		this.idExpediente = idExpediente;
		this.titulacion = titulacion;
		this.anyoInicio = anyoInicio;
		this.anyoFin = anyoFin;
		this.matriculasHonor = matriculasHonor;
		this.sobresalientes = sobresalientes;
		this.notables = notables;
		this.suficientes = suficientes;
		this.euskera = euskera;
		this.frances = frances;
		this.ingles = ingles;
		this.italiano = italiano;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.otrosTituloses = otrosTituloses;
		this.experienciaLaborals = experienciaLaborals;
	}

	/**
	 * Method 'getIdCurriculum'.
	 *
	 * @return Integer
	 */

	public Integer getIdCurriculum() {
		return this.idCurriculum;
	}

	/**
	 * Method 'setIdCurriculum'.
	 *
	 * @param idCurriculum
	 *            Integer
	 * @return
	 */

	public void setIdCurriculum(Integer idCurriculum) {
		this.idCurriculum = idCurriculum;
	}

	/**
	 * Method 'getTiposCertificacionByIdCertificacionIngles'.
	 *
	 * @return TiposCertificacion
	 */

	public TiposCertificacion getTiposCertificacionByIdCertificacionIngles() {
		return this.tiposCertificacionByIdCertificacionIngles;
	}

	/**
	 * Method 'setTiposCertificacionByIdCertificacionIngles'.
	 *
	 * @param tiposCertificacionByIdCertificacionIngles
	 *            TiposCertificacion
	 * @return
	 */

	public void setTiposCertificacionByIdCertificacionIngles(
			TiposCertificacion tiposCertificacionByIdCertificacionIngles) {
		this.tiposCertificacionByIdCertificacionIngles = tiposCertificacionByIdCertificacionIngles;
	}

	/**
	 * Method 'getTiposCertificacionByIdCertificacionFrances'.
	 *
	 * @return TiposCertificacion
	 */

	public TiposCertificacion getTiposCertificacionByIdCertificacionFrances() {
		return this.tiposCertificacionByIdCertificacionFrances;
	}

	/**
	 * Method 'setTiposCertificacionByIdCertificacionFrances'.
	 *
	 * @param tiposCertificacionByIdCertificacionFrances
	 *            TiposCertificacion
	 * @return
	 */

	public void setTiposCertificacionByIdCertificacionFrances(
			TiposCertificacion tiposCertificacionByIdCertificacionFrances) {
		this.tiposCertificacionByIdCertificacionFrances = tiposCertificacionByIdCertificacionFrances;
	}

	/**
	 * Method 'getTiposCertificacionByIdCertificacionItaliano'.
	 *
	 * @return TiposCertificacion
	 */

	public TiposCertificacion getTiposCertificacionByIdCertificacionItaliano() {
		return this.tiposCertificacionByIdCertificacionItaliano;
	}

	/**
	 * Method 'setTiposCertificacionByIdCertificacionItaliano'.
	 *
	 * @param tiposCertificacionByIdCertificacionItaliano
	 *            TiposCertificacion
	 * @return
	 */

	public void setTiposCertificacionByIdCertificacionItaliano(
			TiposCertificacion tiposCertificacionByIdCertificacionItaliano) {
		this.tiposCertificacionByIdCertificacionItaliano = tiposCertificacionByIdCertificacionItaliano;
	}

	/**
	 * Method 'getTiposCertificacionByIdCertificacionEuskera'.
	 *
	 * @return TiposCertificacion
	 */
	public TiposCertificacion getTiposCertificacionByIdCertificacionEuskera() {
		return this.tiposCertificacionByIdCertificacionEuskera;
	}

	/**
	 * Method 'setTiposCertificacionByIdCertificacionEuskera'.
	 *
	 * @param tiposCertificacionByIdCertificacionEuskera
	 *            TiposCertificacion
	 * @return
	 */

	public void setTiposCertificacionByIdCertificacionEuskera(
			TiposCertificacion tiposCertificacionByIdCertificacionEuskera) {
		this.tiposCertificacionByIdCertificacionEuskera = tiposCertificacionByIdCertificacionEuskera;
	}

	/**
	 * Method 'getIdExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdExpediente() {
		return this.idExpediente;
	}

	/**
	 * Method 'setIdExpediente'.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return
	 */

	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'getTitulacion'.
	 *
	 * @return String
	 */

	public String getTitulacion() {
		return this.titulacion;
	}

	/**
	 * Method 'setTitulacion'.
	 *
	 * @param titulacion
	 *            String
	 * @return
	 */

	public void setTitulacion(String titulacion) {
		this.titulacion = titulacion;
	}

	/**
	 * Method 'getAnyoInicio'.
	 *
	 * @return Long
	 */

	public Long getAnyoInicio() {
		return this.anyoInicio;
	}

	/**
	 * Method 'setAnyoInicio'.
	 *
	 * @param anyoInicio
	 *            Long
	 * @return
	 */

	public void setAnyoInicio(Long anyoInicio) {
		this.anyoInicio = anyoInicio;
	}

	/**
	 * Method 'getAnyoFin'.
	 *
	 * @return Long
	 */

	public Long getAnyoFin() {
		return this.anyoFin;
	}

	/**
	 * Method 'setAnyoFin'.
	 *
	 * @param anyoFin
	 *            Long
	 * @return
	 */

	public void setAnyoFin(Long anyoFin) {
		this.anyoFin = anyoFin;
	}

	/**
	 * Method 'getMatriculasHonor'.
	 *
	 * @return Long
	 */

	public Long getMatriculasHonor() {
		return this.matriculasHonor;
	}

	/**
	 * Method 'setMatriculasHonor'.
	 *
	 * @param matriculasHonor
	 *            Long
	 * @return
	 */

	public void setMatriculasHonor(Long matriculasHonor) {
		this.matriculasHonor = matriculasHonor;
	}

	/**
	 * Method 'getSobresalientes'.
	 *
	 * @return Long
	 */

	public Long getSobresalientes() {
		return this.sobresalientes;
	}

	/**
	 * Method 'setSobresalientes'.
	 *
	 * @param sobresalientes
	 *            Long
	 * @return
	 */

	public void setSobresalientes(Long sobresalientes) {
		this.sobresalientes = sobresalientes;
	}

	/**
	 * Method 'getNotables'.
	 *
	 * @return Long
	 */

	public Long getNotables() {
		return this.notables;
	}

	/**
	 * Method 'setNotables'.
	 *
	 * @param notables
	 *            Long
	 * @return
	 */

	public void setNotables(Long notables) {
		this.notables = notables;
	}

	/**
	 * Method 'getSuficientes'.
	 *
	 * @return Long
	 */

	public Long getSuficientes() {
		return this.suficientes;
	}

	/**
	 * Method 'setSuficientes'.
	 *
	 * @param suficientes
	 *            Long
	 * @return
	 */

	public void setSuficientes(Long suficientes) {
		this.suficientes = suficientes;
	}

	/**
	 * Method 'getEuskera'.
	 *
	 * @return Integer
	 */

	public Integer getEuskera() {
		return this.euskera;
	}

	/**
	 * Method 'setEuskera'.
	 *
	 * @param euskera
	 *            Integer
	 * @return
	 */

	public void setEuskera(Integer euskera) {
		this.euskera = euskera;
	}

	/**
	 * Method 'getFrances'.
	 *
	 * @return Integer
	 */

	public Integer getFrances() {
		return this.frances;
	}

	/**
	 * Method 'setFrances'.
	 *
	 * @param frances
	 *            Integer
	 * @return
	 */

	public void setFrances(Integer frances) {
		this.frances = frances;
	}

	/**
	 * Method 'getIngles'.
	 *
	 * @return Integer
	 */

	public Integer getIngles() {
		return this.ingles;
	}

	/**
	 * Method 'setIngles'.
	 *
	 * @param ingles
	 *            Integer
	 * @return
	 */

	public void setIngles(Integer ingles) {
		this.ingles = ingles;
	}

	/**
	 * Method 'getItaliano'.
	 *
	 * @return Integer
	 */

	public Integer getItaliano() {
		return this.italiano;
	}

	/**
	 * Method 'setItaliano'.
	 *
	 * @param italiano
	 *            Integer
	 * @return
	 */

	public void setItaliano(Integer italiano) {
		this.italiano = italiano;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getOtrosTituloses'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<OtrosTitulos> getOtrosTituloses() {
		return this.otrosTituloses;
	}

	/**
	 * Method 'setOtrosTituloses'.
	 *
	 * @param otrosTituloses
	 *            List
	 * @return
	 */
	public void setOtrosTituloses(List<OtrosTitulos> otrosTituloses) {
		this.otrosTituloses = otrosTituloses;
	}

	/**
	 * Method 'getExperienciaLaborals'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<ExperienciaLaboral> getExperienciaLaborals() {
		return this.experienciaLaborals;
	}

	/**
	 * Method 'setExperienciaLaborals'.
	 *
	 * @param experienciaLaborals
	 *            List
	 * @return
	 */
	public void setExperienciaLaborals(List<ExperienciaLaboral> experienciaLaborals) {
		this.experienciaLaborals = experienciaLaborals;
	}

	/**
	 * @return the puntuaciones
	 */
	public Puntuaciones getPuntuaciones() {
		return puntuaciones;
	}

	/**
	 * @param puntuaciones
	 *            the puntuaciones to set
	 */
	public void setPuntuaciones(Puntuaciones puntuaciones) {
		this.puntuaciones = puntuaciones;
	}

	/**
	 * @return the criterios
	 */
	public Integer[] getCriterios() {
		return criterios;
	}

	/**
	 * @param criterios
	 *            the criterios to set
	 */
	public void setCriterios(Integer[] criterios) {
		this.criterios = criterios;
	}

	/**
	 * @return the bandera
	 */
	public Integer getBandera() {
		return bandera;
	}

	/**
	 * @param bandera
	 *            the bandera to set
	 */
	public void setBandera(Integer bandera) {
		this.bandera = bandera;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "Curriculum [idCurriculum=" + idCurriculum + ", tiposCertificacionByIdCertificacionIngles="
				+ tiposCertificacionByIdCertificacionIngles + ", tiposCertificacionByIdCertificacionFrances="
				+ tiposCertificacionByIdCertificacionFrances + ", tiposCertificacionByIdCertificacionItaliano="
				+ tiposCertificacionByIdCertificacionItaliano + ", tiposCertificacionByIdCertificacionEuskera="
				+ tiposCertificacionByIdCertificacionEuskera + ", idExpediente=" + idExpediente + ", titulacion="
				+ titulacion + ", anyoInicio=" + anyoInicio + ", anyoFin=" + anyoFin + ", matriculasHonor="
				+ matriculasHonor + ", sobresalientes=" + sobresalientes + ", notables=" + notables + ", suficientes="
				+ suficientes + ", euskera=" + euskera + ", frances=" + frances + ", ingles=" + ingles + ", italiano="
				+ italiano + ", fechaRegistro=" + fechaRegistro + ", usuarioRegistro=" + usuarioRegistro
				+ ", fechaUltmodificacion=" + fechaUltmodificacion + ", usuarioUltmodificacion="
				+ usuarioUltmodificacion + ", otrosTituloses=" + otrosTituloses + ", experienciaLaborals="
				+ experienciaLaborals + ", puntuaciones=" + puntuaciones + ", criterios=" + Arrays.toString(criterios)
				+ ", bandera=" + bandera + "]";
	}

}
