package com.ejie.ab60.model.BEC;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.Date;

/**
 * ExperienciaLaboral  
 * 
 *  
 */

public class ExperienciaLaboral implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idExperienciaLaboral;
	private Integer idCurriculum;
	private Curriculum curriculum;
	private String empresa;
	private String puesto;
	private Long numeroDias;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private Integer valorar;
	private Integer comercio;

	/**
	 * Method 'ExperienciaLaboral'.
	 */
	public ExperienciaLaboral() {
	}

	/**
	 * Method 'ExperienciaLaboral'.
	 * 
	 * @param idExperienciaLaboral
	 *            Integer
	 */
	public ExperienciaLaboral(Integer idExperienciaLaboral) {
		this.idExperienciaLaboral = idExperienciaLaboral;
	}

	/**
	 * Method 'ExperienciaLaboral'.
	 * 
	 * @param idExperienciaLaboral
	 *            Integer
	 * @param empresa
	 *            String
	 * @param puesto
	 *            String
	 * @param numeroDias
	 *            Long
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param valorar
	 *            Integer
	 * @param comercio
	 *            Integer
	 * @param curriculum
	 *            Curriculum
	 */
	public ExperienciaLaboral(Integer idExperienciaLaboral, String empresa, String puesto, Long numeroDias,
			Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion,
			Integer valorar, Integer comercio, Integer idCurriculum) {

		this.idExperienciaLaboral = idExperienciaLaboral;
		this.idCurriculum = idCurriculum;
		this.empresa = empresa;
		this.puesto = puesto;
		this.numeroDias = numeroDias;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.valorar = valorar;
		this.comercio = comercio;
	}

	/**
	 * Method 'getIdExperienciaLaboral'.
	 *
	 * @return Integer
	 */

	public Integer getIdExperienciaLaboral() {
		return this.idExperienciaLaboral;
	}

	/**
	 * Method 'setIdExperienciaLaboral'.
	 *
	 * @param idExperienciaLaboral
	 *            Integer
	 * @return
	 */

	public void setIdExperienciaLaboral(Integer idExperienciaLaboral) {
		this.idExperienciaLaboral = idExperienciaLaboral;
	}

	/**
	 * @return the idCurriculum
	 */
	public Integer getIdCurriculum() {
		return idCurriculum;
	}

	/**
	 * @param idCurriculum
	 *            the idCurriculum to set
	 */
	public void setIdCurriculum(Integer idCurriculum) {
		this.idCurriculum = idCurriculum;
	}

	/**
	 * Method 'getEmpresa'.
	 *
	 * @return String
	 */

	public String getEmpresa() {
		return this.empresa;
	}

	/**
	 * Method 'setEmpresa'.
	 *
	 * @param empresa
	 *            String
	 * @return
	 */

	public void setEmpresa(String empresa) {
		this.empresa = empresa;
	}

	/**
	 * Method 'getPuesto'.
	 *
	 * @return String
	 */

	public String getPuesto() {
		return this.puesto;
	}

	/**
	 * Method 'setPuesto'.
	 *
	 * @param puesto
	 *            String
	 * @return
	 */

	public void setPuesto(String puesto) {
		this.puesto = puesto;
	}

	/**
	 * Method 'getNumeroDias'.
	 *
	 * @return Long
	 */

	public Long getNumeroDias() {
		return this.numeroDias;
	}

	/**
	 * Method 'setNumeroDias'.
	 *
	 * @param numeroDias
	 *            Long
	 * @return
	 */

	public void setNumeroDias(Long numeroDias) {
		this.numeroDias = numeroDias;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getValorar'.
	 *
	 * @return Integer
	 */

	public Integer getValorar() {
		return this.valorar;
	}

	/**
	 * Method 'setValorar'.
	 *
	 * @param valorar
	 *            Integer
	 * @return
	 */

	public void setValorar(Integer valorar) {
		this.valorar = valorar;
	}

	/**
	 * Method 'getComercio'.
	 *
	 * @return Integer
	 */

	public Integer getComercio() {
		return this.comercio;
	}

	/**
	 * Method 'setComercio'.
	 *
	 * @param comercio
	 *            Integer
	 * @return
	 */

	public void setComercio(Integer comercio) {
		this.comercio = comercio;
	}

	/**
	 * @return the curriculum
	 */
	public Curriculum getCurriculum() {
		return curriculum;
	}

	/**
	 * @param curriculum the curriculum to set
	 */
	public void setCurriculum(Curriculum curriculum) {
		this.curriculum = curriculum;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idExperienciaLaboral: ").append(this.idExperienciaLaboral).append(" ]");
		result.append(", [ empresa: ").append(this.empresa).append(" ]");
		result.append(", [ puesto: ").append(this.puesto).append(" ]");
		result.append(", [ numeroDias: ").append(this.numeroDias).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append(", [ valorar: ").append(this.valorar).append(" ]");
		result.append(", [ comercio: ").append(this.comercio).append(" ]");
		result.append("}");
		return result.toString();
	}

}
