package com.ejie.ab60.model.BEC;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.Date;

/**
 * OtrosTitulos  
 * 
 *  
 */

public class OtrosTitulos implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idTituloCurso;
	private Caracteristicas caracteristicas;
	private Integer idCurriculum;
	private Curriculum curriculum;
	private String tituloCurso;
	private String entidad;
	private Long horas;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private Integer valorar;

	/**
	 * Method 'OtrosTitulos'.
	 */
	public OtrosTitulos() {
	}

	/**
	 * Method 'OtrosTitulos'.
	 * 
	 * @param idTituloCurso
	 *            Integer
	 */
	public OtrosTitulos(Integer idTituloCurso) {
		this.idTituloCurso = idTituloCurso;
	}

	/**
	 * Method 'OtrosTitulos'.
	 * 
	 * @param idTituloCurso
	 *            Integer
	 * @param tituloCurso
	 *            String
	 * @param entidad
	 *            String
	 * @param horas
	 *            Long
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param valorar
	 *            Integer
	 * @param caracteristicas
	 *            Caracteristicas
	 * @param curriculum
	 *            Curriculum
	 */
	public OtrosTitulos(Integer idTituloCurso, String tituloCurso, String entidad, Long horas, Date fechaRegistro,
			String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion, Integer valorar,
			Caracteristicas caracteristicas, Integer idCurriculum) {

		this.idTituloCurso = idTituloCurso;
		this.caracteristicas = caracteristicas;
		this.idCurriculum = idCurriculum;
		this.tituloCurso = tituloCurso;
		this.entidad = entidad;
		this.horas = horas;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.valorar = valorar;
	}

	/**
	 * Method 'getIdTituloCurso'.
	 *
	 * @return Integer
	 */

	public Integer getIdTituloCurso() {
		return this.idTituloCurso;
	}

	/**
	 * Method 'setIdTituloCurso'.
	 *
	 * @param idTituloCurso
	 *            Integer
	 * @return
	 */

	public void setIdTituloCurso(Integer idTituloCurso) {
		this.idTituloCurso = idTituloCurso;
	}

	/**
	 * Method 'getCaracteristicas'.
	 *
	 * @return Caracteristicas
	 */

	public Caracteristicas getCaracteristicas() {
		return this.caracteristicas;
	}

	/**
	 * Method 'setCaracteristicas'.
	 *
	 * @param caracteristicas
	 *            Caracteristicas
	 * @return
	 */

	public void setCaracteristicas(Caracteristicas caracteristicas) {
		this.caracteristicas = caracteristicas;
	}

	/**
	 * Method 'getCurriculum'.
	 *
	 * @return Curriculum
	 */

	/**
	 * Method 'getTituloCurso'.
	 *
	 * @return String
	 */

	public String getTituloCurso() {
		return this.tituloCurso;
	}

	/**
	 * @return the idCurriculum
	 */
	public Integer getIdCurriculum() {
		return idCurriculum;
	}

	/**
	 * @param idCurriculum
	 *            the idCurriculum to set
	 */
	public void setIdCurriculum(Integer idCurriculum) {
		this.idCurriculum = idCurriculum;
	}

	/**
	 * Method 'setTituloCurso'.
	 *
	 * @param tituloCurso
	 *            String
	 * @return
	 */

	public void setTituloCurso(String tituloCurso) {
		this.tituloCurso = tituloCurso;
	}

	/**
	 * Method 'getEntidad'.
	 *
	 * @return String
	 */

	public String getEntidad() {
		return this.entidad;
	}

	/**
	 * Method 'setEntidad'.
	 *
	 * @param entidad
	 *            String
	 * @return
	 */

	public void setEntidad(String entidad) {
		this.entidad = entidad;
	}

	/**
	 * Method 'getHoras'.
	 *
	 * @return Long
	 */

	public Long getHoras() {
		return this.horas;
	}

	/**
	 * Method 'setHoras'.
	 *
	 * @param horas
	 *            Long
	 * @return
	 */

	public void setHoras(Long horas) {
		this.horas = horas;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getValorar'.
	 *
	 * @return Integer
	 */

	public Integer getValorar() {
		return this.valorar;
	}

	/**
	 * Method 'setValorar'.
	 *
	 * @param valorar
	 *            Integer
	 * @return
	 */

	public void setValorar(Integer valorar) {
		this.valorar = valorar;
	}

	/**
	 * @return the curriculum
	 */
	public Curriculum getCurriculum() {
		return curriculum;
	}

	/**
	 * @param curriculum the curriculum to set
	 */
	public void setCurriculum(Curriculum curriculum) {
		this.curriculum = curriculum;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idTituloCurso: ").append(this.idTituloCurso).append(" ]");
		result.append(", [ tituloCurso: ").append(this.tituloCurso).append(" ]");
		result.append(", [ entidad: ").append(this.entidad).append(" ]");
		result.append(", [ horas: ").append(this.horas).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append(", [ valorar: ").append(this.valorar).append(" ]");
		result.append("}");
		return result.toString();
	}

}
