package com.ejie.ab60.model.BEC;

import com.ejie.ab60.model.estudioTecnico.MotivosDesestimacion;
import com.ejie.ab60.model.estudioTecnico.TiposResultado;
import com.ejie.ab60.model.expedientes.Expedientes;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.math.BigDecimal;
import java.util.Date;

/**
 * Puntuaciones  
 * 
 *  
 */

public class Puntuaciones implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idPuntuacion;
	private Integer idExpediente;
	private Expedientes expedientes;
	private BigDecimal puntuacionExpAca;
	private BigDecimal puntuacionIdiomas;
	private BigDecimal puntuacionForCom;
	private BigDecimal puntuacionExpLab;
	private BigDecimal puntuacionTotCv;
	private String observacionesCv;
	private BigDecimal notaConocimientos;
	private BigDecimal puntuacionTotCon;
	private String observacionesCon;
	private BigDecimal notaCurso;
	private BigDecimal puntuacionTotCurso;
	private String observacionesCurso;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private Integer requisitoTitulacion;
	private Integer requisitoEuskera;
	private Integer requisitoEdad;
	private String requisitos;

	private String observacionesResolucion;
	private Fases fases;
	private TiposResultado tiposResultado;
	private MotivosDesestimacion motivosDesestimacion;
	private String empresa;
	private String dotacion;

	/**
	 * Method 'Puntuaciones'.
	 */
	public Puntuaciones() {
	}

	/**
	 * Method 'Puntuaciones'.
	 * 
	 * @param idPuntuacion
	 *            Integer
	 */
	public Puntuaciones(Integer idPuntuacion) {
		this.idPuntuacion = idPuntuacion;
	}

	/**
	 * Method 'Puntuaciones'.
	 * 
	 * @param idPuntuacion
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param puntuacionExpAca
	 *            BigDecimal
	 * @param puntuacionIdiomas
	 *            BigDecimal
	 * @param puntuacionForCom
	 *            BigDecimal
	 * @param puntuacionExpLab
	 *            BigDecimal
	 * @param puntuacionTotCv
	 *            BigDecimal
	 * @param observacionesCv
	 *            String
	 * @param notaConocimientos
	 *            BigDecimal
	 * @param puntuacionTotCon
	 *            BigDecimal
	 * @param observacionesCon
	 *            String
	 * @param notaCurso
	 *            BigDecimal
	 * @param puntuacionTotCurso
	 *            BigDecimal
	 * @param observacionesCurso
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 */
	public Puntuaciones(Integer idPuntuacion, Integer idExpediente, BigDecimal puntuacionExpAca,
			BigDecimal puntuacionIdiomas, BigDecimal puntuacionForCom, BigDecimal puntuacionExpLab,
			BigDecimal puntuacionTotCv, String observacionesCv, BigDecimal notaConocimientos,
			BigDecimal puntuacionTotCon, String observacionesCon, BigDecimal notaCurso, BigDecimal puntuacionTotCurso,
			String observacionesCurso, Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion,
			String usuarioUltmodificacion) {

		this.idPuntuacion = idPuntuacion;
		this.idExpediente = idExpediente;
		this.puntuacionExpAca = puntuacionExpAca;
		this.puntuacionIdiomas = puntuacionIdiomas;
		this.puntuacionForCom = puntuacionForCom;
		this.puntuacionExpLab = puntuacionExpLab;
		this.puntuacionTotCv = puntuacionTotCv;
		this.observacionesCv = observacionesCv;
		this.notaConocimientos = notaConocimientos;
		this.puntuacionTotCon = puntuacionTotCon;
		this.observacionesCon = observacionesCon;
		this.notaCurso = notaCurso;
		this.puntuacionTotCurso = puntuacionTotCurso;
		this.observacionesCurso = observacionesCurso;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'Puntuaciones'.
	 * 
	 * @param idPuntuacion
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param requisitoTitulacion
	 *            Integer
	 * @param requisitoEuskera
	 *            Integer
	 * @param requisitoEdad
	 *            Integer
	 */
	public Puntuaciones(Integer idPuntuacion, Integer idExpediente, Integer requisitoTitulacion,
			Integer requisitoEuskera, Integer requisitoEdad) {

		this.idPuntuacion = idPuntuacion;
		this.idExpediente = idExpediente;
		this.requisitoTitulacion = requisitoTitulacion;
		this.requisitoEuskera = requisitoEuskera;
		this.requisitoEdad = requisitoEdad;
	}

	/**
	 * Method 'getIdPuntuacion'.
	 *
	 * @return Integer
	 */

	public Integer getIdPuntuacion() {
		return this.idPuntuacion;
	}

	/**
	 * Method 'setIdPuntuacion'.
	 *
	 * @param idPuntuacion
	 *            Integer
	 * @return
	 */

	public void setIdPuntuacion(Integer idPuntuacion) {
		this.idPuntuacion = idPuntuacion;
	}

	/**
	 * Method 'getIdExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdExpediente() {
		return this.idExpediente;
	}

	/**
	 * Method 'setIdExpediente'.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return
	 */

	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'getPuntuacionExpAca'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getPuntuacionExpAca() {
		return this.puntuacionExpAca;
	}

	/**
	 * Method 'setPuntuacionExpAca'.
	 *
	 * @param puntuacionExpAca
	 *            BigDecimal
	 * @return
	 */

	public void setPuntuacionExpAca(BigDecimal puntuacionExpAca) {
		this.puntuacionExpAca = puntuacionExpAca;
	}

	/**
	 * Method 'getPuntuacionIdiomas'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getPuntuacionIdiomas() {
		return this.puntuacionIdiomas;
	}

	/**
	 * Method 'setPuntuacionIdiomas'.
	 *
	 * @param puntuacionIdiomas
	 *            BigDecimal
	 * @return
	 */

	public void setPuntuacionIdiomas(BigDecimal puntuacionIdiomas) {
		this.puntuacionIdiomas = puntuacionIdiomas;
	}

	/**
	 * Method 'getPuntuacionForCom'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getPuntuacionForCom() {
		return this.puntuacionForCom;
	}

	/**
	 * Method 'setPuntuacionForCom'.
	 *
	 * @param puntuacionForCom
	 *            BigDecimal
	 * @return
	 */

	public void setPuntuacionForCom(BigDecimal puntuacionForCom) {
		this.puntuacionForCom = puntuacionForCom;
	}

	/**
	 * Method 'getPuntuacionExpLab'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getPuntuacionExpLab() {
		return this.puntuacionExpLab;
	}

	/**
	 * Method 'setPuntuacionExpLab'.
	 *
	 * @param puntuacionExpLab
	 *            BigDecimal
	 * @return
	 */

	public void setPuntuacionExpLab(BigDecimal puntuacionExpLab) {
		this.puntuacionExpLab = puntuacionExpLab;
	}

	/**
	 * Method 'getPuntuacionTotCv'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getPuntuacionTotCv() {
		return this.puntuacionTotCv;
	}

	/**
	 * Method 'setPuntuacionTotCv'.
	 *
	 * @param puntuacionTotCv
	 *            BigDecimal
	 * @return
	 */

	public void setPuntuacionTotCv(BigDecimal puntuacionTotCv) {
		this.puntuacionTotCv = puntuacionTotCv;
	}

	/**
	 * Method 'getObservacionesCv'.
	 *
	 * @return String
	 */

	public String getObservacionesCv() {
		return this.observacionesCv;
	}

	/**
	 * Method 'setObservacionesCv'.
	 *
	 * @param observacionesCv
	 *            String
	 * @return
	 */

	public void setObservacionesCv(String observacionesCv) {
		this.observacionesCv = observacionesCv;
	}

	/**
	 * Method 'getNotaConocimientos'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getNotaConocimientos() {
		return this.notaConocimientos;
	}

	/**
	 * Method 'setNotaConocimientos'.
	 *
	 * @param notaConocimientos
	 *            BigDecimal
	 * @return
	 */

	public void setNotaConocimientos(BigDecimal notaConocimientos) {
		this.notaConocimientos = notaConocimientos;
	}

	/**
	 * Method 'getPuntuacionTotCon'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getPuntuacionTotCon() {
		return this.puntuacionTotCon;
	}

	/**
	 * Method 'setPuntuacionTotCon'.
	 *
	 * @param puntuacionTotCon
	 *            BigDecimal
	 * @return
	 */

	public void setPuntuacionTotCon(BigDecimal puntuacionTotCon) {
		this.puntuacionTotCon = puntuacionTotCon;
	}

	/**
	 * Method 'getObservacionesCon'.
	 *
	 * @return String
	 */

	public String getObservacionesCon() {
		return this.observacionesCon;
	}

	/**
	 * Method 'setObservacionesCon'.
	 *
	 * @param observacionesCon
	 *            String
	 * @return
	 */

	public void setObservacionesCon(String observacionesCon) {
		this.observacionesCon = observacionesCon;
	}

	/**
	 * Method 'getNotaCurso'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getNotaCurso() {
		return this.notaCurso;
	}

	/**
	 * Method 'setNotaCurso'.
	 *
	 * @param notaCurso
	 *            BigDecimal
	 * @return
	 */

	public void setNotaCurso(BigDecimal notaCurso) {
		this.notaCurso = notaCurso;
	}

	/**
	 * Method 'getPuntuacionTotCurso'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getPuntuacionTotCurso() {
		return this.puntuacionTotCurso;
	}

	/**
	 * Method 'setPuntuacionTotCurso'.
	 *
	 * @param puntuacionTotCurso
	 *            BigDecimal
	 * @return
	 */

	public void setPuntuacionTotCurso(BigDecimal puntuacionTotCurso) {
		this.puntuacionTotCurso = puntuacionTotCurso;
	}

	/**
	 * Method 'getObservacionesCurso'.
	 *
	 * @return String
	 */

	public String getObservacionesCurso() {
		return this.observacionesCurso;
	}

	/**
	 * Method 'setObservacionesCurso'.
	 *
	 * @param observacionesCurso
	 *            String
	 * @return
	 */

	public void setObservacionesCurso(String observacionesCurso) {
		this.observacionesCurso = observacionesCurso;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * @return the requisitos
	 */
	public String getRequisitos() {
		return requisitos;
	}

	/**
	 * @param requisitos
	 *            the requisitos to set
	 */
	public void setRequisitos(String requisitos) {
		this.requisitos = requisitos;
	}

	/**
	 * @return the requisitoTitulacion
	 */
	public Integer getRequisitoTitulacion() {
		return requisitoTitulacion;
	}

	/**
	 * @param requisitoTitulacion
	 *            the requisitoTitulacion to set
	 */
	public void setRequisitoTitulacion(Integer requisitoTitulacion) {
		this.requisitoTitulacion = requisitoTitulacion;
	}

	/**
	 * @return the requisitoEuskera
	 */
	public Integer getRequisitoEuskera() {
		return requisitoEuskera;
	}

	/**
	 * @param requisitoEuskera
	 *            the requisitoEuskera to set
	 */
	public void setRequisitoEuskera(Integer requisitoEuskera) {
		this.requisitoEuskera = requisitoEuskera;
	}

	/**
	 * @return the requisitoEdad
	 */
	public Integer getRequisitoEdad() {
		return requisitoEdad;
	}

	/**
	 * @param requisitoEdad
	 *            the requisitoEdad to set
	 */
	public void setRequisitoEdad(Integer requisitoEdad) {
		this.requisitoEdad = requisitoEdad;
	}

	/**
	 * @return the observacionesResolucion
	 */
	public String getObservacionesResolucion() {
		return observacionesResolucion;
	}

	/**
	 * @param observacionesResolucion
	 *            the observacionesResolucion to set
	 */
	public void setObservacionesResolucion(String observacionesResolucion) {
		this.observacionesResolucion = observacionesResolucion;
	}

	/**
	 * @return the fases
	 */
	public Fases getFases() {
		return fases;
	}

	/**
	 * @param fases
	 *            the fases to set
	 */
	public void setFases(Fases fases) {
		this.fases = fases;
	}

	/**
	 * @return the tiposResultado
	 */
	public TiposResultado getTiposResultado() {
		return tiposResultado;
	}

	/**
	 * @param tiposResultado
	 *            the tiposResultado to set
	 */
	public void setTiposResultado(TiposResultado tiposResultado) {
		this.tiposResultado = tiposResultado;
	}

	/**
	 * @return the motivosDesestimacion
	 */
	public MotivosDesestimacion getMotivosDesestimacion() {
		return motivosDesestimacion;
	}

	/**
	 * @param motivosDesestimacion
	 *            the motivosDesestimacion to set
	 */
	public void setMotivosDesestimacion(MotivosDesestimacion motivosDesestimacion) {
		this.motivosDesestimacion = motivosDesestimacion;
	}

	/**
	 * @return the empresa
	 */
	public String getEmpresa() {
		return empresa;
	}

	/**
	 * @param empresa
	 *            the empresa to set
	 */
	public void setEmpresa(String empresa) {
		this.empresa = empresa;
	}

	/**
	 * @return the dotacion
	 */
	public String getDotacion() {
		return dotacion;
	}

	/**
	 * @param dotacion
	 *            the dotacion to set
	 */
	public void setDotacion(String dotacion) {
		this.dotacion = dotacion;
	}

	/**
	 * @return the expedientes
	 */
	public Expedientes getExpedientes() {
		return expedientes;
	}

	/**
	 * @param expedientes
	 *            the expedientes to set
	 */
	public void setExpedientes(Expedientes expedientes) {
		this.expedientes = expedientes;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "Puntuaciones [idPuntuacion=" + idPuntuacion + ", idExpediente=" + idExpediente + ", expedientes="
				+ expedientes + ", puntuacionExpAca=" + puntuacionExpAca + ", puntuacionIdiomas=" + puntuacionIdiomas
				+ ", puntuacionForCom=" + puntuacionForCom + ", puntuacionExpLab=" + puntuacionExpLab
				+ ", puntuacionTotCv=" + puntuacionTotCv + ", observacionesCv=" + observacionesCv
				+ ", notaConocimientos=" + notaConocimientos + ", puntuacionTotCon=" + puntuacionTotCon
				+ ", observacionesCon=" + observacionesCon + ", notaCurso=" + notaCurso + ", puntuacionTotCurso="
				+ puntuacionTotCurso + ", observacionesCurso=" + observacionesCurso + ", fechaRegistro=" + fechaRegistro
				+ ", usuarioRegistro=" + usuarioRegistro + ", fechaUltmodificacion=" + fechaUltmodificacion
				+ ", usuarioUltmodificacion=" + usuarioUltmodificacion + ", requisitoTitulacion=" + requisitoTitulacion
				+ ", requisitoEuskera=" + requisitoEuskera + ", requisitoEdad=" + requisitoEdad + ", requisitos="
				+ requisitos + ", observacionesResolucion=" + observacionesResolucion + ", fases=" + fases
				+ ", tiposResultado=" + tiposResultado + ", motivosDesestimacion=" + motivosDesestimacion + ", empresa="
				+ empresa + ", dotacion=" + dotacion + "]";
	}

}
