package com.ejie.ab60.model.BEC;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * TiposCertificacion  
 * 
 *  
 */

public class TiposCertificacion implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idTipoCertificacion;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<Curriculum> curriculumsForIdCertificacionIngles = new ArrayList<Curriculum>();
	private List<Curriculum> curriculumsForIdCertificacionItaliano = new ArrayList<Curriculum>();
	private List<Curriculum> curriculumsForIdCertificacionEuskera = new ArrayList<Curriculum>();
	private List<Curriculum> curriculumsForIdCertificacionFrances = new ArrayList<Curriculum>();
	private Integer idConvocatoria;

	/**
	 * Method 'TiposCertificacion'.
	 */
	public TiposCertificacion() {
	}

	/**
	 * Method 'TiposCertificacion'.
	 * 
	 * @param idTipoCertificacion
	 *            Long
	 */
	public TiposCertificacion(Long idTipoCertificacion) {
		this.idTipoCertificacion = idTipoCertificacion;
	}

	/**
	 * Method 'TiposCertificacion'.
	 * 
	 * @param idTipoCertificacion
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public TiposCertificacion(Long idTipoCertificacion, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro) {
		this.idTipoCertificacion = idTipoCertificacion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'TiposCertificacion'.
	 * 
	 * @param idTipoCertificacion
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param curriculumsForIdCertificacionIngles
	 *            List<Curriculum>
	 * @param curriculumsForIdCertificacionItaliano
	 *            List<Curriculum>
	 * @param curriculumsForIdCertificacionEuskera
	 *            List<Curriculum>
	 * @param curriculumsForIdCertificacionFrances
	 *            List<Curriculum>
	 */
	public TiposCertificacion(Long idTipoCertificacion, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro, List<Curriculum> curriculumsForIdCertificacionIngles,
			List<Curriculum> curriculumsForIdCertificacionItaliano,
			List<Curriculum> curriculumsForIdCertificacionEuskera,
			List<Curriculum> curriculumsForIdCertificacionFrances) {

		this.idTipoCertificacion = idTipoCertificacion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.curriculumsForIdCertificacionIngles = curriculumsForIdCertificacionIngles;
		this.curriculumsForIdCertificacionItaliano = curriculumsForIdCertificacionItaliano;
		this.curriculumsForIdCertificacionEuskera = curriculumsForIdCertificacionEuskera;
		this.curriculumsForIdCertificacionFrances = curriculumsForIdCertificacionFrances;
	}

	/**
	 * Method 'getIdTipoCertificacion'.
	 *
	 * @return Long
	 */

	public Long getIdTipoCertificacion() {
		return this.idTipoCertificacion;
	}

	/**
	 * Method 'setIdTipoCertificacion'.
	 *
	 * @param idTipoCertificacion
	 *            Long
	 * @return
	 */

	public void setIdTipoCertificacion(Long idTipoCertificacion) {
		this.idTipoCertificacion = idTipoCertificacion;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getCurriculumsForIdCertificacionIngles'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<Curriculum> getCurriculumsForIdCertificacionIngles() {
		return this.curriculumsForIdCertificacionIngles;
	}

	/**
	 * Method 'setCurriculumsForIdCertificacionIngles'.
	 *
	 * @param curriculumsForIdCertificacionIngles
	 *            List
	 * @return
	 */
	public void setCurriculumsForIdCertificacionIngles(List<Curriculum> curriculumsForIdCertificacionIngles) {
		this.curriculumsForIdCertificacionIngles = curriculumsForIdCertificacionIngles;
	}

	/**
	 * Method 'getCurriculumsForIdCertificacionItaliano'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<Curriculum> getCurriculumsForIdCertificacionItaliano() {
		return this.curriculumsForIdCertificacionItaliano;
	}

	/**
	 * Method 'setCurriculumsForIdCertificacionItaliano'.
	 *
	 * @param curriculumsForIdCertificacionItaliano
	 *            List
	 * @return
	 */
	public void setCurriculumsForIdCertificacionItaliano(List<Curriculum> curriculumsForIdCertificacionItaliano) {
		this.curriculumsForIdCertificacionItaliano = curriculumsForIdCertificacionItaliano;
	}

	/**
	 * Method 'getCurriculumsForIdCertificacionEuskera'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<Curriculum> getCurriculumsForIdCertificacionEuskera() {
		return this.curriculumsForIdCertificacionEuskera;
	}

	/**
	 * Method 'setCurriculumsForIdCertificacionEuskera'.
	 *
	 * @param curriculumsForIdCertificacionEuskera
	 *            List
	 * @return
	 */
	public void setCurriculumsForIdCertificacionEuskera(List<Curriculum> curriculumsForIdCertificacionEuskera) {
		this.curriculumsForIdCertificacionEuskera = curriculumsForIdCertificacionEuskera;
	}

	/**
	 * Method 'getCurriculumsForIdCertificacionFrances'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<Curriculum> getCurriculumsForIdCertificacionFrances() {
		return this.curriculumsForIdCertificacionFrances;
	}

	/**
	 * Method 'setCurriculumsForIdCertificacionFrances'.
	 *
	 * @param curriculumsForIdCertificacionFrances
	 *            List
	 * @return
	 */
	public void setCurriculumsForIdCertificacionFrances(List<Curriculum> curriculumsForIdCertificacionFrances) {
		this.curriculumsForIdCertificacionFrances = curriculumsForIdCertificacionFrances;
	}

	/**
	 * @return the idConvocatoria
	 */
	public Integer getIdConvocatoria() {
		return idConvocatoria;
	}

	/**
	 * @param idConvocatoria
	 *            the idConvocatoria to set
	 */
	public void setIdConvocatoria(Integer idConvocatoria) {
		this.idConvocatoria = idConvocatoria;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idTipoCertificacion: ").append(this.idTipoCertificacion).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ idConvocatoria: ").append(this.idConvocatoria).append(" ]");
		result.append("}");
		return result.toString();
	}

}
