package com.ejie.ab60.model.CTP;

import java.util.Date;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Proyectos  
 * 
 *  
 */

public class Proyectos implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private String idProyecto;
	private Solicitantes solicitantes;

	private AsociacionesSectoriales asociacionesSectoriales;
	private Integer idExpediente;
	private String denominacion;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;

	/**
	 * Method 'Proyectos'.
	 */
	public Proyectos() {
	}

	/**
	 * Method 'Proyectos'.
	 * 
	 * @param idProyecto
	 *            String
	 */
	public Proyectos(String idProyecto) {
		this.idProyecto = idProyecto;
	}

	/**
	 * Method 'Proyectos'.
	 * 
	 * @param idProyecto
	 *            String
	 * @param idExpediente
	 *            Integer
	 * @param denominacion
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param solicitantes
	 *            Solicitantes
	 * @param asociacionesSectoriales
	 *            AsociacionesSectoriales
	 */
	public Proyectos(String idProyecto, Integer idExpediente, String denominacion, Date fechaRegistro,
			String usuarioRegistro, Solicitantes solicitantes, AsociacionesSectoriales asociacionesSectoriales) {

		this.idProyecto = idProyecto;
		this.solicitantes = solicitantes;
		this.asociacionesSectoriales = asociacionesSectoriales;
		this.idExpediente = idExpediente;
		this.denominacion = denominacion;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * @param solicitantes
	 *            Solicitantes
	 *
	 */
	public Proyectos(Solicitantes solicitantes, AsociacionesSectoriales asociacionesSectoriales) {

		this.solicitantes = solicitantes;
		this.asociacionesSectoriales = asociacionesSectoriales;

	}

	/**
	 * Method 'getIdProyecto'.
	 *
	 * @return String
	 */

	public String getIdProyecto() {
		return this.idProyecto;
	}

	/**
	 * Method 'setIdProyecto'.
	 *
	 * @param idProyecto
	 *            String
	 * @return
	 */

	public void setIdProyecto(String idProyecto) {
		this.idProyecto = idProyecto;
	}

	/**
	 * Method 'getSolicitantes'.
	 *
	 * @return Solicitantes
	 */
	public Solicitantes getSolicitantes() {
		return this.solicitantes;
	}

	/**
	 * Method 'setSolicitantes'.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 * @return
	 */

	public void setSolicitantes(Solicitantes solicitantes) {
		this.solicitantes = solicitantes;
	}

	/**
	 * Method 'getAsociacionesSectoriales'.
	 *
	 * @return AsociacionesSectoriales
	 */

	public AsociacionesSectoriales getAsociacionesSectoriales() {
		return this.asociacionesSectoriales;
	}

	/**
	 * Method 'setAsociacionesSectoriales'.
	 *
	 * @param asociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @return
	 */

	public void setAsociacionesSectoriales(AsociacionesSectoriales asociacionesSectoriales) {
		this.asociacionesSectoriales = asociacionesSectoriales;
	}

	/**
	 * Method 'getIdExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdExpediente() {
		return this.idExpediente;
	}

	/**
	 * Method 'setIdExpediente'.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return
	 */

	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'getDenominacion'.
	 *
	 * @return String
	 */

	public String getDenominacion() {
		return this.denominacion;
	}

	/**
	 * Method 'setDenominacion'.
	 *
	 * @param denominacion
	 *            String
	 * @return
	 */

	public void setDenominacion(String denominacion) {
		this.denominacion = denominacion;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idProyecto: ").append(this.idProyecto).append(" ]");
		result.append(", [ idExpediente: ").append(this.idExpediente).append(" ]");
		result.append(", [ denominacion: ").append(this.denominacion).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
