package com.ejie.ab60.model.CTP;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Solicitantes  
 * 
 *  
 */

public class Solicitantes implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idSolicitante;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private BigDecimal limiteEntidad;
	private BigDecimal porcentaje;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<Proyectos> proyectoses = new ArrayList<Proyectos>();

	/**
	 * Method 'Solicitantes'.
	 */
	public Solicitantes() {
	}

	/**
	 * Method 'Solicitantes'.
	 * 
	 * @param idSolicitante
	 *            Long
	 */
	public Solicitantes(Long idSolicitante) {
		this.idSolicitante = idSolicitante;
	}

	/**
	 * Method 'Solicitantes'.
	 * 
	 * @param idSolicitante
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param limiteEntidad
	 *            BigDecimal
	 * @param porcentaje
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public Solicitantes(Long idSolicitante, String descripcionCastellano, String descripcionEuskera,
			BigDecimal limiteEntidad, BigDecimal porcentaje, Date fechaRegistro, String usuarioRegistro) {
		this.idSolicitante = idSolicitante;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.limiteEntidad = limiteEntidad;
		this.porcentaje = porcentaje;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'Solicitantes'.
	 * 
	 * @param idSolicitante
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param limiteEntidad
	 *            BigDecimal
	 * @param porcentaje
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param proyectoses
	 *            List<Proyectos>
	 */
	public Solicitantes(Long idSolicitante, String descripcionCastellano, String descripcionEuskera,
			BigDecimal limiteEntidad, BigDecimal porcentaje, Date fechaRegistro, String usuarioRegistro,
			List<Proyectos> proyectoses) {

		this.idSolicitante = idSolicitante;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.limiteEntidad = limiteEntidad;
		this.porcentaje = porcentaje;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.proyectoses = proyectoses;
	}

	/**
	 * Method 'Solicitantes'.
	 * 
	 * @param idSolicitante
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 */
	public Solicitantes(Long idSolicitante, String descripcionEuskera, String descripcionCastellano) {

		this.idSolicitante = idSolicitante;
		this.descripcionEuskera = descripcionEuskera;
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getIdSolicitante'.
	 *
	 * @return Long
	 */

	public Long getIdSolicitante() {
		return this.idSolicitante;
	}

	/**
	 * Method 'setIdSolicitante'.
	 *
	 * @param idSolicitante
	 *            Long
	 * @return
	 */

	public void setIdSolicitante(Long idSolicitante) {
		this.idSolicitante = idSolicitante;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getLimiteEntidad'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getLimiteEntidad() {
		return this.limiteEntidad;
	}

	/**
	 * Method 'setLimiteEntidad'.
	 *
	 * @param limiteEntidad
	 *            BigDecimal
	 * @return
	 */

	public void setLimiteEntidad(BigDecimal limiteEntidad) {
		this.limiteEntidad = limiteEntidad;
	}

	/**
	 * Method 'getPorcentaje'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getPorcentaje() {
		return this.porcentaje;
	}

	/**
	 * Method 'setPorcentaje'.
	 *
	 * @param porcentaje
	 *            BigDecimal
	 * @return
	 */

	public void setPorcentaje(BigDecimal porcentaje) {
		this.porcentaje = porcentaje;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getProyectoses'.
	 *
	 * @return List
	 */

	public List<Proyectos> getProyectoses() {
		return this.proyectoses;
	}

	/**
	 * Method 'setProyectoses'.
	 *
	 * @param proyectoses
	 *            List
	 * @return
	 */
	public void setProyectoses(List<Proyectos> proyectoses) {
		this.proyectoses = proyectoses;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idSolicitante: ").append(this.idSolicitante).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ limiteEntidad: ").append(this.limiteEntidad).append(" ]");
		result.append(", [ porcentaje: ").append(this.porcentaje).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
