package com.ejie.ab60.model.DEC;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * ActAsociacion  
 * 
 *  
 */

public class ActAsociacion implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idActAsociacion;
	private RelExpActSub relExpActSub;
	private String titulo;
	private Date fechaInicio;
	private Date fechaFin;
	private String descripcion;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;

	private String fechaInicioStr;
	private String fechaFinStr;

	/**
	 * Method 'ActAsociacion'.
	 */
	public ActAsociacion() {
	}

	/**
	 * Method 'ActAsociacion'.
	 * 
	 * @param idActAsociacion
	 *            Integer
	 */
	public ActAsociacion(Integer idActAsociacion) {
		this.idActAsociacion = idActAsociacion;
	}

	/**
	 * Method 'ActAsociacion'.
	 * 
	 * @param idActAsociacion
	 *            Integer
	 * @param titulo
	 *            String
	 * @param fechaInicio
	 *            Date
	 * @param fechaFin
	 *            Date
	 * @param decripcion
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param relExpActSub
	 *            RelExpActSub
	 */
	public ActAsociacion(Integer idActAsociacion, String titulo, Date fechaInicio, Date fechaFin, String descripcion,
			Date fechaRegistro, String usuarioRegistro, RelExpActSub relExpActSub) {
		this.idActAsociacion = idActAsociacion;
		this.relExpActSub = relExpActSub;
		this.titulo = titulo;
		this.fechaInicio = fechaInicio;
		this.fechaFin = fechaFin;
		this.descripcion = descripcion;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	public ActAsociacion(Integer idActAsociacion, RelExpActSub relExpActSub, String titulo, Date fechaInicio,
			Date fechaFin, String descripcion) {
		this.idActAsociacion = idActAsociacion;
		this.relExpActSub = relExpActSub;
		this.titulo = titulo;
		this.fechaInicio = fechaInicio;
		this.fechaFin = fechaFin;
		this.descripcion = descripcion;
	}

	/**
	 * Method 'getIdActAsociacion'.
	 *
	 * @return Integer
	 */

	public Integer getIdActAsociacion() {
		return this.idActAsociacion;
	}

	/**
	 * Method 'setIdActAsociacion'.
	 *
	 * @param idActAsociacion
	 *            Integer
	 * @return
	 */

	public void setIdActAsociacion(Integer idActAsociacion) {
		this.idActAsociacion = idActAsociacion;
	}

	/**
	 * Method 'getRelExpActSub'.
	 *
	 * @return RelExpActSub
	 */

	public RelExpActSub getRelExpActSub() {
		return this.relExpActSub;
	}

	/**
	 * Method 'setRelExpActSub'.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return
	 */

	public void setRelExpActSub(RelExpActSub relExpActSub) {
		this.relExpActSub = relExpActSub;
	}

	/**
	 * Method 'getTitulo'.
	 *
	 * @return String
	 */

	public String getTitulo() {
		return this.titulo;
	}

	/**
	 * Method 'setTitulo'.
	 *
	 * @param titulo
	 *            String
	 * @return
	 */

	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}

	/**
	 * Method 'getFechaInicio'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaInicio() {
		return this.fechaInicio;
	}

	/**
	 * Method 'setFechaInicio'.
	 *
	 * @param fechaInicio
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaInicio(Date fechaInicio) {
		this.fechaInicio = fechaInicio;
	}

	/**
	 * Method 'getFechaFin'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaFin() {
		return this.fechaFin;
	}

	/**
	 * Method 'setFechaFin'.
	 *
	 * @param fechaFin
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaFin(Date fechaFin) {
		this.fechaFin = fechaFin;
	}

	/**
	 * Method 'getDecripcion'.
	 *
	 * @return String
	 */

	public String getDescripcion() {
		return this.descripcion;
	}

	/**
	 * Method 'setDecripcion'.
	 *
	 * @param decripcion
	 *            String
	 * @return
	 */

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * @return the fechaUltmodificacion
	 */
	public Date getFechaUltmodificacion() {
		return fechaUltmodificacion;
	}

	/**
	 * @param fechaUltmodificacion
	 *            the fechaUltmodificacion to set
	 */
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * @return the usuarioUltmodificacion
	 */
	public String getUsuarioUltmodificacion() {
		return usuarioUltmodificacion;
	}

	/**
	 * @param usuarioUltmodificacion
	 *            the usuarioUltmodificacion to set
	 */
	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * @return the fechaInicioStr
	 */
	public String getFechaInicioStr() {
		return fechaInicioStr;
	}

	/**
	 * @param fechaFacturaStr
	 *            the fechaFacturaStr to set
	 */
	public void setFechaInicioStr(String fechaInicioStr) {
		this.fechaInicioStr = fechaInicioStr;
	}

	/**
	 * @return the fechaFacturaStr
	 */
	public String getFechaFinStr() {
		return fechaFinStr;
	}

	/**
	 * @param fechaFacturaStr
	 *            the fechaFacturaStr to set
	 */
	public void setFechaFinStr(String fechaFinStr) {
		this.fechaFinStr = fechaFinStr;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idActAsociacion: ").append(this.idActAsociacion).append(" ]");
		result.append(", [ titulo: ").append(this.titulo).append(" ]");
		result.append(", [ fechaInicio: ").append(this.fechaInicio).append(" ]");
		result.append(", [ fechaFin: ").append(this.fechaFin).append(" ]");
		result.append(", [ descripcion: ").append(this.descripcion).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
