package com.ejie.ab60.model.DEC;

import java.math.BigDecimal;
import java.util.Date;

import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * ActAyuntamiento  
 * 
 *  
 */

public class ActAyuntamiento implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idActAyuntamiento;
	private RelExpActSub relExpActSub;
	private String titulo;
	private BigDecimal presupuestoMaterial;
	private BigDecimal importeIva;
	private BigDecimal importeTotal;
	private Date fechaAdjudicacion;
	private Date fechaInicio;
	private Date fechaFin;
	private BigDecimal importeAdmitido;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltactualizacion;
	private String usuarioUltactualizacion;
	private String observacionesCastellano;
	private String observacionesEuskera;

	private Integer idActsub;
	private Integer inspeccionable;

	private String fechaAdjudicacionStr;
	private String fechaInicioStr;
	private String fechaFinStr;

	private String descripcion;

	/**
	 * @return the idActsub
	 */
	public Integer getIdActsub() {
		return idActsub;
	}

	/**
	 * @param idActsub
	 *            the idActsub to set
	 */
	public void setIdActsub(Integer idActsub) {
		this.idActsub = idActsub;
	}

	/**
	 * Method 'ActAyuntamiento'.
	 */
	public ActAyuntamiento() {
	}

	/**
	 * Method 'ActAyuntamiento'.
	 * 
	 * @param idActAyuntamiento
	 *            Integer
	 */
	public ActAyuntamiento(Integer idActAyuntamiento) {
		this.idActAyuntamiento = idActAyuntamiento;
	}

	/**
	 * Method 'ActAyuntamiento'.
	 * 
	 * @param idActAyuntamiento
	 *            Integer
	 * @param titulo
	 *            String
	 * @param presupuestoMaterial
	 *            BigDecimal
	 * @param importeIva
	 *            BigDecimal
	 * @param importeTotal
	 *            BigDecimal
	 * @param fechaAdjudicacion
	 *            Date
	 * @param fechaInicio
	 *            Date
	 * @param fechaFin
	 *            Date
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltactualizacion
	 *            Date
	 * @param usuarioUltactualizacion
	 *            String
	 * @param relExpActSub
	 *            RelExpActSub
	 * @param subtiposActSuv
	 *            SubtiposActSuv
	 */
	public ActAyuntamiento(Integer idActAyuntamiento, String titulo, BigDecimal presupuestoMaterial,
			BigDecimal importeIva, BigDecimal importeTotal, Date fechaAdjudicacion, Date fechaInicio, Date fechaFin,
			BigDecimal importeAdmitido, Date fechaRegistro, String usuarioRegistro, Date fechaUltactualizacion,
			String usuarioUltactualizacion, RelExpActSub relExpActSub) {

		this.idActAyuntamiento = idActAyuntamiento;
		this.relExpActSub = relExpActSub;
		this.titulo = titulo;
		this.presupuestoMaterial = presupuestoMaterial;
		this.importeIva = importeIva;
		this.importeTotal = importeTotal;
		this.fechaAdjudicacion = fechaAdjudicacion;
		this.fechaInicio = fechaInicio;
		this.fechaFin = fechaFin;
		this.importeAdmitido = importeAdmitido;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltactualizacion = fechaUltactualizacion;
		this.usuarioUltactualizacion = usuarioUltactualizacion;
	}

	public ActAyuntamiento(BigDecimal importeTotal, BigDecimal importeAdmitido) {
		super();
		this.importeTotal = importeTotal;
		this.importeAdmitido = importeAdmitido;
	}

	// Constructor para filtrar por DEC

	public ActAyuntamiento(Integer idActAyuntamiento, String titulo, BigDecimal presupuestoMaterial,
			BigDecimal importeIva, Date fechaAdjudicacion, Date fechaInicio, Date fechaFin, RelExpActSub relExpActSub) {
		super();
		this.idActAyuntamiento = idActAyuntamiento;
		this.titulo = titulo;
		this.presupuestoMaterial = presupuestoMaterial;
		this.importeIva = importeIva;
		this.fechaAdjudicacion = fechaAdjudicacion;
		this.fechaInicio = fechaInicio;
		this.fechaFin = fechaFin;
		this.relExpActSub = relExpActSub;
	}

	/**
	 * Method 'getIdActAyuntamiento'.
	 *
	 * @return Integer
	 */

	public Integer getIdActAyuntamiento() {
		return this.idActAyuntamiento;
	}

	public ActAyuntamiento(Integer idActAyuntamiento, String titulo) {
		this.idActAyuntamiento = idActAyuntamiento;
		this.titulo = titulo;
	}

	public ActAyuntamiento(RelExpActSub relExpActSub) {
		super();
		this.relExpActSub = relExpActSub;
	}

	public ActAyuntamiento(Integer idActAyuntamiento, RelExpActSub relExpActSub, String titulo,
			BigDecimal presupuestoMaterial, BigDecimal importeIva, Date fechaAdjudicacion, Date fechaInicio,
			Date fechaFin) {
		this.idActAyuntamiento = idActAyuntamiento;
		this.relExpActSub = relExpActSub;
		this.titulo = titulo;
		this.presupuestoMaterial = presupuestoMaterial;
		this.importeIva = importeIva;
		this.fechaAdjudicacion = fechaAdjudicacion;
		this.fechaInicio = fechaInicio;
		this.fechaFin = fechaFin;
	}

	public ActAyuntamiento(Integer idActAyuntamiento, RelExpActSub relExpActSub, String titulo, String descripcion,
			BigDecimal presupuestoMaterial, BigDecimal importeIva, Date fechaAdjudicacion, Date fechaInicio,
			Date fechaFin) {
		this.idActAyuntamiento = idActAyuntamiento;
		this.relExpActSub = relExpActSub;
		this.titulo = titulo;
		this.descripcion = descripcion;
		this.presupuestoMaterial = presupuestoMaterial;
		this.importeIva = importeIva;
		this.fechaAdjudicacion = fechaAdjudicacion;
		this.fechaInicio = fechaInicio;
		this.fechaFin = fechaFin;
	}

	/**
	 * Method 'setIdActAyuntamiento'.
	 *
	 * @param idActAyuntamiento
	 *            Integer
	 * @return
	 */

	public void setIdActAyuntamiento(Integer idActAyuntamiento) {
		this.idActAyuntamiento = idActAyuntamiento;
	}

	/**
	 * Method 'getRelExpActSub'.
	 *
	 * @return RelExpActSub
	 */

	public RelExpActSub getRelExpActSub() {
		return this.relExpActSub;
	}

	/**
	 * Method 'setRelExpActSub'.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return
	 */

	public void setRelExpActSub(RelExpActSub relExpActSub) {
		this.relExpActSub = relExpActSub;
	}

	/**
	 * Method 'getTitulo'.
	 *
	 * @return String
	 */

	public String getTitulo() {
		return this.titulo;
	}

	/**
	 * Method 'setTitulo'.
	 *
	 * @param titulo
	 *            String
	 * @return
	 */

	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}

	/**
	 * Method 'getPresupuestoMaterial'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getPresupuestoMaterial() {
		return this.presupuestoMaterial;
	}

	/**
	 * Method 'setPresupuestoMaterial'.
	 *
	 * @param presupuestoMaterial
	 *            BigDecimal
	 * @return
	 */

	public void setPresupuestoMaterial(BigDecimal presupuestoMaterial) {
		this.presupuestoMaterial = presupuestoMaterial;
	}

	/**
	 * Method 'getImporteIva'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporteIva() {
		return this.importeIva;
	}

	/**
	 * Method 'setImporteIva'.
	 *
	 * @param importeIva
	 *            BigDecimal
	 * @return
	 */

	public void setImporteIva(BigDecimal importeIva) {
		this.importeIva = importeIva;
	}

	/**
	 * Method 'getImporteTotal'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporteTotal() {
		return this.importeTotal;
	}

	/**
	 * Method 'setImporteTotal'.
	 *
	 * @param importeTotal
	 *            BigDecimal
	 * @return
	 */

	public void setImporteTotal(BigDecimal importeTotal) {
		this.importeTotal = importeTotal;
	}

	/**
	 * Method 'getFechaAdjudicacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaAdjudicacion() {
		return this.fechaAdjudicacion;
	}

	/**
	 * Method 'setFechaAdjudicacion'.
	 *
	 * @param fechaAdjudicacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaAdjudicacion(Date fechaAdjudicacion) {
		this.fechaAdjudicacion = fechaAdjudicacion;
	}

	/**
	 * Method 'getFechaInicio'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaInicio() {
		return this.fechaInicio;
	}

	/**
	 * Method 'setFechaInicio'.
	 *
	 * @param fechaInicio
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaInicio(Date fechaInicio) {
		this.fechaInicio = fechaInicio;
	}

	/**
	 * Method 'getFechaFin'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaFin() {
		return this.fechaFin;
	}

	/**
	 * Method 'setFechaFin'.
	 *
	 * @param fechaFin
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaFin(Date fechaFin) {
		this.fechaFin = fechaFin;
	}

	/**
	 * Method 'getImporteAdmitido'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporteAdmitido() {
		return this.importeAdmitido;
	}

	/**
	 * Method 'setImporteAdmitido'.
	 *
	 * @param importeAdmitido
	 *            BigDecimal
	 * @return
	 */

	public void setImporteAdmitido(BigDecimal importeAdmitido) {
		this.importeAdmitido = importeAdmitido;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltactualizacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltactualizacion() {
		return this.fechaUltactualizacion;
	}

	/**
	 * Method 'setFechaUltactualizacion'.
	 *
	 * @param fechaUltactualizacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltactualizacion(Date fechaUltactualizacion) {
		this.fechaUltactualizacion = fechaUltactualizacion;
	}

	/**
	 * Method 'getUsuarioUltactualizacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltactualizacion() {
		return this.usuarioUltactualizacion;
	}

	/**
	 * Method 'setUsuarioUltactualizacion'.
	 *
	 * @param usuarioUltactualizacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltactualizacion(String usuarioUltactualizacion) {
		this.usuarioUltactualizacion = usuarioUltactualizacion;
	}

	/**
	 * @return the observacionesCastellano
	 */
	public String getObservacionesCastellano() {
		return observacionesCastellano;
	}

	/**
	 * @param observacionesCastellano
	 *            the observacionesCastellano to set
	 */
	public void setObservacionesCastellano(String observacionesCastellano) {
		this.observacionesCastellano = observacionesCastellano;
	}

	/**
	 * @return the observacionesEuskera
	 */
	public String getObservacionesEuskera() {
		return observacionesEuskera;
	}

	/**
	 * @param observacionesEuskera
	 *            the observacionesEuskera to set
	 */
	public void setObservacionesEuskera(String observacionesEuskera) {
		this.observacionesEuskera = observacionesEuskera;
	}

	/**
	 * @return the inspeccionable
	 */
	public Integer getInspeccionable() {
		return inspeccionable;
	}

	/**
	 * @param inspeccionable
	 *            the inspeccionable to set
	 */
	public void setInspeccionable(Integer inspeccionable) {
		this.inspeccionable = inspeccionable;
	}

	/**
	 * Method 'getPresupuestoMaterialMask'.
	 *
	 * @return BigDecimal
	 */

	public String getPresupuestoMaterialMask() {

		return UtilDate.formatearMiles(presupuestoMaterial);

	}

	/**
	 * Method 'getImporteIVAMask'.
	 *
	 * @return BigDecimal
	 */

	public String getImporteIvaMask() {

		return UtilDate.formatearMiles(importeIva);

	}

	/**
	 * @return the fechaAdjudicacionStr
	 */
	public String getFechaAdjudicacionStr() {
		return fechaAdjudicacionStr;
	}

	/**
	 * @param fechaAdjudicacionStr
	 *            the fechaAdjudicacionStr to set
	 */
	public void setFechaAdjudicacionStr(String fechaAdjudicacionStr) {
		this.fechaAdjudicacionStr = fechaAdjudicacionStr;
	}

	/**
	 * @return the fechaInicioStr
	 */
	public String getFechaInicioStr() {
		return fechaInicioStr;
	}

	/**
	 * @param fechaFacturaStr
	 *            the fechaFacturaStr to set
	 */
	public void setFechaInicioStr(String fechaInicioStr) {
		this.fechaInicioStr = fechaInicioStr;
	}

	/**
	 * @return the fechaFacturaStr
	 */
	public String getFechaFinStr() {
		return fechaFinStr;
	}

	/**
	 * @param fechaFacturaStr
	 *            the fechaFacturaStr to set
	 */
	public void setFechaFinStr(String fechaFinStr) {
		this.fechaFinStr = fechaFinStr;
	}

	/**
	 * @return the descripcion
	 */
	public String getDescripcion() {
		return descripcion;
	}

	/**
	 * @param descripcion
	 *            the descripcion to set
	 */
	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idActAyuntamiento: ").append(this.idActAyuntamiento).append(" ]");
		result.append(", [ titulo: ").append(this.titulo).append(" ]");
		result.append(", [ presupuestoMaterial: ").append(this.presupuestoMaterial).append(" ]");
		result.append(", [ importeIva: ").append(this.importeIva).append(" ]");
		result.append(", [ importeTotal: ").append(this.importeTotal).append(" ]");
		result.append(", [ fechaAdjudicacion: ").append(this.fechaAdjudicacion).append(" ]");
		result.append(", [ fechaInicio: ").append(this.fechaInicio).append(" ]");
		result.append(", [ fechaFin: ").append(this.fechaFin).append(" ]");
		result.append(", [ importeAdmitido: ").append(this.importeAdmitido).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltactualizacion: ").append(this.fechaUltactualizacion).append(" ]");
		result.append(", [ usuarioUltactualizacion: ").append(this.usuarioUltactualizacion).append(" ]");
		result.append("}");
		return result.toString();
	}

}
