package com.ejie.ab60.model.DEC;

import java.util.Date;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * AsociacionesComerciantes  
 * 
 *  
 */

public class AsociacionesComerciantes implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idAsociacionComerciante;
	private RelMunAsoCom relMunAsoCom;
	private String cif;
	private String nombre;
	private String representante;
	private Date fechaRegistro;
	private String usuarioRegistro;

	/**
	 * Method 'AsociacionesComerciantes'.
	 */
	public AsociacionesComerciantes() {
	}

	/**
	 * Method 'AsociacionesComerciantes'.
	 * 
	 * @param idAsociacionComerciante
	 *            Integer
	 */
	public AsociacionesComerciantes(Integer idAsociacionComerciante) {
		this.idAsociacionComerciante = idAsociacionComerciante;
	}

	/**
	 * Method 'AsociacionesComerciantes'.
	 * 
	 * @param idAsociacionComerciante
	 *            Integer
	 * @param cif
	 *            String
	 * @param nombre
	 *            String
	 * @param representante
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 */
	public AsociacionesComerciantes(Integer idAsociacionComerciante, String cif, String nombre, String representante,
			Date fechaRegistro, String usuarioRegistro, RelMunAsoCom relMunAsoCom) {

		this.idAsociacionComerciante = idAsociacionComerciante;
		this.relMunAsoCom = relMunAsoCom;
		this.cif = cif;
		this.nombre = nombre;
		this.representante = representante;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getIdAsociacionComerciante'.
	 *
	 * @return Integer
	 */

	public Integer getIdAsociacionComerciante() {
		return this.idAsociacionComerciante;
	}

	/**
	 * Method 'setIdAsociacionComerciante'.
	 *
	 * @param idAsociacionComerciante
	 *            Integer
	 * @return
	 */

	public void setIdAsociacionComerciante(Integer idAsociacionComerciante) {
		this.idAsociacionComerciante = idAsociacionComerciante;
	}

	/**
	 * Method 'getRelMunAsoCom'.
	 *
	 * @return RelMunAsoCom
	 */
	@JsonIgnore

	public RelMunAsoCom getRelMunAsoCom() {
		return this.relMunAsoCom;
	}

	/**
	 * Method 'setRelMunAsoCom'.
	 *
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 * @return
	 */

	public void setRelMunAsoCom(RelMunAsoCom relMunAsoCom) {
		this.relMunAsoCom = relMunAsoCom;
	}

	/**
	 * Method 'getCif'.
	 *
	 * @return String
	 */

	public String getCif() {
		return this.cif;
	}

	/**
	 * Method 'setCif'.
	 *
	 * @param cif
	 *            String
	 * @return
	 */

	public void setCif(String cif) {
		this.cif = cif;
	}

	/**
	 * Method 'getNombre'.
	 *
	 * @return String
	 */

	public String getNombre() {
		return this.nombre;
	}

	/**
	 * Method 'setNombre'.
	 *
	 * @param nombre
	 *            String
	 * @return
	 */

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	/**
	 * Method 'getRepresentante'.
	 *
	 * @return String
	 */

	public String getRepresentante() {
		return this.representante;
	}

	/**
	 * Method 'setRepresentante'.
	 *
	 * @param representante
	 *            String
	 * @return
	 */

	public void setRepresentante(String representante) {
		this.representante = representante;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idAsociacionComerciante: ").append(this.idAsociacionComerciante).append(" ]");
		result.append(", [ cif: ").append(this.cif).append(" ]");
		result.append(", [ nombre: ").append(this.nombre).append(" ]");
		result.append(", [ representante: ").append(this.representante).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
