package com.ejie.ab60.model.DEC;

import java.math.BigDecimal;
import java.util.Date;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * LimiteAsociaciones  
 * 
 *  
 */

public class LimiteAsociaciones implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idMunicipioAso;
	private String municipio;
	private Long numeroComercios;
	private Long poblacion;
	private BigDecimal densidad;
	private BigDecimal coeficiente;
	private BigDecimal subvTramoPoblacion;
	private BigDecimal subvMaxPoblacion;
	private Date fechaRegistro;
	private String usuarioRegistro;

	/**
	 * Method 'LimiteAsociaciones'.
	 */
	public LimiteAsociaciones() {
	}

	/**
	 * Method 'LimiteAsociaciones'.
	 * 
	 * @param idMunicipioAso
	 *            Long
	 */
	public LimiteAsociaciones(Long idMunicipioAso) {
		this.idMunicipioAso = idMunicipioAso;
	}

	/**
	 * Method 'LimiteAsociaciones'.
	 * 
	 * @param idMunicipioAso
	 *            Long
	 * @param municipio
	 *            String
	 * @param numeroComercios
	 *            Long
	 * @param poblacion
	 *            Long
	 * @param densidad
	 *            BigDecimal
	 * @param coeficiente
	 *            BigDecimal
	 * @param subvTramoPoblacion
	 *            BigDecimal
	 * @param subvMaxPoblacion
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public LimiteAsociaciones(Long idMunicipioAso, String municipio, Long numeroComercios, Long poblacion,
			BigDecimal densidad, BigDecimal coeficiente, BigDecimal subvTramoPoblacion, BigDecimal subvMaxPoblacion,
			Date fechaRegistro, String usuarioRegistro) {

		this.idMunicipioAso = idMunicipioAso;
		this.municipio = municipio;
		this.numeroComercios = numeroComercios;
		this.poblacion = poblacion;
		this.densidad = densidad;
		this.coeficiente = coeficiente;
		this.subvTramoPoblacion = subvTramoPoblacion;
		this.subvMaxPoblacion = subvMaxPoblacion;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getIdMunicipioAso'.
	 *
	 * @return Long
	 */

	public Long getIdMunicipioAso() {
		return this.idMunicipioAso;
	}

	/**
	 * Method 'setIdMunicipioAso'.
	 *
	 * @param idMunicipioAso
	 *            Long
	 * @return
	 */

	public void setIdMunicipioAso(Long idMunicipioAso) {
		this.idMunicipioAso = idMunicipioAso;
	}

	/**
	 * Method 'getMunicipio'.
	 *
	 * @return String
	 */

	public String getMunicipio() {
		return this.municipio;
	}

	/**
	 * Method 'setMunicipio'.
	 *
	 * @param municipio
	 *            String
	 * @return
	 */

	public void setMunicipio(String municipio) {
		this.municipio = municipio;
	}

	/**
	 * Method 'getNumeroComercios'.
	 *
	 * @return Long
	 */

	public Long getNumeroComercios() {
		return this.numeroComercios;
	}

	/**
	 * Method 'setNumeroComercios'.
	 *
	 * @param numeroComercios
	 *            Long
	 * @return
	 */

	public void setNumeroComercios(Long numeroComercios) {
		this.numeroComercios = numeroComercios;
	}

	/**
	 * Method 'getPoblacion'.
	 *
	 * @return Long
	 */

	public Long getPoblacion() {
		return this.poblacion;
	}

	/**
	 * Method 'setPoblacion'.
	 *
	 * @param poblacion
	 *            Long
	 * @return
	 */

	public void setPoblacion(Long poblacion) {
		this.poblacion = poblacion;
	}

	/**
	 * Method 'getDensidad'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getDensidad() {
		return this.densidad;
	}

	/**
	 * Method 'setDensidad'.
	 *
	 * @param densidad
	 *            BigDecimal
	 * @return
	 */

	public void setDensidad(BigDecimal densidad) {
		this.densidad = densidad;
	}

	/**
	 * Method 'getCoeficiente'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getCoeficiente() {
		return this.coeficiente;
	}

	/**
	 * Method 'setCoeficiente'.
	 *
	 * @param coeficiente
	 *            BigDecimal
	 * @return
	 */

	public void setCoeficiente(BigDecimal coeficiente) {
		this.coeficiente = coeficiente;
	}

	/**
	 * Method 'getSubvTramoPoblacion'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getSubvTramoPoblacion() {
		return this.subvTramoPoblacion;
	}

	/**
	 * Method 'setSubvTramoPoblacion'.
	 *
	 * @param subvTramoPoblacion
	 *            BigDecimal
	 * @return
	 */

	public void setSubvTramoPoblacion(BigDecimal subvTramoPoblacion) {
		this.subvTramoPoblacion = subvTramoPoblacion;
	}

	/**
	 * Method 'getSubvMaxPoblacion'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getSubvMaxPoblacion() {
		return this.subvMaxPoblacion;
	}

	/**
	 * Method 'setSubvMaxPoblacion'.
	 *
	 * @param subvMaxPoblacion
	 *            BigDecimal
	 * @return
	 */

	public void setSubvMaxPoblacion(BigDecimal subvMaxPoblacion) {
		this.subvMaxPoblacion = subvMaxPoblacion;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idMunicipioAso: ").append(this.idMunicipioAso).append(" ]");
		result.append(", [ municipio: ").append(this.municipio).append(" ]");
		result.append(", [ numeroComercios: ").append(this.numeroComercios).append(" ]");
		result.append(", [ poblacion: ").append(this.poblacion).append(" ]");
		result.append(", [ densidad: ").append(this.densidad).append(" ]");
		result.append(", [ coeficiente: ").append(this.coeficiente).append(" ]");
		result.append(", [ subvTramoPoblacion: ").append(this.subvTramoPoblacion).append(" ]");
		result.append(", [ subvMaxPoblacion: ").append(this.subvMaxPoblacion).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
