package com.ejie.ab60.model.DEC;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * RelMunAsoCom  
 * 
 *  
 */

public class RelMunAsoCom implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idMunicipioAsoCom;
	private Long idProvincia;
	private Long idMunicipio;
	private Long numeroAsociaciones;
	private Integer organoSeguimiento;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<AsociacionesComerciantes> asociacionesComercianteses = new ArrayList<AsociacionesComerciantes>();
	private Integer idExpediente;
	private Integer numeroMujeres;
	private Integer numeroHombres;
	private Integer exentoIva;

	/**
	 * Method 'RelMunAsoCom'.
	 */
	public RelMunAsoCom() {
	}

	/**
	 * Method 'RelMunAsoCom'.
	 * 
	 * @param idMunicipioAsoCom
	 *            Integer
	 */
	public RelMunAsoCom(Integer idMunicipioAsoCom) {
		this.idMunicipioAsoCom = idMunicipioAsoCom;
	}

	/**
	 * Method 'RelMunAsoCom'.
	 * 
	 * @param idMunicipioAsoCom
	 *            Integer
	 * @param idMunicipio
	 *            Long
	 * @param numeroAsociaciones
	 *            Long
	 * @param organoSeguimiento
	 *            Integer
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param tiposSolicitantes
	 *            TiposSolicitantes
	 */
	public RelMunAsoCom(Integer idMunicipioAsoCom, Long idMunicipio, Long numeroAsociaciones, Integer organoSeguimiento,
			Date fechaRegistro, String usuarioRegistro) {
		this.idMunicipioAsoCom = idMunicipioAsoCom;
		this.idMunicipio = idMunicipio;
		this.numeroAsociaciones = numeroAsociaciones;
		this.organoSeguimiento = organoSeguimiento;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'RelMunAsoCom'.
	 * 
	 * @param idMunicipioAsoCom
	 *            Integer
	 * @param idMunicipio
	 *            Long
	 * @param numeroAsociaciones
	 *            Long
	 * @param organoSeguimiento
	 *            Integer
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param tiposSolicitantes
	 *            TiposSolicitantes
	 * @param relExpMunAsoComs
	 *            List<RelExpMunAsoCom>
	 * @param asociacionesComercianteses
	 *            List<AsociacionesComerciantes>
	 */
	public RelMunAsoCom(Integer idMunicipioAsoCom, Long idMunicipio, Long numeroAsociaciones, Integer organoSeguimiento,
			Date fechaRegistro, String usuarioRegistro, List<AsociacionesComerciantes> asociacionesComercianteses) {

		this.idMunicipioAsoCom = idMunicipioAsoCom;
		this.idMunicipio = idMunicipio;
		this.numeroAsociaciones = numeroAsociaciones;
		this.organoSeguimiento = organoSeguimiento;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.asociacionesComercianteses = asociacionesComercianteses;
	}

	/**
	 * Method 'getIdMunicipioAsoCom'.
	 *
	 * @return Integer
	 */

	public Integer getIdMunicipioAsoCom() {
		return this.idMunicipioAsoCom;
	}

	/**
	 * Method 'setIdMunicipioAsoCom'.
	 *
	 * @param idMunicipioAsoCom
	 *            Integer
	 * @return
	 */

	public void setIdMunicipioAsoCom(Integer idMunicipioAsoCom) {
		this.idMunicipioAsoCom = idMunicipioAsoCom;
	}

	/**
	 * Method 'getIdMunicipio'.
	 *
	 * @return Long
	 */

	public Long getIdMunicipio() {
		return this.idMunicipio;
	}

	/**
	 * Method 'setIdMunicipio'.
	 *
	 * @param idMunicipio
	 *            Long
	 * @return
	 */

	public void setIdMunicipio(Long idMunicipio) {
		this.idMunicipio = idMunicipio;
	}

	/**
	 * Method 'getNumeroAsociaciones'.
	 *
	 * @return Long
	 */

	public Long getNumeroAsociaciones() {
		return this.numeroAsociaciones;
	}

	/**
	 * Method 'setNumeroAsociaciones'.
	 *
	 * @param numeroAsociaciones
	 *            Long
	 * @return
	 */

	public void setNumeroAsociaciones(Long numeroAsociaciones) {
		this.numeroAsociaciones = numeroAsociaciones;
	}

	/**
	 * Method 'getOrganoSeguimiento'.
	 *
	 * @return Integer
	 */

	public Integer getOrganoSeguimiento() {
		return this.organoSeguimiento;
	}

	/**
	 * Method 'setOrganoSeguimiento'.
	 *
	 * @param organoSeguimiento
	 *            Integer
	 * @return
	 */

	public void setOrganoSeguimiento(Integer organoSeguimiento) {
		this.organoSeguimiento = organoSeguimiento;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getAsociacionesComercianteses'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<AsociacionesComerciantes> getAsociacionesComercianteses() {
		return this.asociacionesComercianteses;
	}

	/**
	 * Method 'setAsociacionesComercianteses'.
	 *
	 * @param asociacionesComercianteses
	 *            List
	 * @return
	 */
	public void setAsociacionesComercianteses(List<AsociacionesComerciantes> asociacionesComercianteses) {
		this.asociacionesComercianteses = asociacionesComercianteses;
	}

	/**
	 * @return the idExpediente
	 */
	public Integer getIdExpediente() {
		return idExpediente;
	}

	/**
	 * @param idExpediente
	 *            the idExpediente to set
	 */
	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * @return the idProvincia
	 */
	public Long getIdProvincia() {
		return idProvincia;
	}

	/**
	 * @param idProvincia
	 *            the idProvincia to set
	 */
	public void setIdProvincia(Long idProvincia) {
		this.idProvincia = idProvincia;
	}

	/**
	 * @return the numeroMujeres
	 */
	public Integer getNumeroMujeres() {
		return numeroMujeres;
	}

	/**
	 * @param numeroMujeres
	 *            the numeroMujeres to set
	 */
	public void setNumeroMujeres(Integer numeroMujeres) {
		this.numeroMujeres = numeroMujeres;
	}

	/**
	 * @return the numeroHombres
	 */
	public Integer getNumeroHombres() {
		return numeroHombres;
	}

	/**
	 * @param numeroHombres
	 *            the numeroHombres to set
	 */
	public void setNumeroHombres(Integer numeroHombres) {
		this.numeroHombres = numeroHombres;
	}

	/**
	 * @return the exentoIva
	 */
	public Integer getExentoIva() {
		return exentoIva;
	}

	/**
	 * @param exentoIva
	 *            the exentoIva to set
	 */
	public void setExentoIva(Integer exentoIva) {
		this.exentoIva = exentoIva;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idMunicipioAsoCom: ").append(this.idMunicipioAsoCom).append(" ]");
		result.append(", [ idMunicipio: ").append(this.idMunicipio).append(" ]");
		result.append(", [ numeroAsociaciones: ").append(this.numeroAsociaciones).append(" ]");
		result.append(", [ organoSeguimiento: ").append(this.organoSeguimiento).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
