package com.ejie.ab60.model.DIV;

import java.math.BigDecimal;
import java.util.Date;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Acciones  
 * 
 *  
 */

public class Acciones implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idAcciones;
	private TiposActividad tiposActividad;
	private EntidadesSolicitantes entidadesSolicitantes;
	private String titulo;
	private String ponentes;
	private Date fechaInicio;
	private Date fechaFin;
	private Long duracion;
	private Long NEmpresasComerciales;
	private Long NEmpresasAsistentes;
	private BigDecimal contratacion;
	private BigDecimal contratacionAdmitida;
	private BigDecimal actPublicidad;
	private BigDecimal actPublicidadAdmitida;
	private BigDecimal actMailing;
	private BigDecimal actMailingAdmitido;
	private BigDecimal actImpresion;
	private BigDecimal actImpresionAdmitida;
	private BigDecimal actDivulgacion;
	private BigDecimal actDivulgacionAdmitida;
	private BigDecimal actDistribucion;
	private BigDecimal actDistribucionAdmitida;
	private BigDecimal actOtros;
	private BigDecimal actOtrosAdmitidos;
	private BigDecimal gasFotocopias;
	private BigDecimal gasFotocopiasAdmitido;
	private BigDecimal gasMaterial;
	private BigDecimal gasMaterialAdmitida;
	private BigDecimal gasDocumentacion;
	private BigDecimal gasDocumentacionAdmitida;
	private BigDecimal gasAlquiler;
	private BigDecimal gasAlquilerAdmitido;
	private BigDecimal gasOtros;
	private BigDecimal gasOtrosAdmitidos;
	private BigDecimal gasAlojamiento;
	private BigDecimal gasAlojamientoAdmitido;
	private BigDecimal gasTraslado;
	private BigDecimal gasTrasladoAdmitido;
	private BigDecimal gasManutencion;
	private BigDecimal gasManutencionAdmitido;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;

	/**
	 * Method 'Acciones'.
	 */
	public Acciones() {
	}

	/**
	 * Method 'Acciones'.
	 * 
	 * @param idAcciones
	 *            Integer
	 */
	public Acciones(Integer idAcciones) {
		this.idAcciones = idAcciones;
	}

	/**
	 * Method 'Acciones'.
	 * 
	 * @param idAcciones
	 *            Integer
	 * @param titulo
	 *            String
	 * @param ponentes
	 *            String
	 * @param fechaInicio
	 *            Date
	 * @param fechaFin
	 *            Date
	 * @param duracion
	 *            Long
	 * @param NEmpresasComerciales
	 *            Long
	 * @param NEmpresasAsistentes
	 *            Long
	 * @param contratacion
	 *            BigDecimal
	 * @param contratacionAdmitida
	 *            BigDecimal
	 * @param actPublicidad
	 *            BigDecimal
	 * @param actPublicidadAdmitida
	 *            BigDecimal
	 * @param actMailing
	 *            BigDecimal
	 * @param actMailingAdmitido
	 *            BigDecimal
	 * @param actImpresion
	 *            BigDecimal
	 * @param actImpresionAdmitida
	 *            BigDecimal
	 * @param actDivulgacion
	 *            BigDecimal
	 * @param actDivulgacionAdmitida
	 *            BigDecimal
	 * @param actDistribucion
	 *            BigDecimal
	 * @param actDistribucionAdmitida
	 *            BigDecimal
	 * @param actOtros
	 *            BigDecimal
	 * @param actOtrosAdmitidos
	 *            BigDecimal
	 * @param gasFotocopias
	 *            BigDecimal
	 * @param gasFotocopiasAdmitido
	 *            BigDecimal
	 * @param gasMaterial
	 *            BigDecimal
	 * @param gasMaterialAdmitida
	 *            BigDecimal
	 * @param gasDocumentacion
	 *            BigDecimal
	 * @param gasDocumentacionAdmitida
	 *            BigDecimal
	 * @param gasAlquiler
	 *            BigDecimal
	 * @param gasAlquilerAdmitido
	 *            BigDecimal
	 * @param gasOtros
	 *            BigDecimal
	 * @param gasOtrosAdmitidos
	 *            BigDecimal
	 * @param gasAlojamiento
	 *            BigDecimal
	 * @param gasAlojamientoAdmitido
	 *            BigDecimal
	 * @param gasTraslado
	 *            BigDecimal
	 * @param gasTrasladoAdmitido
	 *            BigDecimal
	 * @param gasManutencion
	 *            BigDecimal
	 * @param gasManutencionAdmitido
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param tiposActividad
	 *            TiposActividad
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 */
	public Acciones(Integer idAcciones, String titulo, String ponentes, Date fechaInicio, Date fechaFin, Long duracion,
			Long NEmpresasComerciales, Long NEmpresasAsistentes, BigDecimal contratacion,
			BigDecimal contratacionAdmitida, BigDecimal actPublicidad, BigDecimal actPublicidadAdmitida,
			BigDecimal actMailing, BigDecimal actMailingAdmitido, BigDecimal actImpresion,
			BigDecimal actImpresionAdmitida, BigDecimal actDivulgacion, BigDecimal actDivulgacionAdmitida,
			BigDecimal actDistribucion, BigDecimal actDistribucionAdmitida, BigDecimal actOtros,
			BigDecimal actOtrosAdmitidos, BigDecimal gasFotocopias, BigDecimal gasFotocopiasAdmitido,
			BigDecimal gasMaterial, BigDecimal gasMaterialAdmitida, BigDecimal gasDocumentacion,
			BigDecimal gasDocumentacionAdmitida, BigDecimal gasAlquiler, BigDecimal gasAlquilerAdmitido,
			BigDecimal gasOtros, BigDecimal gasOtrosAdmitidos, BigDecimal gasAlojamiento,
			BigDecimal gasAlojamientoAdmitido, BigDecimal gasTraslado, BigDecimal gasTrasladoAdmitido,
			BigDecimal gasManutencion, BigDecimal gasManutencionAdmitido, Date fechaRegistro, String usuarioRegistro,
			Date fechaUltmodificacion, String usuarioUltmodificacion, TiposActividad tiposActividad,
			EntidadesSolicitantes entidadesSolicitantes) {

		this.idAcciones = idAcciones;
		this.tiposActividad = tiposActividad;
		this.entidadesSolicitantes = entidadesSolicitantes;
		this.titulo = titulo;
		this.ponentes = ponentes;
		this.fechaInicio = fechaInicio;
		this.fechaFin = fechaFin;
		this.duracion = duracion;
		this.NEmpresasComerciales = NEmpresasComerciales;
		this.NEmpresasAsistentes = NEmpresasAsistentes;
		this.contratacion = contratacion;
		this.contratacionAdmitida = contratacionAdmitida;
		this.actPublicidad = actPublicidad;
		this.actPublicidadAdmitida = actPublicidadAdmitida;
		this.actMailing = actMailing;
		this.actMailingAdmitido = actMailingAdmitido;
		this.actImpresion = actImpresion;
		this.actImpresionAdmitida = actImpresionAdmitida;
		this.actDivulgacion = actDivulgacion;
		this.actDivulgacionAdmitida = actDivulgacionAdmitida;
		this.actDistribucion = actDistribucion;
		this.actDistribucionAdmitida = actDistribucionAdmitida;
		this.actOtros = actOtros;
		this.actOtrosAdmitidos = actOtrosAdmitidos;
		this.gasFotocopias = gasFotocopias;
		this.gasFotocopiasAdmitido = gasFotocopiasAdmitido;
		this.gasMaterial = gasMaterial;
		this.gasMaterialAdmitida = gasMaterialAdmitida;
		this.gasDocumentacion = gasDocumentacion;
		this.gasDocumentacionAdmitida = gasDocumentacionAdmitida;
		this.gasAlquiler = gasAlquiler;
		this.gasAlquilerAdmitido = gasAlquilerAdmitido;
		this.gasOtros = gasOtros;
		this.gasOtrosAdmitidos = gasOtrosAdmitidos;
		this.gasAlojamiento = gasAlojamiento;
		this.gasAlojamientoAdmitido = gasAlojamientoAdmitido;
		this.gasTraslado = gasTraslado;
		this.gasTrasladoAdmitido = gasTrasladoAdmitido;
		this.gasManutencion = gasManutencion;
		this.gasManutencionAdmitido = gasManutencionAdmitido;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getIdAcciones'.
	 *
	 * @return Integer
	 */

	public Integer getIdAcciones() {
		return this.idAcciones;
	}

	/**
	 * Method 'setIdAcciones'.
	 *
	 * @param idAcciones
	 *            Integer
	 * @return
	 */

	public void setIdAcciones(Integer idAcciones) {
		this.idAcciones = idAcciones;
	}

	/**
	 * Method 'getTiposActividad'.
	 *
	 * @return TiposActividad
	 */
	@JsonIgnore

	public TiposActividad getTiposActividad() {
		return this.tiposActividad;
	}

	/**
	 * Method 'setTiposActividad'.
	 *
	 * @param tiposActividad
	 *            TiposActividad
	 * @return
	 */

	public void setTiposActividad(TiposActividad tiposActividad) {
		this.tiposActividad = tiposActividad;
	}

	/**
	 * Method 'getEntidadesSolicitantes'.
	 *
	 * @return EntidadesSolicitantes
	 */
	@JsonIgnore

	public EntidadesSolicitantes getEntidadesSolicitantes() {
		return this.entidadesSolicitantes;
	}

	/**
	 * Method 'setEntidadesSolicitantes'.
	 *
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @return
	 */

	public void setEntidadesSolicitantes(EntidadesSolicitantes entidadesSolicitantes) {
		this.entidadesSolicitantes = entidadesSolicitantes;
	}

	/**
	 * Method 'getTitulo'.
	 *
	 * @return String
	 */

	public String getTitulo() {
		return this.titulo;
	}

	/**
	 * Method 'setTitulo'.
	 *
	 * @param titulo
	 *            String
	 * @return
	 */

	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}

	/**
	 * Method 'getPonentes'.
	 *
	 * @return String
	 */

	public String getPonentes() {
		return this.ponentes;
	}

	/**
	 * Method 'setPonentes'.
	 *
	 * @param ponentes
	 *            String
	 * @return
	 */

	public void setPonentes(String ponentes) {
		this.ponentes = ponentes;
	}

	/**
	 * Method 'getFechaInicio'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaInicio() {
		return this.fechaInicio;
	}

	/**
	 * Method 'setFechaInicio'.
	 *
	 * @param fechaInicio
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaInicio(Date fechaInicio) {
		this.fechaInicio = fechaInicio;
	}

	/**
	 * Method 'getFechaFin'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaFin() {
		return this.fechaFin;
	}

	/**
	 * Method 'setFechaFin'.
	 *
	 * @param fechaFin
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaFin(Date fechaFin) {
		this.fechaFin = fechaFin;
	}

	/**
	 * Method 'getDuracion'.
	 *
	 * @return Long
	 */

	public Long getDuracion() {
		return this.duracion;
	}

	/**
	 * Method 'setDuracion'.
	 *
	 * @param duracion
	 *            Long
	 * @return
	 */

	public void setDuracion(Long duracion) {
		this.duracion = duracion;
	}

	/**
	 * Method 'getNEmpresasComerciales'.
	 *
	 * @return Long
	 */

	public Long getNEmpresasComerciales() {
		return this.NEmpresasComerciales;
	}

	/**
	 * Method 'setNEmpresasComerciales'.
	 *
	 * @param NEmpresasComerciales
	 *            Long
	 * @return
	 */

	public void setNEmpresasComerciales(Long NEmpresasComerciales) {
		this.NEmpresasComerciales = NEmpresasComerciales;
	}

	/**
	 * Method 'getNEmpresasAsistentes'.
	 *
	 * @return Long
	 */

	public Long getNEmpresasAsistentes() {
		return this.NEmpresasAsistentes;
	}

	/**
	 * Method 'setNEmpresasAsistentes'.
	 *
	 * @param NEmpresasAsistentes
	 *            Long
	 * @return
	 */

	public void setNEmpresasAsistentes(Long NEmpresasAsistentes) {
		this.NEmpresasAsistentes = NEmpresasAsistentes;
	}

	/**
	 * Method 'getContratacion'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getContratacion() {
		return this.contratacion;
	}

	/**
	 * Method 'setContratacion'.
	 *
	 * @param contratacion
	 *            BigDecimal
	 * @return
	 */

	public void setContratacion(BigDecimal contratacion) {
		this.contratacion = contratacion;
	}

	/**
	 * Method 'getContratacionAdmitida'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getContratacionAdmitida() {
		return this.contratacionAdmitida;
	}

	/**
	 * Method 'setContratacionAdmitida'.
	 *
	 * @param contratacionAdmitida
	 *            BigDecimal
	 * @return
	 */

	public void setContratacionAdmitida(BigDecimal contratacionAdmitida) {
		this.contratacionAdmitida = contratacionAdmitida;
	}

	/**
	 * Method 'getActPublicidad'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getActPublicidad() {
		return this.actPublicidad;
	}

	/**
	 * Method 'setActPublicidad'.
	 *
	 * @param actPublicidad
	 *            BigDecimal
	 * @return
	 */

	public void setActPublicidad(BigDecimal actPublicidad) {
		this.actPublicidad = actPublicidad;
	}

	/**
	 * Method 'getActPublicidadAdmitida'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getActPublicidadAdmitida() {
		return this.actPublicidadAdmitida;
	}

	/**
	 * Method 'setActPublicidadAdmitida'.
	 *
	 * @param actPublicidadAdmitida
	 *            BigDecimal
	 * @return
	 */

	public void setActPublicidadAdmitida(BigDecimal actPublicidadAdmitida) {
		this.actPublicidadAdmitida = actPublicidadAdmitida;
	}

	/**
	 * Method 'getActMailing'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getActMailing() {
		return this.actMailing;
	}

	/**
	 * Method 'setActMailing'.
	 *
	 * @param actMailing
	 *            BigDecimal
	 * @return
	 */

	public void setActMailing(BigDecimal actMailing) {
		this.actMailing = actMailing;
	}

	/**
	 * Method 'getActMailingAdmitido'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getActMailingAdmitido() {
		return this.actMailingAdmitido;
	}

	/**
	 * Method 'setActMailingAdmitido'.
	 *
	 * @param actMailingAdmitido
	 *            BigDecimal
	 * @return
	 */

	public void setActMailingAdmitido(BigDecimal actMailingAdmitido) {
		this.actMailingAdmitido = actMailingAdmitido;
	}

	/**
	 * Method 'getActImpresion'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getActImpresion() {
		return this.actImpresion;
	}

	/**
	 * Method 'setActImpresion'.
	 *
	 * @param actImpresion
	 *            BigDecimal
	 * @return
	 */

	public void setActImpresion(BigDecimal actImpresion) {
		this.actImpresion = actImpresion;
	}

	/**
	 * Method 'getActImpresionAdmitida'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getActImpresionAdmitida() {
		return this.actImpresionAdmitida;
	}

	/**
	 * Method 'setActImpresionAdmitida'.
	 *
	 * @param actImpresionAdmitida
	 *            BigDecimal
	 * @return
	 */

	public void setActImpresionAdmitida(BigDecimal actImpresionAdmitida) {
		this.actImpresionAdmitida = actImpresionAdmitida;
	}

	/**
	 * Method 'getActDivulgacion'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getActDivulgacion() {
		return this.actDivulgacion;
	}

	/**
	 * Method 'setActDivulgacion'.
	 *
	 * @param actDivulgacion
	 *            BigDecimal
	 * @return
	 */

	public void setActDivulgacion(BigDecimal actDivulgacion) {
		this.actDivulgacion = actDivulgacion;
	}

	/**
	 * Method 'getActDivulgacionAdmitida'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getActDivulgacionAdmitida() {
		return this.actDivulgacionAdmitida;
	}

	/**
	 * Method 'setActDivulgacionAdmitida'.
	 *
	 * @param actDivulgacionAdmitida
	 *            BigDecimal
	 * @return
	 */

	public void setActDivulgacionAdmitida(BigDecimal actDivulgacionAdmitida) {
		this.actDivulgacionAdmitida = actDivulgacionAdmitida;
	}

	/**
	 * Method 'getActDistribucion'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getActDistribucion() {
		return this.actDistribucion;
	}

	/**
	 * Method 'setActDistribucion'.
	 *
	 * @param actDistribucion
	 *            BigDecimal
	 * @return
	 */

	public void setActDistribucion(BigDecimal actDistribucion) {
		this.actDistribucion = actDistribucion;
	}

	/**
	 * Method 'getActDistribucionAdmitida'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getActDistribucionAdmitida() {
		return this.actDistribucionAdmitida;
	}

	/**
	 * Method 'setActDistribucionAdmitida'.
	 *
	 * @param actDistribucionAdmitida
	 *            BigDecimal
	 * @return
	 */

	public void setActDistribucionAdmitida(BigDecimal actDistribucionAdmitida) {
		this.actDistribucionAdmitida = actDistribucionAdmitida;
	}

	/**
	 * Method 'getActOtros'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getActOtros() {
		return this.actOtros;
	}

	/**
	 * Method 'setActOtros'.
	 *
	 * @param actOtros
	 *            BigDecimal
	 * @return
	 */

	public void setActOtros(BigDecimal actOtros) {
		this.actOtros = actOtros;
	}

	/**
	 * Method 'getActOtrosAdmitidos'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getActOtrosAdmitidos() {
		return this.actOtrosAdmitidos;
	}

	/**
	 * Method 'setActOtrosAdmitidos'.
	 *
	 * @param actOtrosAdmitidos
	 *            BigDecimal
	 * @return
	 */

	public void setActOtrosAdmitidos(BigDecimal actOtrosAdmitidos) {
		this.actOtrosAdmitidos = actOtrosAdmitidos;
	}

	/**
	 * Method 'getGasFotocopias'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasFotocopias() {
		return this.gasFotocopias;
	}

	/**
	 * Method 'setGasFotocopias'.
	 *
	 * @param gasFotocopias
	 *            BigDecimal
	 * @return
	 */

	public void setGasFotocopias(BigDecimal gasFotocopias) {
		this.gasFotocopias = gasFotocopias;
	}

	/**
	 * Method 'getGasFotocopiasAdmitido'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasFotocopiasAdmitido() {
		return this.gasFotocopiasAdmitido;
	}

	/**
	 * Method 'setGasFotocopiasAdmitido'.
	 *
	 * @param gasFotocopiasAdmitido
	 *            BigDecimal
	 * @return
	 */

	public void setGasFotocopiasAdmitido(BigDecimal gasFotocopiasAdmitido) {
		this.gasFotocopiasAdmitido = gasFotocopiasAdmitido;
	}

	/**
	 * Method 'getGasMaterial'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasMaterial() {
		return this.gasMaterial;
	}

	/**
	 * Method 'setGasMaterial'.
	 *
	 * @param gasMaterial
	 *            BigDecimal
	 * @return
	 */

	public void setGasMaterial(BigDecimal gasMaterial) {
		this.gasMaterial = gasMaterial;
	}

	/**
	 * Method 'getGasMaterialAdmitida'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasMaterialAdmitida() {
		return this.gasMaterialAdmitida;
	}

	/**
	 * Method 'setGasMaterialAdmitida'.
	 *
	 * @param gasMaterialAdmitida
	 *            BigDecimal
	 * @return
	 */

	public void setGasMaterialAdmitida(BigDecimal gasMaterialAdmitida) {
		this.gasMaterialAdmitida = gasMaterialAdmitida;
	}

	/**
	 * Method 'getGasDocumentacion'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasDocumentacion() {
		return this.gasDocumentacion;
	}

	/**
	 * Method 'setGasDocumentacion'.
	 *
	 * @param gasDocumentacion
	 *            BigDecimal
	 * @return
	 */

	public void setGasDocumentacion(BigDecimal gasDocumentacion) {
		this.gasDocumentacion = gasDocumentacion;
	}

	/**
	 * Method 'getGasDocumentacionAdmitida'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasDocumentacionAdmitida() {
		return this.gasDocumentacionAdmitida;
	}

	/**
	 * Method 'setGasDocumentacionAdmitida'.
	 *
	 * @param gasDocumentacionAdmitida
	 *            BigDecimal
	 * @return
	 */

	public void setGasDocumentacionAdmitida(BigDecimal gasDocumentacionAdmitida) {
		this.gasDocumentacionAdmitida = gasDocumentacionAdmitida;
	}

	/**
	 * Method 'getGasAlquiler'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasAlquiler() {
		return this.gasAlquiler;
	}

	/**
	 * Method 'setGasAlquiler'.
	 *
	 * @param gasAlquiler
	 *            BigDecimal
	 * @return
	 */

	public void setGasAlquiler(BigDecimal gasAlquiler) {
		this.gasAlquiler = gasAlquiler;
	}

	/**
	 * Method 'getGasAlquilerAdmitido'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasAlquilerAdmitido() {
		return this.gasAlquilerAdmitido;
	}

	/**
	 * Method 'setGasAlquilerAdmitido'.
	 *
	 * @param gasAlquilerAdmitido
	 *            BigDecimal
	 * @return
	 */

	public void setGasAlquilerAdmitido(BigDecimal gasAlquilerAdmitido) {
		this.gasAlquilerAdmitido = gasAlquilerAdmitido;
	}

	/**
	 * Method 'getGasOtros'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasOtros() {
		return this.gasOtros;
	}

	/**
	 * Method 'setGasOtros'.
	 *
	 * @param gasOtros
	 *            BigDecimal
	 * @return
	 */

	public void setGasOtros(BigDecimal gasOtros) {
		this.gasOtros = gasOtros;
	}

	/**
	 * Method 'getGasOtrosAdmitidos'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasOtrosAdmitidos() {
		return this.gasOtrosAdmitidos;
	}

	/**
	 * Method 'setGasOtrosAdmitidos'.
	 *
	 * @param gasOtrosAdmitidos
	 *            BigDecimal
	 * @return
	 */

	public void setGasOtrosAdmitidos(BigDecimal gasOtrosAdmitidos) {
		this.gasOtrosAdmitidos = gasOtrosAdmitidos;
	}

	/**
	 * Method 'getGasAlojamiento'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasAlojamiento() {
		return this.gasAlojamiento;
	}

	/**
	 * Method 'setGasAlojamiento'.
	 *
	 * @param gasAlojamiento
	 *            BigDecimal
	 * @return
	 */

	public void setGasAlojamiento(BigDecimal gasAlojamiento) {
		this.gasAlojamiento = gasAlojamiento;
	}

	/**
	 * Method 'getGasAlojamientoAdmitido'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasAlojamientoAdmitido() {
		return this.gasAlojamientoAdmitido;
	}

	/**
	 * Method 'setGasAlojamientoAdmitido'.
	 *
	 * @param gasAlojamientoAdmitido
	 *            BigDecimal
	 * @return
	 */

	public void setGasAlojamientoAdmitido(BigDecimal gasAlojamientoAdmitido) {
		this.gasAlojamientoAdmitido = gasAlojamientoAdmitido;
	}

	/**
	 * Method 'getGasTraslado'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasTraslado() {
		return this.gasTraslado;
	}

	/**
	 * Method 'setGasTraslado'.
	 *
	 * @param gasTraslado
	 *            BigDecimal
	 * @return
	 */

	public void setGasTraslado(BigDecimal gasTraslado) {
		this.gasTraslado = gasTraslado;
	}

	/**
	 * Method 'getGasTrasladoAdmitido'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasTrasladoAdmitido() {
		return this.gasTrasladoAdmitido;
	}

	/**
	 * Method 'setGasTrasladoAdmitido'.
	 *
	 * @param gasTrasladoAdmitido
	 *            BigDecimal
	 * @return
	 */

	public void setGasTrasladoAdmitido(BigDecimal gasTrasladoAdmitido) {
		this.gasTrasladoAdmitido = gasTrasladoAdmitido;
	}

	/**
	 * Method 'getGasManutencion'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasManutencion() {
		return this.gasManutencion;
	}

	/**
	 * Method 'setGasManutencion'.
	 *
	 * @param gasManutencion
	 *            BigDecimal
	 * @return
	 */

	public void setGasManutencion(BigDecimal gasManutencion) {
		this.gasManutencion = gasManutencion;
	}

	/**
	 * Method 'getGasManutencionAdmitido'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getGasManutencionAdmitido() {
		return this.gasManutencionAdmitido;
	}

	/**
	 * Method 'setGasManutencionAdmitido'.
	 *
	 * @param gasManutencionAdmitido
	 *            BigDecimal
	 * @return
	 */

	public void setGasManutencionAdmitido(BigDecimal gasManutencionAdmitido) {
		this.gasManutencionAdmitido = gasManutencionAdmitido;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idAcciones: ").append(this.idAcciones).append(" ]");
		result.append(", [ titulo: ").append(this.titulo).append(" ]");
		result.append(", [ ponentes: ").append(this.ponentes).append(" ]");
		result.append(", [ fechaInicio: ").append(this.fechaInicio).append(" ]");
		result.append(", [ fechaFin: ").append(this.fechaFin).append(" ]");
		result.append(", [ duracion: ").append(this.duracion).append(" ]");
		result.append(", [ NEmpresasComerciales: ").append(this.NEmpresasComerciales).append(" ]");
		result.append(", [ NEmpresasAsistentes: ").append(this.NEmpresasAsistentes).append(" ]");
		result.append(", [ contratacion: ").append(this.contratacion).append(" ]");
		result.append(", [ contratacionAdmitida: ").append(this.contratacionAdmitida).append(" ]");
		result.append(", [ actPublicidad: ").append(this.actPublicidad).append(" ]");
		result.append(", [ actPublicidadAdmitida: ").append(this.actPublicidadAdmitida).append(" ]");
		result.append(", [ actMailing: ").append(this.actMailing).append(" ]");
		result.append(", [ actMailingAdmitido: ").append(this.actMailingAdmitido).append(" ]");
		result.append(", [ actImpresion: ").append(this.actImpresion).append(" ]");
		result.append(", [ actImpresionAdmitida: ").append(this.actImpresionAdmitida).append(" ]");
		result.append(", [ actDivulgacion: ").append(this.actDivulgacion).append(" ]");
		result.append(", [ actDivulgacionAdmitida: ").append(this.actDivulgacionAdmitida).append(" ]");
		result.append(", [ actDistribucion: ").append(this.actDistribucion).append(" ]");
		result.append(", [ actDistribucionAdmitida: ").append(this.actDistribucionAdmitida).append(" ]");
		result.append(", [ actOtros: ").append(this.actOtros).append(" ]");
		result.append(", [ actOtrosAdmitidos: ").append(this.actOtrosAdmitidos).append(" ]");
		result.append(", [ gasFotocopias: ").append(this.gasFotocopias).append(" ]");
		result.append(", [ gasFotocopiasAdmitido: ").append(this.gasFotocopiasAdmitido).append(" ]");
		result.append(", [ gasMaterial: ").append(this.gasMaterial).append(" ]");
		result.append(", [ gasMaterialAdmitida: ").append(this.gasMaterialAdmitida).append(" ]");
		result.append(", [ gasDocumentacion: ").append(this.gasDocumentacion).append(" ]");
		result.append(", [ gasDocumentacionAdmitida: ").append(this.gasDocumentacionAdmitida).append(" ]");
		result.append(", [ gasAlquiler: ").append(this.gasAlquiler).append(" ]");
		result.append(", [ gasAlquilerAdmitido: ").append(this.gasAlquilerAdmitido).append(" ]");
		result.append(", [ gasOtros: ").append(this.gasOtros).append(" ]");
		result.append(", [ gasOtrosAdmitidos: ").append(this.gasOtrosAdmitidos).append(" ]");
		result.append(", [ gasAlojamiento: ").append(this.gasAlojamiento).append(" ]");
		result.append(", [ gasAlojamientoAdmitido: ").append(this.gasAlojamientoAdmitido).append(" ]");
		result.append(", [ gasTraslado: ").append(this.gasTraslado).append(" ]");
		result.append(", [ gasTrasladoAdmitido: ").append(this.gasTrasladoAdmitido).append(" ]");
		result.append(", [ gasManutencion: ").append(this.gasManutencion).append(" ]");
		result.append(", [ gasManutencionAdmitido: ").append(this.gasManutencionAdmitido).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

}
