package com.ejie.ab60.model.DIV;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * EntidadesSolicitantes  
 * 
 *  
 */

public class EntidadesSolicitantes implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idEntidadSolicitante;
	private TiposAsociacion tiposAsociacion;
	private Long organoDirectivoMujeres;
	private Long organoDirectivoHombres;
	private Long antiguedadEntidad;
	private Long NSociosTotal;
	private Long NSociosMujeres;
	private Long NSociosHombres;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<RelExpEntSol> relExpEntSols = new ArrayList<RelExpEntSol>();
	private List<Acciones> accioneses = new ArrayList<Acciones>();

	/**
	 * Method 'EntidadesSolicitantes'.
	 */
	public EntidadesSolicitantes() {
	}

	/**
	 * Method 'EntidadesSolicitantes'.
	 * 
	 * @param idEntidadSolicitante
	 *            Integer
	 */
	public EntidadesSolicitantes(Integer idEntidadSolicitante) {
		this.idEntidadSolicitante = idEntidadSolicitante;
	}

	/**
	 * Method 'EntidadesSolicitantes'.
	 * 
	 * @param idEntidadSolicitante
	 *            Integer
	 * @param organoDirectivoMujeres
	 *            Long
	 * @param organoDirectivoHombres
	 *            Long
	 * @param antiguedadEntidad
	 *            Long
	 * @param NSociosTotal
	 *            Long
	 * @param NSociosMujeres
	 *            Long
	 * @param NSociosHombres
	 *            Long
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 */
	public EntidadesSolicitantes(Integer idEntidadSolicitante, Long organoDirectivoMujeres, Long organoDirectivoHombres,
			Long antiguedadEntidad, Long NSociosTotal, Long NSociosMujeres, Long NSociosHombres, Date fechaRegistro,
			String usuarioRegistro, TiposAsociacion tiposAsociacion) {
		this.idEntidadSolicitante = idEntidadSolicitante;
		this.tiposAsociacion = tiposAsociacion;
		this.organoDirectivoMujeres = organoDirectivoMujeres;
		this.organoDirectivoHombres = organoDirectivoHombres;
		this.antiguedadEntidad = antiguedadEntidad;
		this.NSociosTotal = NSociosTotal;
		this.NSociosMujeres = NSociosMujeres;
		this.NSociosHombres = NSociosHombres;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'EntidadesSolicitantes'.
	 * 
	 * @param idEntidadSolicitante
	 *            Integer
	 * @param organoDirectivoMujeres
	 *            Long
	 * @param organoDirectivoHombres
	 *            Long
	 * @param antiguedadEntidad
	 *            Long
	 * @param NSociosTotal
	 *            Long
	 * @param NSociosMujeres
	 *            Long
	 * @param NSociosHombres
	 *            Long
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 * @param relExpEntSols
	 *            List<RelExpEntSol>
	 * @param accioneses
	 *            List<Acciones>
	 */
	public EntidadesSolicitantes(Integer idEntidadSolicitante, Long organoDirectivoMujeres, Long organoDirectivoHombres,
			Long antiguedadEntidad, Long NSociosTotal, Long NSociosMujeres, Long NSociosHombres, Date fechaRegistro,
			String usuarioRegistro, TiposAsociacion tiposAsociacion, List<RelExpEntSol> relExpEntSols,
			List<Acciones> accioneses) {

		this.idEntidadSolicitante = idEntidadSolicitante;
		this.tiposAsociacion = tiposAsociacion;
		this.organoDirectivoMujeres = organoDirectivoMujeres;
		this.organoDirectivoHombres = organoDirectivoHombres;
		this.antiguedadEntidad = antiguedadEntidad;
		this.NSociosTotal = NSociosTotal;
		this.NSociosMujeres = NSociosMujeres;
		this.NSociosHombres = NSociosHombres;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.relExpEntSols = relExpEntSols;
		this.accioneses = accioneses;
	}

	/**
	 * Method 'getIdEntidadSolicitante'.
	 *
	 * @return Integer
	 */

	public Integer getIdEntidadSolicitante() {
		return this.idEntidadSolicitante;
	}

	/**
	 * Method 'setIdEntidadSolicitante'.
	 *
	 * @param idEntidadSolicitante
	 *            Integer
	 * @return
	 */

	public void setIdEntidadSolicitante(Integer idEntidadSolicitante) {
		this.idEntidadSolicitante = idEntidadSolicitante;
	}

	/**
	 * Method 'getTiposAsociacion'.
	 *
	 * @return TiposAsociacion
	 */
	@JsonIgnore

	public TiposAsociacion getTiposAsociacion() {
		return this.tiposAsociacion;
	}

	/**
	 * Method 'setTiposAsociacion'.
	 *
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 * @return
	 */

	public void setTiposAsociacion(TiposAsociacion tiposAsociacion) {
		this.tiposAsociacion = tiposAsociacion;
	}

	/**
	 * Method 'getOrganoDirectivoMujeres'.
	 *
	 * @return Long
	 */

	public Long getOrganoDirectivoMujeres() {
		return this.organoDirectivoMujeres;
	}

	/**
	 * Method 'setOrganoDirectivoMujeres'.
	 *
	 * @param organoDirectivoMujeres
	 *            Long
	 * @return
	 */

	public void setOrganoDirectivoMujeres(Long organoDirectivoMujeres) {
		this.organoDirectivoMujeres = organoDirectivoMujeres;
	}

	/**
	 * Method 'getOrganoDirectivoHombres'.
	 *
	 * @return Long
	 */

	public Long getOrganoDirectivoHombres() {
		return this.organoDirectivoHombres;
	}

	/**
	 * Method 'setOrganoDirectivoHombres'.
	 *
	 * @param organoDirectivoHombres
	 *            Long
	 * @return
	 */

	public void setOrganoDirectivoHombres(Long organoDirectivoHombres) {
		this.organoDirectivoHombres = organoDirectivoHombres;
	}

	/**
	 * Method 'getAntiguedadEntidad'.
	 *
	 * @return Long
	 */

	public Long getAntiguedadEntidad() {
		return this.antiguedadEntidad;
	}

	/**
	 * Method 'setAntiguedadEntidad'.
	 *
	 * @param antiguedadEntidad
	 *            Long
	 * @return
	 */

	public void setAntiguedadEntidad(Long antiguedadEntidad) {
		this.antiguedadEntidad = antiguedadEntidad;
	}

	/**
	 * Method 'getNSociosTotal'.
	 *
	 * @return Long
	 */

	public Long getNSociosTotal() {
		return this.NSociosTotal;
	}

	/**
	 * Method 'setNSociosTotal'.
	 *
	 * @param NSociosTotal
	 *            Long
	 * @return
	 */

	public void setNSociosTotal(Long NSociosTotal) {
		this.NSociosTotal = NSociosTotal;
	}

	/**
	 * Method 'getNSociosMujeres'.
	 *
	 * @return Long
	 */

	public Long getNSociosMujeres() {
		return this.NSociosMujeres;
	}

	/**
	 * Method 'setNSociosMujeres'.
	 *
	 * @param NSociosMujeres
	 *            Long
	 * @return
	 */

	public void setNSociosMujeres(Long NSociosMujeres) {
		this.NSociosMujeres = NSociosMujeres;
	}

	/**
	 * Method 'getNSociosHombres'.
	 *
	 * @return Long
	 */

	public Long getNSociosHombres() {
		return this.NSociosHombres;
	}

	/**
	 * Method 'setNSociosHombres'.
	 *
	 * @param NSociosHombres
	 *            Long
	 * @return
	 */

	public void setNSociosHombres(Long NSociosHombres) {
		this.NSociosHombres = NSociosHombres;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getRelExpEntSols'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<RelExpEntSol> getRelExpEntSols() {
		return this.relExpEntSols;
	}

	/**
	 * Method 'setRelExpEntSols'.
	 *
	 * @param relExpEntSols
	 *            List
	 * @return
	 */
	public void setRelExpEntSols(List<RelExpEntSol> relExpEntSols) {
		this.relExpEntSols = relExpEntSols;
	}

	/**
	 * Method 'getAccioneses'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<Acciones> getAccioneses() {
		return this.accioneses;
	}

	/**
	 * Method 'setAccioneses'.
	 *
	 * @param accioneses
	 *            List
	 * @return
	 */
	public void setAccioneses(List<Acciones> accioneses) {
		this.accioneses = accioneses;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idEntidadSolicitante: ").append(this.idEntidadSolicitante).append(" ]");
		result.append(", [ organoDirectivoMujeres: ").append(this.organoDirectivoMujeres).append(" ]");
		result.append(", [ organoDirectivoHombres: ").append(this.organoDirectivoHombres).append(" ]");
		result.append(", [ antiguedadEntidad: ").append(this.antiguedadEntidad).append(" ]");
		result.append(", [ NSociosTotal: ").append(this.NSociosTotal).append(" ]");
		result.append(", [ NSociosMujeres: ").append(this.NSociosMujeres).append(" ]");
		result.append(", [ NSociosHombres: ").append(this.NSociosHombres).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
