package com.ejie.ab60.model.DIV;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * TiposActividad  
 * 
 *  
 */

public class TiposActividad implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idTipoActividad;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private BigDecimal limiteActividad;
	private BigDecimal maximoHora;
	private BigDecimal limiteContratacion;
	private BigDecimal limiteResto;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<Acciones> accioneses = new ArrayList<Acciones>();

	/**
	 * Method 'TiposActividad'.
	 */
	public TiposActividad() {
	}

	/**
	 * Method 'TiposActividad'.
	 * 
	 * @param idTipoActividad
	 *            Long
	 */
	public TiposActividad(Long idTipoActividad) {
		this.idTipoActividad = idTipoActividad;
	}

	/**
	 * Method 'TiposActividad'.
	 * 
	 * @param idTipoActividad
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param limiteActividad
	 *            BigDecimal
	 * @param maximoHora
	 *            BigDecimal
	 * @param limiteContratacion
	 *            BigDecimal
	 * @param limiteResto
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public TiposActividad(Long idTipoActividad, String descripcionCastellano, String descripcionEuskera,
			BigDecimal limiteActividad, BigDecimal maximoHora, BigDecimal limiteContratacion, BigDecimal limiteResto,
			Date fechaRegistro, String usuarioRegistro) {
		this.idTipoActividad = idTipoActividad;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.limiteActividad = limiteActividad;
		this.maximoHora = maximoHora;
		this.limiteContratacion = limiteContratacion;
		this.limiteResto = limiteResto;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'TiposActividad'.
	 * 
	 * @param idTipoActividad
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param limiteActividad
	 *            BigDecimal
	 * @param maximoHora
	 *            BigDecimal
	 * @param limiteContratacion
	 *            BigDecimal
	 * @param limiteResto
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param accioneses
	 *            List<Acciones>
	 */
	public TiposActividad(Long idTipoActividad, String descripcionCastellano, String descripcionEuskera,
			BigDecimal limiteActividad, BigDecimal maximoHora, BigDecimal limiteContratacion, BigDecimal limiteResto,
			Date fechaRegistro, String usuarioRegistro, List<Acciones> accioneses) {

		this.idTipoActividad = idTipoActividad;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.limiteActividad = limiteActividad;
		this.maximoHora = maximoHora;
		this.limiteContratacion = limiteContratacion;
		this.limiteResto = limiteResto;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.accioneses = accioneses;
	}

	/**
	 * Method 'getIdTipoActividad'.
	 *
	 * @return Long
	 */

	public Long getIdTipoActividad() {
		return this.idTipoActividad;
	}

	/**
	 * Method 'setIdTipoActividad'.
	 *
	 * @param idTipoActividad
	 *            Long
	 * @return
	 */

	public void setIdTipoActividad(Long idTipoActividad) {
		this.idTipoActividad = idTipoActividad;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getLimiteActividad'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getLimiteActividad() {
		return this.limiteActividad;
	}

	/**
	 * Method 'setLimiteActividad'.
	 *
	 * @param limiteActividad
	 *            BigDecimal
	 * @return
	 */

	public void setLimiteActividad(BigDecimal limiteActividad) {
		this.limiteActividad = limiteActividad;
	}

	/**
	 * Method 'getMaximoHora'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getMaximoHora() {
		return this.maximoHora;
	}

	/**
	 * Method 'setMaximoHora'.
	 *
	 * @param maximoHora
	 *            BigDecimal
	 * @return
	 */

	public void setMaximoHora(BigDecimal maximoHora) {
		this.maximoHora = maximoHora;
	}

	/**
	 * Method 'getLimiteContratacion'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getLimiteContratacion() {
		return this.limiteContratacion;
	}

	/**
	 * Method 'setLimiteContratacion'.
	 *
	 * @param limiteContratacion
	 *            BigDecimal
	 * @return
	 */

	public void setLimiteContratacion(BigDecimal limiteContratacion) {
		this.limiteContratacion = limiteContratacion;
	}

	/**
	 * Method 'getLimiteResto'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getLimiteResto() {
		return this.limiteResto;
	}

	/**
	 * Method 'setLimiteResto'.
	 *
	 * @param limiteResto
	 *            BigDecimal
	 * @return
	 */

	public void setLimiteResto(BigDecimal limiteResto) {
		this.limiteResto = limiteResto;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getAccioneses'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<Acciones> getAccioneses() {
		return this.accioneses;
	}

	/**
	 * Method 'setAccioneses'.
	 *
	 * @param accioneses
	 *            List
	 * @return
	 */
	public void setAccioneses(List<Acciones> accioneses) {
		this.accioneses = accioneses;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idTipoActividad: ").append(this.idTipoActividad).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ limiteActividad: ").append(this.limiteActividad).append(" ]");
		result.append(", [ maximoHora: ").append(this.maximoHora).append(" ]");
		result.append(", [ limiteContratacion: ").append(this.limiteContratacion).append(" ]");
		result.append(", [ limiteResto: ").append(this.limiteResto).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
