package com.ejie.ab60.model.DIV;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * TiposAsociacion  
 * 
 *  
 */

public class TiposAsociacion implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idTipoAsociacion;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<EntidadesSolicitantes> entidadesSolicitanteses = new ArrayList<EntidadesSolicitantes>();

	/**
	 * Method 'TiposAsociacion'.
	 */
	public TiposAsociacion() {
	}

	/**
	 * Method 'TiposAsociacion'.
	 * 
	 * @param idTipoAsociacion
	 *            Long
	 */
	public TiposAsociacion(Long idTipoAsociacion) {
		this.idTipoAsociacion = idTipoAsociacion;
	}

	/**
	 * Method 'TiposAsociacion'.
	 * 
	 * @param idTipoAsociacion
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public TiposAsociacion(Long idTipoAsociacion, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro) {
		this.idTipoAsociacion = idTipoAsociacion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'TiposAsociacion'.
	 * 
	 * @param idTipoAsociacion
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param entidadesSolicitanteses
	 *            List<EntidadesSolicitantes>
	 */
	public TiposAsociacion(Long idTipoAsociacion, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro, List<EntidadesSolicitantes> entidadesSolicitanteses) {

		this.idTipoAsociacion = idTipoAsociacion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.entidadesSolicitanteses = entidadesSolicitanteses;
	}

	/**
	 * Method 'getIdTipoAsociacion'.
	 *
	 * @return Long
	 */

	public Long getIdTipoAsociacion() {
		return this.idTipoAsociacion;
	}

	/**
	 * Method 'setIdTipoAsociacion'.
	 *
	 * @param idTipoAsociacion
	 *            Long
	 * @return
	 */

	public void setIdTipoAsociacion(Long idTipoAsociacion) {
		this.idTipoAsociacion = idTipoAsociacion;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getEntidadesSolicitanteses'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<EntidadesSolicitantes> getEntidadesSolicitanteses() {
		return this.entidadesSolicitanteses;
	}

	/**
	 * Method 'setEntidadesSolicitanteses'.
	 *
	 * @param entidadesSolicitanteses
	 *            List
	 * @return
	 */
	public void setEntidadesSolicitanteses(List<EntidadesSolicitantes> entidadesSolicitanteses) {
		this.entidadesSolicitanteses = entidadesSolicitanteses;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idTipoAsociacion: ").append(this.idTipoAsociacion).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
