package com.ejie.ab60.model.MEC;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.ab60.model.actuacionesSubvencionables.ActSubvencionable;
import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.ab60.model.estudioTecnico.MotivosDenegacion;
import com.ejie.ab60.model.estudioTecnico.MotivosMinoracion;
import com.ejie.ab60.model.justificacion.RelTipGasCon;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Facturas  
 * 
 *  
 */

public class Facturas implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idFactura;
	private RelExpActSub relExpActSub;
	private Date fechaFactura;
	private String numeroFactura;
	private String descripcion;
	private String proveedor;
	private BigDecimal importe;
	private Integer pagado;
	private Date fechaPagado;
	private BigDecimal importeAdmitido;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private String observacionesEuskera;
	private String observacionesCastellano;

	private Integer inspeccionable;
	private BigDecimal presentado;
	private BigDecimal admitido;

	private String fechaFacturaStr;
	private String fechaPagadoStr;

	private List<MotivosMinoracion> comboFacturaMinoracion = new ArrayList<MotivosMinoracion>();
	private List<MotivosDenegacion> comboFacturaDenegacion = new ArrayList<MotivosDenegacion>();

	private RelTipGasCon relTipGasCon;
	private Integer enviadoInspeccionar;

	private ActSubvencionable actSubvencionable;

	private String descripcionCastellano;
	private String descripcionEuskera;

	/**
	 * Method 'Facturas'.
	 */
	public Facturas() {
	}

	/**
	 * Method 'Facturas'.
	 * 
	 * @param idFactura
	 *            Integer
	 */
	public Facturas(Integer idFactura) {
		this.idFactura = idFactura;
	}

	public Facturas(BigDecimal importe, BigDecimal importeAdmitido) {
		this.importe = importe;
		this.importeAdmitido = importeAdmitido;
	}

	/**
	 * Method 'Facturas'.
	 * 
	 * @param idFactura
	 *            Integer
	 * @param fechaFactura
	 *            Date
	 * @param numeroFactura
	 *            String
	 * @param descripcion
	 *            String
	 * @param proveedor
	 *            String
	 * @param importe
	 *            BigDecimal
	 * @param pagado
	 *            Integer
	 * @param fechaPagado
	 *            Date
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param relExpActSub
	 *            RelExpActSub
	 */
	public Facturas(Integer idFactura, Date fechaFactura, String numeroFactura, String descripcion, String proveedor,
			BigDecimal importe, Integer pagado, Date fechaPagado, BigDecimal importeAdmitido,
			String observacionesEuskera, String observacionesCastellano, Integer inspeccionable, Date fechaRegistro,
			String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion, RelExpActSub relExpActSub,
			RelTipGasCon relTipoGasCon) {

		this.idFactura = idFactura;
		this.relExpActSub = relExpActSub;
		this.fechaFactura = fechaFactura;
		this.numeroFactura = numeroFactura;
		this.descripcion = descripcion;
		this.proveedor = proveedor;
		this.importe = importe;
		this.pagado = pagado;
		this.fechaPagado = fechaPagado;
		this.importeAdmitido = importeAdmitido;

		this.observacionesEuskera = observacionesEuskera;
		this.observacionesCastellano = observacionesCastellano;
		this.inspeccionable = inspeccionable;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.relTipGasCon = relTipoGasCon;
	}

	public Facturas(Integer idFactura, Date fechaFactura, String numeroFactura, String descripcion, String proveedor,
			BigDecimal importe, BigDecimal importeAdmitido, String observacionesEuskera, String observacionesCastellano,
			Integer inspeccionable, Integer enviadoInspeccionar) {
		super();
		this.idFactura = idFactura;
		this.fechaFactura = fechaFactura;
		this.numeroFactura = numeroFactura;
		this.descripcion = descripcion;
		this.proveedor = proveedor;
		this.importe = importe;
		this.importeAdmitido = importeAdmitido;
		this.observacionesEuskera = observacionesEuskera;
		this.observacionesCastellano = observacionesCastellano;
		this.inspeccionable = inspeccionable;
		this.enviadoInspeccionar = enviadoInspeccionar;
	}

	/**
	 * Method 'Facturas'.
	 * 
	 * @param idFactura
	 *            Integer
	 * @param fechaFactura
	 *            Date
	 * @param numeroFactura
	 *            String
	 * @param descripcion
	 *            String
	 * @param proveedor
	 *            String
	 * @param importe
	 *            BigDecimal
	 * @param pagado
	 *            Integer
	 * @param fechaPagado
	 *            Date
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param idMotivoDenegacion,
	 *            Long
	 * @param idMotivoMinoracion,
	 *            Long
	 * @param observacionesEuskera
	 *            String
	 * @param observacionesCastellano
	 *            String
	 * @param inspeccionable
	 *            Boolean
	 * @param relExpActSub
	 *            RelExpActSub
	 */
	public Facturas(Integer idFactura, String numeroFactura, Date fechaFactura, String descripcion, String proveedor,
			BigDecimal importe, Integer pagado, Date fechaPagado, BigDecimal importeAdmitido,
			String observacionesEuskera, String observacionesCastellano, Integer inspeccionable,
			RelExpActSub relExpActSub) {
		this.idFactura = idFactura;
		this.numeroFactura = numeroFactura;
		this.fechaFactura = fechaFactura;
		this.descripcion = descripcion;
		this.proveedor = proveedor;
		this.importe = importe;
		this.pagado = pagado;
		this.fechaPagado = fechaPagado;
		this.importeAdmitido = importeAdmitido;
		this.observacionesEuskera = observacionesEuskera;
		this.observacionesCastellano = observacionesCastellano;
		this.inspeccionable = inspeccionable;
		this.relExpActSub = relExpActSub;

	}

	/**
	 * Method 'Facturas'.
	 * 
	 * 
	 * @param importe
	 *            BigDecimal
	 * 
	 * 
	 * @param importeAdmitido
	 *            BigDecimal
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 */
	public Facturas(BigDecimal importe, BigDecimal importeAdmitido, RelExpActSub relExpActSub) {

		this.relExpActSub = relExpActSub;
		this.importe = importe;
		this.importeAdmitido = importeAdmitido;

	}

	public Facturas(Integer idFactura, String descripcion) {
		this.idFactura = idFactura;
		this.descripcion = descripcion;
	}

	/**
	 * Method 'getIdFactura'.
	 *
	 * @return Integer
	 */

	public Integer getIdFactura() {
		return this.idFactura;
	}

	/**
	 * Method 'setIdFactura'.
	 *
	 * @param idFactura
	 *            Integer
	 * @return
	 */

	public void setIdFactura(Integer idFactura) {
		this.idFactura = idFactura;
	}

	/**
	 * Method 'getRelExpActSub'.
	 *
	 * @return RelExpActSub
	 */

	public RelExpActSub getRelExpActSub() {
		return this.relExpActSub;
	}

	/**
	 * Method 'setRelExpActSub'.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return
	 */

	public void setRelExpActSub(RelExpActSub relExpActSub) {
		this.relExpActSub = relExpActSub;
	}

	/**
	 * Method 'getFechaFactura'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaFactura() {
		return this.fechaFactura;
	}

	/**
	 * Method 'setFechaFactura'.
	 *
	 * @param fechaFactura
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaFactura(Date fechaFactura) {
		this.fechaFactura = fechaFactura;
	}

	/**
	 * Method 'getNumeroFactura'.
	 *
	 * @return String
	 */

	public String getNumeroFactura() {
		return this.numeroFactura;
	}

	/**
	 * Method 'setNumeroFactura'.
	 *
	 * @param numeroFactura
	 *            String
	 * @return
	 */

	public void setNumeroFactura(String numeroFactura) {
		this.numeroFactura = numeroFactura;
	}

	/**
	 * Method 'getDescripcion'.
	 *
	 * @return String
	 */

	public String getDescripcion() {
		return this.descripcion;
	}

	/**
	 * Method 'setDescripcion'.
	 *
	 * @param descripcion
	 *            String
	 * @return
	 */

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	/**
	 * Method 'getProveedor'.
	 *
	 * @return String
	 */

	public String getProveedor() {
		return this.proveedor;
	}

	/**
	 * Method 'setProveedor'.
	 *
	 * @param proveedor
	 *            String
	 * @return
	 */

	public void setProveedor(String proveedor) {
		this.proveedor = proveedor;
	}

	/**
	 * Method 'getImporte'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporte() {
		return this.importe;
	}

	/**
	 * Method 'setImporte'.
	 *
	 * @param importe
	 *            BigDecimal
	 * @return
	 */

	public void setImporte(BigDecimal importe) {
		this.importe = importe;
	}

	/**
	 * Method 'getPagado'.
	 *
	 * @return Integer
	 */

	public Integer getPagado() {
		return this.pagado;
	}

	/**
	 * Method 'setPagado'.
	 *
	 * @param pagado
	 *            Integer
	 * @return
	 */

	public void setPagado(Integer pagado) {
		this.pagado = pagado;
	}

	/**
	 * Method 'getFechaPagado'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaPagado() {
		return this.fechaPagado;
	}

	/**
	 * Method 'setFechaPagado'.
	 *
	 * @param fechaPagado
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaPagado(Date fechaPagado) {
		this.fechaPagado = fechaPagado;
	}

	/**
	 * Method 'getImporteAdmitido'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporteAdmitido() {
		return this.importeAdmitido;
	}

	/**
	 * Method 'setImporteAdmitido'.
	 *
	 * @param importeAdmitido
	 *            BigDecimal
	 * @return
	 */

	public void setImporteAdmitido(BigDecimal importeAdmitido) {
		this.importeAdmitido = importeAdmitido;
	}

	/**
	 * Method 'getImporteMask'.
	 *
	 * @return BigDecimal
	 */

	public String getimporteAdmitidoMask() {

		return UtilDate.formatearMiles(importeAdmitido);

	}

	/**
	 * Method 'getImporteMask'.
	 *
	 * @return BigDecimal
	 */

	public String getimporteMask() {
		return UtilDate.formatearMiles(importe);

	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idFactura: ").append(this.idFactura).append(" ]");
		result.append(", [ fechaFactura: ").append(this.fechaFactura).append(" ]");
		result.append(", [ numeroFactura: ").append(this.numeroFactura).append(" ]");
		result.append(", [ descripcion: ").append(this.descripcion).append(" ]");
		result.append(", [ proveedor: ").append(this.proveedor).append(" ]");
		result.append(", [ importe: ").append(this.importe).append(" ]");
		result.append(", [ pagado: ").append(this.pagado).append(" ]");
		result.append(", [ fechaPagado: ").append(this.fechaPagado).append(" ]");
		result.append(", [ importeAdmitido: ").append(this.importeAdmitido).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

	/**
	 * @return the presentado
	 */
	public BigDecimal getPresentado() {
		return presentado;
	}

	/**
	 * @param presentado
	 *            the presentado to set
	 */
	public void setPresentado(BigDecimal presentado) {
		this.presentado = presentado;
	}

	/**
	 * @return the admitido
	 */
	public BigDecimal getAdmitido() {
		return admitido;
	}

	/**
	 * @param admitido
	 *            the admitido to set
	 */
	public void setAdmitido(BigDecimal admitido) {
		this.admitido = admitido;
	}

	/**
	 * @return the fechaFacturaStr
	 */
	public String getFechaFacturaStr() {
		return fechaFacturaStr;
	}

	/**
	 * @param fechaFacturaStr
	 *            the fechaFacturaStr to set
	 */
	public void setFechaFacturaStr(String fechaFacturaStr) {
		this.fechaFacturaStr = fechaFacturaStr;
	}

	/**
	 * @return the fechaPagadoStr
	 */
	public String getFechaPagadoStr() {
		return fechaPagadoStr;
	}

	/**
	 * @param fechaPagadoStr
	 *            the fechaPagadoStr to set
	 */
	public void setFechaPagadoStr(String fechaPagadoStr) {
		this.fechaPagadoStr = fechaPagadoStr;
	}

	/**
	 * @return the observacionesEuskera
	 */
	public String getObservacionesEuskera() {
		return observacionesEuskera;
	}

	/**
	 * @param observacionesEuskera
	 *            the observacionesEuskera to set
	 */
	public void setObservacionesEuskera(String observacionesEuskera) {
		this.observacionesEuskera = observacionesEuskera;
	}

	/**
	 * @return the observacionesCastellano
	 */
	public String getObservacionesCastellano() {
		return observacionesCastellano;
	}

	/**
	 * @param observacionesCastellano
	 *            the observacionesCastellano to set
	 */
	public void setObservacionesCastellano(String observacionesCastellano) {
		this.observacionesCastellano = observacionesCastellano;
	}

	public Integer getInspeccionable() {
		return inspeccionable;
	}

	public void setInspeccionable(Integer inspeccionable) {
		this.inspeccionable = inspeccionable;
	}

	/**
	 * @return the comboFacturaMinoracion
	 */
	public List<MotivosMinoracion> getComboFacturaMinoracion() {
		return comboFacturaMinoracion;
	}

	/**
	 * @param comboFacturaMinoracion
	 *            the comboFacturaMinoracion to set
	 */
	public void setComboFacturaMinoracion(List<MotivosMinoracion> comboFacturaMinoracion) {
		this.comboFacturaMinoracion = comboFacturaMinoracion;
	}

	/**
	 * @return the comboFacturaDenegacion
	 */
	public List<MotivosDenegacion> getComboFacturaDenegacion() {
		return comboFacturaDenegacion;
	}

	/**
	 * @param comboFacturaDenegacion
	 *            the comboFacturaDenegacion to set
	 */
	public void setComboFacturaDenegacion(List<MotivosDenegacion> comboFacturaDenegacion) {
		this.comboFacturaDenegacion = comboFacturaDenegacion;
	}

	/**
	 * @return the relTipGasCon
	 */
	public RelTipGasCon getRelTipGasCon() {
		return relTipGasCon;
	}

	/**
	 * @param relTipGasCon
	 *            the relTipGasCon to set
	 */
	public void setRelTipGasCon(RelTipGasCon relTipGasCon) {
		this.relTipGasCon = relTipGasCon;
	}

	/**
	 * @return the enviadoInspeccionar
	 */
	public Integer getEnviadoInspeccionar() {
		return enviadoInspeccionar;
	}

	/**
	 * @param enviadoInspeccionar
	 *            the enviadoInspeccionar to set
	 */
	public void setEnviadoInspeccionar(Integer enviadoInspeccionar) {
		this.enviadoInspeccionar = enviadoInspeccionar;
	}

	/**
	 * @return the descripcionCastellano
	 */
	public String getDescripcionCastellano() {
		return descripcionCastellano;
	}

	/**
	 * @param descripcionCastellano
	 *            the descripcionCastellano to set
	 */
	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * @return the descripcionEuskera
	 */
	public String getDescripcionEuskera() {
		return descripcionEuskera;
	}

	/**
	 * @param descripcionEuskera
	 *            the descripcionEuskera to set
	 */
	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * @return the actSubvencionable
	 */
	public ActSubvencionable getActSubvencionable() {
		return actSubvencionable;
	}

	/**
	 * @param actSubvencionable
	 *            the actSubvencionable to set
	 */
	public void setActSubvencionable(ActSubvencionable actSubvencionable) {
		this.actSubvencionable = actSubvencionable;
	}
}
