package com.ejie.ab60.model;

import java.math.BigDecimal;
import java.util.Date;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * OtrosIngresos  
 * 
 *  
 */

public class OtrosIngresos implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idOtrosIngresos;
	private Integer idRelExpActSub;
	private BigDecimal importe;
	private Integer fase;
	private Date fechaRegistro;
	private String usuarioRegistro;

	/**
	 * Method 'OtrosIngresos'.
	 */
	public OtrosIngresos() {
	}

	/**
	 * Method 'OtrosIngresos'.
	 * 
	 * @param idOtrosIngresos
	 *            Integer
	 */
	public OtrosIngresos(Integer idOtrosIngresos) {
		this.idOtrosIngresos = idOtrosIngresos;
	}

	/**
	 * Method 'OtrosIngresos'.
	 * 
	 * @param idOtrosIngresos
	 *            Integer
	 * @param idRelExpActSub
	 *            Integer
	 * @param importe
	 *            BigDecimal
	 * @param fase
	 *            Integer
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public OtrosIngresos(Integer idOtrosIngresos, Integer idRelExpActSub, BigDecimal importe, Integer fase,
			Date fechaRegistro, String usuarioRegistro) {

		this.idOtrosIngresos = idOtrosIngresos;
		this.idRelExpActSub = idRelExpActSub;
		this.importe = importe;
		this.fase = fase;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getIdOtrosIngresos'.
	 *
	 * @return Integer
	 */

	public Integer getIdOtrosIngresos() {
		return this.idOtrosIngresos;
	}

	/**
	 * Method 'setIdOtrosIngresos'.
	 *
	 * @param idOtrosIngresos
	 *            Integer
	 * @return
	 */

	public void setIdOtrosIngresos(Integer idOtrosIngresos) {
		this.idOtrosIngresos = idOtrosIngresos;
	}

	/**
	 * Method 'getIdRelExpActSub'.
	 *
	 * @return Integer
	 */

	public Integer getIdRelExpActSub() {
		return this.idRelExpActSub;
	}

	/**
	 * Method 'setIdRelExpActSub'.
	 *
	 * @param idRelExpActSub
	 *            Integer
	 * @return
	 */

	public void setIdRelExpActSub(Integer idRelExpActSub) {
		this.idRelExpActSub = idRelExpActSub;
	}

	/**
	 * Method 'getImporte'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporte() {
		return this.importe;
	}

	/**
	 * Method 'setImporte'.
	 *
	 * @param integer
	 *            BigDecimal
	 * @return
	 */

	public void setImporte(BigDecimal integer) {
		this.importe = integer;
	}

	/**
	 * Method 'getFase'.
	 *
	 * @return Integer
	 */

	public Integer getFase() {
		return this.fase;
	}

	/**
	 * Method 'setFase'.
	 *
	 * @param fase
	 *            Integer
	 * @return
	 */

	public void setFase(Integer fase) {
		this.fase = fase;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idOtrosIngresos: ").append(this.idOtrosIngresos).append(" ]");
		result.append(", [ idRelExpActSub: ").append(this.idRelExpActSub).append(" ]");
		result.append(", [ importe: ").append(this.importe).append(" ]");
		result.append(", [ fase: ").append(this.fase).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
