package com.ejie.ab60.model.PTT;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * AmbitosTerritoriales  
 * 
 *  
 */

public class AmbitosTerritoriales implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idAmbitoTerritorial;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<RelExpAmbTer> relExpAmbTers = new ArrayList<RelExpAmbTer>();

	/**
	 * Method 'AmbitosTerritoriales'.
	 */
	public AmbitosTerritoriales() {
	}

	/**
	 * Method 'AmbitosTerritoriales'.
	 * 
	 * @param idAmbitoTerritorial
	 *            Long
	 */
	public AmbitosTerritoriales(Long idAmbitoTerritorial) {
		this.idAmbitoTerritorial = idAmbitoTerritorial;
	}

	/**
	 * Method 'AmbitosTerritoriales'.
	 * 
	 * @param idAmbitoTerritorial
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public AmbitosTerritoriales(Long idAmbitoTerritorial, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro) {
		this.idAmbitoTerritorial = idAmbitoTerritorial;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'AmbitosTerritoriales'.
	 * 
	 * @param idAmbitoTerritorial
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param relExpAmbTers
	 *            List<RelExpAmbTer>
	 */
	public AmbitosTerritoriales(Long idAmbitoTerritorial, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro, List<RelExpAmbTer> relExpAmbTers) {

		this.idAmbitoTerritorial = idAmbitoTerritorial;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.relExpAmbTers = relExpAmbTers;
	}

	/**
	 * Method 'getIdAmbitoTerritorial'.
	 *
	 * @return Long
	 */

	public Long getIdAmbitoTerritorial() {
		return this.idAmbitoTerritorial;
	}

	/**
	 * Method 'setIdAmbitoTerritorial'.
	 *
	 * @param idAmbitoTerritorial
	 *            Long
	 * @return
	 */

	public void setIdAmbitoTerritorial(Long idAmbitoTerritorial) {
		this.idAmbitoTerritorial = idAmbitoTerritorial;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getRelExpAmbTers'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<RelExpAmbTer> getRelExpAmbTers() {
		return this.relExpAmbTers;
	}

	/**
	 * Method 'setRelExpAmbTers'.
	 *
	 * @param relExpAmbTers
	 *            List
	 * @return
	 */
	public void setRelExpAmbTers(List<RelExpAmbTer> relExpAmbTers) {
		this.relExpAmbTers = relExpAmbTers;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idAmbitoTerritorial: ").append(this.idAmbitoTerritorial).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
