package com.ejie.ab60.model.PTT;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Competitividad  
 * 
 *  
 */

public class Competitividad implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idCompetitividad;
	private RelExpActSub relExpActSub;
	private Long NEmpresasDistintas;
	private Long NTrabajadores;
	private Long NMujeres;
	private Long NHombres;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<PersonasContratadas> personasContratadases = new ArrayList<PersonasContratadas>();

	/**
	 * Method 'Competitividad'.
	 */
	public Competitividad() {
	}

	/**
	 * Method 'Competitividad'.
	 * 
	 * @param idCompetitividad
	 *            Integer
	 */
	public Competitividad(Integer idCompetitividad) {
		this.idCompetitividad = idCompetitividad;
	}

	/**
	 * Method 'Competitividad'.
	 * 
	 * @param idCompetitividad
	 *            Integer
	 * @param NEmpresasDistintas
	 *            Long
	 * @param NTrabajadores
	 *            Long
	 * @param NMujeres
	 *            Long
	 * @param NHombres
	 *            Long
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param relExpActSub
	 *            RelExpActSub
	 */
	public Competitividad(Integer idCompetitividad, Long NEmpresasDistintas, Long NTrabajadores, Long NMujeres,
			Long NHombres, Date fechaRegistro, String usuarioRegistro, RelExpActSub relExpActSub) {
		this.idCompetitividad = idCompetitividad;
		this.relExpActSub = relExpActSub;
		this.NEmpresasDistintas = NEmpresasDistintas;
		this.NTrabajadores = NTrabajadores;
		this.NMujeres = NMujeres;
		this.NHombres = NHombres;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'Competitividad'.
	 * 
	 * @param idCompetitividad
	 *            Integer
	 * @param NEmpresasDistintas
	 *            Long
	 * @param NTrabajadores
	 *            Long
	 * @param NMujeres
	 *            Long
	 * @param NHombres
	 *            Long
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param relExpActSub
	 *            RelExpActSub
	 * @param personasContratadases
	 *            List<PersonasContratadas>
	 */
	public Competitividad(Integer idCompetitividad, Long NEmpresasDistintas, Long NTrabajadores, Long NMujeres,
			Long NHombres, Date fechaRegistro, String usuarioRegistro, RelExpActSub relExpActSub,
			List<PersonasContratadas> personasContratadases) {

		this.idCompetitividad = idCompetitividad;
		this.relExpActSub = relExpActSub;
		this.NEmpresasDistintas = NEmpresasDistintas;
		this.NTrabajadores = NTrabajadores;
		this.NMujeres = NMujeres;
		this.NHombres = NHombres;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.personasContratadases = personasContratadases;
	}

	/**
	 * Method 'getidCompetitividad'.
	 *
	 * @return Integer
	 */

	public Integer getIdCompetitividad() {
		return this.idCompetitividad;
	}

	/**
	 * Method 'setidCompetitividad'.
	 *
	 * @param idCompetitividad
	 *            Integer
	 * @return
	 */

	public void setIdCompetitividad(Integer idCompetitividad) {
		this.idCompetitividad = idCompetitividad;
	}

	/**
	 * Method 'getRelExpActSub'.
	 *
	 * @return RelExpActSub
	 */
	@JsonIgnore

	public RelExpActSub getRelExpActSub() {
		return this.relExpActSub;
	}

	/**
	 * Method 'setRelExpActSub'.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return
	 */

	public void setRelExpActSub(RelExpActSub relExpActSub) {
		this.relExpActSub = relExpActSub;
	}

	/**
	 * Method 'getNEmpresasDistintas'.
	 *
	 * @return Long
	 */

	public Long getNEmpresasDistintas() {
		return this.NEmpresasDistintas;
	}

	/**
	 * Method 'setNEmpresasDistintas'.
	 *
	 * @param NEmpresasDistintas
	 *            Long
	 * @return
	 */

	public void setNEmpresasDistintas(Long NEmpresasDistintas) {
		this.NEmpresasDistintas = NEmpresasDistintas;
	}

	/**
	 * Method 'getNTrabajadores'.
	 *
	 * @return Long
	 */

	public Long getNTrabajadores() {
		return this.NTrabajadores;
	}

	/**
	 * Method 'setNTrabajadores'.
	 *
	 * @param NTrabajadores
	 *            Long
	 * @return
	 */

	public void setNTrabajadores(Long NTrabajadores) {
		this.NTrabajadores = NTrabajadores;
	}

	/**
	 * Method 'getNMujeres'.
	 *
	 * @return Long
	 */

	public Long getNMujeres() {
		return this.NMujeres;
	}

	/**
	 * Method 'setNMujeres'.
	 *
	 * @param NMujeres
	 *            Long
	 * @return
	 */

	public void setNMujeres(Long NMujeres) {
		this.NMujeres = NMujeres;
	}

	/**
	 * Method 'getNHombres'.
	 *
	 * @return Long
	 */

	public Long getNHombres() {
		return this.NHombres;
	}

	/**
	 * Method 'setNHombres'.
	 *
	 * @param NHombres
	 *            Long
	 * @return
	 */

	public void setNHombres(Long NHombres) {
		this.NHombres = NHombres;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getPersonasContratadases'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<PersonasContratadas> getPersonasContratadases() {
		return this.personasContratadases;
	}

	/**
	 * Method 'setPersonasContratadases'.
	 *
	 * @param personasContratadases
	 *            List
	 * @return
	 */
	public void setPersonasContratadases(List<PersonasContratadas> personasContratadases) {
		this.personasContratadases = personasContratadases;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idCompetitividad: ").append(this.idCompetitividad).append(" ]");
		result.append(", [ NEmpresasDistintas: ").append(this.NEmpresasDistintas).append(" ]");
		result.append(", [ NTrabajadores: ").append(this.NTrabajadores).append(" ]");
		result.append(", [ NMujeres: ").append(this.NMujeres).append(" ]");
		result.append(", [ NHombres: ").append(this.NHombres).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
