package com.ejie.ab60.model.PTT;

import java.util.Date;

import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.ab60.model.terceros.Sexo;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * ContratacionesPersonal  
 * 
 *  
 */

public class ContratacionesPersonal implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idContratacionPersonal;
	private Integer idRelExpActSub;
	private RelExpActSub relExpActSub;
	private Integer idExpediente;
	private Integer idActSub;
	private ModalidadesContrato modalidadesContrato;
	private Long idModalidadContrato;
	private String nombre;
	private String apellido1;
	private String apellido2;
	private Sexo sexo;
	private Long idSexo;
	private String periodoContratacion;
	private String empresaContratada;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;

	/**
	 * Method 'ContratacionesPersonal'.
	 */
	public ContratacionesPersonal() {
	}

	/**
	 * Method 'ContratacionesPersonal'.
	 * 
	 * @param idContratacionPersonal
	 *            Integer
	 */
	public ContratacionesPersonal(Integer idContratacionPersonal) {
		this.idContratacionPersonal = idContratacionPersonal;
	}

	/**
	 * Method 'ContratacionesPersonal'.
	 * 
	 * @param idContratacionPersonal
	 *            Integer
	 * @param nombre
	 *            String
	 * @param apellido1
	 *            String
	 * @param apellido2
	 *            String
	 * @param idSexo
	 *            Long
	 * @param periodoContratacion
	 *            String
	 * @param empresaContratada
	 *            String
	 * @param importe
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param relExpActSub
	 *            RelExpActSub
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 */
	public ContratacionesPersonal(Integer idContratacionPersonal, String nombre, String apellido1, String apellido2,
			Long idSexo, String periodoContratacion, String empresaContratada, Date fechaRegistro,
			String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion, RelExpActSub relExpActSub,
			ModalidadesContrato modalidadesContrato) {

		this.idContratacionPersonal = idContratacionPersonal;
		this.relExpActSub = relExpActSub;
		this.modalidadesContrato = modalidadesContrato;
		this.nombre = nombre;
		this.apellido1 = apellido1;
		this.apellido2 = apellido2;
		this.idSexo = idSexo;
		this.periodoContratacion = periodoContratacion;
		this.empresaContratada = empresaContratada;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'ContratacionesPersonal'.
	 * 
	 * @param idContratacionPersonal
	 *            Integer
	 * @param nombre
	 *            String
	 * @param apellido1
	 *            String
	 * @param apellido2
	 *            String
	 * @param idSexo
	 *            Long
	 * @param periodoContratacion
	 *            String
	 * @param empresaContratada
	 *            String
	 * @param importe
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param idRelExpActSub
	 *            Integer
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 * @param inspeccionable
	 *            Integer
	 * @param observacionesCastellano
	 *            String
	 * @param observacionesEuskera
	 *            String
	 */
	public ContratacionesPersonal(Integer idContratacionPersonal, String nombre, String apellido1, String apellido2,
			Long idSexo, String periodoContratacion, String empresaContratada, RelExpActSub relExpActSub,
			ModalidadesContrato modalidadesContrato) {

		this.idContratacionPersonal = idContratacionPersonal;
		this.nombre = nombre;
		this.apellido1 = apellido1;
		this.apellido2 = apellido2;
		this.idSexo = idSexo;
		this.periodoContratacion = periodoContratacion;
		this.empresaContratada = empresaContratada;
		this.relExpActSub = relExpActSub;
		this.modalidadesContrato = modalidadesContrato;

	}

	/**
	 * Method 'ContratacionesPersonal'.
	 * 
	 * @param idContratacionPersonal
	 *            Integer
	 * @param nombre
	 *            String
	 * @param apellido1
	 *            String
	 * @param apellido2
	 *            String
	 * @param idSexo
	 *            Long
	 * @param periodoContratacion
	 *            String
	 * @param empresaContratada
	 *            String
	 * @param importe
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param idRelExpActSub
	 *            Integer
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 * @param inspeccionable
	 *            Integer
	 * @param observacionesCastellano
	 *            String
	 * @param observacionesEuskera
	 *            String
	 */
	public ContratacionesPersonal(Integer idContratacionPersonal, String nombre, String apellido1, String apellido2,
			Sexo sexo, String periodoContratacion, String empresaContratada, RelExpActSub relExpActSub,
			ModalidadesContrato modalidadesContrato) {

		this.idContratacionPersonal = idContratacionPersonal;
		this.nombre = nombre;
		this.apellido1 = apellido1;
		this.apellido2 = apellido2;
		this.sexo = sexo;
		this.periodoContratacion = periodoContratacion;
		this.empresaContratada = empresaContratada;
		this.relExpActSub = relExpActSub;
		this.modalidadesContrato = modalidadesContrato;

	}

	/**
	 * Method 'ContratacionesPersonal'.
	 * 
	 * @param idContratacionPersonal
	 *            Integer
	 * @param nombre
	 *            String
	 * @param apellido1
	 *            String
	 * @param apellido2
	 *            String
	 */
	public ContratacionesPersonal(Integer idContratacionPersonal, String nombre, String apellido1, String apellido2) {

		this.idContratacionPersonal = idContratacionPersonal;
		this.nombre = nombre;
		this.apellido1 = apellido1;
		this.apellido2 = apellido2;
	}

	/**
	 * Method 'ContratacionesPersonal'.
	 * 
	 * @param importePresentado
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param relExpActSub
	 *            RelExpActSub
	 */
	public ContratacionesPersonal(RelExpActSub relExpActSub) {

		this.relExpActSub = relExpActSub;

	}

	/**
	 * Method 'getIdContratacionPersonal'.
	 *
	 * @return Integer
	 */

	public Integer getIdContratacionPersonal() {
		return this.idContratacionPersonal;
	}

	/**
	 * Method 'setIdContratacionPersonal'.
	 *
	 * @param idContratacionPersonal
	 *            Integer
	 * @return
	 */

	public void setIdContratacionPersonal(Integer idContratacionPersonal) {
		this.idContratacionPersonal = idContratacionPersonal;
	}

	/**
	 * Method 'getIdRelExpActSub'.
	 *
	 * @return Integer
	 */

	public Integer getIdRelExpActSub() {
		return this.idRelExpActSub;
	}

	/**
	 * Method 'setIdRelExpActSub'.
	 *
	 * @param idRelExpActSub
	 *            Integer
	 * @return
	 */

	public void setIdRelExpActSub(Integer idRelExpActSub) {
		this.idRelExpActSub = idRelExpActSub;
	}

	/**
	 * @return the idExpediente
	 */
	public Integer getIdExpediente() {
		return idExpediente;
	}

	/**
	 * @param idExpediente
	 *            the idExpediente to set
	 */
	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * @return the idActSub
	 */
	public Integer getIdActSub() {
		return idActSub;
	}

	/**
	 * @param idActSub
	 *            the idActSub to set
	 */
	public void setIdActSub(Integer idActSub) {
		this.idActSub = idActSub;
	}

	/**
	 * Method 'getRelExpActSub'.
	 *
	 * @return RelExpActSub
	 */

	public RelExpActSub getRelExpActSub() {
		return this.relExpActSub;
	}

	/**
	 * Method 'setRelExpActSub'.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return
	 */

	public void setRelExpActSub(RelExpActSub relExpActSub) {
		this.relExpActSub = relExpActSub;
	}

	/**
	 * Method 'getModalidadesContrato'.
	 *
	 * @return ModalidadesContrato
	 */

	public ModalidadesContrato getModalidadesContrato() {
		return this.modalidadesContrato;
	}

	/**
	 * Method 'setModalidadesContrato'.
	 *
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 * @return
	 */

	public void setModalidadesContrato(ModalidadesContrato modalidadesContrato) {
		this.modalidadesContrato = modalidadesContrato;
	}

	/**
	 * Method 'getIdModalidadContrato'.
	 *
	 * @return Long
	 */

	public Long getIdModalidadContrato() {
		return this.idModalidadContrato;
	}

	/**
	 * Method 'setIdModalidadContrato'.
	 *
	 * @param idModalidadContrato
	 *            Long
	 * @return
	 */

	public void setIdModalidadContrato(Long idModalidadContrato) {
		this.idModalidadContrato = idModalidadContrato;
	}

	/**
	 * Method 'getNombre'.
	 *
	 * @return String
	 */

	public String getNombre() {
		return this.nombre;
	}

	/**
	 * Method 'setNombre'.
	 *
	 * @param nombre
	 *            String
	 * @return
	 */

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	/**
	 * @return the sexo
	 */
	public Sexo getSexo() {
		return sexo;
	}

	/**
	 * @param sexo
	 *            the sexo to set
	 */
	public void setSexo(Sexo sexo) {
		this.sexo = sexo;
	}

	/**
	 * Method 'getIdSexo'.
	 *
	 * @return Long
	 */

	public Long getIdSexo() {
		return this.idSexo;
	}

	/**
	 * Method 'setIdSexo'.
	 *
	 * @param idSexo
	 *            Long
	 * @return
	 */

	public void setIdSexo(Long idSexo) {
		this.idSexo = idSexo;
	}

	/**
	 * Method 'getPeriodoContratacion'.
	 *
	 * @return String
	 */

	public String getPeriodoContratacion() {
		return this.periodoContratacion;
	}

	/**
	 * Method 'setPeriodoContratacion'.
	 *
	 * @param periodoContratacion
	 *            String
	 * @return
	 */

	public void setPeriodoContratacion(String periodoContratacion) {
		this.periodoContratacion = periodoContratacion;
	}

	/**
	 * Method 'getEmpresaContratada'.
	 *
	 * @return String
	 */

	public String getEmpresaContratada() {
		return this.empresaContratada;
	}

	/**
	 * Method 'setEmpresaContratada'.
	 *
	 * @param empresaContratada
	 *            String
	 * @return
	 */

	public void setEmpresaContratada(String empresaContratada) {
		this.empresaContratada = empresaContratada;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * @return the apellido1
	 */
	public String getApellido1() {
		return apellido1;
	}

	/**
	 * @param apellido1
	 *            the apellido1 to set
	 */
	public void setApellido1(String apellido1) {
		this.apellido1 = apellido1;
	}

	/**
	 * @return the apellido2
	 */
	public String getApellido2() {
		return apellido2;
	}

	/**
	 * @param apellido2
	 *            the apellido2 to set
	 */
	public void setApellido2(String apellido2) {
		this.apellido2 = apellido2;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "ContratacionesPersonal [idContratacionPersonal=" + idContratacionPersonal + ", idRelExpActSub="
				+ idRelExpActSub + ", relExpActSub=" + relExpActSub + ", idExpediente=" + idExpediente + ", idActSub="
				+ idActSub + ", modalidadesContrato=" + modalidadesContrato + ", idModalidadContrato="
				+ idModalidadContrato + ", nombre=" + nombre + ", apellido1=" + apellido1 + ", apellido2=" + apellido2
				+ ", sexo=" + sexo + ", idSexo=" + idSexo + ", periodoContratacion=" + periodoContratacion
				+ ", empresaContratada=" + empresaContratada + ", fechaRegistro=" + fechaRegistro + ", usuarioRegistro="
				+ usuarioRegistro + ", fechaUltmodificacion=" + fechaUltmodificacion + ", usuarioUltmodificacion="
				+ usuarioUltmodificacion + "]";
	}

}
