package com.ejie.ab60.model.PTT;

import java.util.Date;

import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * GastosTuristicos  
 * 
 *  
 */

public class GastosTuristicos implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idGastosTuristicos;
	private RelExpActSub relExpActSub;
	private ProductosTuristicos productosTuristicos;
	private Long idProductosTuristicos;
	private String denominacion;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltimaModificacion;
	private String usuarioUltimaModificacion;

	/**
	 * Method 'GastosTuristicos'.
	 */
	public GastosTuristicos() {
	}

	/**
	 * Method 'GastosTuristicos'.
	 * 
	 * @param idGastosTuristicos
	 *            Integer
	 */
	public GastosTuristicos(Integer idGastosTuristicos) {
		this.idGastosTuristicos = idGastosTuristicos;
	}

	/**
	 * Method 'GastosTuristicos'.
	 * 
	 * @param idGastosTuristicos
	 *            Integer
	 * @param denominacion
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param relExpActSub
	 *            RelExpActSub
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 */
	public GastosTuristicos(Integer idGastosTuristicos, String denominacion, Date fechaRegistro, String usuarioRegistro,
			RelExpActSub relExpActSub, ProductosTuristicos productosTuristicos) {
		this.idGastosTuristicos = idGastosTuristicos;
		this.relExpActSub = relExpActSub;
		this.productosTuristicos = productosTuristicos;
		this.denominacion = denominacion;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'GastosTuristicos'.
	 * 
	 * @param idGastosTuristicos
	 *            Integer
	 * @param denominacion
	 *            String
	 */
	public GastosTuristicos(Integer idGastosTuristicos, String denominacion) {
		this.idGastosTuristicos = idGastosTuristicos;
		this.denominacion = denominacion;
	}

	/**
	 * Method 'GastosTuristicos'.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 */
	public GastosTuristicos(ProductosTuristicos productosTuristicos) {
		this.productosTuristicos = productosTuristicos;
	}

	/**
	 * Method 'getIdGastosTuristicos'.
	 *
	 * @return Integer
	 */

	public Integer getIdGastosTuristicos() {
		return this.idGastosTuristicos;
	}

	/**
	 * Method 'setIdGastosTuristicos'.
	 *
	 * @param idGastosTuristicos
	 *            Integer
	 * @return
	 */

	public void setIdGastosTuristicos(Integer idGastosTuristicos) {
		this.idGastosTuristicos = idGastosTuristicos;
	}

	/**
	 * Method 'getRelExpActSub'.
	 *
	 * @return RelExpActSub
	 */
	@JsonIgnore

	public RelExpActSub getRelExpActSub() {
		return this.relExpActSub;
	}

	/**
	 * Method 'setRelExpActSub'.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return
	 */

	public void setRelExpActSub(RelExpActSub relExpActSub) {
		this.relExpActSub = relExpActSub;
	}

	/**
	 * Method 'getProductosTuristicos'.
	 *
	 * @return ProductosTuristicos
	 */

	public ProductosTuristicos getProductosTuristicos() {
		return this.productosTuristicos;
	}

	/**
	 * Method 'setProductosTuristicos'.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 * @return
	 */

	public void setProductosTuristicos(ProductosTuristicos productosTuristicos) {
		this.productosTuristicos = productosTuristicos;
	}

	/**
	 * Method 'idProductosTuristicos'.
	 * 
	 * @return the idProductosTuristicos
	 */
	public Long getIdProductosTuristicos() {
		return idProductosTuristicos;
	}

	/**
	 * Method 'setIdProductosTuristicos'.
	 * 
	 * @param idProductosTuristicos
	 *            the idProductosTuristicos to set
	 */
	public void setIdProductosTuristicos(Long idProductosTuristicos) {
		this.idProductosTuristicos = idProductosTuristicos;
	}

	/**
	 * Method 'getDenominacion'.
	 *
	 * @return String
	 */

	public String getDenominacion() {
		return this.denominacion;
	}

	/**
	 * Method 'setDenominacion'.
	 *
	 * @param denominacion
	 *            String
	 * @return
	 */

	public void setDenominacion(String denominacion) {
		this.denominacion = denominacion;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * @return the fechaUltimaModificacion
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltimaModificacion() {
		return fechaUltimaModificacion;
	}

	/**
	 * @param fechaUltimaModificacion
	 *            the fechaUltimaModificacion to set
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltimaModificacion(Date fechaUltimaModificacion) {
		this.fechaUltimaModificacion = fechaUltimaModificacion;
	}

	/**
	 * @return the usuarioUltimaModificacion
	 */
	public String getUsuarioUltimaModificacion() {
		return usuarioUltimaModificacion;
	}

	/**
	 * @param usuarioUltimaModificacion
	 *            the usuarioUltimaModificacion to set
	 */
	public void setUsuarioUltimaModificacion(String usuarioUltimaModificacion) {
		this.usuarioUltimaModificacion = usuarioUltimaModificacion;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "GastosTuristicos [idGastosTuristicos=" + idGastosTuristicos + ", relExpActSub=" + relExpActSub
				+ ", productosTuristicos=" + productosTuristicos + ", idProductosTuristicos=" + idProductosTuristicos
				+ ", denominacion=" + denominacion + ", fechaRegistro=" + fechaRegistro + ", usuarioRegistro="
				+ usuarioRegistro + ", fechaUltimaModificacion=" + fechaUltimaModificacion
				+ ", usuarioUltimaModificacion=" + usuarioUltimaModificacion + "]";
	}

}
