package com.ejie.ab60.model.PTT;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * ModalidadesContrato  
 * 
 *  
 */

public class ModalidadesContrato implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idModalidadContrato;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<PersonasContratadas> personasContratadases = new ArrayList<PersonasContratadas>();
	private List<ContratacionesPersonal> contratacionesPersonals = new ArrayList<ContratacionesPersonal>();
	private Integer idConvocatoria;

	/**
	 * Method 'ModalidadesContrato'.
	 */
	public ModalidadesContrato() {
	}

	/**
	 * Method 'ModalidadesContrato'.
	 * 
	 * @param idModalidadContrato
	 *            Long
	 */
	public ModalidadesContrato(Long idModalidadContrato) {
		this.idModalidadContrato = idModalidadContrato;
	}

	/**
	 * Method 'ModalidadesContrato'.
	 * 
	 * @param idModalidadContrato
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public ModalidadesContrato(Long idModalidadContrato, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro) {
		this.idModalidadContrato = idModalidadContrato;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'ModalidadesContrato'.
	 * 
	 * @param idModalidadContrato
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 */
	public ModalidadesContrato(Long idModalidadContrato, String descripcionCastellano, String descripcionEuskera) {
		this.idModalidadContrato = idModalidadContrato;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;

	}

	/**
	 * Method 'ModalidadesContrato'.
	 * 
	 * @param idModalidadContrato
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param personasContratadases
	 *            List<PersonasContratadas>
	 * @param contratacionesPersonals
	 *            List<ContratacionesPersonal>
	 */
	public ModalidadesContrato(Long idModalidadContrato, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro, List<PersonasContratadas> personasContratadases,
			List<ContratacionesPersonal> contratacionesPersonals) {

		this.idModalidadContrato = idModalidadContrato;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.personasContratadases = personasContratadases;
		this.contratacionesPersonals = contratacionesPersonals;
	}

	/**
	 * Method 'getIdModalidadContrato'.
	 *
	 * @return Long
	 */

	public Long getIdModalidadContrato() {
		return this.idModalidadContrato;
	}

	/**
	 * Method 'setIdModalidadContrato'.
	 *
	 * @param idModalidadContrato
	 *            Long
	 * @return
	 */

	public void setIdModalidadContrato(Long idModalidadContrato) {
		this.idModalidadContrato = idModalidadContrato;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getPersonasContratadases'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<PersonasContratadas> getPersonasContratadases() {
		return this.personasContratadases;
	}

	/**
	 * Method 'setPersonasContratadases'.
	 *
	 * @param personasContratadases
	 *            List
	 * @return
	 */
	public void setPersonasContratadases(List<PersonasContratadas> personasContratadases) {
		this.personasContratadases = personasContratadases;
	}

	/**
	 * Method 'getContratacionesPersonals'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<ContratacionesPersonal> getContratacionesPersonals() {
		return this.contratacionesPersonals;
	}

	/**
	 * Method 'setContratacionesPersonals'.
	 *
	 * @param contratacionesPersonals
	 *            List
	 * @return
	 */
	public void setContratacionesPersonals(List<ContratacionesPersonal> contratacionesPersonals) {
		this.contratacionesPersonals = contratacionesPersonals;
	}

	/**
	 * @return the idConvocatoria
	 */
	public Integer getIdConvocatoria() {
		return idConvocatoria;
	}

	/**
	 * @param idConvocatoria
	 *            the idConvocatoria to set
	 */
	public void setIdConvocatoria(Integer idConvocatoria) {
		this.idConvocatoria = idConvocatoria;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idModalidadContrato: ").append(this.idModalidadContrato).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ idConvocatoria: ").append(this.idConvocatoria).append(" ]");
		result.append("}");
		return result.toString();
	}

}
