package com.ejie.ab60.model.PTT;

import java.math.BigDecimal;
import java.util.Date;

import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.ab60.model.terceros.Sexo;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * PersonasContratadas  
 * 
 *  
 */

public class PersonasContratadas implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idPersonaContratada;
	private Integer idRelExpActSub;
	private Integer idExpediente;
	private Integer idActSub;
	private RelExpActSub relExpActSub;
	private ModalidadesContrato modalidadesContrato;
	private String nombrePC;
	private String apellido1PC;
	private String apellido2PC;
	private Sexo sexo;
	private Long idSexo;
	private String empresaContratada;
	private Long nEmpresasN1;
	private Long horasSubvencionablesN1;
	private Long nEmpresasN2;
	private Long horasSubvencionablesN2;
	private BigDecimal costeHoraContratada;
	private BigDecimal costeHoraSubvencionable;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltimaModificacion;
	private String usuarioUltimaModificacion;

	/**
	 * Method 'PersonasContratadas'.
	 */
	public PersonasContratadas() {
	}

	/**
	 * Method 'PersonasContratadas'.
	 * 
	 * @param idPersonaContratada
	 *            Integer
	 */
	public PersonasContratadas(Integer idPersonaContratada) {
		this.idPersonaContratada = idPersonaContratada;
	}

	/**
	 * Method 'PersonasContratadas'.
	 * 
	 * @param idPersonaContratada
	 *            Integer
	 * @param nombreApellidos
	 *            String
	 * @param idSexo
	 *            Long
	 * @param empresaContratada
	 *            String
	 * @param NEmpresasN1
	 *            Long
	 * @param horasSubvencionablesN1
	 *            Long
	 * @param NEmpresasN2
	 *            Long
	 * @param horasSubvencionablesN2
	 *            Long
	 * @param costeHoraContratada
	 *            BigDecimal
	 * @param costeHoraSubvencionable
	 *            BigDecimal
	 * @param baseSubvencionable
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param competitividad
	 *            Competitividad
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 */
	public PersonasContratadas(Integer idPersonaContratada, String nombrePC, String apellido1PC, String apellido2PC,
			Long idSexo, String empresaContratada, Long NEmpresasN1, Long horasSubvencionablesN1, Long NEmpresasN2,
			Long horasSubvencionablesN2, BigDecimal costeHoraContratada, BigDecimal costeHoraSubvencionable,
			Date fechaRegistro, String usuarioRegistro, Date fechaUltimaModificacion, String usuarioUltimaModificacion,
			ModalidadesContrato modalidadesContrato) {

		this.idPersonaContratada = idPersonaContratada;
		this.modalidadesContrato = modalidadesContrato;
		this.nombrePC = nombrePC;
		this.apellido1PC = apellido1PC;
		this.apellido2PC = apellido2PC;
		this.idSexo = idSexo;
		this.empresaContratada = empresaContratada;
		this.nEmpresasN1 = NEmpresasN1;
		this.horasSubvencionablesN1 = horasSubvencionablesN1;
		this.nEmpresasN2 = NEmpresasN2;
		this.horasSubvencionablesN2 = horasSubvencionablesN2;
		this.costeHoraContratada = costeHoraContratada;
		this.costeHoraSubvencionable = costeHoraSubvencionable;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltimaModificacion = fechaUltimaModificacion;
		this.usuarioUltimaModificacion = usuarioUltimaModificacion;
	}

	/**
	 * Method 'PersonasContratadas'.
	 * 
	 * @param idPersonaContratada
	 *            Integer
	 * @param nombreApellidos
	 *            String
	 * @param idSexo
	 *            Long
	 * @param empresaContratada
	 *            String
	 * @param NEmpresasN1
	 *            Long
	 * @param horasSubvencionablesN1
	 *            Long
	 * @param NEmpresasN2
	 *            Long
	 * @param horasSubvencionablesN2
	 *            Long
	 * @param costeHoraContratada
	 *            BigDecimal
	 * @param costeHoraSubvencionable
	 *            BigDecimal
	 * @param baseSubvencionable
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param competitividad
	 *            Competitividad
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 */
	public PersonasContratadas(Integer idPersonaContratada, String nombrePC, String apellido1PC, String apellido2PC,
			Long idSexo, String empresaContratada, Long NEmpresasN1, Long horasSubvencionablesN1, Long NEmpresasN2,
			Long horasSubvencionablesN2, BigDecimal costeHoraContratada, BigDecimal costeHoraSubvencionable,
			Integer idRelExpActSub, ModalidadesContrato modalidadesContrato) {

		this.idPersonaContratada = idPersonaContratada;
		this.nombrePC = nombrePC;
		this.apellido1PC = apellido1PC;
		this.apellido2PC = apellido2PC;
		this.idSexo = idSexo;
		this.empresaContratada = empresaContratada;
		this.nEmpresasN1 = NEmpresasN1;
		this.horasSubvencionablesN1 = horasSubvencionablesN1;
		this.nEmpresasN2 = NEmpresasN2;
		this.horasSubvencionablesN2 = horasSubvencionablesN2;
		this.costeHoraContratada = costeHoraContratada;
		this.costeHoraSubvencionable = costeHoraSubvencionable;
		this.idRelExpActSub = idRelExpActSub;
		this.modalidadesContrato = modalidadesContrato;

	}

	/**
	 * Method 'PersonasContratadas'.
	 * 
	 * @param idPersonaContratada
	 *            Integer
	 * @param nombreApellidos
	 *            String
	 * @param idSexo
	 *            Long
	 * @param empresaContratada
	 *            String
	 * @param NEmpresasN1
	 *            Long
	 * @param horasSubvencionablesN1
	 *            Long
	 * @param NEmpresasN2
	 *            Long
	 * @param horasSubvencionablesN2
	 *            Long
	 * @param costeHoraContratada
	 *            BigDecimal
	 * @param costeHoraSubvencionable
	 *            BigDecimal
	 * @param baseSubvencionable
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * 
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 */
	public PersonasContratadas(Integer idPersonaContratada, String nombrePC, String apellido1PC, String apellido2PC,
			Sexo sexo, String empresaContratada, Long NEmpresasN1, Long horasSubvencionablesN1, Long NEmpresasN2,
			Long horasSubvencionablesN2, BigDecimal costeHoraContratada, BigDecimal costeHoraSubvencionable,
			RelExpActSub relExpActSub, ModalidadesContrato modalidadesContrato) {

		this.idPersonaContratada = idPersonaContratada;
		this.nombrePC = nombrePC;
		this.apellido1PC = apellido1PC;
		this.apellido2PC = apellido2PC;
		this.sexo = sexo;
		this.empresaContratada = empresaContratada;
		this.nEmpresasN1 = NEmpresasN1;
		this.horasSubvencionablesN1 = horasSubvencionablesN1;
		this.nEmpresasN2 = NEmpresasN2;
		this.horasSubvencionablesN2 = horasSubvencionablesN2;
		this.costeHoraContratada = costeHoraContratada;
		this.costeHoraSubvencionable = costeHoraSubvencionable;
		this.relExpActSub = relExpActSub;
		this.modalidadesContrato = modalidadesContrato;

	}

	/**
	 * Method 'PersonasContratadas'.
	 * 
	 * @param idPersonaContratada
	 *            Integer
	 * @param nombrePC
	 *            String
	 * @param apellido1PC
	 *            String
	 * @param apellido2PC
	 *            String
	 */
	public PersonasContratadas(Integer idPersonaContratada, String nombrePC, String apellido1PC, String apellido2PC) {

		this.idPersonaContratada = idPersonaContratada;
		this.nombrePC = nombrePC;
		this.apellido1PC = apellido1PC;
		this.apellido2PC = apellido2PC;

	}

	/**
	 * Method 'getIdPersonaContratada'.
	 *
	 * @return Integer
	 */

	public Integer getIdPersonaContratada() {
		return this.idPersonaContratada;
	}

	/**
	 * Method 'setIdPersonaContratada'.
	 *
	 * @param idPersonaContratada
	 *            Integer
	 * @return
	 */

	public void setIdPersonaContratada(Integer idPersonaContratada) {
		this.idPersonaContratada = idPersonaContratada;
	}

	/**
	 * Method 'getIdRelExpActSub'.
	 *
	 * @return Integer
	 */

	public Integer getIdRelExpActSub() {
		return this.idRelExpActSub;
	}

	/**
	 * Method 'setIdRelExpActSub'.
	 *
	 * @param idRelExpActSub
	 *            Integer
	 * @return
	 */

	public void setIdRelExpActSub(Integer idRelExpActSub) {
		this.idRelExpActSub = idRelExpActSub;
	}

	/**
	 * @return the idExpediente
	 */
	public Integer getIdExpediente() {
		return idExpediente;
	}

	/**
	 * @param idExpediente
	 *            the idExpediente to set
	 */
	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * @return the idActSub
	 */
	public Integer getIdActSub() {
		return idActSub;
	}

	/**
	 * @param idActSub
	 *            the idActSub to set
	 */
	public void setIdActSub(Integer idActSub) {
		this.idActSub = idActSub;
	}

	/**
	 * Method 'getRelExpActSub'.
	 *
	 * @return RelExpActSub
	 */
	public RelExpActSub getRelExpActSub() {
		return relExpActSub;
	}

	/**
	 * Method 'setRelExpActSub'.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return
	 */
	public void setRelExpActSub(RelExpActSub relExpActSub) {
		this.relExpActSub = relExpActSub;
	}

	/**
	 * Method 'getModalidadesContrato'.
	 *
	 * @return ModalidadesContrato
	 */
	@JsonIgnore

	public ModalidadesContrato getModalidadesContrato() {
		return this.modalidadesContrato;
	}

	/**
	 * Method 'setModalidadesContrato'.
	 *
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 * @return
	 */

	public void setModalidadesContrato(ModalidadesContrato modalidadesContrato) {
		this.modalidadesContrato = modalidadesContrato;
	}

	/**
	 * Method 'getNombrePC'.
	 *
	 * @return String
	 */

	public String getNombrePC() {
		return this.nombrePC;
	}

	/**
	 * Method 'setNombrePC'.
	 *
	 * @param nombrePC
	 *            String
	 * @return
	 */

	public void setNombrePC(String nombrePC) {
		this.nombrePC = nombrePC;
	}

	/**
	 * @return the apellido1PC
	 */
	public String getApellido1PC() {
		return apellido1PC;
	}

	/**
	 * @param apellido1PC
	 *            the apellido1PC to set
	 */
	public void setApellido1PC(String apellido1PC) {
		this.apellido1PC = apellido1PC;
	}

	/**
	 * @return the apellido2PC
	 */
	public String getApellido2PC() {
		return apellido2PC;
	}

	/**
	 * @param apellido2PC
	 *            the apellido2PC to set
	 */
	public void setApellido2PC(String apellido2PC) {
		this.apellido2PC = apellido2PC;
	}

	/**
	 * @return the sexo
	 */
	public Sexo getSexo() {
		return sexo;
	}

	/**
	 * @param sexo
	 *            the sexo to set
	 */
	public void setSexo(Sexo sexo) {
		this.sexo = sexo;
	}

	/**
	 * Method 'getIdSexo'.
	 *
	 * @return Long
	 */

	public Long getIdSexo() {
		return this.idSexo;
	}

	/**
	 * Method 'setIdSexo'.
	 *
	 * @param idSexo
	 *            Long
	 * @return
	 */

	public void setIdSexo(Long idSexo) {
		this.idSexo = idSexo;
	}

	/**
	 * Method 'getEmpresaContratada'.
	 *
	 * @return String
	 */

	public String getEmpresaContratada() {
		return this.empresaContratada;
	}

	/**
	 * Method 'setEmpresaContratada'.
	 *
	 * @param empresaContratada
	 *            String
	 * @return
	 */

	public void setEmpresaContratada(String empresaContratada) {
		this.empresaContratada = empresaContratada;
	}

	/**
	 * Method 'getNEmpresasN1'.
	 *
	 * @return Long
	 */

	public Long getNEmpresasN1() {
		return this.nEmpresasN1;
	}

	/**
	 * Method 'setNEmpresasN1'.
	 *
	 * @param NEmpresasN1
	 *            Long
	 * @return
	 */

	public void setNEmpresasN1(Long NEmpresasN1) {
		this.nEmpresasN1 = NEmpresasN1;
	}

	/**
	 * Method 'getHorasSubvencionablesN1'.
	 *
	 * @return Long
	 */

	public Long getHorasSubvencionablesN1() {
		return this.horasSubvencionablesN1;
	}

	/**
	 * Method 'setHorasSubvencionablesN1'.
	 *
	 * @param horasSubvencionablesN1
	 *            Long
	 * @return
	 */

	public void setHorasSubvencionablesN1(Long horasSubvencionablesN1) {
		this.horasSubvencionablesN1 = horasSubvencionablesN1;
	}

	/**
	 * Method 'getNEmpresasN2'.
	 *
	 * @return Long
	 */

	public Long getNEmpresasN2() {
		return this.nEmpresasN2;
	}

	/**
	 * Method 'setNEmpresasN2'.
	 *
	 * @param NEmpresasN2
	 *            Long
	 * @return
	 */

	public void setNEmpresasN2(Long NEmpresasN2) {
		this.nEmpresasN2 = NEmpresasN2;
	}

	/**
	 * Method 'getHorasSubvencionablesN2'.
	 *
	 * @return Long
	 */

	public Long getHorasSubvencionablesN2() {
		return this.horasSubvencionablesN2;
	}

	/**
	 * Method 'setHorasSubvencionablesN2'.
	 *
	 * @param horasSubvencionablesN2
	 *            Long
	 * @return
	 */

	public void setHorasSubvencionablesN2(Long horasSubvencionablesN2) {
		this.horasSubvencionablesN2 = horasSubvencionablesN2;
	}

	/**
	 * Method 'getCosteHoraContratada'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getCosteHoraContratada() {
		return this.costeHoraContratada;
	}

	/**
	 * Method 'setCosteHoraContratada'.
	 *
	 * @param costeHoraContratada
	 *            BigDecimal
	 * @return
	 */

	public void setCosteHoraContratada(BigDecimal costeHoraContratada) {
		this.costeHoraContratada = costeHoraContratada;
	}

	/**
	 * Method 'getCosteHoraSubvencionable'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getCosteHoraSubvencionable() {
		return this.costeHoraSubvencionable;
	}

	/**
	 * Method 'setCosteHoraSubvencionable'.
	 *
	 * @param costeHoraSubvencionable
	 *            BigDecimal
	 * @return
	 */

	public void setCosteHoraSubvencionable(BigDecimal costeHoraSubvencionable) {
		this.costeHoraSubvencionable = costeHoraSubvencionable;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * @return the fechaUltimaModificacion
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltimaModificacion() {
		return fechaUltimaModificacion;
	}

	/**
	 * @param fechaUltimaModificacion
	 *            the fechaUltimaModificacion to set
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltimaModificacion(Date fechaUltimaModificacion) {
		this.fechaUltimaModificacion = fechaUltimaModificacion;
	}

	/**
	 * @return the usuarioUltimaModificacion
	 */
	public String getUsuarioUltimaModificacion() {
		return usuarioUltimaModificacion;
	}

	/**
	 * @param usuarioUltimaModificacion
	 *            the usuarioUltimaModificacion to set
	 */
	public void setUsuarioUltimaModificacion(String usuarioUltimaModificacion) {
		this.usuarioUltimaModificacion = usuarioUltimaModificacion;
	}

	/**
	 * Method 'getCosteHoraContratadaMask'.
	 *
	 * @return BigDecimal
	 */

	public String getCosteHoraContratadaMask() {
		return UtilDate.formatearMiles(costeHoraContratada);
	}

	/**
	 * Method 'getCosteHoraSubvencionableMask'.
	 *
	 * @return BigDecimal
	 */

	public String getCosteHoraSubvencionableMask() {
		return UtilDate.formatearMiles(costeHoraSubvencionable);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "PersonasContratadas [idPersonaContratada=" + idPersonaContratada + ", idRelExpActSub=" + idRelExpActSub
				+ ", idExpediente=" + idExpediente + ", idActSub=" + idActSub + ", relExpActSub=" + relExpActSub
				+ ", modalidadesContrato=" + modalidadesContrato + ", nombrePC=" + nombrePC + ", apellido1PC="
				+ apellido1PC + ", apellido2PC=" + apellido2PC + ", sexo=" + sexo + ", idSexo=" + idSexo
				+ ", empresaContratada=" + empresaContratada + ", NEmpresasN1=" + nEmpresasN1
				+ ", horasSubvencionablesN1=" + horasSubvencionablesN1 + ", NEmpresasN2=" + nEmpresasN2
				+ ", horasSubvencionablesN2=" + horasSubvencionablesN2 + ", costeHoraContratada=" + costeHoraContratada
				+ ", costeHoraSubvencionable=" + costeHoraSubvencionable + ", fechaRegistro=" + fechaRegistro
				+ ", usuarioRegistro=" + usuarioRegistro + ", fechaUltimaModificacion=" + fechaUltimaModificacion
				+ ", usuarioUltimaModificacion=" + usuarioUltimaModificacion + "]";
	}

}
