package com.ejie.ab60.model.PTT;

import java.util.Date;

import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * PertenenciasRedes  
 * 
 *  
 */

public class PertenenciasRedes implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idPertenenciaRedes;
	private RelExpActSub relExpActSub;
	private String denominacion;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltimaModificacion;
	private String usuarioUltimaModificacion;

	/**
	 * Method 'PertenenciasRedes'.
	 */
	public PertenenciasRedes() {
	}

	/**
	 * Method 'PertenenciasRedes'.
	 * 
	 * @param idPertenenciaRedes
	 *            Integer
	 */
	public PertenenciasRedes(Integer idPertenenciaRedes) {
		this.idPertenenciaRedes = idPertenenciaRedes;
	}

	/**
	 * Method 'PertenenciasRedes'.
	 * 
	 * @param idPertenenciaRedes
	 *            Integer
	 * @param denominacion
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param relExpActSub
	 *            RelExpActSub
	 */
	public PertenenciasRedes(Integer idPertenenciaRedes, String denominacion, Date fechaRegistro,
			String usuarioRegistro, RelExpActSub relExpActSub) {
		this.idPertenenciaRedes = idPertenenciaRedes;
		this.relExpActSub = relExpActSub;
		this.denominacion = denominacion;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'PertenenciasRedes'.
	 * 
	 * @param idPertenenciaRedes
	 *            Integer
	 * @param denominacion
	 *            String
	 */
	public PertenenciasRedes(Integer idPertenenciaRedes, String denominacion) {
		this.idPertenenciaRedes = idPertenenciaRedes;
		this.denominacion = denominacion;

	}

	/**
	 * Method 'getIdPertenenciaRedes'.
	 *
	 * @return Integer
	 */

	public Integer getIdPertenenciaRedes() {
		return this.idPertenenciaRedes;
	}

	/**
	 * Method 'setIdPertenenciaRedes'.
	 *
	 * @param idPertenenciaRedes
	 *            Integer
	 * @return
	 */

	public void setIdPertenenciaRedes(Integer idPertenenciaRedes) {
		this.idPertenenciaRedes = idPertenenciaRedes;
	}

	/**
	 * Method 'getRelExpActSub'.
	 *
	 * @return RelExpActSub
	 */
	@JsonIgnore

	public RelExpActSub getRelExpActSub() {
		return this.relExpActSub;
	}

	/**
	 * Method 'setRelExpActSub'.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return
	 */

	public void setRelExpActSub(RelExpActSub relExpActSub) {
		this.relExpActSub = relExpActSub;
	}

	/**
	 * Method 'getDenominacion'.
	 *
	 * @return String
	 */

	public String getDenominacion() {
		return this.denominacion;
	}

	/**
	 * Method 'setDenominacion'.
	 *
	 * @param denominacion
	 *            String
	 * @return
	 */

	public void setDenominacion(String denominacion) {
		this.denominacion = denominacion;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * @return the fechaUltimaModificacion
	 */
	public Date getFechaUltimaModificacion() {
		return fechaUltimaModificacion;
	}

	/**
	 * @param fechaUltimaModificacion
	 *            the fechaUltimaModificacion to set
	 */
	public void setFechaUltimaModificacion(Date fechaUltimaModificacion) {
		this.fechaUltimaModificacion = fechaUltimaModificacion;
	}

	/**
	 * @return the usuarioUltimaModificacion
	 */
	public String getUsuarioUltimaModificacion() {
		return usuarioUltimaModificacion;
	}

	/**
	 * @param usuarioUltimaModificacion
	 *            the usuarioUltimaModificacion to set
	 */
	public void setUsuarioUltimaModificacion(String usuarioUltimaModificacion) {
		this.usuarioUltimaModificacion = usuarioUltimaModificacion;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idPertenenciaRedes: ").append(this.idPertenenciaRedes).append(" ]");
		result.append(", [ denominacion: ").append(this.denominacion).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
