package com.ejie.ab60.model.PTT;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * ProductosTuristicos  
 * 
 *  
 */

public class ProductosTuristicos implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idProductoTuristico;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<GastosTuristicos> gastosTuristicoses = new ArrayList<GastosTuristicos>();
	private int idConvocatoria;

	/**
	 * Method 'ProductosTuristicos'.
	 */
	public ProductosTuristicos() {
	}

	/**
	 * Method 'ProductosTuristicos'.
	 * 
	 * @param idProductoTuristico
	 *            Long
	 */
	public ProductosTuristicos(Long idProductoTuristico) {
		this.idProductoTuristico = idProductoTuristico;
	}

	/**
	 * Method 'ProductosTuristicos'.
	 * 
	 * @param idProductoTuristico
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public ProductosTuristicos(Long idProductoTuristico, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro) {
		this.idProductoTuristico = idProductoTuristico;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'ProductosTuristicos'.
	 * 
	 * @param idProductoTuristico
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 */
	public ProductosTuristicos(Long idProductoTuristico, String descripcionCastellano, String descripcionEuskera) {
		this.idProductoTuristico = idProductoTuristico;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'ProductosTuristicos'.
	 * 
	 * @param idProductoTuristico
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param gastosTuristicoses
	 *            List<GastosTuristicos>
	 */
	public ProductosTuristicos(Long idProductoTuristico, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro, List<GastosTuristicos> gastosTuristicoses) {

		this.idProductoTuristico = idProductoTuristico;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.gastosTuristicoses = gastosTuristicoses;
	}

	/**
	 * Method 'getIdProductoTuristico'.
	 *
	 * @return Long
	 */

	public Long getIdProductoTuristico() {
		return this.idProductoTuristico;
	}

	/**
	 * Method 'setIdProductoTuristico'.
	 *
	 * @param idProductoTuristico
	 *            Long
	 * @return
	 */

	public void setIdProductoTuristico(Long idProductoTuristico) {
		this.idProductoTuristico = idProductoTuristico;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getGastosTuristicoses'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<GastosTuristicos> getGastosTuristicoses() {
		return this.gastosTuristicoses;
	}

	/**
	 * Method 'setGastosTuristicoses'.
	 *
	 * @param gastosTuristicoses
	 *            List
	 * @return
	 */
	public void setGastosTuristicoses(List<GastosTuristicos> gastosTuristicoses) {
		this.gastosTuristicoses = gastosTuristicoses;
	}

	/**
	 * @return the idConvocatoria
	 */
	public int getIdConvocatoria() {
		return idConvocatoria;
	}

	/**
	 * @param idConvocatoria
	 *            the idConvocatoria to set
	 */
	public void setIdConvocatoria(int idConvocatoria) {
		this.idConvocatoria = idConvocatoria;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idProductoTuristico: ").append(this.idProductoTuristico).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ idConvocatoria: ").append(this.idConvocatoria).append(" ]");
		result.append("}");
		return result.toString();
	}

}
