package com.ejie.ab60.model;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.Date;

/**
 * RelExpIns  
 * 
 *  
 */

public class RelExpIns implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idRelExpIns;
	private Integer idExpediente;
	private Integer idInspeccion;
	private Integer tipoInspeccion;
	private String identificadorInspeccion;
	private Date fechaRegistro;
	private String usuarioRegistro;

	/**
	 * Method 'RelExpIns'.
	 */
	public RelExpIns() {
	}

	/**
	 * Method 'RelExpIns'.
	 * 
	 * @param idRelExpIns
	 *            Integer
	 */
	public RelExpIns(Integer idRelExpIns) {
		this.idRelExpIns = idRelExpIns;
	}

	/**
	 * Method 'RelExpIns'.
	 * 
	 * @param idRelExpIns
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param idInspeccion
	 *            Integer
	 * @param tipoInspeccion
	 *            Integer
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public RelExpIns(Integer idRelExpIns, Integer idExpediente, Integer idInspeccion, Integer tipoInspeccion,
			String identificadorInspeccion, Date fechaRegistro, String usuarioRegistro) {

		this.idRelExpIns = idRelExpIns;
		this.idExpediente = idExpediente;
		this.idInspeccion = idInspeccion;
		this.tipoInspeccion = tipoInspeccion;
		this.identificadorInspeccion = identificadorInspeccion;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getIdRelExpIns'.
	 *
	 * @return Integer
	 */

	public Integer getIdRelExpIns() {
		return this.idRelExpIns;
	}

	/**
	 * Method 'setIdRelExpIns'.
	 *
	 * @param idRelExpIns
	 *            Integer
	 * @return
	 */

	public void setIdRelExpIns(Integer idRelExpIns) {
		this.idRelExpIns = idRelExpIns;
	}

	/**
	 * Method 'getIdExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdExpediente() {
		return this.idExpediente;
	}

	/**
	 * Method 'setIdExpediente'.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return
	 */

	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'getIdInspeccion'.
	 *
	 * @return Integer
	 */

	public Integer getIdInspeccion() {
		return this.idInspeccion;
	}

	/**
	 * Method 'setIdInspeccion'.
	 *
	 * @param idInspeccion
	 *            Integer
	 * @return
	 */

	public void setIdInspeccion(Integer idInspeccion) {
		this.idInspeccion = idInspeccion;
	}

	/**
	 * Method 'getTipoInspeccion'.
	 *
	 * @return Integer
	 */

	public Integer getTipoInspeccion() {
		return this.tipoInspeccion;
	}

	/**
	 * Method 'setTipoInspeccion'.
	 *
	 * @param tipoInspeccion
	 *            Integer
	 * @return
	 */

	public void setTipoInspeccion(Integer tipoInspeccion) {
		this.tipoInspeccion = tipoInspeccion;
	}

	/**
	 * Method 'getIdentificadorInspeccion'
	 * 
	 * @return String
	 */

	public String getIdentificadorInspeccion() {
		return this.identificadorInspeccion;
	}

	/**
	 * Method 'setIdentificadorInspeccion'
	 * 
	 * @param identificadorInspeccion
	 *            String
	 * @return
	 */

	public void setIdentificadorInspeccion(String identificadorInspeccion) {
		this.identificadorInspeccion = identificadorInspeccion;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idRelExpIns: ").append(this.idRelExpIns).append(" ]");
		result.append(", [ idExpediente: ").append(this.idExpediente).append(" ]");
		result.append(", [ idInspeccion: ").append(this.idInspeccion).append(" ]");
		result.append(", [ tipoInspeccion: ").append(this.tipoInspeccion).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
