package com.ejie.ab60.model.actuacionesSubvencionables;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.springframework.context.i18n.LocaleContextHolder;

import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * ActSubvencionable  
 * 
 *  
 */

public class ActSubvencionable implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idActSub;
	private Convocatorias convocatorias;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private BigDecimal porcentajeActuacion;
	private BigDecimal importeMinimoInversion;
	private String rutaXmlCarga;
	private String rutaXmlHijoCarga;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private List<RelExpActSub> relExpActSubs = new ArrayList<RelExpActSub>();

	private Integer idActSubPadre;
	private BigDecimal importeInversion;
	private BigDecimal importeDisponible;
	private BigDecimal importe;
	private Integer idActSubComboHijo;

	private Integer idActSubAgrupacion;
	private Integer idActSubPadreAgrupacion;

	private Integer orden;
	private String identificadores;
	private String entidadBancaria;

	/**
	 * Method 'ActSubvencionable'.
	 */
	public ActSubvencionable() {
		super();
	}

	/**
	 * Method 'ActSubvencionable'.
	 * 
	 * @param idActSub
	 *            Integer
	 */
	public ActSubvencionable(Integer idActSub) {
		this.idActSub = idActSub;
	}

	/**
	 * Method 'ActSubvencionable'.
	 * 
	 * @param idActSub
	 *            Integer
	 * @param idActSubPadre
	 *            Integer
	 */
	public ActSubvencionable(Integer idActSub, Integer idActSubPadre) {
		this.idActSubPadre = idActSubPadre;
		this.idActSub = idActSub;
	}

	public ActSubvencionable(Integer orden, Integer idActSub, String descripcionCastellano, String descripcionEuskera) {
		this.orden = orden;
		this.idActSub = idActSub;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
	}

	public ActSubvencionable(String descripcionCastellano, String descripcionEuskera) {

		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'ActSubvencionable'.
	 * 
	 * @param idActSub
	 *            Integer
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param porcentajeActuacion
	 *            BigDecimal
	 * @param importeMinimoInversion
	 *            BigDecimal
	 * @param rutaXmlCarga
	 *            String
	 * @param rutaXmlHijoCarga
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param convocatorias
	 *            Convocatorias
	 */
	public ActSubvencionable(Integer idActSub, String descripcionCastellano, String descripcionEuskera,
			BigDecimal porcentajeActuacion, BigDecimal importeMinimoInversion, Date fechaRegistro,
			String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion,
			Convocatorias convocatorias) {
		this.idActSub = idActSub;
		this.convocatorias = convocatorias;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.porcentajeActuacion = porcentajeActuacion;
		this.importeMinimoInversion = importeMinimoInversion;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'ActSubvencionable'.
	 * 
	 * @param idActSub
	 *            Integer
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param porcentajeActuacion
	 *            BigDecimal
	 * @param importeMinimoInversion
	 *            BigDecimal
	 * @param rutaXmlCarga
	 *            String
	 * @param rutaXmlHijoCarga
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param convocatorias
	 *            Convocatorias
	 * @param relExpActSubs
	 *            List<RelExpActSub>
	 */
	public ActSubvencionable(Integer idActSub, String descripcionCastellano, String descripcionEuskera,
			BigDecimal porcentajeActuacion, BigDecimal importeMinimoInversion, Date fechaRegistro,
			String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion,
			Convocatorias convocatorias, List<RelExpActSub> relExpActSubs) {

		this.idActSub = idActSub;
		this.convocatorias = convocatorias;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.porcentajeActuacion = porcentajeActuacion;
		this.importeMinimoInversion = importeMinimoInversion;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.relExpActSubs = relExpActSubs;
	}

	public ActSubvencionable(Integer idActSub, String descripcionCastellano, String descripcionEuskera,
			BigDecimal porcentajeActuacion) {
		this.idActSub = idActSub;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.porcentajeActuacion = porcentajeActuacion;
	}

	public ActSubvencionable(Integer orden, Integer idActSub, Integer idActSubPadre, Integer idActSubPadreAgrupacion,
			Convocatorias convocatorias, String descripcionCastellano, String descripcionEuskera) {
		this.orden = orden;
		this.idActSub = idActSub;
		this.idActSubPadreAgrupacion = idActSubPadreAgrupacion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.idActSubPadre = idActSubPadre;
		this.convocatorias = convocatorias;
	}

	/**
	 * Method 'getIdActSub'.
	 *
	 * @return Integer
	 */

	public Integer getIdActSub() {
		return this.idActSub;
	}

	/**
	 * Method 'setIdActSub'.
	 *
	 * @param idActSub
	 *            Integer
	 * @return
	 */

	public void setIdActSub(Integer idActSub) {
		this.idActSub = idActSub;
	}

	/**
	 * Method 'getConvocatorias'.
	 *
	 * @return Convocatorias
	 */

	public Convocatorias getConvocatorias() {
		return this.convocatorias;
	}

	/**
	 * Method 'setConvocatorias'.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @return
	 */

	public void setConvocatorias(Convocatorias convocatorias) {
		this.convocatorias = convocatorias;
	}

	public String getDescripcionEntidadBancaria() {

		String idioma = LocaleContextHolder.getLocale().getLanguage();

		if ("es".equalsIgnoreCase(idioma)) {
			if (this.entidadBancaria != null && this.entidadBancaria != "") {
				return this.descripcionCastellano + " (" + this.entidadBancaria + ")";
			} else {
				return this.descripcionCastellano;
			}
		} else {
			if (this.entidadBancaria != null && this.entidadBancaria != "") {
				return this.descripcionEuskera + " (" + this.entidadBancaria + ")";
			} else {
				return this.descripcionEuskera;
			}
		}
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getPorcentajeActuacion'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getPorcentajeActuacion() {
		return this.porcentajeActuacion;
	}

	/**
	 * Method 'getPorcentajeActuacionMask'.
	 *
	 * @return BigDecimal
	 */

	public String getPorcentajeActuacionMask() {
		return UtilDate.formatearMiles(porcentajeActuacion);
	}

	/**
	 * Method 'setPorcentajeActuacion'.
	 *
	 * @param porcentajeActuacion
	 *            BigDecimal
	 * @return
	 */

	public void setPorcentajeActuacion(BigDecimal porcentajeActuacion) {
		this.porcentajeActuacion = porcentajeActuacion;
	}

	/**
	 * Method 'getImporteMinimoInversion'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporteMinimoInversion() {
		return this.importeMinimoInversion;
	}

	/**
	 * Method 'setImporteMinimoInversion'.
	 *
	 * @param importeMinimoInversion
	 *            BigDecimal
	 * @return
	 */

	public void setImporteMinimoInversion(BigDecimal importeMinimoInversion) {
		this.importeMinimoInversion = importeMinimoInversion;
	}

	/**
	 * Method 'getRutaXmlCarga'.
	 *
	 * @return String
	 */

	public String getRutaXmlCarga() {
		return this.rutaXmlCarga;
	}

	/**
	 * Method 'setRutaXmlCarga'.
	 *
	 * @param rutaXmlCarga
	 *            String
	 * @return
	 */

	public void setRutaXmlCarga(String rutaXmlCarga) {
		this.rutaXmlCarga = rutaXmlCarga;
	}

	/**
	 * Method 'getRutaXmlHijoCarga'.
	 *
	 * @return String
	 */

	public String getRutaXmlHijoCarga() {
		return this.rutaXmlHijoCarga;
	}

	/**
	 * Method 'setRutaXmlHijoCarga'.
	 *
	 * @param rutaXmlHijoCarga
	 *            String
	 * @return
	 */

	public void setRutaXmlHijoCarga(String rutaXmlHijoCarga) {
		this.rutaXmlHijoCarga = rutaXmlHijoCarga;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getRelExpActSubs'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<RelExpActSub> getRelExpActSubs() {
		return this.relExpActSubs;
	}

	/**
	 * @return the idActSubPadre
	 */
	public Integer getIdActSubPadre() {
		return idActSubPadre;
	}

	/**
	 * @param idActSubPadre
	 *            the idActSubPadre to set
	 */
	public void setIdActSubPadre(Integer idActSubPadre) {
		this.idActSubPadre = idActSubPadre;
	}

	/**
	 * @return the importeInversion
	 */
	public BigDecimal getImporteInversion() {
		return importeInversion;
	}

	/**
	 * @param importeInversion
	 *            the importeInversion to set
	 */
	public void setImporteInversion(BigDecimal importeInversion) {
		this.importeInversion = importeInversion;
	}

	/**
	 * @return the idActSubComboHijo
	 */
	public Integer getIdActSubComboHijo() {
		return idActSubComboHijo;
	}

	/**
	 * @param idActSubComboHijo
	 *            the idActSubComboHijo to set
	 */
	public void setIdActSubComboHijo(Integer idActSubComboHijo) {
		this.idActSubComboHijo = idActSubComboHijo;
	}

	/**
	 * Method 'setRelExpActSubs'.
	 *
	 * @param relExpActSubs
	 *            List
	 * @return
	 */
	public void setRelExpActSubs(List<RelExpActSub> relExpActSubs) {
		this.relExpActSubs = relExpActSubs;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idActSub: ").append(this.idActSub).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ porcentajeActuacion: ").append(this.porcentajeActuacion).append(" ]");
		result.append(", [ importeMinimoInversion: ").append(this.importeMinimoInversion).append(" ]");
		result.append(", [ rutaXmlCarga: ").append(this.rutaXmlCarga).append(" ]");
		result.append(", [ rutaXmlHijoCarga: ").append(this.rutaXmlHijoCarga).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

	public BigDecimal getImporteDisponible() {
		return importeDisponible;
	}

	public void setImporteDisponible(BigDecimal importeDisponible) {
		this.importeDisponible = importeDisponible;
	}

	public BigDecimal getImporte() {
		return importe;
	}

	public void setImporte(BigDecimal importe) {
		this.importe = importe;
	}

	public String getImporteFormateado() {
		return UtilDate.formatearMiles(this.importe);
	}

	public String getImporteDisponibleFormateado() {
		return UtilDate.formatearMiles(this.importeDisponible);
	}

	/**
	 * @return the orden
	 */
	public Integer getOrden() {
		return orden;
	}

	/**
	 * @param orden
	 *            the orden to set
	 */
	public void setOrden(Integer orden) {
		this.orden = orden;
	}

	public Integer getIdActSubAgrupacion() {
		return idActSubAgrupacion;
	}

	public void setIdActSubAgrupacion(Integer idActSubAgrupacion) {
		this.idActSubAgrupacion = idActSubAgrupacion;
	}

	public Integer getIdActSubPadreAgrupacion() {
		return idActSubPadreAgrupacion;
	}

	public void setIdActSubPadreAgrupacion(Integer idActSubPadreAgrupacion) {
		this.idActSubPadreAgrupacion = idActSubPadreAgrupacion;
	}

	public String getIdentificadores() {
		return idActSubAgrupacion + "/" + idActSub;
	}

	public String getIdentificadoresPadres() {
		return idActSubPadreAgrupacion + "/" + idActSubPadre;
	}

	public void setIdentificadores(String identificadores) {
		this.identificadores = identificadores;
	}

	public String getEntidadBancaria() {
		return entidadBancaria;
	}

	public void setEntidadBancaria(String entidadBancaria) {
		this.entidadBancaria = entidadBancaria;
	}
}
