package com.ejie.ab60.model.actuacionesSubvencionables;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;

import org.springframework.context.i18n.LocaleContextHolder;

import com.ejie.ab60.comun.Constantes;

import com.ejie.ab60.model.DEC.ActAsociacion;
import com.ejie.ab60.model.DEC.ActAyuntamiento;
import com.ejie.ab60.model.MEC.Facturas;
import com.ejie.ab60.model.PTT.Competitividad;
import com.ejie.ab60.model.PTT.ContratacionesPersonal;

import com.ejie.ab60.model.PTT.GastosTuristicos;
import com.ejie.ab60.model.PTT.PersonasContratadas;
import com.ejie.ab60.model.PTT.PertenenciasRedes;

import com.ejie.ab60.model.PTT.ProductosTuristicos;
import com.ejie.ab60.model.estudioTecnico.MotivosDenegacion;
import com.ejie.ab60.model.estudioTecnico.MotivosMinoracion;
import com.ejie.ab60.util.UtilDate;
import com.ejie.ab60.model.estudioTecnico.Conceptos;
import com.ejie.ab60.model.estudioTecnico.EstudioTecnico;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * RelExpActSub  
 * 
 *  
 */

public class RelExpActSub implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idRelExpActSub;
	private Integer idconvocatoria;
	private Integer idActSub;
	private Integer idExpediente;
	private ActSubvencionable actSubvencionable;
	private ActAyuntamiento actAyuntamiento;
	private ActAsociacion actAsociacion;
	private EstudioTecnico estudioTecnico;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private String notas;
	private Integer inspeccionable;
	private String observacionesEuskera;
	private String observacionesCastellano;
	private BigDecimal importeAdmitido;
	private BigDecimal importePresentado;
	private BigDecimal importeJustPresentado;
	private BigDecimal importeJustAdmitido;
	private BigDecimal baseSubvencionable;
	private BigDecimal baseSubvencionableAdmitido;
	private BigDecimal subvencionCalculada;
	private BigDecimal porcentaje;
	private BigDecimal porcentajeJus;
	private BigDecimal importeJustCalculado;
	private Integer enviadoInspeccionar;
	private BigDecimal ayudaConcedida;
	private Integer puntos;

	private String folderNumber;
	private String descEs;
	private String descEus;
	private BigDecimal importe;

	private Integer exento;
	private BigDecimal importeSinIva;

	private Facturas factura;

	private String observacionesInspCastellano;
	private String observacionesInspEuskera;

	private String importeJusAdmitidoStr;

	private Conceptos conceptos;

	/**
	 * @return the importeJustCalculado
	 */
	public BigDecimal getImporteJustCalculado() {
		return importeJustCalculado;
	}

	/**
	 * @param importeJustCalculado
	 *            the importeJustCalculado to set
	 */
	public void setImporteJustCalculado(BigDecimal importeJustCalculado) {
		this.importeJustCalculado = importeJustCalculado;
	}

	private String importeAdmitidoStr;

	private Integer[] criteriosRelActSubSubacts;
	private List<MotivosMinoracion> comboMinoracion = new ArrayList<MotivosMinoracion>();
	private List<MotivosDenegacion> comboDenegacion = new ArrayList<MotivosDenegacion>();

	private List<ActAsociacion> actAsociacions = new ArrayList<ActAsociacion>();
	private List<Competitividad> competitividads = new ArrayList<Competitividad>();
	private List<Facturas> facturases = new ArrayList<Facturas>();
	private List<ActAyuntamiento> actAyuntamientos = new ArrayList<ActAyuntamiento>();

	/**
	 * @return the porcentajeJus
	 */
	public BigDecimal getPorcentajeJus() {
		return porcentajeJus;
	}

	/**
	 * @param porcentajeJus
	 *            the porcentajeJus to set
	 */
	public void setPorcentajeJus(BigDecimal porcentajeJus) {
		this.porcentajeJus = porcentajeJus;
	}

	private Boolean CheckDenegacion;
	private Boolean CheckMinoracion;

	private PertenenciasRedes pertenenciasRedes;
	private GastosTuristicos gastosTuristicos;

	private ProductosTuristicos productosTuristicos;
	private Long idProductoTuristico;
	private ContratacionesPersonal contratacionesPersonal;
	private PersonasContratadas personasContratadas;

	private String actSubvencionableConcatenada;

	/**
	 * Method 'RelExpActSub'.
	 */
	public RelExpActSub() {
	}

	/**
	 ** @param idExpediente
	 *            Integer
	 * @param idActSub
	 *            Integer
	 * @param idRelExpActSub
	 *            Integer
	 */

	/*
	 * public RelExpActSub(Integer idActSub, Long idMotivoDenegacion, Long
	 * idMotivoMinoracion) {
	 * 
	 * this.idActSub = idActSub; this.idMotivoDenegacion = idMotivoDenegacion;
	 * this.idMotivoMinoracion = idMotivoMinoracion; }
	 */

	public RelExpActSub(Integer idRelExpActSub) {

		this.idRelExpActSub = idRelExpActSub;

	}

	/**
	 * Method 'RelExpActSub'.
	 * 
	 * @param idRelExpActSub
	 *            Integer
	 * 
	 */
	public RelExpActSub(Integer idRelExpActSub, Integer idExpediente) {
		this.idRelExpActSub = idRelExpActSub;
		this.idExpediente = idExpediente;
	}

	/**
	 * @param idRelExpActSub
	 * @param actSubvencionable
	 * @param estudioTecnico
	 * @param importeAdmitido
	 * @param importePresentado
	 */
	public RelExpActSub(Integer idRelExpActSub, BigDecimal importeAdmitido, BigDecimal importePresentado,
			ActSubvencionable actSubvencionable) {

		this.idRelExpActSub = idRelExpActSub;
		this.importeAdmitido = importeAdmitido;
		this.importePresentado = importePresentado;
		this.actSubvencionable = actSubvencionable;

	}

	/**
	 * @param idRelExpActSub
	 * @param actSubvencionable
	 * 
	 * @param notas
	 * @param observacionesEuskera
	 * @param observacionesCastellano
	 * @param importeAdmitido
	 * @param importePresentado
	 * 
	 * @param actSubvencionable
	 */
	public RelExpActSub(Integer idRelExpActSub, Integer idActSub, String notas, String observacionesEuskera,
			String observacionesCastellano, BigDecimal importeAdmitido, BigDecimal importePresentado,
			ActSubvencionable actSubvencionable) {

		this.idRelExpActSub = idRelExpActSub;
		this.idActSub = idActSub;
		this.notas = notas;
		this.observacionesEuskera = observacionesEuskera;
		this.observacionesCastellano = observacionesCastellano;
		this.importeAdmitido = importeAdmitido;
		this.importePresentado = importePresentado;

		this.actSubvencionable = actSubvencionable;

	}

	/**
	 * @param idRelExpActSub
	 * @param idActSub
	 * @param notas
	 * @param observacionesEuskera
	 * @param observacionesCastellano
	 * @param importeAdmitido
	 * @param importePresentado
	 * @param gastosTuristicos
	 * @param productosTuristicos
	 */
	public RelExpActSub(Integer idRelExpActSub, Integer idActSub, String notas, String observacionesEuskera,
			String observacionesCastellano, BigDecimal importeAdmitido, BigDecimal importePresentado,
			GastosTuristicos gastosTuristicos, ProductosTuristicos productosTuristicos) {

		this.idRelExpActSub = idRelExpActSub;
		this.idActSub = idActSub;
		this.notas = notas;
		this.observacionesEuskera = observacionesEuskera;
		this.observacionesCastellano = observacionesCastellano;
		this.importeAdmitido = importeAdmitido;
		this.importePresentado = importePresentado;

		this.gastosTuristicos = gastosTuristicos;
		this.productosTuristicos = productosTuristicos;

	}

	/**
	 * @param idRelExpActSub
	 * @param idActSub
	 * @param notas
	 * @param observacionesEuskera
	 * @param observacionesCastellano
	 * @param importeAdmitido
	 * @param importePresentado
	 * @param pertenenciasRedes
	 */
	public RelExpActSub(Integer idRelExpActSub, Integer idActSub, String notas, String observacionesEuskera,
			String observacionesCastellano, BigDecimal importeAdmitido, BigDecimal importePresentado,
			ActSubvencionable actSubvencionable, PertenenciasRedes pertenenciasRedes) {

		this.idRelExpActSub = idRelExpActSub;
		this.idActSub = idActSub;
		this.notas = notas;
		this.observacionesEuskera = observacionesEuskera;
		this.observacionesCastellano = observacionesCastellano;
		this.importeAdmitido = importeAdmitido;
		this.importePresentado = importePresentado;
		this.actSubvencionable = actSubvencionable;

		this.pertenenciasRedes = pertenenciasRedes;

	}

	/**
	 * @param idRelExpActSub
	 * @param actSubvencionable
	 * @param estudioTecnico
	 * @param importeAdmitido
	 * @param importePresentado
	 */
	public RelExpActSub(Integer idRelExpActSub, BigDecimal importeAdmitido, BigDecimal importePresentado,
			ActSubvencionable actSubvencionable, EstudioTecnico estudioTecnico) {

		this.idRelExpActSub = idRelExpActSub;
		this.actSubvencionable = actSubvencionable;
		this.estudioTecnico = estudioTecnico;
		this.importeAdmitido = importeAdmitido;
		this.importePresentado = importePresentado;
	}

	/**
	 * @param idRelExpActSub
	 * @param actSubvencionable
	 * @param estudioTecnico
	 * @param importeAdmitido
	 * @param importePresentado
	 */
	public RelExpActSub(Integer idRelExpActSub, BigDecimal importeAdmitido, BigDecimal importePresentado,
			BigDecimal subvencionCalculada, BigDecimal porcentaje, ActSubvencionable actSubvencionable,
			ContratacionesPersonal contratacionesPersonal, GastosTuristicos gastosTuristicos,
			ProductosTuristicos productosTuristicos, PersonasContratadas personasContratadas) {

		this.idRelExpActSub = idRelExpActSub;
		this.actSubvencionable = actSubvencionable;
		this.importeAdmitido = importeAdmitido;
		this.importePresentado = importePresentado;
		this.subvencionCalculada = subvencionCalculada;
		this.porcentaje = porcentaje;
		this.contratacionesPersonal = contratacionesPersonal;
		this.gastosTuristicos = gastosTuristicos;
		this.productosTuristicos = productosTuristicos;
		this.personasContratadas = personasContratadas;
	}

	/**
	 * @param importePresentado
	 * @param importeAdmitido
	 */
	public RelExpActSub(Integer idRelExpActSub, BigDecimal importePresentado, BigDecimal importeAdmitido,
			Integer inspeccionable, String observacionesCastellano, String observacionesEuskera) {

		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.idRelExpActSub = idRelExpActSub;
		this.inspeccionable = inspeccionable;
		this.observacionesCastellano = observacionesCastellano;
		this.observacionesEuskera = observacionesEuskera;

	}

	/**
	 * @param importePresentado
	 * @param importeAdmitido
	 */
	public RelExpActSub(Integer idRelExpActSub, Integer inspeccionable, String observacionesCastellano,
			String observacionesEuskera) {

		this.idRelExpActSub = idRelExpActSub;
		this.inspeccionable = inspeccionable;
		this.observacionesCastellano = observacionesCastellano;
		this.observacionesEuskera = observacionesEuskera;

	}

	/**
	 * @param importePresentado
	 * @param importeAdmitido
	 */
	public RelExpActSub(BigDecimal importePresentado, BigDecimal importeAdmitido) {

		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;

	}

	/**
	 * @param importePresentado
	 * @param importeAdmitido
	 */
	public RelExpActSub(BigDecimal importePresentado, BigDecimal importeAdmitido, BigDecimal importeJustPresentado,
			BigDecimal importeJustAdmitido, BigDecimal porcentajeJus, BigDecimal importe) {

		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.importeJustPresentado = importeJustPresentado;
		this.importeJustAdmitido = importeJustAdmitido;
		this.porcentajeJus = porcentajeJus;
		this.importe = importe;

	}

	/**
	 * @param importeAdmitido
	 *
	 */
	public RelExpActSub(BigDecimal importeAdmitido) {

		this.importeAdmitido = importeAdmitido;

	}

	/**
	 * Method 'RelExpActSub'.
	 * 
	 * @param idRelExpActSub
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param actSubvencionable
	 *            ActSubvencionable
	 */
	public RelExpActSub(Integer idRelExpActSub, Integer idExpediente, Date fechaRegistro, String usuarioRegistro,
			ActSubvencionable actSubvencionable, Integer idActSub) {

		this.idRelExpActSub = idRelExpActSub;
		this.actSubvencionable = actSubvencionable;
		this.idExpediente = idExpediente;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.idActSub = idActSub;
	}

	/**
	 * Method 'RelExpActSub'.
	 * 
	 * @param idRelExpActSub
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param actSubvencionable
	 *            ActSubvencionable
	 */
	public RelExpActSub(Integer idRelExpActSub, Integer idExpediente, Date fechaRegistro, String usuarioRegistro,
			BigDecimal importePresentado, BigDecimal importeAdmitido, Integer inspeccionable,
			String observacionesEuskera, String observacionesCastellano, ActSubvencionable actSubvencionable) {

		this.idRelExpActSub = idRelExpActSub;
		this.actSubvencionable = actSubvencionable;
		this.idExpediente = idExpediente;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.inspeccionable = inspeccionable;
		this.observacionesEuskera = observacionesEuskera;
		this.observacionesCastellano = observacionesCastellano;
	}

	/**
	 * Method 'RelExpActSub'.
	 * 
	 * @param idRelExpActSub
	 *            Integer
	 * 
	 * @param actSubvencionable
	 *            ActSubvencionable
	 */
	public RelExpActSub(Integer idRelExpActSub, Integer idExpediente, ActSubvencionable actSubvencionable) {
		this.idRelExpActSub = idRelExpActSub;
		this.idExpediente = idExpediente;
		this.actSubvencionable = actSubvencionable;

	}

	/**
	 * Method 'RelExpActSub'.
	 * 
	 * @param idRelExpActSub
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @param actAsociacions
	 *            List<ActAsociacion>
	 * @param conceptosActSubs
	 *            List<ConceptosActSub>
	 * @param competitividads
	 *            List<Competitividad>
	 * @param relActSubSubacts
	 *            List<RelActSubSubact>
	 * @param pertenenciasRedeses
	 *            List<PertenenciasRedes>
	 * @param establecimientoses
	 *            List<Establecimientos>
	 * @param gastosTuristicoses
	 *            List<GastosTuristicos>
	 * @param facturases
	 *            List<Facturas>
	 * @param contratacionesPersonals
	 *            List<ContratacionesPersonal>
	 * @param actAyuntamientos
	 *            List<ActAyuntamiento>
	 */
	public RelExpActSub(Integer idRelExpActSub, Integer idExpediente, Date fechaRegistro, String usuarioRegistro,
			ActSubvencionable actSubvencionable, List<ActAsociacion> actAsociacions,
			List<Competitividad> competitividads, PertenenciasRedes pertenenciasRedes,
			GastosTuristicos gastosTuristicos, List<Facturas> facturases, ContratacionesPersonal contratacionesPersonal,
			List<ActAyuntamiento> actAyuntamientos) {

		this.idRelExpActSub = idRelExpActSub;
		this.actSubvencionable = actSubvencionable;
		this.idExpediente = idExpediente;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.actAsociacions = actAsociacions;
		this.competitividads = competitividads;
		this.pertenenciasRedes = pertenenciasRedes;
		this.gastosTuristicos = gastosTuristicos;
		this.facturases = facturases;
		this.contratacionesPersonal = contratacionesPersonal;
		this.actAyuntamientos = actAyuntamientos;
	}

	public RelExpActSub(ActSubvencionable actSubvencionable, BigDecimal importeAdmitido, BigDecimal importePresentado) {

		this.actSubvencionable = actSubvencionable;
		this.importeAdmitido = importeAdmitido;
		this.importePresentado = importePresentado;
	}

	public RelExpActSub(ActAyuntamiento actAyuntamiento, Integer idRelExpActSub, Integer idActSub) {

		this.actAyuntamiento = actAyuntamiento;
		this.idRelExpActSub = idRelExpActSub;
		this.idActSub = idActSub;
	}

	// Constructor para filtrar por DEC
	public RelExpActSub(Integer idRelExpActSub, Integer idExpediente, BigDecimal subvencionCalculada,
			BigDecimal porcentaje, ActAyuntamiento actAyuntamiento, ActAsociacion actAsociacion,
			BigDecimal importePresentado, BigDecimal importeAdmitido, ActSubvencionable actSubvencionable) {
		this.idRelExpActSub = idRelExpActSub;
		this.idExpediente = idExpediente;
		this.subvencionCalculada = subvencionCalculada;
		this.porcentaje = porcentaje;
		this.actAyuntamiento = actAyuntamiento;
		this.actAsociacion = actAsociacion;
		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.actSubvencionable = actSubvencionable;
	}

	public RelExpActSub(Integer idRelExpActSub, Integer idExpediente, BigDecimal subvencionCalculada,
			BigDecimal porcentaje, ActAyuntamiento actAyuntamiento, Facturas factura, BigDecimal importePresentado,
			BigDecimal importeAdmitido, ActSubvencionable actSubvencionable) {
		this.idRelExpActSub = idRelExpActSub;
		this.idExpediente = idExpediente;
		this.subvencionCalculada = subvencionCalculada;
		this.porcentaje = porcentaje;
		this.actAyuntamiento = actAyuntamiento;
		this.factura = factura;
		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.actSubvencionable = actSubvencionable;
	}

	public RelExpActSub(Integer idRelExpActSub, Integer idExpediente, BigDecimal subvencionCalculada,
			BigDecimal porcentaje, ActAyuntamiento actAyuntamiento, ActAsociacion actAsociacion,
			BigDecimal importePresentado, BigDecimal importeAdmitido, ActSubvencionable actSubvencionable,
			BigDecimal importeSinIva) {
		this.idRelExpActSub = idRelExpActSub;
		this.idExpediente = idExpediente;
		this.subvencionCalculada = subvencionCalculada;
		this.porcentaje = porcentaje;
		this.actAyuntamiento = actAyuntamiento;
		this.actAsociacion = actAsociacion;
		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.actSubvencionable = actSubvencionable;
		this.importeSinIva = importeSinIva;
	}

	public RelExpActSub(Integer idRelExpActSub, BigDecimal importePresentado, BigDecimal importeAdmitido, String notas,
			String observacionesCastellano, String observacionesEuskera) {

		this.idRelExpActSub = idRelExpActSub;
		this.notas = notas;
		this.observacionesEuskera = observacionesEuskera;
		this.observacionesCastellano = observacionesCastellano;
		this.importeAdmitido = importeAdmitido;
		this.importePresentado = importePresentado;
	}

	public RelExpActSub(ActSubvencionable actSubvencionable) {
		this.actSubvencionable = actSubvencionable;
	}

	public RelExpActSub(Integer idRelExpActSub, Integer inspeccionable, String observacionesInspCastellano,
			String observacionesInspEuskera, BigDecimal importePresentado, BigDecimal importeAdmitido, String notas,
			String observacionesCastellano, String observacionesEuskera, ActAyuntamiento actAyuntamiento,
			ActAsociacion actAsociacion, ActSubvencionable actSubvencionable) {
		this.idRelExpActSub = idRelExpActSub;
		this.inspeccionable = inspeccionable;
		this.observacionesInspCastellano = observacionesInspCastellano;
		this.observacionesInspEuskera = observacionesInspEuskera;
		this.actSubvencionable = actSubvencionable;
		this.actAyuntamiento = actAyuntamiento;
		this.actAsociacion = actAsociacion;
		this.notas = notas;
		this.observacionesEuskera = observacionesEuskera;
		this.observacionesCastellano = observacionesCastellano;
		this.importeAdmitido = importeAdmitido;
		this.importePresentado = importePresentado;

	}

	public RelExpActSub(int enviadoInspeccionar, int inspeccionable, BigDecimal importePresentado,
			String observacionesCastellano, String observacionesEuskera) {
		this.enviadoInspeccionar = enviadoInspeccionar;
		this.inspeccionable = inspeccionable;
		this.importePresentado = importePresentado;
		this.observacionesCastellano = observacionesCastellano;
		this.observacionesEuskera = observacionesEuskera;
	}

	public String getActSubvencionableConcatenadaDEC() {
		Locale locale = LocaleContextHolder.getLocale();
		String idioma = locale.getLanguage();
		String result = "";
		String descripcion = descripcionPorIdioma(idioma);
		if (null != this.actSubvencionable && null != this.actAyuntamiento && null != this.actAsociacion) {

			// Para justificacion, porque no va relleno el id
			if (this.actSubvencionable.getIdActSubPadreAgrupacion() != null) {
				if (this.actSubvencionable
						.getIdActSubPadreAgrupacion() == Constantes.ID_AGRUPACION_DEC_Ayuntamiento_Estudios
						|| this.actSubvencionable
								.getIdActSubPadreAgrupacion() == Constantes.ID_AGRUPACION_DEC_Ayuntamiento_Actuaciones_Urbanisticas) {
					result = descripcion + " (" + this.actAyuntamiento.getTitulo() + ")";
				} else if (this.actSubvencionable
						.getIdActSubPadreAgrupacion() == Constantes.ID_AGRUPACION_DEC_Asociacion) {
					result = descripcion + " (" + this.actAsociacion.getTitulo() + ")";
				}
			}

		}

		return result;
	}

	public String getActSubvencionableConcatenadaEMCO() {
		Locale locale = LocaleContextHolder.getLocale();
		String idioma = locale.getLanguage();
		String result = "";
		String descripcion = descripcionPorIdioma(idioma);

		if (null != this.actSubvencionable && null != this.actAyuntamiento) {

			// Para justificacion, porque no va relleno el id
			if (this.actSubvencionable.getIdActSubPadreAgrupacion() != null) {
				if (this.actSubvencionable
						.getIdActSubPadreAgrupacion() != Constantes.ID_AGRUPACION_EMCO_Emprendimiento) {
					result = descripcion + " (" + this.actAyuntamiento.getTitulo() + ")";
				}
			}

		}

		return result;
	}

	/**
	 * Method 'getActSubvencionableConcatenada'.
	 *
	 * Devuelve el titulo de la accion subvencionable + la concatenacion de
	 * datos de otras tablas
	 */

	public String getActSubvencionableConcatenada() {
		Locale locale = LocaleContextHolder.getLocale();
		String idioma = locale.getLanguage();
		String descripcion;
		descripcion = descripcionPorIdioma(idioma);
		if (null != this.actSubvencionable && null != this.actSubvencionable.getIdActSubAgrupacion()) {
			if (this.actSubvencionable.getIdActSubAgrupacion() == Constantes.ID_AGRUPACION_PTT_Contratacion_Temporal) {
				actSubvencionableConcatenada = calcularDescripcion_Contratacion_Temporal(descripcion);
			} else if (this.actSubvencionable
					.getIdActSubAgrupacion() == Constantes.ID_AGRUPACION_PTT_Pertenencia_Redes) {
				actSubvencionableConcatenada = descripcion;
			} else if (this.actSubvencionable.getIdActSubAgrupacion() == Constantes.ID_AGRUPACION_PTT_Gastos_Creacion) {
				actSubvencionableConcatenada = calcularDescripcion_Gastos_Creacion(idioma, descripcion);
			} else if (this.actSubvencionable
					.getIdActSubAgrupacion() == Constantes.ID_AGRUPACION_PTT_Programa_Calidad_Destinos
					|| this.actSubvencionable.getIdActSubAgrupacion() == Constantes.ID_AGRUPACION_PTT_Programa_TIC
					|| this.actSubvencionable
							.getIdActSubAgrupacion() == Constantes.ID_AGRUPACION_PTT_Programa_Ecoetiquetas_Europea
					|| this.actSubvencionable
							.getIdActSubAgrupacion() == Constantes.ID_AGRUPACION_PTT_Programa_Compromiso_Accesibilidad
					|| this.actSubvencionable
							.getIdActSubAgrupacion() == Constantes.ID_AGRUPACION_PTT_Programa_Compromiso_Codigo_Etico) {
				actSubvencionableConcatenada = calcularDescripcionActSubResto(descripcion);
			}
		}
		return actSubvencionableConcatenada;
	}

	private String calcularDescripcionActSubResto(String descripcion) {
		String result;
		// Para la justificacion, personasContratadas es nulo
		if (this.personasContratadas != null) {
			String apellido2 = this.personasContratadas.getApellido2PC() != null
					? this.personasContratadas.getApellido2PC() : "";
			result = descripcion + " (" + this.personasContratadas.getNombrePC() + " "
					+ this.personasContratadas.getApellido1PC() + " " + apellido2 + ")";
		} else {
			result = "";
		}
		return result;
	}

	private String calcularDescripcion_Gastos_Creacion(String idioma, String descripcion) {
		String result;
		String descripcionProductoTuristico = "";
		String denominacion = "";
		try {
			if ("es".equalsIgnoreCase(idioma)) {
				descripcionProductoTuristico = this.gastosTuristicos.getProductosTuristicos()
						.getDescripcionCastellano();
			} else if ("eu".equalsIgnoreCase(idioma)) {
				descripcionProductoTuristico = this.gastosTuristicos.getProductosTuristicos().getDescripcionEuskera();
			}
			denominacion = this.gastosTuristicos.getDenominacion();
		} catch (Exception e) {
			descripcionProductoTuristico = "";
			denominacion = "";
		}
		result = descripcion + " (" + descripcionProductoTuristico + " " + denominacion + ")";
		return result;
	}

	private String calcularDescripcion_Contratacion_Temporal(String descripcion) {
		String result;
		if (contratacionesPersonal != null) {
			String apellido2 = this.contratacionesPersonal.getApellido2() != null
					? this.contratacionesPersonal.getApellido2() : "";
			result = descripcion + " (" + this.contratacionesPersonal.getNombre() + " "
					+ this.contratacionesPersonal.getApellido1() + " " + apellido2 + ")";
			return result;
		} else
			return descripcion;

	}

	private String descripcionPorIdioma(String idioma) {
		String descripcion = "";
		if (null != this.actSubvencionable) {
			if ("es".equalsIgnoreCase(idioma)) {
				descripcion = this.actSubvencionable.getDescripcionCastellano();
			} else if ("eu".equalsIgnoreCase(idioma)) {
				descripcion = this.actSubvencionable.getDescripcionEuskera();
			}
		}

		return descripcion;
	}

	/**
	 * Method 'getIdRelExpActSub'.
	 *
	 * @return Integer
	 */

	public Integer getIdRelExpActSub() {
		return this.idRelExpActSub;
	}

	/**
	 * Method 'setIdRelExpActSub'.
	 *
	 * @param idRelExpActSub
	 *            Integer
	 * @return
	 */

	public void setIdRelExpActSub(Integer idRelExpActSub) {
		this.idRelExpActSub = idRelExpActSub;
	}

	/**
	 * Method 'getActSubvencionable'.
	 *
	 * @return ActSubvencionable
	 */

	public ActSubvencionable getActSubvencionable() {
		return this.actSubvencionable;
	}

	/**
	 * Method 'setActSubvencionable'.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return
	 */

	public void setActSubvencionable(ActSubvencionable actSubvencionable) {
		this.actSubvencionable = actSubvencionable;
	}

	/**
	 * Method 'getIdExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdExpediente() {
		return this.idExpediente;
	}

	/**
	 * Method 'setIdExpediente'.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return
	 */

	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getActAsociacions'.
	 *
	 * @return List
	 */

	public List<ActAsociacion> getActAsociacions() {
		return this.actAsociacions;
	}

	/**
	 * Method 'setActAsociacions'.
	 *
	 * @param actAsociacions
	 *            List
	 * @return
	 */
	public void setActAsociacions(List<ActAsociacion> actAsociacions) {
		this.actAsociacions = actAsociacions;
	}

	/**
	 * Method 'getCompetitividads'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<Competitividad> getCompetitividads() {
		return this.competitividads;
	}

	/**
	 * Method 'setCompetitividads'.
	 *
	 * @param competitividads
	 *            List
	 * @return
	 */
	public void setCompetitividads(List<Competitividad> competitividads) {
		this.competitividads = competitividads;
	}

	/**
	 * Method 'getFacturases'.
	 *
	 * @return List
	 */

	public List<Facturas> getFacturases() {
		return this.facturases;
	}

	/**
	 * Method 'setFacturases'.
	 *
	 * @param facturases
	 *            List
	 * @return
	 */
	public void setFacturases(List<Facturas> facturases) {
		this.facturases = facturases;
	}

	/**
	 * Method 'getContratacionesPersonals'.
	 *
	 * @return List
	 */
	public ContratacionesPersonal getContratacionesPersonal() {
		return this.contratacionesPersonal;
	}

	/**
	 * Method 'setContratacionesPersonals'.
	 *
	 * @param contratacionesPersonals
	 *            List
	 * @return
	 */
	public void setContratacionesPersonal(ContratacionesPersonal contratacionesPersonal) {
		this.contratacionesPersonal = contratacionesPersonal;
	}

	/**
	 * Method 'getActAyuntamientos'.
	 *
	 * @return List
	 */
	public List<ActAyuntamiento> getActAyuntamientos() {
		return this.actAyuntamientos;
	}

	/**
	 * Method 'setActAyuntamientos'.
	 *
	 * @param actAyuntamientos
	 *            List
	 * @return
	 */
	public void setActAyuntamientos(List<ActAyuntamiento> actAyuntamientos) {
		this.actAyuntamientos = actAyuntamientos;
	}

	/**
	 * @return the notas
	 */
	public String getNotas() {
		return notas;
	}

	/**
	 * @param notas
	 *            the notas to set
	 */
	public void setNotas(String notas) {
		this.notas = notas;
	}

	/**
	 * @return the observacionesEuskera
	 */
	public String getObservacionesEuskera() {
		return observacionesEuskera;
	}

	/**
	 * @param observacionesEuskera
	 *            the observacionesEuskera to set
	 */
	public void setObservacionesEuskera(String observacionesEuskera) {
		this.observacionesEuskera = observacionesEuskera;
	}

	/**
	 * @return the observacionesCastellano
	 */
	public String getObservacionesCastellano() {
		return observacionesCastellano;
	}

	/**
	 * @param observacionesCastellano
	 *            the observacionesCastellano to set
	 */
	public void setObservacionesCastellano(String observacionesCastellano) {
		this.observacionesCastellano = observacionesCastellano;
	}

	/**
	 * @return the importeAdmitido
	 */
	public BigDecimal getImporteAdmitido() {
		return importeAdmitido;
	}

	public String getImporteAdmitidoStr() {
		String importeAdmitidoStrResult = "";
		if (null != this.importeAdmitido) {
			importeAdmitidoStrResult = this.importeAdmitido.toString();
		}
		return importeAdmitidoStrResult;
	}

	public String getImporteAdmitidoStrInline() {
		return importeAdmitidoStr;
	}

	public void setImporteAdmitidoStr(String importeAdmitidoStr) {
		this.importeAdmitidoStr = importeAdmitidoStr;
	}

	/**
	 * Method 'getImporteAdmitidoMask'.
	 *
	 * @return BigDecimal
	 */

	public String getImporteAdmitidoMask() {

		return UtilDate.formatearMiles(importeAdmitido);

	}

	/**
	 * Method 'getImporteAdmitidoMask'.
	 *
	 * @return BigDecimal
	 */

	public String getSubvencionCalculadaMask() {

		return UtilDate.formatearMiles(subvencionCalculada);

	}

	public String getAyudaConcedidaMask() {

		return UtilDate.formatearMiles(ayudaConcedida);

	}

	public String getPorcentajeMask() {

		return UtilDate.formatearMiles(porcentaje);

	}

	/**
	 * @param importeAdmitido
	 *            the importeAdmitido to set
	 */
	public void setImporteAdmitido(BigDecimal importeAdmitido) {
		this.importeAdmitido = importeAdmitido;
	}

	/**
	 * @return the importePresentado
	 */
	public BigDecimal getImportePresentado() {
		return importePresentado;
	}

	/**
	 * Method 'getImportePresentadoMask'.
	 *
	 * @return BigDecimal
	 */

	public String getImportePresentadoMask() {

		return UtilDate.formatearMiles(importePresentado);

	}

	/**
	 * @param importePresentado
	 *            the importePresentado to set
	 */
	public void setImportePresentado(BigDecimal importePresentado) {
		this.importePresentado = importePresentado;
	}

	/**
	 * @return the importeJustPresentado
	 */
	public BigDecimal getImporteJustPresentado() {
		return importeJustPresentado;
	}

	/**
	 * @param importeJustPresentado
	 *            the importeJustPresentado to set
	 */
	public void setImporteJustPresentado(BigDecimal importeJustPresentado) {
		this.importeJustPresentado = importeJustPresentado;
	}

	/**
	 * @return the importeJustAdmitido
	 */
	public BigDecimal getImporteJustAdmitido() {
		return importeJustAdmitido;
	}

	/**
	 * @param importeJustAdmitido
	 *            the importeJustAdmitido to set
	 */
	public void setImporteJustAdmitido(BigDecimal importeJustAdmitido) {
		this.importeJustAdmitido = importeJustAdmitido;
	}

	/**
	 * @return the fechaUltmodificacion
	 */
	public Date getFechaUltmodificacion() {
		return fechaUltmodificacion;
	}

	/**
	 * @param fechaUltmodificacion
	 *            the fechaUltmodificacion to set
	 */
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * @return the usuarioUltmodificacion
	 */
	public String getUsuarioUltmodificacion() {
		return usuarioUltmodificacion;
	}

	/**
	 * @param usuarioUltmodificacion
	 *            the usuarioUltmodificacion to set
	 */
	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 * 
	 * @Override public String toString() { StringBuilder result = new
	 *           StringBuilder();
	 *           result.append(this.getClass().getName()).append(" Object { ");
	 *           result.append(" [ idRelExpActSub:
	 *           ").append(this.idRelExpActSub).append(" ]"); result.append(", [
	 *           idExpediente: ").append(this.idExpediente).append(" ]");
	 *           result.append(", [ fechaRegistro:
	 *           ").append(this.fechaRegistro).append(" ]"); result.append(", [
	 *           usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
	 *           result.append("}"); return result.toString(); }
	 * 
	 */

	/**
	 * @return the estudioTecnico
	 */
	public EstudioTecnico getEstudioTecnico() {
		return estudioTecnico;
	}

	/**
	 * @param estudioTecnico
	 *            the estudioTecnico to set
	 */
	public void setEstudioTecnico(EstudioTecnico estudioTecnico) {
		this.estudioTecnico = estudioTecnico;
	}

	/**
	 * @return the checkDenegacion
	 */
	public Boolean getCheckDenegacion() {
		return CheckDenegacion;
	}

	/**
	 * @param checkDenegacion
	 *            the checkDenegacion to set
	 */
	public void setCheckDenegacion(Boolean checkDenegacion) {
		CheckDenegacion = checkDenegacion;
	}

	/**
	 * @return the checkMinoracion
	 */
	public Boolean getCheckMinoracion() {
		return CheckMinoracion;
	}

	/**
	 * @param checkMinoracion
	 *            the checkMinoracion to set
	 */
	public void setCheckMinoracion(Boolean checkMinoracion) {
		CheckMinoracion = checkMinoracion;
	}

	/**
	 * @return the idconvocatoria
	 */
	public Integer getIdconvocatoria() {
		return idconvocatoria;
	}

	/**
	 * @param idconvocatoria
	 *            the idconvocatoria to set
	 */
	public void setIdconvocatoria(Integer idconvocatoria) {
		this.idconvocatoria = idconvocatoria;
	}

	/**
	 * @return the idActSub
	 */
	public Integer getIdActSub() {
		return idActSub;
	}

	/**
	 * @param idActSub
	 *            the idActSub to set
	 */
	public void setIdActSub(Integer idActSub) {
		this.idActSub = idActSub;
	}

	/**
	 * @return the actAyuntamiento
	 */
	public ActAyuntamiento getActAyuntamiento() {
		return actAyuntamiento;
	}

	/**
	 * @param actAyuntamiento
	 *            the actAyuntamiento to set
	 */
	public void setActAyuntamiento(ActAyuntamiento actAyuntamiento) {
		this.actAyuntamiento = actAyuntamiento;
	}

	/**
	 * Method 'getPertenenciasRedes'.
	 * 
	 * @return the pertenenciasRedes
	 */
	public PertenenciasRedes getPertenenciasRedes() {
		return pertenenciasRedes;
	}

	/**
	 * Method 'setPertenenciasRedes'.
	 * 
	 * @param pertenenciasRedes
	 *            the pertenenciasRedes to set
	 */
	public void setPertenenciasRedes(PertenenciasRedes pertenenciasRedes) {
		this.pertenenciasRedes = pertenenciasRedes;
	}

	/**
	 * Method 'getGastosTuristicos'.
	 * 
	 * @return the gastosTuristicos
	 */
	public GastosTuristicos getGastosTuristicos() {
		return gastosTuristicos;
	}

	/**
	 * Method 'setGastosTuristicos'.
	 * 
	 * @param gastosTuristicos
	 *            the gastosTuristicos to set
	 */
	public void setGastosTuristicos(GastosTuristicos gastosTuristicos) {
		this.gastosTuristicos = gastosTuristicos;
	}

	/**
	 * Method 'getProductosTuristicos'.
	 * 
	 * @return the productosTuristicos
	 */
	public ProductosTuristicos getProductosTuristicos() {
		return productosTuristicos;
	}

	/**
	 * Method 'setProductosTuristicos'.
	 * 
	 * @param productosTuristicos
	 *            the productosTuristicos to set
	 */
	public void setProductosTuristicos(ProductosTuristicos productosTuristicos) {
		this.productosTuristicos = productosTuristicos;
	}

	/**
	 * Method 'getIdProductoTuristico'.
	 *
	 * @return Long
	 */

	public Long getIdProductoTuristico() {
		return this.idProductoTuristico;
	}

	/**
	 * Method 'setIdProductoTuristico'.
	 *
	 * @param idProductoTuristico
	 *            Long
	 * @return
	 */

	public void setIdProductoTuristico(Long idProductoTuristico) {
		this.idProductoTuristico = idProductoTuristico;
	}

	/**
	 * @return the inspeccionable
	 */
	public Integer getInspeccionable() {
		return inspeccionable;
	}

	/**
	 * @param inspeccionable
	 *            the inspeccionable to set
	 */
	public void setInspeccionable(Integer inspeccionable) {
		this.inspeccionable = inspeccionable;
	}

	/**
	 * @return the personasContratadas
	 */
	public PersonasContratadas getPersonasContratadas() {
		return personasContratadas;
	}

	/**
	 * @param personasContratadas
	 *            the personasContratadas to set
	 */
	public void setPersonasContratadas(PersonasContratadas personasContratadas) {
		this.personasContratadas = personasContratadas;
	}

	/**
	 * @return the subvencionCalculada
	 */
	public BigDecimal getSubvencionCalculada() {
		return subvencionCalculada;
	}

	/**
	 * @param subvencionCalculada
	 *            the subvencionCalculada to set
	 */
	public void setSubvencionCalculada(BigDecimal subvencionCalculada) {
		this.subvencionCalculada = subvencionCalculada;
	}

	/**
	 * @return the porcentaje
	 */
	public BigDecimal getPorcentaje() {
		return porcentaje;
	}

	/**
	 * @param porcentaje
	 *            the porcentaje to set
	 */
	public void setPorcentaje(BigDecimal porcentaje) {
		this.porcentaje = porcentaje;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "RelExpActSub [idRelExpActSub=" + idRelExpActSub + ", idActSub=" + idActSub + ", actSubvencionable="
				+ actSubvencionable + ", actAyuntamiento=" + actAyuntamiento + ", estudioTecnico=" + estudioTecnico
				+ ", idExpediente=" + idExpediente + ", fechaRegistro=" + fechaRegistro + ", usuarioRegistro="
				+ usuarioRegistro + ", fechaUltmodificacion=" + fechaUltmodificacion + ", usuarioUltmodificacion="
				+ usuarioUltmodificacion + ", notas=" + notas + ", inspeccionable=" + inspeccionable
				+ ", observacionesEuskera=" + observacionesEuskera + ", observacionesCastellano="
				+ observacionesCastellano + ", importeAdmitido=" + importeAdmitido + ", importePresentado="
				+ importePresentado + ", importeJustPresentado=" + importeJustPresentado + ", importeJustAdmitido="
				+ importeJustAdmitido + ", actAsociacions=" + actAsociacions + ", competitividads=" + competitividads
				+ ", facturases=" + facturases + ", actAyuntamientos=" + actAyuntamientos + ", CheckDenegacion="
				+ CheckDenegacion + ", CheckMinoracion=" + CheckMinoracion + ", idconvocatoria=" + idconvocatoria
				+ ", pertenenciasRedes=" + pertenenciasRedes + ", gastosTuristicos=" + gastosTuristicos
				+ ", productosTuristicos=" + productosTuristicos + ", idProductoTuristico=" + idProductoTuristico
				+ ", contratacionesPersonal=" + contratacionesPersonal + ", personasContratadas=" + personasContratadas
				+ "]";
	}

	/**
	 * @return the baseSubvencionable
	 */
	public BigDecimal getBaseSubvencionable() {
		return baseSubvencionable;
	}

	/**
	 * @param baseSubvencionable
	 *            the baseSubvencionable to set
	 */
	public void setBaseSubvencionable(BigDecimal baseSubvencionable) {
		this.baseSubvencionable = baseSubvencionable;
	}

	/**
	 * @return the baseSubvencionableAdmitido
	 */
	public BigDecimal getBaseSubvencionableAdmitido() {
		return baseSubvencionableAdmitido;
	}

	/**
	 * @param baseSubvencionableAdmitido
	 *            the baseSubvencionableAdmitido to set
	 */
	public void setBaseSubvencionableAdmitido(BigDecimal baseSubvencionableAdmitido) {
		this.baseSubvencionableAdmitido = baseSubvencionableAdmitido;
	}

	/**
	 * @return the criteriosRelActSubSubacts
	 */
	public Integer[] getCriteriosRelActSubSubacts() {
		return criteriosRelActSubSubacts;
	}

	/**
	 * @param criteriosRelActSubSubacts
	 *            the criteriosRelActSubSubacts to set
	 */
	public void setCriteriosRelActSubSubacts(Integer[] criteriosRelActSubSubacts) {
		this.criteriosRelActSubSubacts = criteriosRelActSubSubacts;
	}

	/**
	 * @return the actAsociacion
	 */
	public ActAsociacion getActAsociacion() {
		return actAsociacion;
	}

	/**
	 * @param actAsociacion
	 *            the actAsociacion to set
	 */
	public void setActAsociacion(ActAsociacion actAsociacion) {
		this.actAsociacion = actAsociacion;
	}

	/**
	 * @return the comboMinoracion
	 */
	public List<MotivosMinoracion> getComboMinoracion() {
		return comboMinoracion;
	}

	/**
	 * @param comboMinoracion
	 *            the comboMinoracion to set
	 */
	public void setComboMinoracion(List<MotivosMinoracion> comboMinoracion) {
		this.comboMinoracion = comboMinoracion;
	}

	/**
	 * @return the comboDenegacion
	 */
	public List<MotivosDenegacion> getComboDenegacion() {
		return comboDenegacion;
	}

	/**
	 * @param comboDenegacion
	 *            the comboDenegacion to set
	 */
	public void setComboDenegacion(List<MotivosDenegacion> comboDenegacion) {
		this.comboDenegacion = comboDenegacion;
	}

	/**
	 * @return the enviadoInspeccionar
	 */
	public Integer getEnviadoInspeccionar() {
		return enviadoInspeccionar;
	}

	/**
	 * @param enviadoInspeccionar
	 *            the enviadoInspeccionar to set
	 */
	public void setEnviadoInspeccionar(Integer enviadoInspeccionar) {
		this.enviadoInspeccionar = enviadoInspeccionar;
	}

	/**
	 * @return the ayudaConcedida
	 */
	public BigDecimal getAyudaConcedida() {
		return ayudaConcedida;
	}

	/**
	 * @param ayudaConcedida
	 *            the ayudaConcedida to set
	 */
	public void setAyudaConcedida(BigDecimal ayudaConcedida) {
		this.ayudaConcedida = ayudaConcedida;
	}

	/**
	 * @return the puntos
	 */
	public Integer getPuntos() {
		return puntos;
	}

	/**
	 * @param puntos
	 *            the puntos to set
	 */
	public void setPuntos(Integer puntos) {
		this.puntos = puntos;
	}

	/**
	 * @return the folderNumber
	 */
	public String getFolderNumber() {
		return folderNumber;
	}

	/**
	 * @param folderNumber
	 *            the folderNumber to set
	 */
	public void setFolderNumber(String folderNumber) {
		this.folderNumber = folderNumber;
	}

	/**
	 * @return the descEs
	 */
	public String getDescEs() {
		return descEs;
	}

	/**
	 * @param descEs
	 *            the descEs to set
	 */
	public void setDescEs(String descEs) {
		this.descEs = descEs;
	}

	/**
	 * @return the descEus
	 */
	public String getDescEus() {
		return descEus;
	}

	/**
	 * @param descEus
	 *            the descEus to set
	 */
	public void setDescEus(String descEus) {
		this.descEus = descEus;
	}

	/**
	 * @return the importe
	 */
	public BigDecimal getImporte() {
		return importe;
	}

	/**
	 * @param importe
	 *            the importe to set
	 */
	public void setImporte(BigDecimal importe) {
		this.importe = importe;
	}

	/**
	 * @return the exento
	 */
	public Integer getExento() {
		return exento;
	}

	/**
	 * @param exento
	 *            the exento to set
	 */
	public void setExento(Integer exento) {
		this.exento = exento;
	}

	/**
	 * @return the importeSinIva
	 */
	public BigDecimal getImporteSinIva() {
		return importeSinIva;
	}

	/**
	 * @param importeSinIva
	 *            the importeSinIva to set
	 */
	public void setImporteSinIva(BigDecimal importeSinIva) {
		this.importeSinIva = importeSinIva;
	}

	/**
	 * @return the factura
	 */
	public Facturas getFactura() {
		return factura;
	}

	/**
	 * @param factura
	 *            the factura to set
	 */
	public void setFactura(Facturas factura) {
		this.factura = factura;
	}

	public String getObservacionesInspCastellano() {
		return observacionesInspCastellano;
	}

	public void setObservacionesInspCastellano(String observacionesInspCastellano) {
		this.observacionesInspCastellano = observacionesInspCastellano;
	}

	public String getObservacionesInspEuskera() {
		return observacionesInspEuskera;
	}

	public void setObservacionesInspEuskera(String observacionesInspEuskera) {
		this.observacionesInspEuskera = observacionesInspEuskera;
	}

	public String getImporteJusAdmitidoStr() {
		String importeAdmitidoStrResult = "";
		if (null != this.importeJustAdmitido) {
			importeAdmitidoStrResult = this.importeJustAdmitido.toString();
		}
		return importeAdmitidoStrResult;
	}

	public String getImporteJusAdmitidoStrInline() {
		return importeJusAdmitidoStr;
	}

	public void setImporteJusAdmitidoStr(String importeJusAdmitidoStr) {
		this.importeJusAdmitidoStr = importeJusAdmitidoStr;
	}

	/**
	 * @return the conceptos
	 */
	public Conceptos getConceptos() {
		return conceptos;
	}

	/**
	 * @param conceptos
	 *            the conceptos to set
	 */
	public void setConceptos(Conceptos conceptos) {
		this.conceptos = conceptos;
	}

}
