package com.ejie.ab60.model.convocatorias;

import com.ejie.ab60.model.nora.T17Provincia;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import java.math.BigDecimal;
import java.util.Date;

/**
 * AplicacionesPresupuestarias  
 * 
 *  
 */

public class AplicacionesPresupuestarias implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idAplicacionPresupuestaria;
	private Integer idConvocatoria;
	private String ejercicio;
	private String agrupacion;
	private String gastoIngreso;
	private String seccion;
	private String servicio;
	private String centro;
	// private Integer idProvincia;
	private T17Provincia provincia;
	private String cac;
	private String sc;
	private String programa;
	private String partida;
	private String letraControl;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private BigDecimal importe;
	private BigDecimal importeDisponible;
	private ReferenciasIntervencion refIntervencion;

	private boolean controlError;

	/**
	 * Method 'AplicacionesPresupuestarias'.
	 */
	public AplicacionesPresupuestarias() {
	}

	/**
	 * Method 'AplicacionesPresupuestarias'.
	 * 
	 * @param idAplicacionPresupuestaria
	 *            Integer
	 */
	public AplicacionesPresupuestarias(Integer idAplicacionPresupuestaria) {
		this.idAplicacionPresupuestaria = idAplicacionPresupuestaria;
	}

	/**
	 * Method 'AplicacionesPresupuestarias'.
	 * 
	 * @param idAplicacionPresupuestaria
	 *            Integer
	 * @param idProcedimiento
	 *            Integer
	 * @param ejercicio
	 *            String
	 * @param agrupacion
	 *            Integer
	 * @param gastoIngreso
	 *            Integer
	 * @param seccion
	 *            String
	 * @param servicio
	 *            String
	 * @param centro
	 *            Integer
	 * @param idProvincia
	 *            String
	 * @param cac
	 *            String
	 * @param sc
	 *            String
	 * @param programa
	 *            Integer
	 * @param partida
	 *            String
	 * @param letraControl
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 */
	public AplicacionesPresupuestarias(Integer idAplicacionPresupuestaria, Integer idConvocatoria, String ejercicio,
			String agrupacion, String gastoIngreso, String seccion, String servicio, String centro,
			T17Provincia provincia, String cac, String sc, String programa, String partida, String letraControl,
			Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion,
			BigDecimal importe, BigDecimal importeDisponible) {

		this.idAplicacionPresupuestaria = idAplicacionPresupuestaria;
		this.idConvocatoria = idConvocatoria;
		this.ejercicio = ejercicio;
		this.agrupacion = agrupacion;
		this.gastoIngreso = gastoIngreso;
		this.seccion = seccion;
		this.servicio = servicio;
		this.centro = centro;
		this.provincia = provincia;
		this.cac = cac;
		this.sc = sc;
		this.programa = programa;
		this.partida = partida;
		this.letraControl = letraControl;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.importe = importe;
		this.importeDisponible = importeDisponible;
	}

	/**
	 * Method 'getIdAplicacionPresupuestaria'.
	 *
	 * @return Integer
	 */

	public Integer getIdAplicacionPresupuestaria() {
		return this.idAplicacionPresupuestaria;
	}

	/**
	 * Method 'setIdAplicacionPresupuestaria'.
	 *
	 * @param idAplicacionPresupuestaria
	 *            Integer
	 * @return
	 */

	public void setIdAplicacionPresupuestaria(Integer idAplicacionPresupuestaria) {
		this.idAplicacionPresupuestaria = idAplicacionPresupuestaria;
	}

	/**
	 * Method 'getIdProcedimiento'.
	 *
	 * @return Integer
	 */

	public Integer getIdConvocatoria() {
		return this.idConvocatoria;
	}

	/**
	 * Method 'setIdProcedimiento'.
	 *
	 * @param idProcedimiento
	 *            Integer
	 * @return
	 */

	public void setIdConvocatoria(Integer idConvocatoria) {
		this.idConvocatoria = idConvocatoria;
	}

	/**
	 * Method 'getEjercicio'.
	 *
	 * @return String
	 */

	public String getEjercicio() {
		return this.ejercicio;
	}

	/**
	 * Method 'setEjercicio'.
	 *
	 * @param ejercicio
	 *            String
	 * @return
	 */

	public void setEjercicio(String ejercicio) {
		this.ejercicio = ejercicio;
	}

	/**
	 * Method 'getAgrupacion'.
	 *
	 * @return Integer
	 */

	public String getAgrupacion() {
		return this.agrupacion;
	}

	/**
	 * Method 'setAgrupacion'.
	 *
	 * @param agrupacion
	 *            Integer
	 * @return
	 */

	public void setAgrupacion(String agrupacion) {
		this.agrupacion = agrupacion;
	}

	/**
	 * Method 'getGastoIngreso'.
	 *
	 * @return Integer
	 */

	public String getGastoIngreso() {
		return this.gastoIngreso;
	}

	/**
	 * Method 'setGastoIngreso'.
	 *
	 * @param gastoIngreso
	 *            Integer
	 * @return
	 */

	public void setGastoIngreso(String gastoIngreso) {
		this.gastoIngreso = gastoIngreso;
	}

	/**
	 * Method 'getSeccion'.
	 *
	 * @return String
	 */

	public String getSeccion() {
		return this.seccion;
	}

	/**
	 * Method 'setSeccion'.
	 *
	 * @param seccion
	 *            String
	 * @return
	 */

	public void setSeccion(String seccion) {
		this.seccion = seccion;
	}

	/**
	 * Method 'getServicio'.
	 *
	 * @return String
	 */

	public String getServicio() {
		return this.servicio;
	}

	/**
	 * Method 'setServicio'.
	 *
	 * @param servicio
	 *            String
	 * @return
	 */

	public void setServicio(String servicio) {
		this.servicio = servicio;
	}

	/**
	 * Method 'getCentro'.
	 *
	 * @return Integer
	 */

	public String getCentro() {
		return this.centro;
	}

	/**
	 * Method 'setCentro'.
	 *
	 * @param centro
	 *            Integer
	 * @return
	 */

	public void setCentro(String centro) {
		this.centro = centro;
	}

	/**
	 * Method 'getCac'.
	 *
	 * @return String
	 */

	public String getCac() {
		return this.cac;
	}

	/**
	 * Method 'setCac'.
	 *
	 * @param cac
	 *            String
	 * @return
	 */

	public void setCac(String cac) {
		this.cac = cac;
	}

	/**
	 * Method 'getSc'.
	 *
	 * @return String
	 */

	public String getSc() {
		return this.sc;
	}

	/**
	 * Method 'setSc'.
	 *
	 * @param sc
	 *            String
	 * @return
	 */

	public void setSc(String sc) {
		this.sc = sc;
	}

	/**
	 * Method 'getPrograma'.
	 *
	 * @return Integer
	 */

	public String getPrograma() {
		return this.programa;
	}

	/**
	 * Method 'setPrograma'.
	 *
	 * @param programa
	 *            Integer
	 * @return
	 */

	public void setPrograma(String programa) {
		this.programa = programa;
	}

	/**
	 * Method 'getPartida'.
	 *
	 * @return String
	 */

	public String getPartida() {
		return this.partida;
	}

	/**
	 * Method 'setPartida'.
	 *
	 * @param partida
	 *            String
	 * @return
	 */

	public void setPartida(String partida) {
		this.partida = partida;
	}

	/**
	 * Method 'getLetraControl'.
	 *
	 * @return String
	 */

	public String getLetraControl() {
		return this.letraControl;
	}

	/**
	 * Method 'setLetraControl'.
	 *
	 * @param letraControl
	 *            String
	 * @return
	 */

	public void setLetraControl(String letraControl) {
		this.letraControl = letraControl;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * @return the importe
	 */
	public BigDecimal getImporte() {
		return importe;
	}

	/**
	 * @param importe
	 *            the importe to set
	 */
	public void setImporte(BigDecimal importe) {
		this.importe = importe;
	}

	/**
	 * @return the importeDisponible
	 */
	public BigDecimal getImporteDisponible() {
		return importeDisponible;
	}

	/**
	 * @param importeDisponible
	 *            the importeDisponible to set
	 */
	public void setImporteDisponible(BigDecimal importeDisponible) {
		this.importeDisponible = importeDisponible;
	}

	/**
	 * @return the provincia
	 */
	public T17Provincia getProvincia() {
		return provincia;
	}

	/**
	 * @param provincia
	 *            the provincia to set
	 */
	public void setProvincia(T17Provincia provincia) {
		this.provincia = provincia;
	}

	/**
	 * Method 'getImporteMask'.
	 *
	 * @return BigDecimal
	 */

	public String getimporteDisponibleMask() {

		return UtilDate.formatearMiles(importeDisponible);

	}

	/**
	 * Method 'getImporteMask'.
	 *
	 * @return BigDecimal
	 */

	public String getimporteMask() {
		return UtilDate.formatearMiles(importe);

	}

	/**
	 * @return the controlError
	 */
	public boolean isControlError() {
		return controlError;
	}

	/**
	 * @param controlError
	 *            the controlError to set
	 */
	public void setControlError(boolean controlError) {
		this.controlError = controlError;
	}

	/**
	 * @return the refIntervencion
	 */
	public ReferenciasIntervencion getRefIntervencion() {
		return refIntervencion;
	}

	/**
	 * @param refIntervencion
	 *            the refIntervencion to set
	 */
	public void setRefIntervencion(ReferenciasIntervencion refIntervencion) {
		this.refIntervencion = refIntervencion;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idAplicacionPresupuestaria: ").append(this.idAplicacionPresupuestaria).append(" ]");
		result.append(", [ idConvocatoria: ").append(this.idConvocatoria).append(" ]");
		result.append(", [ ejercicio: ").append(this.ejercicio).append(" ]");
		result.append(", [ agrupacion: ").append(this.agrupacion).append(" ]");
		result.append(", [ gastoIngreso: ").append(this.gastoIngreso).append(" ]");
		result.append(", [ seccion: ").append(this.seccion).append(" ]");
		result.append(", [ servicio: ").append(this.servicio).append(" ]");
		result.append(", [ centro: ").append(this.centro).append(" ]");
		result.append(", [ cac: ").append(this.cac).append(" ]");
		result.append(", [ sc: ").append(this.sc).append(" ]");
		result.append(", [ programa: ").append(this.programa).append(" ]");
		result.append(", [ partida: ").append(this.partida).append(" ]");
		result.append(", [ letraControl: ").append(this.letraControl).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

}
