package com.ejie.ab60.model.convocatorias;

import com.ejie.ab60.comun.Constantes;
import com.ejie.ab60.model.actuacionesSubvencionables.ActSubvencionable;
import com.ejie.ab60.model.criteriosPuntuacion.CriteriosPuntuacion;

import com.ejie.ab60.model.pagos.PagosConvocatoria;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.springframework.context.i18n.LocaleContextHolder;

/**
 * Convocatorias  
 * 
 *  
 */

public class Convocatorias implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idConvocatoria;
	private TiposConvocatoria tiposConvocatoria;
	private Integer idProcedimiento;
	private String codProcedureId;
	private String descripcionEs;
	private String descripcionEu;
	private String convocatoria;
	private Date fechaResolucion;
	private BigDecimal importe;
	private BigDecimal importeDisponible;

	private BigDecimal porcentajeSubvencion;
	private BigDecimal cantMaxSubvencion;
	private String plsqlCalculo;
	private String plsqlReparto;
	private String plsqlAnularReparto;
	private String observaciones;
	// private BigDecimal importeMinimoInversion;
	private Date fechaOrdenDia;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private BigDecimal limiteLocal;
	private BigDecimal importeMinimoInversionSinReferencia;
	private List<PagosConvocatoria> pagosConvocatorias = new ArrayList<PagosConvocatoria>();
	private List<CriteriosPuntuacion> criteriosPuntuacions = new ArrayList<CriteriosPuntuacion>();
	private List<ActSubvencionable> actSubvencionables = new ArrayList<ActSubvencionable>();
	private Integer idTipoAyuda;

	private Long idTipoConvocatoria;

	private String fechaResolucionStr;
	private String fechaOrdenDiaStr;

	private Integer numPersonasConocimientos;
	private Integer numPersonasCurso;
	private Integer numBecas;
	private Integer numSuplentes;
	private Integer faseActiva;
	private String importesActSubActualizar;
	private String origenMaqueta;
	private boolean actualizarImportes;
	private String anyoConvocatoria;
	private String identificadores;
	private boolean exentoIva;

	/**
	 * Method 'Convocatorias'.
	 */
	public Convocatorias() {
	}

	/**
	 * Method 'Convocatorias'.
	 * 
	 * @param idConvocatoria
	 *            Integer
	 */
	public Convocatorias(Integer idConvocatoria) {
		this.idConvocatoria = idConvocatoria;
	}

	/**
	 * Method 'Convocatorias'.
	 * 
	 * @param idConvocatoria
	 *            Integer
	 * @param idProcedimiento
	 *            Integer
	 * @param convocatoria
	 *            String
	 * @param fechaResolucion
	 *            Date
	 * @param importe
	 *            BigDecimal
	 * @param porcentajeSubvencion
	 *            BigDecimal
	 * @param cantMaxSubvencion
	 *            BigDecimal
	 * @param plsqlCalculo
	 *            String
	 * @param plsqlReparto
	 *            String
	 * @param observaciones
	 *            String
	 * @param importeMinimoInversion
	 *            BigDecimal
	 * @param fechaOrdenDia
	 *            Date
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param limiteLocal
	 *            BigDecimal
	 * @param tiposConvocatoria
	 *            TiposConvocatoria
	 */
	public Convocatorias(Integer idConvocatoria, Integer idProcedimiento, String convocatoria, Date fechaResolucion,
			BigDecimal importe, BigDecimal porcentajeSubvencion, BigDecimal cantMaxSubvencion, String plsqlCalculo,
			String plsqlReparto, String observaciones, Date fechaOrdenDia, Date fechaRegistro, String usuarioRegistro,
			Date fechaUltmodificacion, String usuarioUltmodificacion, BigDecimal limiteLocal,
			TiposConvocatoria tiposConvocatoria) {
		this.idConvocatoria = idConvocatoria;
		this.tiposConvocatoria = tiposConvocatoria;
		this.idProcedimiento = idProcedimiento;
		this.convocatoria = convocatoria;
		this.fechaResolucion = fechaResolucion;
		this.importe = importe;
		this.porcentajeSubvencion = porcentajeSubvencion;
		this.cantMaxSubvencion = cantMaxSubvencion;
		this.plsqlCalculo = plsqlCalculo;
		this.plsqlReparto = plsqlReparto;
		this.observaciones = observaciones;
		// this.importeMinimoInversion = importeMinimoInversion;
		this.fechaOrdenDia = fechaOrdenDia;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.limiteLocal = limiteLocal;
	}

	/**
	 * Method 'Convocatorias'.
	 * 
	 * @param idConvocatoria
	 *            Integer
	 * @param idProcedimiento
	 *            Integer
	 * @param convocatoria
	 *            String
	 * @param fechaResolucion
	 *            Date
	 * @param importe
	 *            BigDecimal
	 * @param porcentajeSubvencion
	 *            BigDecimal
	 * @param cantMaxSubvencion
	 *            BigDecimal
	 * @param plsqlCalculo
	 *            String
	 * @param plsqlReparto
	 *            String
	 * @param observaciones
	 *            String
	 * @param importeMinimoInversion
	 *            BigDecimal
	 * @param fechaOrdenDia
	 *            Date
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param limiteLocal
	 *            BigDecimal
	 * @param tiposConvocatoria
	 *            TiposConvocatoria
	 * @param pagosConvocatorias
	 *            List<PagosConvocatoria>
	 * @param criteriosPuntuacions
	 *            List<CriteriosPuntuacion>
	 * @param actSubvencionables
	 *            List<ActSubvencionable>
	 */
	public Convocatorias(Integer idConvocatoria, Integer idProcedimiento, String convocatoria, Date fechaResolucion,
			BigDecimal importe, BigDecimal porcentajeSubvencion, BigDecimal cantMaxSubvencion, String plsqlCalculo,
			String plsqlReparto, String observaciones, Date fechaOrdenDia, Date fechaRegistro, String usuarioRegistro,
			Date fechaUltmodificacion, String usuarioUltmodificacion, BigDecimal limiteLocal,
			TiposConvocatoria tiposConvocatoria, List<PagosConvocatoria> pagosConvocatorias,
			List<CriteriosPuntuacion> criteriosPuntuacions, List<ActSubvencionable> actSubvencionables) {

		this.idConvocatoria = idConvocatoria;
		this.tiposConvocatoria = tiposConvocatoria;
		this.idProcedimiento = idProcedimiento;
		this.convocatoria = convocatoria;
		this.fechaResolucion = fechaResolucion;
		this.importe = importe;
		this.porcentajeSubvencion = porcentajeSubvencion;
		this.cantMaxSubvencion = cantMaxSubvencion;
		this.plsqlCalculo = plsqlCalculo;
		this.plsqlReparto = plsqlReparto;
		this.observaciones = observaciones;
		// this.importeMinimoInversion = importeMinimoInversion;
		this.fechaOrdenDia = fechaOrdenDia;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.limiteLocal = limiteLocal;
		this.pagosConvocatorias = pagosConvocatorias;
		this.criteriosPuntuacions = criteriosPuntuacions;
		this.actSubvencionables = actSubvencionables;
	}

	public Convocatorias(Integer idConvocatoria, Long idTipoConvocatoria, Integer idProcedimiento, String convocatoria,
			Date fechaResolucion, BigDecimal importe, BigDecimal porcentajeSubvencion, BigDecimal cantMaxSubvencion,
			String plsqlCalculo, String plsqlReparto, String observaciones, Date fechaOrdenDia, Date fechaRegistro,
			String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion, BigDecimal limiteLocal,
			Integer idTipoAyuda) {

		this.idConvocatoria = idConvocatoria;
		this.idTipoConvocatoria = idTipoConvocatoria;
		this.idProcedimiento = idProcedimiento;
		this.convocatoria = convocatoria;
		this.fechaResolucion = fechaResolucion;
		this.importe = importe;
		this.porcentajeSubvencion = porcentajeSubvencion;
		this.cantMaxSubvencion = cantMaxSubvencion;
		this.plsqlCalculo = plsqlCalculo;
		this.plsqlReparto = plsqlReparto;
		this.observaciones = observaciones;
		this.fechaOrdenDia = fechaOrdenDia;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.limiteLocal = limiteLocal;
		this.idTipoAyuda = idTipoAyuda;
	}

	public Convocatorias(Integer idConvocatoria, Long idTipoConvocatoria, Integer idProcedimiento, String convocatoria,
			Date fechaResolucion, BigDecimal importe, BigDecimal porcentajeSubvencion, BigDecimal cantMaxSubvencion,
			String plsqlCalculo, String plsqlReparto, String observaciones, Date fechaOrdenDia, Date fechaRegistro,
			String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion, BigDecimal limiteLocal,
			Integer idTipoAyuda, String descripcionEs, String descripcionEu) {

		this.idConvocatoria = idConvocatoria;
		this.idTipoConvocatoria = idTipoConvocatoria;
		this.idProcedimiento = idProcedimiento;
		this.convocatoria = convocatoria;
		this.fechaResolucion = fechaResolucion;
		this.importe = importe;
		this.porcentajeSubvencion = porcentajeSubvencion;
		this.cantMaxSubvencion = cantMaxSubvencion;
		this.plsqlCalculo = plsqlCalculo;
		this.plsqlReparto = plsqlReparto;
		this.observaciones = observaciones;
		this.fechaOrdenDia = fechaOrdenDia;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.limiteLocal = limiteLocal;
		this.idTipoAyuda = idTipoAyuda;
		this.descripcionEs = descripcionEs;
		this.descripcionEu = descripcionEu;
	}

	public Convocatorias(Integer idConvocatoria, Long idTipoConvocatoria, Integer idProcedimiento,
			String codProcedureId, String descripcionEs, String descripcionEu, String convocatoria,
			Date fechaResolucion, BigDecimal importe, BigDecimal importeDisponible, BigDecimal porcentajeSubvencion,
			BigDecimal cantMaxSubvencion, String plsqlCalculo, String plsqlReparto, String observaciones,
			Date fechaOrdenDia, Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion,
			String usuarioUltmodificacion, BigDecimal limiteLocal, Integer idTipoAyuda, Integer faseActiva,
			Integer numPersonasConocimientos, Integer numPersonasCurso, Integer numBecas, Integer numSuplentes,
			String origenMaqutea, boolean exentoIva) {

		this.idConvocatoria = idConvocatoria;
		this.idTipoConvocatoria = idTipoConvocatoria;
		this.idProcedimiento = idProcedimiento;
		this.codProcedureId = codProcedureId;
		this.descripcionEs = descripcionEs;
		this.descripcionEu = descripcionEu;
		this.convocatoria = convocatoria;
		this.fechaResolucion = fechaResolucion;
		this.importe = importe;
		this.importeDisponible = importeDisponible;
		this.porcentajeSubvencion = porcentajeSubvencion;
		this.cantMaxSubvencion = cantMaxSubvencion;
		this.plsqlCalculo = plsqlCalculo;
		this.plsqlReparto = plsqlReparto;
		this.observaciones = observaciones;
		this.fechaOrdenDia = fechaOrdenDia;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.limiteLocal = limiteLocal;
		this.idTipoAyuda = idTipoAyuda;
		this.faseActiva = faseActiva;
		this.numPersonasConocimientos = numPersonasConocimientos;
		this.numPersonasCurso = numPersonasCurso;
		this.numBecas = numBecas;
		this.numSuplentes = numSuplentes;
		this.origenMaqueta = origenMaqutea;
		this.exentoIva = exentoIva;
	}

	public Convocatorias(long idTipoConvocatoria, TiposConvocatoria tiposConvocatoria) {
		this.idTipoConvocatoria = idTipoConvocatoria;
		this.tiposConvocatoria = tiposConvocatoria;
	}

	/**
	 * Method 'Convocatorias'.
	 * 
	 * @param idConvocatoria
	 *            Integer
	 * @param plsqlReparto
	 *            String
	 */
	public Convocatorias(long idTipoConvocatoria, String plsqlCalculo) {
		this.idTipoConvocatoria = idTipoConvocatoria;
		this.plsqlCalculo = plsqlCalculo;
	}

	/**
	 * Method 'Convocatorias'.
	 * 
	 * @param idConvocatoria
	 *            Integer
	 * @param idProcedimiento
	 *            Integer
	 * @param plsqlReparto
	 *            String
	 */
	public Convocatorias(Integer idConvocatoria, Integer idProcedimiento, String plsqlReparto) {
		this.idConvocatoria = idConvocatoria;
		this.idProcedimiento = idProcedimiento;
		this.plsqlReparto = plsqlReparto;
	}

	/**
	 * Method 'Convocatorias'.
	 * 
	 * @param idConvocatoria
	 *            Integer
	 * @param idProcedimiento
	 *            Integer
	 * @param plsqlAnularReparto
	 *            String
	 */
	public Convocatorias(String plsqlAnularReparto) {
		this.plsqlAnularReparto = plsqlAnularReparto;
	}

	/**
	 * Method 'getIdConvocatoria'.
	 *
	 * @return Integer
	 */

	public Integer getIdConvocatoria() {
		return this.idConvocatoria;
	}

	/**
	 * Method 'setIdConvocatoria'.
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @return
	 */

	public void setIdConvocatoria(Integer idConvocatoria) {
		this.idConvocatoria = idConvocatoria;
	}

	/**
	 * Method 'getTiposConvocatoria'.
	 *
	 * @return TiposConvocatoria
	 */
	@JsonIgnore

	public TiposConvocatoria getTiposConvocatoria() {
		return this.tiposConvocatoria;
	}

	/**
	 * Method 'setTiposConvocatoria'.
	 *
	 * @param tiposConvocatoria
	 *            TiposConvocatoria
	 * @return
	 */

	public void setTiposConvocatoria(TiposConvocatoria tiposConvocatoria) {
		this.tiposConvocatoria = tiposConvocatoria;
	}

	/**
	 * Method 'getIdProcedimiento'.
	 *
	 * @return Integer
	 */

	public Integer getIdProcedimiento() {
		return this.idProcedimiento;
	}

	/**
	 * Method 'setIdProcedimiento'.
	 *
	 * @param idProcedimiento
	 *            Integer
	 * @return
	 */

	public void setIdProcedimiento(Integer idProcedimiento) {
		this.idProcedimiento = idProcedimiento;
	}

	/**
	 * Method 'getConvocatoria'.
	 *
	 * @return String
	 */

	public String getConvocatoria() {
		return this.convocatoria;
	}

	/**
	 * Method 'setConvocatoria'.
	 *
	 * @param convocatoria
	 *            String
	 * @return
	 */

	public void setConvocatoria(String convocatoria) {
		this.convocatoria = convocatoria;
	}

	/**
	 * Method 'getFechaResolucion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaResolucion() {
		return this.fechaResolucion;
	}

	/**
	 * Method 'setFechaResolucion'.
	 *
	 * @param fechaResolucion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaResolucion(Date fechaResolucion) {
		this.fechaResolucion = fechaResolucion;
	}

	/**
	 * Method 'getImporte'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporte() {
		return this.importe;
	}

	/**
	 * Method 'getImporteMask'.
	 *
	 * @return BigDecimal
	 */

	public String getImporteMask() {
		return UtilDate.formatearMiles(importe);
	}

	/**
	 * Method 'getImporteDisponibleMask'.
	 *
	 * @return BigDecimal
	 */

	public String getImporteDisponibleMask() {
		return UtilDate.formatearMiles(importeDisponible);
	}

	/**
	 * Method 'setImporte'.
	 *
	 * @param importe
	 *            BigDecimal
	 * @return
	 */

	public void setImporte(BigDecimal importe) {
		this.importe = importe;
	}

	/**
	 * Method 'getPorcenajeSubvencion'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getPorcentajeSubvencion() {
		return this.porcentajeSubvencion;
	}

	/**
	 * Method 'getPorcentajeSubvencionMask'.
	 *
	 * @return BigDecimal
	 */

	public String getPorcentajeSubvencionMask() {
		return UtilDate.formatearMiles(porcentajeSubvencion);
	}

	/**
	 * Method 'setPorcenajeSubvencion'.
	 *
	 * @param porcentajeSubvencion
	 *            BigDecimal
	 * @return
	 */

	public void setPorcentajeSubvencion(BigDecimal porcentajeSubvencion) {
		this.porcentajeSubvencion = porcentajeSubvencion;
	}

	/**
	 * Method 'getCantMaxSubvencion'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getCantMaxSubvencion() {
		return this.cantMaxSubvencion;
	}

	/**
	 * Method 'getCantMaxSubvencionMask'.
	 *
	 * @return BigDecimal
	 */

	public String getCantMaxSubvencionMask() {
		return UtilDate.formatearMiles(cantMaxSubvencion);
	}

	/**
	 * Method 'setCantMaxSubvencion'.
	 *
	 * @param cantMaxSubvencion
	 *            BigDecimal
	 * @return
	 */

	public void setCantMaxSubvencion(BigDecimal cantMaxSubvencion) {
		this.cantMaxSubvencion = cantMaxSubvencion;
	}

	/**
	 * Method 'getPlsqlCalculo'.
	 *
	 * @return String
	 */

	public String getPlsqlCalculo() {
		return this.plsqlCalculo;
	}

	/**
	 * Method 'setPlsqlCalculo'.
	 *
	 * @param plsqlCalculo
	 *            String
	 * @return
	 */

	public void setPlsqlCalculo(String plsqlCalculo) {
		this.plsqlCalculo = plsqlCalculo;
	}

	/**
	 * Method 'getPlsqlReparto'.
	 *
	 * @return String
	 */

	public String getPlsqlReparto() {
		return this.plsqlReparto;
	}

	/**
	 * Method 'setPlsqlReparto'.
	 *
	 * @param plsqlReparto
	 *            String
	 * @return
	 */

	public void setPlsqlReparto(String plsqlReparto) {
		this.plsqlReparto = plsqlReparto;
	}

	/**
	 * Method 'getObservaciones'.
	 *
	 * @return String
	 */

	public String getObservaciones() {
		return this.observaciones;
	}

	/**
	 * Method 'setObservaciones'.
	 *
	 * @param observaciones
	 *            String
	 * @return
	 */

	public void setObservaciones(String observaciones) {
		this.observaciones = observaciones;
	}

	/**
	 * Method 'getImporteMinimoInversion'.
	 *
	 * @return BigDecimal
	 */

	/*
	 * public BigDecimal getImporteMinimoInversion() { return
	 * this.importeMinimoInversion; }
	 */

	/**
	 * Method 'setImporteMinimoInversion'.
	 *
	 * @param importeMinimoInversion
	 *            BigDecimal
	 * @return
	 */

	/*
	 * public void setImporteMinimoInversion(BigDecimal importeMinimoInversion)
	 * { this.importeMinimoInversion = importeMinimoInversion; }
	 */

	/**
	 * Method 'getFechaOrdenDia'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaOrdenDia() {
		return this.fechaOrdenDia;
	}

	/**
	 * Method 'setFechaOrdenDia'.
	 *
	 * @param fechaOrdenDia
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaOrdenDia(Date fechaOrdenDia) {
		this.fechaOrdenDia = fechaOrdenDia;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getLimiteLocal'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getLimiteLocal() {
		return this.limiteLocal;
	}

	/**
	 * Method 'setLimiteLocal'.
	 *
	 * @param limiteLocal
	 *            BigDecimal
	 * @return
	 */

	public void setLimiteLocal(BigDecimal limiteLocal) {
		this.limiteLocal = limiteLocal;
	}

	/**
	 * @return the importeMinimoInversionSinReferencia
	 */
	public BigDecimal getImporteMinimoInversionSinReferencia() {
		return importeMinimoInversionSinReferencia;
	}

	/**
	 * @param importeMinimoInversionSinReferencia
	 *            the importeMinimoInversionSinReferencia to set
	 */
	public void setImporteMinimoInversionSinReferencia(BigDecimal importeMinimoInversionSinReferencia) {
		this.importeMinimoInversionSinReferencia = importeMinimoInversionSinReferencia;
	}

	/**
	 * Method 'getPagosConvocatorias'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<PagosConvocatoria> getPagosConvocatorias() {
		return this.pagosConvocatorias;
	}

	/**
	 * Method 'setPagosConvocatorias'.
	 *
	 * @param pagosConvocatorias
	 *            List
	 * @return
	 */
	public void setPagosConvocatorias(List<PagosConvocatoria> pagosConvocatorias) {
		this.pagosConvocatorias = pagosConvocatorias;
	}

	/**
	 * Method 'getCriteriosPuntuacions'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<CriteriosPuntuacion> getCriteriosPuntuacions() {
		return this.criteriosPuntuacions;
	}

	/**
	 * Method 'setCriteriosPuntuacions'.
	 *
	 * @param criteriosPuntuacions
	 *            List
	 * @return
	 */
	public void setCriteriosPuntuacions(List<CriteriosPuntuacion> criteriosPuntuacions) {
		this.criteriosPuntuacions = criteriosPuntuacions;
	}

	/**
	 * Method 'getActSubvencionables'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<ActSubvencionable> getActSubvencionables() {
		return this.actSubvencionables;
	}

	/**
	 * Method 'setActSubvencionables'.
	 *
	 * @param actSubvencionables
	 *            List
	 * @return
	 */
	public void setActSubvencionables(List<ActSubvencionable> actSubvencionables) {
		this.actSubvencionables = actSubvencionables;
	}

	/**
	 * @return the idTipoAyuda
	 */
	public Integer getIdTipoAyuda() {
		return idTipoAyuda;
	}

	/**
	 * @param idTipoAyuda
	 *            the idTipoAyuda to set
	 */
	public void setIdTipoAyuda(Integer idTipoAyuda) {
		this.idTipoAyuda = idTipoAyuda;
	}

	/**
	 * Method 'getIdTipoConvocatoria'.
	 *
	 * @return Long
	 */

	public Long getIdTipoConvocatoria() {
		return this.idTipoConvocatoria;
	}

	/**
	 * Method 'setIdTipoConvocatoria'.
	 *
	 * @param idTipoConvocatoria
	 *            Long
	 * @return
	 */

	public void setIdTipoConvocatoria(Long idTipoConvocatoria) {
		this.idTipoConvocatoria = idTipoConvocatoria;
	}

	/**
	 * @return the importeDisponible
	 */
	public BigDecimal getImporteDisponible() {
		return importeDisponible;
	}

	public void setImporteDisponible(BigDecimal importeDisponible) {
		this.importeDisponible = importeDisponible;
	}

	/**
	 * @return the fechaResolucionStr
	 */
	public String getFechaResolucionStr() {
		return fechaResolucionStr;
	}

	/**
	 * @param fechaResolucionStr
	 *            the fechaResolucionStr to set
	 */
	public void setFechaResolucionStr(String fechaResolucionStr) {
		this.fechaResolucionStr = fechaResolucionStr;
	}

	/**
	 * @return the numPersonasConocimientos
	 */
	public Integer getNumPersonasConocimientos() {
		return numPersonasConocimientos;
	}

	/**
	 * @param numPersonasConocimientos
	 *            the numPersonasConocimientos to set
	 */
	public void setNumPersonasConocimientos(Integer numPersonasConocimientos) {
		this.numPersonasConocimientos = numPersonasConocimientos;
	}

	/**
	 * @return the numPersonasCurso
	 */
	public Integer getNumPersonasCurso() {
		return numPersonasCurso;
	}

	/**
	 * @param numPersonasCurso
	 *            the numPersonasCurso to set
	 */
	public void setNumPersonasCurso(Integer numPersonasCurso) {
		this.numPersonasCurso = numPersonasCurso;
	}

	/**
	 * @return the numBecas
	 */
	public Integer getNumBecas() {
		return numBecas;
	}

	/**
	 * @param numBecas
	 *            the numBecas to set
	 */
	public void setNumBecas(Integer numBecas) {
		this.numBecas = numBecas;
	}

	/**
	 * @return the numSuplentes
	 */
	public Integer getNumSuplentes() {
		return numSuplentes;
	}

	/**
	 * @param numSuplentes
	 *            the numSuplentes to set
	 */
	public void setNumSuplentes(Integer numSuplentes) {
		this.numSuplentes = numSuplentes;
	}

	/**
	 * @return the faseActiva
	 */
	public Integer getFaseActiva() {
		return faseActiva;
	}

	/**
	 * @param faseActiva
	 *            the faseActiva to set
	 */
	public void setFaseActiva(Integer faseActiva) {
		this.faseActiva = faseActiva;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "Convocatorias [idConvocatoria=" + idConvocatoria + ", tiposConvocatoria=" + tiposConvocatoria
				+ ", idProcedimiento=" + idProcedimiento + ", convocatoria=" + convocatoria + ", fechaResolucion="
				+ fechaResolucion + ", importe=" + importe + ", importeDisponible=" + importeDisponible
				+ ", porcentajeSubvencion=" + porcentajeSubvencion + ", cantMaxSubvencion=" + cantMaxSubvencion
				+ ", plsqlCalculo=" + plsqlCalculo + ", plsqlReparto=" + plsqlReparto + ", observaciones="
				+ observaciones + ", fechaOrdenDia=" + fechaOrdenDia + ", fechaRegistro=" + fechaRegistro
				+ ", usuarioRegistro=" + usuarioRegistro + ", fechaUltmodificacion=" + fechaUltmodificacion
				+ ", usuarioUltmodificacion=" + usuarioUltmodificacion + ", limiteLocal=" + limiteLocal
				+ ", importeMinimoInversionSinReferencia=" + importeMinimoInversionSinReferencia
				+ ", pagosConvocatorias=" + pagosConvocatorias + ", criteriosPuntuacions=" + criteriosPuntuacions
				+ ", actSubvencionables=" + actSubvencionables + ", idTipoAyuda=" + idTipoAyuda
				+ ", idTipoConvocatoria=" + idTipoConvocatoria + ", fechaResolucionStr=" + fechaResolucionStr
				+ ", numPersonasConocimientos=" + numPersonasConocimientos + ", numPersonasCurso=" + numPersonasCurso
				+ ", numBecas=" + numBecas + ", numSuplentes=" + numSuplentes + ", faseActiva=" + faseActiva + "]";
	}

	public String getImportesActSubActualizar() {
		return importesActSubActualizar;
	}

	public void setImportesActSubActualizar(String importesActSubActualizar) {
		this.importesActSubActualizar = importesActSubActualizar;
	}

	public String getDescripcionEs() {
		return descripcionEs;
	}

	public void setDescripcionEs(String descripcionEs) {
		this.descripcionEs = descripcionEs;
	}

	public String getDescripcionEu() {
		return descripcionEu;
	}

	public void setDescripcionEu(String descripcionEu) {
		this.descripcionEu = descripcionEu;
	}

	public String getDescripcionPorIdioma() {
		String idioma = LocaleContextHolder.getLocale().getLanguage();
		if (Constantes.CASTELLANO.equalsIgnoreCase(idioma)) {
			return this.descripcionEs;
		} else {
			return this.descripcionEu;
		}
	}

	/**
	 * @return the plsqlAnularReparto
	 */
	public String getPlsqlAnularReparto() {
		return plsqlAnularReparto;
	}

	/**
	 * @param plsqlAnularReparto
	 *            the plsqlAnularReparto to set
	 */
	public void setPlsqlAnularReparto(String plsqlAnularReparto) {
		this.plsqlAnularReparto = plsqlAnularReparto;
	}

	public String getCodProcedureId() {
		return codProcedureId;
	}

	public void setCodProcedureId(String codProcedureId) {
		this.codProcedureId = codProcedureId;
	}

	/**
	 * @return the origenMaqueta
	 */
	public String getOrigenMaqueta() {
		return origenMaqueta;
	}

	/**
	 * @param origenMaqueta
	 *            the origenMaqueta to set
	 */
	public void setOrigenMaqueta(String origenMaqueta) {
		this.origenMaqueta = origenMaqueta;
	}

	/**
	 * @return the actualizarImportes
	 */
	public boolean getActualizarImportes() {
		return actualizarImportes;
	}

	/**
	 * @param actualizarImportes
	 *            the actualizarImportes to set
	 */
	public void setActualizarImportes(boolean actualizarImportes) {
		this.actualizarImportes = actualizarImportes;
	}

	/**
	 * @return the anyoConvocatoria
	 */
	public String getAnyoConvocatoria() {
		return anyoConvocatoria;
	}

	/**
	 * @param anyoConvocatoria
	 *            the anyoConvocatoria to set
	 */
	public void setAnyoConvocatoria(String anyoConvocatoria) {
		this.anyoConvocatoria = anyoConvocatoria;
	}

	/**
	 * @return the identificadores
	 */
	public String getIdentificadores() {
		return idTipoAyuda + "#" + idConvocatoria;
	}

	/**
	 * @param identificadores
	 *            the identificadores to set
	 */
	public void setIdentificadores(String identificadores) {
		this.identificadores = identificadores;
	}

	/**
	 * @return the fechaOrdenDiaStr
	 */
	public String getFechaOrdenDiaStr() {
		return fechaOrdenDiaStr;
	}

	/**
	 * @param fechaOrdenDiaStr
	 *            the fechaOrdenDiaStr to set
	 */
	public void setFechaOrdenDiaStr(String fechaOrdenDiaStr) {
		this.fechaOrdenDiaStr = fechaOrdenDiaStr;
	}

	public boolean isExentoIva() {
		return exentoIva;
	}

	public void setExentoIva(boolean exentoIva) {
		this.exentoIva = exentoIva;
	}

}
