package com.ejie.ab60.model.convocatorias;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import java.math.BigDecimal;
import java.util.Date;

/**
 * DatosContables  
 * 
 *  
 */

public class DatosContables implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idDatoContable;
	private Integer idConvocatoria;
	private String institucion;
	private String ejercicio;
	private String seccion;
	private String usuarioIkus;
	private Integer idIdioma;
	private String conceptoResumido;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private BigDecimal importe;
	private BigDecimal importeDisponible;

	/**
	 * Method 'DatosContables'.
	 */
	public DatosContables() {
	}

	/**
	 * Method 'DatosContables'.
	 * 
	 * @param idDatoContable
	 *            Integer
	 */
	public DatosContables(Integer idDatoContable) {
		this.idDatoContable = idDatoContable;
	}

	/**
	 * Method 'DatosContables'.
	 * 
	 * @param idDatoContable
	 *            Integer
	 * @param idProcedimiento
	 *            Integer
	 * @param institucion
	 *            Integer
	 * @param ejercicio
	 *            Long
	 * @param seccion
	 *            Long
	 * @param usuarioIkus
	 *            String
	 * @param idioma
	 *            Integer
	 * @param conceptoResumido
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 */
	public DatosContables(Integer idDatoContable, Integer idConvocatoria, String institucion, String ejercicio,
			String seccion, String usuarioIkus, Integer idIdioma, String conceptoResumido, Date fechaRegistro,
			String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion, BigDecimal importe,
			BigDecimal importeDisponible) {

		this.idDatoContable = idDatoContable;
		this.idConvocatoria = idConvocatoria;
		this.institucion = institucion;
		this.ejercicio = ejercicio;
		this.seccion = seccion;
		this.usuarioIkus = usuarioIkus;
		this.idIdioma = idIdioma;
		this.conceptoResumido = conceptoResumido;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.importe = importe;
		this.importeDisponible = importeDisponible;
	}

	/**
	 * Method 'getIdDatoContable'.
	 *
	 * @return Integer
	 */

	public Integer getIdDatoContable() {
		return this.idDatoContable;
	}

	/**
	 * Method 'setIdDatoContable'.
	 *
	 * @param idDatoContable
	 *            Integer
	 * @return
	 */

	public void setIdDatoContable(Integer idDatoContable) {
		this.idDatoContable = idDatoContable;
	}

	/**
	 * Method 'getIdProcedimiento'.
	 *
	 * @return Integer
	 */

	public Integer getIdConvocatoria() {
		return this.idConvocatoria;
	}

	/**
	 * Method 'setIdProcedimiento'.
	 *
	 * @param idProcedimiento
	 *            Integer
	 * @return
	 */

	public void setIdConvocatoria(Integer idConvocatoria) {
		this.idConvocatoria = idConvocatoria;
	}

	/**
	 * Method 'getInstitucion'.
	 *
	 * @return Integer
	 */

	public String getInstitucion() {
		return this.institucion;
	}

	/**
	 * Method 'setInstitucion'.
	 *
	 * @param institucion
	 *            Integer
	 * @return
	 */

	public void setInstitucion(String institucion) {
		this.institucion = institucion;
	}

	/**
	 * Method 'getEjercicio'.
	 *
	 * @return Long
	 */

	public String getEjercicio() {
		return this.ejercicio;
	}

	/**
	 * Method 'setEjercicio'.
	 *
	 * @param ejercicio
	 *            Long
	 * @return
	 */

	public void setEjercicio(String ejercicio) {
		this.ejercicio = ejercicio;
	}

	/**
	 * Method 'getSeccion'.
	 *
	 * @return Long
	 */

	public String getSeccion() {
		return this.seccion;
	}

	/**
	 * Method 'setSeccion'.
	 *
	 * @param seccion
	 *            Long
	 * @return
	 */

	public void setSeccion(String seccion) {
		this.seccion = seccion;
	}

	/**
	 * Method 'getUsuarioIkus'.
	 *
	 * @return String
	 */

	public String getUsuarioIkus() {
		return this.usuarioIkus;
	}

	/**
	 * Method 'setUsuarioIkus'.
	 *
	 * @param usuarioIkus
	 *            String
	 * @return
	 */

	public void setUsuarioIkus(String usuarioIkus) {
		this.usuarioIkus = usuarioIkus;
	}

	/**
	 * Method 'getIdioma'.
	 *
	 * @return Integer
	 */

	public Integer getIdIdioma() {
		return this.idIdioma;
	}

	/**
	 * Method 'setIdioma'.
	 *
	 * @param idioma
	 *            Integer
	 * @return
	 */

	public void setIdIdioma(Integer idIdioma) {
		this.idIdioma = idIdioma;
	}

	/**
	 * Method 'getConceptoResumido'.
	 *
	 * @return String
	 */

	public String getConceptoResumido() {
		return this.conceptoResumido;
	}

	/**
	 * Method 'setConceptoResumido'.
	 *
	 * @param conceptoResumido
	 *            String
	 * @return
	 */

	public void setConceptoResumido(String conceptoResumido) {
		this.conceptoResumido = conceptoResumido;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * @return the importe
	 */
	public BigDecimal getImporte() {
		return importe;
	}

	/**
	 * @param importe
	 *            the importe to set
	 */
	public void setImporte(BigDecimal importe) {
		this.importe = importe;
	}

	/**
	 * @return the importeDisponible
	 */
	public BigDecimal getImporteDisponible() {
		return importeDisponible;
	}

	/**
	 * @param importeDisponible
	 *            the importeDisponible to set
	 */
	public void setImporteDisponible(BigDecimal importeDisponible) {
		this.importeDisponible = importeDisponible;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idDatoContable: ").append(this.idDatoContable).append(" ]");
		result.append(", [ idProcedimiento: ").append(this.idConvocatoria).append(" ]");
		result.append(", [ institucion: ").append(this.institucion).append(" ]");
		result.append(", [ ejercicio: ").append(this.ejercicio).append(" ]");
		result.append(", [ seccion: ").append(this.seccion).append(" ]");
		result.append(", [ usuarioIkus: ").append(this.usuarioIkus).append(" ]");
		result.append(", [ idioma: ").append(this.idIdioma).append(" ]");
		result.append(", [ conceptoResumido: ").append(this.conceptoResumido).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

}