package com.ejie.ab60.model.convocatorias;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.Date;

/**
 * ReferenciasIntervencion  
 * 
 *  
 */

public class ReferenciasIntervencion implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idReferenciaIntervencion;
	private Integer idAplicacionPresupuestaria;
	private String ejercicio;
	private String anyoOrigen;
	private String numero;
	private String disponible;
	private String obligacion;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;

	/**
	 * Method 'ReferenciasIntervencion'.
	 */
	public ReferenciasIntervencion() {
	}

	/**
	 * Method 'ReferenciasIntervencion'.
	 * 
	 * @param idReferenciaIntervencion
	 *            Integer
	 */
	public ReferenciasIntervencion(Integer idReferenciaIntervencion) {
		this.idReferenciaIntervencion = idReferenciaIntervencion;
	}

	/**
	 * Method 'ReferenciasIntervencion'.
	 * 
	 * @param idReferenciaIntervencion
	 *            Integer
	 * @param idProcedimiento
	 *            Integer
	 * @param ejercicio
	 *            Long
	 * @param anyoOrigen
	 *            Long
	 * @param numero
	 *            Integer
	 * @param disponible
	 *            Integer
	 * @param obligacion
	 *            Long
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 */
	public ReferenciasIntervencion(Integer idReferenciaIntervencion, Integer idAplicacionPresupuestaria,
			String ejercicio, String anyoOrigen, String numero, String disponible, String obligacion,
			Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion) {

		this.idReferenciaIntervencion = idReferenciaIntervencion;
		this.idAplicacionPresupuestaria = idAplicacionPresupuestaria;
		this.ejercicio = ejercicio;
		this.anyoOrigen = anyoOrigen;
		this.numero = numero;
		this.disponible = disponible;
		this.obligacion = obligacion;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getIdReferenciaIntervencion'.
	 *
	 * @return Integer
	 */

	public Integer getIdReferenciaIntervencion() {
		return this.idReferenciaIntervencion;
	}

	/**
	 * Method 'setIdReferenciaIntervencion'.
	 *
	 * @param idReferenciaIntervencion
	 *            Integer
	 * @return
	 */

	public void setIdReferenciaIntervencion(Integer idReferenciaIntervencion) {
		this.idReferenciaIntervencion = idReferenciaIntervencion;
	}

	/**
	 * Method 'getIdProcedimiento'.
	 *
	 * @return Integer
	 */

	public Integer getIdAplicacionPresupuestaria() {
		return this.idAplicacionPresupuestaria;
	}

	/**
	 * Method 'setIdProcedimiento'.
	 *
	 * @param idProcedimiento
	 *            Integer
	 * @return
	 */

	public void setIdAplicacionPresupuestaria(Integer idAplicacionPresupuestaria) {
		this.idAplicacionPresupuestaria = idAplicacionPresupuestaria;
	}

	/**
	 * Method 'getEjercicio'.
	 *
	 * @return Long
	 */

	public String getEjercicio() {
		return this.ejercicio;
	}

	/**
	 * Method 'setEjercicio'.
	 *
	 * @param ejercicio
	 *            Long
	 * @return
	 */

	public void setEjercicio(String ejercicio) {
		this.ejercicio = ejercicio;
	}

	/**
	 * Method 'getAnyoOrigen'.
	 *
	 * @return Long
	 */

	public String getAnyoOrigen() {
		return this.anyoOrigen;
	}

	/**
	 * Method 'setAnyoOrigen'.
	 *
	 * @param anyoOrigen
	 *            Long
	 * @return
	 */

	public void setAnyoOrigen(String anyoOrigen) {
		this.anyoOrigen = anyoOrigen;
	}

	/**
	 * Method 'getNumero'.
	 *
	 * @return Integer
	 */

	public String getNumero() {
		return this.numero;
	}

	/**
	 * Method 'setNumero'.
	 *
	 * @param numero
	 *            Integer
	 * @return
	 */

	public void setNumero(String numero) {
		this.numero = numero;
	}

	/**
	 * Method 'getDisponible'.
	 *
	 * @return Integer
	 */

	public String getDisponible() {
		return this.disponible;
	}

	/**
	 * Method 'setDisponible'.
	 *
	 * @param disponible
	 *            Integer
	 * @return
	 */

	public void setDisponible(String disponible) {
		this.disponible = disponible;
	}

	/**
	 * Method 'getObligacion'.
	 *
	 * @return Long
	 */

	public String getObligacion() {
		return this.obligacion;
	}

	/**
	 * Method 'setObligacion'.
	 *
	 * @param obligacion
	 *            Long
	 * @return
	 */

	public void setObligacion(String obligacion) {
		this.obligacion = obligacion;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idReferenciaIntervencion: ").append(this.idReferenciaIntervencion).append(" ]");
		result.append(", [ idAplicacionPresupuestaria: ").append(this.idAplicacionPresupuestaria).append(" ]");
		result.append(", [ ejercicio: ").append(this.ejercicio).append(" ]");
		result.append(", [ anyoOrigen: ").append(this.anyoOrigen).append(" ]");
		result.append(", [ numero: ").append(this.numero).append(" ]");
		result.append(", [ disponible: ").append(this.disponible).append(" ]");
		result.append(", [ obligacion: ").append(this.obligacion).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

}
