package com.ejie.ab60.model.convocatorias;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * TiposConvocatoria  
 * 
 *  
 */

public class TiposConvocatoria implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idTipoConvocatoria;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<Convocatorias> convocatoriases = new ArrayList<Convocatorias>();

	/**
	 * Method 'TiposConvocatoria'.
	 */
	public TiposConvocatoria() {
	}

	/**
	 * Method 'TiposConvocatoria'.
	 * 
	 * @param idTipoConvocatoria
	 *            Long
	 */
	public TiposConvocatoria(Long idTipoConvocatoria) {
		this.idTipoConvocatoria = idTipoConvocatoria;
	}

	/**
	 * Method 'TiposConvocatoria'.
	 * 
	 * @param idTipoConvocatoria
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public TiposConvocatoria(Long idTipoConvocatoria, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro) {
		this.idTipoConvocatoria = idTipoConvocatoria;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'TiposConvocatoria'.
	 * 
	 * @param idTipoConvocatoria
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param convocatoriases
	 *            List<Convocatorias>
	 */
	public TiposConvocatoria(Long idTipoConvocatoria, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro, List<Convocatorias> convocatoriases) {

		this.idTipoConvocatoria = idTipoConvocatoria;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.convocatoriases = convocatoriases;
	}

	/**
	 * Method 'getIdTipoConvocatoria'.
	 *
	 * @return Long
	 */

	public Long getIdTipoConvocatoria() {
		return this.idTipoConvocatoria;
	}

	/**
	 * Method 'setIdTipoConvocatoria'.
	 *
	 * @param idTipoConvocatoria
	 *            Long
	 * @return
	 */

	public void setIdTipoConvocatoria(Long idTipoConvocatoria) {
		this.idTipoConvocatoria = idTipoConvocatoria;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getConvocatoriases'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<Convocatorias> getConvocatoriases() {
		return this.convocatoriases;
	}

	/**
	 * Method 'setConvocatoriases'.
	 *
	 * @param convocatoriases
	 *            List
	 * @return
	 */
	public void setConvocatoriases(List<Convocatorias> convocatoriases) {
		this.convocatoriases = convocatoriases;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idTipoConvocatoria: ").append(this.idTipoConvocatoria).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
