package com.ejie.ab60.model.criteriosPuntuacion;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * CriteriosPuntuacion  
 * 
 *  
 */

public class CriteriosPuntuacion implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idCriterio;
	private TiposCriterio tiposCriterio;
	private Convocatorias convocatorias;
	private String criPunCastellano;
	private String criPunEuskera;
	private BigDecimal valorMinimo;
	private BigDecimal valorMaximo;
	private BigDecimal incrementoPorcentaje;
	private String observaciones;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private List<RelExpCriPun> relExpCriPuns = new ArrayList<RelExpCriPun>();

	/**
	 * Method 'CriteriosPuntuacion'.
	 */
	public CriteriosPuntuacion() {
	}

	/**
	 * Method 'CriteriosPuntuacion'.
	 * 
	 * @param idCriterio
	 *            Integer
	 */
	public CriteriosPuntuacion(Integer idCriterio) {
		this.idCriterio = idCriterio;
	}

	/**
	 * Method 'CriteriosPuntuacion'.
	 * 
	 * @param idCriterio
	 *            Integer
	 * @param criPunCastellano
	 *            String
	 * @param criPunEuskera
	 *            String
	 * @param valorMinimo
	 *            BigDecimal
	 * @param valorMaximo
	 *            BigDecimal
	 * @param incrementoPorcenaje
	 *            BigDecimal
	 * @param observaciones
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param tiposCriterio
	 *            TiposCriterio
	 * @param convocatorias
	 *            Convocatorias
	 */
	public CriteriosPuntuacion(Integer idCriterio, String criPunCastellano, String criPunEuskera,
			BigDecimal valorMinimo, BigDecimal valorMaximo, BigDecimal incrementoPorcenaje, String observaciones,
			Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion,
			TiposCriterio tiposCriterio, Convocatorias convocatorias) {
		this.idCriterio = idCriterio;
		this.tiposCriterio = tiposCriterio;
		this.convocatorias = convocatorias;
		this.criPunCastellano = criPunCastellano;
		this.criPunEuskera = criPunEuskera;
		this.valorMinimo = valorMinimo;
		this.valorMaximo = valorMaximo;
		this.incrementoPorcentaje = incrementoPorcentaje;
		this.observaciones = observaciones;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'CriteriosPuntuacion'.
	 * 
	 * @param idCriterio
	 *            Integer
	 * @param criPunCastellano
	 *            String
	 * @param criPunEuskera
	 *            String
	 *
	 * @param tiposCriterio
	 *            TiposCriterio
	 * @param convocatorias
	 *            Convocatorias
	 */
	public CriteriosPuntuacion(Integer idCriterio, String criPunCastellano, String criPunEuskera,
			BigDecimal valorMinimo, BigDecimal valorMaximo, TiposCriterio tiposCriterio, Convocatorias convocatorias) {
		this.idCriterio = idCriterio;
		this.criPunCastellano = criPunCastellano;
		this.criPunEuskera = criPunEuskera;
		this.tiposCriterio = tiposCriterio;
		this.convocatorias = convocatorias;
		this.valorMinimo = valorMinimo;
		this.valorMaximo = valorMaximo;

	}

	/**
	 * Method 'CriteriosPuntuacion'.
	 * 
	 * @param idCriterio
	 *            Integer
	 * @param criPunCastellano
	 *            String
	 * @param criPunEuskera
	 *            String
	 * @param valorMinimo
	 *            BigDecimal
	 * @param valorMaximo
	 *            BigDecimal
	 */
	public CriteriosPuntuacion(Integer idCriterio, String criPunCastellano, String criPunEuskera,
			BigDecimal valorMinimo, BigDecimal valorMaximo) {
		this.idCriterio = idCriterio;
		this.criPunCastellano = criPunCastellano;
		this.criPunEuskera = criPunEuskera;
		this.valorMinimo = valorMinimo;
		this.valorMaximo = valorMaximo;

	}

	/**
	 * Method 'CriteriosPuntuacion'.
	 * 
	 * @param idCriterio
	 *            Integer
	 * @param criPunCastellano
	 *            String
	 * @param criPunEuskera
	 *            String
	 * @param valorMinimo
	 *            BigDecimal
	 * @param valorMaximo
	 *            BigDecimal
	 * @param convocatorias
	 *            Convocatorias
	 */
	public CriteriosPuntuacion(Integer idCriterio, String criPunCastellano, String criPunEuskera,
			BigDecimal valorMinimo, BigDecimal valorMaximo, Convocatorias convocatorias) {
		this.idCriterio = idCriterio;
		this.criPunCastellano = criPunCastellano;
		this.criPunEuskera = criPunEuskera;
		this.valorMinimo = valorMinimo;
		this.valorMaximo = valorMaximo;
		this.convocatorias = convocatorias;

	}

	/**
	 * Method 'CriteriosPuntuacion'.
	 * 
	 * @param idCriterio
	 *            Integer
	 * @param criPunCastellano
	 *            String
	 * @param criPunEuskera
	 *            String
	 *
	 * @param tiposCriterio
	 *            TiposCriterio
	 * @param convocatorias
	 *            Convocatorias
	 */
	public CriteriosPuntuacion(Integer idCriterio, String criPunCastellano, String criPunEuskera,
			TiposCriterio tiposCriterio, Convocatorias convocatorias) {
		this.idCriterio = idCriterio;
		this.tiposCriterio = tiposCriterio;
		this.convocatorias = convocatorias;
		this.criPunCastellano = criPunCastellano;
		this.criPunEuskera = criPunEuskera;

	}

	/**
	 * Method 'CriteriosPuntuacion'.
	 * 
	 * @param criPunCastellano
	 *            String
	 * @param criPunEuskera
	 *            String
	 */
	public CriteriosPuntuacion(Integer idCriterio, String criPunCastellano, String criPunEuskera) {
		this.idCriterio = idCriterio;
		this.criPunCastellano = criPunCastellano;
		this.criPunEuskera = criPunEuskera;

	}

	/**
	 * Method 'CriteriosPuntuacion'.
	 * 
	 * @param idCriterio
	 *            Integer
	 * @param criPunCastellano
	 *            String
	 * @param criPunEuskera
	 *            String
	 * @param valorMinimo
	 *            BigDecimal
	 * @param valorMaximo
	 *            BigDecimal
	 * @param incrementoPorcenaje
	 *            BigDecimal
	 * @param observaciones
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param tiposCriterio
	 *            TiposCriterio
	 * @param convocatorias
	 *            Convocatorias
	 * @param relExpCriPuns
	 *            List<RelExpCriPun>
	 */
	public CriteriosPuntuacion(Integer idCriterio, String criPunCastellano, String criPunEuskera,
			BigDecimal valorMinimo, BigDecimal valorMaximo, BigDecimal incrementoPorcenaje, String observaciones,
			Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion,
			TiposCriterio tiposCriterio, Convocatorias convocatorias, List<RelExpCriPun> relExpCriPuns) {

		this.idCriterio = idCriterio;
		this.tiposCriterio = tiposCriterio;
		this.convocatorias = convocatorias;
		this.criPunCastellano = criPunCastellano;
		this.criPunEuskera = criPunEuskera;
		this.valorMinimo = valorMinimo;
		this.valorMaximo = valorMaximo;
		this.incrementoPorcentaje = incrementoPorcentaje;
		this.observaciones = observaciones;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.relExpCriPuns = relExpCriPuns;
	}

	/**
	 * Method 'getIdCriterio'.
	 *
	 * @return Integer
	 */

	public Integer getIdCriterio() {
		return this.idCriterio;
	}

	/**
	 * Method 'setIdCriterio'.
	 *
	 * @param idCriterio
	 *            Integer
	 * @return
	 */

	public void setIdCriterio(Integer idCriterio) {
		this.idCriterio = idCriterio;
	}

	/**
	 * Method 'getTiposCriterio'.
	 *
	 * @return TiposCriterio
	 */
	@JsonIgnore

	public TiposCriterio getTiposCriterio() {
		return this.tiposCriterio;
	}

	/**
	 * Method 'setTiposCriterio'.
	 *
	 * @param tiposCriterio
	 *            TiposCriterio
	 * @return
	 */

	public void setTiposCriterio(TiposCriterio tiposCriterio) {
		this.tiposCriterio = tiposCriterio;
	}

	/**
	 * Method 'getConvocatorias'.
	 *
	 * @return Convocatorias
	 */
	@JsonIgnore

	public Convocatorias getConvocatorias() {
		return this.convocatorias;
	}

	/**
	 * Method 'setConvocatorias'.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @return
	 */

	public void setConvocatorias(Convocatorias convocatorias) {
		this.convocatorias = convocatorias;
	}

	/**
	 * Method 'getCriPunCastellano'.
	 *
	 * @return String
	 */

	public String getCriPunCastellano() {
		return this.criPunCastellano;
	}

	/**
	 * Method 'setCriPunCastellano'.
	 *
	 * @param criPunCastellano
	 *            String
	 * @return
	 */

	public void setCriPunCastellano(String criPunCastellano) {
		this.criPunCastellano = criPunCastellano;
	}

	/**
	 * Method 'getCriPunEuskera'.
	 *
	 * @return String
	 */

	public String getCriPunEuskera() {
		return this.criPunEuskera;
	}

	/**
	 * Method 'setCriPunEuskera'.
	 *
	 * @param criPunEuskera
	 *            String
	 * @return
	 */

	public void setCriPunEuskera(String criPunEuskera) {
		this.criPunEuskera = criPunEuskera;
	}

	/**
	 * Method 'getValorMinimo'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getValorMinimo() {
		return this.valorMinimo;
	}

	/**
	 * Method 'setValorMinimo'.
	 *
	 * @param valorMinimo
	 *            BigDecimal
	 * @return
	 */

	public void setValorMinimo(BigDecimal valorMinimo) {
		this.valorMinimo = valorMinimo;
	}

	/**
	 * Method 'getValorMaximo'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getValorMaximo() {
		return this.valorMaximo;
	}

	/**
	 * Method 'setValorMaximo'.
	 *
	 * @param valorMaximo
	 *            BigDecimal
	 * @return
	 */

	public void setValorMaximo(BigDecimal valorMaximo) {
		this.valorMaximo = valorMaximo;
	}

	/**
	 * Method 'getIncrementoPorcentaje'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getIncrementoPorcentaje() {
		return this.incrementoPorcentaje;
	}

	/**
	 * Method 'setIncrementoPorcentaje'.
	 *
	 * @param incrementoPorcentaje
	 *            BigDecimal
	 * @return
	 */

	public void setIncrementoPorcenaje(BigDecimal incrementoPorcentaje) {
		this.incrementoPorcentaje = incrementoPorcentaje;
	}

	/**
	 * Method 'getObservaciones'.
	 *
	 * @return String
	 */

	public String getObservaciones() {
		return this.observaciones;
	}

	/**
	 * Method 'setObservaciones'.
	 *
	 * @param observaciones
	 *            String
	 * @return
	 */

	public void setObservaciones(String observaciones) {
		this.observaciones = observaciones;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getRelExpCriPuns'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<RelExpCriPun> getRelExpCriPuns() {
		return this.relExpCriPuns;
	}

	/**
	 * Method 'setRelExpCriPuns'.
	 *
	 * @param relExpCriPuns
	 *            List
	 * @return
	 */
	public void setRelExpCriPuns(List<RelExpCriPun> relExpCriPuns) {
		this.relExpCriPuns = relExpCriPuns;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idCriterio: ").append(this.idCriterio).append(" ]");
		result.append(", [ criPunCastellano: ").append(this.criPunCastellano).append(" ]");
		result.append(", [ criPunEuskera: ").append(this.criPunEuskera).append(" ]");
		result.append(", [ valorMinimo: ").append(this.valorMinimo).append(" ]");
		result.append(", [ valorMaximo: ").append(this.valorMaximo).append(" ]");
		result.append(", [ incrementoPorcenaje: ").append(this.incrementoPorcentaje).append(" ]");
		result.append(", [ observaciones: ").append(this.observaciones).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

}
