package com.ejie.ab60.model.criteriosPuntuacion;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * TiposCriterio  
 * 
 *  
 */

public class TiposCriterio implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idTipoCriterio;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<CriteriosPuntuacion> criteriosPuntuacions = new ArrayList<CriteriosPuntuacion>();

	/**
	 * Method 'TiposCriterio'.
	 */
	public TiposCriterio() {
	}

	/**
	 * Method 'TiposCriterio'.
	 * 
	 * @param idTipoCriterio
	 *            Long
	 */
	public TiposCriterio(Long idTipoCriterio) {
		this.idTipoCriterio = idTipoCriterio;
	}

	/**
	 * Method 'TiposCriterio'.
	 * 
	 * @param idTipoCriterio
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public TiposCriterio(Long idTipoCriterio, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro) {
		this.idTipoCriterio = idTipoCriterio;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'TiposCriterio'.
	 * 
	 * @param idTipoCriterio
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param criteriosPuntuacions
	 *            List<CriteriosPuntuacion>
	 */
	public TiposCriterio(Long idTipoCriterio, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro, List<CriteriosPuntuacion> criteriosPuntuacions) {

		this.idTipoCriterio = idTipoCriterio;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.criteriosPuntuacions = criteriosPuntuacions;
	}

	/**
	 * Method 'getIdTipoCriterio'.
	 *
	 * @return Long
	 */

	public Long getIdTipoCriterio() {
		return this.idTipoCriterio;
	}

	/**
	 * Method 'setIdTipoCriterio'.
	 *
	 * @param idTipoCriterio
	 *            Long
	 * @return
	 */

	public void setIdTipoCriterio(Long idTipoCriterio) {
		this.idTipoCriterio = idTipoCriterio;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getCriteriosPuntuacions'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<CriteriosPuntuacion> getCriteriosPuntuacions() {
		return this.criteriosPuntuacions;
	}

	/**
	 * Method 'setCriteriosPuntuacions'.
	 *
	 * @param criteriosPuntuacions
	 *            List
	 * @return
	 */
	public void setCriteriosPuntuacions(List<CriteriosPuntuacion> criteriosPuntuacions) {
		this.criteriosPuntuacions = criteriosPuntuacions;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idTipoCriterio: ").append(this.idTipoCriterio).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
