package com.ejie.ab60.model.estudioTecnico;

import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.math.BigDecimal;
import java.util.Date;

/**
 * Conceptos  
 * 
 *  
 */

public class Conceptos implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idConcepto;
	private Integer idRelExpActSub;
	private Integer idExpediente;
	private Integer idActSub;
	private RelExpActSub relExpActSub;
	private Long idTipoGasto;
	private TiposGasto tiposGasto;
	private String concepto;
	private BigDecimal importePresentado;
	private BigDecimal importeAdmitido;
	private BigDecimal ayudaSubvencionada;
	private BigDecimal importeConcedido;
	private BigDecimal importeSinIva;
	private BigDecimal importeIva;
	private BigDecimal importeJusPresentado;
	private BigDecimal importeJusAdmitido;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private Integer inspeccionable;
	private String observacionesCastellano;
	private String observacionesEuskera;
	private Integer enviadoInspeccionar;

	/**
	 * Method 'Conceptos'.
	 */
	public Conceptos() {
	}

	/**
	 * Method 'Conceptos'.
	 * 
	 * @param idConcepto
	 *            Integer
	 */
	public Conceptos(Integer idConcepto) {
		this.idConcepto = idConcepto;
	}

	/**
	 * Method 'Conceptos'.
	 * 
	 * @param idConcepto
	 *            Integer
	 * @param idRelExpActSub
	 *            Integer
	 * @param idTipoGasto
	 *            Long
	 * @param concepto
	 *            String
	 * @param importePresentado
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param importeJusPresentado
	 *            BigDecimal
	 * @param importeJusAdmitido
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param inspeccionable
	 *            Integer
	 * @param observacionesCastellano
	 *            String
	 * @param observacionesEuskera
	 *            String
	 */
	public Conceptos(Integer idConcepto, Integer idRelExpActSub, Long idTipoGasto, String concepto,
			BigDecimal importePresentado, BigDecimal importeAdmitido, BigDecimal importeJusPresentado,
			BigDecimal importeJusAdmitido, Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion,
			String usuarioUltmodificacion, Integer inspeccionable, String observacionesCastellano,
			String observacionesEuskera) {

		this.idConcepto = idConcepto;
		this.idRelExpActSub = idRelExpActSub;
		this.idTipoGasto = idTipoGasto;
		this.concepto = concepto;
		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.importeJusPresentado = importeJusPresentado;
		this.importeJusAdmitido = importeJusAdmitido;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.inspeccionable = inspeccionable;
		this.observacionesCastellano = observacionesCastellano;
		this.observacionesEuskera = observacionesEuskera;
	}

	/**
	 * Method 'Conceptos'.
	 * 
	 * @param idConcepto
	 *            Integer
	 * @param idTipoGasto
	 *            Long
	 * @param concepto
	 *            String
	 * @param importePresentado
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param importeJusPresentado
	 *            BigDecimal
	 * @param importeJusAdmitido
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param inspeccionable
	 *            Integer
	 * @param observacionesCastellano
	 *            String
	 * @param observacionesEuskera
	 *            String
	 * @param relExpActSub
	 *            RelExpActSub
	 */
	public Conceptos(Integer idConcepto, Long idTipoGasto, String concepto, BigDecimal importePresentado,
			BigDecimal importeAdmitido, BigDecimal importeJusPresentado, BigDecimal importeJusAdmitido,
			Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion,
			Integer inspeccionable, String observacionesCastellano, String observacionesEuskera,
			RelExpActSub relExpActSub) {

		this.idConcepto = idConcepto;
		this.idTipoGasto = idTipoGasto;
		this.concepto = concepto;
		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.importeJusPresentado = importeJusPresentado;
		this.importeJusAdmitido = importeJusAdmitido;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.inspeccionable = inspeccionable;
		this.observacionesCastellano = observacionesCastellano;
		this.observacionesEuskera = observacionesEuskera;
		this.relExpActSub = relExpActSub;
	}

	/**
	 * Method 'Conceptos'.
	 * 
	 * @param idConcepto
	 *            Integer
	 * @param idRelExpActSub
	 *            Integer
	 * @param tiposGasto
	 *            TiposGasto
	 * @param concepto
	 *            String
	 * @param importePresentado
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 */
	public Conceptos(Integer idConcepto, Integer idRelExpActSub, TiposGasto tiposGasto, String concepto,
			BigDecimal importePresentado, BigDecimal importeAdmitido) {

		this.idConcepto = idConcepto;
		this.idRelExpActSub = idRelExpActSub;
		this.tiposGasto = tiposGasto;
		this.concepto = concepto;
		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;

	}

	/**
	 * Method 'Conceptos'.
	 * 
	 * @param importePresentado
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param relExpActSub
	 *            RelExpActSub
	 */
	public Conceptos(BigDecimal importePresentado, BigDecimal importeAdmitido, RelExpActSub relExpActSub) {

		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.relExpActSub = relExpActSub;

	}

	public Conceptos(BigDecimal importePresentado, BigDecimal importeAdmitido, BigDecimal importeSinIva,
			RelExpActSub relExpActSub) {

		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.importeSinIva = importeSinIva;
		this.relExpActSub = relExpActSub;

	}

	/**
	 * Method 'Conceptos'.
	 * 
	 * @param idConcepto
	 *            Integer
	 * @param idTipoGasto
	 *            Integer
	 * @param concepto
	 *            String
	 * @param importePresentado
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param relExpActSub
	 *            RelExpActSub
	 */
	public Conceptos(Integer idConcepto, Long idTipoGasto, String concepto, BigDecimal importePresentado,
			BigDecimal importeAdmitido, Integer idRelExpActSub) {
		this.idConcepto = idConcepto;
		this.idTipoGasto = idTipoGasto;
		this.concepto = concepto;
		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.idRelExpActSub = idRelExpActSub;

	}

	/**
	 * Method 'Conceptos'.
	 * 
	 * @param importeAdmitido
	 *            BigDecimal
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 */
	public Conceptos(BigDecimal importeAdmitido, RelExpActSub relExpActSub) {

		this.relExpActSub = relExpActSub;
		this.importeAdmitido = importeAdmitido;

	}

	/**
	 * Method 'Conceptos'.
	 * 
	 * @param importePresentado
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 *
	 */
	public Conceptos(BigDecimal importePresentado, BigDecimal importeAdmitido) {

		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;

	}

	public Conceptos(int enviadoInspeccionar, int inspeccionable, String concepto, BigDecimal importePresentado,
			String observacionesCastellano, String observacionesEuskera) {
		this.enviadoInspeccionar = enviadoInspeccionar;
		this.inspeccionable = inspeccionable;
		this.concepto = concepto;
		this.importePresentado = importePresentado;
		this.observacionesCastellano = observacionesCastellano;
		this.observacionesEuskera = observacionesEuskera;
	}

	/**
	 * Method 'getIdConcepto'.
	 *
	 * @return Integer
	 */

	public Integer getIdConcepto() {
		return this.idConcepto;
	}

	/**
	 * Method 'setIdConcepto'.
	 *
	 * @param idConcepto
	 *            Integer
	 * @return
	 */

	public void setIdConcepto(Integer idConcepto) {
		this.idConcepto = idConcepto;
	}

	/**
	 * Method 'getIdRelExpActSub'.
	 *
	 * @return Integer
	 */

	public Integer getIdRelExpActSub() {
		return this.idRelExpActSub;
	}

	/**
	 * Method 'setIdRelExpActSub'.
	 *
	 * @param idRelExpActSub
	 *            Integer
	 * @return
	 */

	public void setIdRelExpActSub(Integer idRelExpActSub) {
		this.idRelExpActSub = idRelExpActSub;
	}

	/**
	 * @return the idExpediente
	 */
	public Integer getIdExpediente() {
		return idExpediente;
	}

	/**
	 * @param idExpediente
	 *            the idExpediente to set
	 */
	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * @return the idActSub
	 */
	public Integer getIdActSub() {
		return idActSub;
	}

	/**
	 * @param idActSub
	 *            the idActSub to set
	 */
	public void setIdActSub(Integer idActSub) {
		this.idActSub = idActSub;
	}

	/**
	 * Method 'getRelExpActSub'.
	 *
	 * @return RelExpActSub
	 */
	public RelExpActSub getRelExpActSub() {
		return relExpActSub;
	}

	/**
	 * Method 'setRelExpActSub'.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return
	 */
	public void setRelExpActSub(RelExpActSub relExpActSub) {
		this.relExpActSub = relExpActSub;
	}

	/**
	 * Method 'getIdTipoGasto'.
	 *
	 * @return Long
	 */

	public Long getIdTipoGasto() {
		return this.idTipoGasto;
	}

	/**
	 * Method 'setIdTipoGasto'.
	 *
	 * @param idTipoGasto
	 *            Long
	 * @return
	 */

	public void setIdTipoGasto(Long idTipoGasto) {
		this.idTipoGasto = idTipoGasto;
	}

	/**
	 * Method 'getTiposGasto'.
	 *
	 * @return TiposGasto
	 */
	public TiposGasto getTiposGasto() {
		return tiposGasto;
	}

	/**
	 * Method 'setTiposGasto'.
	 *
	 * @param tiposGasto
	 *            TiposGasto
	 * @return
	 */
	public void setTiposGasto(TiposGasto tiposGasto) {
		this.tiposGasto = tiposGasto;
	}

	/**
	 * Method 'getConcepto'.
	 *
	 * @return String
	 */

	public String getConcepto() {
		return this.concepto;
	}

	/**
	 * Method 'setConcepto'.
	 *
	 * @param concepto
	 *            String
	 * @return
	 */

	public void setConcepto(String concepto) {
		this.concepto = concepto;
	}

	/**
	 * Method 'getImportePresentado'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImportePresentado() {
		return this.importePresentado;
	}

	/**
	 * Method 'getImporteMask'.
	 *
	 * @return BigDecimal
	 */

	public String getimportePresentadoMask() {

		return UtilDate.formatearMiles(importePresentado);

	}

	/**
	 * Method 'setImportePresentado'.
	 *
	 * @param importePresentado
	 *            BigDecimal
	 * @return
	 */

	public void setImportePresentado(BigDecimal importePresentado) {
		this.importePresentado = importePresentado;
	}

	/**
	 * Method 'getImporteAdmitido'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporteAdmitido() {
		return this.importeAdmitido;
	}

	/**
	 * Method 'getImporteMask'.
	 *
	 * @return BigDecimal
	 */

	public String getimporteAdmitidoMask() {

		return UtilDate.formatearMiles(importeAdmitido);

	}

	/**
	 * Method 'setImporteAdmitido'.
	 *
	 * @param importeAdmitido
	 *            BigDecimal
	 * @return
	 */

	public void setImporteAdmitido(BigDecimal importeAdmitido) {
		this.importeAdmitido = importeAdmitido;
	}

	/**
	 * Method 'getImporteJusPresentado'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporteJusPresentado() {
		return this.importeJusPresentado;
	}

	/**
	 * Method 'setImporteJusPresentado'.
	 *
	 * @param importeJusPresentado
	 *            BigDecimal
	 * @return
	 */

	public void setImporteJusPresentado(BigDecimal importeJusPresentado) {
		this.importeJusPresentado = importeJusPresentado;
	}

	/**
	 * Method 'getImporteJusAdmitido'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporteJusAdmitido() {
		return this.importeJusAdmitido;
	}

	/**
	 * Method 'setImporteJusAdmitido'.
	 *
	 * @param importeJusAdmitido
	 *            BigDecimal
	 * @return
	 */

	public void setImporteJusAdmitido(BigDecimal importeJusAdmitido) {
		this.importeJusAdmitido = importeJusAdmitido;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getInspeccionable'.
	 *
	 * @return Integer
	 */

	public Integer getInspeccionable() {
		return this.inspeccionable;
	}

	/**
	 * Method 'setInspeccionable'.
	 *
	 * @param inspeccionable
	 *            Integer
	 * @return
	 */

	public void setInspeccionable(Integer inspeccionable) {
		this.inspeccionable = inspeccionable;
	}

	/**
	 * Method 'getObservacionesCastellano'.
	 *
	 * @return String
	 */

	public String getObservacionesCastellano() {
		return this.observacionesCastellano;
	}

	/**
	 * Method 'setObservacionesCastellano'.
	 *
	 * @param observacionesCastellano
	 *            String
	 * @return
	 */

	public void setObservacionesCastellano(String observacionesCastellano) {
		this.observacionesCastellano = observacionesCastellano;
	}

	/**
	 * Method 'getObservacionesEuskera'.
	 *
	 * @return String
	 */

	public String getObservacionesEuskera() {
		return this.observacionesEuskera;
	}

	/**
	 * Method 'setObservacionesEuskera'.
	 *
	 * @param observacionesEuskera
	 *            String
	 * @return
	 */

	public void setObservacionesEuskera(String observacionesEuskera) {
		this.observacionesEuskera = observacionesEuskera;
	}

	/**
	 * @return the enviadoInspeccionar
	 */
	public Integer getEnviadoInspeccionar() {
		return enviadoInspeccionar;
	}

	/**
	 * @param enviadoInspeccionar
	 *            the enviadoInspeccionar to set
	 */
	public void setEnviadoInspeccionar(Integer enviadoInspeccionar) {
		this.enviadoInspeccionar = enviadoInspeccionar;
	}

	/**
	 * Method 'getImporteMask'.
	 *
	 * @return BigDecimal
	 */

	public String getImporteSinIvaMask() {

		return UtilDate.formatearMiles(importeSinIva);

	}

	/**
	 * @return the importeSinIva
	 */
	public BigDecimal getImporteSinIva() {
		return importeSinIva;
	}

	/**
	 * @param importeSinIva
	 *            the importeSinIva to set
	 */
	public void setImporteSinIva(BigDecimal importeSinIva) {
		this.importeSinIva = importeSinIva;
	}

	/**
	 * Method 'getImporteMask'.
	 *
	 * @return BigDecimal
	 */

	public String getImporteIvaMask() {

		return UtilDate.formatearMiles(importeIva);

	}

	/**
	 * @return the importeIva
	 */
	public BigDecimal getImporteIva() {
		return importeIva;
	}

	/**
	 * @param importeIva
	 *            the importeIva to set
	 */
	public void setImporteIva(BigDecimal importeIva) {
		this.importeIva = importeIva;
	}

	/**
	 * @return the ayudaSubvencionada
	 */
	public BigDecimal getAyudaSubvencionada() {
		return ayudaSubvencionada;
	}

	/**
	 * @param ayudaSubvencionada
	 *            the ayudaSubvencionada to set
	 */
	public void setAyudaSubvencionada(BigDecimal ayudaSubvencionada) {
		this.ayudaSubvencionada = ayudaSubvencionada;
	}

	/**
	 * @return the importeConcedido
	 */
	public BigDecimal getImporteConcedido() {
		return importeConcedido;
	}

	/**
	 * @param importeConcedido
	 *            the importeConcedido to set
	 */
	public void setImporteConcedido(BigDecimal importeConcedido) {
		this.importeConcedido = importeConcedido;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idConcepto: ").append(this.idConcepto).append(" ]");
		result.append(", [ idRelExpActSub: ").append(this.idRelExpActSub).append(" ]");
		result.append(", [ idTipoGasto: ").append(this.idTipoGasto).append(" ]");
		result.append(", [ concepto: ").append(this.concepto).append(" ]");
		result.append(", [ importePresentado: ").append(this.importePresentado).append(" ]");
		result.append(", [ importeAdmitido: ").append(this.importeAdmitido).append(" ]");
		result.append(", [ importeJusPresentado: ").append(this.importeJusPresentado).append(" ]");
		result.append(", [ importeJusAdmitido: ").append(this.importeJusAdmitido).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append(", [ inspeccionable: ").append(this.inspeccionable).append(" ]");
		result.append(", [ observacionesCastellano: ").append(this.observacionesCastellano).append(" ]");
		result.append(", [ observacionesEuskera: ").append(this.observacionesEuskera).append(" ]");
		result.append("}");
		return result.toString();
	}

}
