package com.ejie.ab60.model.estudioTecnico;

import com.ejie.ab60.model.actuacionesSubvencionables.ActSubvencionable;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.Date;

/**
 * ErroresCalculo  
 * 
 *  
 */

public class ErroresCalculo implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idCodigoerror;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Integer tipoError;
	private ActSubvencionable actSubvencionable;

	/**
	 * Method 'ErroresCalculo'.
	 */
	public ErroresCalculo() {
	}

	/**
	 * Method 'ErroresCalculo'.
	 * 
	 * @param idCodigoerror
	 *            Integer
	 */
	public ErroresCalculo(Integer idCodigoerror) {
		this.idCodigoerror = idCodigoerror;
	}

	/**
	 * Method 'ErroresCalculo'.
	 * 
	 * @param idCodigoerror
	 *            Integer
	 * @param idConvocatoria
	 *            Integer
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param tipoError
	 *            Integer
	 */
	public ErroresCalculo(Integer idCodigoerror, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro, Integer tipoError, ActSubvencionable actSubvencionable) {

		this.idCodigoerror = idCodigoerror;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.tipoError = tipoError;
		this.actSubvencionable = actSubvencionable;
	}

	/**
	 * Method 'getIdCodigoerror'.
	 *
	 * @return Integer
	 */

	public Integer getIdCodigoerror() {
		return this.idCodigoerror;
	}

	/**
	 * Method 'setIdCodigoerror'.
	 *
	 * @param idCodigoerror
	 *            Integer
	 * @return
	 */

	public void setIdCodigoerror(Integer idCodigoerror) {
		this.idCodigoerror = idCodigoerror;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * @return the actSubvencionable
	 */
	public ActSubvencionable getActSubvencionable() {
		return actSubvencionable;
	}

	/**
	 * @param actSubvencionable
	 *            the actSubvencionable to set
	 */
	public void setActSubvencionable(ActSubvencionable actSubvencionable) {
		this.actSubvencionable = actSubvencionable;
	}

	/**
	 * Method 'getTipoError'.
	 *
	 * @return Integer
	 */

	public Integer getTipoError() {
		return this.tipoError;
	}

	/**
	 * Method 'setTipoError'.
	 *
	 * @param tipoError
	 *            Integer
	 * @return
	 */

	public void setTipoError(Integer tipoError) {
		this.tipoError = tipoError;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idCodigoerror: ").append(this.idCodigoerror).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ tipoError: ").append(this.tipoError).append(" ]");
		result.append(", [ actSubvencionable: ").append(this.actSubvencionable).append(" ]");
		result.append("}");
		return result.toString();
	}

}
