package com.ejie.ab60.model.estudioTecnico;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.Arrays;
import java.util.Date;

import com.ejie.ab60.model.RelExpIns;
import com.ejie.ab60.model.CTP.Proyectos;
import com.ejie.ab60.model.actuacionesSubvencionables.ActSubvencionable;

import com.ejie.ab60.model.criteriosPuntuacion.CriteriosPuntuacion;
import com.ejie.ab60.model.estudioTecnico.MotivosDesestimacion;
import com.ejie.ab60.model.estudioTecnico.TecnicosResponsables;
import com.ejie.ab60.model.estudioTecnico.TiposResultado;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * DatosProyecto  
 * 
 *  
 */

public class EstudioTecnico implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idProyectoExpediente;
	private Integer expedienteValidado;

	private Integer idRelacion;
	private Integer idResultado;
	private Integer idMotivoDesestimacion;
	private Integer idTecnicoResponsable;
	private Integer idConvocatoria;

	private MotivosDesestimacion motivosDesestimacion;
	private TecnicosResponsables tecnicosResponsables;
	private TiposResultado tiposResultado;
	private Integer idExpediente;
	private BigDecimal importePresentado;
	private BigDecimal importeAdmitido;
	private BigDecimal subvencionCalculada;
	private BigDecimal subvencionJustificada;
	private BigDecimal importeRecurso;
	private BigDecimal subvencionResuelta;

	private BigDecimal importeFinal;
	private BigDecimal importeFinalConvocatoria;
	private Date fechaInforme;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private String observacionesCastellano;
	private String observacionesEuskera;

	private String fechaInformeStr;

	private BigDecimal importeDisponible;

	private BigDecimal importePresentadoDesde;
	private BigDecimal importePresentadoHasta;
	private BigDecimal importeAdmitidoDesde;
	private BigDecimal importeAdmitidoHasta;
	private BigDecimal subvencionResueltaDesde;
	private BigDecimal subvencionResueltaHasta;

	private BigDecimal importeSinIva;

	private Integer[] criterios;
	private Integer bandera;

	private Proyectos proyectos;
	private ActSubvencionable actSubvencionable;
	private CriteriosPuntuacion criteriosPuntuacion;

	private Integer tipoImporte;

	private DatosTerOmic datosTerOmic;
	private RelExpIns relExpIns;

	private Integer exeptoHidden;

	private Integer cargarSolSub;

	/**
	 * Method 'EstudioTecnico'.
	 */
	public EstudioTecnico() {
	}

	/**
	 * Method 'EstudioTecnico'.
	 * 
	 * @param idProyectoExpediente
	 *            Integer
	 */
	public EstudioTecnico(Integer idProyectoExpediente) {
		this.idProyectoExpediente = idProyectoExpediente;
	}

	/**
	 * @param idRelacion
	 * @param idMotivoDesestimacion
	 * @param idTecnicoResponsable
	 * @param fechaInforme
	 * @param subvencionCalculada
	 *            BigDecimal
	 */
	public EstudioTecnico(Integer idResultado, Integer idMotivoDesestimacion, Integer idTecnicoResponsable,
			Date fechaInforme, BigDecimal subvencionCalculada) {

		this.idResultado = idResultado;
		this.idMotivoDesestimacion = idMotivoDesestimacion;
		this.idTecnicoResponsable = idTecnicoResponsable;
		this.fechaInforme = fechaInforme;
		this.subvencionCalculada = subvencionCalculada;
	}

	/**
	 * @param importePresentado
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param subvencionCalculada
	 *            BigDecimal
	 * @param subvencionResuelta
	 *            BigDecimal
	 */
	public EstudioTecnico(BigDecimal importePresentado, BigDecimal importeAdmitido, BigDecimal subvencionCalculada,
			BigDecimal subvencionResuelta) {

		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.subvencionCalculada = subvencionCalculada;
		this.subvencionResuelta = subvencionResuelta;
	}

	/**
	 * * @param importeDisponible BigDecimal
	 * 
	 * @param importeFinal
	 *            BigDecimal
	 * @param subvencionCalculada
	 *            BigDecimal
	 * 
	 */
	public EstudioTecnico(BigDecimal importeFinal, BigDecimal importeDisponible, BigDecimal subvencionCalculada) {

		this.importeFinal = importeFinal;
		this.importeDisponible = importeDisponible;
		this.subvencionCalculada = subvencionCalculada;
	}

	/**
	 * * @param importeDisponible BigDecimal
	 * 
	 */
	public EstudioTecnico(BigDecimal importeFinal) {

		this.importeFinal = importeFinal;

	}

	/**
	 * @param idExpediente
	 *            Integer
	 * @param expedienteValidado
	 *            Integer
	 * @param subvencionResuelta
	 *            BigDecimal
	 * 
	 */
	public EstudioTecnico(Integer idExpediente, Integer expedienteValidado, BigDecimal subvencionResuelta) {
		this.idExpediente = idExpediente;
		this.expedienteValidado = expedienteValidado;
		this.subvencionResuelta = subvencionResuelta;
	}

	/**
	 * Method 'DatosProyecto'.
	 * 
	 * @param idProyectoExpediente
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param expedienteValidado
	 *            Integer
	 * @param importePresentado
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param subvencionCalculada
	 *            BigDecimal
	 * @param subvencionJustificada
	 *            BigDecimal
	 * @param importeRecurso
	 *            BigDecimal
	 * @param subvencionResuelta
	 *            BigDecimal
	 * 
	 * @param observacionesCastellano
	 *            String
	 * 
	 * @param observacionesEuskera
	 *            String
	 * @param fechaInforme
	 *            Date
	 * @param fechaRegistro
	 *            Date
	 *
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @param tecnicosResponsables
	 *            TecnicosResponsables
	 * @param tiposResultado
	 *            TiposResultado
	 * 
	 * 
	 */

	public EstudioTecnico(Integer idProyectoExpediente, Integer idExpediente, Integer expedienteValidado,
			BigDecimal importePresentado, BigDecimal importeAdmitido, BigDecimal subvencionCalculada,
			BigDecimal subvencionJustificada, BigDecimal importeRecurso, BigDecimal subvencionResuelta,
			String observacionesCastellano, String observacionesEuskera, Date fechaInforme,
			BigDecimal importeDisponible, Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion,
			String usuarioUltmodificacion, MotivosDesestimacion motivosDesestimacion,
			TecnicosResponsables tecnicosResponsables, TiposResultado tiposResultado,
			ActSubvencionable actSubvencionable, Proyectos proyectos, CriteriosPuntuacion criteriosPuntuacion) {

		this.idProyectoExpediente = idProyectoExpediente;
		this.idExpediente = idExpediente;
		this.expedienteValidado = expedienteValidado;
		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.subvencionCalculada = subvencionCalculada;
		this.subvencionJustificada = subvencionJustificada;
		this.importeRecurso = importeRecurso;
		this.subvencionResuelta = subvencionResuelta;
		this.observacionesCastellano = observacionesCastellano;
		this.observacionesEuskera = observacionesEuskera;
		this.fechaInforme = fechaInforme;
		this.importeDisponible = importeDisponible;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.motivosDesestimacion = motivosDesestimacion;
		this.tecnicosResponsables = tecnicosResponsables;
		this.tiposResultado = tiposResultado;
		this.actSubvencionable = actSubvencionable;
		this.proyectos = proyectos;
		this.criteriosPuntuacion = criteriosPuntuacion;

	}

	/**
	 * Method 'DatosProyecto'.
	 * 
	 * @param idProyectoExpediente
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param expedienteValidado
	 *            Integer
	 * @param importePresentado
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param subvencionCalculada
	 *            BigDecimal
	 * @param subvencionJustificada
	 *            BigDecimal
	 * @param importeRecurso
	 *            BigDecimal
	 * @param subvencionResuelta
	 *            BigDecimal
	 * 
	 * @param observacionesCastellano
	 *            String
	 * 
	 * @param observacionesEuskera
	 *            String
	 * @param fechaInforme
	 *            Date
	 * @param fechaRegistro
	 *            Date
	 *
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @param tecnicosResponsables
	 *            TecnicosResponsables
	 * @param tiposResultado
	 *            TiposResultado
	 * 
	 * 
	 */

	public EstudioTecnico(Integer idProyectoExpediente, Integer idExpediente, Integer expedienteValidado,
			BigDecimal importePresentado, BigDecimal importeAdmitido, BigDecimal subvencionCalculada,
			BigDecimal subvencionJustificada, BigDecimal importeRecurso, BigDecimal subvencionResuelta,
			String observacionesCastellano, String observacionesEuskera, Date fechaInforme,
			BigDecimal importeDisponible, Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion,
			String usuarioUltmodificacion, MotivosDesestimacion motivosDesestimacion,
			TecnicosResponsables tecnicosResponsables, TiposResultado tiposResultado) {

		this.idProyectoExpediente = idProyectoExpediente;
		this.idExpediente = idExpediente;
		this.expedienteValidado = expedienteValidado;
		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.subvencionCalculada = subvencionCalculada;
		this.subvencionJustificada = subvencionJustificada;
		this.importeRecurso = importeRecurso;
		this.subvencionResuelta = subvencionResuelta;
		this.observacionesCastellano = observacionesCastellano;
		this.observacionesEuskera = observacionesEuskera;
		this.fechaInforme = fechaInforme;
		this.importeDisponible = importeDisponible;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.motivosDesestimacion = motivosDesestimacion;
		this.tecnicosResponsables = tecnicosResponsables;
		this.tiposResultado = tiposResultado;

	}

	/**
	 * Method 'DatosProyecto'.
	 * 
	 * @param idProyectoExpediente
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * 
	 * @param importePresentado
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param subvencionCalculada
	 *            BigDecimal
	 * @param subvencionJustificada
	 *            BigDecimal
	 * @param importeRecurso
	 *            BigDecimal
	 * @param subvencionResuelta
	 *            BigDecimal
	 * @param fechaInforme
	 *            Date
	 * @param importedisponible
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @param tecnicosResponsables
	 *            TecnicosResponsables
	 * @param tiposResultado
	 *            TiposResultado
	 * 
	 * @param criteriosPuntuacion
	 *            CriteriosPuntuacion
	 */

	public EstudioTecnico(Integer idProyectoExpediente, Integer idExpediente, BigDecimal importePresentado,
			BigDecimal importeAdmitido, BigDecimal subvencionCalculada, BigDecimal subvencionJustificada,
			BigDecimal importeRecurso, BigDecimal subvencionResuelta, Date fechaInforme, Date fechaRegistro,
			String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion,
			MotivosDesestimacion motivosDesestimacion, TecnicosResponsables tecnicosResponsables,
			TiposResultado tiposResultado, CriteriosPuntuacion criteriosPuntuacion) {

		this.idProyectoExpediente = idProyectoExpediente;
		this.motivosDesestimacion = motivosDesestimacion;
		this.tecnicosResponsables = tecnicosResponsables;
		this.tiposResultado = tiposResultado;
		this.idExpediente = idExpediente;

		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.subvencionCalculada = subvencionCalculada;
		this.subvencionJustificada = subvencionJustificada;
		this.importeRecurso = importeRecurso;
		this.subvencionResuelta = subvencionResuelta;
		this.fechaInforme = fechaInforme;

		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'DatosProyecto'.
	 * 
	 * @param idProyectoExpediente
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param importePresentado
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param subvencionCalculada
	 *            BigDecimal
	 * @param subvencionJustificada
	 *            BigDecimal
	 * @param importeRecurso
	 *            BigDecimal
	 * @param subvencionResuelta
	 *            BigDecimal
	 * @param fechaInforme
	 *            Date
	 */
	public EstudioTecnico(Integer idProyectoExpediente, Integer idExpediente, BigDecimal importePresentado,
			BigDecimal importeAdmitido, BigDecimal subvencionCalculada, BigDecimal subvencionJustificada,
			BigDecimal importeRecurso, BigDecimal subvencionResuelta, Date fechaInforme) {

		this.idProyectoExpediente = idProyectoExpediente;
		this.idExpediente = idExpediente;

		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
		this.subvencionCalculada = subvencionCalculada;
		this.subvencionJustificada = subvencionJustificada;
		this.importeRecurso = importeRecurso;
		this.subvencionResuelta = subvencionResuelta;
		this.fechaInforme = fechaInforme;

	}

	/**
	 * @param importePresentado
	 * @param importeAdmitido
	 */
	public EstudioTecnico(BigDecimal importePresentado, BigDecimal importeAdmitido) {

		this.importePresentado = importePresentado;
		this.importeAdmitido = importeAdmitido;
	}

	/**
	 * @return the fechaInformeStr
	 */
	public String getFechaInformeStr() {
		return fechaInformeStr;
	}

	/**
	 * @param fechaInformeStr
	 *            the fechaInformeStr to set
	 */
	public void setFechaInformeStr(String fechaInformeStr) {
		this.fechaInformeStr = fechaInformeStr;
	}

	/**
	 * @return the relExpIns
	 */
	public RelExpIns getRelExpIns() {
		return relExpIns;
	}

	/**
	 * @param relExpIns
	 *            the relExpIns to set
	 */
	public void setRelExpIns(RelExpIns relExpIns) {
		this.relExpIns = relExpIns;
	}

	/**
	 * Method 'getIdProyectoExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdProyectoExpediente() {
		return this.idProyectoExpediente;
	}

	/**
	 * Method 'setIdProyectoExpediente'.
	 *
	 * @param idProyectoExpediente
	 *            Integer
	 * @return
	 */

	public void setIdProyectoExpediente(Integer idProyectoExpediente) {
		this.idProyectoExpediente = idProyectoExpediente;
	}

	/**
	 * Method 'getMotivosDesestimacion'.
	 *
	 * @return MotivosDesestimacion
	 */

	public MotivosDesestimacion getMotivosDesestimacion() {
		return this.motivosDesestimacion;
	}

	/**
	 * Method 'setMotivosDesestimacion'.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @return
	 */

	public void setMotivosDesestimacion(MotivosDesestimacion motivosDesestimacion) {
		this.motivosDesestimacion = motivosDesestimacion;
	}

	/**
	 * Method 'getTecnicosResponsables'.
	 *
	 * @return TecnicosResponsables
	 */

	public TecnicosResponsables getTecnicosResponsables() {
		return this.tecnicosResponsables;
	}

	/**
	 * Method 'setTecnicosResponsables'.
	 *
	 * @param tecnicosResponsables
	 *            TecnicosResponsables
	 * @return
	 */

	public void setTecnicosResponsables(TecnicosResponsables tecnicosResponsables) {
		this.tecnicosResponsables = tecnicosResponsables;
	}

	/**
	 * Method 'getTiposResultado'.
	 *
	 * @return TiposResultado
	 */

	public TiposResultado getTiposResultado() {
		return this.tiposResultado;
	}

	/**
	 * Method 'setTiposResultado'.
	 *
	 * @param tiposResultado
	 *            TiposResultado
	 * @return
	 */

	public void setTiposResultado(TiposResultado tiposResultado) {
		this.tiposResultado = tiposResultado;
	}

	/**
	 * Method 'getIdExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdExpediente() {
		return this.idExpediente;
	}

	/**
	 * Method 'setIdExpediente'.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return
	 */

	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'getImportePresentado'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImportePresentado() {
		return this.importePresentado;
	}

	/**
	 * Method 'setImportePresentado'.
	 *
	 * @param importePresentado
	 *            BigDecimal
	 * @return
	 */

	public void setImportePresentado(BigDecimal importePresentado) {
		this.importePresentado = importePresentado;
	}

	/**
	 * Method 'getImporteAdmitido'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporteAdmitido() {
		return this.importeAdmitido;
	}

	/**
	 * Method 'setImporteAdmitido'.
	 *
	 * @param importeAdmitido
	 *            BigDecimal
	 * @return
	 */

	public void setImporteAdmitido(BigDecimal importeAdmitido) {
		this.importeAdmitido = importeAdmitido;
	}

	/**
	 * Method 'getSubvencionCalculada'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getSubvencionCalculada() {
		return this.subvencionCalculada;
	}

	/**
	 * Method 'setSubvencionCalculada'.
	 *
	 * @param subvencionCalculada
	 *            BigDecimal
	 * @return
	 */

	public void setSubvencionCalculada(BigDecimal subvencionCalculada) {
		this.subvencionCalculada = subvencionCalculada;
	}

	/**
	 * Method 'getSubvencionJustificada'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getSubvencionJustificada() {
		return this.subvencionJustificada;
	}

	/**
	 * Method 'setSubvencionJustificada'.
	 *
	 * @param subvencionJustificada
	 *            BigDecimal
	 * @return
	 */

	public void setSubvencionJustificada(BigDecimal subvencionJustificada) {
		this.subvencionJustificada = subvencionJustificada;
	}

	/**
	 * Method 'getImporteRecurso'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporteRecurso() {
		return this.importeRecurso;
	}

	/**
	 * Method 'setImporteRecurso'.
	 *
	 * @param importeRecurso
	 *            BigDecimal
	 * @return
	 */

	public void setImporteRecurso(BigDecimal importeRecurso) {
		this.importeRecurso = importeRecurso;
	}

	/**
	 * Method 'getSubvencionResuelta'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getSubvencionResuelta() {
		return this.subvencionResuelta;
	}

	/**
	 * Method 'setSubvencionResuelta'.
	 *
	 * @param subvencionResuelta
	 *            BigDecimal
	 * @return
	 */

	public void setSubvencionResuelta(BigDecimal subvencionResuelta) {
		this.subvencionResuelta = subvencionResuelta;
	}

	/**
	 * Method 'getFechaInforme'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaInforme() {
		return this.fechaInforme;
	}

	/**
	 * Method 'setFechaInforme'.
	 *
	 * @param fechaInforme
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaInforme(Date fechaInforme) {
		this.fechaInforme = fechaInforme;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getimportePresentadoMask'.
	 *
	 * @return BigDecimal
	 */

	public String getimportePresentadoMask() {
		return UtilDate.formatearMiles(importePresentado);
	}

	/**
	 * Method 'getimportePresentadoMask'.
	 *
	 * @return BigDecimal
	 */

	public String getimportePresentadoMask1() {
		return UtilDate.formatearMiles(importePresentado);
	}

	/**
	 * Method 'getimporteAdmitidoMask'.
	 *
	 * @return BigDecimal
	 */

	public String getimporteAdmitidoMask() {
		return UtilDate.formatearMiles(importeAdmitido);

	}

	/**
	 * Method 'getimporteAdmitidoMask'.
	 *
	 * @return BigDecimal
	 */

	public String getimporteAdmitidoMask1() {
		return UtilDate.formatearMiles(importeAdmitido);

	}

	/**
	 * Method 'getsubvencionCalculadaMask'.
	 *
	 * @return BigDecimal
	 */

	public String getsubvencionCalculadaMask() {
		return UtilDate.formatearMiles(subvencionCalculada);

	}

	/**
	 * Method 'getsubvencionResueltaMask'.
	 *
	 * @return BigDecimal
	 */

	public String getsubvencionResueltaMask() {
		return UtilDate.formatearMiles(subvencionResuelta);

	}

	/**
	 * Method 'getObservacionesCastellano'.
	 *
	 * @return String
	 */
	public String getObservacionesCastellano() {
		return observacionesCastellano;
	}

	/**
	 * Method 'setObservacionesCastellano'.
	 *
	 * @param observacionesCastellano
	 *            String
	 * @return
	 */
	public void setObservacionesCastellano(String observacionesCastellano) {
		this.observacionesCastellano = observacionesCastellano;
	}

	/**
	 * Method 'getObservacionesEuskera'.
	 *
	 * @return String
	 */
	public String getObservacionesEuskera() {
		return observacionesEuskera;
	}

	/**
	 * Method 'setObservacionesEuskera'.
	 *
	 * @param observacionesEuskera
	 *            String
	 * @return
	 */
	public void setObservacionesEuskera(String observacionesEuskera) {
		this.observacionesEuskera = observacionesEuskera;
	}

	/**
	 * @return the criterios
	 */
	public Integer[] getCriterios() {
		return criterios;
	}

	/**
	 * @param criterios
	 *            the criterios to set
	 */
	public void setCriterios(Integer[] criterios) {
		this.criterios = criterios;
	}

	/**
	 * @return the importePresentadoDesde
	 */
	public BigDecimal getImportePresentadoDesde() {
		return importePresentadoDesde;
	}

	/**
	 * @return the importePresentadoDesdeMask
	 */
	public String getImportePresentadoDesdeMask() {
		return UtilDate.formatearMiles(importePresentadoDesde);

	}

	/**
	 * @param importePresentadoDesde
	 *            the importePresentadoDesde to set
	 */
	public void setImportePresentadoDesde(BigDecimal importePresentadoDesde) {
		this.importePresentadoDesde = importePresentadoDesde;
	}

	/**
	 * @return the importePresentadoHasta
	 */
	public BigDecimal getImportePresentadoHasta() {
		return importePresentadoHasta;
	}

	/**
	 * @return the importePresentadoHastaMask
	 */
	public String getImportePresentadoHastaMask() {
		return UtilDate.formatearMiles(importePresentadoHasta);
	}

	/**
	 * @param importePresentadoHasta
	 *            the importePresentadoHasta to set
	 */
	public void setImportePresentadoHasta(BigDecimal importePresentadoHasta) {
		this.importePresentadoHasta = importePresentadoHasta;
	}

	/**
	 * @return the importeAdmitidoDesde
	 */
	public BigDecimal getImporteAdmitidoDesde() {
		return importeAdmitidoDesde;
	}

	/**
	 * @return the importeAdmitidoDesdeMask
	 */
	public String getImporteAdmitidoDesdeMask() {
		return UtilDate.formatearMiles(importeAdmitidoDesde);
	}

	/**
	 * @param importeAdmitidoDesde
	 *            the importeAdmitidoDesde to set
	 */
	public void setImporteAdmitidoDesde(BigDecimal importeAdmitidoDesde) {
		this.importeAdmitidoDesde = importeAdmitidoDesde;
	}

	/**
	 * @return the importeAdmitidoHasta
	 */
	public BigDecimal getImporteAdmitidoHasta() {
		return importeAdmitidoHasta;
	}

	/**
	 * @return the importeAdmitidoHastaMask
	 */
	public String getImporteAdmitidoHastaMask() {
		return UtilDate.formatearMiles(importeAdmitidoHasta);
	}

	/**
	 * @param importeAdmitidoHasta
	 *            the importeAdmitidoHasta to set
	 */
	public void setImporteAdmitidoHasta(BigDecimal importeAdmitidoHasta) {
		this.importeAdmitidoHasta = importeAdmitidoHasta;
	}

	/**
	 * @return the subvencionResueltaDesde
	 */
	public BigDecimal getSubvencionResueltaDesde() {
		return this.subvencionResueltaDesde;
	}

	/**
	 * @return the subvencionResueltaDesdeMask
	 */
	public String getSubvencionResueltaDesdeMask() {
		return UtilDate.formatearMiles(subvencionResueltaDesde);
	}

	/**
	 * 
	 * @param subvencionResueltaDesde
	 *            the subvencionResueltaDesde to set
	 */
	public void setSubvencionResueltaDesde(BigDecimal subvencionResueltaDesde) {
		this.subvencionResueltaDesde = subvencionResueltaDesde;
	}

	/**
	 * @return the subvencionResueltaHasta
	 */
	public BigDecimal getSubvencionResueltaHasta() {
		return this.subvencionResueltaHasta;
	}

	/**
	 * @return the subvencionResueltaHastaMask
	 */
	public String getSubvencionResueltaHastaMask() {
		return UtilDate.formatearMiles(subvencionResueltaHasta);
	}

	/**
	 * 
	 * @param subvencionResueltaHasta
	 *            the subvencionResueltaHasta to set
	 */
	public void setSubvencionResueltaHasta(BigDecimal subvencionResueltaHasta) {
		this.subvencionResueltaHasta = subvencionResueltaHasta;
	}

	/**
	 * @return the expedienteValidado
	 */
	public Integer getExpedienteValidado() {
		return expedienteValidado;
	}

	/**
	 * @param expedienteValidado
	 *            the expedienteValidado to set
	 */
	public void setExpedienteValidado(Integer expedienteValidado) {
		this.expedienteValidado = expedienteValidado;
	}

	/**
	 * @return the idRelacion
	 */
	public Integer getIdRelacion() {
		return idRelacion;
	}

	/**
	 * @param idRelacion
	 *            the idRelacion to set
	 */
	public void setIdRelacion(Integer idRelacion) {
		this.idRelacion = idRelacion;
	}

	/**
	 * @return the idMotivoDesestimacion
	 */
	public Integer getIdMotivoDesestimacion() {
		return idMotivoDesestimacion;
	}

	/**
	 * @param idMotivoDesestimacion
	 *            the idMotivoDesestimacion to set
	 */
	public void setIdMotivoDesestimacion(Integer idMotivoDesestimacion) {
		this.idMotivoDesestimacion = idMotivoDesestimacion;
	}

	/**
	 * @return the idTecnicoResponsable
	 */
	public Integer getIdTecnicoResponsable() {
		return idTecnicoResponsable;
	}

	/**
	 * @param idTecnicoResponsable
	 *            the idTecnicoResponsable to set
	 */
	public void setIdTecnicoResponsable(Integer idTecnicoResponsable) {
		this.idTecnicoResponsable = idTecnicoResponsable;
	}

	/**
	 * Method 'getimporteDisponibleMask'.
	 *
	 * @return BigDecimal
	 */

	public String getImporteDisponibleMask() {
		return UtilDate.formatearMiles(importeDisponible);
	}

	public BigDecimal getImporteDisponible() {
		return importeDisponible;
	}

	/**
	 * @param importeDisponible
	 *            the importeDisponible to set
	 */
	public void setImporteDisponible(BigDecimal importeDisponible) {
		this.importeDisponible = importeDisponible;
	}

	/**
	 * @return the bandera
	 */
	public Integer getBandera() {
		return bandera;
	}

	/**
	 * @param bandera
	 *            the bandera to set
	 */
	public void setBandera(Integer bandera) {
		this.bandera = bandera;
	}

	/**
	 * @return the idResultado
	 */
	public Integer getIdResultado() {
		return idResultado;
	}

	/**
	 * @param idResultado
	 *            the idResultado to set
	 */
	public void setIdResultado(Integer idResultado) {
		this.idResultado = idResultado;
	}

	/**
	 * @return the importeFinal
	 */
	public BigDecimal getImporteFinal() {
		return importeFinal;
	}

	/**
	 * @param importeFinal
	 *            the importeFinal to set
	 */
	public void setImporteFinal(BigDecimal importeFinal) {
		this.importeFinal = importeFinal;
	}

	/**
	 * @return the idConvocatoria
	 */
	public Integer getIdConvocatoria() {
		return idConvocatoria;
	}

	/**
	 * @param idConvocatoria
	 *            the idConvocatoria to set
	 */
	public void setIdConvocatoria(Integer idConvocatoria) {
		this.idConvocatoria = idConvocatoria;
	}

	/**
	 * @return the proyectos
	 */
	public Proyectos getProyectos() {
		return proyectos;
	}

	/**
	 * @param proyectos
	 *            the proyectos to set
	 */
	public void setProyectos(Proyectos proyectos) {
		this.proyectos = proyectos;
	}

	/**
	 * @return the actSubvencionable
	 */
	public ActSubvencionable getActSubvencionable() {
		return actSubvencionable;
	}

	/**
	 * @param actSubvencionable
	 *            the actSubvencionable to set
	 */
	public void setActSubvencionable(ActSubvencionable actSubvencionable) {
		this.actSubvencionable = actSubvencionable;
	}

	/**
	 * @return the criteriosPuntuacion
	 */
	public CriteriosPuntuacion getCriteriosPuntuacion() {
		return criteriosPuntuacion;
	}

	/**
	 * @param criteriosPuntuacion
	 *            the criteriosPuntuacion to set
	 */
	public void setCriteriosPuntuacion(CriteriosPuntuacion criteriosPuntuacion) {
		this.criteriosPuntuacion = criteriosPuntuacion;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "EstudioTecnico [idProyectoExpediente=" + idProyectoExpediente + ", expedienteValidado="
				+ expedienteValidado + ", idRelacion=" + idRelacion + ", idResultado=" + idResultado
				+ ", idMotivoDesestimacion=" + idMotivoDesestimacion + ", idTecnicoResponsable=" + idTecnicoResponsable
				+ ", idConvocatoria=" + idConvocatoria + ", motivosDesestimacion=" + motivosDesestimacion
				+ ", tecnicosResponsables=" + tecnicosResponsables + ", tiposResultado=" + tiposResultado
				+ ", idExpediente=" + idExpediente + ", importePresentado=" + importePresentado + ", importeAdmitido="
				+ importeAdmitido + ", subvencionCalculada=" + subvencionCalculada + ", subvencionJustificada="
				+ subvencionJustificada + ", importeRecurso=" + importeRecurso + ", subvencionResuelta="
				+ subvencionResuelta + ", importeFinal=" + importeFinal + ", fechaInforme=" + fechaInforme
				+ ", fechaRegistro=" + fechaRegistro + ", usuarioRegistro=" + usuarioRegistro
				+ ", fechaUltmodificacion=" + fechaUltmodificacion + ", usuarioUltmodificacion="
				+ usuarioUltmodificacion + ", observacionesCastellano=" + observacionesCastellano
				+ ", observacionesEuskera=" + observacionesEuskera + ", fechaInformeStr=" + fechaInformeStr
				+ ", importeDisponible=" + importeDisponible + ", importePresentadoDesde=" + importePresentadoDesde
				+ ", importePresentadoHasta=" + importePresentadoHasta + ", importeAdmitidoDesde="
				+ importeAdmitidoDesde + ", importeAdmitidoHasta=" + importeAdmitidoHasta + ", criterios="
				+ Arrays.toString(criterios) + ", bandera=" + bandera + ", proyectos=" + proyectos
				+ ", actSubvencionable=" + actSubvencionable + ", criteriosPuntuacion=" + criteriosPuntuacion + "]";
	}

	public Integer getTipoImporte() {
		return tipoImporte;
	}

	public void setTipoImporte(Integer tipoImporte) {
		this.tipoImporte = tipoImporte;
	}

	public BigDecimal getImporteFinalConvocatoria() {
		return importeFinalConvocatoria;
	}

	public void setImporteFinalConvocatoria(BigDecimal importeFinalConvocatoria) {
		this.importeFinalConvocatoria = importeFinalConvocatoria;
	}

	/**
	 * @return the datosTerOmic
	 */
	public DatosTerOmic getDatosTerOmic() {
		return datosTerOmic;
	}

	/**
	 * @param datosTerOmic
	 *            the datosTerOmic to set
	 */
	public void setDatosTerOmic(DatosTerOmic datosTerOmic) {
		this.datosTerOmic = datosTerOmic;
	}

	/**
	 * @return the importePresentadoMask2
	 */
	public String getImportePresentadoMask2() {

		String importePresentadoMask2 = null;

		if (null != importePresentado) {
			BigDecimal importePresentadoAux = importePresentado.setScale(2, BigDecimal.ROUND_DOWN);
			DecimalFormat df = new DecimalFormat();
			df.setMaximumFractionDigits(2);
			df.setMinimumFractionDigits(0);
			df.setGroupingUsed(false);

			importePresentadoMask2 = df.format(importePresentadoAux);
			importePresentadoMask2 = importePresentadoMask2.replace(".", ",");
		}
		return importePresentadoMask2;
	}

	/**
	 * @return the importeAdmitidoMask2
	 */
	public String getImporteAdmitidoMask2() {

		String importeAdmitidoMask2 = null;

		if (null != importeAdmitido) {
			BigDecimal importeAdmitidoAux = importeAdmitido.setScale(2, BigDecimal.ROUND_DOWN);
			DecimalFormat df = new DecimalFormat();
			df.setMaximumFractionDigits(2);
			df.setMinimumFractionDigits(0);
			df.setGroupingUsed(false);

			importeAdmitidoMask2 = df.format(importeAdmitidoAux);
			importeAdmitidoMask2 = importeAdmitidoMask2.replace(".", ",");
		}
		return importeAdmitidoMask2;
	}

	/**
	 * @return the subvencionCalculadaMask1
	 */
	public String getSubvencionCalculadaMask1() {

		String subvencionCalculadaMask1 = null;

		if (null != subvencionCalculada) {
			BigDecimal subvencionCalculadaAux = subvencionCalculada.setScale(2, BigDecimal.ROUND_DOWN);
			DecimalFormat df = new DecimalFormat();
			df.setMaximumFractionDigits(2);
			df.setMinimumFractionDigits(0);
			df.setGroupingUsed(false);

			subvencionCalculadaMask1 = df.format(subvencionCalculadaAux);
			subvencionCalculadaMask1 = subvencionCalculadaMask1.replace(".", ",");
		}

		return subvencionCalculadaMask1;
	}

	/**
	 * @return the subvencionCalculadaMask1
	 */
	public String getSubvencionResueltaMask1() {

		String subvencionResueltaMask1 = null;

		if (null != subvencionResuelta) {
			BigDecimal subvencionResueltaAux = subvencionResuelta.setScale(2, BigDecimal.ROUND_DOWN);
			DecimalFormat df = new DecimalFormat();
			df.setMaximumFractionDigits(2);
			df.setMinimumFractionDigits(0);
			df.setGroupingUsed(false);

			subvencionResueltaMask1 = df.format(subvencionResueltaAux);
			subvencionResueltaMask1 = subvencionResueltaMask1.replace(".", ",");
		}

		return subvencionResueltaMask1;
	}

	/**
	 * @return the exepto
	 */
	public Integer getExeptoHidden() {
		return exeptoHidden;
	}

	/**
	 * @param exepto
	 *            the exepto to set
	 */
	public void setExeptoHidden(Integer exepto) {
		this.exeptoHidden = exepto;
	}

	/**
	 * @return the importeSinIva
	 */
	public BigDecimal getImporteSinIva() {
		return importeSinIva;
	}

	/**
	 * @param importeSinIva
	 *            the importeSinIva to set
	 */
	public void setImporteSinIva(BigDecimal importeSinIva) {
		this.importeSinIva = importeSinIva;
	}

	/**
	 * @return the cargarSolSub
	 */
	public Integer getCargarSolSub() {
		return cargarSolSub;
	}

	/**
	 * @param cargarSolSub
	 *            the cargarSolSub to set
	 */
	public void setCargarSolSub(Integer cargarSolSub) {
		this.cargarSolSub = cargarSolSub;
	}

}
