package com.ejie.ab60.model.estudioTecnico;

import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.Date;

/**
 * MotivosDenegacion  
 * 
 *  
 */

public class MotivosDenegacion implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idMotivoDenegacion;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private String comboDenegacion;
	private String comboFacturaDenegacion;

	private Integer origen;
	private Convocatorias convocatoria;
	private Date fechaUltModificacion;
	private String usuarioUltModificacion;
	private Integer baja;

	private Integer busqConvocatoria;

	/**
	 * Method 'MotivosDenegacion'.
	 */
	public MotivosDenegacion() {
	}

	/**
	 * Method 'MotivosDenegacion'.
	 * 
	 * @param idMotivoDenegacion
	 *            Long
	 */
	public MotivosDenegacion(Long idMotivoDenegacion) {
		this.idMotivoDenegacion = idMotivoDenegacion;
	}

	/**
	 * @param idMotivoDenegacion
	 * @param descripcionCastellano
	 * @param descripcionEuskera
	 */
	public MotivosDenegacion(Long idMotivoDenegacion, String descripcionCastellano, String descripcionEuskera) {
		super();
		this.idMotivoDenegacion = idMotivoDenegacion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'MotivosDenegacion'.
	 * 
	 * @param idMotivoDenegacion
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public MotivosDenegacion(Long idMotivoDenegacion, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro) {

		this.idMotivoDenegacion = idMotivoDenegacion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getIdMotivoDenegacion'.
	 *
	 * @return Long
	 */

	public Long getIdMotivoDenegacion() {
		return this.idMotivoDenegacion;
	}

	/**
	 * Method 'setIdMotivoDenegacion'.
	 *
	 * @param idMotivoDenegacion
	 *            Long
	 * @return
	 */

	public void setIdMotivoDenegacion(Long idMotivoDenegacion) {
		this.idMotivoDenegacion = idMotivoDenegacion;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * @return the origen
	 */
	public Integer getOrigen() {
		return this.origen;
	}

	/**
	 * @param origen
	 *            the origen to set
	 */
	public void setOrigen(Integer origen) {
		this.origen = origen;
	}

	/**
	 * @return the convocatoria
	 */
	public Convocatorias getConvocatoria() {
		return this.convocatoria;
	}

	/**
	 * @param convocatoria
	 *            the convocatoria to set
	 */
	public void setConvocatoria(Convocatorias convocatoria) {
		this.convocatoria = convocatoria;
	}

	/**
	 * @return the fechaUltModificacion
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltModificacion() {
		return fechaUltModificacion;
	}

	/**
	 * @param fechaUltModificacion
	 *            the fechaUltModificacion to set
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltModificacion(Date fechaUltModificacion) {
		this.fechaUltModificacion = fechaUltModificacion;
	}

	/**
	 * @return the usuarioUltModificacion
	 */
	public String getUsuarioUltModificacion() {
		return this.usuarioUltModificacion;
	}

	/**
	 * @param usuarioUltModificacion
	 *            the usuarioUltModificacion to set
	 */
	public void setUsuarioUltModificacion(String usuarioUltModificacion) {
		this.usuarioUltModificacion = usuarioUltModificacion;
	}

	/**
	 * @return the baja
	 */
	public Integer getBaja() {
		return baja;
	}

	/**
	 * @param baja
	 *            the baja to set
	 */
	public void setBaja(Integer baja) {
		this.baja = baja;
	}

	/**
	 * @return the busqConvocatoria
	 */
	public Integer getBusqConvocatoria() {
		return this.busqConvocatoria;
	}

	/**
	 * @param busqConvocatoria
	 *            the busqConvocatoria to set
	 */
	public void setBusqConvocatoria(Integer busqConvocatoria) {
		this.busqConvocatoria = busqConvocatoria;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idMotivoDenegacion: ").append(this.idMotivoDenegacion).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

	/**
	 * @return the comboDenegacion
	 */
	public String getComboDenegacion() {
		return comboDenegacion;
	}

	/**
	 * @param comboDenegacion
	 *            the comboDenegacion to set
	 */
	public void setComboDenegacion(String comboDenegacion) {
		this.comboDenegacion = comboDenegacion;
	}

	/**
	 * @return the comboFacturaDenegacion
	 */
	public String getComboFacturaDenegacion() {
		return comboFacturaDenegacion;
	}

	/**
	 * @param comboFacturaDenegacion
	 *            the comboFacturaDenegacion to set
	 */
	public void setComboFacturaDenegacion(String comboFacturaDenegacion) {
		this.comboFacturaDenegacion = comboFacturaDenegacion;
	}

}
