package com.ejie.ab60.model.estudioTecnico;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * MotivosDesestimacion  
 * 
 *  
 */

public class MotivosDesestimacion implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idMotivoDesestimacion;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<EstudioTecnico> estudiosTecnico = new ArrayList<EstudioTecnico>();

	/**
	 * Method 'MotivosDesestimacion'.
	 */
	public MotivosDesestimacion() {
	}

	/**
	 * Method 'MotivosDesestimacion'.
	 * 
	 * @param idMotivoDesestimacion
	 *            Long
	 */
	public MotivosDesestimacion(Long idMotivoDesestimacion) {
		this.idMotivoDesestimacion = idMotivoDesestimacion;
	}

	/**
	 * Method 'MotivosDesestimacion'.
	 * 
	 * @param idMotivoDesestimacion
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public MotivosDesestimacion(Long idMotivoDesestimacion, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro) {
		this.idMotivoDesestimacion = idMotivoDesestimacion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'MotivosDesestimacion'.
	 * 
	 * @param idMotivoDesestimacion
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * 
	 */
	public MotivosDesestimacion(Long idMotivoDesestimacion, String descripcionCastellano, String descripcionEuskera) {
		this.idMotivoDesestimacion = idMotivoDesestimacion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;

	}

	/**
	 * Method 'MotivosDesestimacion'.
	 * 
	 * @param idMotivoDesestimacion
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param estudiosTecnico
	 *            List<EstudioTecnico>
	 */
	public MotivosDesestimacion(Long idMotivoDesestimacion, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro, List<EstudioTecnico> estudiosTecnico) {

		this.idMotivoDesestimacion = idMotivoDesestimacion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.estudiosTecnico = estudiosTecnico;
	}

	/**
	 * Method 'getIdMotivoDesestimacion'.
	 *
	 * @return Long
	 */

	public Long getIdMotivoDesestimacion() {
		return this.idMotivoDesestimacion;
	}

	/**
	 * Method 'setIdMotivoDesestimacion'.
	 *
	 * @param idMotivoDesestimacion
	 *            Long
	 * @return
	 */

	public void setIdMotivoDesestimacion(Long idMotivoDesestimacion) {
		this.idMotivoDesestimacion = idMotivoDesestimacion;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * @return the estudiosTecnico
	 */
	public List<EstudioTecnico> getEstudiosTecnico() {
		return estudiosTecnico;
	}

	/**
	 * @param estudiosTecnico
	 *            the estudiosTecnico to set
	 */
	public void setEstudiosTecnico(List<EstudioTecnico> estudiosTecnico) {
		this.estudiosTecnico = estudiosTecnico;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "MotivosDesestimacion [idMotivoDesestimacion=" + idMotivoDesestimacion + ", descripcionCastellano="
				+ descripcionCastellano + ", descripcionEuskera=" + descripcionEuskera + ", fechaRegistro="
				+ fechaRegistro + ", usuarioRegistro=" + usuarioRegistro + ", estudiosTecnico=" + estudiosTecnico + "]";
	}
}
