package com.ejie.ab60.model.estudioTecnico;

import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.Date;

/**
 * MotivosMinoracion  
 * 
 *  
 */

public class MotivosMinoracion implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idMotivoMinoracion;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private String comboMinoracion;
	private String comboFacturaMinoracion;

	private Integer origen;
	private Convocatorias convocatoria;
	private Date fechaUltModificacion;
	private String usuarioUltModificacion;
	private Integer baja;

	private Integer busqConvocatoria;

	/**
	 * Method 'MotivosMinoracion'.
	 */
	public MotivosMinoracion() {
	}

	/**
	 * Method 'MotivosMinoracion'.
	 * 
	 * @param idMotivoMinoracion
	 *            Long
	 */
	public MotivosMinoracion(Long idMotivoMinoracion) {
		this.idMotivoMinoracion = idMotivoMinoracion;
	}

	/**
	 * @param idMotivoMinoracion
	 * @param descripcionCastellano
	 * @param descripcionEuskera
	 */
	public MotivosMinoracion(Long idMotivoMinoracion, String descripcionCastellano, String descripcionEuskera) {
		super();
		this.idMotivoMinoracion = idMotivoMinoracion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'MotivosMinoracion'.
	 * 
	 * @param idMotivoMinoracion
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public MotivosMinoracion(Long idMotivoMinoracion, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro) {

		this.idMotivoMinoracion = idMotivoMinoracion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getIdMotivoMinoracion'.
	 *
	 * @return Long
	 */

	public Long getIdMotivoMinoracion() {
		return this.idMotivoMinoracion;
	}

	/**
	 * Method 'setIdMotivoMinoracion'.
	 *
	 * @param idMotivoMinoracion
	 *            Long
	 * @return
	 */

	public void setIdMotivoMinoracion(Long idMotivoMinoracion) {
		this.idMotivoMinoracion = idMotivoMinoracion;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * @return the origen
	 */
	public Integer getOrigen() {
		return this.origen;
	}

	/**
	 * @param origen
	 *            the origen to set
	 */
	public void setOrigen(Integer origen) {
		this.origen = origen;
	}

	/**
	 * @return the convocatoria
	 */
	public Convocatorias getConvocatoria() {
		return this.convocatoria;
	}

	/**
	 * @param convocatoria
	 *            the convocatoria to set
	 */
	public void setConvocatoria(Convocatorias convocatoria) {
		this.convocatoria = convocatoria;
	}

	/**
	 * @return the fechaUltModificacion
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltModificacion() {
		return fechaUltModificacion;
	}

	/**
	 * @param fechaUltModificacion
	 *            the fechaUltModificacion to set
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltModificacion(Date fechaUltModificacion) {
		this.fechaUltModificacion = fechaUltModificacion;
	}

	/**
	 * @return the usuarioUltModificacion
	 */
	public String getUsuarioUltModificacion() {
		return this.usuarioUltModificacion;
	}

	/**
	 * @param usuarioUltModificacion
	 *            the usuarioUltModificacion to set
	 */
	public void setUsuarioUltModificacion(String usuarioUltModificacion) {
		this.usuarioUltModificacion = usuarioUltModificacion;
	}

	/**
	 * @return the baja
	 */
	public Integer getBaja() {
		return baja;
	}

	/**
	 * @param baja
	 *            the baja to set
	 */
	public void setBaja(Integer baja) {
		this.baja = baja;
	}

	/**
	 * @return the busqConvocatoria
	 */
	public Integer getBusqConvocatoria() {
		return this.busqConvocatoria;
	}

	/**
	 * @param busqConvocatoria
	 *            the busqConvocatoria to set
	 */
	public void setBusqConvocatoria(Integer busqConvocatoria) {
		this.busqConvocatoria = busqConvocatoria;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idMotivoMinoracion: ").append(this.idMotivoMinoracion).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

	/**
	 * @return the comboMinoracion
	 */
	public String getComboMinoracion() {
		return comboMinoracion;
	}

	/**
	 * @param comboMinoracion
	 *            the comboMinoracion to set
	 */
	public void setComboMinoracion(String comboMinoracion) {
		this.comboMinoracion = comboMinoracion;
	}

	/**
	 * @return the comboFacturaMinoracion
	 */
	public String getComboFacturaMinoracion() {
		return comboFacturaMinoracion;
	}

	/**
	 * @param comboFacturaMinoracion
	 *            the comboFacturaMinoracion to set
	 */
	public void setComboFacturaMinoracion(String comboFacturaMinoracion) {
		this.comboFacturaMinoracion = comboFacturaMinoracion;
	}

}
