package com.ejie.ab60.model.estudioTecnico;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.Date;

import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * OtrasAyudas  
 * 
 *  
 */

public class OtrasAyudas implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idOtraAyuda;
	private Integer idExpediente;
	private Long anyoSolicitud;
	private String institucion;
	private String programa;
	private String tipoAyuda;
	private String actividad;
	private BigDecimal importeSolicitado;
	private BigDecimal ayudaConcedida;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Integer idTipoOtraAyuda;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;

	/**
	 * Method 'OtrasAyudas'.
	 */
	public OtrasAyudas() {
	}

	/**
	 * Method 'OtrasAyudas'.
	 * 
	 * @param idOtraAyuda
	 *            Integer
	 */
	public OtrasAyudas(Integer idOtraAyuda) {
		this.idOtraAyuda = idOtraAyuda;
	}

	/**
	 * Method 'OtrasAyudas'.
	 * 
	 * @param idOtraAyuda
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param anyoSolicitud
	 *            Long
	 * @param institucion
	 *            String
	 * @param programa
	 *            String
	 * @param tipoAyuda
	 *            String
	 * @param actividad
	 *            String
	 * @param importeSolicitado
	 *            BigDecimal
	 * @param ayudaConcedida
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public OtrasAyudas(Integer idOtraAyuda, Integer idExpediente, Long anyoSolicitud, String institucion,
			String programa, String tipoAyuda, String actividad, BigDecimal importeSolicitado,
			BigDecimal ayudaConcedida, Date fechaRegistro, String usuarioRegistro) {

		this.idOtraAyuda = idOtraAyuda;
		this.idExpediente = idExpediente;
		this.anyoSolicitud = anyoSolicitud;
		this.institucion = institucion;
		this.programa = programa;
		this.tipoAyuda = tipoAyuda;
		this.actividad = actividad;
		this.importeSolicitado = importeSolicitado;
		this.ayudaConcedida = ayudaConcedida;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getIdOtraAyuda'.
	 *
	 * @return Integer
	 */

	public Integer getIdOtraAyuda() {
		return this.idOtraAyuda;
	}

	/**
	 * Method 'setIdOtraAyuda'.
	 *
	 * @param idOtraAyuda
	 *            Integer
	 * @return
	 */

	public void setIdOtraAyuda(Integer idOtraAyuda) {
		this.idOtraAyuda = idOtraAyuda;
	}

	/**
	 * Method 'getIdExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdExpediente() {
		return this.idExpediente;
	}

	/**
	 * Method 'setIdExpediente'.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return
	 */

	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'getAnyoSolicitud'.
	 *
	 * @return Long
	 */

	public Long getAnyoSolicitud() {
		return this.anyoSolicitud;
	}

	/**
	 * Method 'setAnyoSolicitud'.
	 *
	 * @param anyoSolicitud
	 *            Long
	 * @return
	 */

	public void setAnyoSolicitud(Long anyoSolicitud) {
		this.anyoSolicitud = anyoSolicitud;
	}

	/**
	 * Method 'getInstitucion'.
	 *
	 * @return String
	 */

	public String getInstitucion() {
		return this.institucion;
	}

	/**
	 * Method 'setInstitucion'.
	 *
	 * @param institucion
	 *            String
	 * @return
	 */

	public void setInstitucion(String institucion) {
		this.institucion = institucion;
	}

	/**
	 * Method 'getPrograma'.
	 *
	 * @return String
	 */

	public String getPrograma() {
		return this.programa;
	}

	/**
	 * Method 'setPrograma'.
	 *
	 * @param programa
	 *            String
	 * @return
	 */

	public void setPrograma(String programa) {
		this.programa = programa;
	}

	/**
	 * Method 'getTipoAyuda'.
	 *
	 * @return String
	 */

	public String getTipoAyuda() {
		return this.tipoAyuda;
	}

	/**
	 * Method 'setTipoAyuda'.
	 *
	 * @param tipoAyuda
	 *            String
	 * @return
	 */

	public void setTipoAyuda(String tipoAyuda) {
		this.tipoAyuda = tipoAyuda;
	}

	/**
	 * Method 'getActividad'.
	 *
	 * @return String
	 */

	public String getActividad() {
		return this.actividad;
	}

	/**
	 * Method 'setActividad'.
	 *
	 * @param actividad
	 *            String
	 * @return
	 */

	public void setActividad(String actividad) {
		this.actividad = actividad;
	}

	/**
	 * Method 'getImporteSolicitado'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporteSolicitado() {
		return this.importeSolicitado;
	}

	/**
	 * Method 'getImporteSolicitadoMask'.
	 *
	 * @return BigDecimal
	 */

	public String getImporteSolicitadoMask() {
		return UtilDate.formatearMiles(importeSolicitado);
	}

	/**
	 * Method 'setImporteSolicitado'.
	 *
	 * @param importeSolicitado
	 *            BigDecimal
	 * @return
	 */

	public void setImporteSolicitado(BigDecimal importeSolicitado) {
		this.importeSolicitado = importeSolicitado;
	}

	/**
	 * Method 'getAyudaConcedida'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getAyudaConcedida() {
		return this.ayudaConcedida;
	}

	/**
	 * Method 'getAyudaConcedidaMask'.
	 *
	 * @return BigDecimal
	 */

	public String getAyudaConcedidaMask() {
		return UtilDate.formatearMiles(ayudaConcedida);

	}

	/**
	 * Method 'setAyudaConcedida'.
	 *
	 * @param ayudaConcedida
	 *            BigDecimal
	 * @return
	 */

	public void setAyudaConcedida(BigDecimal ayudaConcedida) {
		this.ayudaConcedida = ayudaConcedida;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * @return the idTipoOtraAyuda
	 */
	public Integer getIdTipoOtraAyuda() {
		return idTipoOtraAyuda;
	}

	/**
	 * @param idTipoOtraAyuda
	 *            the idTipoOtraAyuda to set
	 */
	public void setIdTipoOtraAyuda(Integer idTipoOtraAyuda) {
		this.idTipoOtraAyuda = idTipoOtraAyuda;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "OtrasAyudas [idOtraAyuda=" + idOtraAyuda + ", idExpediente=" + idExpediente + ", anyoSolicitud="
				+ anyoSolicitud + ", institucion=" + institucion + ", programa=" + programa + ", tipoAyuda=" + tipoAyuda
				+ ", actividad=" + actividad + ", importeSolicitado=" + importeSolicitado + ", ayudaConcedida="
				+ ayudaConcedida + ", fechaRegistro=" + fechaRegistro + ", usuarioRegistro=" + usuarioRegistro
				+ ", idTipoOtraAyuda=" + idTipoOtraAyuda + ", fechaUltmodificacion=" + fechaUltmodificacion
				+ ", usuarioUltmodificacion=" + usuarioUltmodificacion + "]";
	}
}
