package com.ejie.ab60.model.estudioTecnico;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * TecnicosResponsables  
 * 
 *  
 */

public class TecnicosResponsables implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idTecnicoResponsable;
	private String nombreTecnico;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<EstudioTecnico> estudiosTecnico = new ArrayList<EstudioTecnico>();

	private Date fechaUltModificacion;
	private String usuarioUltModificacion;
	private Integer baja;
	private List<RelTecResCon> listRelTecResCon = new ArrayList<RelTecResCon>();
	private String idsConvocatorias;

	private RelTecResCon relTecResCon;

	/**
	 * Method 'TecnicosResponsables'.
	 */
	public TecnicosResponsables() {
	}

	/**
	 * Method 'TecnicosResponsables'.
	 * 
	 * @param idTecnicoResponsable
	 *            Integer
	 */
	public TecnicosResponsables(Integer idTecnicoResponsable) {
		this.idTecnicoResponsable = idTecnicoResponsable;
	}

	/**
	 * Method 'TecnicosResponsables'.
	 * 
	 * @param idTecnicoResponsable
	 *            Integer
	 * @param nombreTecnico
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public TecnicosResponsables(Integer idTecnicoResponsable, String nombreTecnico, Date fechaRegistro,
			String usuarioRegistro) {
		this.idTecnicoResponsable = idTecnicoResponsable;
		this.nombreTecnico = nombreTecnico;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'TecnicosResponsables'.
	 * 
	 * @param idTecnicoResponsable
	 *            Integer
	 * @param nombreTecnico
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param estudiosTecnico
	 *            List<EstudioTecnico>
	 */
	public TecnicosResponsables(Integer idTecnicoResponsable, String nombreTecnico, Date fechaRegistro,
			String usuarioRegistro, List<EstudioTecnico> estudiosTecnico) {

		this.idTecnicoResponsable = idTecnicoResponsable;
		this.nombreTecnico = nombreTecnico;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.estudiosTecnico = estudiosTecnico;
	}

	/**
	 * Method 'TecnicosResponsables'.
	 * 
	 * @param idTecnicoResponsable
	 *            Integer
	 * @param nombreTecnico
	 *            String
	 *
	 */
	public TecnicosResponsables(Integer idTecnicoResponsable, String nombreTecnico) {

		this.idTecnicoResponsable = idTecnicoResponsable;
		this.nombreTecnico = nombreTecnico;

	}

	/**
	 * Method 'getIdTecnicoResponsable'.
	 *
	 * @return Integer
	 */

	public Integer getIdTecnicoResponsable() {
		return this.idTecnicoResponsable;
	}

	/**
	 * Method 'setIdTecnicoResponsable'.
	 *
	 * @param idTecnicoResponsable
	 *            Integer
	 * @return
	 */

	public void setIdTecnicoResponsable(Integer idTecnicoResponsable) {
		this.idTecnicoResponsable = idTecnicoResponsable;
	}

	/**
	 * Method 'getNombreTecnico'.
	 *
	 * @return String
	 */

	public String getNombreTecnico() {
		return this.nombreTecnico;
	}

	/**
	 * Method 'setNombreTecnico'.
	 *
	 * @param nombreTecnico
	 *            String
	 * @return
	 */

	public void setNombreTecnico(String nombreTecnico) {
		this.nombreTecnico = nombreTecnico;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getEstudioTecnicos'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<EstudioTecnico> getEstudioTecnicos() {
		return this.estudiosTecnico;
	}

	/**
	 * Method 'setEstudioTecnicos'.
	 *
	 * @param estudiosTecnico
	 *            List
	 * @return
	 */
	public void setEstudioTecnicos(List<EstudioTecnico> estudiosTecnico) {
		this.estudiosTecnico = estudiosTecnico;
	}

	/**
	 * @return the fechaUltModificacion
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltModificacion() {
		return this.fechaUltModificacion;
	}

	/**
	 * @param fechaUltModificacion
	 *            the fechaUltModificacion to set
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltModificacion(Date fechaUltModificacion) {
		this.fechaUltModificacion = fechaUltModificacion;
	}

	/**
	 * @return the usuarioUltModificacion
	 */
	public String getUsuarioUltModificacion() {
		return this.usuarioUltModificacion;
	}

	/**
	 * @param usuarioUltModificacion
	 *            the usuarioUltModificacion to set
	 */
	public void setUsuarioUltModificacion(String usuarioUltModificacion) {
		this.usuarioUltModificacion = usuarioUltModificacion;
	}

	/**
	 * @return the baja
	 */
	public Integer getBaja() {
		return this.baja;
	}

	/**
	 * @param baja
	 *            the baja to set
	 */
	public void setBaja(Integer baja) {
		this.baja = baja;
	}

	/**
	 * @return the listRelTecResCon
	 */
	public List<RelTecResCon> getListRelTecResCon() {
		return this.listRelTecResCon;
	}

	/**
	 * @param listRelTecResCon
	 *            the listRelTecResCon to set
	 */
	public void setListRelTecResCon(List<RelTecResCon> listRelTecResCon) {
		this.listRelTecResCon = listRelTecResCon;
	}

	/**
	 * @return the idsConvocatorias
	 */
	public String getIdsConvocatorias() {
		StringBuilder convocatorias = new StringBuilder();

		for (int indice = 0; indice < listRelTecResCon.size(); indice++) {
			convocatorias.append(Long.toString(listRelTecResCon.get(indice).getIdConvocatoria()));
			if ((indice + 1) != listRelTecResCon.size()) {
				convocatorias.append(",");
			}
		}

		this.idsConvocatorias = convocatorias.toString();

		return this.idsConvocatorias;
	}

	/**
	 * @return the relTecResCon
	 */
	public RelTecResCon getRelTecResCon() {
		return this.relTecResCon;
	}

	/**
	 * @param relTecResCon
	 *            the relTecResCon to set
	 */
	public void setRelTecResCon(RelTecResCon relTecResCon) {
		this.relTecResCon = relTecResCon;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idTecnicoResponsable: ").append(this.idTecnicoResponsable).append(" ]");
		result.append(", [ nombreTecnico: ").append(this.nombreTecnico).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
