package com.ejie.ab60.model.estudioTecnico;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * TiposResultado  
 * 
 *  
 */

public class TiposResultado implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idResultado;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<EstudioTecnico> estudiosTecnico = new ArrayList<EstudioTecnico>();

	/**
	 * Method 'TiposResultado'.
	 */
	public TiposResultado() {
	}

	/**
	 * Method 'TiposResultado'.
	 * 
	 * @param idResultado
	 *            Long
	 */
	public TiposResultado(Long idResultado) {
		this.idResultado = idResultado;
	}

	public TiposResultado(String descripcionCastellano, String descripcionEuskera) {
		super();
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'TiposResultado'.
	 * 
	 * @param idResultado
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioReguistro
	 *            String
	 */
	public TiposResultado(Long idResultado, String descripcionCastellano, String descripcionEuskera, Date fechaRegistro,
			String usuarioRegistro) {
		this.idResultado = idResultado;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'TiposResultado'.
	 * 
	 * @param idResultado
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * 
	 */
	public TiposResultado(Long idResultado, String descripcionCastellano, String descripcionEuskera) {
		this.idResultado = idResultado;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'TiposResultado'.
	 * 
	 * @param idResultado
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioReguistro
	 *            String
	 * @param estudiosTecnico
	 *            List<EstudioTecnico>
	 */
	public TiposResultado(Long idResultado, String descripcionCastellano, String descripcionEuskera, Date fechaRegistro,
			String usuarioRegistro, List<EstudioTecnico> estudiosTecnico) {

		this.idResultado = idResultado;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.estudiosTecnico = estudiosTecnico;
	}

	/**
	 * Method 'getIdResultado'.
	 *
	 * @return Long
	 */

	public Long getIdResultado() {
		return this.idResultado;
	}

	/**
	 * Method 'setIdResultado'.
	 *
	 * @param idResultado
	 *            Long
	 * @return
	 */

	public void setIdResultado(Long idResultado) {
		this.idResultado = idResultado;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioReguistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioReguistro'.
	 *
	 * @param usuarioReguistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getEstudioTecnicos'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<EstudioTecnico> getEstudioTecnicos() {
		return this.estudiosTecnico;
	}

	/**
	 * Method 'setEstudioTecnicos'.
	 *
	 * @param estudiosTecnico
	 *            List
	 * @return
	 */
	public void setEstudioTecnicos(List<EstudioTecnico> estudiosTecnico) {
		this.estudiosTecnico = estudiosTecnico;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idResultado: ").append(this.idResultado).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
