package com.ejie.ab60.model.expedientes;

import java.math.BigDecimal;
import java.util.Date;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.ejie.ab60.model.BEC.Curriculum;
import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.ab60.model.estudioTecnico.EstudioTecnico;
import com.ejie.ab60.model.estudioTecnico.TiposResultado;
import com.ejie.ab60.model.procedimientos.Procedimientos;
import com.ejie.ab60.model.terceros.DatosDirecciones;
import com.ejie.ab60.model.terceros.DatosTerceros;
import com.ejie.ab60.service.calculoAyuda.CalculoAyudaServiceImpl;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

public class Expedientes implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idExpediente;
	private Procedimientos procedimientos;
	private Long idTerritorioHistorico;
	private String folderId;
	private String folderNumber;
	private String titulo;
	private Date fechaRegistro;
	private String usuarioRegistro;

	private String fechaEntradaStr;
	private String fechaDocFormalStr;
	private String fechaUltAporStr;

	private EstudioTecnico estudioTecnico;
	private Convocatorias convocatoria;
	private TiposResultado tiposResultado;
	private Procedimientos procedimiento;
	private Curriculum curriculum;

	private Date fechaEntrada;
	private Date fechaDocFormal;
	private Date fechaUltApor;

	private Integer idTipoAyuda;

	private DatosTerceros datosTerceros;
	private DatosDirecciones datosDirecciones;
	private String tipoEmpTer;
	private String terEmp;
	private String identificadoresInspeccion;
	private String idsInspeccion;
	private String tiposInspeccion;
	private boolean inspeccionesSinEnviar;
	private BigDecimal importeResuelto;
	private BigDecimal importeLiquidado;
	private boolean expedienteHistorico;
	private Integer relacionExpediente;

	private String urlAplicacion;

	private static final Logger logger = LoggerFactory.getLogger(CalculoAyudaServiceImpl.class);

	/**
	 * Method 'Expedientes'.
	 */
	public Expedientes() {
		super();
	}

	/**
	 * Method 'Expedientes'.
	 * 
	 * @param idExpediente
	 *            Integer
	 */
	public Expedientes(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	public Expedientes(String folderNumber) {

		this.folderNumber = folderNumber;
	}

	/**
	 * Method 'Expedientes'.
	 * 
	 * @param idExpediente
	 *            Integer
	 * @param idTerritorioHistorico
	 *            Long
	 * @param folderId
	 *            String
	 * @param folderNumber
	 *            String
	 * @param titulo
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param procedimientos
	 *            Procedimientos
	 * 
	 */
	public Expedientes(Integer idExpediente, Long idTerritorioHistorico, String folderId, String folderNumber,
			String titulo, Date fechaRegistro, String usuarioRegistro, Procedimientos procedimientos,
			Integer relacionExpediente) {

		this.idExpediente = idExpediente;
		this.procedimientos = procedimientos;
		this.idTerritorioHistorico = idTerritorioHistorico;
		this.folderId = folderId;
		this.folderNumber = folderNumber;
		this.titulo = titulo;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.relacionExpediente = relacionExpediente;

	}

	public Expedientes(Integer idExpediente, String folderNumber, Date fechaEntrada, Date fechaDocFormal,
			Date fechaUltApor, EstudioTecnico estudioTecnico, TiposResultado tiposResultado) {

		this.idExpediente = idExpediente;
		this.folderNumber = folderNumber;
		this.fechaEntrada = fechaEntrada;
		this.fechaDocFormal = fechaDocFormal;
		this.fechaUltApor = fechaUltApor;

		this.estudioTecnico = estudioTecnico;
		this.tiposResultado = tiposResultado;
	}

	public Expedientes(Integer idExpediente, String titulo) {
		super();
		this.idExpediente = idExpediente;
		this.titulo = titulo;
	}

	/**
	 * @return the fechaUltApor
	 */
	public Date getFechaUltApor() {
		return fechaUltApor;
	}

	/**
	 * @param fechaUltApor
	 *            the fechaUltApor to set
	 */
	public void setFechaUltApor(Date fechaUltApor) {
		this.fechaUltApor = fechaUltApor;
	}

	/**
	 * @return the fechaEntrada
	 */
	public Date getFechaEntrada() {
		return fechaEntrada;
	}

	/**
	 * @param fechaEntrada
	 *            the fechaEntrada to set
	 */
	public void setFechaEntrada(Date fechaEntrada) {
		this.fechaEntrada = fechaEntrada;
	}

	/**
	 * @return the fechaDocFormal
	 */
	public Date getFechaDocFormal() {
		return fechaDocFormal;
	}

	/**
	 * @param fechaDocFormal
	 *            the fechaDocFormal to set
	 */
	public void setFechaDocFormal(Date fechaDocFormal) {
		this.fechaDocFormal = fechaDocFormal;
	}

	/**
	 * 
	 * /**
	 * 
	 * @return the procedimiento
	 */
	public Procedimientos getProcedimiento() {
		return procedimiento;
	}

	/**
	 * @param procedimiento
	 *            the procedimiento to set
	 */
	public void setProcedimiento(Procedimientos procedimiento) {
		this.procedimiento = procedimiento;
	}

	/**
	 * @return the tiposResultado
	 */
	public TiposResultado getTiposResultado() {
		return tiposResultado;
	}

	/**
	 * @param tiposResultado
	 *            the tiposResultado to set
	 */
	public void setTiposResultado(TiposResultado tiposResultado) {
		this.tiposResultado = tiposResultado;
	}

	/**
	 * @return the convocatoria
	 */
	public Convocatorias getConvocatoria() {
		return convocatoria;
	}

	/**
	 * @param convocatoria
	 *            the convocatoria to set
	 */
	public void setConvocatoria(Convocatorias convocatoria) {
		this.convocatoria = convocatoria;
	}

	/**
	 * @return the estudioTecnico
	 */
	public EstudioTecnico getEstudioTecnico() {
		return estudioTecnico;
	}

	/**
	 * @param estudioTecnico
	 *            the estudioTecnico to set
	 */
	public void setEstudioTecnico(EstudioTecnico estudioTecnico) {
		this.estudioTecnico = estudioTecnico;
	}

	/**
	 * @return the fechaEntradaStr
	 */
	public String getFechaEntradaStr() {
		return fechaEntradaStr;
	}

	/**
	 * @param fechaEntradaStr
	 *            the fechaEntradaStr to set
	 */
	public void setFechaEntradaStr(String fechaEntradaStr) {
		this.fechaEntradaStr = fechaEntradaStr;
	}

	/**
	 * @return the fechaDocFormalStr
	 */
	public String getFechaDocFormalStr() {
		return fechaDocFormalStr;
	}

	/**
	 * @param fechaDocFormalStr
	 *            the fechaDocFormalStr to set
	 */
	public void setFechaDocFormalStr(String fechaDocFormalStr) {
		this.fechaDocFormalStr = fechaDocFormalStr;
	}

	/**
	 * @return the fechaUltAporStr
	 */
	public String getFechaUltAporStr() {
		return fechaUltAporStr;
	}

	/**
	 * @param fechaUltAporStr
	 *            the fechaUltAporStr to set
	 */
	public void setFechaUltAporStr(String fechaUltAporStr) {
		this.fechaUltAporStr = fechaUltAporStr;
	}

	/**
	 * Method 'getIdExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdExpediente() {
		return this.idExpediente;
	}

	/**
	 * Method 'setIdExpediente'.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return
	 */

	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'getProcedimientos'.
	 *
	 * @return Procedimientos
	 */
	@JsonIgnore

	public Procedimientos getProcedimientos() {
		return this.procedimientos;
	}

	/**
	 * Method 'setProcedimientos'.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @return
	 */

	public void setProcedimientos(Procedimientos procedimientos) {
		this.procedimientos = procedimientos;
	}

	/**
	 * Method 'getIdTerritorioHistorico'.
	 *
	 * @return Long
	 */

	public Long getIdTerritorioHistorico() {
		return this.idTerritorioHistorico;
	}

	/**
	 * Method 'setIdTerritorioHistorico'.
	 *
	 * @param idTerritorioHistorico
	 *            Long
	 * @return
	 */

	public void setIdTerritorioHistorico(Long idTerritorioHistorico) {
		this.idTerritorioHistorico = idTerritorioHistorico;
	}

	/**
	 * Method 'getFolderId'.
	 *
	 * @return String
	 */

	public String getFolderId() {
		return this.folderId;
	}

	/**
	 * Method 'setFolderId'.
	 *
	 * @param folderId
	 *            String
	 * @return
	 */

	public void setFolderId(String folderId) {
		this.folderId = folderId;
	}

	/**
	 * Method 'getFolderNumber'.
	 *
	 * @return String
	 */

	public String getFolderNumber() {
		return this.folderNumber;
	}

	/**
	 * Method 'setFolderNumber'.
	 *
	 * @param folderNumber
	 *            String
	 * @return
	 */

	public void setFolderNumber(String folderNumber) {
		this.folderNumber = folderNumber;
	}

	/**
	 * Method 'getTitulo'.
	 *
	 * @return String
	 */

	public String getTitulo() {
		return this.titulo;
	}

	/**
	 * Method 'setTitulo'.
	 *
	 * @param titulo
	 *            String
	 * @return
	 */

	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaDocFormalHoraStr'.
	 *
	 * @return String
	 */

	public String getFechaDocFormalHoraStr() {
		logger.info("this.fechaDocFormal = " + this.fechaDocFormal);
		logger.info("UtilDate.convertirEnFechaConHora = " + UtilDate.convertirEnFechaConHora(this.fechaDocFormal));
		return UtilDate.convertirEnFechaConHora(this.fechaDocFormal);
	}

	/**
	 * Method 'getFechaUltAporHoraStr'.
	 *
	 * @return String
	 */

	public String getFechaUltAporHoraStr() {
		logger.info("this.fechaUltApor = " + this.fechaUltApor);
		logger.info("UtilDate.convertirEnFechaConHora = " + UtilDate.convertirEnFechaConHora(this.fechaUltApor));
		return UtilDate.convertirEnFechaConHora(this.fechaUltApor);
	}

	/**
	 * Method 'getFechaUltAporHoraStr'.
	 *
	 * @return String
	 */

	public String getFechaEntradaHoraStr() {
		return UtilDate.convertirEnFechaConHora(this.fechaEntrada);
	}

	/**
	 * @return the idTipoAyuda
	 */
	public Integer getIdTipoAyuda() {
		return idTipoAyuda;
	}

	/**
	 * @param idTipoAyuda
	 *            the idTipoAyuda to set
	 */
	public void setIdTipoAyuda(Integer idTipoAyuda) {
		this.idTipoAyuda = idTipoAyuda;
	}

	/**
	 * @return the curriculum
	 */
	public Curriculum getCurriculum() {
		return curriculum;
	}

	/**
	 * @param curriculum
	 *            the curriculum to set
	 */
	public void setCurriculum(Curriculum curriculum) {
		this.curriculum = curriculum;
	}

	/**
	 * @return the datosTerceros
	 */
	public DatosTerceros getDatosTerceros() {
		return datosTerceros;
	}

	/**
	 * @param datosTerceros
	 *            the datosTerceros to set
	 */
	public void setDatosTerceros(DatosTerceros datosTerceros) {
		this.datosTerceros = datosTerceros;
	}

	/**
	 * @return the datosDirecciones
	 */
	public DatosDirecciones getDatosDirecciones() {
		return this.datosDirecciones;
	}

	/**
	 * @param datosDirecciones
	 *            the datosDirecciones to set
	 */
	public void setDatosDirecciones(DatosDirecciones datosDirecciones) {
		this.datosDirecciones = datosDirecciones;
	}

	/**
	 * @return the terEmp
	 */
	public String getTerEmp() {
		if (null != this.datosTerceros && null != this.datosTerceros.getNombre()
				&& !"".equalsIgnoreCase(datosTerceros.getNombre())) {
			return datosTerceros.getDocumento() + " - " + datosTerceros.getNombre() + " " + datosTerceros.getApellido1()
					+ " " + datosTerceros.getApellido2();
		} else
			return "";
	}

	/**
	 * @param terEmp
	 *            the terEmp to set
	 */
	public void setTerEmp(String terEmp) {
		this.terEmp = terEmp;
	}

	/**
	 * @return the tipoEmpTer
	 */
	public String getTipoEmpTer() {
		return tipoEmpTer;
	}

	/**
	 * @param tipoEmpTer
	 *            the tipoEmpTer to set
	 */
	public void setTipoEmpTer(String tipoEmpTer) {
		this.tipoEmpTer = tipoEmpTer;
	}

	public String getIdentificadoresInspeccion() {
		return this.identificadoresInspeccion;
	}

	public void setIdentificadoresInspeccion(String identificadoresInspeccion) {
		this.identificadoresInspeccion = identificadoresInspeccion;
	}

	public String getIdsInspeccion() {
		return idsInspeccion;
	}

	public void setIdsInspeccion(String idsInspeccion) {
		this.idsInspeccion = idsInspeccion;
	}

	public String getTiposInspeccion() {
		return this.tiposInspeccion;
	}

	public void setTiposInspeccion(String tiposInspeccion) {
		this.tiposInspeccion = tiposInspeccion;
	}

	public boolean isInspeccionesSinEnviar() {
		return inspeccionesSinEnviar;
	}

	public void setInspeccionesSinEnviar(boolean inspeccionesSinEnviar) {
		this.inspeccionesSinEnviar = inspeccionesSinEnviar;
	}

	public BigDecimal getImporteResuelto() {
		return importeResuelto;
	}

	public void setImporteResuelto(BigDecimal importeResuelto) {
		this.importeResuelto = importeResuelto;
	}

	public BigDecimal getImporteLiquidado() {
		return importeLiquidado;
	}

	public void setImporteLiquidado(BigDecimal importeLiquidado) {
		this.importeLiquidado = importeLiquidado;
	}

	public String getUrlAplicacion() {
		return urlAplicacion;
	}

	public void setUrlAplicacion(String urlAplicacion) {
		this.urlAplicacion = urlAplicacion;
	}

	public boolean isExpedienteHistorico() {
		return this.expedienteHistorico;
	}

	public void setExpedienteHistorico(boolean expedienteHistorico) {
		this.expedienteHistorico = expedienteHistorico;
	}

	public Integer getRelacionExpediente() {
		return this.relacionExpediente;
	}

	public void setRelacionExpediente(Integer relacionExpediente) {
		this.relacionExpediente = relacionExpediente;
	}

}
