package com.ejie.ab60.model.expedientes;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.ab60.clientesWS.ab79WebService.DatosInspeccionWS;
import com.ejie.ab60.model.MEC.Facturas;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

public class MarcarInspeccionable implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Expedientes expediente;
	private Date fechaLimInspeccion;
	private String observacionInspeccion;
	private Date fechaLimInspeccionJus;
	private String observacionInspeccionJus;
	private String folderYTitulo;
	private String fechaLimInspeccionStr;
	private List<Facturas> facturas = new ArrayList<Facturas>();
	private Usuario usuario;
	private Integer origenInspeccion;
	private Integer tipoInspeccion;

	private List<DatosInspeccionWS> datosInspeccionEnviarWS = new ArrayList<DatosInspeccionWS>();

	public MarcarInspeccionable() {

	}

	public MarcarInspeccionable(Date fechaLimInspeccion, Date fechaLimInspeccionJus, String observacionInspeccion,
			String observacionInspeccionJus) {
		this.fechaLimInspeccion = fechaLimInspeccion;
		this.fechaLimInspeccionJus = fechaLimInspeccionJus;
		this.observacionInspeccion = observacionInspeccion;
		this.observacionInspeccionJus = observacionInspeccionJus;
	}

	/**
	 * @return the fechaFacturaStr
	 */

	public String getFechaLimInspeccionStr() {
		return fechaLimInspeccionStr;
	}

	/**
	 * @param fechaFacturaStr
	 *            the fechaFacturaStr to set
	 */

	public void setFechaLimInspeccionStr(String fechaLimInspeccionStr) {
		this.fechaLimInspeccionStr = fechaLimInspeccionStr;
	}

	/**
	 * @return the expediente
	 */
	public Expedientes getExpediente() {
		return expediente;
	}

	/**
	 * @param expediente
	 *            the expediente to set
	 */
	public void setExpediente(Expedientes expediente) {
		this.expediente = expediente;
	}

	/**
	 * @return the fechaLimInspeccion
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaLimInspeccion() {
		return fechaLimInspeccion;
	}

	/**
	 * @param fechaLimInspeccion
	 *            the fechaLimInspeccion to set
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaLimInspeccion(Date fechaLimInspeccion) {
		this.fechaLimInspeccion = fechaLimInspeccion;
	}

	/**
	 * @return the observacionInspeccion
	 */
	public String getObservacionInspeccion() {
		return observacionInspeccion;
	}

	/**
	 * @param observacionInspeccion
	 *            the observacionInspeccion to set
	 */
	public void setObservacionInspeccion(String observacionInspeccion) {
		this.observacionInspeccion = observacionInspeccion;
	}

	/**
	 * @return the folderYTitulo
	 */
	public String getFolderYTitulo() {
		return folderYTitulo;
	}

	/**
	 * @param folderYTitulo
	 *            the folderYTitulo to set
	 */
	public void setFolderYTitulo(String folderYTitulo) {
		this.folderYTitulo = folderYTitulo;
	}

	/**
	 * @return the facturas
	 */
	public List<Facturas> getFacturas() {
		return facturas;
	}

	/**
	 * @param facturas
	 *            the facturas to set
	 */
	public void setFacturas(List<Facturas> facturas) {
		this.facturas = facturas;
	}

	/**
	 * @return the usuario
	 */
	public Usuario getUsuario() {
		return usuario;
	}

	/**
	 * @param usuario
	 *            the usuario to set
	 */
	public void setUsuario(Usuario usuario) {
		this.usuario = usuario;
	}

	/**
	 * @return the origenInspeccion
	 */
	public Integer getOrigenInspeccion() {
		return origenInspeccion;
	}

	/**
	 * @param origenInspeccion
	 *            the origenInspeccion to set
	 */
	public void setOrigenInspeccion(Integer origenInspeccion) {
		this.origenInspeccion = origenInspeccion;
	}

	/**
	 * @return the tipoInspeccion
	 */
	public Integer getTipoInspeccion() {
		return tipoInspeccion;
	}

	/**
	 * @param tipoInspeccion
	 *            the tipoInspeccion to set
	 */
	public void setTipoInspeccion(Integer tipoInspeccion) {
		this.tipoInspeccion = tipoInspeccion;
	}

	/**
	 * @return the fechaLimInspeccionJus
	 */
	public Date getFechaLimInspeccionJus() {
		return fechaLimInspeccionJus;
	}

	/**
	 * @param fechaLimInspeccionJus
	 *            the fechaLimInspeccionJus to set
	 */
	public void setFechaLimInspeccionJus(Date fechaLimInspeccionJus) {
		this.fechaLimInspeccionJus = fechaLimInspeccionJus;
	}

	/**
	 * @return the observacionInspeccionJus
	 */
	public String getObservacionInspeccionJus() {
		return observacionInspeccionJus;
	}

	/**
	 * @param observacionInspeccionJus
	 *            the observacionInspeccionJus to set
	 */
	public void setObservacionInspeccionJus(String observacionInspeccionJus) {
		this.observacionInspeccionJus = observacionInspeccionJus;
	}

	/**
	 * @return the datosInspeccionEnviarWS
	 */
	public List<DatosInspeccionWS> getDatosInspeccionEnviarWS() {
		return datosInspeccionEnviarWS;
	}

	/**
	 * @param datosInspeccionEnviarWS
	 *            the datosInspeccionEnviarWS to set
	 */
	public void setDatosInspeccionEnviarWS(List<DatosInspeccionWS> datosInspeccionEnviarWS) {
		this.datosInspeccionEnviarWS = datosInspeccionEnviarWS;
	}

}
