package com.ejie.ab60.model.expedientes;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.ab60.clientesWS.ab79WebService.DatosInspeccionWS;
import com.ejie.ab60.model.actuacionesSubvencionables.ActSubvencionable;
import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.ab60.model.estudioTecnico.Conceptos;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

public class MarcarInspeccionableAct implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Expedientes expediente;
	private Date fechaLimInspeccion;
	private String observacionInspeccion;
	private String folderYTitulo;
	private String fechaLimInspeccionStr;
	private Usuario usuario;
	private Integer origenInspeccion;
	private Integer tipoInspeccion;
	private ActSubvencionable actSubs = new ActSubvencionable();
	private RelExpActSub relExpActSub = new RelExpActSub();
	private Conceptos conceptos = new Conceptos();
	private List<DatosInspeccionWS> datosInspeccionEnviarWS = new ArrayList<DatosInspeccionWS>();
	private List<Conceptos> conceptosList = new ArrayList<Conceptos>();

	public MarcarInspeccionableAct() {
		// TODO Auto-generated constructor stub
	}

	public MarcarInspeccionableAct(Date fechaLimInspeccion, String observacionInspeccion) {
		this.fechaLimInspeccion = fechaLimInspeccion;
		this.observacionInspeccion = observacionInspeccion;
	}

	/**
	 * @return the expediente
	 */
	public Expedientes getExpediente() {
		return expediente;
	}

	/**
	 * @param expediente
	 *            the expediente to set
	 */
	public void setExpediente(Expedientes expediente) {
		this.expediente = expediente;
	}

	/**
	 * @return the folderYTitulo
	 */
	public String getFolderYTitulo() {
		return folderYTitulo;
	}

	/**
	 * @param folderYTitulo
	 *            the folderYTitulo to set
	 */
	public void setFolderYTitulo(String folderYTitulo) {
		this.folderYTitulo = folderYTitulo;
	}

	/**
	 * @return the fechaLimInspeccion
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaLimInspeccion() {
		return fechaLimInspeccion;
	}

	/**
	 * @param fechaLimInspeccion
	 *            the fechaLimInspeccion to set
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaLimInspeccion(Date fechaLimInspeccion) {
		this.fechaLimInspeccion = fechaLimInspeccion;
	}

	/**
	 * @return the observacionInspeccion
	 */
	public String getObservacionInspeccion() {
		return observacionInspeccion;
	}

	/**
	 * @param observacionInspeccion
	 *            the observacionInspeccion to set
	 */
	public void setObservacionInspeccion(String observacionInspeccion) {
		this.observacionInspeccion = observacionInspeccion;
	}

	/**
	 * @return the fechaLimInspeccionStr
	 */
	public String getFechaLimInspeccionStr() {
		return fechaLimInspeccionStr;
	}

	/**
	 * @param fechaLimInspeccionStr
	 *            the fechaLimInspeccionStr to set
	 */
	public void setFechaLimInspeccionStr(String fechaLimInspeccionStr) {
		this.fechaLimInspeccionStr = fechaLimInspeccionStr;
	}

	/**
	 * @return the usuario
	 */
	public Usuario getUsuario() {
		return usuario;
	}

	/**
	 * @param usuario
	 *            the usuario to set
	 */
	public void setUsuario(Usuario usuario) {
		this.usuario = usuario;
	}

	/**
	 * @return the origenInspeccion
	 */
	public Integer getOrigenInspeccion() {
		return origenInspeccion;
	}

	/**
	 * @param origenInspeccion
	 *            the origenInspeccion to set
	 */
	public void setOrigenInspeccion(Integer origenInspeccion) {
		this.origenInspeccion = origenInspeccion;
	}

	/**
	 * @return the tipoInspeccion
	 */
	public Integer getTipoInspeccion() {
		return tipoInspeccion;
	}

	/**
	 * @param tipoInspeccion
	 *            the tipoInspeccion to set
	 */
	public void setTipoInspeccion(Integer tipoInspeccion) {
		this.tipoInspeccion = tipoInspeccion;
	}

	/**
	 * @return the actSubs
	 */
	public ActSubvencionable getActSubs() {
		return actSubs;
	}

	/**
	 * @param actSubs
	 *            the actSubs to set
	 */
	public void setActSubs(ActSubvencionable actSubs) {
		this.actSubs = actSubs;
	}

	/**
	 * @return the relExpActSub
	 */
	public RelExpActSub getRelExpActSub() {
		return relExpActSub;
	}

	/**
	 * @param relExpActSub
	 *            the relExpActSub to set
	 */
	public void setRelExpActSub(RelExpActSub relExpActSub) {
		this.relExpActSub = relExpActSub;
	}

	/**
	 * @return the conceptos
	 */
	public Conceptos getConceptos() {
		return conceptos;
	}

	/**
	 * @param conceptos
	 *            the conceptos to set
	 */
	public void setConceptos(Conceptos conceptos) {
		this.conceptos = conceptos;
	}

	public Integer getEnviado() {

		Integer enviado = null;

		if (getConceptos() != null && getConceptos().getEnviadoInspeccionar() != null) {
			enviado = getConceptos().getEnviadoInspeccionar();
		} else if (getRelExpActSub() != null && getRelExpActSub().getEnviadoInspeccionar() != null) {
			enviado = getRelExpActSub().getEnviadoInspeccionar();
		}

		return enviado;
	}

	public Integer getInspeccionable() {

		Integer inspeccionable = null;

		if (getConceptos() != null && getConceptos().getInspeccionable() != null) {
			inspeccionable = getConceptos().getInspeccionable();
		} else if (getRelExpActSub() != null && getRelExpActSub().getInspeccionable() != null) {
			inspeccionable = getRelExpActSub().getInspeccionable();
		}

		return inspeccionable;
	}

	public String getImporteAdmitido() {

		String importeAdmitido = null;

		if (getConceptos() != null && getConceptos().getimporteAdmitidoMask().length() > 0) {
			importeAdmitido = getConceptos().getimporteAdmitidoMask();
		} else if (getRelExpActSub() != null && getRelExpActSub().getImporteAdmitidoMask().length() > 0) {
			importeAdmitido = getRelExpActSub().getImporteAdmitidoMask();
		}

		return importeAdmitido;
	}

	public String getImportePresentado() {

		String importePresentado = null;

		if (getConceptos() != null && getConceptos().getimportePresentadoMask().length() > 0) {
			importePresentado = getConceptos().getimportePresentadoMask();
		} else if (getRelExpActSub() != null && getRelExpActSub().getImportePresentadoMask().length() > 0) {
			importePresentado = getRelExpActSub().getImportePresentadoMask();
		}

		return importePresentado;
	}

	public String getObservacionesCas() {

		String observaciones = null;

		if (getConceptos() != null && getConceptos().getObservacionesCastellano() != null) {
			observaciones = getConceptos().getObservacionesCastellano();
		} else if (getRelExpActSub() != null && getRelExpActSub().getObservacionesCastellano() != null) {
			observaciones = getRelExpActSub().getObservacionesCastellano();
		}

		return observaciones;
	}

	public String getObservacionesEus() {

		String observaciones = null;

		if (getConceptos() != null && getConceptos().getObservacionesEuskera() != null) {
			observaciones = getConceptos().getObservacionesEuskera();
		} else if (getRelExpActSub() != null && getRelExpActSub().getObservacionesEuskera() != null) {
			observaciones = getRelExpActSub().getObservacionesEuskera();
		}

		return observaciones;
	}

	/**
	 * @return the ojetosWSAct
	 */
	public List<DatosInspeccionWS> getDatosInspeccionEnviarWS() {
		return datosInspeccionEnviarWS;
	}

	/**
	 * @param ojetosWSAct
	 *            the ojetosWSAct to set
	 */
	public void setDatosInspeccionEnviarWS(List<DatosInspeccionWS> datosInspeccionEnviarWS) {
		this.datosInspeccionEnviarWS = datosInspeccionEnviarWS;
	}

	public List<Conceptos> getConceptosList() {
		return this.conceptosList;
	}

	public void setConceptosList(List<Conceptos> conceptosList) {
		this.conceptosList = conceptosList;
	}

}
