/**
 * 
 */
package com.ejie.ab60.model.justificacion;

import java.math.BigDecimal;
import java.util.Date;

import com.ejie.ab60.model.RelExpIns;
import com.ejie.ab60.model.estudioTecnico.TecnicosResponsables;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Justificacion  
 * 
 *  
 */

public class Justificacion implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idProyectoExpediente;
	private Integer expedienteValidado;

	private BigDecimal subvencionResuelta;
	private BigDecimal subvencionJustificada;

	private BigDecimal importeJusAdmitido;
	private BigDecimal importeJusCalculado;

	private String observacionesCastellano;
	private String observacionesEuskera;

	private Date fechaInformeJus;

	private Integer idTecnicoResponsable;
	private TecnicosResponsables tecnicosResponsables;

	private Integer idResultado;
	private TiposResJus tiposResJus;

	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;

	private String fechaInformeStr;

	private Integer idMotivoIncumplimiento;
	private MotivosIncumplimiento motivosIncumplimiento;

	private Integer idConvocatoria;

	private Integer idExpediente;

	private Integer bandera;

	private RelExpIns relExpIns;

	private BigDecimal rendimientoFinanciero;

	/**
	 * Method 'Justificacion'.
	 */
	public Justificacion() {
	}

	public Justificacion(Integer idProyectoExpediente, Integer idExpediente, BigDecimal subvencionResuelta,
			BigDecimal subvencionJustificada, BigDecimal importeJusAdmitido, BigDecimal importeJusCalculado,
			String observacionesCastellano, String observacionesEuskera, Date fechaInformeJus,
			MotivosIncumplimiento motivosInclumplimiento, TecnicosResponsables tecnicosResponsables,
			TiposResJus tiposResultado) {

		this.idProyectoExpediente = idProyectoExpediente;
		this.idExpediente = idExpediente;
		this.importeJusAdmitido = importeJusAdmitido;
		this.importeJusCalculado = importeJusCalculado;
		this.subvencionResuelta = subvencionResuelta;
		this.subvencionJustificada = subvencionJustificada;
		this.observacionesCastellano = observacionesCastellano;
		this.observacionesEuskera = observacionesEuskera;
		this.fechaInformeJus = fechaInformeJus;
		this.motivosIncumplimiento = motivosInclumplimiento;
		this.tecnicosResponsables = tecnicosResponsables;
		this.tiposResJus = tiposResultado;

	}

	/**
	 * @param importePresentado
	 *            BigDecimal
	 * @param importeAdmitido
	 *            BigDecimal
	 * @param subvencionCalculada
	 *            BigDecimal
	 * @param subvencionResuelta
	 *            BigDecimal
	 */
	public Justificacion(BigDecimal subvencionResuelta, BigDecimal subvencionJustificada, BigDecimal importeAdmitido,
			BigDecimal importePresentado) {

		this.subvencionResuelta = subvencionResuelta;
		this.subvencionJustificada = subvencionJustificada;
		this.importeJusAdmitido = importeAdmitido;
		this.importeJusCalculado = importePresentado;
	}

	/**
	 * @return the idProyectoExpediente
	 */
	public Integer getIdProyectoExpediente() {
		return idProyectoExpediente;
	}

	/**
	 * @param idProyectoExpediente
	 *            the idProyectoExpediente to set
	 */
	public void setIdProyectoExpediente(Integer idProyectoExpediente) {
		this.idProyectoExpediente = idProyectoExpediente;
	}

	/**
	 * @return the expedienteValidado
	 */
	public Integer getExpedienteValidado() {
		return expedienteValidado;
	}

	/**
	 * @param expedienteValidado
	 *            the expedienteValidado to set
	 */
	public void setExpedienteValidado(Integer expedienteValidado) {
		this.expedienteValidado = expedienteValidado;
	}

	/**
	 * @return the relExpIns
	 */
	public RelExpIns getRelExpIns() {
		return relExpIns;
	}

	/**
	 * @param relExpIns
	 *            the relExpIns to set
	 */
	public void setRelExpIns(RelExpIns relExpIns) {
		this.relExpIns = relExpIns;
	}

	/**
	 * @return the subvencionCalculada
	 */
	public BigDecimal getSubvencionResuelta() {
		return subvencionResuelta;
	}

	/**
	 * @param subvencionCalculada
	 *            the subvencionCalculada to set
	 */
	public void setSubvencionResuelta(BigDecimal subvencionResuelta) {
		this.subvencionResuelta = subvencionResuelta;
	}

	/**
	 * @return the subvencionJustificada
	 */
	public BigDecimal getSubvencionJustificada() {
		return subvencionJustificada;
	}

	/**
	 * @param subvencionJustificada
	 *            the subvencionJustificada to set
	 */
	public void setSubvencionJustificada(BigDecimal subvencionJustificada) {
		this.subvencionJustificada = subvencionJustificada;
	}

	/**
	 * @return the importeJusAdmitido
	 */
	public BigDecimal getImporteJusAdmitido() {
		return importeJusAdmitido;
	}

	/**
	 * @param importeJusAdmitido
	 *            the importeJusAdmitido to set
	 */
	public void setImporteJusAdmitido(BigDecimal importeJusAdmitido) {
		this.importeJusAdmitido = importeJusAdmitido;
	}

	/**
	 * @return the importeJusCalculado
	 */
	public BigDecimal getImporteJusCalculado() {
		return importeJusCalculado;
	}

	/**
	 * @param importeJusCalculado
	 *            the importeJusCalculado to set
	 */
	public void setImporteJusCalculado(BigDecimal importeJusCalculado) {
		this.importeJusCalculado = importeJusCalculado;
	}

	/**
	 * @return the observacionesCastellano
	 */
	public String getObservacionesCastellano() {
		return observacionesCastellano;
	}

	/**
	 * @param observacionesCastellano
	 *            the observacionesCastellano to set
	 */
	public void setObservacionesCastellano(String observacionesCastellano) {
		this.observacionesCastellano = observacionesCastellano;
	}

	/**
	 * @return the observacionesEuskera
	 */
	public String getObservacionesEuskera() {
		return observacionesEuskera;
	}

	/**
	 * @param observacionesEuskera
	 *            the observacionesEuskera to set
	 */
	public void setObservacionesEuskera(String observacionesEuskera) {
		this.observacionesEuskera = observacionesEuskera;
	}

	/**
	 * @return the fechaInforme
	 */

	@JsonDeserialize(using = JsonDateDeserializer.class)
	public Date getFechaInformeJus() {
		return fechaInformeJus;
	}

	/**
	 * @param fechaInforme
	 *            the fechaInforme to set
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public void setFechaInformeJus(Date fechaInformeJus) {
		this.fechaInformeJus = fechaInformeJus;
	}

	/**
	 * @return the idTecnicoResponsable
	 */
	public Integer getIdTecnicoResponsable() {
		return idTecnicoResponsable;
	}

	/**
	 * @param idTecnicoResponsable
	 *            the idTecnicoResponsable to set
	 */
	public void setIdTecnicoResponsable(Integer idTecnicoResponsable) {
		this.idTecnicoResponsable = idTecnicoResponsable;
	}

	/**
	 * @return the tecnicosResponsables
	 */
	public TecnicosResponsables getTecnicosResponsables() {
		return tecnicosResponsables;
	}

	/**
	 * @param tecnicosResponsables
	 *            the tecnicosResponsables to set
	 */
	public void setTecnicosResponsables(TecnicosResponsables tecnicosResponsables) {
		this.tecnicosResponsables = tecnicosResponsables;
	}

	/**
	 * @return the idResultado
	 */
	public Integer getIdResultado() {
		return idResultado;
	}

	/**
	 * @param idResultado
	 *            the idResultado to set
	 */
	public void setIdResultado(Integer idResultado) {
		this.idResultado = idResultado;
	}

	/**
	 * @return the tiposResultado
	 */
	public TiposResJus getTiposResJus() {
		return tiposResJus;
	}

	/**
	 * @param tiposResultado
	 *            the tiposResultado to set
	 */
	public void setTiposResJus(TiposResJus tiposResultado) {
		this.tiposResJus = tiposResultado;
	}

	/**
	 * @return the fechaRegistro
	 */
	public Date getFechaRegistro() {
		return fechaRegistro;
	}

	/**
	 * @param fechaRegistro
	 *            the fechaRegistro to set
	 */
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * @return the usuarioRegistro
	 */
	public String getUsuarioRegistro() {
		return usuarioRegistro;
	}

	/**
	 * @param usuarioRegistro
	 *            the usuarioRegistro to set
	 */
	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * @return the idMotivoIncumplimiento
	 */
	public Integer getIdMotivoIncumplimiento() {
		return idMotivoIncumplimiento;
	}

	/**
	 * @param idMotivoIncumplimiento
	 *            the idMotivoIncumplimiento to set
	 */
	public void setIdMotivoIncumplimiento(Integer idMotivoIncumplimiento) {
		this.idMotivoIncumplimiento = idMotivoIncumplimiento;
	}

	/**
	 * @return the motivosIncumplimiento
	 */
	public MotivosIncumplimiento getMotivosIncumplimiento() {
		return this.motivosIncumplimiento;
	}

	/**
	 * Method 'setMotivosDesestimacion'.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @return
	 */

	public void setMotivosIncumplimiento(MotivosIncumplimiento motivosIncumplimiento) {
		this.motivosIncumplimiento = motivosIncumplimiento;
	}

	/**
	 * @return the idConvocatoria
	 */
	public Integer getIdConvocatoria() {
		return idConvocatoria;
	}

	/**
	 * @param idConvocatoria
	 *            the idConvocatoria to set
	 */
	public void setIdConvocatoria(Integer idConvocatoria) {
		this.idConvocatoria = idConvocatoria;
	}

	/**
	 * @return the idExpediente
	 */
	public Integer getIdExpediente() {
		return idExpediente;
	}

	/**
	 * @param idExpediente
	 *            the idExpediente to set
	 */
	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * @return the bandera
	 */
	public Integer getBandera() {
		return bandera;
	}

	/**
	 * @param bandera
	 *            the bandera to set
	 */
	public void setBandera(Integer bandera) {
		this.bandera = bandera;
	}

	/**
	 * @return the fechaUltmodificacion
	 */
	public Date getFechaUltmodificacion() {
		return fechaUltmodificacion;
	}

	/**
	 * @param fechaUltmodificacion
	 *            the fechaUltmodificacion to set
	 */
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * @return the usuarioUltmodificacion
	 */
	public String getUsuarioUltmodificacion() {
		return usuarioUltmodificacion;
	}

	/**
	 * @param usuarioUltmodificacion
	 *            the usuarioUltmodificacion to set
	 */
	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * @return the fechaInformeStr
	 */

	public String getFechaInformeStr() {
		return fechaInformeStr;
	}

	/**
	 * @param fechaInformeStr
	 *            the fechaInformeStr to set
	 */

	public void setFechaInformeStr(String fechaInformeStr) {
		this.fechaInformeStr = fechaInformeStr;
	}

	/**
	 * Method 'getimporteJusAdmitidoMask'.
	 *
	 * @return BigDecimal
	 */

	public String getimporteJusAdmitidoMask() {
		return UtilDate.formatearMiles(importeJusAdmitido);
	}

	/**
	 * Method 'getimporteJusCalculadoMask'.
	 *
	 * @return BigDecimal
	 */

	public String getimporteJusCalculadoMask() {
		return UtilDate.formatearMiles(importeJusCalculado);

	}

	/**
	 * Method 'getsubvencionCalculadaMask'.
	 *
	 * @return BigDecimal
	 */

	public String getsubvencionResueltaMask1() {
		return UtilDate.formatearMiles(subvencionResuelta);

	}

	/**
	 * Method 'getsubvencionRJustificadaMask'.
	 *
	 * @return BigDecimal
	 */

	public String getsubvencionJustificadaMask1() {
		return UtilDate.formatearMiles(subvencionJustificada);

	}

	/**
	 * @return the rendimientoFinanciero
	 */
	public BigDecimal getRendimientoFinanciero() {
		return rendimientoFinanciero;
	}

	/**
	 * @param rendimientoFinanciero
	 *            the rendimientoFinanciero to set
	 */
	public void setRendimientoFinanciero(BigDecimal rendimientoFinanciero) {
		this.rendimientoFinanciero = rendimientoFinanciero;
	}

	/**
	 * @return the rendimientoFinancieroMask
	 */
	public String getRendimientoFinancieroMask() {
		return UtilDate.formatearMiles(rendimientoFinanciero);
	}
}
