package com.ejie.ab60.model.justificacion;

import java.util.ArrayList;
import java.util.List;

import com.ejie.ab60.model.MEC.Facturas;
import com.ejie.ab60.model.estudioTecnico.MotivosDenegacion;
import com.ejie.ab60.model.estudioTecnico.MotivosMinoracion;

/**
 * VActuacionesSubvencionables  
 * 
 *  
 */

public class RelFacActSubvencionables implements java.io.Serializable {

	private static final long serialVersionUID = 1L;

	// Clave compuesta
	private Integer idExpediente;
	private String folderNumber;
	private Integer idRelExpActSub;
	private String descripcionEs;
	private String descripcionEu;
	private Integer idActSub;

	private List<MotivosMinoracion> comboFacturaMinoracion = new ArrayList<MotivosMinoracion>();
	private List<MotivosDenegacion> comboFacturaDenegacion = new ArrayList<MotivosDenegacion>();

	private Facturas factura;

	/**
	 * Method 'RelFacActSubvencionables'.
	 * 
	 * 
	 * 
	 */
	public RelFacActSubvencionables() {
	}

	/**
	 * Method 'RelFacActSubvencionables'.
	 * 
	 * 
	 * 
	 */
	public RelFacActSubvencionables(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'VActuacionesSubvencionables'.
	 * 
	 * @param idExpediente
	 *            Integer
	 * @param folderNumber
	 *            String
	 * @param idRelExpActSub
	 *            Integer
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEu
	 *            String
	 * @param factura
	 *            Facturas
	 */
	public RelFacActSubvencionables(Integer idExpediente, String folderNumber, Integer idRelExpActSub,
			String descripcionEs, String descripcionEu, Integer idActSub, Facturas factura) {

		this.idExpediente = idExpediente;
		this.folderNumber = folderNumber;
		this.idRelExpActSub = idRelExpActSub;
		this.descripcionEs = descripcionEs;
		this.descripcionEu = descripcionEu;
		this.idActSub = idActSub;
		this.setFactura(factura);
	}

	/**
	 * Method 'VActuacionesSubvencionables'.
	 * 
	 * @param idRelExpActSub
	 *            Integer
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 */
	public RelFacActSubvencionables(Integer idRelExpActSub, String descripcionEs, String descripcionEu) {

		this.idRelExpActSub = idRelExpActSub;
		this.descripcionEs = descripcionEs;
		this.descripcionEu = descripcionEu;
	}

	/**
	 * Method 'getIdExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdExpediente() {
		return this.idExpediente;
	}

	/**
	 * Method 'setIdExpediente'.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return
	 */

	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'getFolderNumber'.
	 *
	 * @return String
	 */

	public String getFolderNumber() {
		return this.folderNumber;
	}

	/**
	 * Method 'setFolderNumber'.
	 *
	 * @param folderNumber
	 *            String
	 * @return
	 */

	public void setFolderNumber(String folderNumber) {
		this.folderNumber = folderNumber;
	}

	/**
	 * Method 'getIdRelExpActSub'.
	 *
	 * @return Integer
	 */

	public Integer getIdRelExpActSub() {
		return this.idRelExpActSub;
	}

	/**
	 * Method 'setIdRelExpActSub'.
	 *
	 * @param idRelExpActSub
	 *            Integer
	 * @return
	 */

	public void setIdRelExpActSub(Integer idRelExpActSub) {
		this.idRelExpActSub = idRelExpActSub;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionEs() {
		return this.descripcionEs;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionEs(String descripcionEs) {
		this.descripcionEs = descripcionEs;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEu() {
		return this.descripcionEu;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEu(String descripcionEu) {
		this.descripcionEu = descripcionEu;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		// Clave compuesta

		result.append("[ idExpediente: ").append(this.idExpediente).append(" ]");

		result.append(", [ folderNumber: ").append(this.folderNumber).append(" ]");

		result.append(", [ idActSub: ").append(this.idActSub).append(" ]");

		result.append(", [ idRelExpActSub: ").append(this.idRelExpActSub).append(" ]");

		result.append(", [ descripcionEs: ").append(this.descripcionEs).append(" ]");

		result.append(", [ descripcionEu: ").append(this.descripcionEu).append(" ]");
		result.append("}");
		return result.toString();
	}

	public Facturas getFactura() {
		return factura;
	}

	public void setFactura(Facturas factura) {
		this.factura = factura;
	}

	public Integer getIdActSub() {
		return idActSub;
	}

	public void setIdActSub(Integer idActSub) {
		this.idActSub = idActSub;
	}

	public List<MotivosMinoracion> getComboFacturaMinoracion() {
		return comboFacturaMinoracion;
	}

	public void setComboFacturaMinoracion(List<MotivosMinoracion> comboFacturaMinoracion) {
		this.comboFacturaMinoracion = comboFacturaMinoracion;
	}

	public List<MotivosDenegacion> getComboFacturaDenegacion() {
		return comboFacturaDenegacion;
	}

	public void setComboFacturaDenegacion(List<MotivosDenegacion> comboFacturaDenegacion) {
		this.comboFacturaDenegacion = comboFacturaDenegacion;
	}

}
