package com.ejie.ab60.model.justificacion;

import com.ejie.ab60.model.estudioTecnico.EstudioTecnico;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * TiposResJus  
 * 
 *  
 */

public class TiposResJus implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Long idResJustificacion;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<Justificacion> justificaciones = new ArrayList<Justificacion>();

	/**
	 * Method 'TiposResJus'.
	 */
	public TiposResJus() {
	}

	/**
	 * Method 'TiposResJus'.
	 * 
	 * @param idResJustificacion
	 *            Long
	 */
	public TiposResJus(Long idResJustificacion) {
		this.idResJustificacion = idResJustificacion;
	}

	public TiposResJus(String descripcionCastellano, String descripcionEuskera) {
		super();
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'TiposResJus'.
	 * 
	 * @param idResJustificacion
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public TiposResJus(Long idResJustificacion, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro) {

		this.idResJustificacion = idResJustificacion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'TiposResultado'.
	 * 
	 * @param idResultado
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * 
	 */
	public TiposResJus(Long idResultado, String descripcionCastellano, String descripcionEuskera) {
		this.idResJustificacion = idResultado;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'TiposResultado'.
	 * 
	 * @param idResultado
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioReguistro
	 *            String
	 * @param justificaciones
	 *            List<Justificacion>
	 */
	public TiposResJus(Long idResultado, String descripcionCastellano, String descripcionEuskera, Date fechaRegistro,
			String usuarioRegistro, List<Justificacion> justificaciones) {

		this.idResJustificacion = idResultado;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.justificaciones = justificaciones;
	}

	/**
	 * Method 'getIdResJustificacion'.
	 *
	 * @return Long
	 */

	public Long getIdResJustificacion() {
		return this.idResJustificacion;
	}

	/**
	 * Method 'setIdResJustificacion'.
	 *
	 * @param idResJustificacion
	 *            Long
	 * @return
	 */

	public void setIdResJustificacion(Long idResJustificacion) {
		this.idResJustificacion = idResJustificacion;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idResJustificacion: ").append(this.idResJustificacion).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
