package com.ejie.ab60.model.moduloContable;

import java.math.BigDecimal;
import java.util.Date;

import com.ejie.ab60.model.pagos.PagosConvocatoria;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Convocatorias  
 * 
 *  
 */

public class DocContables implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	// Clave compuesta
	private Integer idProcedimiento;
	private Integer idExpediente;
	private Integer idAplicacionPresupuestaria;
	private String expediente;
	private String conceptoResumido;
	private BigDecimal importePago;
	private String aplicacionPresupuestaria;
	private String ejercicioAplPre;
	private String agrupacion;
	private String gastoIngreso;
	private String seccion;
	private String servicio;
	private String centro;
	private String territorio;
	private String cac;
	private String sc;
	private String programa;
	private String partida;
	private String letraControl;
	private String ejercicioRefInt;
	private String anyoOrigen;
	private String numero;
	private String disponible;
	private String obligacion;
	private String terceroMostrar;
	private String tercero;
	private Date fechaDocumentoD;
	private String refIntD;
	private String refIntO;
	private String refIntDO;
	private String tipoDocumento;
	private String idDocumentoContable;
	private Date fechaDocumentoO;
	private Integer idPagoConvo;
	private BigDecimal importeSigPago;
	private Integer numeroPago;
	private Date fechaDocumentoDO;
	private Date fechaResolucion;

	// Tipo de documento contable que se va a generar.
	private Long idTipoDocCon;
	private String estado;

	private PagosConvocatoria pagosConvocatoria;

	private BigDecimal importeApl;
	private BigDecimal importeDisponibleApl;
	private Integer idAplicPresu;

	private Integer tipoRegistro;
	private String referenciaIntervencion;
	private String referenciaContratacion;
	private String numeroPlurianual;
	private String codigoSubvencion;
	private String ejercicioCompromiso1;
	private String ejercicioCompromiso2;
	private String ejercicioCompromiso3;
	private String ejercicioCompromiso4;
	private String importeCompromiso1;
	private String importeCompromiso2;
	private String importeCompromiso3;
	private String importeCompromiso4;
	private String importeCompromisoResto;
	private String ejercicioMaquetaTercero;
	private String numeroMaquetaTercero;

	private String tipoOperacionGastos;
	private Date fechaLimiteJustificacion;
	private String cuentaPCP;
	private String inmovilizado;
	private String numeroOrden;
	private String numeroFactura;
	private Date fechaFactura;
	private String ejercicioEndoso;
	private String numeroEndoso;
	private String otroPerceptor;
	private Date fechaVencimiento;
	private String codigoRetencion;
	private String baseRetencion;
	private String formaPago;
	private String cuentaFinanciera;
	private String ejercicioMaquetaTerceroOtroPerceptor;
	private String numeroMaquetaTerceroOtroPerceptor;
	private String codigoContrato;
	private Date fechaInicioPeriodoPago;
	private String registroContable;

	/**
	 * Method 'DocContables'.
	 */
	public DocContables() {
	}

	/**
	 * Method 'DocContables'.
	 * 
	 * @param idExpediente
	 *            Integer
	 * @param idProcedimiento
	 *            Integer
	 * @param expediente
	 *            String
	 * @param conceptoResumido
	 *            String
	 * @param importePago
	 *            BigDecimal
	 * @param aplicacionPresupuestaria
	 *            String
	 * @param referenciaIntervencion
	 *            Long
	 * @param tipoTercero
	 *            BigDecimal
	 * @param codigoTercero
	 *            BigDecimal
	 * @param versionTercero
	 *            BigDecimal
	 * @param fechaDocumentoD
	 *            Date
	 * @param refIntD
	 *            String
	 * @param idTipoDocCon
	 *            Long
	 */
	public DocContables(Integer idProcedimiento, Integer idExpediente, String expediente, String conceptoResumido,
			BigDecimal importePago, String aplicacionPresupuestaria, String ejercicioAplPre, String agrupacion,
			String gastoIngreso, String seccion, String servicio, String centro, String territorio, String cac,
			String sc, String programa, String partida, String letraControl, BigDecimal importeDisponible,
			Integer idAplicPresu, String ejercicioRefInt, String anyoOrigen, String numero, String disponible,
			String obligacion, String terceroMostrar, String tercero, Date fechaDocumentoD, Date fechaDocumentoDO,
			String refIntD, String refIntO, String tipoDocumento, String idDocContable, Date fechaDocumentoO,
			Integer idPagoConvo, BigDecimal importeSigPago, Date fechaResolucion) {
		this.idProcedimiento = idProcedimiento;
		this.idExpediente = idExpediente;
		this.expediente = expediente;
		this.conceptoResumido = conceptoResumido;
		this.importePago = importePago;
		this.aplicacionPresupuestaria = aplicacionPresupuestaria;
		this.ejercicioAplPre = ejercicioAplPre;
		this.agrupacion = agrupacion;
		this.gastoIngreso = gastoIngreso;
		this.seccion = seccion;
		this.servicio = servicio;
		this.centro = centro;
		this.territorio = territorio;
		this.cac = cac;
		this.sc = sc;
		this.programa = programa;
		this.partida = partida;
		this.letraControl = letraControl;
		this.importeDisponibleApl = importeDisponible;
		this.idAplicPresu = idAplicPresu;
		this.ejercicioRefInt = ejercicioRefInt;
		this.anyoOrigen = anyoOrigen;
		this.numero = numero;
		this.disponible = disponible;
		this.obligacion = obligacion;
		this.terceroMostrar = terceroMostrar;
		this.tercero = tercero;
		this.fechaDocumentoD = fechaDocumentoD;
		this.fechaDocumentoDO = fechaDocumentoDO;
		this.refIntD = refIntD;
		this.refIntO = refIntO;
		this.tipoDocumento = tipoDocumento;
		this.idDocumentoContable = idDocContable;
		this.fechaDocumentoO = fechaDocumentoO;
		this.idPagoConvo = idPagoConvo;
		this.importeSigPago = importeSigPago;
		this.fechaResolucion = fechaResolucion;
	}

	public DocContables(Integer idProcedimiento, Integer idExpediente, String expediente, String conceptoResumido,
			BigDecimal importePAgo, String aplicacionPresupuestaria, String ejercicioAplPre, String agrupacion,
			String gastoIngreso, String seccion, String servicio, String centro, String territorio, String cac,
			String sc, String programa, String partida, String letraControl, String ejercicioRefInt, String anyoOrigen,
			String numero, String disponible, String obligacion, String terceroMostrar, String tercero,
			Date fechaDocumentoD, Date fechaDocumentoDO, String refIntD, String refIntO, String tipoDocumento,
			String idDocContable, Date fechaDocumentoO, Integer idPagoConvo, BigDecimal importeSigPago,
			Integer numeroPago, Date fechaResolucion) {
		this.idProcedimiento = idProcedimiento;
		this.idExpediente = idExpediente;
		this.expediente = expediente;
		this.conceptoResumido = conceptoResumido;
		this.importePago = importePAgo;
		this.aplicacionPresupuestaria = aplicacionPresupuestaria;
		this.ejercicioAplPre = ejercicioAplPre;
		this.agrupacion = agrupacion;
		this.gastoIngreso = gastoIngreso;
		this.seccion = seccion;
		this.servicio = servicio;
		this.centro = centro;
		this.territorio = territorio;
		this.cac = cac;
		this.sc = sc;
		this.programa = programa;
		this.partida = partida;
		this.letraControl = letraControl;
		this.ejercicioRefInt = ejercicioRefInt;
		this.anyoOrigen = anyoOrigen;
		this.numero = numero;
		this.disponible = disponible;
		this.obligacion = obligacion;
		this.terceroMostrar = terceroMostrar;
		this.tercero = tercero;
		this.fechaDocumentoD = fechaDocumentoD;
		this.fechaDocumentoDO = fechaDocumentoDO;
		this.refIntD = refIntD;
		this.refIntO = refIntO;
		this.tipoDocumento = tipoDocumento;
		this.idDocumentoContable = idDocContable;
		this.fechaDocumentoO = fechaDocumentoO;
		this.idPagoConvo = idPagoConvo;
		this.importeSigPago = importeSigPago;
		this.numeroPago = numeroPago;
		this.fechaResolucion = fechaResolucion;
	}

	/**
	 * Method 'DocContables'.
	 * 
	 * @param idExpediente
	 *            Integer
	 * @param idProcedimiento
	 *            Integer
	 * @param expediente
	 *            String
	 * @param conceptoResumido
	 *            String
	 * @param importePAgo
	 *            BigDecimal
	 * @param aplicacionPresupuestaria
	 *            String
	 * @param referenciaIntervencion
	 *            Long
	 * @param tipoTercero
	 *            BigDecimal
	 * @param codigoTercero
	 *            BigDecimal
	 * @param versionTercero
	 *            BigDecimal
	 * @param fechaDocumentoD
	 *            Date
	 * @param refIntD
	 *            String
	 * @param idTipoDocCon
	 *            Long
	 */
	public DocContables(Integer idExpediente, Integer idProcedimiento, String expediente, String conceptoResumido,
			BigDecimal importePAgo, String aplicacionPresupuestaria, Date fechaDocumentoD, String refIntD,
			Long idTipoDocCon) {
		this.idExpediente = idExpediente;
		this.idProcedimiento = idProcedimiento;
		this.expediente = expediente;
		this.conceptoResumido = conceptoResumido;
		this.importePago = importePAgo;
		this.aplicacionPresupuestaria = aplicacionPresupuestaria;
		this.fechaDocumentoD = fechaDocumentoD;
		this.refIntD = refIntD;
		this.idTipoDocCon = idTipoDocCon;
	}

	// -----------------------------

	/**
	 * Method 'DocContables' para la vista V_EXP_INF_CONTABLE_D.
	 * 
	 * @param idProcedimiento
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param idDocumentoContable
	 *            String
	 * @param aplicacionPresupuestaria
	 *            Integer
	 * @param referenciaIntervencion
	 *            Integer
	 * @param refIntD
	 *            String
	 * @param tipoRegistro
	 *            String
	 * @param tipoDocumento
	 *            String
	 * @param expediente
	 *            String
	 * @param referenciaContratacion
	 *            String
	 * @param aplicacionPresupuestaria
	 *            String
	 * @param aplicacionPresupuestaria
	 *            String
	 * @param ejercicioAplPre
	 *            String
	 * @param agrupacion
	 *            String
	 * @param gastoIngreso
	 *            String
	 * @param seccion
	 *            String
	 * @param servicio
	 *            String
	 * @param centro
	 *            String
	 * @param territorio
	 *            String
	 * @param cac
	 *            String
	 * @param sc
	 *            String
	 * @param programa
	 *            String
	 * @param partida
	 *            String
	 * @param letraControl
	 *            String
	 * @param ejercicioRefInt
	 *            String
	 * @param anyoOrigen
	 *            String
	 * @param numero
	 *            String
	 * @param disponible
	 *            String
	 * @param numeroPlurianual
	 *            String
	 * @param codigoSubvencion
	 *            String
	 * @param conceptoResumido
	 *            String
	 * @param terceroMostrar
	 *            String
	 * @param tercero
	 *            String
	 * @param importe
	 *            BigDecimal
	 * @param ejercicioCompromiso1
	 *            String
	 * @param ejercicioCompromiso2
	 *            String
	 * @param ejercicioCompromiso3
	 *            String
	 * @param ejercicioCompromiso4
	 *            String
	 * @param importeCompromiso1
	 *            String
	 * @param importeCompromiso2
	 *            String
	 * @param importeCompromiso3
	 *            String
	 * @param importeCompromiso4
	 *            String
	 * @param importeCompromisoResto
	 *            String
	 * @param ejercicioMaquetaTercero
	 *            String
	 * @param numeroMaquetaTercero
	 *            String
	 * @param fechaResolucion
	 *            Date
	 * @param fechaDocumentoD
	 *            Date
	 * @param refIntD
	 *            String
	 */
	public DocContables(Integer idProcedimiento, Integer idExpediente, String idDocumentoContable,
			Integer idAplicacionPresupuestaria, String referenciaIntervencion, Integer tipoRegistro,
			String tipoDocumento, String expediente, String referenciaContratacion, String aplicacionPresupuestaria,
			String ejercicioAplPre, String agrupacion, String gastoIngreso, String seccion, String servicio,
			String centro, String territorio, String cac, String sc, String programa, String partida,
			String letraControl, String ejercicioRefInt, String anyoOrigen, String numero, String disponible,
			String numeroPlurianual, String codigoSubvencion, String conceptoResumido, String terceroMostrar,
			String tercero, BigDecimal importe, String ejercicioCompromiso1, String ejercicioCompromiso2,
			String ejercicioCompromiso3, String ejercicioCompromiso4, String importeCompromiso1,
			String importeCompromiso2, String importeCompromiso3, String importeCompromiso4,
			String importeCompromisoResto, String ejercicioMaquetaTercero, String numeroMaquetaTercero,
			Date fechaResolucion, Date fechaDocumentoD, String refIntD) {
		this.idProcedimiento = idProcedimiento;
		this.idExpediente = idExpediente;
		this.idDocumentoContable = idDocumentoContable;
		this.idAplicacionPresupuestaria = idAplicacionPresupuestaria; // ID_APLICACION_PRESUPUESTARIA
		this.referenciaIntervencion = referenciaIntervencion;
		this.tipoRegistro = tipoRegistro;
		this.tipoDocumento = tipoDocumento;
		this.expediente = expediente;
		this.referenciaContratacion = referenciaContratacion;
		this.aplicacionPresupuestaria = aplicacionPresupuestaria;
		this.ejercicioAplPre = ejercicioAplPre;
		this.agrupacion = agrupacion;
		this.gastoIngreso = gastoIngreso;
		this.seccion = seccion;
		this.servicio = servicio;
		this.centro = centro;
		this.territorio = territorio;
		this.cac = cac;
		this.sc = sc;
		this.programa = programa;
		this.partida = partida;
		this.letraControl = letraControl;
		this.ejercicioRefInt = ejercicioRefInt;
		this.anyoOrigen = anyoOrigen;
		this.numero = numero;
		this.disponible = disponible;
		this.numeroPlurianual = numeroPlurianual;
		this.codigoSubvencion = codigoSubvencion;
		this.conceptoResumido = conceptoResumido;
		this.terceroMostrar = terceroMostrar;
		this.tercero = tercero; // TERCER
		this.importePago = importe; // IMPORTE
		this.ejercicioCompromiso1 = ejercicioCompromiso1;
		this.ejercicioCompromiso2 = ejercicioCompromiso2;
		this.ejercicioCompromiso3 = ejercicioCompromiso3;
		this.ejercicioCompromiso4 = ejercicioCompromiso4;
		this.importeCompromiso1 = importeCompromiso1;
		this.importeCompromiso2 = importeCompromiso2;
		this.importeCompromiso3 = importeCompromiso3;
		this.importeCompromiso4 = importeCompromiso4;
		this.importeCompromisoResto = importeCompromisoResto;
		this.ejercicioMaquetaTercero = ejercicioMaquetaTercero;
		this.numeroMaquetaTercero = numeroMaquetaTercero;
		this.fechaResolucion = fechaResolucion;
		this.fechaDocumentoD = fechaDocumentoD;
		this.refIntD = refIntD; // REF_INT_D
	}

	/**
	 * Method 'DocContables' para la vista V_EXP_INF_CONTABLE_O.
	 * 
	 * @param tipoRegistro
	 *            Integer
	 * @param tipoDocumento
	 *            String
	 * @param expediente
	 *            String
	 * @param tipoOperacionGastos
	 *            String
	 * @param fechaLimiteJustificacion
	 * @param ejercicioAplPre
	 *            String
	 * @param agrupacion
	 *            String
	 * @param gastoIngreso
	 *            String
	 * @param seccion
	 *            String
	 * @param servicio
	 *            String
	 * @param centro
	 *            String
	 * @param territorio
	 *            String
	 * @param cac
	 *            String
	 * @param sc
	 *            String
	 * @param programa
	 *            String
	 * @param partida
	 *            String
	 * @param letraControl
	 *            String
	 * @param cuentaPCP
	 *            String
	 * @param inmovilizado
	 *            String
	 * @param ejercicioRefInt
	 *            String
	 * @param anyoOrigen
	 *            String
	 * @param numero
	 *            String
	 * @param disponible
	 *            String
	 * @param obligacion
	 *            String
	 * @param numeroOrden
	 *            String
	 * @param numeroPlurianual
	 *            String
	 * @param codigoSubvencion
	 *            String
	 * @param importeCompromisoResto
	 *            String
	 * @param numeroFactura
	 *            String
	 * @param fechaFactura
	 *            Date
	 * @param conceptoResumido
	 *            String
	 * @param tercero
	 *            String
	 * @param importePago
	 *            String
	 * @param ejercicioEndoso
	 *            String
	 * @param numeroEndoso
	 *            String
	 * @param otroPerceptor
	 *            String
	 * @param fechaVencimiento
	 *            Date
	 * @param codigoRetencion
	 *            String
	 * @param baseRetencion
	 *            String
	 * @param formaPago
	 *            String
	 * @param cuentaFinanciera
	 *            String
	 * @param ejercicioMaquetaTercero
	 *            String
	 * @param numeroMaquetaTercero
	 *            String
	 * @param ejercicioMaquetaTerceroOtroPerceptor
	 *            String
	 * @param numeroMaquetaTerceroOtroPerceptor
	 *            String
	 * @param fechaInicioPeriodoPago
	 *            Date
	 * @param codigoContrato
	 *            String
	 * @param registroContable
	 *            String
	 * @param fechaResolucion
	 *            Date
	 */
	public DocContables(Integer tipoRegistro, String tipoDocumento, String expediente, String tipoOperacionGastos,
			Date fechaLimiteJustificacion, String ejercicioAplPre, String agrupacion, String gastoIngreso,
			String seccion, String servicio, String centro, String territorio, String cac, String sc, String programa,
			String partida, String letraControl, String cuentaPCP, String inmovilizado, String ejercicioRefInt,
			String anyoOrigen, String numero, String disponible, String obligacion, String numeroOrden,
			String numeroPlurianual, String codigoSubvencion, String importeCompromisoResto, String numeroFactura,
			Date fechaFactura, String conceptoResumido, String tercero, BigDecimal importePago, String ejercicioEndoso,
			String numeroEndoso, String otroPerceptor, Date fechaVencimiento, String codigoRetencion,
			String baseRetencion, String formaPago, String cuentaFinanciera, String ejercicioMaquetaTercero,
			String numeroMaquetaTercero, String ejercicioMaquetaTerceroOtroPerceptor,
			String numeroMaquetaTerceroOtroPerceptor, Date fechaInicioPeriodoPago, String codigoContrato,
			String registroContable, Date fechaResolucion) {
		this.tipoRegistro = tipoRegistro;
		this.tipoDocumento = tipoDocumento;
		this.expediente = expediente;
		this.tipoOperacionGastos = tipoOperacionGastos;
		this.fechaLimiteJustificacion = fechaLimiteJustificacion;
		this.ejercicioAplPre = ejercicioAplPre;
		this.agrupacion = agrupacion;
		this.gastoIngreso = gastoIngreso;
		this.seccion = seccion;
		this.servicio = servicio;
		this.centro = centro;
		this.territorio = territorio;
		this.cac = cac;
		this.sc = sc;
		this.programa = programa;
		this.partida = partida;
		this.letraControl = letraControl;
		this.cuentaPCP = cuentaPCP;
		this.inmovilizado = inmovilizado;
		this.ejercicioRefInt = ejercicioRefInt;
		this.anyoOrigen = anyoOrigen;
		this.numero = numero;
		this.disponible = disponible;
		this.obligacion = obligacion;
		this.numeroOrden = numeroOrden;
		this.numeroPlurianual = numeroPlurianual;
		this.codigoSubvencion = codigoSubvencion;
		this.importeCompromisoResto = importeCompromisoResto;
		this.numeroFactura = numeroFactura;
		this.fechaFactura = fechaFactura;
		this.conceptoResumido = conceptoResumido;
		this.tercero = tercero;
		this.importePago = importePago;
		this.ejercicioEndoso = ejercicioEndoso;
		this.numeroEndoso = numeroEndoso;
		this.otroPerceptor = otroPerceptor;
		this.fechaVencimiento = fechaVencimiento;
		this.codigoRetencion = codigoRetencion;
		this.baseRetencion = baseRetencion;
		this.formaPago = formaPago;
		this.cuentaFinanciera = cuentaFinanciera;
		this.ejercicioMaquetaTercero = ejercicioMaquetaTercero;
		this.numeroMaquetaTercero = numeroMaquetaTercero;
		this.ejercicioMaquetaTerceroOtroPerceptor = ejercicioMaquetaTerceroOtroPerceptor;
		this.numeroMaquetaTerceroOtroPerceptor = numeroMaquetaTerceroOtroPerceptor;
		this.fechaInicioPeriodoPago = fechaInicioPeriodoPago;
		this.codigoContrato = codigoContrato;
		this.registroContable = registroContable;
		this.fechaResolucion = fechaResolucion;
	}

	/**
	 * Method 'DocContables' para la vista V_EXP_INF_CONTABLE_DO.
	 * 
	 * @param idProcedimiento
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param idDocumentoContable
	 *            String
	 * @param idAplicacionPresupuestaria
	 *            Integer
	 * @param aplicacionPresupuestaria
	 *            String
	 * @param referenciaIntervencion
	 *            Integer
	 * @param tipoRegistro
	 *            Integer
	 * @param tipoDocumento
	 *            String
	 * @param expediente
	 *            String
	 * @param referenciaContratacion
	 *            String
	 * @param tipoOperacionGastos
	 *            String
	 * @param fechaLimiteJustificacion
	 *            Date
	 * @param ejercicioAplPre
	 *            String
	 * @param agrupacion
	 *            String
	 * @param gastoIngreso
	 *            String
	 * @param seccion
	 *            String
	 * @param servicio
	 *            String
	 * @param centro
	 *            String
	 * @param territorio
	 *            String
	 * @param cac
	 *            String
	 * @param sc
	 *            String
	 * @param programa
	 *            String
	 * @param partida
	 *            String
	 * @param letraControl
	 *            String
	 * @param cuentaPCP
	 *            String
	 * @param inmovilizado
	 *            String
	 * @param ejercicioRefInt
	 *            String
	 * @param anyoOrigen
	 *            String
	 * @param numero
	 *            String
	 * @param disponible
	 *            String
	 * @param obligacion
	 *            String
	 * @param numeroOrden
	 *            String
	 * @param numeroPlurianual
	 *            String
	 * @param codigoSubvencion
	 *            String
	 * @param importeCompromisoResto
	 *            String
	 * @param numeroFactura
	 *            String
	 * @param fechaFactura
	 *            Date
	 * @param conceptoResumido
	 *            String
	 * @param tercero
	 *            String
	 * @param terceroMostrar
	 *            String
	 * @param importe
	 *            BigDecimal
	 * @param ejercicioEndoso
	 *            String
	 * @param numeroEndoso
	 *            String
	 * @param otroPerceptor
	 *            String
	 * @param fechaVencimiento
	 *            Date
	 * @param codigoRetencion
	 *            String
	 * @param baseRetencion
	 *            String
	 * @param formaPago
	 *            String
	 * @param cuentaFinanciera
	 *            String
	 * @param ejercicioMaquetaTercero
	 *            String
	 * @param numeroMaquetaTercero
	 *            String
	 * @param ejercicioMaquetaTerceroOtroPerceptor
	 *            String
	 * @param numeroMaquetaTerceroOtroPerceptor
	 *            String
	 * @param codigoContrato
	 *            String
	 * @param fechaInicioPeriodoPago
	 *            Date
	 * @param registroContable
	 *            String
	 * @param fechaResolucion
	 *            Date
	 * @param fechaDocumentoDO
	 *            Date
	 */
	public DocContables(Integer idProcedimiento, Integer idExpediente, String idDocumentoContable,
			Integer idAplicacionPresupuestaria, String aplicacionPresupuestaria, String referenciaIntervencion,
			Integer tipoRegistro, String tipoDocumento, String expediente, String referenciaContratacion,
			String tipoOperacionGastos, Date fechaLimiteJustificacion, String ejercicioAplPre, String agrupacion,
			String gastoIngreso, String seccion, String servicio, String centro, String territorio, String cac,
			String sc, String programa, String partida, String letraControl, String cuentaPCP, String inmovilizado,
			String ejercicioRefInt, String anyoOrigen, String numero, String disponible, String obligacion,
			String numeroOrden, String numeroPlurianual, String codigoSubvencion, String importeCompromisoResto,
			String numeroFactura, Date fechaFactura, String conceptoResumido, String tercero, String terceroMostrar,
			BigDecimal importe, String ejercicioEndoso, String numeroEndoso, String otroPerceptor,
			Date fechaVencimiento, String codigoRetencion, String baseRetencion, String formaPago,
			String cuentaFinanciera, String ejercicioMaquetaTercero, String numeroMaquetaTercero,
			String ejercicioMaquetaTerceroOtroPerceptor, String numeroMaquetaTerceroOtroPerceptor,
			String codigoContrato, Date fechaInicioPeriodoPago, String registroContable, Date fechaResolucion,
			Date fechaDocumentoDO) {
		this.idProcedimiento = idProcedimiento;
		this.idExpediente = idExpediente;
		this.idDocumentoContable = idDocumentoContable;
		this.idAplicacionPresupuestaria = idAplicacionPresupuestaria; // ID_APLICACION_PRESUPUESTARIA
		this.aplicacionPresupuestaria = aplicacionPresupuestaria;
		this.refIntDO = referenciaIntervencion; // ID_REFERENCIA_INTERVENCION

		this.tipoRegistro = tipoRegistro;
		this.tipoDocumento = tipoDocumento;
		this.expediente = expediente;
		this.referenciaContratacion = referenciaContratacion;
		this.tipoOperacionGastos = tipoOperacionGastos;
		this.fechaLimiteJustificacion = fechaLimiteJustificacion;

		this.ejercicioAplPre = ejercicioAplPre;
		this.agrupacion = agrupacion;
		this.gastoIngreso = gastoIngreso;
		this.seccion = seccion;
		this.servicio = servicio;
		this.centro = centro;
		this.territorio = territorio;
		this.cac = cac;
		this.sc = sc;
		this.programa = programa;
		this.partida = partida;
		this.letraControl = letraControl;
		this.cuentaPCP = cuentaPCP;
		this.inmovilizado = inmovilizado;

		this.ejercicioRefInt = ejercicioRefInt;
		this.anyoOrigen = anyoOrigen;
		this.numero = numero;
		this.disponible = disponible;
		this.obligacion = obligacion;
		this.numeroOrden = numeroOrden;
		this.numeroPlurianual = numeroPlurianual;
		this.codigoSubvencion = codigoSubvencion;
		this.importeCompromisoResto = importeCompromisoResto;
		this.numeroFactura = numeroFactura;
		this.fechaFactura = fechaFactura;

		this.conceptoResumido = conceptoResumido;
		this.tercero = tercero;
		this.terceroMostrar = terceroMostrar;
		this.importePago = importe;

		this.ejercicioEndoso = ejercicioEndoso;
		this.numeroEndoso = numeroEndoso;
		this.otroPerceptor = otroPerceptor;
		this.fechaVencimiento = fechaVencimiento;
		this.codigoRetencion = codigoRetencion;
		this.baseRetencion = baseRetencion;
		this.formaPago = formaPago;
		this.cuentaFinanciera = cuentaFinanciera;

		this.ejercicioMaquetaTercero = ejercicioMaquetaTercero;
		this.numeroMaquetaTercero = numeroMaquetaTercero;

		this.ejercicioMaquetaTerceroOtroPerceptor = ejercicioMaquetaTerceroOtroPerceptor;
		this.numeroMaquetaTerceroOtroPerceptor = numeroMaquetaTerceroOtroPerceptor;
		this.codigoContrato = codigoContrato;
		this.fechaInicioPeriodoPago = fechaInicioPeriodoPago;
		this.registroContable = registroContable;
		this.fechaResolucion = fechaResolucion;
		this.fechaDocumentoDO = fechaDocumentoDO;
	}

	// -----------------------------

	/**
	 * Method 'getIdExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdExpediente() {
		return this.idExpediente;
	}

	/**
	 * Method 'setIdExpediente'.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return
	 */

	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'getIdProcedimiento'.
	 *
	 * @return Integer
	 */

	public Integer getIdProcedimiento() {
		return this.idProcedimiento;
	}

	/**
	 * Method 'setIdProcedimiento'.
	 *
	 * @param idProcedimiento
	 *            Integer
	 * @return
	 */

	public void setIdProcedimiento(Integer idProcedimiento) {
		this.idProcedimiento = idProcedimiento;
	}

	/**
	 * @return the idAplicacionPresupuestaria
	 */
	public Integer getIdAplicacionPresupuestaria() {
		return this.idAplicacionPresupuestaria;
	}

	/**
	 * @param idAplicacionPresupuestaria
	 *            the idAplicacionPresupuestaria to set
	 */
	public void setIdAplicacionPresupuestaria(Integer idAplicacionPresupuestaria) {
		this.idAplicacionPresupuestaria = idAplicacionPresupuestaria;
	}

	/**
	 * Method 'getExpediente'.
	 *
	 * @return String
	 */

	public String getExpediente() {
		return this.expediente;
	}

	/**
	 * Method 'setExpediente'.
	 *
	 * @param expediente
	 *            String
	 * @return
	 */

	public void setExpediente(String expediente) {
		this.expediente = expediente;
	}

	/**
	 * Method 'getConceptoResumido'.
	 *
	 * @return String
	 */

	public String getConceptoResumido() {
		return this.conceptoResumido;
	}

	/**
	 * Method 'setConceptoResumido'.
	 *
	 * @param conceptoResumido
	 *            String
	 * @return
	 */

	public void setConceptoResumido(String conceptoResumido) {
		this.conceptoResumido = conceptoResumido;
	}

	/**
	 * Method 'getImportePago'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImportePago() {
		return this.importePago;
	}

	/**
	 * Method 'setImportePago'.
	 *
	 * @param importePAgo
	 *            BigDecimal
	 * @return
	 */

	public void setImportePago(BigDecimal importePAgo) {
		this.importePago = importePAgo;
	}

	/**
	 * Method 'getAplicacionPresupuestaria'.
	 *
	 * @return String
	 */

	public String getAplicacionPresupuestaria() {
		return this.aplicacionPresupuestaria;
	}

	/**
	 * Method 'setAplicacionPresupuestaria'.
	 *
	 * @param aplicacionPresupuestaria
	 *            String
	 * @return
	 */

	public void setAplicacionPresupuestaria(String aplicacionPresupuestaria) {
		this.aplicacionPresupuestaria = aplicacionPresupuestaria;
	}

	/**
	 * Method 'getReferenciaIntervencion'.
	 *
	 * @return Long
	 */

	/**
	 * @return the terceroMostrar
	 */
	public String getTerceroMostrar() {
		return this.terceroMostrar;
	}

	/**
	 * @param terceroMostrar
	 *            the terceroMostrar to set
	 */
	public void setTerceroMostrar(String terceroMostrar) {
		this.terceroMostrar = terceroMostrar;
	}

	/**
	 * Method 'getFechaDocumentoD'.
	 *
	 * @return Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaDocumentoD() {
		return this.fechaDocumentoD;
	}

	/**
	 * Method 'setFechaDocumentoD'.
	 *
	 * @param fechaDocumentoD
	 *            Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaDocumentoD(Date fechaDocumentoD) {
		this.fechaDocumentoD = fechaDocumentoD;
	}

	/**
	 * Method 'getRefIntD'.
	 *
	 * @return String
	 */

	public String getRefIntD() {
		return this.refIntD;
	}

	/**
	 * Method 'setRefIntD'.
	 *
	 * @param refIntD
	 *            String
	 * @return
	 */

	public void setRefIntD(String refIntD) {
		this.refIntD = refIntD;
	}

	/**
	 * @return the pagosConvocatoria
	 */
	public PagosConvocatoria getPagosConvocatoria() {
		return this.pagosConvocatoria;
	}

	/**
	 * @param pagosConvocatoria
	 *            the pagosConvocatoria to set
	 */
	public void setPagosConvocatoria(PagosConvocatoria pagosConvocatoria) {
		this.pagosConvocatoria = pagosConvocatoria;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		// Clave compuesta

		result.append("[ idExpediente: ").append(this.idExpediente).append(" ]");

		result.append(", [ idProcedimiento: ").append(this.idProcedimiento).append(" ]");

		result.append(", [ expediente: ").append(this.expediente).append(" ]");

		result.append(", [ conceptoResumido: ").append(this.conceptoResumido).append(" ]");

		result.append(", [ importePAgo: ").append(this.importePago).append(" ]");

		result.append(", [ aplicacionPresupuestaria: ").append(this.aplicacionPresupuestaria).append(" ]");

		result.append(", [ fechaDocumentoD: ").append(this.fechaDocumentoD).append(" ]");

		result.append(", [ refIntD: ").append(this.refIntD).append(" ]");

		result.append(", [ idTipoDocCon: ").append(this.idTipoDocCon).append(" ]");

		result.append(", [ estado: ").append(this.estado).append(" ]");
		result.append("}");
		return result.toString();
	}

	public Long getIdTipoDocCon() {
		return this.idTipoDocCon;
	}

	public void setIdTipoDocCon(Long idTipoDocCon) {
		this.idTipoDocCon = idTipoDocCon;
	}

	public String getEstado() {
		return this.estado;
	}

	public void setEstado(String estado) {
		this.estado = estado;
	}

	/**
	 * @return the ejercicioAplPre
	 */
	public String getEjercicioAplPre() {
		return this.ejercicioAplPre;
	}

	/**
	 * @param ejercicioAplPre
	 *            the ejercicioAplPre to set
	 */
	public void setEjercicioAplPre(String ejercicioAplPre) {
		this.ejercicioAplPre = ejercicioAplPre;
	}

	/**
	 * @return the agrupacion
	 */
	public String getAgrupacion() {
		return this.agrupacion;
	}

	/**
	 * @param agrupacion
	 *            the agrupacion to set
	 */
	public void setAgrupacion(String agrupacion) {
		this.agrupacion = agrupacion;
	}

	/**
	 * @return the gastoIngreso
	 */
	public String getGastoIngreso() {
		return this.gastoIngreso;
	}

	/**
	 * @param gastoIngreso
	 *            the gastoIngreso to set
	 */
	public void setGastoIngreso(String gastoIngreso) {
		this.gastoIngreso = gastoIngreso;
	}

	/**
	 * @return the seccion
	 */
	public String getSeccion() {
		return this.seccion;
	}

	/**
	 * @param seccion
	 *            the seccion to set
	 */
	public void setSeccion(String seccion) {
		this.seccion = seccion;
	}

	/**
	 * @return the servicio
	 */
	public String getServicio() {
		return this.servicio;
	}

	/**
	 * @param servicio
	 *            the servicio to set
	 */
	public void setServicio(String servicio) {
		this.servicio = servicio;
	}

	/**
	 * @return the centro
	 */
	public String getCentro() {
		return this.centro;
	}

	/**
	 * @param centro
	 *            the centro to set
	 */
	public void setCentro(String centro) {
		this.centro = centro;
	}

	/**
	 * @return the territorio
	 */
	public String getTerritorio() {
		return this.territorio;
	}

	/**
	 * @param territorio
	 *            the territorio to set
	 */
	public void setTerritorio(String territorio) {
		this.territorio = territorio;
	}

	/**
	 * @return the cac
	 */
	public String getCac() {
		return this.cac;
	}

	/**
	 * @param cac
	 *            the cac to set
	 */
	public void setCac(String cac) {
		this.cac = cac;
	}

	/**
	 * @return the sc
	 */
	public String getSc() {
		return this.sc;
	}

	/**
	 * @param sc
	 *            the sc to set
	 */
	public void setSc(String sc) {
		this.sc = sc;
	}

	/**
	 * @return the programa
	 */
	public String getPrograma() {
		return this.programa;
	}

	/**
	 * @param programa
	 *            the programa to set
	 */
	public void setPrograma(String programa) {
		this.programa = programa;
	}

	/**
	 * @return the partida
	 */
	public String getPartida() {
		return this.partida;
	}

	/**
	 * @param partida
	 *            the partida to set
	 */
	public void setPartida(String partida) {
		this.partida = partida;
	}

	/**
	 * @return the letraControl
	 */
	public String getLetraControl() {
		return this.letraControl;
	}

	/**
	 * @param letraControl
	 *            the letraControl to set
	 */
	public void setLetraControl(String letraControl) {
		this.letraControl = letraControl;
	}

	/**
	 * @return the ejercicioRefInt
	 */
	public String getEjercicioRefInt() {
		return this.ejercicioRefInt;
	}

	/**
	 * @param ejercicioRefInt
	 *            the ejercicioRefInt to set
	 */
	public void setEjercicioRefInt(String ejercicioRefInt) {
		this.ejercicioRefInt = ejercicioRefInt;
	}

	/**
	 * @return the anyoOrigen
	 */
	public String getAnyoOrigen() {
		return this.anyoOrigen;
	}

	/**
	 * @param anyoOrigen
	 *            the anyoOrigen to set
	 */
	public void setAnyoOrigen(String anyoOrigen) {
		this.anyoOrigen = anyoOrigen;
	}

	/**
	 * @return the numero
	 */
	public String getNumero() {
		return this.numero;
	}

	/**
	 * @param numero
	 *            the numero to set
	 */
	public void setNumero(String numero) {
		this.numero = numero;
	}

	/**
	 * @return the disponible
	 */
	public String getDisponible() {
		return this.disponible;
	}

	/**
	 * @param disponible
	 *            the disponible to set
	 */
	public void setDisponible(String disponible) {
		this.disponible = disponible;
	}

	public String getObligacion() {
		return this.obligacion;
	}

	public void setObligacion(String obligacion) {
		this.obligacion = obligacion;
	}

	/**
	 * @return the tercero
	 */
	public String getTercero() {
		return this.tercero;
	}

	/**
	 * @param tercero
	 *            the tercero to set
	 */
	public void setTercero(String tercero) {
		this.tercero = tercero;
	}

	/**
	 * @return the refIntO
	 */
	public String getRefIntO() {
		return this.refIntO;
	}

	/**
	 * @param refIntO
	 *            the refIntO to set
	 */
	public void setRefIntO(String refIntO) {
		this.refIntO = refIntO;
	}

	/**
	 * @return the refIntDO
	 */
	public String getRefIntDO() {
		return this.refIntDO;
	}

	/**
	 * @param refIntDO
	 *            the refIntDO to set
	 */
	public void setRefIntDO(String refIntDO) {
		this.refIntDO = refIntDO;
	}

	/**
	 * @return the tipoDocumento
	 */
	public String getTipoDocumento() {
		return this.tipoDocumento;
	}

	/**
	 * @param tipoDocumento
	 *            the tipoDocumento to set
	 */
	public void setTipoDocumento(String tipoDocumento) {
		this.tipoDocumento = tipoDocumento;
	}

	/**
	 * @return the idDocumentoContable
	 */
	public String getIdDocumentoContable() {
		return this.idDocumentoContable;
	}

	/**
	 * @param idDocumentoContable
	 *            the idDocumentoContable to set
	 */
	public void setIdDocumentoContable(String idDocumentoContable) {
		this.idDocumentoContable = idDocumentoContable;
	}

	/**
	 * @return the fechaDocumentoO
	 */
	public Date getFechaDocumentoO() {
		return this.fechaDocumentoO;
	}

	/**
	 * @param fechaDocumentoO
	 *            the fechaDocumentoO to set
	 */
	public void setFechaDocumentoO(Date fechaDocumentoO) {
		this.fechaDocumentoO = fechaDocumentoO;
	}

	/**
	 * @return the idPagoConvo
	 */
	public Integer getIdPagoConvo() {
		return this.idPagoConvo;
	}

	/**
	 * @param idPagoConvo
	 *            the idPagoConvo to set
	 */
	public void setIdPagoConvo(Integer idPagoConvo) {
		this.idPagoConvo = idPagoConvo;
	}

	/**
	 * @return the importeSigPago
	 */
	public BigDecimal getImporteSigPago() {
		return this.importeSigPago;
	}

	/**
	 * @param importeSigPago
	 *            the importeSigPago to set
	 */
	public void setImporteSigPago(BigDecimal importeSigPago) {
		this.importeSigPago = importeSigPago;
	}

	/**
	 * @return the numeroPago
	 */
	public Integer getNumeroPago() {
		return this.numeroPago;
	}

	/**
	 * @param numeroPago
	 *            the numeroPago to set
	 */
	public void setNumeroPago(Integer numeroPago) {
		this.numeroPago = numeroPago;
	}

	/**
	 * @return the importeApl
	 */
	public BigDecimal getImporteApl() {
		return this.importeApl;
	}

	/**
	 * @param importeApl
	 *            the importeApl to set
	 */
	public void setImporteApl(BigDecimal importeApl) {
		this.importeApl = importeApl;
	}

	/**
	 * @return the importeDisponibleApl
	 */
	public BigDecimal getImporteDisponibleApl() {
		return this.importeDisponibleApl;
	}

	/**
	 * @param importeDisponibleApl
	 *            the importeDisponibleApl to set
	 */
	public void setImporteDisponibleApl(BigDecimal importeDisponibleApl) {
		this.importeDisponibleApl = importeDisponibleApl;
	}

	/**
	 * @return the idAplicPresu
	 */
	public Integer getIdAplicPresu() {
		return this.idAplicPresu;
	}

	/**
	 * @param idAplicPresu
	 *            the idAplicPresu to set
	 */
	public void setIdAplicPresu(Integer idAplicPresu) {
		this.idAplicPresu = idAplicPresu;
	}

	/**
	 * Method 'getFechaDocumentoDO'.
	 *
	 * @return Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaDocumentoDO() {
		return this.fechaDocumentoDO;
	}

	/**
	 * Method 'setFechaDocumentoDO'.
	 *
	 * @param fechaDocumentoDO
	 *            Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaDocumentoDO(Date fechaDocumentoDO) {
		this.fechaDocumentoDO = fechaDocumentoDO;
	}

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaResolucion() {
		return this.fechaResolucion;
	}

	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaResolucion(Date fechaResolucion) {
		this.fechaResolucion = fechaResolucion;
	}

	/**
	 * @return the tipoRegistro
	 */
	public Integer getTipoRegistro() {
		return this.tipoRegistro;
	}

	/**
	 * @param tipoRegistro
	 *            the tipoRegistro to set
	 */
	public void setTipoRegistro(Integer tipoRegistro) {
		this.tipoRegistro = tipoRegistro;
	}

	/**
	 * @return the referenciaContratacion
	 */
	public String getReferenciaContratacion() {
		return this.referenciaContratacion;
	}

	/**
	 * @param referenciaContratacion
	 *            the referenciaContratacion to set
	 */
	public void setReferenciaContratacion(String referenciaContratacion) {
		this.referenciaContratacion = referenciaContratacion;
	}

	/**
	 * @return the numeroPlurianual
	 */
	public String getNumeroPlurianual() {
		return this.numeroPlurianual;
	}

	/**
	 * @param numeroPlurianual
	 *            the numeroPlurianual to set
	 */
	public void setNumeroPlurianual(String numeroPlurianual) {
		this.numeroPlurianual = numeroPlurianual;
	}

	/**
	 * @return the codigoSubvencion
	 */
	public String getCodigoSubvencion() {
		return this.codigoSubvencion;
	}

	/**
	 * @param codigoSubvencion
	 *            the codigoSubvencion to set
	 */
	public void setCodigoSubvencion(String codigoSubvencion) {
		this.codigoSubvencion = codigoSubvencion;
	}

	/**
	 * @return the ejercicioCompromiso1
	 */
	public String getEjercicioCompromiso1() {
		return this.ejercicioCompromiso1;
	}

	/**
	 * @param ejercicioCompromiso1
	 *            the ejercicioCompromiso1 to set
	 */
	public void setEjercicioCompromiso1(String ejercicioCompromiso1) {
		this.ejercicioCompromiso1 = ejercicioCompromiso1;
	}

	/**
	 * @return the ejercicioCompromiso2
	 */
	public String getEjercicioCompromiso2() {
		return this.ejercicioCompromiso2;
	}

	/**
	 * @param ejercicioCompromiso2
	 *            the ejercicioCompromiso2 to set
	 */
	public void setEjercicioCompromiso2(String ejercicioCompromiso2) {
		this.ejercicioCompromiso2 = ejercicioCompromiso2;
	}

	/**
	 * @return the ejercicioCompromiso3
	 */
	public String getEjercicioCompromiso3() {
		return this.ejercicioCompromiso3;
	}

	/**
	 * @param ejercicioCompromiso3
	 *            the ejercicioCompromiso3 to set
	 */
	public void setEjercicioCompromiso3(String ejercicioCompromiso3) {
		this.ejercicioCompromiso3 = ejercicioCompromiso3;
	}

	/**
	 * @return the ejercicioCompromiso4
	 */
	public String getEjercicioCompromiso4() {
		return this.ejercicioCompromiso4;
	}

	/**
	 * @param ejercicioCompromiso4
	 *            the ejercicioCompromiso4 to set
	 */
	public void setEjercicioCompromiso4(String ejercicioCompromiso4) {
		this.ejercicioCompromiso4 = ejercicioCompromiso4;
	}

	/**
	 * @return the importeCompromiso1
	 */
	public String getImporteCompromiso1() {
		return this.importeCompromiso1;
	}

	/**
	 * @param importeCompromiso1
	 *            the importeCompromiso1 to set
	 */
	public void setImporteCompromiso1(String importeCompromiso1) {
		this.importeCompromiso1 = importeCompromiso1;
	}

	/**
	 * @return the importeCompromiso2
	 */
	public String getImporteCompromiso2() {
		return this.importeCompromiso2;
	}

	/**
	 * @param importeCompromiso2
	 *            the importeCompromiso2 to set
	 */
	public void setImporteCompromiso2(String importeCompromiso2) {
		this.importeCompromiso2 = importeCompromiso2;
	}

	/**
	 * @return the importeCompromiso3
	 */
	public String getImporteCompromiso3() {
		return this.importeCompromiso3;
	}

	/**
	 * @param importeCompromiso3
	 *            the importeCompromiso3 to set
	 */
	public void setImporteCompromiso3(String importeCompromiso3) {
		this.importeCompromiso3 = importeCompromiso3;
	}

	/**
	 * @return the importeCompromiso4
	 */
	public String getImporteCompromiso4() {
		return this.importeCompromiso4;
	}

	/**
	 * @param importeCompromiso4
	 *            the importeCompromiso4 to set
	 */
	public void setImporteCompromiso4(String importeCompromiso4) {
		this.importeCompromiso4 = importeCompromiso4;
	}

	/**
	 * @return the importeCompromisoResto
	 */
	public String getImporteCompromisoResto() {
		return this.importeCompromisoResto;
	}

	/**
	 * @param importeCompromisoResto
	 *            the importeCompromisoResto to set
	 */
	public void setImporteCompromisoResto(String importeCompromisoResto) {
		this.importeCompromisoResto = importeCompromisoResto;
	}

	/**
	 * @return the ejercicioMaquetaTercero
	 */
	public String getEjercicioMaquetaTercero() {
		return this.ejercicioMaquetaTercero;
	}

	/**
	 * @param ejercicioMaquetaTercero
	 *            the ejercicioMaquetaTercero to set
	 */
	public void setEjercicioMaquetaTercero(String ejercicioMaquetaTercero) {
		this.ejercicioMaquetaTercero = ejercicioMaquetaTercero;
	}

	/**
	 * @return the numeroMaquetaTercero
	 */
	public String getNumeroMaquetaTercero() {
		return this.numeroMaquetaTercero;
	}

	/**
	 * @param numeroMaquetaTercero
	 *            the numeroMaquetaTercero to set
	 */
	public void setNumeroMaquetaTercero(String numeroMaquetaTercero) {
		this.numeroMaquetaTercero = numeroMaquetaTercero;
	}

	/**
	 * @return the tipoOperacionGastos
	 */
	public String getTipoOperacionGastos() {
		return this.tipoOperacionGastos;
	}

	/**
	 * @param tipoOperacionGastos
	 *            the tipoOperacionGastos to set
	 */
	public void setTipoOperacionGastos(String tipoOperacionGastos) {
		this.tipoOperacionGastos = tipoOperacionGastos;
	}

	/**
	 * @return the fechaLimiteJustificacion
	 */
	public Date getFechaLimiteJustificacion() {
		return this.fechaLimiteJustificacion;
	}

	/**
	 * @param fechaLimiteJustificacion
	 *            the fechaLimiteJustificacion to set
	 */
	public void setFechaLimiteJustificacion(Date fechaLimiteJustificacion) {
		this.fechaLimiteJustificacion = fechaLimiteJustificacion;
	}

	/**
	 * @return the cuentaPCP
	 */
	public String getCuentaPCP() {
		return this.cuentaPCP;
	}

	/**
	 * @param cuentaPCP
	 *            the cuentaPCP to set
	 */
	public void setCuentaPCP(String cuentaPCP) {
		this.cuentaPCP = cuentaPCP;
	}

	/**
	 * @return the inmovilizado
	 */
	public String getInmovilizado() {
		return this.inmovilizado;
	}

	/**
	 * @param inmovilizado
	 *            the inmovilizado to set
	 */
	public void setInmovilizado(String inmovilizado) {
		this.inmovilizado = inmovilizado;
	}

	/**
	 * @return the numeroOrden
	 */
	public String getNumeroOrden() {
		return this.numeroOrden;
	}

	/**
	 * @param numeroOrden
	 *            the numeroOrden to set
	 */
	public void setNumeroOrden(String numeroOrden) {
		this.numeroOrden = numeroOrden;
	}

	/**
	 * @return the numeroFactura
	 */
	public String getNumeroFactura() {
		return this.numeroFactura;
	}

	/**
	 * @param numeroFactura
	 *            the numeroFactura to set
	 */
	public void setNumeroFactura(String numeroFactura) {
		this.numeroFactura = numeroFactura;
	}

	/**
	 * @return the fechaFactura
	 */
	public Date getFechaFactura() {
		return this.fechaFactura;
	}

	/**
	 * @param fechaFactura
	 *            the fechaFactura to set
	 */
	public void setFechaFactura(Date fechaFactura) {
		this.fechaFactura = fechaFactura;
	}

	/**
	 * @return the ejercicioEndoso
	 */
	public String getEjercicioEndoso() {
		return this.ejercicioEndoso;
	}

	/**
	 * @param ejercicioEndoso
	 *            the ejercicioEndoso to set
	 */
	public void setEjercicioEndoso(String ejercicioEndoso) {
		this.ejercicioEndoso = ejercicioEndoso;
	}

	/**
	 * @return the numeroEndoso
	 */
	public String getNumeroEndoso() {
		return this.numeroEndoso;
	}

	/**
	 * @param numeroEndoso
	 *            the numeroEndoso to set
	 */
	public void setNumeroEndoso(String numeroEndoso) {
		this.numeroEndoso = numeroEndoso;
	}

	/**
	 * @return the otroPerceptor
	 */
	public String getOtroPerceptor() {
		return this.otroPerceptor;
	}

	/**
	 * @param otroPerceptor
	 *            the otroPerceptor to set
	 */
	public void setOtroPerceptor(String otroPerceptor) {
		this.otroPerceptor = otroPerceptor;
	}

	/**
	 * @return the fechaVencimiento
	 */
	public Date getFechaVencimiento() {
		return this.fechaVencimiento;
	}

	/**
	 * @param fechaVencimiento
	 *            the fechaVencimiento to set
	 */
	public void setFechaVencimiento(Date fechaVencimiento) {
		this.fechaVencimiento = fechaVencimiento;
	}

	/**
	 * @return the codigoRetencion
	 */
	public String getCodigoRetencion() {
		return this.codigoRetencion;
	}

	/**
	 * @param codigoRetencion
	 *            the codigoRetencion to set
	 */
	public void setCodigoRetencion(String codigoRetencion) {
		this.codigoRetencion = codigoRetencion;
	}

	/**
	 * @return the baseRetencion
	 */
	public String getBaseRetencion() {
		return this.baseRetencion;
	}

	/**
	 * @param baseRetencion
	 *            the baseRetencion to set
	 */
	public void setBaseRetencion(String baseRetencion) {
		this.baseRetencion = baseRetencion;
	}

	/**
	 * @return the formaPago
	 */
	public String getFormaPago() {
		return this.formaPago;
	}

	/**
	 * @param formaPago
	 *            the formaPago to set
	 */
	public void setFormaPago(String formaPago) {
		this.formaPago = formaPago;
	}

	/**
	 * @return the cuentaFinanciera
	 */
	public String getCuentaFinanciera() {
		return this.cuentaFinanciera;
	}

	/**
	 * @param cuentaFinanciera
	 *            the cuentaFinanciera to set
	 */
	public void setCuentaFinanciera(String cuentaFinanciera) {
		this.cuentaFinanciera = cuentaFinanciera;
	}

	/**
	 * @return the ejercicioMaquetaTerceroOtroPerceptor
	 */
	public String getEjercicioMaquetaTerceroOtroPerceptor() {
		return this.ejercicioMaquetaTerceroOtroPerceptor;
	}

	/**
	 * @param ejercicioMaquetaTerceroOtroPerceptor
	 *            the ejercicioMaquetaTerceroOtroPerceptor to set
	 */
	public void setEjercicioMaquetaTerceroOtroPerceptor(String ejercicioMaquetaTerceroOtroPerceptor) {
		this.ejercicioMaquetaTerceroOtroPerceptor = ejercicioMaquetaTerceroOtroPerceptor;
	}

	/**
	 * @return the numeroMaquetaTerceroOtroPerceptor
	 */
	public String getNumeroMaquetaTerceroOtroPerceptor() {
		return this.numeroMaquetaTerceroOtroPerceptor;
	}

	/**
	 * @param numeroMaquetaTerceroOtroPerceptor
	 *            the numeroMaquetaTerceroOtroPerceptor to set
	 */
	public void setNumeroMaquetaTerceroOtroPerceptor(String numeroMaquetaTerceroOtroPerceptor) {
		this.numeroMaquetaTerceroOtroPerceptor = numeroMaquetaTerceroOtroPerceptor;
	}

	/**
	 * @return the codigoContrato
	 */
	public String getCodigoContrato() {
		return this.codigoContrato;
	}

	/**
	 * @param codigoContrato
	 *            the codigoContrato to set
	 */
	public void setCodigoContrato(String codigoContrato) {
		this.codigoContrato = codigoContrato;
	}

	/**
	 * @return the registroContable
	 */
	public String getRegistroContable() {
		return this.registroContable;
	}

	/**
	 * @param registroContable
	 *            the registroContable to set
	 */
	public void setRegistroContable(String registroContable) {
		this.registroContable = registroContable;
	}

	/**
	 * @return the fechaInicioPeriodoPago
	 */
	public Date getFechaInicioPeriodoPago() {
		return this.fechaInicioPeriodoPago;
	}

	/**
	 * @param fechaInicioPeriodoPago
	 *            the fechaInicioPeriodoPago to set
	 */
	public void setFechaInicioPeriodoPago(Date fechaInicioPeriodoPago) {
		this.fechaInicioPeriodoPago = fechaInicioPeriodoPago;
	}

	/**
	 * @return the referenciaIntervencion
	 */
	public String getReferenciaIntervencion() {
		return referenciaIntervencion;
	}

	/**
	 * @param referenciaIntervencion
	 *            the referenciaIntervencion to set
	 */
	public void setReferenciaIntervencion(String referenciaIntervencion) {
		this.referenciaIntervencion = referenciaIntervencion;
	}
}
