package com.ejie.ab60.model.moduloContable;

import java.math.BigDecimal;
import java.util.Date;

import com.ejie.ab60.comun.Constantes;
import com.ejie.ab60.model.terceros.TiposDocumento;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * DocumentosContables  
 * 
 *  
 */

public class DocumentosContables implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idConvocatoria;
	private String idDocumentoContable;
	private Integer idFicheroContable;
	private Integer idExpediente;
	private Date fechaDocumentoD;
	private String refIntD;
	private Integer idPagoConvocatoria;
	private String refIntO;
	private String tipoRegistro;
	private TiposDocumento tipoDocumento;
	private String tipoDocumentoStr;
	private String numeroExpediente;
	private String ejercicioAplPre;
	private String agrupacion;
	private String gastoIngreso;
	private String seccion;
	private String servicio;
	private String centro;
	private String territorio;
	private String nombreTerritorio;
	private String cac;
	private String sc;
	private String programa;
	private String partida;
	private String letraControl;
	private String ejercicioRefInt;
	private String anyoOrigen;
	private String numero;
	private String disponible;
	private String obligacion;
	private String conceptoResumido;
	private String tercero;
	private BigDecimal importe;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaDocumentoO;
	private Date fechaUltModificacion;
	private String usuarioUltModificacion;
	private Date fechaDocumentoDO;

	private String aplicacionPresupuestaria;
	private String puntoTramitacion;
	private String numeroMaqueta;
	private Date fechaActualizacion;
	private String fechaActualizacionStr;
	private Date fechaContabilizacion;
	private String indicadorError;
	private String numeroApunte;
	private String numeroOrden;
	private boolean estado;
	private String numeroOrdenMV;
	private String numeroApunteEP;
	private String referencial;

	private String tipoArchivoSeleccionado;
	private Integer idAplicPresu;
	private Date fechaResolucion;

	// Para la vista V_EXP_INF_CONTABLE_D.
	private String referenciaContratacion;
	private String numeroPlurianual;
	private String codigoSubvencion;
	private String ejercicioCompromiso1;
	private String ejercicioCompromiso2;
	private String ejercicioCompromiso3;
	private String ejercicioCompromiso4;
	private String importeCompromiso1;
	private String importeCompromiso2;
	private String importeCompromiso3;
	private String importeCompromiso4;
	private String importeCompromisoResto;
	private String ejercicioMaquetaTercero;
	private String numeroMaquetaTercero;

	// Para la vista V_EXP_INF_CONTABLE_DO.
	private String tipoOperacionGastos;
	private Date fechaLimiteJustificacion;
	private String cuentaPCP;
	private String inmovilizado;
	private String numeroFactura;
	private Date fechaFactura;
	private String ejercicioEndoso;
	private String numeroEndoso;
	private String otroPerceptor;
	private Date fechaVencimiento;
	private String codigoRetencion;
	private String baseRetencion;
	private String formaPago;
	private String cuentaFinanciera;
	private String ejercicioMaquetaTerceroOtroPerceptor;
	private String numeroMaquetaTerceroOtroPerceptor;
	private Date fechaInicioPeriodoPago;
	private String codigoContrato;
	private String registroContable;

	/**
	 * Method 'DocumentosContables'.
	 */
	public DocumentosContables() {
	}

	/**
	 * Method 'DocumentosContables'.
	 * 
	 * @param idDocumentoContable
	 *            String
	 */
	public DocumentosContables(String idDocumentoContable) {
		this.idDocumentoContable = idDocumentoContable;
	}

	public DocumentosContables(BigDecimal importe, Integer idAplicPresu) {
		this.importe = importe;
		this.idAplicPresu = idAplicPresu;
	}

	/**
	 * Method 'DocumentosContables'.
	 * 
	 * @param idDocumentoContable
	 *            String
	 * @param idFicheroContable
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param fechaDocumentoD
	 *            Date
	 * @param refIntD
	 *            String
	 * @param idPagoConvocatoria
	 *            Integer
	 * @param refIntO
	 *            String
	 * @param tipoRegistro
	 *            String
	 * @param tipoDocumento
	 *            String
	 * @param numeroExpediente
	 *            String
	 * @param ejercicioAplPre
	 *            Long
	 * @param agrupacion
	 *            Integer
	 * @param gastoIngreso
	 *            Integer
	 * @param seccion
	 *            Long
	 * @param servicio
	 *            Long
	 * @param centro
	 *            Long
	 * @param territorio
	 *            Integer
	 * @param cac
	 *            Long
	 * @param sc
	 *            Long
	 * @param programa
	 *            Integer
	 * @param partida
	 *            Long
	 * @param letraControl
	 *            String
	 * @param ejercicioRefInt
	 *            Long
	 * @param anyoOrigen
	 *            Long
	 * @param numero
	 *            Integer
	 * @param disponible
	 *            Integer
	 * @param conceptoResumido
	 *            String
	 * @param tercero
	 *            String
	 * @param importe
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */

	public DocumentosContables(String idDocumentoContable, Integer idFicheroContable, Integer idExpediente,
			Date fechaDocumentoD, String refIntD, Integer idPagoConvocatoria, String refIntO, String tipoRegistro,
			String tipoDocumentoStr, String numeroExpediente, String ejercicioAplPre, String agrupacion,
			String gastoIngreso, String seccion, String servicio, String centro, String territorio, String cac,
			String sc, String programa, String partida, String letraControl, String ejercicioRefInt, String anyoOrigen,
			String numero, String disponible, String conceptoResumido, String tercero, BigDecimal importe,
			Date fechaRegistro, String usuarioRegistro) {

		this.idDocumentoContable = idDocumentoContable;
		this.idFicheroContable = idFicheroContable;
		this.idExpediente = idExpediente;
		this.fechaDocumentoD = fechaDocumentoD;
		this.refIntD = refIntD;
		this.idPagoConvocatoria = idPagoConvocatoria;
		this.refIntO = refIntO;
		this.tipoRegistro = tipoRegistro;
		this.tipoDocumentoStr = tipoDocumentoStr;
		this.numeroExpediente = numeroExpediente;
		this.ejercicioAplPre = ejercicioAplPre;
		this.agrupacion = agrupacion;
		this.gastoIngreso = gastoIngreso;
		this.seccion = seccion;
		this.servicio = servicio;
		this.centro = centro;
		this.territorio = territorio;
		this.cac = cac;
		this.sc = sc;
		this.programa = programa;
		this.partida = partida;
		this.letraControl = letraControl;
		this.ejercicioRefInt = ejercicioRefInt;
		this.anyoOrigen = anyoOrigen;
		this.numero = numero;
		this.disponible = disponible;
		this.conceptoResumido = conceptoResumido;
		this.tercero = tercero;
		this.importe = importe;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	public DocumentosContables(String idDocumentoContable, Integer idConvocatoria, Integer idFicheroContable,
			Integer idExpediente, Date fechaDocumentoD, String refIntD, Integer idPagoConvocatoria, String refIntO,
			String tipoRegistro, TiposDocumento tipoDocumento, String numeroExpediente, String ejercicioAplPre,
			String agrupacion, String gastoIngreso, String seccion, String servicio, String centro, String territorio,
			String cac, String sc, String programa, String partida, String letraControl, String ejercicioRefInt,
			String anyoOrigen, String numero, String disponible, String conceptoResumido, String tercero,
			BigDecimal importe, Date fechaRegistro, String usuarioRegistro) {

		this.idDocumentoContable = idDocumentoContable;
		this.idConvocatoria = idConvocatoria;
		this.idFicheroContable = idFicheroContable;
		this.idExpediente = idExpediente;
		this.fechaDocumentoD = fechaDocumentoD;
		this.refIntD = refIntD;
		this.idPagoConvocatoria = idPagoConvocatoria;
		this.refIntO = refIntO;
		this.tipoRegistro = tipoRegistro;
		this.tipoDocumento = tipoDocumento;
		this.numeroExpediente = numeroExpediente;
		this.ejercicioAplPre = ejercicioAplPre;
		this.agrupacion = agrupacion;
		this.gastoIngreso = gastoIngreso;
		this.seccion = seccion;
		this.servicio = servicio;
		this.centro = centro;
		this.territorio = territorio;
		this.cac = cac;
		this.sc = sc;
		this.programa = programa;
		this.partida = partida;
		this.letraControl = letraControl;
		this.ejercicioRefInt = ejercicioRefInt;
		this.anyoOrigen = anyoOrigen;
		this.numero = numero;
		this.disponible = disponible;
		this.conceptoResumido = conceptoResumido;
		this.tercero = tercero;
		this.importe = importe;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	public DocumentosContables(String idDocumentoContable, Integer idConvocatoria, Integer idFicheroContable,
			Integer idExpediente, Date fechaDocumentoD, String refIntD, Integer idPagoConvocatoria, String refIntO,
			String tipoRegistro, String tipoDocumentoStr, String numeroExpediente, String ejercicioAplPre,
			String agrupacion, String gastoIngreso, String seccion, String servicio, String centro, String territorio,
			String cac, String sc, String programa, String partida, String letraControl, String ejercicioRefInt,
			String anyoOrigen, String numero, String disponible, String conceptoResumido, String tercero,
			BigDecimal importe, Date fechaRegistro, String usuarioRegistro) {

		this.idDocumentoContable = idDocumentoContable;
		this.idConvocatoria = idConvocatoria;
		this.idFicheroContable = idFicheroContable;
		this.idExpediente = idExpediente;
		this.fechaDocumentoD = fechaDocumentoD;
		this.refIntD = refIntD;
		this.idPagoConvocatoria = idPagoConvocatoria;
		this.refIntO = refIntO;
		this.tipoRegistro = tipoRegistro;
		this.tipoDocumentoStr = tipoDocumentoStr;
		this.numeroExpediente = numeroExpediente;
		this.ejercicioAplPre = ejercicioAplPre;
		this.agrupacion = agrupacion;
		this.gastoIngreso = gastoIngreso;
		this.seccion = seccion;
		this.servicio = servicio;
		this.centro = centro;
		this.territorio = territorio;
		this.cac = cac;
		this.sc = sc;
		this.programa = programa;
		this.partida = partida;
		this.letraControl = letraControl;
		this.ejercicioRefInt = ejercicioRefInt;
		this.anyoOrigen = anyoOrigen;
		this.numero = numero;
		this.disponible = disponible;
		this.conceptoResumido = conceptoResumido;
		this.tercero = tercero;
		this.importe = importe;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	public DocumentosContables(String idDocumentoContable, Integer idConvocatoria, Integer idFicheroContable,
			Integer idExpediente, Date fechaDocumentoD, String numeroExpediente, String aplPresupuestaria,
			String conceptoResumido, String tercero, BigDecimal importe, String territorio, Integer idAplicPresu) {

		this.idDocumentoContable = idDocumentoContable;
		this.idConvocatoria = idConvocatoria;
		this.idFicheroContable = idFicheroContable;
		this.idExpediente = idExpediente;
		this.fechaDocumentoD = fechaDocumentoD;
		this.numeroExpediente = numeroExpediente;
		this.aplicacionPresupuestaria = aplPresupuestaria;
		this.conceptoResumido = conceptoResumido;
		this.tercero = tercero;
		this.importe = importe;
		this.territorio = territorio;
		this.idAplicPresu = idAplicPresu;
	}

	public DocumentosContables(String idDocumentoContable, String puntoTramitacion, String numeroMaqueta,
			Date fechaActualizacion, Date fechaContabilizacion, String expediente, String indicadorError,
			String numeroApunte, String numeroOrden, String territorio, String fechaActualizacionStr) {

		this.idDocumentoContable = idDocumentoContable;
		this.puntoTramitacion = puntoTramitacion;
		this.numeroMaqueta = numeroMaqueta;
		this.fechaActualizacion = fechaActualizacion;
		this.fechaContabilizacion = fechaContabilizacion;
		this.numeroExpediente = expediente;
		this.indicadorError = indicadorError;
		this.numeroApunte = numeroApunte;
		this.numeroOrden = numeroOrden;
		this.territorio = territorio;
		this.fechaActualizacionStr = fechaActualizacionStr;
	}

	/*
	 * public DocumentosContables(String idDocumentoContable, Integer
	 * idConvocatoria, Integer idFicheroContable, Integer idExpediente, Date
	 * fechaDocumentoD, String refIntD, Integer idPagoConvocatoria, String
	 * refIntO, String tipoRegistro, String tipoDocumento, String
	 * tipoDocumentoStr, String numeroExpediente, Long ejercicioAplPre, Integer
	 * agrupacion, Integer gastoIngreso, Long seccion, Long servicio, Long
	 * centro, Integer territorio, Long cac, Long sc, Integer programa, Long
	 * partida, String letraControl, Long ejercicioRefInt, Long anyoOrigen,
	 * Integer numero, Integer disponible, String conceptoResumido, String
	 * tercero, BigDecimal importe, Date fechaRegistro, String usuarioRegistro)
	 * {
	 * 
	 * this.idDocumentoContable = idDocumentoContable; this.idConvocatoria =
	 * idConvocatoria; this.idFicheroContable = idFicheroContable;
	 * this.idExpediente = idExpediente; this.fechaDocumentoD = fechaDocumentoD;
	 * this.refIntD = refIntD; this.idPagoConvocatoria = idPagoConvocatoria;
	 * this.refIntO = refIntO; this.tipoRegistro = tipoRegistro;
	 * this.tipoDocumento = tipoDocumento; this.tipoDocumentoStr =
	 * tipoDocumentoStr; this.numeroExpediente = numeroExpediente;
	 * this.ejercicioAplPre = ejercicioAplPre; this.agrupacion = agrupacion;
	 * this.gastoIngreso = gastoIngreso; this.seccion = seccion; this.servicio =
	 * servicio; this.centro = centro; this.territorio = territorio; this.cac =
	 * cac; this.sc = sc; this.programa = programa; this.partida = partida;
	 * this.letraControl = letraControl; this.ejercicioRefInt = ejercicioRefInt;
	 * this.anyoOrigen = anyoOrigen; this.numero = numero; this.disponible =
	 * disponible; this.conceptoResumido = conceptoResumido; this.tercero =
	 * tercero; this.importe = importe; this.fechaRegistro = fechaRegistro;
	 * this.usuarioRegistro = usuarioRegistro; }
	 */

	/**
	 * Method 'getIdDocumentoContable'.
	 *
	 * @return String
	 */

	public String getIdDocumentoContable() {
		return this.idDocumentoContable;
	}

	/**
	 * Method 'setIdDocumentoContable'.
	 *
	 * @param idDocumentoContable
	 *            String
	 * @return
	 */

	public void setIdDocumentoContable(String idDocumentoContable) {
		this.idDocumentoContable = idDocumentoContable;
	}

	/**
	 * @return the nombreTipoDocumento
	 */
	/*
	 * public String getTipoDocumentoStr() {
	 * 
	 * if ("1".equals(tipoDocumento)) tipoDocumentoStr = "D"; else if
	 * ("2".equals(tipoDocumento)) tipoDocumentoStr = "O"; else if
	 * ("3".equals(tipoDocumento)) tipoDocumentoStr = "DO"; else
	 * tipoDocumentoStr = "";
	 * 
	 * return tipoDocumentoStr; }
	 */

	/**
	 * @return the idConvocatoria
	 */
	public Integer getIdConvocatoria() {
		return idConvocatoria;
	}

	/**
	 * @param idConvocatoria
	 *            the idConvocatoria to set
	 */
	public void setIdConvocatoria(Integer idConvocatoria) {
		this.idConvocatoria = idConvocatoria;
	}

	/**
	 * Method 'getIdFicheroContable'.
	 *
	 * @return Integer
	 */

	public Integer getIdFicheroContable() {
		return this.idFicheroContable;
	}

	/**
	 * Method 'setIdFicheroContable'.
	 *
	 * @param idFicheroContable
	 *            Integer
	 * @return
	 */

	public void setIdFicheroContable(Integer idFicheroContable) {
		this.idFicheroContable = idFicheroContable;
	}

	/**
	 * Method 'getIdExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdExpediente() {
		return this.idExpediente;
	}

	/**
	 * Method 'setIdExpediente'.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return
	 */

	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'getFechaDocumentoD'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaDocumentoD() {
		return this.fechaDocumentoD;
	}

	/**
	 * Method 'setFechaDocumentoD'.
	 *
	 * @param fechaDocumentoD
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaDocumentoD(Date fechaDocumentoD) {
		this.fechaDocumentoD = fechaDocumentoD;
	}

	/**
	 * Method 'getRefIntD'.
	 *
	 * @return String
	 */

	public String getRefIntD() {
		return this.refIntD;
	}

	/**
	 * Method 'setRefIntD'.
	 *
	 * @param refIntD
	 *            String
	 * @return
	 */

	public void setRefIntD(String refIntD) {
		this.refIntD = refIntD;
	}

	/**
	 * Method 'getIdPagoConvocatoria'.
	 *
	 * @return Integer
	 */

	public Integer getIdPagoConvocatoria() {
		return this.idPagoConvocatoria;
	}

	/**
	 * Method 'setIdPagoConvocatoria'.
	 *
	 * @param idPagoConvocatoria
	 *            Integer
	 * @return
	 */

	public void setIdPagoConvocatoria(Integer idPagoConvocatoria) {
		this.idPagoConvocatoria = idPagoConvocatoria;
	}

	/**
	 * Method 'getRefIntO'.
	 *
	 * @return String
	 */

	public String getRefIntO() {
		return this.refIntO;
	}

	/**
	 * Method 'setRefIntO'.
	 *
	 * @param refIntO
	 *            String
	 * @return
	 */

	public void setRefIntO(String refIntO) {
		this.refIntO = refIntO;
	}

	/**
	 * Method 'getTipoRegistro'.
	 *
	 * @return String
	 */

	public String getTipoRegistro() {
		return this.tipoRegistro;
	}

	/**
	 * Method 'setTipoRegistro'.
	 *
	 * @param tipoRegistro
	 *            String
	 * @return
	 */

	public void setTipoRegistro(String tipoRegistro) {
		this.tipoRegistro = tipoRegistro;
	}

	/**
	 * Method 'getTipoDocumento'.
	 *
	 * @return String
	 */

	public TiposDocumento getTipoDocumento() {
		return this.tipoDocumento;
	}

	/**
	 * Method 'setTipoDocumento'.
	 *
	 * @param tipoDocumento
	 *            String
	 * @return
	 */

	public void setTipoDocumento(TiposDocumento tipoDocumento) {
		this.tipoDocumento = tipoDocumento;
	}

	/**
	 * @return the tipoDocumentoStr
	 */
	public String getTipoDocumentoStr() {
		return tipoDocumentoStr;
	}

	/**
	 * @param tipoDocumentoStr
	 *            the tipoDocumentoStr to set
	 */
	public void setTipoDocumentoStr(String tipoDocumentoStr) {
		this.tipoDocumentoStr = tipoDocumentoStr;
	}

	/**
	 * Method 'getNumeroExpediente'.
	 *
	 * @return String
	 */

	public String getNumeroExpediente() {
		return this.numeroExpediente;
	}

	/**
	 * Method 'setNumeroExpediente'.
	 *
	 * @param numeroExpediente
	 *            String
	 * @return
	 */

	public void setNumeroExpediente(String numeroExpediente) {
		this.numeroExpediente = numeroExpediente;
	}

	/**
	 * Method 'getEjercicioAplPre'.
	 *
	 * @return Long
	 */

	public String getEjercicioAplPre() {
		return this.ejercicioAplPre;
	}

	/**
	 * Method 'setEjercicioAplPre'.
	 *
	 * @param ejercicioAplPre
	 *            Long
	 * @return
	 */

	public void setEjercicioAplPre(String ejercicioAplPre) {
		this.ejercicioAplPre = ejercicioAplPre;
	}

	/**
	 * Method 'getAgrupacion'.
	 *
	 * @return Integer
	 */

	public String getAgrupacion() {
		return this.agrupacion;
	}

	/**
	 * Method 'setAgrupacion'.
	 *
	 * @param agrupacion
	 *            Integer
	 * @return
	 */

	public void setAgrupacion(String agrupacion) {
		this.agrupacion = agrupacion;
	}

	/**
	 * Method 'getGastoIngreso'.
	 *
	 * @return Integer
	 */

	public String getGastoIngreso() {
		return this.gastoIngreso;
	}

	/**
	 * Method 'setGastoIngreso'.
	 *
	 * @param gastoIngreso
	 *            Integer
	 * @return
	 */

	public void setGastoIngreso(String gastoIngreso) {
		this.gastoIngreso = gastoIngreso;
	}

	/**
	 * Method 'getSeccion'.
	 *
	 * @return Long
	 */

	public String getSeccion() {
		return this.seccion;
	}

	/**
	 * Method 'setSeccion'.
	 *
	 * @param seccion
	 *            Long
	 * @return
	 */

	public void setSeccion(String seccion) {
		this.seccion = seccion;
	}

	/**
	 * Method 'getServicio'.
	 *
	 * @return Long
	 */

	public String getServicio() {
		return this.servicio;
	}

	/**
	 * Method 'setServicio'.
	 *
	 * @param servicio
	 *            Long
	 * @return
	 */

	public void setServicio(String servicio) {
		this.servicio = servicio;
	}

	/**
	 * Method 'getCentro'.
	 *
	 * @return Long
	 */

	public String getCentro() {
		return this.centro;
	}

	/**
	 * Method 'setCentro'.
	 *
	 * @param centro
	 *            Long
	 * @return
	 */

	public void setCentro(String centro) {
		this.centro = centro;
	}

	/**
	 * Method 'getTerritorio'.
	 *
	 * @return Integer
	 */

	public String getTerritorio() {
		return this.territorio;
	}

	/**
	 * Method 'setTerritorio'.
	 *
	 * @param territorio
	 *            Integer
	 * @return
	 */

	public void setTerritorio(String territorio) {
		this.territorio = territorio;
	}

	/**
	 * @return the nombreTerritorio
	 */
	public String getNombreTerritorio() {

		if (territorio.equals("1"))
			nombreTerritorio = Constantes.PROVINCIA_ARABA;
		else if (territorio.equals("2"))
			nombreTerritorio = Constantes.PROVINCIA_GIPUZKOA;
		else if (territorio.equals("3"))
			nombreTerritorio = Constantes.PROVINCIA_BIZKAIA;
		else
			nombreTerritorio = "";

		return nombreTerritorio;
	}

	/**
	 * Method 'getCac'.
	 *
	 * @return Long
	 */

	public String getCac() {
		return this.cac;
	}

	/**
	 * Method 'setCac'.
	 *
	 * @param cac
	 *            Long
	 * @return
	 */

	public void setCac(String cac) {
		this.cac = cac;
	}

	/**
	 * Method 'getSc'.
	 *
	 * @return Long
	 */

	public String getSc() {
		return this.sc;
	}

	/**
	 * Method 'setSc'.
	 *
	 * @param sc
	 *            Long
	 * @return
	 */

	public void setSc(String sc) {
		this.sc = sc;
	}

	/**
	 * Method 'getPrograma'.
	 *
	 * @return Integer
	 */

	public String getPrograma() {
		return this.programa;
	}

	/**
	 * Method 'setPrograma'.
	 *
	 * @param programa
	 *            Integer
	 * @return
	 */

	public void setPrograma(String programa) {
		this.programa = programa;
	}

	/**
	 * Method 'getPartida'.
	 *
	 * @return Long
	 */

	public String getPartida() {
		return this.partida;
	}

	/**
	 * Method 'setPartida'.
	 *
	 * @param partida
	 *            Long
	 * @return
	 */

	public void setPartida(String partida) {
		this.partida = partida;
	}

	/**
	 * Method 'getLetraControl'.
	 *
	 * @return String
	 */

	public String getLetraControl() {
		return this.letraControl;
	}

	/**
	 * Method 'setLetraControl'.
	 *
	 * @param letraControl
	 *            String
	 * @return
	 */

	public void setLetraControl(String letraControl) {
		this.letraControl = letraControl;
	}

	/**
	 * Method 'getEjercicioRefInt'.
	 *
	 * @return Long
	 */

	public String getEjercicioRefInt() {
		return this.ejercicioRefInt;
	}

	/**
	 * Method 'setEjercicioRefInt'.
	 *
	 * @param ejercicioRefInt
	 *            Long
	 * @return
	 */

	public void setEjercicioRefInt(String ejercicioRefInt) {
		this.ejercicioRefInt = ejercicioRefInt;
	}

	/**
	 * Method 'getAnyoOrigen'.
	 *
	 * @return Long
	 */

	public String getAnyoOrigen() {
		return this.anyoOrigen;
	}

	/**
	 * Method 'setAnyoOrigen'.
	 *
	 * @param anyoOrigen
	 *            Long
	 * @return
	 */

	public void setAnyoOrigen(String anyoOrigen) {
		this.anyoOrigen = anyoOrigen;
	}

	/**
	 * Method 'getNumero'.
	 *
	 * @return Integer
	 */

	public String getNumero() {
		return this.numero;
	}

	/**
	 * Method 'setNumero'.
	 *
	 * @param numero
	 *            Integer
	 * @return
	 */

	public void setNumero(String numero) {
		this.numero = numero;
	}

	/**
	 * Method 'getDisponible'.
	 *
	 * @return Integer
	 */

	public String getDisponible() {
		return this.disponible;
	}

	/**
	 * Method 'setDisponible'.
	 *
	 * @param disponible
	 *            Integer
	 * @return
	 */

	public void setDisponible(String disponible) {
		this.disponible = disponible;
	}

	public String getObligacion() {
		return obligacion;
	}

	public void setObligacion(String obligacion) {
		this.obligacion = obligacion;
	}

	/**
	 * Method 'getConceptoResumido'.
	 *
	 * @return String
	 */

	public String getConceptoResumido() {
		return this.conceptoResumido;
	}

	/**
	 * Method 'setConceptoResumido'.
	 *
	 * @param conceptoResumido
	 *            String
	 * @return
	 */

	public void setConceptoResumido(String conceptoResumido) {
		this.conceptoResumido = conceptoResumido;
	}

	/**
	 * Method 'getTercero'.
	 *
	 * @return String
	 */

	public String getTercero() {
		return this.tercero;
	}

	/**
	 * Method 'setTercero'.
	 *
	 * @param tercero
	 *            String
	 * @return
	 */

	public void setTercero(String tercero) {
		this.tercero = tercero;
	}

	/**
	 * Method 'getImporte'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImporte() {
		return this.importe;
	}

	/**
	 * Method 'setImporte'.
	 *
	 * @param importe
	 *            BigDecimal
	 * @return
	 */

	public void setImporte(BigDecimal importe) {
		this.importe = importe;
	}

	public String getimporteMask() {
		return UtilDate.formatearMiles(importe);
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * @return the aplicacionPresupuestaria
	 */
	public String getAplicacionPresupuestaria() {
		return aplicacionPresupuestaria;
	}

	/**
	 * @param aplicacionPresupuestaria
	 *            the aplicacionPresupuestaria to set
	 */
	public void setAplicacionPresupuestaria(String aplicacionPresupuestaria) {
		this.aplicacionPresupuestaria = aplicacionPresupuestaria;
	}

	/**
	 * @return the fechaDocumentoO
	 */
	public Date getFechaDocumentoO() {
		return fechaDocumentoO;
	}

	/**
	 * @param fechaDocumentoO
	 *            the fechaDocumentoO to set
	 */
	public void setFechaDocumentoO(Date fechaDocumentoO) {
		this.fechaDocumentoO = fechaDocumentoO;
	}

	/**
	 * @return the puntoTramitacion
	 */
	public String getPuntoTramitacion() {
		return puntoTramitacion;
	}

	/**
	 * @param puntoTramitacion
	 *            the puntoTramitacion to set
	 */
	public void setPuntoTramitacion(String puntoTramitacion) {
		this.puntoTramitacion = puntoTramitacion;
	}

	/**
	 * @return the numeroMaqueta
	 */
	public String getNumeroMaqueta() {
		return numeroMaqueta;
	}

	/**
	 * @param numeroMaqueta
	 *            the numeroMaqueta to set
	 */
	public void setNumeroMaqueta(String numeroMaqueta) {
		this.numeroMaqueta = numeroMaqueta;
	}

	/**
	 * @return the fechaActualizacion
	 */
	public Date getFechaActualizacion() {

		return fechaActualizacion;

	}

	/**
	 * @param fechaActualizacion
	 *            the fechaActualizacion to set
	 */
	public void setFechaActualizacion(Date fechaActualizacion) {
		this.fechaActualizacion = fechaActualizacion;
	}

	/**
	 * @return the fechaActualizacionStr
	 */
	public String getFechaActualizacionStr() {
		/*
		 * if (fechaActualizacion != null) { SimpleDateFormat f = new
		 * SimpleDateFormat("yyyy/MM/dd HH:mm:ss"); return
		 * f.format(fechaActualizacion); } else { return ""; }
		 */
		return fechaActualizacionStr;
	}

	/**
	 * @param fechaActualizacionStr
	 *            the fechaActualizacionStr to set
	 */
	public void setFechaActualizacionStr(String fechaActualizacionStr) {
		this.fechaActualizacionStr = fechaActualizacionStr;
	}

	/**
	 * @return the fechaContabilizacion
	 */
	public Date getFechaContabilizacion() {
		return fechaContabilizacion;
	}

	/**
	 * @param fechaContabilizacion
	 *            the fechaContabilizacion to set
	 */
	public void setFechaContabilizacion(Date fechaContabilizacion) {
		this.fechaContabilizacion = fechaContabilizacion;
	}

	/**
	 * @return the indicadorError
	 */
	public String getIndicadorError() {
		return indicadorError;
	}

	/**
	 * @param indicadorError
	 *            the indicadorError to set
	 */
	public void setIndicadorError(String indicadorError) {
		this.indicadorError = indicadorError;
	}

	/**
	 * @return the numeroApunte
	 */
	public String getNumeroApunte() {
		return numeroApunte;
	}

	/**
	 * @param numeroApunte
	 *            the numeroApunte to set
	 */
	public void setNumeroApunte(String numeroApunte) {
		this.numeroApunte = numeroApunte;
	}

	/**
	 * @param nombreTerritorio
	 *            the nombreTerritorio to set
	 */
	public void setNombreTerritorio(String nombreTerritorio) {
		this.nombreTerritorio = nombreTerritorio;
	}

	/**
	 * @return the numeroOrden
	 */
	public String getNumeroOrden() {
		return numeroOrden;
	}

	/**
	 * @param numeroOrden
	 *            the numeroOrden to set
	 */
	public void setNumeroOrden(String numeroOrden) {
		this.numeroOrden = numeroOrden;
	}

	/**
	 * @return the estado
	 */
	public boolean isEstado() {
		return estado;
	}

	/**
	 * @param estado
	 *            the estado to set
	 */
	public void setEstado(boolean estado) {
		this.estado = estado;
	}

	/**
	 * @return the tipoArchivoSeleccionado
	 */
	public String getTipoArchivoSeleccionado() {
		return tipoArchivoSeleccionado;
	}

	/**
	 * @param tipoArchivoSeleccionado
	 *            the tipoArchivoSeleccionado to set
	 */
	public void setTipoArchivoSeleccionado(String tipoArchivoSeleccionado) {
		this.tipoArchivoSeleccionado = tipoArchivoSeleccionado;
	}

	/**
	 * @return the numeroOrdenMV
	 */
	public String getNumeroOrdenMV() {
		return numeroOrdenMV;
	}

	/**
	 * @param numeroOrdenMV
	 *            the numeroOrdenMV to set
	 */
	public void setNumeroOrdenMV(String numeroOrdenMV) {
		this.numeroOrdenMV = numeroOrdenMV;
	}

	/**
	 * @return the numeroApunteEP
	 */
	public String getNumeroApunteEP() {
		return numeroApunteEP;
	}

	/**
	 * @param numeroApunteEP
	 *            the numeroApunteEP to set
	 */
	public void setNumeroApunteEP(String numeroApunteEP) {
		this.numeroApunteEP = numeroApunteEP;
	}

	/**
	 * @return the referencial
	 */
	public String getReferencial() {
		return referencial;
	}

	/**
	 * @param referencial
	 *            the referencial to set
	 */
	public void setReferencial(String referencial) {
		this.referencial = referencial;
	}

	/**
	 * @return the fechaUltModificacion
	 */
	public Date getFechaUltModificacion() {
		return fechaUltModificacion;
	}

	/**
	 * @param fechaUltModificacion
	 *            the fechaUltModificacion to set
	 */
	public void setFechaUltModificacion(Date fechaUltModificacion) {
		this.fechaUltModificacion = fechaUltModificacion;
	}

	/**
	 * @return the usuarioUltModificacion
	 */
	public String getUsuarioUltModificacion() {
		return usuarioUltModificacion;
	}

	/**
	 * @param usuarioUltModificacion
	 *            the usuarioUltModificacion to set
	 */
	public void setUsuarioUltModificacion(String usuarioUltModificacion) {
		this.usuarioUltModificacion = usuarioUltModificacion;
	}

	/**
	 * Method 'getFechaDocumentoDO'
	 * 
	 * @return the fechaDocumentoDO
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaDocumentoDO() {
		return this.fechaDocumentoDO;
	}

	/**
	 * Method 'setFechaDocumentoDO'
	 * 
	 * @param fechaDocumentoDO
	 *            the fechaDocumentoDO to set
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaDocumentoDO(Date fechaDocumentoDO) {
		this.fechaDocumentoDO = fechaDocumentoDO;
	}

	/**
	 * @return the idAplicPresu
	 */
	public Integer getIdAplicPresu() {
		return idAplicPresu;
	}

	/**
	 * @param idAplicPresu
	 *            the idAplicPresu to set
	 */
	public void setIdAplicPresu(Integer idAplicPresu) {
		this.idAplicPresu = idAplicPresu;
	}

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaResolucion() {
		return fechaResolucion;
	}

	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaResolucion(Date fechaResolucion) {
		this.fechaResolucion = fechaResolucion;
	}

	/**
	 * @return the referenciaContratacion
	 */
	public String getReferenciaContratacion() {
		return referenciaContratacion;
	}

	/**
	 * @param referenciaContratacion
	 *            the referenciaContratacion to set
	 */
	public void setReferenciaContratacion(String referenciaContratacion) {
		this.referenciaContratacion = referenciaContratacion;
	}

	/**
	 * @return the numeroPlurianual
	 */
	public String getNumeroPlurianual() {
		return numeroPlurianual;
	}

	/**
	 * @param numeroPlurianual
	 *            the numeroPlurianual to set
	 */
	public void setNumeroPlurianual(String numeroPlurianual) {
		this.numeroPlurianual = numeroPlurianual;
	}

	/**
	 * @return the codigoSubvencion
	 */
	public String getCodigoSubvencion() {
		return codigoSubvencion;
	}

	/**
	 * @param codigoSubvencion
	 *            the codigoSubvencion to set
	 */
	public void setCodigoSubvencion(String codigoSubvencion) {
		this.codigoSubvencion = codigoSubvencion;
	}

	/**
	 * @return the ejercicioCompromiso1
	 */
	public String getEjercicioCompromiso1() {
		return ejercicioCompromiso1;
	}

	/**
	 * @param ejercicioCompromiso1
	 *            the ejercicioCompromiso1 to set
	 */
	public void setEjercicioCompromiso1(String ejercicioCompromiso1) {
		this.ejercicioCompromiso1 = ejercicioCompromiso1;
	}

	/**
	 * @return the ejercicioCompromiso2
	 */
	public String getEjercicioCompromiso2() {
		return ejercicioCompromiso2;
	}

	/**
	 * @param ejercicioCompromiso2
	 *            the ejercicioCompromiso2 to set
	 */
	public void setEjercicioCompromiso2(String ejercicioCompromiso2) {
		this.ejercicioCompromiso2 = ejercicioCompromiso2;
	}

	/**
	 * @return the ejercicioCompromiso3
	 */
	public String getEjercicioCompromiso3() {
		return ejercicioCompromiso3;
	}

	/**
	 * @param ejercicioCompromiso3
	 *            the ejercicioCompromiso3 to set
	 */
	public void setEjercicioCompromiso3(String ejercicioCompromiso3) {
		this.ejercicioCompromiso3 = ejercicioCompromiso3;
	}

	/**
	 * @return the ejercicioCompromiso4
	 */
	public String getEjercicioCompromiso4() {
		return ejercicioCompromiso4;
	}

	/**
	 * @param ejercicioCompromiso4
	 *            the ejercicioCompromiso4 to set
	 */
	public void setEjercicioCompromiso4(String ejercicioCompromiso4) {
		this.ejercicioCompromiso4 = ejercicioCompromiso4;
	}

	/**
	 * @return the importeCompromiso1
	 */
	public String getImporteCompromiso1() {
		return importeCompromiso1;
	}

	/**
	 * @param importeCompromiso1
	 *            the importeCompromiso1 to set
	 */
	public void setImporteCompromiso1(String importeCompromiso1) {
		this.importeCompromiso1 = importeCompromiso1;
	}

	/**
	 * @return the importeCompromiso2
	 */
	public String getImporteCompromiso2() {
		return importeCompromiso2;
	}

	/**
	 * @param importeCompromiso2
	 *            the importeCompromiso2 to set
	 */
	public void setImporteCompromiso2(String importeCompromiso2) {
		this.importeCompromiso2 = importeCompromiso2;
	}

	/**
	 * @return the importeCompromiso3
	 */
	public String getImporteCompromiso3() {
		return importeCompromiso3;
	}

	/**
	 * @param importeCompromiso3
	 *            the importeCompromiso3 to set
	 */
	public void setImporteCompromiso3(String importeCompromiso3) {
		this.importeCompromiso3 = importeCompromiso3;
	}

	/**
	 * @return the importeCompromiso4
	 */
	public String getImporteCompromiso4() {
		return importeCompromiso4;
	}

	/**
	 * @param importeCompromiso4
	 *            the importeCompromiso4 to set
	 */
	public void setImporteCompromiso4(String importeCompromiso4) {
		this.importeCompromiso4 = importeCompromiso4;
	}

	/**
	 * @return the importeCompromisoResto
	 */
	public String getImporteCompromisoResto() {
		return importeCompromisoResto;
	}

	/**
	 * @param importeCompromisoResto
	 *            the importeCompromisoResto to set
	 */
	public void setImporteCompromisoResto(String importeCompromisoResto) {
		this.importeCompromisoResto = importeCompromisoResto;
	}

	/**
	 * @return the ejercicioMaquetaTercero
	 */
	public String getEjercicioMaquetaTercero() {
		return ejercicioMaquetaTercero;
	}

	/**
	 * @param ejercicioMaquetaTercero
	 *            the ejercicioMaquetaTercero to set
	 */
	public void setEjercicioMaquetaTercero(String ejercicioMaquetaTercero) {
		this.ejercicioMaquetaTercero = ejercicioMaquetaTercero;
	}

	/**
	 * @return the numeroMaquetaTercero
	 */
	public String getNumeroMaquetaTercero() {
		return numeroMaquetaTercero;
	}

	/**
	 * @param numeroMaquetaTercero
	 *            the numeroMaquetaTercero to set
	 */
	public void setNumeroMaquetaTercero(String numeroMaquetaTercero) {
		this.numeroMaquetaTercero = numeroMaquetaTercero;
	}

	/**
	 * @return the tipoOperacionGastos
	 */
	public String getTipoOperacionGastos() {
		return tipoOperacionGastos;
	}

	/**
	 * @param tipoOperacionGastos
	 *            the tipoOperacionGastos to set
	 */
	public void setTipoOperacionGastos(String tipoOperacionGastos) {
		this.tipoOperacionGastos = tipoOperacionGastos;
	}

	/**
	 * @return the fechaLimiteJustificacion
	 */
	public Date getFechaLimiteJustificacion() {
		return fechaLimiteJustificacion;
	}

	/**
	 * @param fechaLimiteJustificacion
	 *            the fechaLimiteJustificacion to set
	 */
	public void setFechaLimiteJustificacion(Date fechaLimiteJustificacion) {
		this.fechaLimiteJustificacion = fechaLimiteJustificacion;
	}

	/**
	 * @return the cuentaPCP
	 */
	public String getCuentaPCP() {
		return cuentaPCP;
	}

	/**
	 * @param cuentaPCP
	 *            the cuentaPCP to set
	 */
	public void setCuentaPCP(String cuentaPCP) {
		this.cuentaPCP = cuentaPCP;
	}

	/**
	 * @return the inmovilizado
	 */
	public String getInmovilizado() {
		return inmovilizado;
	}

	/**
	 * @param inmovilizado
	 *            the inmovilizado to set
	 */
	public void setInmovilizado(String inmovilizado) {
		this.inmovilizado = inmovilizado;
	}

	/**
	 * @return the numeroFactura
	 */
	public String getNumeroFactura() {
		return numeroFactura;
	}

	/**
	 * @param numeroFactura
	 *            the numeroFactura to set
	 */
	public void setNumeroFactura(String numeroFactura) {
		this.numeroFactura = numeroFactura;
	}

	/**
	 * @return the fechaFactura
	 */
	public Date getFechaFactura() {
		return fechaFactura;
	}

	/**
	 * @param fechaFactura
	 *            the fechaFactura to set
	 */
	public void setFechaFactura(Date fechaFactura) {
		this.fechaFactura = fechaFactura;
	}

	/**
	 * @return the ejercicioEndoso
	 */
	public String getEjercicioEndoso() {
		return ejercicioEndoso;
	}

	/**
	 * @param ejercicioEndoso
	 *            the ejercicioEndoso to set
	 */
	public void setEjercicioEndoso(String ejercicioEndoso) {
		this.ejercicioEndoso = ejercicioEndoso;
	}

	/**
	 * @return the numeroEndoso
	 */
	public String getNumeroEndoso() {
		return numeroEndoso;
	}

	/**
	 * @param numeroEndoso
	 *            the numeroEndoso to set
	 */
	public void setNumeroEndoso(String numeroEndoso) {
		this.numeroEndoso = numeroEndoso;
	}

	/**
	 * @return the otroPerceptor
	 */
	public String getOtroPerceptor() {
		return otroPerceptor;
	}

	/**
	 * @param otroPerceptor
	 *            the otroPerceptor to set
	 */
	public void setOtroPerceptor(String otroPerceptor) {
		this.otroPerceptor = otroPerceptor;
	}

	/**
	 * @return the fechaVencimiento
	 */
	public Date getFechaVencimiento() {
		return fechaVencimiento;
	}

	/**
	 * @param fechaVencimiento
	 *            the fechaVencimiento to set
	 */
	public void setFechaVencimiento(Date fechaVencimiento) {
		this.fechaVencimiento = fechaVencimiento;
	}

	/**
	 * @return the codigoRetencion
	 */
	public String getCodigoRetencion() {
		return codigoRetencion;
	}

	/**
	 * @param codigoRetencion
	 *            the codigoRetencion to set
	 */
	public void setCodigoRetencion(String codigoRetencion) {
		this.codigoRetencion = codigoRetencion;
	}

	/**
	 * @return the baseRetencion
	 */
	public String getBaseRetencion() {
		return baseRetencion;
	}

	/**
	 * @param baseRetencion
	 *            the baseRetencion to set
	 */
	public void setBaseRetencion(String baseRetencion) {
		this.baseRetencion = baseRetencion;
	}

	/**
	 * @return the formaPago
	 */
	public String getFormaPago() {
		return formaPago;
	}

	/**
	 * @param formaPago
	 *            the formaPago to set
	 */
	public void setFormaPago(String formaPago) {
		this.formaPago = formaPago;
	}

	/**
	 * @return the cuentaFinanciera
	 */
	public String getCuentaFinanciera() {
		return cuentaFinanciera;
	}

	/**
	 * @param cuentaFinanciera
	 *            the cuentaFinanciera to set
	 */
	public void setCuentaFinanciera(String cuentaFinanciera) {
		this.cuentaFinanciera = cuentaFinanciera;
	}

	/**
	 * @return the ejercicioMaquetaTerceroOtroPerceptor
	 */
	public String getEjercicioMaquetaTerceroOtroPerceptor() {
		return ejercicioMaquetaTerceroOtroPerceptor;
	}

	/**
	 * @param ejercicioMaquetaTerceroOtroPerceptor
	 *            the ejercicioMaquetaTerceroOtroPerceptor to set
	 */
	public void setEjercicioMaquetaTerceroOtroPerceptor(String ejercicioMaquetaTerceroOtroPerceptor) {
		this.ejercicioMaquetaTerceroOtroPerceptor = ejercicioMaquetaTerceroOtroPerceptor;
	}

	/**
	 * @return the numeroMaquetaTerceroOtroPerceptor
	 */
	public String getNumeroMaquetaTerceroOtroPerceptor() {
		return numeroMaquetaTerceroOtroPerceptor;
	}

	/**
	 * @param numeroMaquetaTerceroOtroPerceptor
	 *            the numeroMaquetaTerceroOtroPerceptor to set
	 */
	public void setNumeroMaquetaTerceroOtroPerceptor(String numeroMaquetaTerceroOtroPerceptor) {
		this.numeroMaquetaTerceroOtroPerceptor = numeroMaquetaTerceroOtroPerceptor;
	}

	/**
	 * @return the fechaInicioPeriodoPago
	 */
	public Date getFechaInicioPeriodoPago() {
		return fechaInicioPeriodoPago;
	}

	/**
	 * @param fechaInicioPeriodoPago
	 *            the fechaInicioPeriodoPago to set
	 */
	public void setFechaInicioPeriodoPago(Date fechaInicioPeriodoPago) {
		this.fechaInicioPeriodoPago = fechaInicioPeriodoPago;
	}

	/**
	 * @return the codigoContrato
	 */
	public String getCodigoContrato() {
		return codigoContrato;
	}

	/**
	 * @param codigoContrato
	 *            the codigoContrato to set
	 */
	public void setCodigoContrato(String codigoContrato) {
		this.codigoContrato = codigoContrato;
	}

	/**
	 * @return the registroContable
	 */
	public String getRegistroContable() {
		return registroContable;
	}

	/**
	 * @param registroContable
	 *            the registroContable to set
	 */
	public void setRegistroContable(String registroContable) {
		this.registroContable = registroContable;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idDocumentoContable: ").append(this.idDocumentoContable).append(" ]");
		result.append(", [ idFicheroContable: ").append(this.idFicheroContable).append(" ]");
		result.append(", [ idExpediente: ").append(this.idExpediente).append(" ]");
		result.append(", [ fechaDocumentoD: ").append(this.fechaDocumentoD).append(" ]");
		result.append(", [ refIntD: ").append(this.refIntD).append(" ]");
		result.append(", [ idPagoConvocatoria: ").append(this.idPagoConvocatoria).append(" ]");
		result.append(", [ refIntO: ").append(this.refIntO).append(" ]");
		result.append(", [ tipoRegistro: ").append(this.tipoRegistro).append(" ]");
		result.append(", [ tipoDocumento: ").append(this.tipoDocumento).append(" ]");
		result.append(", [ numeroExpediente: ").append(this.numeroExpediente).append(" ]");
		result.append(", [ ejercicioAplPre: ").append(this.ejercicioAplPre).append(" ]");
		result.append(", [ agrupacion: ").append(this.agrupacion).append(" ]");
		result.append(", [ gastoIngreso: ").append(this.gastoIngreso).append(" ]");
		result.append(", [ seccion: ").append(this.seccion).append(" ]");
		result.append(", [ servicio: ").append(this.servicio).append(" ]");
		result.append(", [ centro: ").append(this.centro).append(" ]");
		result.append(", [ territorio: ").append(this.territorio).append(" ]");
		result.append(", [ cac: ").append(this.cac).append(" ]");
		result.append(", [ sc: ").append(this.sc).append(" ]");
		result.append(", [ programa: ").append(this.programa).append(" ]");
		result.append(", [ partida: ").append(this.partida).append(" ]");
		result.append(", [ letraControl: ").append(this.letraControl).append(" ]");
		result.append(", [ ejercicioRefInt: ").append(this.ejercicioRefInt).append(" ]");
		result.append(", [ anyoOrigen: ").append(this.anyoOrigen).append(" ]");
		result.append(", [ numero: ").append(this.numero).append(" ]");
		result.append(", [ disponible: ").append(this.disponible).append(" ]");
		result.append(", [ conceptoResumido: ").append(this.conceptoResumido).append(" ]");
		result.append(", [ tercero: ").append(this.tercero).append(" ]");
		result.append(", [ importe: ").append(this.importe).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ obligacion: ").append(this.obligacion).append(" ]");
		result.append(", [ referenciaContratacion: ").append(this.referenciaContratacion).append(" ]");
		result.append(", [ numeroPlurianual: ").append(this.numeroPlurianual).append(" ]");
		result.append(", [ codigoSubvencion: ").append(this.codigoSubvencion).append(" ]");
		result.append(", [ ejercicioCompromiso1: ").append(this.ejercicioCompromiso1).append(" ]");
		result.append(", [ ejercicioCompromiso2: ").append(this.ejercicioCompromiso2).append(" ]");
		result.append(", [ ejercicioCompromiso3: ").append(this.ejercicioCompromiso3).append(" ]");
		result.append(", [ ejercicioCompromiso4: ").append(this.ejercicioCompromiso4).append(" ]");
		result.append(", [ importeCompromiso1: ").append(this.importeCompromiso1).append(" ]");
		result.append(", [ importeCompromiso2: ").append(this.importeCompromiso2).append(" ]");
		result.append(", [ importeCompromiso3: ").append(this.importeCompromiso3).append(" ]");
		result.append(", [ importeCompromiso4: ").append(this.importeCompromiso4).append(" ]");
		result.append(", [ importeCompromisoResto: ").append(this.importeCompromisoResto).append(" ]");
		result.append(", [ ejercicioMaquetaTercero: ").append(this.ejercicioMaquetaTercero).append(" ]");
		result.append(", [ numeroMaquetaTercero: ").append(this.numeroMaquetaTercero).append(" ]");
		result.append("}");
		return result.toString();
	}

}
