package com.ejie.ab60.model.moduloContable;

import com.ejie.ab60.comun.Constantes;
import com.ejie.ab60.model.pagos.PagosConvocatoria;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import java.math.BigDecimal;
import java.util.Date;
import java.util.Locale;

import org.springframework.context.i18n.LocaleContextHolder;

/**
 * FicherosContables  
 * 
 *  
 */

public class FicherosContables implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idFicheroContable;
	private Integer idConvocatoria;
	private String nombreFichero;
	private Long idTipoDocCon;
	private String descTipoDocCon;
	private String descTipoDocConEs;
	private String descTipoDocConEu;
	private String descEstado;
	private Integer estado;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private BigDecimal importe;
	private Integer numeroRegistros;

	// datos de cabeceraLOT
	private String tipoRegistro;
	private String institucion;
	private String ejercicio;
	private String seccion;
	private String origenMaqueta;
	private String identificadorCinta;
	private String usuario;
	private Long idIdioma;
	// descripciones del idioma
	private String descripcionCastellano;
	private String descripcionEuskera;

	/**
	 * Method 'FicherosContables'.
	 */
	public FicherosContables() {
	}

	/**
	 * Method 'FicherosContables'.
	 * 
	 * @param idFicheroContable
	 *            Integer
	 */
	public FicherosContables(Integer idFicheroContable) {
		this.idFicheroContable = idFicheroContable;
	}

	/**
	 * Method 'FicherosContables'.
	 * 
	 * @param idFicheroContable
	 *            Integer
	 * @param idConvocatoria
	 *            Integer
	 * @param nombreFichero
	 *            String
	 * @param idTipoDocCon
	 *            Long
	 * @param estado
	 *            Integer
	 * @param tipoRegistro
	 *            String
	 * @param institucion
	 *            Integer
	 * @param ejercicio
	 *            Long
	 * @param seccion
	 *            Long
	 * @param origenMaqueta
	 *            String
	 * @param identificadorCinta
	 *            Long
	 * @param usuario
	 *            String
	 * @param idIdioma
	 *            Long
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 */
	public FicherosContables(Integer idFicheroContable, Integer idConvocatoria, String nombreFichero, Long idTipoDocCon,
			Integer estado, String tipoRegistro, String institucion, String ejercicio, String seccion,
			String origenMaqueta, String identificadorCinta, String usuario, Long idIdioma, Date fechaRegistro,
			String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion) {

		this.idFicheroContable = idFicheroContable;
		this.idConvocatoria = idConvocatoria;
		this.nombreFichero = nombreFichero;
		this.idTipoDocCon = idTipoDocCon;
		this.estado = estado;
		this.tipoRegistro = tipoRegistro;
		this.institucion = institucion;
		this.ejercicio = ejercicio;
		this.seccion = seccion;
		this.origenMaqueta = origenMaqueta;
		this.identificadorCinta = identificadorCinta;
		this.usuario = usuario;
		this.idIdioma = idIdioma;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	public FicherosContables(Integer idFicheroContable, Integer idConvocatoria, String nombreFichero, Long idTipoDocCon,
			String descTipoDocConEs, String descTipoDocConEu, Integer estado, String tipoRegistro, String institucion,
			String ejercicio, String seccion, String origenMaqueta, String identificadorCinta, String usuario,
			Long idIdioma, String descripcionCas, String descripcionEusk, Date fechaRegistro, String usuarioRegistro,
			Date fechaUltmodificacion, String usuarioUltmodificacion) {

		this.idFicheroContable = idFicheroContable;
		this.idConvocatoria = idConvocatoria;
		this.nombreFichero = nombreFichero;
		this.idTipoDocCon = idTipoDocCon;
		this.descTipoDocConEs = descTipoDocConEs;
		this.descTipoDocConEu = descTipoDocConEu;
		this.estado = estado;
		this.tipoRegistro = tipoRegistro;
		this.institucion = institucion;
		this.ejercicio = ejercicio;
		this.seccion = seccion;
		this.origenMaqueta = origenMaqueta;
		this.identificadorCinta = identificadorCinta;
		this.usuario = usuario;
		this.idIdioma = idIdioma;
		this.descripcionCastellano = descripcionCas;
		this.descripcionEuskera = descripcionEusk;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	public FicherosContables(Integer idFicheroContable, Integer idConvocatoria, String nombreFichero, Long idTipoDocCon,
			String descTipoDocConEs, String descTipoDocConEu, Integer estado, String tipoRegistro, String institucion,
			String ejercicio, String seccion, String origenMaqueta, String identificadorCinta, String usuario,
			Long idIdioma, Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion,
			String usuarioUltmodificacion, BigDecimal importe, Integer numeroRegistros) {

		this.idFicheroContable = idFicheroContable;
		this.idConvocatoria = idConvocatoria;
		this.nombreFichero = nombreFichero;
		this.idTipoDocCon = idTipoDocCon;
		this.descTipoDocConEs = descTipoDocConEs;
		this.descTipoDocConEu = descTipoDocConEu;
		this.estado = estado;
		this.tipoRegistro = tipoRegistro;
		this.institucion = institucion;
		this.ejercicio = ejercicio;
		this.seccion = seccion;
		this.origenMaqueta = origenMaqueta;
		this.identificadorCinta = identificadorCinta;
		this.usuario = usuario;
		this.idIdioma = idIdioma;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.importe = importe;
		this.numeroRegistros = numeroRegistros;
	}

	/**
	 * Method 'FicherosContables'.
	 * 
	 * @param nombreFichero
	 *            String
	 * @param institucion
	 *            Integer
	 * @param ejercicio
	 *            Long
	 * @param seccion
	 *            Long
	 * @param usuario
	 *            String
	 * @param idIdioma
	 *            Long
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 */
	public FicherosContables(Integer idConvocatoria, String nombreFichero, String institucion, String ejercicio,
			String seccion, String usuario, Long idIdioma, String descripcionCastellano, String descripcionEuskera,
			String origenMaqueta) {

		this.idConvocatoria = idConvocatoria;
		this.nombreFichero = nombreFichero;
		this.institucion = institucion;
		this.ejercicio = ejercicio;
		this.seccion = seccion;
		this.usuario = usuario;
		this.idIdioma = idIdioma;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.origenMaqueta = origenMaqueta;
	}

	/**
	 * Method 'getIdFicheroContable'.
	 *
	 * @return Integer
	 */

	public Integer getIdFicheroContable() {
		return this.idFicheroContable;
	}

	/**
	 * Method 'setIdFicheroContable'.
	 *
	 * @param idFicheroContable
	 *            Integer
	 * @return
	 */

	public void setIdFicheroContable(Integer idFicheroContable) {
		this.idFicheroContable = idFicheroContable;
	}

	/**
	 * Method 'getIdConvocatoria'.
	 *
	 * @return Integer
	 */

	public Integer getIdConvocatoria() {
		return this.idConvocatoria;
	}

	/**
	 * Method 'setIdConvocatoria'.
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @return
	 */

	public void setIdConvocatoria(Integer idConvocatoria) {
		this.idConvocatoria = idConvocatoria;
	}

	/**
	 * Method 'getNombreFichero'.
	 *
	 * @return String
	 */

	public String getNombreFichero() {
		return this.nombreFichero;
	}

	/**
	 * Method 'setNombreFichero'.
	 *
	 * @param nombreFichero
	 *            String
	 * @return
	 */

	public void setNombreFichero(String nombreFichero) {
		this.nombreFichero = nombreFichero;
	}

	/**
	 * Method 'getIdTipoDocCon'.
	 *
	 * @return Long
	 */

	public Long getIdTipoDocCon() {
		return this.idTipoDocCon;
	}

	/**
	 * Method 'setIdTipoDocCon'.
	 *
	 * @param idTipoDocCon
	 *            Long
	 * @return
	 */

	public void setIdTipoDocCon(Long idTipoDocCon) {
		this.idTipoDocCon = idTipoDocCon;
	}

	/**
	 * @return the descTipoDocCon
	 */
	/*
	 * public String getDescEstado() { if (estado == 0) descEstado =
	 * "Pendiente de generar"; else if (estado == 1) descEstado = "Generado";
	 * else descEstado = ""; return descEstado; }
	 */

	/**
	 * @return the descTipoDocCon
	 */
	/*
	 * Borrar porque la descripcion se obtiene de la tabla AB6097T00 public
	 * String getDescTipoDocCon() { if (idTipoDocCon ==
	 * Constantes.TIPO_DOCUMENTO_CONTABLE_D) descTipoDocCon = "D"; else if
	 * (idTipoDocCon == Constantes.TIPO_DOCUMENTO_CONTABLE_O) descTipoDocCon =
	 * "O"; else if (idTipoDocCon == Constantes.TIPO_DOCUMENTO_CONTABLE_DO)
	 * descTipoDocCon = "DO"; else descTipoDocCon = "";
	 * 
	 * return descTipoDocCon; }
	 */

	/**
	 * Method 'getEstado'.
	 *
	 * @return Integer
	 */

	public Integer getEstado() {
		return this.estado;
	}

	/**
	 * Method 'setEstado'.
	 *
	 * @param estado
	 *            Integer
	 * @return
	 */

	public void setEstado(Integer estado) {
		this.estado = estado;
	}

	/**
	 * Method 'getTipoRegistro'.
	 *
	 * @return String
	 */

	public String getTipoRegistro() {
		return this.tipoRegistro;
	}

	/**
	 * Method 'setTipoRegistro'.
	 *
	 * @param tipoRegistro
	 *            String
	 * @return
	 */

	public void setTipoRegistro(String tipoRegistro) {
		this.tipoRegistro = tipoRegistro;
	}

	/**
	 * Method 'getInstitucion'.
	 *
	 * @return Integer
	 */

	public String getInstitucion() {
		return this.institucion;
	}

	/**
	 * Method 'setInstitucion'.
	 *
	 * @param institucion
	 *            Integer
	 * @return
	 */

	public void setInstitucion(String institucion) {
		this.institucion = institucion;
	}

	/**
	 * Method 'getEjercicio'.
	 *
	 * @return Long
	 */

	public String getEjercicio() {
		return this.ejercicio;
	}

	/**
	 * Method 'setEjercicio'.
	 *
	 * @param ejercicio
	 *            Long
	 * @return
	 */

	public void setEjercicio(String ejercicio) {
		this.ejercicio = ejercicio;
	}

	/**
	 * Method 'getSeccion'.
	 *
	 * @return Long
	 */

	public String getSeccion() {
		return this.seccion;
	}

	/**
	 * Method 'setSeccion'.
	 *
	 * @param seccion
	 *            Long
	 * @return
	 */

	public void setSeccion(String seccion) {
		this.seccion = seccion;
	}

	/**
	 * Method 'getOrigenMaqueta'.
	 *
	 * @return String
	 */

	public String getOrigenMaqueta() {
		return this.origenMaqueta;
	}

	/**
	 * Method 'setOrigenMaqueta'.
	 *
	 * @param origenMaqueta
	 *            String
	 * @return
	 */

	public void setOrigenMaqueta(String origenMaqueta) {
		this.origenMaqueta = origenMaqueta;
	}

	/**
	 * Method 'getIdentificadorCinta'.
	 *
	 * @return Long
	 */

	public String getIdentificadorCinta() {
		return this.identificadorCinta;
	}

	/**
	 * Method 'setIdentificadorCinta'.
	 *
	 * @param identificadorCinta
	 *            Long
	 * @return
	 */

	public void setIdentificadorCinta(String identificadorCinta) {
		this.identificadorCinta = identificadorCinta;
	}

	/**
	 * Method 'getUsuario'.
	 *
	 * @return String
	 */

	public String getUsuario() {
		return this.usuario;
	}

	/**
	 * Method 'setUsuario'.
	 *
	 * @param usuario
	 *            String
	 * @return
	 */

	public void setUsuario(String usuario) {
		this.usuario = usuario;
	}

	/**
	 * Method 'getIdIdioma'.
	 *
	 * @return Long
	 */

	public Long getIdIdioma() {
		return this.idIdioma;
	}

	/**
	 * Method 'setIdIdioma'.
	 *
	 * @param idIdioma
	 *            Long
	 * @return
	 */

	public void setIdIdioma(Long idIdioma) {
		this.idIdioma = idIdioma;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idFicheroContable: ").append(this.idFicheroContable).append(" ]");
		result.append(", [ idConvocatoria: ").append(this.idConvocatoria).append(" ]");
		result.append(", [ nombreFichero: ").append(this.nombreFichero).append(" ]");
		result.append(", [ idTipoDocCon: ").append(this.idTipoDocCon).append(" ]");
		result.append(", [ estado: ").append(this.estado).append(" ]");
		result.append(", [ tipoRegistro: ").append(this.tipoRegistro).append(" ]");
		result.append(", [ institucion: ").append(this.institucion).append(" ]");
		result.append(", [ ejercicio: ").append(this.ejercicio).append(" ]");
		result.append(", [ seccion: ").append(this.seccion).append(" ]");
		result.append(", [ origenMaqueta: ").append(this.origenMaqueta).append(" ]");
		result.append(", [ identificadorCinta: ").append(this.identificadorCinta).append(" ]");
		result.append(", [ usuario: ").append(this.usuario).append(" ]");
		result.append(", [ idIdioma: ").append(this.idIdioma).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

	public String getDescripcionCastellano() {
		return descripcionCastellano;
	}

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	public String getDescripcionEuskera() {
		return descripcionEuskera;
	}

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	public String getDescripcionPorIdioma() {
		String idioma = LocaleContextHolder.getLocale().getLanguage();
		if (Constantes.CASTELLANO.equalsIgnoreCase(idioma)) {
			return this.descripcionCastellano;
		} else {
			return this.descripcionEuskera;
		}
	}

	/**
	 * @return the importe
	 */
	public BigDecimal getImporte() {
		return importe;
	}

	/**
	 * @param importe
	 *            the importe to set
	 */
	public void setImporte(BigDecimal importe) {
		this.importe = importe;
	}

	/**
	 * @return the numeroRegistros
	 */
	public Integer getNumeroRegistros() {
		return numeroRegistros;
	}

	/**
	 * @param numeroRegistros
	 *            the numeroRegistros to set
	 */
	public void setNumeroRegistros(Integer numeroRegistros) {
		this.numeroRegistros = numeroRegistros;
	}

	public String getImporteMask() {
		return UtilDate.formatearMiles(importe);

	}

	/**
	 * @return the descTipoDocCon
	 */
	public String getDescTipoDocCon() {
		Locale locale = LocaleContextHolder.getLocale();
		String idioma = locale.getLanguage();
		if (Constantes.EUSKERA.equalsIgnoreCase(idioma)) {
			return this.descTipoDocConEu;
		} else {
			return this.descTipoDocConEs;
		}
	}

	/**
	 * @return the descTipoDocConEs
	 */
	public String getDescTipoDocConEs() {
		return descTipoDocConEs;
	}

	/**
	 * @param descTipoDocConEs
	 *            the descTipoDocConEs to set
	 */
	public void setDescTipoDocConEs(String descTipoDocConEs) {
		this.descTipoDocConEs = descTipoDocConEs;
	}

	/**
	 * @return the descTipoDocConEu
	 */
	public String getDescTipoDocConEu() {
		return descTipoDocConEu;
	}

	/**
	 * @param descTipoDocConEu
	 *            the descTipoDocConEu to set
	 */
	public void setDescTipoDocConEu(String descTipoDocConEu) {
		this.descTipoDocConEu = descTipoDocConEu;
	}

}