package com.ejie.ab60.model.moduloContable;

import java.math.BigDecimal;
import java.util.List;

/**
 * Convocatorias  
 * 
 *  
 */

public class ModuloContable implements java.io.Serializable {

	private static final long serialVersionUID = 1L;

	private Integer idProcedimiento;
	private DocumentosContables docContables;
	private FicherosContables ficherosContables;
	private String idsExpedientesSeleccionados;
	private String rutaPIF;
	private BigDecimal importeDisponibleApl;
	private List<DocContables> listaDocContables;

	/**
	 * Method 'DocContables'.
	 */
	public ModuloContable() {
	}

	/**
	 * Method 'DocContables'.
	 * 
	 * @param idExpediente
	 *            Integer
	 * @param idProcedimiento
	 *            Integer
	 * @param expediente
	 *            String
	 * @param conceptoResumido
	 *            String
	 * @param subvencionResuelta
	 *            BigDecimal
	 * @param aplicacionPresupuestaria
	 *            String
	 * @param referenciaIntervencion
	 *            Long
	 * @param tipoTercero
	 *            BigDecimal
	 * @param codigoTercero
	 *            BigDecimal
	 * @param versionTercero
	 *            BigDecimal
	 * @param fechaDocumentoD
	 *            Date
	 * @param refIntD
	 *            String
	 * @param idTipoDocCon
	 *            Long
	 */
	public ModuloContable(Integer idProcedimiento, DocumentosContables docContables,
			FicherosContables ficherosContables) {
		this.idProcedimiento = idProcedimiento;
		this.docContables = docContables;
		this.ficherosContables = ficherosContables;

	}

	/**
	 * @return the idsExpedientesSeleccionados
	 */
	public String getIdsExpedientesSeleccionados() {
		return idsExpedientesSeleccionados;
	}

	/**
	 * @param idsExpedientesSeleccionados
	 *            the idsExpedientesSeleccionados to set
	 */
	public void setIdsExpedientesSeleccionados(String idsExpedientesSeleccionados) {
		this.idsExpedientesSeleccionados = idsExpedientesSeleccionados;
	}

	public Integer getIdProcedimiento() {
		return this.idProcedimiento;
	}

	/**
	 * Method 'setIdProcedimiento'.
	 *
	 * @param idProcedimiento
	 *            Integer
	 * @return
	 */

	public void setIdProcedimiento(Integer idProcedimiento) {
		this.idProcedimiento = idProcedimiento;
	}

	/**
	 * Method 'getExpediente'.
	 *
	 * @return String
	 */

	/**
	 * @return the docContables
	 */
	public DocumentosContables getDocContables() {
		return docContables;
	}

	/**
	 * @param docContables
	 *            the docContables to set
	 */
	public void setDocContables(DocumentosContables docContables) {
		this.docContables = docContables;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		// Clave compuesta

		result.append(", [ idProcedimiento: ").append(this.idProcedimiento).append(" ]");
		result.append("}");
		return result.toString();
	}

	public FicherosContables getFicherosContables() {
		return ficherosContables;
	}

	public void setFicherosContables(FicherosContables ficherosContables) {
		this.ficherosContables = ficherosContables;
	}

	/**
	 * @return the importeDisponibleApl
	 */
	public BigDecimal getImporteDisponibleApl() {
		return importeDisponibleApl;
	}

	/**
	 * @param importeDisponibleApl
	 *            the importeDisponibleApl to set
	 */
	public void setImporteDisponibleApl(BigDecimal importeDisponibleApl) {
		this.importeDisponibleApl = importeDisponibleApl;
	}

	public String getRutaPIF() {
		return rutaPIF;
	}

	public void setRutaPIF(String rutaPIF) {
		this.rutaPIF = rutaPIF;
	}

	public List<DocContables> getListaDocContables() {
		return listaDocContables;
	}

	public void setListaDocContables(List<DocContables> listaDocContables) {
		this.listaDocContables = listaDocContables;
	}

}
