package com.ejie.ab60.model.moduloContable;


import com.ejie.ab60.comun.Constantes;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.util.Date;

import org.springframework.context.i18n.LocaleContextHolder;

/**
 * TiposDocContables  
 *  
 */

public class TiposDocContables  implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
            private Long idTipoDocCon;
            private String descripcionCastellano;
            private String descripcionEuskera;
            private Date fechaRegistro;
            private String usuarioRegistro;

	/** 
	 * Method 'TiposDocContables'.
	 */
    public TiposDocContables() {
    }


	
    
    /** 
     * Method 'TiposDocContables'.
     * @param idTipoDocCon Long
     */    
     public TiposDocContables(Long idTipoDocCon) {
          this.idTipoDocCon = idTipoDocCon;
	}

    

    /** 
     * Method 'TiposDocContables'.
     * @param idTipoDocCon Long
     * @param descripcionCastellano String
     * @param descripcionEuskera String
     * @param fechaRegistro Date
     * @param usuarioRegistro String
     */
   public TiposDocContables(Long idTipoDocCon, String descripcionCastellano, String descripcionEuskera, Date fechaRegistro, String usuarioRegistro) {	

           this.idTipoDocCon = idTipoDocCon;
           this.descripcionCastellano = descripcionCastellano;
           this.descripcionEuskera = descripcionEuskera;
           this.fechaRegistro = fechaRegistro;
           this.usuarioRegistro = usuarioRegistro;
    }

    /**
	 * Method 'getIdTipoDocCon'.
	 *
	 * @return Long
	 */
	
	
	public Long getIdTipoDocCon() {
		return this.idTipoDocCon;
	}

	/**
	 * Method 'setIdTipoDocCon'.
	 *
	 * @param idTipoDocCon Long
	 * @return
     */
	
	public void setIdTipoDocCon(Long idTipoDocCon) {
		this.idTipoDocCon = idTipoDocCon;
	}
    /**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */
	
	
	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano String
	 * @return
     */
	
	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}
    /**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */
	
	
	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera String
	 * @return
     */
	
	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}
    /**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */
	
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro java.util.Date
	 * @return
     */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}
    /**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */
	
	
	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro String
	 * @return
     */
	
	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	public String getDescripcionPorIdioma (){
		String idioma = LocaleContextHolder.getLocale().getLanguage();
		if (Constantes.CASTELLANO.equalsIgnoreCase(idioma)) {
			return this.descripcionCastellano;
		} else {
			return this.descripcionEuskera;
		}
	}	
	
	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { " ); 
		result.append(" [ idTipoDocCon: ").append(this.idTipoDocCon).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}


}

