package com.ejie.ab60.model.pagos;

import java.math.BigDecimal;
import java.util.Date;

import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * PagosConvocatoria  
 * 
 *  
 */

public class PagosConvocatoria implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idPagoConvocatoria;
	private Convocatorias convocatorias;
	private Long numeroPago;
	private BigDecimal porcentajePago;
	private Long anyoPresupuesto;
	private String observaciones;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;

	/**
	 * Method 'PagosConvocatoria'.
	 */
	public PagosConvocatoria() {
	}

	/**
	 * Method 'PagosConvocatoria'.
	 * 
	 * @param idPagoConvocatoria
	 *            Integer
	 */
	public PagosConvocatoria(Integer idPagoConvocatoria) {
		this.idPagoConvocatoria = idPagoConvocatoria;
	}

	/**
	 * Method 'PagosConvocatoria'.
	 * 
	 * @param idPagoConvocatoria
	 *            Integer
	 * @param numeroPago
	 *            Long
	 * @param porcentajePago
	 *            BigDecimal
	 * @param anyoPresupuesto
	 *            Long
	 * @param observaciones
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param convocatorias
	 *            Convocatorias
	 */
	public PagosConvocatoria(Integer idPagoConvocatoria, Long numeroPago, BigDecimal porcentajePago,
			Long anyoPresupuesto, String observaciones, Date fechaRegistro, String usuarioRegistro,
			Date fechaUltmodificacion, String usuarioUltmodificacion, Convocatorias convocatorias) {

		this.idPagoConvocatoria = idPagoConvocatoria;
		this.convocatorias = convocatorias;
		this.numeroPago = numeroPago;
		this.porcentajePago = porcentajePago;
		this.anyoPresupuesto = anyoPresupuesto;
		this.observaciones = observaciones;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	public PagosConvocatoria(Integer idPagoConvocatoria, Long numeroPago) {

		this.idPagoConvocatoria = idPagoConvocatoria;
		this.numeroPago = numeroPago;
	}

	/**
	 * Method 'getIdPagoConvocatoria'.
	 *
	 * @return Integer
	 */

	public Integer getIdPagoConvocatoria() {
		return this.idPagoConvocatoria;
	}

	/**
	 * Method 'setIdPagoConvocatoria'.
	 *
	 * @param idPagoConvocatoria
	 *            Integer
	 * @return
	 */

	public void setIdPagoConvocatoria(Integer idPagoConvocatoria) {
		this.idPagoConvocatoria = idPagoConvocatoria;
	}

	/**
	 * Method 'getConvocatorias'.
	 *
	 * @return Convocatorias
	 */
	@JsonIgnore

	public Convocatorias getConvocatorias() {
		return this.convocatorias;
	}

	/**
	 * Method 'setConvocatorias'.
	 *
	 * @param convocatorias
	 *            Convocatorias
	 * @return
	 */

	public void setConvocatorias(Convocatorias convocatorias) {
		this.convocatorias = convocatorias;
	}

	/**
	 * Method 'getNumeroPago'.
	 *
	 * @return Long
	 */

	public Long getNumeroPago() {
		return this.numeroPago;
	}

	/**
	 * Method 'setNumeroPago'.
	 *
	 * @param numeroPago
	 *            Long
	 * @return
	 */

	public void setNumeroPago(Long numeroPago) {
		this.numeroPago = numeroPago;
	}

	/**
	 * Method 'getPorcentajePago'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getPorcentajePago() {
		return this.porcentajePago;
	}

	/**
	 * Method 'setPorcentajePago'.
	 *
	 * @param porcentajePago
	 *            BigDecimal
	 * @return
	 */

	public void setPorcentajePago(BigDecimal porcentajePago) {
		this.porcentajePago = porcentajePago;
	}

	/**
	 * Method 'getAnyoPresupuesto'.
	 *
	 * @return Long
	 */

	public Long getAnyoPresupuesto() {
		return this.anyoPresupuesto;
	}

	/**
	 * Method 'setAnyoPresupuesto'.
	 *
	 * @param anyoPresupuesto
	 *            Long
	 * @return
	 */

	public void setAnyoPresupuesto(Long anyoPresupuesto) {
		this.anyoPresupuesto = anyoPresupuesto;
	}

	/**
	 * Method 'getObservaciones'.
	 *
	 * @return String
	 */

	public String getObservaciones() {
		return this.observaciones;
	}

	/**
	 * Method 'setObservaciones'.
	 *
	 * @param observaciones
	 *            String
	 * @return
	 */

	public void setObservaciones(String observaciones) {
		this.observaciones = observaciones;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idPagoConvocatoria: ").append(this.idPagoConvocatoria).append(" ]");
		result.append(", [ numeroPago: ").append(this.numeroPago).append(" ]");
		result.append(", [ porcentajePago: ").append(this.porcentajePago).append(" ]");
		result.append(", [ anyoPresupuesto: ").append(this.anyoPresupuesto).append(" ]");
		result.append(", [ observaciones: ").append(this.observaciones).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

}
