package com.ejie.ab60.service.BEC;


import com.ejie.ab60.model.BEC.Caracteristicas;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * CaracteristicasService  
 *  
 */

public interface CaracteristicasService {

	/**
	 * Inserts a single row in the Caracteristicas table.
	 *
	 * @param caracteristicas Caracteristicas
	 * @return Caracteristicas
	 */
    Caracteristicas add(Caracteristicas caracteristicas);

	/**
	 * Updates a single row in the Caracteristicas table.
	 *
	 * @param caracteristicas Caracteristicas
	 * @return Caracteristicas
	 */
	Caracteristicas update(Caracteristicas caracteristicas);

	/**
	 * Finds a single row in the Caracteristicas table.
	 *
	 * @param caracteristicas Caracteristicas
	 * @return Caracteristicas
	 */
	Caracteristicas find(Caracteristicas caracteristicas);

	/**
	 * Deletes a single row in the Caracteristicas table.
	 *
	 * @param caracteristicas Caracteristicas
	 */
	void remove(Caracteristicas caracteristicas);

	/**
	 * Finds a list of rows in the Caracteristicas table.
	 *
	 * @param caracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<Caracteristicas>
	 */
	List<Caracteristicas> findAll(Caracteristicas caracteristicas, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Caracteristicas table using like.
	 *
	 * @param caracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean	 
	 * @return List<Caracteristicas>
	 */
	List<Caracteristicas> findAllLike(Caracteristicas caracteristicas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Caracteristicas table.
	 *
	 * @param filterCaracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	void removeMultiple(Caracteristicas filterCaracteristicas, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
   
    
	/**
	 * Filter method in the Caracteristicas table.
	 *
	 * @param filterCaracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<Caracteristicas>
	 */	
	JQGridResponseDto<Caracteristicas> filter(Caracteristicas filterCaracteristicas, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
    
    /**
	 * Searches rows in the Caracteristicas table.
	 *
	 * @param filterCaracteristicas Caracteristicas
	 * @param searchCaracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<Caracteristicas>>
	 */	
    List<TableRowDto<Caracteristicas>> search(Caracteristicas filterCaracteristicas, Caracteristicas searchCaracteristicas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /**
	 * Reorder the selection made in Caracteristicas table.
	 *
	 * @param filterCaracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    Object reorderSelection(Caracteristicas filterCaracteristicas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the Caracteristicas table.
	 *
	 * @param filterCaracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Caracteristicas>>
	 */	
	JQGridResponseDto<JerarquiaDto<Caracteristicas>> jerarquia(Caracteristicas filterCaracteristicas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	/**
	 * Finder method for siblings rows in the hierarchical the Caracteristicas table.
	 *
	 * @param filterCaracteristicas Caracteristicas
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Caracteristicas>>
	 */	
	JQGridResponseDto<JerarquiaDto<Caracteristicas>> jerarquiaChildren(Caracteristicas filterCaracteristicas, JQGridRequestDto jqGridRequestDto);
    
}


