package com.ejie.ab60.service.BEC;

import com.ejie.ab60.model.BEC.Curriculum;
import com.ejie.ab60.model.BEC.Puntuaciones;
import com.ejie.ab60.model.estudioTecnico.EstudioTecnico;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * CurriculumService  
 * 
 *  
 */

public interface CurriculumService {

	/**
	 * Inserts a single row in the Curriculum table.
	 *
	 * @param curriculum
	 *            Curriculum
	 * @return Curriculum
	 */
	Curriculum add(Curriculum curriculum);

	/**
	 * Updates a single row in the Curriculum table.
	 *
	 * @param curriculum
	 *            Curriculum
	 * @return Curriculum
	 */
	Curriculum update(Curriculum curriculum);

	/**
	 * Updates a single row in the Curriculum table.
	 *
	 * @param curriculum
	 *            Curriculum
	 * @return Curriculum
	 */
	Curriculum save(Integer idExpediente, Curriculum curriculum, Usuario usuario);

	/**
	 * Finds a single row in the Curriculum table.
	 *
	 * @param curriculum
	 *            Curriculum
	 * @return Curriculum
	 */
	Curriculum find(Curriculum curriculum);

	/**
	 * Deletes a single row in the Curriculum table.
	 *
	 * @param curriculum
	 *            Curriculum
	 */
	void remove(Curriculum curriculum);

	/**
	 * Finds a list of rows in the Curriculum table.
	 *
	 * @param curriculum
	 *            Curriculum
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Curriculum>
	 */
	List<Curriculum> findAll(Curriculum curriculum, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Curriculum table using like.
	 *
	 * @param curriculum
	 *            Curriculum
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Curriculum>
	 */
	List<Curriculum> findAllLike(Curriculum curriculum, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Curriculum table.
	 *
	 * @param filterCurriculum
	 *            Curriculum
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Curriculum filterCurriculum, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Curriculum table.
	 *
	 * @param filterCurriculum
	 *            Curriculum
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Curriculum>
	 */
	JQGridResponseDto<Curriculum> filter(Curriculum filterCurriculum, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the Curriculum table.
	 *
	 * @param filterCurriculum
	 *            Curriculum
	 * @param searchCurriculum
	 *            Curriculum
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Curriculum>>
	 */
	List<TableRowDto<Curriculum>> search(Curriculum filterCurriculum, Curriculum searchCurriculum,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in Curriculum table.
	 *
	 * @param filterCurriculum
	 *            Curriculum
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Curriculum filterCurriculum, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Curriculum table.
	 *
	 * @param filterCurriculum
	 *            Curriculum
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Curriculum>>
	 */
	JQGridResponseDto<JerarquiaDto<Curriculum>> jerarquia(Curriculum filterCurriculum,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Curriculum table.
	 *
	 * @param filterCurriculum
	 *            Curriculum
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Curriculum>>
	 */
	JQGridResponseDto<JerarquiaDto<Curriculum>> jerarquiaChildren(Curriculum filterCurriculum,
			JQGridRequestDto jqGridRequestDto);
}
