package com.ejie.ab60.service.BEC;


import com.ejie.ab60.model.BEC.ExperienciaLaboral;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * ExperienciaLaboralService  
 *  
 */

public interface ExperienciaLaboralService {

	/**
	 * Inserts a single row in the ExperienciaLaboral table.
	 *
	 * @param experienciaLaboral ExperienciaLaboral
	 * @return ExperienciaLaboral
	 */
    ExperienciaLaboral add(ExperienciaLaboral experienciaLaboral);

	/**
	 * Updates a single row in the ExperienciaLaboral table.
	 *
	 * @param experienciaLaboral ExperienciaLaboral
	 * @return ExperienciaLaboral
	 */
	ExperienciaLaboral update(ExperienciaLaboral experienciaLaboral);

	/**
	 * Finds a single row in the ExperienciaLaboral table.
	 *
	 * @param experienciaLaboral ExperienciaLaboral
	 * @return ExperienciaLaboral
	 */
	ExperienciaLaboral find(ExperienciaLaboral experienciaLaboral);

	/**
	 * Deletes a single row in the ExperienciaLaboral table.
	 *
	 * @param experienciaLaboral ExperienciaLaboral
	 */
	void remove(ExperienciaLaboral experienciaLaboral);

	/**
	 * Finds a list of rows in the ExperienciaLaboral table.
	 *
	 * @param experienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<ExperienciaLaboral>
	 */
	List<ExperienciaLaboral> findAll(ExperienciaLaboral experienciaLaboral, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ExperienciaLaboral table using like.
	 *
	 * @param experienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean	 
	 * @return List<ExperienciaLaboral>
	 */
	List<ExperienciaLaboral> findAllLike(ExperienciaLaboral experienciaLaboral, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the ExperienciaLaboral table.
	 *
	 * @param filterExperienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	void removeMultiple(ExperienciaLaboral filterExperienciaLaboral, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
   
    
	/**
	 * Filter method in the ExperienciaLaboral table.
	 *
	 * @param filterExperienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<ExperienciaLaboral>
	 */	
	JQGridResponseDto<ExperienciaLaboral> filter(ExperienciaLaboral filterExperienciaLaboral, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
    
    /**
	 * Searches rows in the ExperienciaLaboral table.
	 *
	 * @param filterExperienciaLaboral ExperienciaLaboral
	 * @param searchExperienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<ExperienciaLaboral>>
	 */	
    List<TableRowDto<ExperienciaLaboral>> search(ExperienciaLaboral filterExperienciaLaboral, ExperienciaLaboral searchExperienciaLaboral, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /**
	 * Reorder the selection made in ExperienciaLaboral table.
	 *
	 * @param filterExperienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    Object reorderSelection(ExperienciaLaboral filterExperienciaLaboral, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the ExperienciaLaboral table.
	 *
	 * @param filterExperienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<JerarquiaDto<ExperienciaLaboral>>
	 */	
	JQGridResponseDto<JerarquiaDto<ExperienciaLaboral>> jerarquia(ExperienciaLaboral filterExperienciaLaboral, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	/**
	 * Finder method for siblings rows in the hierarchical the ExperienciaLaboral table.
	 *
	 * @param filterExperienciaLaboral ExperienciaLaboral
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<ExperienciaLaboral>>
	 */	
	JQGridResponseDto<JerarquiaDto<ExperienciaLaboral>> jerarquiaChildren(ExperienciaLaboral filterExperienciaLaboral, JQGridRequestDto jqGridRequestDto);
    
}


