package com.ejie.ab60.service.BEC;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.BEC.Fases;

/**
 * FasesService  
 * 
 *  
 */

public interface FasesService {

	/**
	 * Inserts a single row in the Fases table.
	 *
	 * @param fases
	 *            Fases
	 * @return Fases
	 */
	Fases add(Fases fases);

	/**
	 * Updates a single row in the Fases table.
	 *
	 * @param fases
	 *            Fases
	 * @return Fases
	 */
	Fases update(Fases fases);

	/**
	 * Finds a single row in the Fases table.
	 *
	 * @param fases
	 *            Fases
	 * @return Fases
	 */
	Fases find(Fases fases);

	/**
	 * Finds a list of rows in the Fases table.
	 *
	 * 
	 * @return List<Fases>
	 */
	List<Fases> findFases();

	/**
	 * Deletes a single row in the Fases table.
	 *
	 * @param fases
	 *            Fases
	 */
	void remove(Fases fases);

	/**
	 * Finds a list of rows in the Fases table.
	 *
	 * @param fases
	 *            Fases
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Fases>
	 */
	List<Fases> findAll(Fases fases, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Fases table using like.
	 *
	 * @param fases
	 *            Fases
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Fases>
	 */
	List<Fases> findAllLike(Fases fases, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Fases table.
	 *
	 * @param filterFases
	 *            Fases
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Fases filterFases, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Fases table.
	 *
	 * @param filterFases
	 *            Fases
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Fases>
	 */
	JQGridResponseDto<Fases> filter(Fases filterFases, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the Fases table.
	 *
	 * @param filterFases
	 *            Fases
	 * @param searchFases
	 *            Fases
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Fases>>
	 */
	List<TableRowDto<Fases>> search(Fases filterFases, Fases searchFases, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Reorder the selection made in Fases table.
	 *
	 * @param filterFases
	 *            Fases
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Fases filterFases, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Fases table.
	 *
	 * @param filterFases
	 *            Fases
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Fases>>
	 */
	JQGridResponseDto<JerarquiaDto<Fases>> jerarquia(Fases filterFases, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Fases table.
	 *
	 * @param filterFases
	 *            Fases
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Fases>>
	 */
	JQGridResponseDto<JerarquiaDto<Fases>> jerarquiaChildren(Fases filterFases, JQGridRequestDto jqGridRequestDto);

}
