package com.ejie.ab60.service.BEC;

import com.ejie.ab60.model.BEC.OtrosTitulos;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * OtrosTitulosService  
 * 
 *  
 */

public interface OtrosTitulosService {

	/**
	 * Inserts a single row in the OtrosTitulos table.
	 *
	 * @param otrosTitulos
	 *            OtrosTitulos
	 * @return OtrosTitulos
	 */
	OtrosTitulos add(OtrosTitulos otrosTitulos);

	/**
	 * Updates a single row in the OtrosTitulos table.
	 *
	 * @param otrosTitulos
	 *            OtrosTitulos
	 * @return OtrosTitulos
	 */
	OtrosTitulos update(OtrosTitulos otrosTitulos);

	/**
	 * Finds a single row in the OtrosTitulos table.
	 *
	 * @param otrosTitulos
	 *            OtrosTitulos
	 * @return OtrosTitulos
	 */
	OtrosTitulos find(OtrosTitulos otrosTitulos);

	/**
	 * Deletes a single row in the OtrosTitulos table.
	 *
	 * @param otrosTitulos
	 *            OtrosTitulos
	 */
	void remove(OtrosTitulos otrosTitulos);

	/**
	 * Finds a list of rows in the OtrosTitulos table.
	 *
	 * @param otrosTitulos
	 *            OtrosTitulos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<OtrosTitulos>
	 */
	List<OtrosTitulos> findAll(OtrosTitulos otrosTitulos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the OtrosTitulos table using like.
	 *
	 * @param otrosTitulos
	 *            OtrosTitulos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<OtrosTitulos>
	 */
	List<OtrosTitulos> findAllLike(OtrosTitulos otrosTitulos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the OtrosTitulos table.
	 *
	 * @param filterOtrosTitulos
	 *            OtrosTitulos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(OtrosTitulos filterOtrosTitulos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the OtrosTitulos table.
	 *
	 * @param filterOtrosTitulos
	 *            OtrosTitulos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<OtrosTitulos>
	 */
	JQGridResponseDto<OtrosTitulos> filter(OtrosTitulos filterOtrosTitulos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the OtrosTitulos table.
	 *
	 * @param filterOtrosTitulos
	 *            OtrosTitulos
	 * @param searchOtrosTitulos
	 *            OtrosTitulos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OtrosTitulos>>
	 */
	List<TableRowDto<OtrosTitulos>> search(OtrosTitulos filterOtrosTitulos, OtrosTitulos searchOtrosTitulos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in OtrosTitulos table.
	 *
	 * @param filterOtrosTitulos
	 *            OtrosTitulos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(OtrosTitulos filterOtrosTitulos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the OtrosTitulos table.
	 *
	 * @param filterOtrosTitulos
	 *            OtrosTitulos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<OtrosTitulos>>
	 */
	JQGridResponseDto<JerarquiaDto<OtrosTitulos>> jerarquia(OtrosTitulos filterOtrosTitulos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the OtrosTitulos
	 * table.
	 *
	 * @param filterOtrosTitulos
	 *            OtrosTitulos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<OtrosTitulos>>
	 */
	JQGridResponseDto<JerarquiaDto<OtrosTitulos>> jerarquiaChildren(OtrosTitulos filterOtrosTitulos,
			JQGridRequestDto jqGridRequestDto);

}
