package com.ejie.ab60.service.BEC;

import com.ejie.ab60.model.BEC.Puntuaciones;
import com.ejie.ab60.model.pagos.PagosExpediente;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * PuntuacionesService  
 * 
 *  
 */

public interface PuntuacionesService {

	/**
	 * Inserts a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones add(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateCurriculum(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones addOrUpdateRequisitos(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones addOrUpdateConocimientos(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones addOrUpdateCurso(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones addOrUpdateResolucion(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateConocimientos(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateCurso(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateResolucion(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateBecarios(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateSuplentes(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones updateFasePuntuacion(Puntuaciones puntuaciones);

	/**
	 * Updates a single row in the Puntuaciones table.
	 * 
	 * @param idRow
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones intercambioBecariosSuplentes(Integer idProcedimiento, Integer idRow, Puntuaciones puntuaciones,
			Usuario usuario);

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones find(Puntuaciones puntuaciones);

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones findRequisitos(Puntuaciones puntuaciones);

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones findConocimientos(Puntuaciones puntuaciones);

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones findCurso(Puntuaciones puntuaciones);

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	Puntuaciones findResolucion(Puntuaciones puntuaciones);

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param idProcedimiento
	 *            Integer
	 * @return Puntuaciones
	 */
	Puntuaciones findPuntuacionMaxSuplentes(Integer idProcedimiento);

	/**
	 * Deletes a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 */
	void remove(Puntuaciones puntuaciones);

	/**
	 * Finds a list of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Puntuaciones>
	 */
	List<Puntuaciones> findAll(Puntuaciones puntuaciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return List<Puntuaciones>
	 */
	List<Puntuaciones> findExpedientesParaConocimientos(Puntuaciones puntuaciones, Integer idConvocatoria);

	/**
	 * Finds rows in the Puntuaciones table using like.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Puntuaciones>
	 */
	List<Puntuaciones> findAllLike(Puntuaciones puntuaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Puntuaciones filterPuntuaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Puntuaciones>
	 */
	JQGridResponseDto<Puntuaciones> filterFaseCurriculum(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finds rows in the Puntuaciones table using like.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Puntuaciones>
	 */
	List<Puntuaciones> findAllLikeExportExcelCurr(Puntuaciones puntuaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finds rows in the Puntuaciones table using like.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Puntuaciones>
	 */
	List<Puntuaciones> findAllLikeExportExcelCono(Puntuaciones puntuaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finds rows in the Puntuaciones table using like.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Puntuaciones>
	 */
	List<Puntuaciones> findAllLikeExportExcelCurso(Puntuaciones puntuaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finds rows in the Puntuaciones table using like.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Puntuaciones>
	 */
	List<Puntuaciones> findAllLikeExportExcelBecarios(Puntuaciones puntuaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finds rows in the Puntuaciones table using like.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Puntuaciones>
	 */
	List<Puntuaciones> findAllLikeExportExcelSuplentes(Puntuaciones puntuaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Puntuaciones>
	 */
	JQGridResponseDto<Puntuaciones> filterFaseConocimientos(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Puntuaciones>
	 */
	JQGridResponseDto<Puntuaciones> filterFaseCurso(Puntuaciones filterPuntuaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Puntuaciones>
	 */
	JQGridResponseDto<Puntuaciones> filterFaseBecasBecarios(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Puntuaciones>
	 */
	JQGridResponseDto<Puntuaciones> filterFaseBecasSuplentes(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param searchPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Puntuaciones>>
	 */
	List<TableRowDto<Puntuaciones>> search(Puntuaciones filterPuntuaciones, Puntuaciones searchPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Puntuaciones filterPuntuaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Puntuaciones>>
	 */
	JQGridResponseDto<JerarquiaDto<Puntuaciones>> jerarquia(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Puntuaciones
	 * table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Puntuaciones>>
	 */
	JQGridResponseDto<JerarquiaDto<Puntuaciones>> jerarquiaChildren(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto);
}
