package com.ejie.ab60.service.BEC;

import com.ejie.ab60.dao.BEC.PuntuacionesDao;
import com.ejie.ab60.model.BEC.Puntuaciones;
import com.ejie.ab60.model.expedientes.Expedientes;
import com.ejie.ab60.model.pagos.PagosExpediente;
import com.ejie.ab60.model.procedimientos.Procedimientos;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

import java.util.Date;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * PuntuacionesServiceImpl  
 * 
 *  
 */

@Service(value = "puntuacionesService")
public class PuntuacionesServiceImpl implements PuntuacionesService {

	private static final Logger logger = LoggerFactory.getLogger(PuntuacionesServiceImpl.class);

	@Autowired
	private PuntuacionesDao puntuacionesDao;

	/**
	 * Inserts a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Puntuaciones add(Puntuaciones puntuaciones) {
		return this.puntuacionesDao.add(puntuaciones);
	}

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public Puntuaciones updateCurriculum(Puntuaciones puntuaciones) {
		return this.puntuacionesDao.updateCurriculum(puntuaciones);
	}

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public Puntuaciones updateConocimientos(Puntuaciones puntuaciones) {
		return this.puntuacionesDao.updateConocimientos(puntuaciones);
	}

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public Puntuaciones addOrUpdateConocimientos(Puntuaciones puntuacion) {
		Puntuaciones puntuacionResult = new Puntuaciones();
		if (null != puntuacion.getIdPuntuacion()) {
			puntuacionResult = this.puntuacionesDao.updateConocimientos(puntuacion);
		} else {
			puntuacionResult = this.puntuacionesDao.addConocimientos(puntuacion);
		}
		return puntuacionResult;
	}

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public Puntuaciones addOrUpdateCurso(Puntuaciones puntuacion) {
		Puntuaciones puntuacionResult = new Puntuaciones();
		if (null != puntuacion.getIdPuntuacion()) {
			puntuacionResult = this.puntuacionesDao.updateCurso(puntuacion);
		} else {
			puntuacionResult = this.puntuacionesDao.addCurso(puntuacion);
		}
		return puntuacionResult;
	}

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public Puntuaciones updateCurso(Puntuaciones puntuaciones) {
		return this.puntuacionesDao.updateCurso(puntuaciones);
	}

	@Override
	@Transactional(rollbackFor = Throwable.class)
	public Puntuaciones addOrUpdateRequisitos(Puntuaciones puntuacion) {
		Puntuaciones puntuacionResult = new Puntuaciones();
		if (null != puntuacion.getIdPuntuacion()) {
			puntuacionResult = this.puntuacionesDao.updateRequisitos(puntuacion);
		} else {
			puntuacionResult = this.puntuacionesDao.addRequisitos(puntuacion);
		}
		return puntuacionResult;
	}

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public Puntuaciones addOrUpdateResolucion(Puntuaciones puntuacion) {
		Puntuaciones puntuacionResult = new Puntuaciones();
		if (null != puntuacion.getIdPuntuacion()) {
			puntuacionResult = this.puntuacionesDao.updateResolucion(puntuacion);
		} else {
			puntuacionResult = this.puntuacionesDao.addResolucion(puntuacion);
		}
		return puntuacionResult;
	}

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public Puntuaciones updateResolucion(Puntuaciones puntuaciones) {
		return this.puntuacionesDao.updateResolucion(puntuaciones);
	}

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public Puntuaciones updateBecarios(Puntuaciones puntuaciones) {
		return this.puntuacionesDao.updateBecarios(puntuaciones);
	}

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public Puntuaciones updateSuplentes(Puntuaciones puntuaciones) {
		return this.puntuacionesDao.updateSuplentes(puntuaciones);
	}

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public Puntuaciones updateFasePuntuacion(Puntuaciones puntuaciones) {
		return this.puntuacionesDao.updateFasePuntuacion(puntuaciones);
	}

	/**
	 * Updates a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Puntuaciones intercambioBecariosSuplentes(Integer idProcedimiento, Integer idRow, Puntuaciones puntuaciones,
			Usuario usuario) {
		Puntuaciones puntuacionAux = new Puntuaciones();
		puntuaciones.setFechaRegistro(new Date());
		puntuaciones.setUsuarioRegistro(usuario.getNombreUsuario());
		Expedientes expedienteBecario = new Expedientes();
		expedienteBecario.setIdExpediente(idRow);
		puntuaciones.setExpedientes(expedienteBecario);

		// Busco el suplente con la maxima puntuacion
		Puntuaciones puntuacionMaxSuplente = this.puntuacionesDao.findPuntuacionMaxSuplentes(idProcedimiento);
		if (null != puntuacionMaxSuplente) {
			try {
				Puntuaciones puntuacionBecarios = this.puntuacionesDao.updateBecarios(puntuaciones);
				if (null != puntuacionBecarios) {
					Procedimientos procedimientos = new Procedimientos();
					procedimientos.setIdProcedimiento(idProcedimiento);
					Expedientes expedienteSuplente = new Expedientes();
					expedienteSuplente.setIdExpediente(puntuacionMaxSuplente.getExpedientes().getIdExpediente());
					expedienteSuplente.setProcedimientos(procedimientos);
					puntuacionMaxSuplente.setExpedientes(expedienteSuplente);
					puntuacionMaxSuplente.setFechaRegistro(new Date());
					puntuacionMaxSuplente.setUsuarioRegistro(usuario.getNombreUsuario());
					puntuacionAux = this.puntuacionesDao.updateSuplentes(puntuacionMaxSuplente);
				}
			} catch (Exception e) {
				PuntuacionesServiceImpl.logger.info("[PUT] : Puntuaciones actualizado correctamente");
			}
		}
		return puntuacionAux;

	}

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	public Puntuaciones findRequisitos(Puntuaciones puntuaciones) {
		return (Puntuaciones) this.puntuacionesDao.findRequisitos(puntuaciones);
	}

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	public Puntuaciones find(Puntuaciones puntuaciones) {
		return (Puntuaciones) this.puntuacionesDao.find(puntuaciones);
	}

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	public Puntuaciones findConocimientos(Puntuaciones puntuaciones) {
		return (Puntuaciones) this.puntuacionesDao.findConocimientos(puntuaciones);
	}

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	public Puntuaciones findCurso(Puntuaciones puntuaciones) {
		return (Puntuaciones) this.puntuacionesDao.findCurso(puntuaciones);
	}

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return Puntuaciones
	 */
	public Puntuaciones findResolucion(Puntuaciones puntuaciones) {
		return (Puntuaciones) this.puntuacionesDao.findResolucion(puntuaciones);
	}

	/**
	 * Finds a single row in the Puntuaciones table.
	 *
	 * @param idProcedimiento
	 *            Integer
	 * @return Puntuaciones
	 */
	public Puntuaciones findPuntuacionMaxSuplentes(Integer idProcedimiento) {
		return (Puntuaciones) this.puntuacionesDao.findPuntuacionMaxSuplentes(idProcedimiento);
	}

	/**
	 * Deletes a single row in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(Puntuaciones puntuaciones) {
		this.puntuacionesDao.remove(puntuaciones);
	}

	/**
	 * Finds a list of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Puntuaciones>
	 */
	public List<Puntuaciones> findAll(Puntuaciones puntuaciones, JQGridRequestDto jqGridRequestDto) {
		return (List<Puntuaciones>) this.puntuacionesDao.findAll(puntuaciones, jqGridRequestDto);
	}

	/**
	 * Finds a list of rows in the Puntuaciones table.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @return List<Puntuaciones>
	 */
	public List<Puntuaciones> findExpedientesParaConocimientos(Puntuaciones puntuaciones, Integer idconvocatoria) {
		return (List<Puntuaciones>) this.puntuacionesDao.findExpedientesParaConocimientos(puntuaciones, idconvocatoria);
	}

	/**
	 * Finds rows in the Puntuaciones table using like.
	 *
	 * @param puntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Puntuaciones>
	 */
	public List<Puntuaciones> findAllLike(Puntuaciones puntuaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<Puntuaciones>) this.puntuacionesDao.findAllLike(puntuaciones, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(Puntuaciones filterPuntuaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.puntuacionesDao.removeMultiple(filterPuntuaciones, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Puntuaciones>
	 */
	public JQGridResponseDto<Puntuaciones> filterFaseCurriculum(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<Puntuaciones> listaPuntuaciones = this.puntuacionesDao.findFaseCurriculum(filterPuntuaciones);
		Long recordNum = this.puntuacionesDao
				.findAllLikeCount(filterPuntuaciones != null ? filterPuntuaciones : new Puntuaciones(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<Puntuaciones>> reorderSelection = this.puntuacionesDao.reorderSelection(filterPuntuaciones,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<Puntuaciones>(jqGridRequestDto, recordNum, listaPuntuaciones,
					reorderSelection);
		}
		return new JQGridResponseDto<Puntuaciones>(jqGridRequestDto, recordNum, listaPuntuaciones);
	}

	/**
	 * Finds rows in the Puntuaciones table using like.
	 *
	 * @param puntuacion
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Puntuaciones>
	 */
	public List<Puntuaciones> findAllLikeExportExcelCurr(Puntuaciones puntuacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<Puntuaciones>) this.puntuacionesDao.findFaseCurriculum(puntuacion);
	}

	/**
	 * Finds rows in the Puntuaciones table using like.
	 *
	 * @param puntuacion
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Puntuaciones>
	 */
	public List<Puntuaciones> findAllLikeExportExcelCono(Puntuaciones puntuacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<Puntuaciones>) this.puntuacionesDao.findFaseConocimientos(puntuacion);
	}

	/**
	 * Finds rows in the Puntuaciones table using like.
	 *
	 * @param puntuacion
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Puntuaciones>
	 */
	public List<Puntuaciones> findAllLikeExportExcelCurso(Puntuaciones puntuacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<Puntuaciones>) this.puntuacionesDao.findFaseCurso(puntuacion);
	}

	/**
	 * Finds rows in the Puntuaciones table using like.
	 *
	 * @param puntuacion
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Puntuaciones>
	 */
	public List<Puntuaciones> findAllLikeExportExcelBecarios(Puntuaciones puntuacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<Puntuaciones>) this.puntuacionesDao.findFaseBecasBecarios(puntuacion);
	}

	/**
	 * Finds rows in the Puntuaciones table using like.
	 *
	 * @param puntuacion
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Puntuaciones>
	 */
	public List<Puntuaciones> findAllLikeExportExcelSuplentes(Puntuaciones puntuacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<Puntuaciones>) this.puntuacionesDao.findFaseBecasSuplentes(puntuacion);
	}

	/**
	 * Filter method in the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Puntuaciones>
	 */
	public JQGridResponseDto<Puntuaciones> filterFaseConocimientos(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<Puntuaciones> listaPuntuaciones = this.puntuacionesDao.findFaseConocimientos(filterPuntuaciones);
		Long recordNum = this.puntuacionesDao
				.findAllLikeCount(filterPuntuaciones != null ? filterPuntuaciones : new Puntuaciones(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<Puntuaciones>> reorderSelection = this.puntuacionesDao.reorderSelection(filterPuntuaciones,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<Puntuaciones>(jqGridRequestDto, recordNum, listaPuntuaciones,
					reorderSelection);
		}
		return new JQGridResponseDto<Puntuaciones>(jqGridRequestDto, recordNum, listaPuntuaciones);
	}

	/**
	 * Filter method in the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Puntuaciones>
	 */
	public JQGridResponseDto<Puntuaciones> filterFaseCurso(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<Puntuaciones> listaPuntuaciones = this.puntuacionesDao.findFaseCurso(filterPuntuaciones);
		Long recordNum = this.puntuacionesDao
				.findAllLikeCount(filterPuntuaciones != null ? filterPuntuaciones : new Puntuaciones(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<Puntuaciones>> reorderSelection = this.puntuacionesDao.reorderSelection(filterPuntuaciones,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<Puntuaciones>(jqGridRequestDto, recordNum, listaPuntuaciones,
					reorderSelection);
		}
		return new JQGridResponseDto<Puntuaciones>(jqGridRequestDto, recordNum, listaPuntuaciones);
	}

	/**
	 * Filter method in the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Puntuaciones>
	 */
	public JQGridResponseDto<Puntuaciones> filterFaseBecasBecarios(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<Puntuaciones> listaPuntuaciones = this.puntuacionesDao.findFaseBecasBecarios(filterPuntuaciones);
		Long recordNum = this.puntuacionesDao
				.findAllLikeCount(filterPuntuaciones != null ? filterPuntuaciones : new Puntuaciones(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<Puntuaciones>> reorderSelection = this.puntuacionesDao.reorderSelection(filterPuntuaciones,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<Puntuaciones>(jqGridRequestDto, recordNum, listaPuntuaciones,
					reorderSelection);
		}
		return new JQGridResponseDto<Puntuaciones>(jqGridRequestDto, recordNum, listaPuntuaciones);
	}

	/**
	 * Filter method in the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Puntuaciones>
	 */
	public JQGridResponseDto<Puntuaciones> filterFaseBecasSuplentes(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<Puntuaciones> listaPuntuaciones = this.puntuacionesDao.findFaseBecasSuplentes(filterPuntuaciones);
		Long recordNum = this.puntuacionesDao
				.findAllLikeCount(filterPuntuaciones != null ? filterPuntuaciones : new Puntuaciones(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<Puntuaciones>> reorderSelection = this.puntuacionesDao.reorderSelection(filterPuntuaciones,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<Puntuaciones>(jqGridRequestDto, recordNum, listaPuntuaciones,
					reorderSelection);
		}
		return new JQGridResponseDto<Puntuaciones>(jqGridRequestDto, recordNum, listaPuntuaciones);
	}

	/**
	 * Searches rows in the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param searchPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Puntuaciones>>
	 */
	public List<TableRowDto<Puntuaciones>> search(Puntuaciones filterPuntuaciones, Puntuaciones searchPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.puntuacionesDao.search(filterPuntuaciones, searchPuntuaciones, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(Puntuaciones filterPuntuaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.puntuacionesDao.reorderSelection(filterPuntuaciones, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Puntuaciones table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Puntuaciones>>
	 */
	public JQGridResponseDto<JerarquiaDto<Puntuaciones>> jerarquia(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<Puntuaciones>> listaPuntuaciones = this.puntuacionesDao
				.findAllLikeJerarquia(filterPuntuaciones, jqGridRequestDto);
		Long recordNum = this.puntuacionesDao.findAllLikeCountJerarquia(filterPuntuaciones, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<Puntuaciones>>(jqGridRequestDto, recordNum, listaPuntuaciones);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the Puntuaciones
	 * table.
	 *
	 * @param filterPuntuaciones
	 *            Puntuaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Puntuaciones>>
	 */
	public JQGridResponseDto<JerarquiaDto<Puntuaciones>> jerarquiaChildren(Puntuaciones filterPuntuaciones,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<Puntuaciones>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<Puntuaciones>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.puntuacionesDao.findAllChild(filterPuntuaciones, jqGridRequestDto));
		return jqGridResponseDto;
	}
}
