package com.ejie.ab60.service.BEC;

import com.ejie.ab60.model.BEC.TiposCertificacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * TiposCertificacionService  
 * 
 *  
 */

public interface TiposCertificacionService {

	/**
	 * Inserts a single row in the TiposCertificacion table.
	 *
	 * @param tiposCertificacion
	 *            TiposCertificacion
	 * @return TiposCertificacion
	 */
	TiposCertificacion add(TiposCertificacion tiposCertificacion);

	/**
	 * Updates a single row in the TiposCertificacion table.
	 *
	 * @param tiposCertificacion
	 *            TiposCertificacion
	 * @return TiposCertificacion
	 */
	TiposCertificacion update(TiposCertificacion tiposCertificacion);

	/**
	 * Finds a single row in the TiposCertificacion table.
	 *
	 * @param tiposCertificacion
	 *            TiposCertificacion
	 * @return TiposCertificacion
	 */
	TiposCertificacion find(TiposCertificacion tiposCertificacion);

	/**
	 * findCertificaciones
	 * 
	 * @param tiposCertificacion
	 * 
	 * @return listaTiposCertificacion
	 */
	List<TiposCertificacion> findCertificaciones(TiposCertificacion tiposCertificacion);

	/**
	 * Deletes a single row in the TiposCertificacion table.
	 *
	 * @param tiposCertificacion
	 *            TiposCertificacion
	 */
	void remove(TiposCertificacion tiposCertificacion);

	/**
	 * Finds a list of rows in the TiposCertificacion table.
	 *
	 * @param tiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TiposCertificacion>
	 */
	List<TiposCertificacion> findAll(TiposCertificacion tiposCertificacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposCertificacion table using like.
	 *
	 * @param tiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposCertificacion>
	 */
	List<TiposCertificacion> findAllLike(TiposCertificacion tiposCertificacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposCertificacion table.
	 *
	 * @param filterTiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposCertificacion filterTiposCertificacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the TiposCertificacion table.
	 *
	 * @param filterTiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<TiposCertificacion>
	 */
	JQGridResponseDto<TiposCertificacion> filter(TiposCertificacion filterTiposCertificacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the TiposCertificacion table.
	 *
	 * @param filterTiposCertificacion
	 *            TiposCertificacion
	 * @param searchTiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposCertificacion>>
	 */
	List<TableRowDto<TiposCertificacion>> search(TiposCertificacion filterTiposCertificacion,
			TiposCertificacion searchTiposCertificacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in TiposCertificacion table.
	 *
	 * @param filterTiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(TiposCertificacion filterTiposCertificacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposCertificacion table.
	 *
	 * @param filterTiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposCertificacion>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposCertificacion>> jerarquia(TiposCertificacion filterTiposCertificacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * TiposCertificacion table.
	 *
	 * @param filterTiposCertificacion
	 *            TiposCertificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposCertificacion>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposCertificacion>> jerarquiaChildren(TiposCertificacion filterTiposCertificacion,
			JQGridRequestDto jqGridRequestDto);

}
