package com.ejie.ab60.service.CTP;

import java.util.List;

import com.ejie.ab60.model.CTP.AsociacionesSectoriales;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * AsociacionesSectorialesService  
 * 
 *  
 */

public interface AsociacionesSectorialesService {

	/**
	 * Inserts a single row in the AsociacionesSectoriales table.
	 *
	 * @param asociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @return AsociacionesSectoriales
	 */
	AsociacionesSectoriales add(AsociacionesSectoriales asociacionesSectoriales);

	/**
	 * Updates a single row in the AsociacionesSectoriales table.
	 *
	 * @param asociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @return AsociacionesSectoriales
	 */
	AsociacionesSectoriales update(AsociacionesSectoriales asociacionesSectoriales);

	/**
	 * Finds a single row in the AsociacionesSectoriales table.
	 *
	 * @param asociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @return AsociacionesSectoriales
	 */
	AsociacionesSectoriales find(AsociacionesSectoriales asociacionesSectoriales);

	/**
	 * Lista de asociones sectoriales para cargar el combo del select
	 */

	List<AsociacionesSectoriales> findAsociacionesSectoriales();

	/**
	 * Deletes a single row in the AsociacionesSectoriales table.
	 *
	 * @param asociacionesSectoriales
	 *            AsociacionesSectoriales
	 */
	void remove(AsociacionesSectoriales asociacionesSectoriales);

	/**
	 * Finds a list of rows in the AsociacionesSectoriales table.
	 *
	 * @param asociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<AsociacionesSectoriales>
	 */
	List<AsociacionesSectoriales> findAll(AsociacionesSectoriales asociacionesSectoriales,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the AsociacionesSectoriales table using like.
	 *
	 * @param asociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<AsociacionesSectoriales>
	 */
	List<AsociacionesSectoriales> findAllLike(AsociacionesSectoriales asociacionesSectoriales,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the AsociacionesSectoriales table.
	 *
	 * @param filterAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(AsociacionesSectoriales filterAsociacionesSectoriales, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the AsociacionesSectoriales table.
	 *
	 * @param filterAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<AsociacionesSectoriales>
	 */
	JQGridResponseDto<AsociacionesSectoriales> filter(AsociacionesSectoriales filterAsociacionesSectoriales,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the AsociacionesSectoriales table.
	 *
	 * @param filterAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param searchAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AsociacionesSectoriales>>
	 */
	List<TableRowDto<AsociacionesSectoriales>> search(AsociacionesSectoriales filterAsociacionesSectoriales,
			AsociacionesSectoriales searchAsociacionesSectoriales, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Reorder the selection made in AsociacionesSectoriales table.
	 *
	 * @param filterAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(AsociacionesSectoriales filterAsociacionesSectoriales, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the AsociacionesSectoriales table.
	 *
	 * @param filterAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<AsociacionesSectoriales>>
	 */
	JQGridResponseDto<JerarquiaDto<AsociacionesSectoriales>> jerarquia(
			AsociacionesSectoriales filterAsociacionesSectoriales, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * AsociacionesSectoriales table.
	 *
	 * @param filterAsociacionesSectoriales
	 *            AsociacionesSectoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<AsociacionesSectoriales>>
	 */
	JQGridResponseDto<JerarquiaDto<AsociacionesSectoriales>> jerarquiaChildren(
			AsociacionesSectoriales filterAsociacionesSectoriales, JQGridRequestDto jqGridRequestDto);

}
