package com.ejie.ab60.service.CTP;

import java.util.List;

import com.ejie.ab60.model.CTP.Proyectos;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ProyectosService  
 * 
 *  
 */

public interface ProyectosService {

	/**
	 * Inserts a single row in the Proyectos table.
	 *
	 * @param proyectos
	 *            Proyectos
	 * @return Proyectos
	 */
	Proyectos add(Proyectos proyectos);

	/**
	 * Updates a single row in the Proyectos table.
	 *
	 * @param proyectos
	 *            Proyectos
	 * @return Proyectos
	 */
	Proyectos update(Proyectos proyectos);

	/**
	 * Updates idAsociacion en la tabla in the Proyectos
	 *
	 * @param proyectos
	 *            Proyectos
	 * @return Proyectos
	 */
	Proyectos updateIdAsociacion(Proyectos proyectos);

	/**
	 * Finds a single row in the Proyectos table.
	 *
	 * @param proyectos
	 *            Proyectos
	 * @return Proyectos
	 */
	Proyectos find(Proyectos proyectos);

	/**
	 * Deletes a single row in the Proyectos table.
	 *
	 * @param proyectos
	 *            Proyectos
	 */
	void remove(Proyectos proyectos);

	/**
	 * Finds a list of rows in the Proyectos table.
	 *
	 * @param proyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Proyectos>
	 */
	List<Proyectos> findAll(Proyectos proyectos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Proyectos table using like.
	 *
	 * @param proyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Proyectos>
	 */
	List<Proyectos> findAllLike(Proyectos proyectos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Proyectos table.
	 *
	 * @param filterProyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Proyectos filterProyectos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Proyectos table.
	 *
	 * @param filterProyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Proyectos>
	 */
	JQGridResponseDto<Proyectos> filter(Proyectos filterProyectos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the Proyectos table.
	 *
	 * @param filterProyectos
	 *            Proyectos
	 * @param searchProyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Proyectos>>
	 */
	List<TableRowDto<Proyectos>> search(Proyectos filterProyectos, Proyectos searchProyectos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in Proyectos table.
	 *
	 * @param filterProyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Proyectos filterProyectos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Proyectos table.
	 *
	 * @param filterProyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Proyectos>>
	 */
	JQGridResponseDto<JerarquiaDto<Proyectos>> jerarquia(Proyectos filterProyectos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Proyectos table.
	 *
	 * @param filterProyectos
	 *            Proyectos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Proyectos>>
	 */
	JQGridResponseDto<JerarquiaDto<Proyectos>> jerarquiaChildren(Proyectos filterProyectos,
			JQGridRequestDto jqGridRequestDto);

}
