package com.ejie.ab60.service.CTP;

import java.util.List;

import com.ejie.ab60.model.CTP.Solicitantes;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * SolicitantesService  
 * 
 *  
 */

public interface SolicitantesService {

	/**
	 * Inserts a single row in the Solicitantes table.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 * @return Solicitantes
	 */
	Solicitantes add(Solicitantes solicitantes);

	/**
	 * Updates a single row in the Solicitantes table.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 * @return Solicitantes
	 */
	Solicitantes update(Solicitantes solicitantes);

	/**
	 * Finds a single row in the Solicitantes table.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 * @return Solicitantes
	 */
	Solicitantes find(Solicitantes solicitantes);

	/**
	 * Deletes a single row in the Solicitantes table.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 */
	void remove(Solicitantes solicitantes);

	/**
	 * Finds a list of rows in the Solicitantes table.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Solicitantes>
	 */
	List<Solicitantes> findAll(Solicitantes solicitantes, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Solicitantes table using like.
	 *
	 * @param solicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Solicitantes>
	 */
	List<Solicitantes> findAllLike(Solicitantes solicitantes, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Solicitantes table.
	 *
	 * @param filterSolicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Solicitantes filterSolicitantes, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Solicitantes table.
	 *
	 * @param filterSolicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Solicitantes>
	 */
	JQGridResponseDto<Solicitantes> filter(Solicitantes filterSolicitantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the Solicitantes table.
	 *
	 * @param filterSolicitantes
	 *            Solicitantes
	 * @param searchSolicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Solicitantes>>
	 */
	List<TableRowDto<Solicitantes>> search(Solicitantes filterSolicitantes, Solicitantes searchSolicitantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in Solicitantes table.
	 *
	 * @param filterSolicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Solicitantes filterSolicitantes, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Solicitantes table.
	 *
	 * @param filterSolicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Solicitantes>>
	 */
	JQGridResponseDto<JerarquiaDto<Solicitantes>> jerarquia(Solicitantes filterSolicitantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Solicitantes
	 * table.
	 *
	 * @param filterSolicitantes
	 *            Solicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Solicitantes>>
	 */
	JQGridResponseDto<JerarquiaDto<Solicitantes>> jerarquiaChildren(Solicitantes filterSolicitantes,
			JQGridRequestDto jqGridRequestDto);

}
