package com.ejie.ab60.service.DEC;

import java.util.List;

import com.ejie.ab60.model.DEC.ActAsociacion;
import com.ejie.ab60.model.DEC.AsociacionesComerciantes;
import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ActAsociacionService  
 * 
 *  
 */

public interface ActAsociacionService {

	/**
	 * Finds a single row in the ActAsociacion table.
	 *
	 * @param actAsociacion
	 *            ActAsociacion
	 * @return ActAsociacion
	 */
	ActAsociacion find(ActAsociacion actAsociacion);

	/**
	 * Deletes a single row in the actAsociaciones table.
	 *
	 * @param Integer
	 *            idRelExpActSub
	 *
	 */
	void remove(Integer idRelExpActSub);

	/**
	 * Finds a list of rows in the ActAsociacion table.
	 *
	 * @param actAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ActAsociacion>
	 */
	List<ActAsociacion> findAll(ActAsociacion actAsociacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ActAsociacion table using like.
	 *
	 * @param actAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ActAsociacion>
	 */
	List<ActAsociacion> findAllLike(ActAsociacion actAsociacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the ActAsociacion table.
	 *
	 * @param filterActAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ActAsociacion filterActAsociacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the ActAsociacion table.
	 *
	 * @param filterActAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ActAsociacion>
	 */
	JQGridResponseDto<ActAsociacion> filter(ActAsociacion filterActAsociacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the ActAsociacion table.
	 *
	 * @param filterActAsociacion
	 *            ActAsociacion
	 * @param searchActAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ActAsociacion>>
	 */
	List<TableRowDto<ActAsociacion>> search(ActAsociacion filterActAsociacion, ActAsociacion searchActAsociacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in ActAsociacion table.
	 *
	 * @param filterActAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(ActAsociacion filterActAsociacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the ActAsociacion table.
	 *
	 * @param filterActAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<ActAsociacion>>
	 */
	JQGridResponseDto<JerarquiaDto<ActAsociacion>> jerarquia(ActAsociacion filterActAsociacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the ActAsociacion
	 * table.
	 *
	 * @param filterActAsociacion
	 *            ActAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<ActAsociacion>>
	 */
	JQGridResponseDto<JerarquiaDto<ActAsociacion>> jerarquiaChildren(ActAsociacion filterActAsociacion,
			JQGridRequestDto jqGridRequestDto);

}
