package com.ejie.ab60.service.DEC;

import java.util.List;

import com.ejie.ab60.model.DEC.ActAyuntamiento;
import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ActAyuntamientoService  
 * 
 *  
 */

public interface ActAyuntamientoService {

	/**
	 * Finds a single row in the ActAyuntamiento table.
	 *
	 * @param actAyuntamiento
	 *            ActAyuntamiento
	 * @return ActAyuntamiento
	 */
	ActAyuntamiento findidRelacion(ActAyuntamiento actAyuntamiento);

	/**
	 * Updates a single row in the ActAyuntamiento table.
	 *
	 * @param actAyuntamiento
	 *            ActAyuntamiento
	 * @return ActAyuntamiento
	 */
	ActAyuntamiento updateTotal(ActAyuntamiento actAyuntamiento);

	/**
	 * Finds a list of rows in the ActAyuntamiento table.
	 *
	 * @param actAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ActAyuntamiento>
	 */
	List<ActAyuntamiento> findAll(ActAyuntamiento actAyuntamiento, JQGridRequestDto jqGridRequestDto);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the ActAyuntamiento table.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ActAyuntamiento filterActAyuntamiento, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the ActAyuntamiento table.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param searchActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ActAyuntamiento>>
	 */
	List<TableRowDto<ActAyuntamiento>> search(ActAyuntamiento filterActAyuntamiento,
			ActAyuntamiento searchActAyuntamiento, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in ActAyuntamiento table.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(ActAyuntamiento filterActAyuntamiento, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the ActAyuntamiento table.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<ActAyuntamiento>>
	 */
	JQGridResponseDto<JerarquiaDto<ActAyuntamiento>> jerarquia(ActAyuntamiento filterActAyuntamiento,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the ActAyuntamiento
	 * table.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<ActAyuntamiento>>
	 */
	JQGridResponseDto<JerarquiaDto<ActAyuntamiento>> jerarquiaChildren(ActAyuntamiento filterActAyuntamiento,
			JQGridRequestDto jqGridRequestDto);

}
