package com.ejie.ab60.service.DEC;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.DEC.ActAyuntamientoDao;
import com.ejie.ab60.model.DEC.ActAyuntamiento;
import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ActAyuntamientoServiceImpl  
 * 
 *  
 */

@Service(value = "actAyuntamientoService")
public class ActAyuntamientoServiceImpl implements ActAyuntamientoService {

	@Autowired
	private ActAyuntamientoDao actAyuntamientoDao;

	/**
	 * Finds a single row in the ActAyuntamiento table.
	 *
	 * @param actAyuntamiento
	 *            ActAyuntamiento
	 * @return ActAyuntamiento
	 */
	public ActAyuntamiento findidRelacion(ActAyuntamiento actAyuntamiento) {
		return (ActAyuntamiento) this.actAyuntamientoDao.findidRelacion(actAyuntamiento);
	}

	/**
	 * Updates a single row in the ActAyuntamiento table.
	 *
	 * @param actAyuntamiento
	 *            ActAyuntamiento
	 * @return ActAyuntamiento
	 */
	@Transactional(rollbackFor = Throwable.class)
	public ActAyuntamiento updateTotal(ActAyuntamiento actAyuntamiento) {
		return this.actAyuntamientoDao.updateTotal(actAyuntamiento);
	}

	/**
	 * Finds a list of rows in the ActAyuntamiento table.
	 *
	 * @param actAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ActAyuntamiento>
	 */
	public List<ActAyuntamiento> findAll(ActAyuntamiento actAyuntamiento, JQGridRequestDto jqGridRequestDto) {
		return (List<ActAyuntamiento>) this.actAyuntamientoDao.findAll(actAyuntamiento, jqGridRequestDto);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the ActAyuntamiento table.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(ActAyuntamiento filterActAyuntamiento, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.actAyuntamientoDao.removeMultiple(filterActAyuntamiento, jqGridRequestDto, startsWith);
	}

	/**
	 * Searches rows in the ActAyuntamiento table.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param searchActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ActAyuntamiento>>
	 */
	public List<TableRowDto<ActAyuntamiento>> search(ActAyuntamiento filterActAyuntamiento,
			ActAyuntamiento searchActAyuntamiento, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.actAyuntamientoDao.search(filterActAyuntamiento, searchActAyuntamiento, jqGridRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in ActAyuntamiento table.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(ActAyuntamiento filterActAyuntamiento, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.actAyuntamientoDao.reorderSelection(filterActAyuntamiento, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the ActAyuntamiento table.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<ActAyuntamiento>>
	 */
	public JQGridResponseDto<JerarquiaDto<ActAyuntamiento>> jerarquia(ActAyuntamiento filterActAyuntamiento,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<ActAyuntamiento>> listaActAyuntamiento = this.actAyuntamientoDao
				.findAllLikeJerarquia(filterActAyuntamiento, jqGridRequestDto);
		Long recordNum = this.actAyuntamientoDao.findAllLikeCountJerarquia(filterActAyuntamiento, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<ActAyuntamiento>>(jqGridRequestDto, recordNum, listaActAyuntamiento);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the ActAyuntamiento
	 * table.
	 *
	 * @param filterActAyuntamiento
	 *            ActAyuntamiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<ActAyuntamiento>>
	 */
	public JQGridResponseDto<JerarquiaDto<ActAyuntamiento>> jerarquiaChildren(ActAyuntamiento filterActAyuntamiento,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<ActAyuntamiento>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<ActAyuntamiento>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.actAyuntamientoDao.findAllChild(filterActAyuntamiento, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
