package com.ejie.ab60.service.DEC;

import java.util.List;

import com.ejie.ab60.model.DEC.AsociacionesComerciantes;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * AsociacionesComerciantesService  
 * 
 *  
 */

public interface AsociacionesComerciantesService {

	/**
	 * Inserts a single row in the AsociacionesComerciantes table.
	 *
	 * @param asociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @return AsociacionesComerciantes
	 */
	AsociacionesComerciantes add(AsociacionesComerciantes asociacionesComerciantes);

	/**
	 * Updates a single row in the AsociacionesComerciantes table.
	 *
	 * @param asociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @return AsociacionesComerciantes
	 */
	AsociacionesComerciantes update(AsociacionesComerciantes asociacionesComerciantes);

	/**
	 * Finds a single row in the AsociacionesComerciantes table.
	 *
	 * @param asociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @return AsociacionesComerciantes
	 */
	AsociacionesComerciantes find(AsociacionesComerciantes asociacionesComerciantes);

	/**
	 * Deletes a single row in the AsociacionesComerciantes table.
	 *
	 * @param asociacionesComerciantes
	 *            AsociacionesComerciantes
	 */
	void remove(AsociacionesComerciantes asociacionesComerciantes);

	/**
	 * Finds a list of rows in the AsociacionesComerciantes table.
	 *
	 * @param asociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<AsociacionesComerciantes>
	 */
	List<AsociacionesComerciantes> findAll(AsociacionesComerciantes asociacionesComerciantes,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the AsociacionesComerciantes table using like.
	 *
	 * @param asociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<AsociacionesComerciantes>
	 */
	List<AsociacionesComerciantes> findAllLike(AsociacionesComerciantes asociacionesComerciantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the AsociacionesComerciantes table.
	 *
	 * @param filterAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(AsociacionesComerciantes filterAsociacionesComerciantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the AsociacionesComerciantes table.
	 *
	 * @param filterAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<AsociacionesComerciantes>
	 */
	JQGridResponseDto<AsociacionesComerciantes> filter(AsociacionesComerciantes filterAsociacionesComerciantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the AsociacionesComerciantes table.
	 *
	 * @param filterAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param searchAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AsociacionesComerciantes>>
	 */
	List<TableRowDto<AsociacionesComerciantes>> search(AsociacionesComerciantes filterAsociacionesComerciantes,
			AsociacionesComerciantes searchAsociacionesComerciantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Reorder the selection made in AsociacionesComerciantes table.
	 *
	 * @param filterAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(AsociacionesComerciantes filterAsociacionesComerciantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the AsociacionesComerciantes table.
	 *
	 * @param filterAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<AsociacionesComerciantes>>
	 */
	JQGridResponseDto<JerarquiaDto<AsociacionesComerciantes>> jerarquia(
			AsociacionesComerciantes filterAsociacionesComerciantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * AsociacionesComerciantes table.
	 *
	 * @param filterAsociacionesComerciantes
	 *            AsociacionesComerciantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<AsociacionesComerciantes>>
	 */
	JQGridResponseDto<JerarquiaDto<AsociacionesComerciantes>> jerarquiaChildren(
			AsociacionesComerciantes filterAsociacionesComerciantes, JQGridRequestDto jqGridRequestDto);

}
