package com.ejie.ab60.service.DEC;

import java.util.List;

import com.ejie.ab60.model.DEC.LimiteAsociaciones;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * LimiteAsociacionesService  
 * 
 *  
 */

public interface LimiteAsociacionesService {

	/**
	 * Inserts a single row in the LimiteAsociaciones table.
	 *
	 * @param limiteAsociaciones
	 *            LimiteAsociaciones
	 * @return LimiteAsociaciones
	 */
	LimiteAsociaciones add(LimiteAsociaciones limiteAsociaciones);

	/**
	 * Updates a single row in the LimiteAsociaciones table.
	 *
	 * @param limiteAsociaciones
	 *            LimiteAsociaciones
	 * @return LimiteAsociaciones
	 */
	LimiteAsociaciones update(LimiteAsociaciones limiteAsociaciones);

	/**
	 * Finds a single row in the LimiteAsociaciones table.
	 *
	 * @param limiteAsociaciones
	 *            LimiteAsociaciones
	 * @return LimiteAsociaciones
	 */
	LimiteAsociaciones find(LimiteAsociaciones limiteAsociaciones);

	/**
	 * Deletes a single row in the LimiteAsociaciones table.
	 *
	 * @param limiteAsociaciones
	 *            LimiteAsociaciones
	 */
	void remove(LimiteAsociaciones limiteAsociaciones);

	/**
	 * Finds a list of rows in the LimiteAsociaciones table.
	 *
	 * @param limiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<LimiteAsociaciones>
	 */
	List<LimiteAsociaciones> findAll(LimiteAsociaciones limiteAsociaciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the LimiteAsociaciones table using like.
	 *
	 * @param limiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<LimiteAsociaciones>
	 */
	List<LimiteAsociaciones> findAllLike(LimiteAsociaciones limiteAsociaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(LimiteAsociaciones filterLimiteAsociaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<LimiteAsociaciones>
	 */
	JQGridResponseDto<LimiteAsociaciones> filter(LimiteAsociaciones filterLimiteAsociaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param searchLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<LimiteAsociaciones>>
	 */
	List<TableRowDto<LimiteAsociaciones>> search(LimiteAsociaciones filterLimiteAsociaciones,
			LimiteAsociaciones searchLimiteAsociaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(LimiteAsociaciones filterLimiteAsociaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<LimiteAsociaciones>>
	 */
	JQGridResponseDto<JerarquiaDto<LimiteAsociaciones>> jerarquia(LimiteAsociaciones filterLimiteAsociaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<LimiteAsociaciones>>
	 */
	JQGridResponseDto<JerarquiaDto<LimiteAsociaciones>> jerarquiaChildren(LimiteAsociaciones filterLimiteAsociaciones,
			JQGridRequestDto jqGridRequestDto);

}
