package com.ejie.ab60.service.DEC;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.DEC.LimiteAsociacionesDao;
import com.ejie.ab60.model.DEC.LimiteAsociaciones;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * LimiteAsociacionesServiceImpl  
 * 
 *  
 */

@Service(value = "limiteAsociacionesService")
public class LimiteAsociacionesServiceImpl implements LimiteAsociacionesService {

	@Autowired
	private LimiteAsociacionesDao limiteAsociacionesDao;

	/**
	 * Inserts a single row in the LimiteAsociaciones table.
	 *
	 * @param limiteAsociaciones
	 *            LimiteAsociaciones
	 * @return LimiteAsociaciones
	 */
	@Transactional(rollbackFor = Throwable.class)
	public LimiteAsociaciones add(LimiteAsociaciones limiteAsociaciones) {
		return this.limiteAsociacionesDao.add(limiteAsociaciones);
	}

	/**
	 * Updates a single row in the LimiteAsociaciones table.
	 *
	 * @param limiteAsociaciones
	 *            LimiteAsociaciones
	 * @return LimiteAsociaciones
	 */
	@Transactional(rollbackFor = Throwable.class)
	public LimiteAsociaciones update(LimiteAsociaciones limiteAsociaciones) {
		return this.limiteAsociacionesDao.update(limiteAsociaciones);
	}

	/**
	 * Finds a single row in the LimiteAsociaciones table.
	 *
	 * @param limiteAsociaciones
	 *            LimiteAsociaciones
	 * @return LimiteAsociaciones
	 */
	public LimiteAsociaciones find(LimiteAsociaciones limiteAsociaciones) {
		return (LimiteAsociaciones) this.limiteAsociacionesDao.find(limiteAsociaciones);
	}

	/**
	 * Deletes a single row in the LimiteAsociaciones table.
	 *
	 * @param limiteAsociaciones
	 *            LimiteAsociaciones
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(LimiteAsociaciones limiteAsociaciones) {
		this.limiteAsociacionesDao.remove(limiteAsociaciones);
	}

	/**
	 * Finds a list of rows in the LimiteAsociaciones table.
	 *
	 * @param limiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<LimiteAsociaciones>
	 */
	public List<LimiteAsociaciones> findAll(LimiteAsociaciones limiteAsociaciones, JQGridRequestDto jqGridRequestDto) {
		return (List<LimiteAsociaciones>) this.limiteAsociacionesDao.findAll(limiteAsociaciones, jqGridRequestDto);
	}

	/**
	 * Finds rows in the LimiteAsociaciones table using like.
	 *
	 * @param limiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<LimiteAsociaciones>
	 */
	public List<LimiteAsociaciones> findAllLike(LimiteAsociaciones limiteAsociaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<LimiteAsociaciones>) this.limiteAsociacionesDao.findAllLike(limiteAsociaciones, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(LimiteAsociaciones filterLimiteAsociaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.limiteAsociacionesDao.removeMultiple(filterLimiteAsociaciones, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<LimiteAsociaciones>
	 */
	public JQGridResponseDto<LimiteAsociaciones> filter(LimiteAsociaciones filterLimiteAsociaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<LimiteAsociaciones> listaLimiteAsociaciones = this.limiteAsociacionesDao
				.findAllLike(filterLimiteAsociaciones, jqGridRequestDto, false);
		Long recordNum = this.limiteAsociacionesDao.findAllLikeCount(
				filterLimiteAsociaciones != null ? filterLimiteAsociaciones : new LimiteAsociaciones(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<LimiteAsociaciones>> reorderSelection = this.limiteAsociacionesDao
					.reorderSelection(filterLimiteAsociaciones, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<LimiteAsociaciones>(jqGridRequestDto, recordNum, listaLimiteAsociaciones,
					reorderSelection);
		}
		return new JQGridResponseDto<LimiteAsociaciones>(jqGridRequestDto, recordNum, listaLimiteAsociaciones);
	}

	/**
	 * Searches rows in the LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param searchLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<LimiteAsociaciones>>
	 */
	public List<TableRowDto<LimiteAsociaciones>> search(LimiteAsociaciones filterLimiteAsociaciones,
			LimiteAsociaciones searchLimiteAsociaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.limiteAsociacionesDao.search(filterLimiteAsociaciones, searchLimiteAsociaciones, jqGridRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(LimiteAsociaciones filterLimiteAsociaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.limiteAsociacionesDao.reorderSelection(filterLimiteAsociaciones, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<LimiteAsociaciones>>
	 */
	public JQGridResponseDto<JerarquiaDto<LimiteAsociaciones>> jerarquia(LimiteAsociaciones filterLimiteAsociaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<LimiteAsociaciones>> listaLimiteAsociaciones = this.limiteAsociacionesDao
				.findAllLikeJerarquia(filterLimiteAsociaciones, jqGridRequestDto);
		Long recordNum = this.limiteAsociacionesDao.findAllLikeCountJerarquia(filterLimiteAsociaciones,
				jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<LimiteAsociaciones>>(jqGridRequestDto, recordNum,
				listaLimiteAsociaciones);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * LimiteAsociaciones table.
	 *
	 * @param filterLimiteAsociaciones
	 *            LimiteAsociaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<LimiteAsociaciones>>
	 */
	public JQGridResponseDto<JerarquiaDto<LimiteAsociaciones>> jerarquiaChildren(
			LimiteAsociaciones filterLimiteAsociaciones, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<LimiteAsociaciones>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<LimiteAsociaciones>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.limiteAsociacionesDao.findAllChild(filterLimiteAsociaciones, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
