package com.ejie.ab60.service.DEC;

import java.util.List;

import com.ejie.ab60.model.DEC.LimiteAyuntamientos;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * LimiteAyuntamientosService  
 * 
 *  
 */

public interface LimiteAyuntamientosService {

	/**
	 * Inserts a single row in the LimiteAyuntamientos table.
	 *
	 * @param limiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @return LimiteAyuntamientos
	 */
	LimiteAyuntamientos add(LimiteAyuntamientos limiteAyuntamientos);

	/**
	 * Updates a single row in the LimiteAyuntamientos table.
	 *
	 * @param limiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @return LimiteAyuntamientos
	 */
	LimiteAyuntamientos update(LimiteAyuntamientos limiteAyuntamientos);

	/**
	 * Finds a single row in the LimiteAyuntamientos table.
	 *
	 * @param limiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @return LimiteAyuntamientos
	 */
	LimiteAyuntamientos find(LimiteAyuntamientos limiteAyuntamientos);

	/**
	 * Deletes a single row in the LimiteAyuntamientos table.
	 *
	 * @param limiteAyuntamientos
	 *            LimiteAyuntamientos
	 */
	void remove(LimiteAyuntamientos limiteAyuntamientos);

	/**
	 * Finds a list of rows in the LimiteAyuntamientos table.
	 *
	 * @param limiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<LimiteAyuntamientos>
	 */
	List<LimiteAyuntamientos> findAll(LimiteAyuntamientos limiteAyuntamientos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the LimiteAyuntamientos table using like.
	 *
	 * @param limiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<LimiteAyuntamientos>
	 */
	List<LimiteAyuntamientos> findAllLike(LimiteAyuntamientos limiteAyuntamientos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(LimiteAyuntamientos filterLimiteAyuntamientos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<LimiteAyuntamientos>
	 */
	JQGridResponseDto<LimiteAyuntamientos> filter(LimiteAyuntamientos filterLimiteAyuntamientos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param searchLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<LimiteAyuntamientos>>
	 */
	List<TableRowDto<LimiteAyuntamientos>> search(LimiteAyuntamientos filterLimiteAyuntamientos,
			LimiteAyuntamientos searchLimiteAyuntamientos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(LimiteAyuntamientos filterLimiteAyuntamientos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<LimiteAyuntamientos>>
	 */
	JQGridResponseDto<JerarquiaDto<LimiteAyuntamientos>> jerarquia(LimiteAyuntamientos filterLimiteAyuntamientos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<LimiteAyuntamientos>>
	 */
	JQGridResponseDto<JerarquiaDto<LimiteAyuntamientos>> jerarquiaChildren(
			LimiteAyuntamientos filterLimiteAyuntamientos, JQGridRequestDto jqGridRequestDto);

}
