package com.ejie.ab60.service.DEC;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.DEC.LimiteAyuntamientosDao;
import com.ejie.ab60.model.DEC.LimiteAyuntamientos;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * LimiteAyuntamientosServiceImpl  
 * 
 *  
 */

@Service(value = "limiteAyuntamientosService")
public class LimiteAyuntamientosServiceImpl implements LimiteAyuntamientosService {

	@Autowired
	private LimiteAyuntamientosDao limiteAyuntamientosDao;

	/**
	 * Inserts a single row in the LimiteAyuntamientos table.
	 *
	 * @param limiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @return LimiteAyuntamientos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public LimiteAyuntamientos add(LimiteAyuntamientos limiteAyuntamientos) {
		return this.limiteAyuntamientosDao.add(limiteAyuntamientos);
	}

	/**
	 * Updates a single row in the LimiteAyuntamientos table.
	 *
	 * @param limiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @return LimiteAyuntamientos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public LimiteAyuntamientos update(LimiteAyuntamientos limiteAyuntamientos) {
		return this.limiteAyuntamientosDao.update(limiteAyuntamientos);
	}

	/**
	 * Finds a single row in the LimiteAyuntamientos table.
	 *
	 * @param limiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @return LimiteAyuntamientos
	 */
	public LimiteAyuntamientos find(LimiteAyuntamientos limiteAyuntamientos) {
		return (LimiteAyuntamientos) this.limiteAyuntamientosDao.find(limiteAyuntamientos);
	}

	/**
	 * Deletes a single row in the LimiteAyuntamientos table.
	 *
	 * @param limiteAyuntamientos
	 *            LimiteAyuntamientos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(LimiteAyuntamientos limiteAyuntamientos) {
		this.limiteAyuntamientosDao.remove(limiteAyuntamientos);
	}

	/**
	 * Finds a list of rows in the LimiteAyuntamientos table.
	 *
	 * @param limiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<LimiteAyuntamientos>
	 */
	public List<LimiteAyuntamientos> findAll(LimiteAyuntamientos limiteAyuntamientos,
			JQGridRequestDto jqGridRequestDto) {
		return (List<LimiteAyuntamientos>) this.limiteAyuntamientosDao.findAll(limiteAyuntamientos, jqGridRequestDto);
	}

	/**
	 * Finds rows in the LimiteAyuntamientos table using like.
	 *
	 * @param limiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<LimiteAyuntamientos>
	 */
	public List<LimiteAyuntamientos> findAllLike(LimiteAyuntamientos limiteAyuntamientos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<LimiteAyuntamientos>) this.limiteAyuntamientosDao.findAllLike(limiteAyuntamientos,
				jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(LimiteAyuntamientos filterLimiteAyuntamientos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.limiteAyuntamientosDao.removeMultiple(filterLimiteAyuntamientos, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<LimiteAyuntamientos>
	 */
	public JQGridResponseDto<LimiteAyuntamientos> filter(LimiteAyuntamientos filterLimiteAyuntamientos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<LimiteAyuntamientos> listaLimiteAyuntamientos = this.limiteAyuntamientosDao
				.findAllLike(filterLimiteAyuntamientos, jqGridRequestDto, false);
		Long recordNum = this.limiteAyuntamientosDao.findAllLikeCount(
				filterLimiteAyuntamientos != null ? filterLimiteAyuntamientos : new LimiteAyuntamientos(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<LimiteAyuntamientos>> reorderSelection = this.limiteAyuntamientosDao
					.reorderSelection(filterLimiteAyuntamientos, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<LimiteAyuntamientos>(jqGridRequestDto, recordNum, listaLimiteAyuntamientos,
					reorderSelection);
		}
		return new JQGridResponseDto<LimiteAyuntamientos>(jqGridRequestDto, recordNum, listaLimiteAyuntamientos);
	}

	/**
	 * Searches rows in the LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param searchLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<LimiteAyuntamientos>>
	 */
	public List<TableRowDto<LimiteAyuntamientos>> search(LimiteAyuntamientos filterLimiteAyuntamientos,
			LimiteAyuntamientos searchLimiteAyuntamientos, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.limiteAyuntamientosDao.search(filterLimiteAyuntamientos, searchLimiteAyuntamientos,
				jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(LimiteAyuntamientos filterLimiteAyuntamientos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.limiteAyuntamientosDao.reorderSelection(filterLimiteAyuntamientos, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<LimiteAyuntamientos>>
	 */
	public JQGridResponseDto<JerarquiaDto<LimiteAyuntamientos>> jerarquia(LimiteAyuntamientos filterLimiteAyuntamientos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<LimiteAyuntamientos>> listaLimiteAyuntamientos = this.limiteAyuntamientosDao
				.findAllLikeJerarquia(filterLimiteAyuntamientos, jqGridRequestDto);
		Long recordNum = this.limiteAyuntamientosDao.findAllLikeCountJerarquia(filterLimiteAyuntamientos,
				jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<LimiteAyuntamientos>>(jqGridRequestDto, recordNum,
				listaLimiteAyuntamientos);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * LimiteAyuntamientos table.
	 *
	 * @param filterLimiteAyuntamientos
	 *            LimiteAyuntamientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<LimiteAyuntamientos>>
	 */
	public JQGridResponseDto<JerarquiaDto<LimiteAyuntamientos>> jerarquiaChildren(
			LimiteAyuntamientos filterLimiteAyuntamientos, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<LimiteAyuntamientos>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<LimiteAyuntamientos>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.limiteAyuntamientosDao.findAllChild(filterLimiteAyuntamientos, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
