package com.ejie.ab60.service.DEC;

import java.util.List;

import com.ejie.ab60.model.DEC.RelMunAsoCom;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelMunAsoComService  
 * 
 *  
 */

public interface RelMunAsoComService {

	/**
	 * Inserts a single row in the RelMunAsoCom table.
	 *
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 * @return RelMunAsoCom
	 */
	RelMunAsoCom add(RelMunAsoCom relMunAsoCom);

	/**
	 * Updates a single row in the RelMunAsoCom table.
	 *
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 * @return RelMunAsoCom
	 */
	RelMunAsoCom update(RelMunAsoCom relMunAsoCom);

	/**
	 * Finds a single row in the RelMunAsoCom table.
	 *
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 * @return RelMunAsoCom
	 */
	RelMunAsoCom find(RelMunAsoCom relMunAsoCom);

	/**
	 * Deletes a single row in the RelMunAsoCom table.
	 *
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 */
	void remove(RelMunAsoCom relMunAsoCom);

	/**
	 * Finds a list of rows in the RelMunAsoCom table.
	 *
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelMunAsoCom>
	 */
	List<RelMunAsoCom> findAll(RelMunAsoCom relMunAsoCom, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelMunAsoCom table using like.
	 *
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelMunAsoCom>
	 */
	List<RelMunAsoCom> findAllLike(RelMunAsoCom relMunAsoCom, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelMunAsoCom table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelMunAsoCom filterRelMunAsoCom, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelMunAsoCom table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelMunAsoCom>
	 */
	JQGridResponseDto<RelMunAsoCom> filter(RelMunAsoCom filterRelMunAsoCom, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelMunAsoCom table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param searchRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelMunAsoCom>>
	 */
	List<TableRowDto<RelMunAsoCom>> search(RelMunAsoCom filterRelMunAsoCom, RelMunAsoCom searchRelMunAsoCom,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelMunAsoCom table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelMunAsoCom filterRelMunAsoCom, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelMunAsoCom table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelMunAsoCom>>
	 */
	JQGridResponseDto<JerarquiaDto<RelMunAsoCom>> jerarquia(RelMunAsoCom filterRelMunAsoCom,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelMunAsoCom
	 * table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelMunAsoCom>>
	 */
	JQGridResponseDto<JerarquiaDto<RelMunAsoCom>> jerarquiaChildren(RelMunAsoCom filterRelMunAsoCom,
			JQGridRequestDto jqGridRequestDto);

	RelMunAsoCom findById(Integer idExpediente);

}
