package com.ejie.ab60.service.DEC;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.DEC.RelMunAsoComDao;
import com.ejie.ab60.model.DEC.RelMunAsoCom;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelMunAsoComServiceImpl  
 * 
 *  
 */

@Service(value = "relMunAsoComService")
public class RelMunAsoComServiceImpl implements RelMunAsoComService {

	@Autowired
	private RelMunAsoComDao relMunAsoComDao;

	/**
	 * Inserts a single row in the RelMunAsoCom table.
	 *
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 * @return RelMunAsoCom
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelMunAsoCom add(RelMunAsoCom relMunAsoCom) {
		return this.relMunAsoComDao.add(relMunAsoCom);
	}

	/**
	 * Updates a single row in the RelMunAsoCom table.
	 *
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 * @return RelMunAsoCom
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelMunAsoCom update(RelMunAsoCom relMunAsoCom) {
		return this.relMunAsoComDao.update(relMunAsoCom);
	}

	/**
	 * Finds a single row in the RelMunAsoCom table.
	 *
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 * @return RelMunAsoCom
	 */
	public RelMunAsoCom find(RelMunAsoCom relMunAsoCom) {
		return (RelMunAsoCom) this.relMunAsoComDao.find(relMunAsoCom);
	}

	/**
	 * Deletes a single row in the RelMunAsoCom table.
	 *
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(RelMunAsoCom relMunAsoCom) {
		this.relMunAsoComDao.remove(relMunAsoCom);
	}

	/**
	 * Finds a list of rows in the RelMunAsoCom table.
	 *
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelMunAsoCom>
	 */
	public List<RelMunAsoCom> findAll(RelMunAsoCom relMunAsoCom, JQGridRequestDto jqGridRequestDto) {
		return (List<RelMunAsoCom>) this.relMunAsoComDao.findAll(relMunAsoCom, jqGridRequestDto);
	}

	/**
	 * Finds rows in the RelMunAsoCom table using like.
	 *
	 * @param relMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelMunAsoCom>
	 */
	public List<RelMunAsoCom> findAllLike(RelMunAsoCom relMunAsoCom, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<RelMunAsoCom>) this.relMunAsoComDao.findAllLike(relMunAsoCom, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelMunAsoCom table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(RelMunAsoCom filterRelMunAsoCom, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.relMunAsoComDao.removeMultiple(filterRelMunAsoCom, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the RelMunAsoCom table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelMunAsoCom>
	 */
	public JQGridResponseDto<RelMunAsoCom> filter(RelMunAsoCom filterRelMunAsoCom, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<RelMunAsoCom> listaRelMunAsoCom = this.relMunAsoComDao.findAllLike(filterRelMunAsoCom, jqGridRequestDto,
				false);
		Long recordNum = this.relMunAsoComDao
				.findAllLikeCount(filterRelMunAsoCom != null ? filterRelMunAsoCom : new RelMunAsoCom(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelMunAsoCom>> reorderSelection = this.relMunAsoComDao.reorderSelection(filterRelMunAsoCom,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelMunAsoCom>(jqGridRequestDto, recordNum, listaRelMunAsoCom,
					reorderSelection);
		}
		return new JQGridResponseDto<RelMunAsoCom>(jqGridRequestDto, recordNum, listaRelMunAsoCom);
	}

	/**
	 * Searches rows in the RelMunAsoCom table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param searchRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelMunAsoCom>>
	 */
	public List<TableRowDto<RelMunAsoCom>> search(RelMunAsoCom filterRelMunAsoCom, RelMunAsoCom searchRelMunAsoCom,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.relMunAsoComDao.search(filterRelMunAsoCom, searchRelMunAsoCom, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in RelMunAsoCom table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(RelMunAsoCom filterRelMunAsoCom, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.relMunAsoComDao.reorderSelection(filterRelMunAsoCom, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelMunAsoCom table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelMunAsoCom>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelMunAsoCom>> jerarquia(RelMunAsoCom filterRelMunAsoCom,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<RelMunAsoCom>> listaRelMunAsoCom = this.relMunAsoComDao
				.findAllLikeJerarquia(filterRelMunAsoCom, jqGridRequestDto);
		Long recordNum = this.relMunAsoComDao.findAllLikeCountJerarquia(filterRelMunAsoCom, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<RelMunAsoCom>>(jqGridRequestDto, recordNum, listaRelMunAsoCom);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the RelMunAsoCom
	 * table.
	 *
	 * @param filterRelMunAsoCom
	 *            RelMunAsoCom
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelMunAsoCom>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelMunAsoCom>> jerarquiaChildren(RelMunAsoCom filterRelMunAsoCom,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<RelMunAsoCom>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<RelMunAsoCom>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.relMunAsoComDao.findAllChild(filterRelMunAsoCom, jqGridRequestDto));
		return jqGridResponseDto;
	}

	@Override
	public RelMunAsoCom findById(Integer idExpediente) {
		return this.relMunAsoComDao.findById(idExpediente);
	}

}
