package com.ejie.ab60.service.DIV;

import java.util.List;

import com.ejie.ab60.model.DIV.Acciones;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * AccionesService  
 * 
 *  
 */

public interface AccionesService {

	/**
	 * Inserts a single row in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 * @return Acciones
	 */
	Acciones add(Acciones acciones);

	/**
	 * Updates a single row in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 * @return Acciones
	 */
	Acciones update(Acciones acciones);

	/**
	 * Finds a single row in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 * @return Acciones
	 */
	Acciones find(Acciones acciones);

	/**
	 * Deletes a single row in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 */
	void remove(Acciones acciones);

	/**
	 * Finds a list of rows in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Acciones>
	 */
	List<Acciones> findAll(Acciones acciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Acciones table using like.
	 *
	 * @param acciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Acciones>
	 */
	List<Acciones> findAllLike(Acciones acciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Acciones table.
	 *
	 * @param filterAcciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Acciones filterAcciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Acciones table.
	 *
	 * @param filterAcciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Acciones>
	 */
	JQGridResponseDto<Acciones> filter(Acciones filterAcciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the Acciones table.
	 *
	 * @param filterAcciones
	 *            Acciones
	 * @param searchAcciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Acciones>>
	 */
	List<TableRowDto<Acciones>> search(Acciones filterAcciones, Acciones searchAcciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in Acciones table.
	 *
	 * @param filterAcciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Acciones filterAcciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Acciones table.
	 *
	 * @param filterAcciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Acciones>>
	 */
	JQGridResponseDto<JerarquiaDto<Acciones>> jerarquia(Acciones filterAcciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Acciones table.
	 *
	 * @param filterAcciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Acciones>>
	 */
	JQGridResponseDto<JerarquiaDto<Acciones>> jerarquiaChildren(Acciones filterAcciones,
			JQGridRequestDto jqGridRequestDto);

}
