package com.ejie.ab60.service.DIV;

import java.util.List;

import com.ejie.ab60.model.DIV.EntidadesSolicitantes;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * EntidadesSolicitantesService  
 * 
 *  
 */

public interface EntidadesSolicitantesService {

	/**
	 * Inserts a single row in the EntidadesSolicitantes table.
	 *
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @return EntidadesSolicitantes
	 */
	EntidadesSolicitantes add(EntidadesSolicitantes entidadesSolicitantes);

	/**
	 * Updates a single row in the EntidadesSolicitantes table.
	 *
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @return EntidadesSolicitantes
	 */
	EntidadesSolicitantes update(EntidadesSolicitantes entidadesSolicitantes);

	/**
	 * Finds a single row in the EntidadesSolicitantes table.
	 *
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @return EntidadesSolicitantes
	 */
	EntidadesSolicitantes find(EntidadesSolicitantes entidadesSolicitantes);

	/**
	 * Deletes a single row in the EntidadesSolicitantes table.
	 *
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 */
	void remove(EntidadesSolicitantes entidadesSolicitantes);

	/**
	 * Finds a list of rows in the EntidadesSolicitantes table.
	 *
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<EntidadesSolicitantes>
	 */
	List<EntidadesSolicitantes> findAll(EntidadesSolicitantes entidadesSolicitantes, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the EntidadesSolicitantes table using like.
	 *
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<EntidadesSolicitantes>
	 */
	List<EntidadesSolicitantes> findAllLike(EntidadesSolicitantes entidadesSolicitantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(EntidadesSolicitantes filterEntidadesSolicitantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<EntidadesSolicitantes>
	 */
	JQGridResponseDto<EntidadesSolicitantes> filter(EntidadesSolicitantes filterEntidadesSolicitantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param searchEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<EntidadesSolicitantes>>
	 */
	List<TableRowDto<EntidadesSolicitantes>> search(EntidadesSolicitantes filterEntidadesSolicitantes,
			EntidadesSolicitantes searchEntidadesSolicitantes, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(EntidadesSolicitantes filterEntidadesSolicitantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<EntidadesSolicitantes>>
	 */
	JQGridResponseDto<JerarquiaDto<EntidadesSolicitantes>> jerarquia(EntidadesSolicitantes filterEntidadesSolicitantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<EntidadesSolicitantes>>
	 */
	JQGridResponseDto<JerarquiaDto<EntidadesSolicitantes>> jerarquiaChildren(
			EntidadesSolicitantes filterEntidadesSolicitantes, JQGridRequestDto jqGridRequestDto);

}
