package com.ejie.ab60.service.DIV;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.DIV.EntidadesSolicitantesDao;
import com.ejie.ab60.model.DIV.EntidadesSolicitantes;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * EntidadesSolicitantesServiceImpl  
 * 
 *  
 */

@Service(value = "entidadesSolicitantesService")
public class EntidadesSolicitantesServiceImpl implements EntidadesSolicitantesService {

	@Autowired
	private EntidadesSolicitantesDao entidadesSolicitantesDao;

	/**
	 * Inserts a single row in the EntidadesSolicitantes table.
	 *
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @return EntidadesSolicitantes
	 */
	@Transactional(rollbackFor = Throwable.class)
	public EntidadesSolicitantes add(EntidadesSolicitantes entidadesSolicitantes) {
		return this.entidadesSolicitantesDao.add(entidadesSolicitantes);
	}

	/**
	 * Updates a single row in the EntidadesSolicitantes table.
	 *
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @return EntidadesSolicitantes
	 */
	@Transactional(rollbackFor = Throwable.class)
	public EntidadesSolicitantes update(EntidadesSolicitantes entidadesSolicitantes) {
		return this.entidadesSolicitantesDao.update(entidadesSolicitantes);
	}

	/**
	 * Finds a single row in the EntidadesSolicitantes table.
	 *
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @return EntidadesSolicitantes
	 */
	public EntidadesSolicitantes find(EntidadesSolicitantes entidadesSolicitantes) {
		return (EntidadesSolicitantes) this.entidadesSolicitantesDao.find(entidadesSolicitantes);
	}

	/**
	 * Deletes a single row in the EntidadesSolicitantes table.
	 *
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(EntidadesSolicitantes entidadesSolicitantes) {
		this.entidadesSolicitantesDao.remove(entidadesSolicitantes);
	}

	/**
	 * Finds a list of rows in the EntidadesSolicitantes table.
	 *
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<EntidadesSolicitantes>
	 */
	public List<EntidadesSolicitantes> findAll(EntidadesSolicitantes entidadesSolicitantes,
			JQGridRequestDto jqGridRequestDto) {
		return (List<EntidadesSolicitantes>) this.entidadesSolicitantesDao.findAll(entidadesSolicitantes,
				jqGridRequestDto);
	}

	/**
	 * Finds rows in the EntidadesSolicitantes table using like.
	 *
	 * @param entidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<EntidadesSolicitantes>
	 */
	public List<EntidadesSolicitantes> findAllLike(EntidadesSolicitantes entidadesSolicitantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<EntidadesSolicitantes>) this.entidadesSolicitantesDao.findAllLike(entidadesSolicitantes,
				jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(EntidadesSolicitantes filterEntidadesSolicitantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.entidadesSolicitantesDao.removeMultiple(filterEntidadesSolicitantes, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<EntidadesSolicitantes>
	 */
	public JQGridResponseDto<EntidadesSolicitantes> filter(EntidadesSolicitantes filterEntidadesSolicitantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<EntidadesSolicitantes> listaEntidadesSolicitantes = this.entidadesSolicitantesDao
				.findAllLike(filterEntidadesSolicitantes, jqGridRequestDto, false);
		Long recordNum = this.entidadesSolicitantesDao.findAllLikeCount(
				filterEntidadesSolicitantes != null ? filterEntidadesSolicitantes : new EntidadesSolicitantes(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<EntidadesSolicitantes>> reorderSelection = this.entidadesSolicitantesDao
					.reorderSelection(filterEntidadesSolicitantes, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<EntidadesSolicitantes>(jqGridRequestDto, recordNum, listaEntidadesSolicitantes,
					reorderSelection);
		}
		return new JQGridResponseDto<EntidadesSolicitantes>(jqGridRequestDto, recordNum, listaEntidadesSolicitantes);
	}

	/**
	 * Searches rows in the EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param searchEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<EntidadesSolicitantes>>
	 */
	public List<TableRowDto<EntidadesSolicitantes>> search(EntidadesSolicitantes filterEntidadesSolicitantes,
			EntidadesSolicitantes searchEntidadesSolicitantes, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.entidadesSolicitantesDao.search(filterEntidadesSolicitantes, searchEntidadesSolicitantes,
				jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(EntidadesSolicitantes filterEntidadesSolicitantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.entidadesSolicitantesDao.reorderSelection(filterEntidadesSolicitantes, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<EntidadesSolicitantes>>
	 */
	public JQGridResponseDto<JerarquiaDto<EntidadesSolicitantes>> jerarquia(
			EntidadesSolicitantes filterEntidadesSolicitantes, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<EntidadesSolicitantes>> listaEntidadesSolicitantes = this.entidadesSolicitantesDao
				.findAllLikeJerarquia(filterEntidadesSolicitantes, jqGridRequestDto);
		Long recordNum = this.entidadesSolicitantesDao.findAllLikeCountJerarquia(filterEntidadesSolicitantes,
				jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<EntidadesSolicitantes>>(jqGridRequestDto, recordNum,
				listaEntidadesSolicitantes);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * EntidadesSolicitantes table.
	 *
	 * @param filterEntidadesSolicitantes
	 *            EntidadesSolicitantes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<EntidadesSolicitantes>>
	 */
	public JQGridResponseDto<JerarquiaDto<EntidadesSolicitantes>> jerarquiaChildren(
			EntidadesSolicitantes filterEntidadesSolicitantes, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<EntidadesSolicitantes>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<EntidadesSolicitantes>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.entidadesSolicitantesDao.findAllChild(filterEntidadesSolicitantes, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
