package com.ejie.ab60.service.DIV;

import java.util.List;

import com.ejie.ab60.model.DIV.RelExpEntSol;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpEntSolService  
 * 
 *  
 */

public interface RelExpEntSolService {

	/**
	 * Inserts a single row in the RelExpEntSol table.
	 *
	 * @param relExpEntSol
	 *            RelExpEntSol
	 * @return RelExpEntSol
	 */
	RelExpEntSol add(RelExpEntSol relExpEntSol);

	/**
	 * Updates a single row in the RelExpEntSol table.
	 *
	 * @param relExpEntSol
	 *            RelExpEntSol
	 * @return RelExpEntSol
	 */
	RelExpEntSol update(RelExpEntSol relExpEntSol);

	/**
	 * Finds a single row in the RelExpEntSol table.
	 *
	 * @param relExpEntSol
	 *            RelExpEntSol
	 * @return RelExpEntSol
	 */
	RelExpEntSol find(RelExpEntSol relExpEntSol);

	/**
	 * Deletes a single row in the RelExpEntSol table.
	 *
	 * @param relExpEntSol
	 *            RelExpEntSol
	 */
	void remove(RelExpEntSol relExpEntSol);

	/**
	 * Finds a list of rows in the RelExpEntSol table.
	 *
	 * @param relExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelExpEntSol>
	 */
	List<RelExpEntSol> findAll(RelExpEntSol relExpEntSol, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelExpEntSol table using like.
	 *
	 * @param relExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelExpEntSol>
	 */
	List<RelExpEntSol> findAllLike(RelExpEntSol relExpEntSol, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelExpEntSol table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpEntSol filterRelExpEntSol, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelExpEntSol table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpEntSol>
	 */
	JQGridResponseDto<RelExpEntSol> filter(RelExpEntSol filterRelExpEntSol, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelExpEntSol table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param searchRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpEntSol>>
	 */
	List<TableRowDto<RelExpEntSol>> search(RelExpEntSol filterRelExpEntSol, RelExpEntSol searchRelExpEntSol,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelExpEntSol table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelExpEntSol filterRelExpEntSol, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelExpEntSol table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelExpEntSol>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpEntSol>> jerarquia(RelExpEntSol filterRelExpEntSol,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelExpEntSol
	 * table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelExpEntSol>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpEntSol>> jerarquiaChildren(RelExpEntSol filterRelExpEntSol,
			JQGridRequestDto jqGridRequestDto);

}
