package com.ejie.ab60.service.DIV;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.DIV.RelExpEntSolDao;
import com.ejie.ab60.model.DIV.RelExpEntSol;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpEntSolServiceImpl  
 * 
 *  
 */

@Service(value = "relExpEntSolService")
public class RelExpEntSolServiceImpl implements RelExpEntSolService {

	@Autowired
	private RelExpEntSolDao relExpEntSolDao;

	/**
	 * Inserts a single row in the RelExpEntSol table.
	 *
	 * @param relExpEntSol
	 *            RelExpEntSol
	 * @return RelExpEntSol
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpEntSol add(RelExpEntSol relExpEntSol) {
		return this.relExpEntSolDao.add(relExpEntSol);
	}

	/**
	 * Updates a single row in the RelExpEntSol table.
	 *
	 * @param relExpEntSol
	 *            RelExpEntSol
	 * @return RelExpEntSol
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpEntSol update(RelExpEntSol relExpEntSol) {
		return this.relExpEntSolDao.update(relExpEntSol);
	}

	/**
	 * Finds a single row in the RelExpEntSol table.
	 *
	 * @param relExpEntSol
	 *            RelExpEntSol
	 * @return RelExpEntSol
	 */
	public RelExpEntSol find(RelExpEntSol relExpEntSol) {
		return (RelExpEntSol) this.relExpEntSolDao.find(relExpEntSol);
	}

	/**
	 * Deletes a single row in the RelExpEntSol table.
	 *
	 * @param relExpEntSol
	 *            RelExpEntSol
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(RelExpEntSol relExpEntSol) {
		this.relExpEntSolDao.remove(relExpEntSol);
	}

	/**
	 * Finds a list of rows in the RelExpEntSol table.
	 *
	 * @param relExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelExpEntSol>
	 */
	public List<RelExpEntSol> findAll(RelExpEntSol relExpEntSol, JQGridRequestDto jqGridRequestDto) {
		return (List<RelExpEntSol>) this.relExpEntSolDao.findAll(relExpEntSol, jqGridRequestDto);
	}

	/**
	 * Finds rows in the RelExpEntSol table using like.
	 *
	 * @param relExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelExpEntSol>
	 */
	public List<RelExpEntSol> findAllLike(RelExpEntSol relExpEntSol, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<RelExpEntSol>) this.relExpEntSolDao.findAllLike(relExpEntSol, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelExpEntSol table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(RelExpEntSol filterRelExpEntSol, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.relExpEntSolDao.removeMultiple(filterRelExpEntSol, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the RelExpEntSol table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpEntSol>
	 */
	public JQGridResponseDto<RelExpEntSol> filter(RelExpEntSol filterRelExpEntSol, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<RelExpEntSol> listaRelExpEntSol = this.relExpEntSolDao.findAllLike(filterRelExpEntSol, jqGridRequestDto,
				false);
		Long recordNum = this.relExpEntSolDao
				.findAllLikeCount(filterRelExpEntSol != null ? filterRelExpEntSol : new RelExpEntSol(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelExpEntSol>> reorderSelection = this.relExpEntSolDao.reorderSelection(filterRelExpEntSol,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelExpEntSol>(jqGridRequestDto, recordNum, listaRelExpEntSol,
					reorderSelection);
		}
		return new JQGridResponseDto<RelExpEntSol>(jqGridRequestDto, recordNum, listaRelExpEntSol);
	}

	/**
	 * Searches rows in the RelExpEntSol table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param searchRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpEntSol>>
	 */
	public List<TableRowDto<RelExpEntSol>> search(RelExpEntSol filterRelExpEntSol, RelExpEntSol searchRelExpEntSol,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.relExpEntSolDao.search(filterRelExpEntSol, searchRelExpEntSol, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in RelExpEntSol table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(RelExpEntSol filterRelExpEntSol, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.relExpEntSolDao.reorderSelection(filterRelExpEntSol, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelExpEntSol table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelExpEntSol>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelExpEntSol>> jerarquia(RelExpEntSol filterRelExpEntSol,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<RelExpEntSol>> listaRelExpEntSol = this.relExpEntSolDao
				.findAllLikeJerarquia(filterRelExpEntSol, jqGridRequestDto);
		Long recordNum = this.relExpEntSolDao.findAllLikeCountJerarquia(filterRelExpEntSol, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<RelExpEntSol>>(jqGridRequestDto, recordNum, listaRelExpEntSol);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the RelExpEntSol
	 * table.
	 *
	 * @param filterRelExpEntSol
	 *            RelExpEntSol
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelExpEntSol>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelExpEntSol>> jerarquiaChildren(RelExpEntSol filterRelExpEntSol,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<RelExpEntSol>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<RelExpEntSol>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.relExpEntSolDao.findAllChild(filterRelExpEntSol, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
