package com.ejie.ab60.service.DIV;

import java.util.List;

import com.ejie.ab60.model.DIV.TiposActividad;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * TiposActividadService  
 * 
 *  
 */

public interface TiposActividadService {

	/**
	 * Inserts a single row in the TiposActividad table.
	 *
	 * @param tiposActividad
	 *            TiposActividad
	 * @return TiposActividad
	 */
	TiposActividad add(TiposActividad tiposActividad);

	/**
	 * Updates a single row in the TiposActividad table.
	 *
	 * @param tiposActividad
	 *            TiposActividad
	 * @return TiposActividad
	 */
	TiposActividad update(TiposActividad tiposActividad);

	/**
	 * Finds a single row in the TiposActividad table.
	 *
	 * @param tiposActividad
	 *            TiposActividad
	 * @return TiposActividad
	 */
	TiposActividad find(TiposActividad tiposActividad);

	/**
	 * Deletes a single row in the TiposActividad table.
	 *
	 * @param tiposActividad
	 *            TiposActividad
	 */
	void remove(TiposActividad tiposActividad);

	/**
	 * Finds a list of rows in the TiposActividad table.
	 *
	 * @param tiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TiposActividad>
	 */
	List<TiposActividad> findAll(TiposActividad tiposActividad, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposActividad table using like.
	 *
	 * @param tiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposActividad>
	 */
	List<TiposActividad> findAllLike(TiposActividad tiposActividad, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposActividad table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposActividad filterTiposActividad, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the TiposActividad table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<TiposActividad>
	 */
	JQGridResponseDto<TiposActividad> filter(TiposActividad filterTiposActividad, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the TiposActividad table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param searchTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposActividad>>
	 */
	List<TableRowDto<TiposActividad>> search(TiposActividad filterTiposActividad, TiposActividad searchTiposActividad,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in TiposActividad table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(TiposActividad filterTiposActividad, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposActividad table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposActividad>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposActividad>> jerarquia(TiposActividad filterTiposActividad,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the TiposActividad
	 * table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposActividad>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposActividad>> jerarquiaChildren(TiposActividad filterTiposActividad,
			JQGridRequestDto jqGridRequestDto);

}
