package com.ejie.ab60.service.DIV;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.DIV.TiposActividadDao;
import com.ejie.ab60.model.DIV.TiposActividad;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * TiposActividadServiceImpl  
 * 
 *  
 */

@Service(value = "tiposActividadService")
public class TiposActividadServiceImpl implements TiposActividadService {

	@Autowired
	private TiposActividadDao tiposActividadDao;

	/**
	 * Inserts a single row in the TiposActividad table.
	 *
	 * @param tiposActividad
	 *            TiposActividad
	 * @return TiposActividad
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposActividad add(TiposActividad tiposActividad) {
		return this.tiposActividadDao.add(tiposActividad);
	}

	/**
	 * Updates a single row in the TiposActividad table.
	 *
	 * @param tiposActividad
	 *            TiposActividad
	 * @return TiposActividad
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposActividad update(TiposActividad tiposActividad) {
		return this.tiposActividadDao.update(tiposActividad);
	}

	/**
	 * Finds a single row in the TiposActividad table.
	 *
	 * @param tiposActividad
	 *            TiposActividad
	 * @return TiposActividad
	 */
	public TiposActividad find(TiposActividad tiposActividad) {
		return (TiposActividad) this.tiposActividadDao.find(tiposActividad);
	}

	/**
	 * Deletes a single row in the TiposActividad table.
	 *
	 * @param tiposActividad
	 *            TiposActividad
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(TiposActividad tiposActividad) {
		this.tiposActividadDao.remove(tiposActividad);
	}

	/**
	 * Finds a list of rows in the TiposActividad table.
	 *
	 * @param tiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TiposActividad>
	 */
	public List<TiposActividad> findAll(TiposActividad tiposActividad, JQGridRequestDto jqGridRequestDto) {
		return (List<TiposActividad>) this.tiposActividadDao.findAll(tiposActividad, jqGridRequestDto);
	}

	/**
	 * Finds rows in the TiposActividad table using like.
	 *
	 * @param tiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposActividad>
	 */
	public List<TiposActividad> findAllLike(TiposActividad tiposActividad, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<TiposActividad>) this.tiposActividadDao.findAllLike(tiposActividad, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposActividad table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(TiposActividad filterTiposActividad, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.tiposActividadDao.removeMultiple(filterTiposActividad, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the TiposActividad table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<TiposActividad>
	 */
	public JQGridResponseDto<TiposActividad> filter(TiposActividad filterTiposActividad,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<TiposActividad> listaTiposActividad = this.tiposActividadDao.findAllLike(filterTiposActividad,
				jqGridRequestDto, false);
		Long recordNum = this.tiposActividadDao
				.findAllLikeCount(filterTiposActividad != null ? filterTiposActividad : new TiposActividad(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<TiposActividad>> reorderSelection = this.tiposActividadDao
					.reorderSelection(filterTiposActividad, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<TiposActividad>(jqGridRequestDto, recordNum, listaTiposActividad,
					reorderSelection);
		}
		return new JQGridResponseDto<TiposActividad>(jqGridRequestDto, recordNum, listaTiposActividad);
	}

	/**
	 * Searches rows in the TiposActividad table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param searchTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposActividad>>
	 */
	public List<TableRowDto<TiposActividad>> search(TiposActividad filterTiposActividad,
			TiposActividad searchTiposActividad, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.tiposActividadDao.search(filterTiposActividad, searchTiposActividad, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in TiposActividad table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(TiposActividad filterTiposActividad, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.tiposActividadDao.reorderSelection(filterTiposActividad, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposActividad table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposActividad>>
	 */
	public JQGridResponseDto<JerarquiaDto<TiposActividad>> jerarquia(TiposActividad filterTiposActividad,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<TiposActividad>> listaTiposActividad = this.tiposActividadDao
				.findAllLikeJerarquia(filterTiposActividad, jqGridRequestDto);
		Long recordNum = this.tiposActividadDao.findAllLikeCountJerarquia(filterTiposActividad, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<TiposActividad>>(jqGridRequestDto, recordNum, listaTiposActividad);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the TiposActividad
	 * table.
	 *
	 * @param filterTiposActividad
	 *            TiposActividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposActividad>>
	 */
	public JQGridResponseDto<JerarquiaDto<TiposActividad>> jerarquiaChildren(TiposActividad filterTiposActividad,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<TiposActividad>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<TiposActividad>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.tiposActividadDao.findAllChild(filterTiposActividad, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
