package com.ejie.ab60.service.DIV;

import java.util.List;

import com.ejie.ab60.model.DIV.TiposAsociacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * TiposAsociacionService  
 * 
 *  
 */

public interface TiposAsociacionService {

	/**
	 * Inserts a single row in the TiposAsociacion table.
	 *
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 * @return TiposAsociacion
	 */
	TiposAsociacion add(TiposAsociacion tiposAsociacion);

	/**
	 * Updates a single row in the TiposAsociacion table.
	 *
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 * @return TiposAsociacion
	 */
	TiposAsociacion update(TiposAsociacion tiposAsociacion);

	/**
	 * Finds a single row in the TiposAsociacion table.
	 *
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 * @return TiposAsociacion
	 */
	TiposAsociacion find(TiposAsociacion tiposAsociacion);

	/**
	 * Deletes a single row in the TiposAsociacion table.
	 *
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 */
	void remove(TiposAsociacion tiposAsociacion);

	/**
	 * Finds a list of rows in the TiposAsociacion table.
	 *
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TiposAsociacion>
	 */
	List<TiposAsociacion> findAll(TiposAsociacion tiposAsociacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposAsociacion table using like.
	 *
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposAsociacion>
	 */
	List<TiposAsociacion> findAllLike(TiposAsociacion tiposAsociacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposAsociacion table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposAsociacion filterTiposAsociacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the TiposAsociacion table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<TiposAsociacion>
	 */
	JQGridResponseDto<TiposAsociacion> filter(TiposAsociacion filterTiposAsociacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the TiposAsociacion table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param searchTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposAsociacion>>
	 */
	List<TableRowDto<TiposAsociacion>> search(TiposAsociacion filterTiposAsociacion,
			TiposAsociacion searchTiposAsociacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in TiposAsociacion table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(TiposAsociacion filterTiposAsociacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposAsociacion table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposAsociacion>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposAsociacion>> jerarquia(TiposAsociacion filterTiposAsociacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the TiposAsociacion
	 * table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposAsociacion>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposAsociacion>> jerarquiaChildren(TiposAsociacion filterTiposAsociacion,
			JQGridRequestDto jqGridRequestDto);

}
