package com.ejie.ab60.service.DIV;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.DIV.TiposAsociacionDao;
import com.ejie.ab60.model.DIV.TiposAsociacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * TiposAsociacionServiceImpl  
 * 
 *  
 */

@Service(value = "tiposAsociacionService")
public class TiposAsociacionServiceImpl implements TiposAsociacionService {

	@Autowired
	private TiposAsociacionDao tiposAsociacionDao;

	/**
	 * Inserts a single row in the TiposAsociacion table.
	 *
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 * @return TiposAsociacion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposAsociacion add(TiposAsociacion tiposAsociacion) {
		return this.tiposAsociacionDao.add(tiposAsociacion);
	}

	/**
	 * Updates a single row in the TiposAsociacion table.
	 *
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 * @return TiposAsociacion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposAsociacion update(TiposAsociacion tiposAsociacion) {
		return this.tiposAsociacionDao.update(tiposAsociacion);
	}

	/**
	 * Finds a single row in the TiposAsociacion table.
	 *
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 * @return TiposAsociacion
	 */
	public TiposAsociacion find(TiposAsociacion tiposAsociacion) {
		return (TiposAsociacion) this.tiposAsociacionDao.find(tiposAsociacion);
	}

	/**
	 * Deletes a single row in the TiposAsociacion table.
	 *
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(TiposAsociacion tiposAsociacion) {
		this.tiposAsociacionDao.remove(tiposAsociacion);
	}

	/**
	 * Finds a list of rows in the TiposAsociacion table.
	 *
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TiposAsociacion>
	 */
	public List<TiposAsociacion> findAll(TiposAsociacion tiposAsociacion, JQGridRequestDto jqGridRequestDto) {
		return (List<TiposAsociacion>) this.tiposAsociacionDao.findAll(tiposAsociacion, jqGridRequestDto);
	}

	/**
	 * Finds rows in the TiposAsociacion table using like.
	 *
	 * @param tiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposAsociacion>
	 */
	public List<TiposAsociacion> findAllLike(TiposAsociacion tiposAsociacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<TiposAsociacion>) this.tiposAsociacionDao.findAllLike(tiposAsociacion, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposAsociacion table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(TiposAsociacion filterTiposAsociacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.tiposAsociacionDao.removeMultiple(filterTiposAsociacion, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the TiposAsociacion table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<TiposAsociacion>
	 */
	public JQGridResponseDto<TiposAsociacion> filter(TiposAsociacion filterTiposAsociacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<TiposAsociacion> listaTiposAsociacion = this.tiposAsociacionDao.findAllLike(filterTiposAsociacion,
				jqGridRequestDto, false);
		Long recordNum = this.tiposAsociacionDao
				.findAllLikeCount(filterTiposAsociacion != null ? filterTiposAsociacion : new TiposAsociacion(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<TiposAsociacion>> reorderSelection = this.tiposAsociacionDao
					.reorderSelection(filterTiposAsociacion, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<TiposAsociacion>(jqGridRequestDto, recordNum, listaTiposAsociacion,
					reorderSelection);
		}
		return new JQGridResponseDto<TiposAsociacion>(jqGridRequestDto, recordNum, listaTiposAsociacion);
	}

	/**
	 * Searches rows in the TiposAsociacion table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param searchTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposAsociacion>>
	 */
	public List<TableRowDto<TiposAsociacion>> search(TiposAsociacion filterTiposAsociacion,
			TiposAsociacion searchTiposAsociacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.tiposAsociacionDao.search(filterTiposAsociacion, searchTiposAsociacion, jqGridRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in TiposAsociacion table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(TiposAsociacion filterTiposAsociacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.tiposAsociacionDao.reorderSelection(filterTiposAsociacion, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposAsociacion table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposAsociacion>>
	 */
	public JQGridResponseDto<JerarquiaDto<TiposAsociacion>> jerarquia(TiposAsociacion filterTiposAsociacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<TiposAsociacion>> listaTiposAsociacion = this.tiposAsociacionDao
				.findAllLikeJerarquia(filterTiposAsociacion, jqGridRequestDto);
		Long recordNum = this.tiposAsociacionDao.findAllLikeCountJerarquia(filterTiposAsociacion, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<TiposAsociacion>>(jqGridRequestDto, recordNum, listaTiposAsociacion);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the TiposAsociacion
	 * table.
	 *
	 * @param filterTiposAsociacion
	 *            TiposAsociacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposAsociacion>>
	 */
	public JQGridResponseDto<JerarquiaDto<TiposAsociacion>> jerarquiaChildren(TiposAsociacion filterTiposAsociacion,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<TiposAsociacion>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<TiposAsociacion>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.tiposAsociacionDao.findAllChild(filterTiposAsociacion, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
