package com.ejie.ab60.service.MEC;

import java.util.List;

import com.ejie.ab60.model.MEC.Iae;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * IaeService  
 * 
 *  
 */

public interface IaeService {

	/**
	 * Inserts a single row in the Iae table.
	 *
	 * @param iae
	 *            Iae
	 * @return Iae
	 */
	Iae add(Iae iae);

	/**
	 * Updates a single row in the Iae table.
	 *
	 * @param iae
	 *            Iae
	 * @return Iae
	 */
	Iae update(Iae iae);

	/**
	 * Finds a single row in the Iae table.
	 *
	 * @param iae
	 *            Iae
	 * @return Iae
	 */
	Iae find(Iae iae);

	/**
	 * Deletes a single row in the Iae table.
	 *
	 * @param iae
	 *            Iae
	 */
	void remove(Iae iae);

	/**
	 * Finds a list of rows in the Iae table.
	 *
	 * @param iae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Iae>
	 */
	List<Iae> findAll(Iae iae, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Iae table using like.
	 *
	 * @param iae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Iae>
	 */
	List<Iae> findAllLike(Iae iae, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Iae table.
	 *
	 * @param filterIae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Iae filterIae, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Iae table.
	 *
	 * @param filterIae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Iae>
	 */
	JQGridResponseDto<Iae> filter(Iae filterIae, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the Iae table.
	 *
	 * @param filterIae
	 *            Iae
	 * @param searchIae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Iae>>
	 */
	List<TableRowDto<Iae>> search(Iae filterIae, Iae searchIae, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in Iae table.
	 *
	 * @param filterIae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Iae filterIae, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Iae table.
	 *
	 * @param filterIae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Iae>>
	 */
	JQGridResponseDto<JerarquiaDto<Iae>> jerarquia(Iae filterIae, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Iae table.
	 *
	 * @param filterIae
	 *            Iae
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Iae>>
	 */
	JQGridResponseDto<JerarquiaDto<Iae>> jerarquiaChildren(Iae filterIae, JQGridRequestDto jqGridRequestDto);

}
