package com.ejie.ab60.service.MEC;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.MEC.ParticipantesDao;
import com.ejie.ab60.model.MEC.Participantes;
import com.ejie.ab60.model.expedientes.Expedientes;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ParticipantesServiceImpl  
 * 
 *  
 */

@Service(value = "participantesService")
public class ParticipantesServiceImpl implements ParticipantesService {

	@Autowired
	private ParticipantesDao participantesDao;

	/**
	 * Inserts a single row in the Participantes table.
	 *
	 * @param participantes
	 *            Participantes
	 * @return Participantes
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Participantes add(Participantes participantes) {
		return this.participantesDao.add(participantes);
	}

	/**
	 * Updates a single row in the Participantes table.
	 *
	 * @param participantes
	 *            Participantes
	 * @return Participantes
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Participantes update(Participantes participantes) {
		return this.participantesDao.update(participantes);
	}

	/**
	 * Busca la lista de participantes para la comunidad de bienes ,del
	 * solicitante titular
	 *
	 * @param idTercero
	 *            Integer
	 * @return List<Participantes> Participantes
	 */
	public List<Participantes> find(Integer idTercero) {
		List<Participantes> participanteList = this.participantesDao.find(idTercero);
		return participanteList;
	}

	/**
	 * Busca participante de la comunidad de bienes del solicitante titular
	 *
	 * @param idParticipante
	 *            Integer
	 * @return Participantes participantes
	 */
	public Participantes findParticipante(Integer idParticipante) {
		Participantes participante = this.participantesDao.findParticipante(idParticipante);
		return participante;
	}

	/**
	 * Deletes a single row in the Participantes table.
	 *
	 * @param participantes
	 *            Participantes
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(Participantes participantes) {
		this.participantesDao.remove(participantes);
	}

	@Override
	public List<Participantes> findAll(Participantes participantes, JQGridRequestDto jqGridRequestDto) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<Participantes> findAllLike(Participantes participantes, Expedientes expediente) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<Participantes> findAllLike(Participantes participantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void removeMultiple(Participantes filterParticipantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		// TODO Auto-generated method stub

	}

	@Override
	public JQGridResponseDto<Participantes> filter(Participantes filterParticipantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<TableRowDto<Participantes>> search(Participantes filterParticipantes, Participantes searchParticipantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Object reorderSelection(Participantes filterParticipantes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public JQGridResponseDto<JerarquiaDto<Participantes>> jerarquia(Participantes filterParticipantes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public JQGridResponseDto<JerarquiaDto<Participantes>> jerarquiaChildren(Participantes filterParticipantes,
			JQGridRequestDto jqGridRequestDto) {
		// TODO Auto-generated method stub
		return null;
	}

}
