package com.ejie.ab60.service.MEC;

import com.ejie.ab60.model.MEC.RelFacMotDen;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelFacMotDenService  
 * 
 *  
 */

public interface RelFacMotDenService {

	/**
	 * Inserts a single row in the RelFacMotDen table.
	 *
	 * @param relFacMotDen
	 *            RelFacMotDen
	 * @return RelFacMotDen
	 */
	RelFacMotDen add(RelFacMotDen relFacMotDen);

	/**
	 * Updates a single row in the RelFacMotDen table.
	 *
	 * @param relFacMotDen
	 *            RelFacMotDen
	 * @return RelFacMotDen
	 */
	RelFacMotDen update(RelFacMotDen relFacMotDen);

	/**
	 * Finds a single row in the RelFacMotDen table.
	 *
	 * @param relFacMotDen
	 *            RelFacMotDen
	 * @return RelFacMotDen
	 */
	RelFacMotDen find(RelFacMotDen relFacMotDen);

	/**
	 * Saca los id de motivos de denegacion de facturas
	 *
	 * @param idRelActSubMotDen
	 *            Integer
	 *
	 * @return List<RelActSubMotDen>
	 */

	List<RelFacMotDen> findIdsFacturaMotivosDenegaciones(Integer idFactura);

	/**
	 * Deletes a single row in the RelFacMotDen table.
	 *
	 * @param relFacMotDen
	 *            RelFacMotDen
	 */
	void remove(RelFacMotDen relFacMotDen);

	/**
	 * Finds a list of rows in the RelFacMotDen table.
	 *
	 * @param relFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelFacMotDen>
	 */
	List<RelFacMotDen> findAll(RelFacMotDen relFacMotDen, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelFacMotDen table using like.
	 *
	 * @param relFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelFacMotDen>
	 */
	List<RelFacMotDen> findAllLike(RelFacMotDen relFacMotDen, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelFacMotDen table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelFacMotDen filterRelFacMotDen, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelFacMotDen table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelFacMotDen>
	 */
	JQGridResponseDto<RelFacMotDen> filter(RelFacMotDen filterRelFacMotDen, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelFacMotDen table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param searchRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelFacMotDen>>
	 */
	List<TableRowDto<RelFacMotDen>> search(RelFacMotDen filterRelFacMotDen, RelFacMotDen searchRelFacMotDen,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelFacMotDen table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelFacMotDen filterRelFacMotDen, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelFacMotDen table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelFacMotDen>>
	 */
	JQGridResponseDto<JerarquiaDto<RelFacMotDen>> jerarquia(RelFacMotDen filterRelFacMotDen,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelFacMotDen
	 * table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelFacMotDen>>
	 */
	JQGridResponseDto<JerarquiaDto<RelFacMotDen>> jerarquiaChildren(RelFacMotDen filterRelFacMotDen,
			JQGridRequestDto jqGridRequestDto);

}
