package com.ejie.ab60.service.MEC;

import com.ejie.ab60.dao.MEC.RelFacMotDenDao;
import com.ejie.ab60.model.MEC.RelFacMotDen;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * RelFacMotDenServiceImpl  
 * 
 *  
 */

@Service(value = "relFacMotDenService")
public class RelFacMotDenServiceImpl implements RelFacMotDenService {

	@Autowired
	private RelFacMotDenDao relFacMotDenDao;

	/**
	 * Inserts a single row in the RelFacMotDen table.
	 *
	 * @param relFacMotDen
	 *            RelFacMotDen
	 * @return RelFacMotDen
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelFacMotDen add(RelFacMotDen relFacMotDen) {
		return this.relFacMotDenDao.add(relFacMotDen);
	}

	/**
	 * Updates a single row in the RelFacMotDen table.
	 *
	 * @param relFacMotDen
	 *            RelFacMotDen
	 * @return RelFacMotDen
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelFacMotDen update(RelFacMotDen relFacMotDen) {
		return this.relFacMotDenDao.update(relFacMotDen);
	}

	/**
	 * Finds a single row in the RelFacMotDen table.
	 *
	 * @param relFacMotDen
	 *            RelFacMotDen
	 * @return RelFacMotDen
	 */
	public RelFacMotDen find(RelFacMotDen relFacMotDen) {
		return (RelFacMotDen) this.relFacMotDenDao.find(relFacMotDen);
	}

	/**
	 * Saca los id de motivos de denegacion
	 *
	 * @param idRelActSubMotDen
	 *            Integer
	 *
	 * @return List<RelActSubMotDen>
	 */

	public List<RelFacMotDen> findIdsFacturaMotivosDenegaciones(Integer idRelActSubMotDen) {
		return (List<RelFacMotDen>) this.relFacMotDenDao.findIdsFacturaMotivosDenegaciones(idRelActSubMotDen);
	}

	/**
	 * Deletes a single row in the RelFacMotDen table.
	 *
	 * @param relFacMotDen
	 *            RelFacMotDen
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(RelFacMotDen relFacMotDen) {
		this.relFacMotDenDao.remove(relFacMotDen);
	}

	/**
	 * Finds a list of rows in the RelFacMotDen table.
	 *
	 * @param relFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelFacMotDen>
	 */
	public List<RelFacMotDen> findAll(RelFacMotDen relFacMotDen, JQGridRequestDto jqGridRequestDto) {
		return (List<RelFacMotDen>) this.relFacMotDenDao.findAll(relFacMotDen, jqGridRequestDto);
	}

	/**
	 * Finds rows in the RelFacMotDen table using like.
	 *
	 * @param relFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelFacMotDen>
	 */
	public List<RelFacMotDen> findAllLike(RelFacMotDen relFacMotDen, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<RelFacMotDen>) this.relFacMotDenDao.findAllLike(relFacMotDen, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelFacMotDen table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(RelFacMotDen filterRelFacMotDen, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.relFacMotDenDao.removeMultiple(filterRelFacMotDen, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the RelFacMotDen table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelFacMotDen>
	 */
	public JQGridResponseDto<RelFacMotDen> filter(RelFacMotDen filterRelFacMotDen, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<RelFacMotDen> listaRelFacMotDen = this.relFacMotDenDao.findAllLike(filterRelFacMotDen, jqGridRequestDto,
				false);
		Long recordNum = this.relFacMotDenDao
				.findAllLikeCount(filterRelFacMotDen != null ? filterRelFacMotDen : new RelFacMotDen(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelFacMotDen>> reorderSelection = this.relFacMotDenDao.reorderSelection(filterRelFacMotDen,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelFacMotDen>(jqGridRequestDto, recordNum, listaRelFacMotDen,
					reorderSelection);
		}
		return new JQGridResponseDto<RelFacMotDen>(jqGridRequestDto, recordNum, listaRelFacMotDen);
	}

	/**
	 * Searches rows in the RelFacMotDen table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param searchRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelFacMotDen>>
	 */
	public List<TableRowDto<RelFacMotDen>> search(RelFacMotDen filterRelFacMotDen, RelFacMotDen searchRelFacMotDen,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.relFacMotDenDao.search(filterRelFacMotDen, searchRelFacMotDen, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in RelFacMotDen table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(RelFacMotDen filterRelFacMotDen, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.relFacMotDenDao.reorderSelection(filterRelFacMotDen, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelFacMotDen table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelFacMotDen>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelFacMotDen>> jerarquia(RelFacMotDen filterRelFacMotDen,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<RelFacMotDen>> listaRelFacMotDen = this.relFacMotDenDao
				.findAllLikeJerarquia(filterRelFacMotDen, jqGridRequestDto);
		Long recordNum = this.relFacMotDenDao.findAllLikeCountJerarquia(filterRelFacMotDen, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<RelFacMotDen>>(jqGridRequestDto, recordNum, listaRelFacMotDen);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the RelFacMotDen
	 * table.
	 *
	 * @param filterRelFacMotDen
	 *            RelFacMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelFacMotDen>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelFacMotDen>> jerarquiaChildren(RelFacMotDen filterRelFacMotDen,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<RelFacMotDen>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<RelFacMotDen>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.relFacMotDenDao.findAllChild(filterRelFacMotDen, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
