package com.ejie.ab60.service.MEC;

import com.ejie.ab60.model.MEC.RelFacMotMin;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelFacMotMinService  
 * 
 *  
 */

public interface RelFacMotMinService {

	/**
	 * Inserts a single row in the RelFacMotMin table.
	 *
	 * @param relFacMotMin
	 *            RelFacMotMin
	 * @return RelFacMotMin
	 */
	RelFacMotMin add(RelFacMotMin relFacMotMin);

	/**
	 * Updates a single row in the RelFacMotMin table.
	 *
	 * @param relFacMotMin
	 *            RelFacMotMin
	 * @return RelFacMotMin
	 */
	RelFacMotMin update(RelFacMotMin relFacMotMin);

	/**
	 * Finds a single row in the RelFacMotMin table.
	 *
	 * @param relFacMotMin
	 *            RelFacMotMin
	 * @return RelFacMotMin
	 */
	RelFacMotMin find(RelFacMotMin relFacMotMin);

	/**
	 * Saca los id de motivos de denegacion de facturas
	 * 
	 * @param origenMotivosMinoracion
	 *
	 * @param idRelActSubMotDen
	 *            Integer
	 *
	 * @return List<RelActSubMotDen>
	 */

	List<RelFacMotMin> findIdsFacturaMotivosMinoraciones(Integer idFactura, Integer origenMotivosMinoracion);

	/**
	 * Deletes a single row in the RelFacMotMin table.
	 *
	 * @param relFacMotMin
	 *            RelFacMotMin
	 */
	void remove(RelFacMotMin relFacMotMin);

	/**
	 * Finds a list of rows in the RelFacMotMin table.
	 *
	 * @param relFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelFacMotMin>
	 */
	List<RelFacMotMin> findAll(RelFacMotMin relFacMotMin, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelFacMotMin table using like.
	 *
	 * @param relFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelFacMotMin>
	 */
	List<RelFacMotMin> findAllLike(RelFacMotMin relFacMotMin, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelFacMotMin table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelFacMotMin filterRelFacMotMin, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelFacMotMin table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelFacMotMin>
	 */
	JQGridResponseDto<RelFacMotMin> filter(RelFacMotMin filterRelFacMotMin, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelFacMotMin table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param searchRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelFacMotMin>>
	 */
	List<TableRowDto<RelFacMotMin>> search(RelFacMotMin filterRelFacMotMin, RelFacMotMin searchRelFacMotMin,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelFacMotMin table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelFacMotMin filterRelFacMotMin, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelFacMotMin table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelFacMotMin>>
	 */
	JQGridResponseDto<JerarquiaDto<RelFacMotMin>> jerarquia(RelFacMotMin filterRelFacMotMin,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelFacMotMin
	 * table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelFacMotMin>>
	 */
	JQGridResponseDto<JerarquiaDto<RelFacMotMin>> jerarquiaChildren(RelFacMotMin filterRelFacMotMin,
			JQGridRequestDto jqGridRequestDto);

}
