package com.ejie.ab60.service.MEC;

import com.ejie.ab60.dao.MEC.RelFacMotMinDao;
import com.ejie.ab60.model.MEC.RelFacMotMin;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * RelFacMotMinServiceImpl  
 * 
 *  
 */

@Service(value = "relFacMotMinService")
public class RelFacMotMinServiceImpl implements RelFacMotMinService {

	@Autowired
	private RelFacMotMinDao relFacMotMinDao;

	/**
	 * Inserts a single row in the RelFacMotMin table.
	 *
	 * @param relFacMotMin
	 *            RelFacMotMin
	 * @return RelFacMotMin
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelFacMotMin add(RelFacMotMin relFacMotMin) {
		return this.relFacMotMinDao.add(relFacMotMin);
	}

	/**
	 * Updates a single row in the RelFacMotMin table.
	 *
	 * @param relFacMotMin
	 *            RelFacMotMin
	 * @return RelFacMotMin
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelFacMotMin update(RelFacMotMin relFacMotMin) {
		return this.relFacMotMinDao.update(relFacMotMin);
	}

	/**
	 * Finds a single row in the RelFacMotMin table.
	 *
	 * @param relFacMotMin
	 *            RelFacMotMin
	 * @return RelFacMotMin
	 */
	public RelFacMotMin find(RelFacMotMin relFacMotMin) {
		return (RelFacMotMin) this.relFacMotMinDao.find(relFacMotMin);
	}

	/**
	 * Saca los id de motivos de denegacion de facturas
	 *
	 * @param idRelActSubMotDen
	 *            Integer
	 *
	 * @return List<RelActSubMotDen>
	 */

	public List<RelFacMotMin> findIdsFacturaMotivosMinoraciones(Integer idFactura, Integer origenMotivosMinoracion) {
		return (List<RelFacMotMin>) this.relFacMotMinDao.findIdsFacturaMotivosMinoraciones(idFactura,
				origenMotivosMinoracion);
	}

	/**
	 * Deletes a single row in the RelFacMotMin table.
	 *
	 * @param relFacMotMin
	 *            RelFacMotMin
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(RelFacMotMin relFacMotMin) {
		this.relFacMotMinDao.remove(relFacMotMin);
	}

	/**
	 * Finds a list of rows in the RelFacMotMin table.
	 *
	 * @param relFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelFacMotMin>
	 */
	public List<RelFacMotMin> findAll(RelFacMotMin relFacMotMin, JQGridRequestDto jqGridRequestDto) {
		return (List<RelFacMotMin>) this.relFacMotMinDao.findAll(relFacMotMin, jqGridRequestDto);
	}

	/**
	 * Finds rows in the RelFacMotMin table using like.
	 *
	 * @param relFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelFacMotMin>
	 */
	public List<RelFacMotMin> findAllLike(RelFacMotMin relFacMotMin, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<RelFacMotMin>) this.relFacMotMinDao.findAllLike(relFacMotMin, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelFacMotMin table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(RelFacMotMin filterRelFacMotMin, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.relFacMotMinDao.removeMultiple(filterRelFacMotMin, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the RelFacMotMin table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelFacMotMin>
	 */
	public JQGridResponseDto<RelFacMotMin> filter(RelFacMotMin filterRelFacMotMin, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<RelFacMotMin> listaRelFacMotMin = this.relFacMotMinDao.findAllLike(filterRelFacMotMin, jqGridRequestDto,
				false);
		Long recordNum = this.relFacMotMinDao
				.findAllLikeCount(filterRelFacMotMin != null ? filterRelFacMotMin : new RelFacMotMin(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelFacMotMin>> reorderSelection = this.relFacMotMinDao.reorderSelection(filterRelFacMotMin,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelFacMotMin>(jqGridRequestDto, recordNum, listaRelFacMotMin,
					reorderSelection);
		}
		return new JQGridResponseDto<RelFacMotMin>(jqGridRequestDto, recordNum, listaRelFacMotMin);
	}

	/**
	 * Searches rows in the RelFacMotMin table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param searchRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelFacMotMin>>
	 */
	public List<TableRowDto<RelFacMotMin>> search(RelFacMotMin filterRelFacMotMin, RelFacMotMin searchRelFacMotMin,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.relFacMotMinDao.search(filterRelFacMotMin, searchRelFacMotMin, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in RelFacMotMin table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(RelFacMotMin filterRelFacMotMin, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.relFacMotMinDao.reorderSelection(filterRelFacMotMin, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelFacMotMin table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelFacMotMin>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelFacMotMin>> jerarquia(RelFacMotMin filterRelFacMotMin,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<RelFacMotMin>> listaRelFacMotMin = this.relFacMotMinDao
				.findAllLikeJerarquia(filterRelFacMotMin, jqGridRequestDto);
		Long recordNum = this.relFacMotMinDao.findAllLikeCountJerarquia(filterRelFacMotMin, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<RelFacMotMin>>(jqGridRequestDto, recordNum, listaRelFacMotMin);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the RelFacMotMin
	 * table.
	 *
	 * @param filterRelFacMotMin
	 *            RelFacMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelFacMotMin>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelFacMotMin>> jerarquiaChildren(RelFacMotMin filterRelFacMotMin,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<RelFacMotMin>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<RelFacMotMin>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.relFacMotMinDao.findAllChild(filterRelFacMotMin, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
