package com.ejie.ab60.service.OTC;

import java.util.List;

import com.ejie.ab60.model.OTC.OficinasTecnicas;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * OficinasTecnicasService  
 * 
 *  
 */

public interface OficinasTecnicasService {

	/**
	 * Inserts a single row in the OficinasTecnicas table.
	 *
	 * @param oficinasTecnicas
	 *            OficinasTecnicas
	 * @return OficinasTecnicas
	 */
	OficinasTecnicas add(OficinasTecnicas oficinasTecnicas);

	/**
	 * Updates a single row in the OficinasTecnicas table.
	 *
	 * @param oficinasTecnicas
	 *            OficinasTecnicas
	 * @return OficinasTecnicas
	 */
	OficinasTecnicas update(OficinasTecnicas oficinasTecnicas);

	/**
	 * Finds a single row in the OficinasTecnicas table.
	 *
	 * @param oficinasTecnicas
	 *            OficinasTecnicas
	 * @return OficinasTecnicas
	 */
	OficinasTecnicas find(OficinasTecnicas oficinasTecnicas);

	/**
	 * Deletes a single row in the OficinasTecnicas table.
	 *
	 * @param oficinasTecnicas
	 *            OficinasTecnicas
	 */
	void remove(OficinasTecnicas oficinasTecnicas);

	/**
	 * Finds a list of rows in the OficinasTecnicas table.
	 *
	 * @param oficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<OficinasTecnicas>
	 */
	List<OficinasTecnicas> findAll(OficinasTecnicas oficinasTecnicas, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the OficinasTecnicas table using like.
	 *
	 * @param oficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<OficinasTecnicas>
	 */
	List<OficinasTecnicas> findAllLike(OficinasTecnicas oficinasTecnicas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the OficinasTecnicas table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(OficinasTecnicas filterOficinasTecnicas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the OficinasTecnicas table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<OficinasTecnicas>
	 */
	JQGridResponseDto<OficinasTecnicas> filter(OficinasTecnicas filterOficinasTecnicas,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the OficinasTecnicas table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param searchOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OficinasTecnicas>>
	 */
	List<TableRowDto<OficinasTecnicas>> search(OficinasTecnicas filterOficinasTecnicas,
			OficinasTecnicas searchOficinasTecnicas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in OficinasTecnicas table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(OficinasTecnicas filterOficinasTecnicas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the OficinasTecnicas table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<OficinasTecnicas>>
	 */
	JQGridResponseDto<JerarquiaDto<OficinasTecnicas>> jerarquia(OficinasTecnicas filterOficinasTecnicas,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the OficinasTecnicas
	 * table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<OficinasTecnicas>>
	 */
	JQGridResponseDto<JerarquiaDto<OficinasTecnicas>> jerarquiaChildren(OficinasTecnicas filterOficinasTecnicas,
			JQGridRequestDto jqGridRequestDto);

}
