package com.ejie.ab60.service.OTC;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.OTC.OficinasTecnicasDao;
import com.ejie.ab60.model.OTC.OficinasTecnicas;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * OficinasTecnicasServiceImpl  
 * 
 *  
 */

@Service(value = "oficinasTecnicasService")
public class OficinasTecnicasServiceImpl implements OficinasTecnicasService {

	@Autowired
	private OficinasTecnicasDao oficinasTecnicasDao;

	/**
	 * Inserts a single row in the OficinasTecnicas table.
	 *
	 * @param oficinasTecnicas
	 *            OficinasTecnicas
	 * @return OficinasTecnicas
	 */
	@Transactional(rollbackFor = Throwable.class)
	public OficinasTecnicas add(OficinasTecnicas oficinasTecnicas) {
		return this.oficinasTecnicasDao.add(oficinasTecnicas);
	}

	/**
	 * Updates a single row in the OficinasTecnicas table.
	 *
	 * @param oficinasTecnicas
	 *            OficinasTecnicas
	 * @return OficinasTecnicas
	 */
	@Transactional(rollbackFor = Throwable.class)
	public OficinasTecnicas update(OficinasTecnicas oficinasTecnicas) {
		return this.oficinasTecnicasDao.update(oficinasTecnicas);
	}

	/**
	 * Finds a single row in the OficinasTecnicas table.
	 *
	 * @param oficinasTecnicas
	 *            OficinasTecnicas
	 * @return OficinasTecnicas
	 */
	public OficinasTecnicas find(OficinasTecnicas oficinasTecnicas) {
		return (OficinasTecnicas) this.oficinasTecnicasDao.find(oficinasTecnicas);
	}

	/**
	 * Deletes a single row in the OficinasTecnicas table.
	 *
	 * @param oficinasTecnicas
	 *            OficinasTecnicas
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(OficinasTecnicas oficinasTecnicas) {
		this.oficinasTecnicasDao.remove(oficinasTecnicas);
	}

	/**
	 * Finds a list of rows in the OficinasTecnicas table.
	 *
	 * @param oficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<OficinasTecnicas>
	 */
	public List<OficinasTecnicas> findAll(OficinasTecnicas oficinasTecnicas, JQGridRequestDto jqGridRequestDto) {
		return (List<OficinasTecnicas>) this.oficinasTecnicasDao.findAll(oficinasTecnicas, jqGridRequestDto);
	}

	/**
	 * Finds rows in the OficinasTecnicas table using like.
	 *
	 * @param oficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<OficinasTecnicas>
	 */
	public List<OficinasTecnicas> findAllLike(OficinasTecnicas oficinasTecnicas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<OficinasTecnicas>) this.oficinasTecnicasDao.findAllLike(oficinasTecnicas, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the OficinasTecnicas table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(OficinasTecnicas filterOficinasTecnicas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.oficinasTecnicasDao.removeMultiple(filterOficinasTecnicas, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the OficinasTecnicas table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<OficinasTecnicas>
	 */
	public JQGridResponseDto<OficinasTecnicas> filter(OficinasTecnicas filterOficinasTecnicas,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<OficinasTecnicas> listaOficinasTecnicas = this.oficinasTecnicasDao.findAllLike(filterOficinasTecnicas,
				jqGridRequestDto, false);
		Long recordNum = this.oficinasTecnicasDao.findAllLikeCount(
				filterOficinasTecnicas != null ? filterOficinasTecnicas : new OficinasTecnicas(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<OficinasTecnicas>> reorderSelection = this.oficinasTecnicasDao
					.reorderSelection(filterOficinasTecnicas, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<OficinasTecnicas>(jqGridRequestDto, recordNum, listaOficinasTecnicas,
					reorderSelection);
		}
		return new JQGridResponseDto<OficinasTecnicas>(jqGridRequestDto, recordNum, listaOficinasTecnicas);
	}

	/**
	 * Searches rows in the OficinasTecnicas table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param searchOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OficinasTecnicas>>
	 */
	public List<TableRowDto<OficinasTecnicas>> search(OficinasTecnicas filterOficinasTecnicas,
			OficinasTecnicas searchOficinasTecnicas, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.oficinasTecnicasDao.search(filterOficinasTecnicas, searchOficinasTecnicas, jqGridRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in OficinasTecnicas table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(OficinasTecnicas filterOficinasTecnicas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.oficinasTecnicasDao.reorderSelection(filterOficinasTecnicas, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the OficinasTecnicas table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<OficinasTecnicas>>
	 */
	public JQGridResponseDto<JerarquiaDto<OficinasTecnicas>> jerarquia(OficinasTecnicas filterOficinasTecnicas,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<OficinasTecnicas>> listaOficinasTecnicas = this.oficinasTecnicasDao
				.findAllLikeJerarquia(filterOficinasTecnicas, jqGridRequestDto);
		Long recordNum = this.oficinasTecnicasDao.findAllLikeCountJerarquia(filterOficinasTecnicas, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<OficinasTecnicas>>(jqGridRequestDto, recordNum,
				listaOficinasTecnicas);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the OficinasTecnicas
	 * table.
	 *
	 * @param filterOficinasTecnicas
	 *            OficinasTecnicas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<OficinasTecnicas>>
	 */
	public JQGridResponseDto<JerarquiaDto<OficinasTecnicas>> jerarquiaChildren(OficinasTecnicas filterOficinasTecnicas,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<OficinasTecnicas>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<OficinasTecnicas>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.oficinasTecnicasDao.findAllChild(filterOficinasTecnicas, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
