package com.ejie.ab60.service.OTC;

import java.util.List;

import com.ejie.ab60.model.OTC.Zonas;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ZonasService  
 * 
 *  
 */

public interface ZonasService {

	/**
	 * Inserts a single row in the Zonas table.
	 *
	 * @param zonas
	 *            Zonas
	 * @return Zonas
	 */
	Zonas add(Zonas zonas);

	/**
	 * Updates a single row in the Zonas table.
	 *
	 * @param zonas
	 *            Zonas
	 * @return Zonas
	 */
	Zonas update(Zonas zonas);

	/**
	 * Finds a single row in the Zonas table.
	 *
	 * @param zonas
	 *            Zonas
	 * @return Zonas
	 */
	Zonas find(Zonas zonas);

	/**
	 * Deletes a single row in the Zonas table.
	 *
	 * @param zonas
	 *            Zonas
	 */
	void remove(Zonas zonas);

	/**
	 * Finds a list of rows in the Zonas table.
	 *
	 * @param zonas
	 *            Zonas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Zonas>
	 */
	List<Zonas> findAll(Zonas zonas, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Zonas table using like.
	 *
	 * @param zonas
	 *            Zonas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Zonas>
	 */
	List<Zonas> findAllLike(Zonas zonas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Zonas table.
	 *
	 * @param filterZonas
	 *            Zonas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Zonas filterZonas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Zonas table.
	 *
	 * @param filterZonas
	 *            Zonas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Zonas>
	 */
	JQGridResponseDto<Zonas> filter(Zonas filterZonas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the Zonas table.
	 *
	 * @param filterZonas
	 *            Zonas
	 * @param searchZonas
	 *            Zonas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Zonas>>
	 */
	List<TableRowDto<Zonas>> search(Zonas filterZonas, Zonas searchZonas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Reorder the selection made in Zonas table.
	 *
	 * @param filterZonas
	 *            Zonas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Zonas filterZonas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Zonas table.
	 *
	 * @param filterZonas
	 *            Zonas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Zonas>>
	 */
	JQGridResponseDto<JerarquiaDto<Zonas>> jerarquia(Zonas filterZonas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Zonas table.
	 *
	 * @param filterZonas
	 *            Zonas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Zonas>>
	 */
	JQGridResponseDto<JerarquiaDto<Zonas>> jerarquiaChildren(Zonas filterZonas, JQGridRequestDto jqGridRequestDto);

}
