package com.ejie.ab60.service;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.OtrosIngresosDao;
import com.ejie.ab60.model.OtrosIngresos;

/**
 * OtrosIngresosServiceImpl  
 * 
 *  
 */

@Service(value = "otrosIngresosService")
public class OtrosIngresosServiceImpl implements OtrosIngresosService {

	@Autowired
	private OtrosIngresosDao otrosIngresosDao;

	/**
	 * Inserts a single row in the OtrosIngresos table.
	 *
	 * @param otrosIngresos
	 *            OtrosIngresos
	 * @return OtrosIngresos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public OtrosIngresos add(OtrosIngresos otrosIngresos) {
		return this.otrosIngresosDao.add(otrosIngresos);
	}

	/**
	 * Updates a single row in the OtrosIngresos table.
	 *
	 * @param otrosIngresos
	 *            OtrosIngresos
	 * @return OtrosIngresos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public OtrosIngresos update(OtrosIngresos otrosIngresos) {
		return this.otrosIngresosDao.update(otrosIngresos);
	}

	/**
	 * Finds a single row in the OtrosIngresos table.
	 *
	 * @param otrosIngresos
	 *            OtrosIngresos
	 * @return OtrosIngresos
	 */
	public OtrosIngresos find(OtrosIngresos otrosIngresos) {
		return (OtrosIngresos) this.otrosIngresosDao.find(otrosIngresos);
	}

	/**
	 * Deletes a single row in the OtrosIngresos table.
	 *
	 * @param otrosIngresos
	 *            OtrosIngresos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(OtrosIngresos otrosIngresos) {
		this.otrosIngresosDao.remove(otrosIngresos);
	}

	@Override
	public OtrosIngresos findByIdRelExpActSub(OtrosIngresos otrosIngresos) {
		return (OtrosIngresos) this.otrosIngresosDao.findByIdRelExpActSub(otrosIngresos);
	}

	@Override
	public OtrosIngresos updateImporte(OtrosIngresos otrosIngresos) {
		return this.otrosIngresosDao.updateImporte(otrosIngresos);
	}
}
