package com.ejie.ab60.service.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.AmbitosTerritoriales;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * AmbitosTerritorialesService  
 * 
 *  
 */

public interface AmbitosTerritorialesService {

	/**
	 * Inserts a single row in the AmbitosTerritoriales table.
	 *
	 * @param ambitosTerritoriales
	 *            AmbitosTerritoriales
	 * @return AmbitosTerritoriales
	 */
	AmbitosTerritoriales add(AmbitosTerritoriales ambitosTerritoriales);

	/**
	 * Updates a single row in the AmbitosTerritoriales table.
	 *
	 * @param ambitosTerritoriales
	 *            AmbitosTerritoriales
	 * @return AmbitosTerritoriales
	 */
	AmbitosTerritoriales update(AmbitosTerritoriales ambitosTerritoriales);

	/**
	 * Finds a single row in the AmbitosTerritoriales table.
	 *
	 * @param ambitosTerritoriales
	 *            AmbitosTerritoriales
	 * @return AmbitosTerritoriales
	 */
	AmbitosTerritoriales find(AmbitosTerritoriales ambitosTerritoriales);

	/**
	 * Deletes a single row in the AmbitosTerritoriales table.
	 *
	 * @param ambitosTerritoriales
	 *            AmbitosTerritoriales
	 */
	void remove(AmbitosTerritoriales ambitosTerritoriales);

	/**
	 * Finds a list of rows in the AmbitosTerritoriales table.
	 *
	 * @param ambitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<AmbitosTerritoriales>
	 */
	List<AmbitosTerritoriales> findAll(AmbitosTerritoriales ambitosTerritoriales, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the AmbitosTerritoriales table using like.
	 *
	 * @param ambitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<AmbitosTerritoriales>
	 */
	List<AmbitosTerritoriales> findAllLike(AmbitosTerritoriales ambitosTerritoriales, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(AmbitosTerritoriales filterAmbitosTerritoriales, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<AmbitosTerritoriales>
	 */
	JQGridResponseDto<AmbitosTerritoriales> filter(AmbitosTerritoriales filterAmbitosTerritoriales,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param searchAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AmbitosTerritoriales>>
	 */
	List<TableRowDto<AmbitosTerritoriales>> search(AmbitosTerritoriales filterAmbitosTerritoriales,
			AmbitosTerritoriales searchAmbitosTerritoriales, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(AmbitosTerritoriales filterAmbitosTerritoriales, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<AmbitosTerritoriales>>
	 */
	JQGridResponseDto<JerarquiaDto<AmbitosTerritoriales>> jerarquia(AmbitosTerritoriales filterAmbitosTerritoriales,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<AmbitosTerritoriales>>
	 */
	JQGridResponseDto<JerarquiaDto<AmbitosTerritoriales>> jerarquiaChildren(
			AmbitosTerritoriales filterAmbitosTerritoriales, JQGridRequestDto jqGridRequestDto);

}
