package com.ejie.ab60.service.PTT;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.PTT.AmbitosTerritorialesDao;
import com.ejie.ab60.model.PTT.AmbitosTerritoriales;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * AmbitosTerritorialesServiceImpl  
 * 
 *  
 */

@Service(value = "ambitosTerritorialesService")
public class AmbitosTerritorialesServiceImpl implements AmbitosTerritorialesService {

	@Autowired
	private AmbitosTerritorialesDao ambitosTerritorialesDao;

	/**
	 * Inserts a single row in the AmbitosTerritoriales table.
	 *
	 * @param ambitosTerritoriales
	 *            AmbitosTerritoriales
	 * @return AmbitosTerritoriales
	 */
	@Transactional(rollbackFor = Throwable.class)
	public AmbitosTerritoriales add(AmbitosTerritoriales ambitosTerritoriales) {
		return this.ambitosTerritorialesDao.add(ambitosTerritoriales);
	}

	/**
	 * Updates a single row in the AmbitosTerritoriales table.
	 *
	 * @param ambitosTerritoriales
	 *            AmbitosTerritoriales
	 * @return AmbitosTerritoriales
	 */
	@Transactional(rollbackFor = Throwable.class)
	public AmbitosTerritoriales update(AmbitosTerritoriales ambitosTerritoriales) {
		return this.ambitosTerritorialesDao.update(ambitosTerritoriales);
	}

	/**
	 * Finds a single row in the AmbitosTerritoriales table.
	 *
	 * @param ambitosTerritoriales
	 *            AmbitosTerritoriales
	 * @return AmbitosTerritoriales
	 */
	public AmbitosTerritoriales find(AmbitosTerritoriales ambitosTerritoriales) {
		return (AmbitosTerritoriales) this.ambitosTerritorialesDao.find(ambitosTerritoriales);
	}

	/**
	 * Deletes a single row in the AmbitosTerritoriales table.
	 *
	 * @param ambitosTerritoriales
	 *            AmbitosTerritoriales
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(AmbitosTerritoriales ambitosTerritoriales) {
		this.ambitosTerritorialesDao.remove(ambitosTerritoriales);
	}

	/**
	 * Finds a list of rows in the AmbitosTerritoriales table.
	 *
	 * @param ambitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<AmbitosTerritoriales>
	 */
	public List<AmbitosTerritoriales> findAll(AmbitosTerritoriales ambitosTerritoriales,
			JQGridRequestDto jqGridRequestDto) {
		return (List<AmbitosTerritoriales>) this.ambitosTerritorialesDao.findAll(ambitosTerritoriales,
				jqGridRequestDto);
	}

	/**
	 * Finds rows in the AmbitosTerritoriales table using like.
	 *
	 * @param ambitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<AmbitosTerritoriales>
	 */
	public List<AmbitosTerritoriales> findAllLike(AmbitosTerritoriales ambitosTerritoriales,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<AmbitosTerritoriales>) this.ambitosTerritorialesDao.findAllLike(ambitosTerritoriales,
				jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(AmbitosTerritoriales filterAmbitosTerritoriales, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.ambitosTerritorialesDao.removeMultiple(filterAmbitosTerritoriales, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<AmbitosTerritoriales>
	 */
	public JQGridResponseDto<AmbitosTerritoriales> filter(AmbitosTerritoriales filterAmbitosTerritoriales,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<AmbitosTerritoriales> listaAmbitosTerritoriales = this.ambitosTerritorialesDao
				.findAllLike(filterAmbitosTerritoriales, jqGridRequestDto, false);
		Long recordNum = this.ambitosTerritorialesDao.findAllLikeCount(
				filterAmbitosTerritoriales != null ? filterAmbitosTerritoriales : new AmbitosTerritoriales(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<AmbitosTerritoriales>> reorderSelection = this.ambitosTerritorialesDao
					.reorderSelection(filterAmbitosTerritoriales, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<AmbitosTerritoriales>(jqGridRequestDto, recordNum, listaAmbitosTerritoriales,
					reorderSelection);
		}
		return new JQGridResponseDto<AmbitosTerritoriales>(jqGridRequestDto, recordNum, listaAmbitosTerritoriales);
	}

	/**
	 * Searches rows in the AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param searchAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AmbitosTerritoriales>>
	 */
	public List<TableRowDto<AmbitosTerritoriales>> search(AmbitosTerritoriales filterAmbitosTerritoriales,
			AmbitosTerritoriales searchAmbitosTerritoriales, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.ambitosTerritorialesDao.search(filterAmbitosTerritoriales, searchAmbitosTerritoriales,
				jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(AmbitosTerritoriales filterAmbitosTerritoriales, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.ambitosTerritorialesDao.reorderSelection(filterAmbitosTerritoriales, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<AmbitosTerritoriales>>
	 */
	public JQGridResponseDto<JerarquiaDto<AmbitosTerritoriales>> jerarquia(
			AmbitosTerritoriales filterAmbitosTerritoriales, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<AmbitosTerritoriales>> listaAmbitosTerritoriales = this.ambitosTerritorialesDao
				.findAllLikeJerarquia(filterAmbitosTerritoriales, jqGridRequestDto);
		Long recordNum = this.ambitosTerritorialesDao.findAllLikeCountJerarquia(filterAmbitosTerritoriales,
				jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<AmbitosTerritoriales>>(jqGridRequestDto, recordNum,
				listaAmbitosTerritoriales);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * AmbitosTerritoriales table.
	 *
	 * @param filterAmbitosTerritoriales
	 *            AmbitosTerritoriales
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<AmbitosTerritoriales>>
	 */
	public JQGridResponseDto<JerarquiaDto<AmbitosTerritoriales>> jerarquiaChildren(
			AmbitosTerritoriales filterAmbitosTerritoriales, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<AmbitosTerritoriales>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<AmbitosTerritoriales>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.ambitosTerritorialesDao.findAllChild(filterAmbitosTerritoriales, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
