package com.ejie.ab60.service.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.Competitividad;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * CompetitividadService  
 * 
 *  
 */

public interface CompetitividadService {

	/**
	 * Inserts a single row in the Competitividad table.
	 *
	 * @param competitividad
	 *            Competitividad
	 * @return Competitividad
	 */
	Competitividad add(Competitividad competitividad);

	/**
	 * Updates a single row in the Competitividad table.
	 *
	 * @param competitividad
	 *            Competitividad
	 * @return Competitividad
	 */
	Competitividad update(Competitividad competitividad);

	/**
	 * Finds a single row in the Competitividad table.
	 *
	 * @param competitividad
	 *            Competitividad
	 * @return Competitividad
	 */
	Competitividad find(Competitividad competitividad);

	/**
	 * Deletes a single row in the Competitividad table.
	 *
	 * @param competitividad
	 *            Competitividad
	 */
	void remove(Competitividad competitividad);

	/**
	 * Finds a list of rows in the Competitividad table.
	 *
	 * @param competitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Competitividad>
	 */
	List<Competitividad> findAll(Competitividad competitividad, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Competitividad table using like.
	 *
	 * @param competitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Competitividad>
	 */
	List<Competitividad> findAllLike(Competitividad competitividad, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Competitividad table.
	 *
	 * @param filterCompetitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Competitividad filterCompetitividad, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Competitividad table.
	 *
	 * @param filterCompetitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Competitividad>
	 */
	JQGridResponseDto<Competitividad> filter(Competitividad filterCompetitividad, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the Competitividad table.
	 *
	 * @param filterCompetitividad
	 *            Competitividad
	 * @param searchCompetitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Competitividad>>
	 */
	List<TableRowDto<Competitividad>> search(Competitividad filterCompetitividad, Competitividad searchCompetitividad,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in Competitividad table.
	 *
	 * @param filterCompetitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Competitividad filterCompetitividad, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Competitividad table.
	 *
	 * @param filterCompetitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Competitividad>>
	 */
	JQGridResponseDto<JerarquiaDto<Competitividad>> jerarquia(Competitividad filterCompetitividad,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Competitividad
	 * table.
	 *
	 * @param filterCompetitividad
	 *            Competitividad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Competitividad>>
	 */
	JQGridResponseDto<JerarquiaDto<Competitividad>> jerarquiaChildren(Competitividad filterCompetitividad,
			JQGridRequestDto jqGridRequestDto);

}
