package com.ejie.ab60.service.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.ContratacionesPersonal;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ContratacionesPersonalService  
 * 
 *  
 */

public interface ContratacionesPersonalService {

	/**
	 * Inserts a single row in the ContratacionesPersonal table.
	 *
	 * @param contratacionesPersonal
	 *            ContratacionesPersonal
	 * @return ContratacionesPersonal
	 */
	ContratacionesPersonal add(ContratacionesPersonal contratacionesPersonal);

	/**
	 * Updates a single row in the ContratacionesPersonal table.
	 *
	 * @param contratacionesPersonal
	 *            ContratacionesPersonal
	 * @return ContratacionesPersonal
	 */
	ContratacionesPersonal update(ContratacionesPersonal contratacionesPersonal);

	/**
	 * Finds a single row in the ContratacionesPersonal table.
	 *
	 * @param contratacionesPersonal
	 *            ContratacionesPersonal
	 * @return ContratacionesPersonal
	 */
	ContratacionesPersonal find(ContratacionesPersonal contratacionesPersonal);

	/**
	 * Finds a single row in the ContratacionesPersonal table.
	 *
	 * @param Integer
	 *            idRelExpActSub
	 * @return List<ContratacionesPersonal>
	 */
	List<ContratacionesPersonal> findContratacionesPersonalPorRelExpActSub(Integer idRelExpActSub);

	/**
	 * Deletes a single row in the ContratacionesPersonal table.
	 *
	 * @param contratacionesPersonal
	 *            ContratacionesPersonal
	 */
	void remove(ContratacionesPersonal contratacionesPersonal);

	/**
	 * Finds a list of rows in the ContratacionesPersonal table.
	 *
	 * @param contratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ContratacionesPersonal>
	 */
	List<ContratacionesPersonal> findAll(ContratacionesPersonal contratacionesPersonal,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ContratacionesPersonal table using like.
	 *
	 * @param contratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ContratacionesPersonal>
	 */
	List<ContratacionesPersonal> findAllLike(ContratacionesPersonal contratacionesPersonal,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the ContratacionesPersonal table.
	 *
	 * @param filterContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ContratacionesPersonal filterContratacionesPersonal, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the ContratacionesPersonal table.
	 *
	 * @param filterContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ContratacionesPersonal>
	 */
	JQGridResponseDto<ContratacionesPersonal> filter(ContratacionesPersonal filterContratacionesPersonal,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the ContratacionesPersonal table.
	 *
	 * @param filterContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param searchContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ContratacionesPersonal>>
	 */
	List<TableRowDto<ContratacionesPersonal>> search(ContratacionesPersonal filterContratacionesPersonal,
			ContratacionesPersonal searchContratacionesPersonal, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in ContratacionesPersonal table.
	 *
	 * @param filterContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(ContratacionesPersonal filterContratacionesPersonal, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the ContratacionesPersonal table.
	 *
	 * @param filterContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<ContratacionesPersonal>>
	 */
	JQGridResponseDto<JerarquiaDto<ContratacionesPersonal>> jerarquia(
			ContratacionesPersonal filterContratacionesPersonal, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * ContratacionesPersonal table.
	 *
	 * @param filterContratacionesPersonal
	 *            ContratacionesPersonal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<ContratacionesPersonal>>
	 */
	JQGridResponseDto<JerarquiaDto<ContratacionesPersonal>> jerarquiaChildren(
			ContratacionesPersonal filterContratacionesPersonal, JQGridRequestDto jqGridRequestDto);

	/**
	 * Removes a single row in the ContratacionesPersonal table.
	 *
	 * @param idRelExpActSub
	 *            Integer
	 * @return
	 */
	void removeByIdRelExpActSub(Integer idRelExpActSub);

}
