package com.ejie.ab60.service.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.GastosTuristicos;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * GastosTuristicosService  
 * 
 *  
 */

public interface GastosTuristicosService {

	/**
	 * Inserts a single row in the GastosTuristicos table.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 * @return GastosTuristicos
	 */
	GastosTuristicos add(GastosTuristicos gastosTuristicos);

	/**
	 * Updates a single row in the GastosTuristicos table.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 * @return GastosTuristicos
	 */
	GastosTuristicos update(GastosTuristicos gastosTuristicos);

	/**
	 * Updates a single row in the GastosTuristicos table.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 * @return GastosTuristicos
	 */
	GastosTuristicos updateGastosTuristicos(GastosTuristicos gastosTuristicos);

	/**
	 * Finds a single row in the GastosTuristicos table.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 * @return GastosTuristicos
	 */
	GastosTuristicos find(GastosTuristicos gastosTuristicos);

	/**
	 * Deletes a single row in the GastosTuristicos table.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 */
	void remove(GastosTuristicos gastosTuristicos);

	/**
	 * Finds a list of rows in the GastosTuristicos table.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<GastosTuristicos>
	 */
	List<GastosTuristicos> findAll(GastosTuristicos gastosTuristicos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the GastosTuristicos table using like.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<GastosTuristicos>
	 */
	List<GastosTuristicos> findAllLike(GastosTuristicos gastosTuristicos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the GastosTuristicos table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(GastosTuristicos filterGastosTuristicos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the GastosTuristicos table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<GastosTuristicos>
	 */
	JQGridResponseDto<GastosTuristicos> filter(GastosTuristicos filterGastosTuristicos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the GastosTuristicos table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param searchGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<GastosTuristicos>>
	 */
	List<TableRowDto<GastosTuristicos>> search(GastosTuristicos filterGastosTuristicos,
			GastosTuristicos searchGastosTuristicos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in GastosTuristicos table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(GastosTuristicos filterGastosTuristicos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the GastosTuristicos table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<GastosTuristicos>>
	 */
	JQGridResponseDto<JerarquiaDto<GastosTuristicos>> jerarquia(GastosTuristicos filterGastosTuristicos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the GastosTuristicos
	 * table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<GastosTuristicos>>
	 */
	JQGridResponseDto<JerarquiaDto<GastosTuristicos>> jerarquiaChildren(GastosTuristicos filterGastosTuristicos,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * findGastosTuristicosPorRelExpActSub
	 * 
	 * @param idRelExpActSub
	 *            Integer
	 */
	GastosTuristicos findGastosTuristicosPorRelExpActSub(Integer idRelExpActSub);

}
