package com.ejie.ab60.service.PTT;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.PTT.GastosTuristicosDao;
import com.ejie.ab60.model.PTT.GastosTuristicos;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * GastosTuristicosServiceImpl  
 * 
 *  
 */

@Service(value = "gastosTuristicosService")
public class GastosTuristicosServiceImpl implements GastosTuristicosService {

	@Autowired
	private GastosTuristicosDao gastosTuristicosDao;

	/**
	 * Inserts a single row in the GastosTuristicos table.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 * @return GastosTuristicos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public GastosTuristicos add(GastosTuristicos gastosTuristicos) {
		return this.gastosTuristicosDao.add(gastosTuristicos);
	}

	/**
	 * Updates a single row in the GastosTuristicos table.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 * @return GastosTuristicos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public GastosTuristicos update(GastosTuristicos gastosTuristicos) {
		return this.gastosTuristicosDao.update(gastosTuristicos);
	}

	/**
	 * Updates a single row in the GastosTuristicos table.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 * @return GastosTuristicos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public GastosTuristicos updateGastosTuristicos(GastosTuristicos gastosTuristicos) {
		return this.gastosTuristicosDao.updateGastosTuristicos(gastosTuristicos);
	}

	/**
	 * Finds a single row in the GastosTuristicos table.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 * @return GastosTuristicos
	 */
	public GastosTuristicos find(GastosTuristicos gastosTuristicos) {
		return (GastosTuristicos) this.gastosTuristicosDao.find(gastosTuristicos);
	}

	/**
	 * findGastosTuristicosPorRelExpActSub
	 * 
	 * @param idRelExpActSub
	 *            Integer
	 */
	@Override
	public GastosTuristicos findGastosTuristicosPorRelExpActSub(Integer idRelExpActSub) {
		return (GastosTuristicos) this.gastosTuristicosDao.findGastosTuristicosPorRelExpActSub(idRelExpActSub);
	}

	/**
	 * Deletes a single row in the GastosTuristicos table.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(GastosTuristicos gastosTuristicos) {
		this.gastosTuristicosDao.remove(gastosTuristicos);
	}

	/**
	 * Finds a list of rows in the GastosTuristicos table.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<GastosTuristicos>
	 */
	public List<GastosTuristicos> findAll(GastosTuristicos gastosTuristicos, JQGridRequestDto jqGridRequestDto) {
		return (List<GastosTuristicos>) this.gastosTuristicosDao.findAll(gastosTuristicos, jqGridRequestDto);
	}

	/**
	 * Finds rows in the GastosTuristicos table using like.
	 *
	 * @param gastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<GastosTuristicos>
	 */
	public List<GastosTuristicos> findAllLike(GastosTuristicos gastosTuristicos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<GastosTuristicos>) this.gastosTuristicosDao.findAllLike(gastosTuristicos, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the GastosTuristicos table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(GastosTuristicos filterGastosTuristicos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.gastosTuristicosDao.removeMultiple(filterGastosTuristicos, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the GastosTuristicos table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<GastosTuristicos>
	 */
	public JQGridResponseDto<GastosTuristicos> filter(GastosTuristicos filterGastosTuristicos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<GastosTuristicos> listaGastosTuristicos = this.gastosTuristicosDao.findAllLike(filterGastosTuristicos,
				jqGridRequestDto, false);
		Long recordNum = this.gastosTuristicosDao.findAllLikeCount(
				filterGastosTuristicos != null ? filterGastosTuristicos : new GastosTuristicos(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<GastosTuristicos>> reorderSelection = this.gastosTuristicosDao
					.reorderSelection(filterGastosTuristicos, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<GastosTuristicos>(jqGridRequestDto, recordNum, listaGastosTuristicos,
					reorderSelection);
		}
		return new JQGridResponseDto<GastosTuristicos>(jqGridRequestDto, recordNum, listaGastosTuristicos);
	}

	/**
	 * Searches rows in the GastosTuristicos table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param searchGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<GastosTuristicos>>
	 */
	public List<TableRowDto<GastosTuristicos>> search(GastosTuristicos filterGastosTuristicos,
			GastosTuristicos searchGastosTuristicos, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.gastosTuristicosDao.search(filterGastosTuristicos, searchGastosTuristicos, jqGridRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in GastosTuristicos table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(GastosTuristicos filterGastosTuristicos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.gastosTuristicosDao.reorderSelection(filterGastosTuristicos, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the GastosTuristicos table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<GastosTuristicos>>
	 */
	public JQGridResponseDto<JerarquiaDto<GastosTuristicos>> jerarquia(GastosTuristicos filterGastosTuristicos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<GastosTuristicos>> listaGastosTuristicos = this.gastosTuristicosDao
				.findAllLikeJerarquia(filterGastosTuristicos, jqGridRequestDto);
		Long recordNum = this.gastosTuristicosDao.findAllLikeCountJerarquia(filterGastosTuristicos, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<GastosTuristicos>>(jqGridRequestDto, recordNum,
				listaGastosTuristicos);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the GastosTuristicos
	 * table.
	 *
	 * @param filterGastosTuristicos
	 *            GastosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<GastosTuristicos>>
	 */
	public JQGridResponseDto<JerarquiaDto<GastosTuristicos>> jerarquiaChildren(GastosTuristicos filterGastosTuristicos,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<GastosTuristicos>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<GastosTuristicos>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.gastosTuristicosDao.findAllChild(filterGastosTuristicos, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
