package com.ejie.ab60.service.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.ModalidadesContrato;
import com.ejie.ab60.model.estudioTecnico.MotivosDenegacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ModalidadesContratoService  
 * 
 *  
 */

public interface ModalidadesContratoService {

	/**
	 * Finds a list of rows in the ModalidadesContrato table.
	 * 
	 * @param modalidadesContrato
	 *
	 * 
	 * @return List<ModalidadesContrato>
	 */
	List<ModalidadesContrato> findModalidadesContrato();

	/**
	 * Inserts a single row in the ModalidadesContrato table.
	 *
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 * @return ModalidadesContrato
	 */
	ModalidadesContrato add(ModalidadesContrato modalidadesContrato);

	/**
	 * Updates a single row in the ModalidadesContrato table.
	 *
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 * @return ModalidadesContrato
	 */
	ModalidadesContrato update(ModalidadesContrato modalidadesContrato);

	/**
	 * Finds a single row in the ModalidadesContrato table.
	 *
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 * @return ModalidadesContrato
	 */
	ModalidadesContrato find(ModalidadesContrato modalidadesContrato);

	/**
	 * Deletes a single row in the ModalidadesContrato table.
	 *
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 */
	void remove(ModalidadesContrato modalidadesContrato);

	/**
	 * Finds a list of rows in the ModalidadesContrato table.
	 *
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ModalidadesContrato>
	 */
	List<ModalidadesContrato> findAll(ModalidadesContrato modalidadesContrato, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ModalidadesContrato table using like.
	 *
	 * @param modalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ModalidadesContrato>
	 */
	List<ModalidadesContrato> findAllLike(ModalidadesContrato modalidadesContrato, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the ModalidadesContrato table.
	 *
	 * @param filterModalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ModalidadesContrato filterModalidadesContrato, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the ModalidadesContrato table.
	 *
	 * @param filterModalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ModalidadesContrato>
	 */
	JQGridResponseDto<ModalidadesContrato> filter(ModalidadesContrato filterModalidadesContrato,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the ModalidadesContrato table.
	 *
	 * @param filterModalidadesContrato
	 *            ModalidadesContrato
	 * @param searchModalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ModalidadesContrato>>
	 */
	List<TableRowDto<ModalidadesContrato>> search(ModalidadesContrato filterModalidadesContrato,
			ModalidadesContrato searchModalidadesContrato, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in ModalidadesContrato table.
	 *
	 * @param filterModalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(ModalidadesContrato filterModalidadesContrato, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the ModalidadesContrato table.
	 *
	 * @param filterModalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<ModalidadesContrato>>
	 */
	JQGridResponseDto<JerarquiaDto<ModalidadesContrato>> jerarquia(ModalidadesContrato filterModalidadesContrato,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * ModalidadesContrato table.
	 *
	 * @param filterModalidadesContrato
	 *            ModalidadesContrato
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<ModalidadesContrato>>
	 */
	JQGridResponseDto<JerarquiaDto<ModalidadesContrato>> jerarquiaChildren(
			ModalidadesContrato filterModalidadesContrato, JQGridRequestDto jqGridRequestDto);

}
