package com.ejie.ab60.service.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.ContratacionesPersonal;
import com.ejie.ab60.model.PTT.PersonasContratadas;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * PersonasContratadasService  
 * 
 *  
 */

public interface PersonasContratadasService {

	/**
	 * Inserts a single row in the PersonasContratadas table.
	 *
	 * @param personasContratadas
	 *            PersonasContratadas
	 * @return PersonasContratadas
	 */
	PersonasContratadas add(PersonasContratadas personasContratadas);

	/**
	 * Updates a single row in the PersonasContratadas table.
	 *
	 * @param personasContratadas
	 *            PersonasContratadas
	 * @return PersonasContratadas
	 */
	PersonasContratadas update(PersonasContratadas personasContratadas);

	/**
	 * Finds a single row in the PersonasContratadas table.
	 *
	 * @param personasContratadas
	 *            PersonasContratadas
	 * @return PersonasContratadas
	 */
	PersonasContratadas find(PersonasContratadas personasContratadas);

	/**
	 * Finds a single row in the PersonasContratadas table.
	 *
	 * @param Integer
	 *            idRelExpActSub
	 * @return List<PersonasContratadas>
	 */
	List<PersonasContratadas> findPersonasContratadasPorRelExpActSub(Integer idRelExpActSub);

	/**
	 * Deletes a single row in the PersonasContratadas table.
	 *
	 * @param personasContratadas
	 *            PersonasContratadas
	 */
	void remove(PersonasContratadas personasContratadas);

	/**
	 * Removes a single row in the PersonasContratadas table.
	 *
	 * @param idRelExpActSub
	 *            Integer
	 * @return
	 */
	void removeByIdRelExpActSub(Integer idRelExpActSub);

	/**
	 * Finds a list of rows in the PersonasContratadas table.
	 *
	 * @param personasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<PersonasContratadas>
	 */
	List<PersonasContratadas> findAll(PersonasContratadas personasContratadas, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the PersonasContratadas table using like.
	 *
	 * @param personasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<PersonasContratadas>
	 */
	List<PersonasContratadas> findAllLike(PersonasContratadas personasContratadas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the PersonasContratadas table.
	 *
	 * @param filterPersonasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(PersonasContratadas filterPersonasContratadas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the PersonasContratadas table.
	 *
	 * @param filterPersonasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<PersonasContratadas>
	 */
	JQGridResponseDto<PersonasContratadas> filter(PersonasContratadas filterPersonasContratadas,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the PersonasContratadas table.
	 *
	 * @param filterPersonasContratadas
	 *            PersonasContratadas
	 * @param searchPersonasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<PersonasContratadas>>
	 */
	List<TableRowDto<PersonasContratadas>> search(PersonasContratadas filterPersonasContratadas,
			PersonasContratadas searchPersonasContratadas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in PersonasContratadas table.
	 *
	 * @param filterPersonasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(PersonasContratadas filterPersonasContratadas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the PersonasContratadas table.
	 *
	 * @param filterPersonasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<PersonasContratadas>>
	 */
	JQGridResponseDto<JerarquiaDto<PersonasContratadas>> jerarquia(PersonasContratadas filterPersonasContratadas,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * PersonasContratadas table.
	 *
	 * @param filterPersonasContratadas
	 *            PersonasContratadas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<PersonasContratadas>>
	 */
	JQGridResponseDto<JerarquiaDto<PersonasContratadas>> jerarquiaChildren(
			PersonasContratadas filterPersonasContratadas, JQGridRequestDto jqGridRequestDto);

}
