package com.ejie.ab60.service.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.PertenenciasRedes;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * PertenenciasRedesService  
 * 
 *  
 */

public interface PertenenciasRedesService {

	/**
	 * Inserts a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 * @return PertenenciasRedes
	 */
	PertenenciasRedes add(PertenenciasRedes pertenenciasRedes);

	/**
	 * Updates a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 * @return PertenenciasRedes
	 */
	PertenenciasRedes update(PertenenciasRedes pertenenciasRedes);

	/**
	 * Updates a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 * @return PertenenciasRedes
	 */
	PertenenciasRedes updateDenominacionRedes(PertenenciasRedes pertenenciasRedes);

	/**
	 * Finds a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 * @return PertenenciasRedes
	 */
	PertenenciasRedes find(PertenenciasRedes pertenenciasRedes);

	/**
	 * Deletes a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 */
	void remove(PertenenciasRedes pertenenciasRedes);

	/**
	 * Finds a list of rows in the PertenenciasRedes table.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<PertenenciasRedes>
	 */
	List<PertenenciasRedes> findAll(PertenenciasRedes pertenenciasRedes, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the PertenenciasRedes table using like.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<PertenenciasRedes>
	 */
	List<PertenenciasRedes> findAllLike(PertenenciasRedes pertenenciasRedes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the PertenenciasRedes table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(PertenenciasRedes filterPertenenciasRedes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the PertenenciasRedes table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<PertenenciasRedes>
	 */
	JQGridResponseDto<PertenenciasRedes> filter(PertenenciasRedes filterPertenenciasRedes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the PertenenciasRedes table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param searchPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<PertenenciasRedes>>
	 */
	List<TableRowDto<PertenenciasRedes>> search(PertenenciasRedes filterPertenenciasRedes,
			PertenenciasRedes searchPertenenciasRedes, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in PertenenciasRedes table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(PertenenciasRedes filterPertenenciasRedes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the PertenenciasRedes table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<PertenenciasRedes>>
	 */
	JQGridResponseDto<JerarquiaDto<PertenenciasRedes>> jerarquia(PertenenciasRedes filterPertenenciasRedes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the PertenenciasRedes
	 * table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<PertenenciasRedes>>
	 */
	JQGridResponseDto<JerarquiaDto<PertenenciasRedes>> jerarquiaChildren(PertenenciasRedes filterPertenenciasRedes,
			JQGridRequestDto jqGridRequestDto);

}
