package com.ejie.ab60.service.PTT;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.PTT.PertenenciasRedesDao;
import com.ejie.ab60.model.PTT.PertenenciasRedes;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * PertenenciasRedesServiceImpl  
 * 
 *  
 */

@Service(value = "pertenenciasRedesService")
public class PertenenciasRedesServiceImpl implements PertenenciasRedesService {

	@Autowired
	private PertenenciasRedesDao pertenenciasRedesDao;

	/**
	 * Inserts a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 * @return PertenenciasRedes
	 */
	@Transactional(rollbackFor = Throwable.class)
	public PertenenciasRedes add(PertenenciasRedes pertenenciasRedes) {
		return this.pertenenciasRedesDao.add(pertenenciasRedes);
	}

	/**
	 * Updates a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 * @return PertenenciasRedes
	 */
	@Transactional(rollbackFor = Throwable.class)
	public PertenenciasRedes update(PertenenciasRedes pertenenciasRedes) {
		return this.pertenenciasRedesDao.update(pertenenciasRedes);
	}

	/**
	 * Updates a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 * @return PertenenciasRedes
	 */
	@Transactional(rollbackFor = Throwable.class)
	public PertenenciasRedes updateDenominacionRedes(PertenenciasRedes pertenenciasRedes) {
		return this.pertenenciasRedesDao.updateDenominacionRedes(pertenenciasRedes);
	}

	/**
	 * Finds a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 * @return PertenenciasRedes
	 */
	public PertenenciasRedes find(PertenenciasRedes pertenenciasRedes) {
		return (PertenenciasRedes) this.pertenenciasRedesDao.find(pertenenciasRedes);
	}

	/**
	 * Deletes a single row in the PertenenciasRedes table.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(PertenenciasRedes pertenenciasRedes) {
		this.pertenenciasRedesDao.remove(pertenenciasRedes);
	}

	/**
	 * Finds a list of rows in the PertenenciasRedes table.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<PertenenciasRedes>
	 */
	public List<PertenenciasRedes> findAll(PertenenciasRedes pertenenciasRedes, JQGridRequestDto jqGridRequestDto) {
		return (List<PertenenciasRedes>) this.pertenenciasRedesDao.findAll(pertenenciasRedes, jqGridRequestDto);
	}

	/**
	 * Finds rows in the PertenenciasRedes table using like.
	 *
	 * @param pertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<PertenenciasRedes>
	 */
	public List<PertenenciasRedes> findAllLike(PertenenciasRedes pertenenciasRedes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<PertenenciasRedes>) this.pertenenciasRedesDao.findAllLike(pertenenciasRedes, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the PertenenciasRedes table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(PertenenciasRedes filterPertenenciasRedes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.pertenenciasRedesDao.removeMultiple(filterPertenenciasRedes, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the PertenenciasRedes table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<PertenenciasRedes>
	 */
	public JQGridResponseDto<PertenenciasRedes> filter(PertenenciasRedes filterPertenenciasRedes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<PertenenciasRedes> listaPertenenciasRedes = this.pertenenciasRedesDao.findAllLike(filterPertenenciasRedes,
				jqGridRequestDto, false);
		Long recordNum = this.pertenenciasRedesDao.findAllLikeCount(
				filterPertenenciasRedes != null ? filterPertenenciasRedes : new PertenenciasRedes(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<PertenenciasRedes>> reorderSelection = this.pertenenciasRedesDao
					.reorderSelection(filterPertenenciasRedes, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<PertenenciasRedes>(jqGridRequestDto, recordNum, listaPertenenciasRedes,
					reorderSelection);
		}
		return new JQGridResponseDto<PertenenciasRedes>(jqGridRequestDto, recordNum, listaPertenenciasRedes);
	}

	/**
	 * Searches rows in the PertenenciasRedes table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param searchPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<PertenenciasRedes>>
	 */
	public List<TableRowDto<PertenenciasRedes>> search(PertenenciasRedes filterPertenenciasRedes,
			PertenenciasRedes searchPertenenciasRedes, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.pertenenciasRedesDao.search(filterPertenenciasRedes, searchPertenenciasRedes, jqGridRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in PertenenciasRedes table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(PertenenciasRedes filterPertenenciasRedes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.pertenenciasRedesDao.reorderSelection(filterPertenenciasRedes, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the PertenenciasRedes table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<PertenenciasRedes>>
	 */
	public JQGridResponseDto<JerarquiaDto<PertenenciasRedes>> jerarquia(PertenenciasRedes filterPertenenciasRedes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<PertenenciasRedes>> listaPertenenciasRedes = this.pertenenciasRedesDao
				.findAllLikeJerarquia(filterPertenenciasRedes, jqGridRequestDto);
		Long recordNum = this.pertenenciasRedesDao.findAllLikeCountJerarquia(filterPertenenciasRedes, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<PertenenciasRedes>>(jqGridRequestDto, recordNum,
				listaPertenenciasRedes);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the PertenenciasRedes
	 * table.
	 *
	 * @param filterPertenenciasRedes
	 *            PertenenciasRedes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<PertenenciasRedes>>
	 */
	public JQGridResponseDto<JerarquiaDto<PertenenciasRedes>> jerarquiaChildren(
			PertenenciasRedes filterPertenenciasRedes, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<PertenenciasRedes>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<PertenenciasRedes>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.pertenenciasRedesDao.findAllChild(filterPertenenciasRedes, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
