package com.ejie.ab60.service.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.ProductosTuristicos;
import com.ejie.ab60.model.estudioTecnico.TiposGasto;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ProductosTuristicosService  
 * 
 *  
 */

public interface ProductosTuristicosService {

	/**
	 * Inserts a single row in the ProductosTuristicos table.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 * @return ProductosTuristicos
	 */
	ProductosTuristicos add(ProductosTuristicos productosTuristicos);

	/**
	 * Updates a single row in the ProductosTuristicos table.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 * @return ProductosTuristicos
	 */
	ProductosTuristicos update(ProductosTuristicos productosTuristicos);

	/**
	 * Finds a single row in the ProductosTuristicos table.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 * @return ProductosTuristicos
	 */
	ProductosTuristicos find(ProductosTuristicos productosTuristicos);

	/**
	 * Deletes a single row in the ProductosTuristicos table.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 */
	void remove(ProductosTuristicos productosTuristicos);

	/**
	 * Finds a list of rows in the ProductosTuristicos table.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ProductosTuristicos>
	 */
	List<ProductosTuristicos> findAll(ProductosTuristicos productosTuristicos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the ProductosTuristicos table.
	 * 
	 * @param productosTuristicos
	 * 
	 * @param productosTuristicos
	 *
	 * 
	 * @return List<ProductosTuristicos>
	 */
	List<ProductosTuristicos> findProductosTuristicos(ProductosTuristicos productosTuristicos);

	/**
	 * Finds rows in the ProductosTuristicos table using like.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ProductosTuristicos>
	 */
	List<ProductosTuristicos> findAllLike(ProductosTuristicos productosTuristicos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ProductosTuristicos filterProductosTuristicos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ProductosTuristicos>
	 */
	JQGridResponseDto<ProductosTuristicos> filter(ProductosTuristicos filterProductosTuristicos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param searchProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ProductosTuristicos>>
	 */
	List<TableRowDto<ProductosTuristicos>> search(ProductosTuristicos filterProductosTuristicos,
			ProductosTuristicos searchProductosTuristicos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(ProductosTuristicos filterProductosTuristicos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<ProductosTuristicos>>
	 */
	JQGridResponseDto<JerarquiaDto<ProductosTuristicos>> jerarquia(ProductosTuristicos filterProductosTuristicos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<ProductosTuristicos>>
	 */
	JQGridResponseDto<JerarquiaDto<ProductosTuristicos>> jerarquiaChildren(
			ProductosTuristicos filterProductosTuristicos, JQGridRequestDto jqGridRequestDto);

}
