package com.ejie.ab60.service.PTT;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.PTT.ProductosTuristicosDao;
import com.ejie.ab60.model.PTT.ProductosTuristicos;
import com.ejie.ab60.model.estudioTecnico.TiposGasto;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ProductosTuristicosServiceImpl  
 * 
 *  
 */

@Service(value = "productosTuristicosService")
public class ProductosTuristicosServiceImpl implements ProductosTuristicosService {

	@Autowired
	private ProductosTuristicosDao productosTuristicosDao;

	/**
	 * Inserts a single row in the ProductosTuristicos table.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 * @return ProductosTuristicos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public ProductosTuristicos add(ProductosTuristicos productosTuristicos) {
		return this.productosTuristicosDao.add(productosTuristicos);
	}

	/**
	 * Updates a single row in the ProductosTuristicos table.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 * @return ProductosTuristicos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public ProductosTuristicos update(ProductosTuristicos productosTuristicos) {
		return this.productosTuristicosDao.update(productosTuristicos);
	}

	/**
	 * Finds a single row in the ProductosTuristicos table.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 * @return ProductosTuristicos
	 */
	public ProductosTuristicos find(ProductosTuristicos productosTuristicos) {
		return (ProductosTuristicos) this.productosTuristicosDao.find(productosTuristicos);
	}

	/**
	 * Deletes a single row in the ProductosTuristicos table.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(ProductosTuristicos productosTuristicos) {
		this.productosTuristicosDao.remove(productosTuristicos);
	}

	/**
	 * Finds a list of rows in the ProductosTuristicos table.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ProductosTuristicos>
	 */
	public List<ProductosTuristicos> findAll(ProductosTuristicos productosTuristicos,
			JQGridRequestDto jqGridRequestDto) {
		return (List<ProductosTuristicos>) this.productosTuristicosDao.findAll(productosTuristicos, jqGridRequestDto);
	}

	/**
	 * Finds a list of rows in the ProductosTuristicos.
	 * 
	 * @return List<ProductosTuristicos>
	 */
	public List<ProductosTuristicos> findProductosTuristicos(ProductosTuristicos productosTuristicos) {
		return (List<ProductosTuristicos>) this.productosTuristicosDao.findProductosTuristicos(productosTuristicos);
	}

	/**
	 * Finds rows in the ProductosTuristicos table using like.
	 *
	 * @param productosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ProductosTuristicos>
	 */
	public List<ProductosTuristicos> findAllLike(ProductosTuristicos productosTuristicos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<ProductosTuristicos>) this.productosTuristicosDao.findAllLike(productosTuristicos,
				jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(ProductosTuristicos filterProductosTuristicos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.productosTuristicosDao.removeMultiple(filterProductosTuristicos, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ProductosTuristicos>
	 */
	public JQGridResponseDto<ProductosTuristicos> filter(ProductosTuristicos filterProductosTuristicos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<ProductosTuristicos> listaProductosTuristicos = this.productosTuristicosDao
				.findAllLike(filterProductosTuristicos, jqGridRequestDto, false);
		Long recordNum = this.productosTuristicosDao.findAllLikeCount(
				filterProductosTuristicos != null ? filterProductosTuristicos : new ProductosTuristicos(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<ProductosTuristicos>> reorderSelection = this.productosTuristicosDao
					.reorderSelection(filterProductosTuristicos, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<ProductosTuristicos>(jqGridRequestDto, recordNum, listaProductosTuristicos,
					reorderSelection);
		}
		return new JQGridResponseDto<ProductosTuristicos>(jqGridRequestDto, recordNum, listaProductosTuristicos);
	}

	/**
	 * Searches rows in the ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param searchProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ProductosTuristicos>>
	 */
	public List<TableRowDto<ProductosTuristicos>> search(ProductosTuristicos filterProductosTuristicos,
			ProductosTuristicos searchProductosTuristicos, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.productosTuristicosDao.search(filterProductosTuristicos, searchProductosTuristicos,
				jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(ProductosTuristicos filterProductosTuristicos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.productosTuristicosDao.reorderSelection(filterProductosTuristicos, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<ProductosTuristicos>>
	 */
	public JQGridResponseDto<JerarquiaDto<ProductosTuristicos>> jerarquia(ProductosTuristicos filterProductosTuristicos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<ProductosTuristicos>> listaProductosTuristicos = this.productosTuristicosDao
				.findAllLikeJerarquia(filterProductosTuristicos, jqGridRequestDto);
		Long recordNum = this.productosTuristicosDao.findAllLikeCountJerarquia(filterProductosTuristicos,
				jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<ProductosTuristicos>>(jqGridRequestDto, recordNum,
				listaProductosTuristicos);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * ProductosTuristicos table.
	 *
	 * @param filterProductosTuristicos
	 *            ProductosTuristicos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<ProductosTuristicos>>
	 */
	public JQGridResponseDto<JerarquiaDto<ProductosTuristicos>> jerarquiaChildren(
			ProductosTuristicos filterProductosTuristicos, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<ProductosTuristicos>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<ProductosTuristicos>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.productosTuristicosDao.findAllChild(filterProductosTuristicos, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
