package com.ejie.ab60.service.PTT;

import java.util.List;

import com.ejie.ab60.model.PTT.RelExpAmbTer;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpAmbTerService  
 * 
 *  
 */

public interface RelExpAmbTerService {

	/**
	 * Inserts a single row in the RelExpAmbTer table.
	 *
	 * @param relExpAmbTer
	 *            RelExpAmbTer
	 * @return RelExpAmbTer
	 */
	RelExpAmbTer add(RelExpAmbTer relExpAmbTer);

	/**
	 * Updates a single row in the RelExpAmbTer table.
	 *
	 * @param relExpAmbTer
	 *            RelExpAmbTer
	 * @return RelExpAmbTer
	 */
	RelExpAmbTer update(RelExpAmbTer relExpAmbTer);

	/**
	 * Finds a single row in the RelExpAmbTer table.
	 *
	 * @param relExpAmbTer
	 *            RelExpAmbTer
	 * @return RelExpAmbTer
	 */
	RelExpAmbTer find(RelExpAmbTer relExpAmbTer);

	/**
	 * Deletes a single row in the RelExpAmbTer table.
	 *
	 * @param relExpAmbTer
	 *            RelExpAmbTer
	 */
	void remove(RelExpAmbTer relExpAmbTer);

	/**
	 * Finds a list of rows in the RelExpAmbTer table.
	 *
	 * @param relExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelExpAmbTer>
	 */
	List<RelExpAmbTer> findAll(RelExpAmbTer relExpAmbTer, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelExpAmbTer table using like.
	 *
	 * @param relExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelExpAmbTer>
	 */
	List<RelExpAmbTer> findAllLike(RelExpAmbTer relExpAmbTer, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelExpAmbTer table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpAmbTer filterRelExpAmbTer, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelExpAmbTer table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpAmbTer>
	 */
	JQGridResponseDto<RelExpAmbTer> filter(RelExpAmbTer filterRelExpAmbTer, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelExpAmbTer table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param searchRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpAmbTer>>
	 */
	List<TableRowDto<RelExpAmbTer>> search(RelExpAmbTer filterRelExpAmbTer, RelExpAmbTer searchRelExpAmbTer,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelExpAmbTer table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelExpAmbTer filterRelExpAmbTer, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelExpAmbTer table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelExpAmbTer>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpAmbTer>> jerarquia(RelExpAmbTer filterRelExpAmbTer,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelExpAmbTer
	 * table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelExpAmbTer>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpAmbTer>> jerarquiaChildren(RelExpAmbTer filterRelExpAmbTer,
			JQGridRequestDto jqGridRequestDto);

}
