package com.ejie.ab60.service.PTT;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.PTT.RelExpAmbTerDao;
import com.ejie.ab60.model.PTT.RelExpAmbTer;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpAmbTerServiceImpl  
 * 
 *  
 */

@Service(value = "relExpAmbTerService")
public class RelExpAmbTerServiceImpl implements RelExpAmbTerService {

	@Autowired
	private RelExpAmbTerDao relExpAmbTerDao;

	/**
	 * Inserts a single row in the RelExpAmbTer table.
	 *
	 * @param relExpAmbTer
	 *            RelExpAmbTer
	 * @return RelExpAmbTer
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpAmbTer add(RelExpAmbTer relExpAmbTer) {
		return this.relExpAmbTerDao.add(relExpAmbTer);
	}

	/**
	 * Updates a single row in the RelExpAmbTer table.
	 *
	 * @param relExpAmbTer
	 *            RelExpAmbTer
	 * @return RelExpAmbTer
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpAmbTer update(RelExpAmbTer relExpAmbTer) {
		return this.relExpAmbTerDao.update(relExpAmbTer);
	}

	/**
	 * Finds a single row in the RelExpAmbTer table.
	 *
	 * @param relExpAmbTer
	 *            RelExpAmbTer
	 * @return RelExpAmbTer
	 */
	public RelExpAmbTer find(RelExpAmbTer relExpAmbTer) {
		return (RelExpAmbTer) this.relExpAmbTerDao.find(relExpAmbTer);
	}

	/**
	 * Deletes a single row in the RelExpAmbTer table.
	 *
	 * @param relExpAmbTer
	 *            RelExpAmbTer
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(RelExpAmbTer relExpAmbTer) {
		this.relExpAmbTerDao.remove(relExpAmbTer);
	}

	/**
	 * Finds a list of rows in the RelExpAmbTer table.
	 *
	 * @param relExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelExpAmbTer>
	 */
	public List<RelExpAmbTer> findAll(RelExpAmbTer relExpAmbTer, JQGridRequestDto jqGridRequestDto) {
		return (List<RelExpAmbTer>) this.relExpAmbTerDao.findAll(relExpAmbTer, jqGridRequestDto);
	}

	/**
	 * Finds rows in the RelExpAmbTer table using like.
	 *
	 * @param relExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelExpAmbTer>
	 */
	public List<RelExpAmbTer> findAllLike(RelExpAmbTer relExpAmbTer, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<RelExpAmbTer>) this.relExpAmbTerDao.findAllLike(relExpAmbTer, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelExpAmbTer table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(RelExpAmbTer filterRelExpAmbTer, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.relExpAmbTerDao.removeMultiple(filterRelExpAmbTer, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the RelExpAmbTer table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpAmbTer>
	 */
	public JQGridResponseDto<RelExpAmbTer> filter(RelExpAmbTer filterRelExpAmbTer, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<RelExpAmbTer> listaRelExpAmbTer = this.relExpAmbTerDao.findAllLike(filterRelExpAmbTer, jqGridRequestDto,
				false);
		Long recordNum = this.relExpAmbTerDao
				.findAllLikeCount(filterRelExpAmbTer != null ? filterRelExpAmbTer : new RelExpAmbTer(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelExpAmbTer>> reorderSelection = this.relExpAmbTerDao.reorderSelection(filterRelExpAmbTer,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelExpAmbTer>(jqGridRequestDto, recordNum, listaRelExpAmbTer,
					reorderSelection);
		}
		return new JQGridResponseDto<RelExpAmbTer>(jqGridRequestDto, recordNum, listaRelExpAmbTer);
	}

	/**
	 * Searches rows in the RelExpAmbTer table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param searchRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpAmbTer>>
	 */
	public List<TableRowDto<RelExpAmbTer>> search(RelExpAmbTer filterRelExpAmbTer, RelExpAmbTer searchRelExpAmbTer,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.relExpAmbTerDao.search(filterRelExpAmbTer, searchRelExpAmbTer, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in RelExpAmbTer table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(RelExpAmbTer filterRelExpAmbTer, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.relExpAmbTerDao.reorderSelection(filterRelExpAmbTer, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelExpAmbTer table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelExpAmbTer>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelExpAmbTer>> jerarquia(RelExpAmbTer filterRelExpAmbTer,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<RelExpAmbTer>> listaRelExpAmbTer = this.relExpAmbTerDao
				.findAllLikeJerarquia(filterRelExpAmbTer, jqGridRequestDto);
		Long recordNum = this.relExpAmbTerDao.findAllLikeCountJerarquia(filterRelExpAmbTer, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<RelExpAmbTer>>(jqGridRequestDto, recordNum, listaRelExpAmbTer);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the RelExpAmbTer
	 * table.
	 *
	 * @param filterRelExpAmbTer
	 *            RelExpAmbTer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelExpAmbTer>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelExpAmbTer>> jerarquiaChildren(RelExpAmbTer filterRelExpAmbTer,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<RelExpAmbTer>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<RelExpAmbTer>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.relExpAmbTerDao.findAllChild(filterRelExpAmbTer, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
