package com.ejie.ab60.service;

import java.util.List;

import com.ejie.ab60.model.RelExpIns;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpInsService  
 * 
 * 
 *  
 */

public interface RelExpInsService {

	/**
	 * Finds a single row in the RelExpIns table.
	 *
	 * @param relExpIns
	 *            RelExpIns
	 * @return RelExpIns
	 */
	RelExpIns findTipoInspeccion(RelExpIns relExpIns);

	/**
	 * Inserts a single row in the RelExpIns table.
	 *
	 * @param relExpIns
	 *            RelExpIns
	 * @return RelExpIns
	 */
	RelExpIns add(RelExpIns relExpIns);

	/**
	 * Updates a single row in the RelExpIns table.
	 *
	 * @param relExpIns
	 *            RelExpIns
	 * @return RelExpIns
	 */
	RelExpIns update(RelExpIns relExpIns);

	/**
	 * Finds a single row in the RelExpIns table.
	 *
	 * @param relExpIns
	 *            RelExpIns
	 * @return RelExpIns
	 */
	RelExpIns find(RelExpIns relExpIns);

	/**
	 * Deletes a single row in the RelExpIns table.
	 *
	 * @param relExpIns
	 *            RelExpIns
	 */
	void remove(RelExpIns relExpIns);

	/**
	 * Finds a list of rows in the RelExpIns table.
	 *
	 * @param relExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelExpIns>
	 */
	List<RelExpIns> findAll(RelExpIns relExpIns, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelExpIns table using like.
	 *
	 * @param relExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelExpIns>
	 */
	List<RelExpIns> findAllLike(RelExpIns relExpIns, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelExpIns table.
	 *
	 * @param filterRelExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpIns filterRelExpIns, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelExpIns table.
	 *
	 * @param filterRelExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpIns>
	 */
	JQGridResponseDto<RelExpIns> filter(RelExpIns filterRelExpIns, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelExpIns table.
	 *
	 * @param filterRelExpIns
	 *            RelExpIns
	 * @param searchRelExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpIns>>
	 */
	List<TableRowDto<RelExpIns>> search(RelExpIns filterRelExpIns, RelExpIns searchRelExpIns,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelExpIns table.
	 *
	 * @param filterRelExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelExpIns filterRelExpIns, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelExpIns table.
	 *
	 * @param filterRelExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelExpIns>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpIns>> jerarquia(RelExpIns filterRelExpIns, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelExpIns table.
	 *
	 * @param filterRelExpIns
	 *            RelExpIns
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelExpIns>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpIns>> jerarquiaChildren(RelExpIns filterRelExpIns,
			JQGridRequestDto jqGridRequestDto);

	RelExpIns findByIdExpediente(RelExpIns relExpIns);

	Integer obtenerID(String identificadorInspeccion);

	RelExpIns findByIdentificadorInspeccion(RelExpIns relExpIns);

	RelExpIns findByIdInspeccion(RelExpIns relExpIns);

}
