package com.ejie.ab60.service.actuacionesSubvencionables;

import java.util.List;

import com.ejie.ab60.model.actuacionesSubvencionables.ActSubvencionable;
import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.ab60.model.estudioTecnico.RelExpErrCal;
import com.ejie.ab60.model.expedientes.MarcarInspeccionableAct;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ActSubvencionableService  
 * 
 *  
 */

public interface ActSubvencionableService {

	/**
	 * Inserts a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable add(ActSubvencionable actSubvencionable);

	/**
	 * Updates a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable update(ActSubvencionable actSubvencionable);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable find(ActSubvencionable actSubvencionable);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable findImporteDisponible(ActSubvencionable actSubvencionable);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable findIdActSub(Integer idActSub);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable findPorcentaje(ActSubvencionable actSubvencionable);

	/**
	 * Busca las act. subvencionables de una convocatoria segun el padre de la
	 * actuacion subvencionable
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @param idCriterio
	 *            Integer
	 * @return actSubvencionableList
	 */
	List<ActSubvencionable> findActSubporConvocatoriaPorActSubPadre(Integer Idconvocatoria, Integer idCriterio);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findAccionSubvencionablePadre(Integer idExpediente, Integer idConvocatoria);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findAccionSubvencionableDEC(Integer idExpediente, Integer idConvocatoria);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findAccionSubvencionableEMCO(Integer idExpediente, Integer idConvocatoria);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findAccionSubvencionablePadrePTT(Integer idConvocatoria);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findAccionSubvencionableNieto(Integer idActSub);

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param idActSubAgrupacion
	 *            Integer
	 * @param existe_Pertenencia_Redes
	 *            Boolean
	 * @return ActSubvencionable
	 */
	List<ActSubvencionable> findAccionSubvencionableHijoPTT(Integer idActSubAgrupacion,
			Boolean existe_Pertenencia_Redes);

	List<ActSubvencionable> findActuacionesMEC(Integer idConvocatoria);

	/**
	 * Deletes a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 */
	void remove(ActSubvencionable actSubvencionable);

	/**
	 * Finds a list of rows in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ActSubvencionable>
	 */
	List<ActSubvencionable> findAll(ActSubvencionable actSubvencionable, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ActSubvencionable table using like.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ActSubvencionable>
	 */
	List<ActSubvencionable> findAllLike(ActSubvencionable actSubvencionable, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ActSubvencionable filterActSubvencionable, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ActSubvencionable>
	 */
	JQGridResponseDto<ActSubvencionable> filter(ActSubvencionable filterActSubvencionable,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ActSubvencionable>
	 */
	JQGridResponseDto<ActSubvencionable> filterPorcentaje(ActSubvencionable filterActSubvencionable,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param searchActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ActSubvencionable>>
	 */
	List<TableRowDto<ActSubvencionable>> search(ActSubvencionable filterActSubvencionable,
			ActSubvencionable searchActSubvencionable, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(ActSubvencionable filterActSubvencionable, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<ActSubvencionable>>
	 */
	JQGridResponseDto<JerarquiaDto<ActSubvencionable>> jerarquia(ActSubvencionable filterActSubvencionable,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the ActSubvencionable
	 * table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<ActSubvencionable>>
	 */
	JQGridResponseDto<JerarquiaDto<ActSubvencionable>> jerarquiaChildren(ActSubvencionable filterActSubvencionable,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Updates Importe_Disponible en Convocatorias table.
	 *
	 * @param ActSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	ActSubvencionable updateImporteDisponible(ActSubvencionable actSubencionable);

	RelExpErrCal obtenerDescripcionActSub(RelExpErrCal relExpErrCal);

	Integer obtenerIdentificadorAgrupacion(Integer idActuacionSubvencionable);

	JQGridResponseDto<MarcarInspeccionableAct> filterSubActMarcarInspeccionable(Integer idExpediente,
			Convocatorias convocatoria, JQGridRequestDto jqGridRequestDto, boolean b);

	JQGridResponseDto<MarcarInspeccionableAct> filterSubActMarcarInspeccionableEMCO(Integer idExpediente,
			JQGridRequestDto jqGridRequestDto, boolean b);

	List<ActSubvencionable> findActuacionesEMCO(Integer idConvocatoria, Integer idRelExpActSub);

	List<ActSubvencionable> findAccionSubvencionableAsoEMCO(Integer idExpediente, Integer idConvocatoria);

	List<ActSubvencionable> getAccionSubvencionableAsoEMCONieto(Integer idActSub, Integer idExpediente);

	JQGridResponseDto<MarcarInspeccionableAct> filterSubActMarcarInspeccionableDEC(Integer idExpediente,
			Convocatorias convocatoria, JQGridRequestDto jqGridRequestDto, boolean b, Integer idActSubPadre);

}
