package com.ejie.ab60.service.actuacionesSubvencionables;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.actuacionesSubvencionables.ActSubvencionableDao;
import com.ejie.ab60.model.actuacionesSubvencionables.ActSubvencionable;
import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.ab60.model.estudioTecnico.RelExpErrCal;
import com.ejie.ab60.model.expedientes.MarcarInspeccionableAct;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ActSubvencionableServiceImpl  
 * 
 *  
 */

@Service(value = "actSubvencionableService")
public class ActSubvencionableServiceImpl implements ActSubvencionableService {

	@Autowired
	private ActSubvencionableDao actSubvencionableDao;

	/**
	 * Inserts a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	@Transactional(rollbackFor = Throwable.class)
	public ActSubvencionable add(ActSubvencionable actSubvencionable) {
		return this.actSubvencionableDao.add(actSubvencionable);
	}

	/**
	 * Updates a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	@Transactional(rollbackFor = Throwable.class)
	public ActSubvencionable update(ActSubvencionable actSubvencionable) {
		return this.actSubvencionableDao.update(actSubvencionable);
	}

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	public ActSubvencionable find(ActSubvencionable actSubvencionable) {
		return (ActSubvencionable) this.actSubvencionableDao.find(actSubvencionable);
	}

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	public ActSubvencionable findImporteDisponible(ActSubvencionable actSubvencionable) {
		return (ActSubvencionable) this.actSubvencionableDao.findImporteDisponible(actSubvencionable);
	}

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	public ActSubvencionable findIdActSub(Integer idActSub) {
		return (ActSubvencionable) this.actSubvencionableDao.findIdActSub(idActSub);
	}

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	public ActSubvencionable findPorcentaje(ActSubvencionable actSubvencionable) {
		return (ActSubvencionable) this.actSubvencionableDao.findPorcentaje(actSubvencionable);
	}

	/**
	 * Busca las act. subvencionables de una convocatoria segun el padre de la
	 * actuacion subvencionable
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @param idCriterio
	 *            Integer
	 * @return actSubvencionableList
	 */
	public List<ActSubvencionable> findActSubporConvocatoriaPorActSubPadre(Integer idConvocatoria, Integer idCriterio) {
		return (List<ActSubvencionable>) this.actSubvencionableDao
				.findActSubporConvocatoriaPorActSubPadre(idConvocatoria, idCriterio);
	}

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	public List<ActSubvencionable> findAccionSubvencionablePadre(Integer idExpediente, Integer idConvocatoria) {
		return (List<ActSubvencionable>) this.actSubvencionableDao.findAccionSubvencionablePadre(idExpediente,
				idConvocatoria);
	}

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	public List<ActSubvencionable> findAccionSubvencionableDEC(Integer idExpediente, Integer idConvocatoria) {
		return (List<ActSubvencionable>) this.actSubvencionableDao.findAccionSubvencionableDEC(idExpediente,
				idConvocatoria);
	}

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	public List<ActSubvencionable> findAccionSubvencionableEMCO(Integer idExpediente, Integer idConvocatoria) {
		return (List<ActSubvencionable>) this.actSubvencionableDao.findAccionSubvencionableEMCO(idExpediente,
				idConvocatoria);
	}

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	public List<ActSubvencionable> findAccionSubvencionablePadrePTT(Integer idConvocatoria) {
		return (List<ActSubvencionable>) this.actSubvencionableDao.findAccionSubvencionablePadrePTT(idConvocatoria);
	}

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @return ActSubvencionable
	 */
	public List<ActSubvencionable> findAccionSubvencionableNieto(Integer idActSub) {
		return (List<ActSubvencionable>) this.actSubvencionableDao.findAccionSubvencionableNieto(idActSub);
	}

	/**
	 * Finds a single row in the ActSubvencionable table.
	 *
	 * @param idActSubAgrupacion
	 *            Integer
	 * @param existe_Pertenencia_Redes
	 *            Boolean
	 * @return ActSubvencionable
	 */
	public List<ActSubvencionable> findAccionSubvencionableHijoPTT(Integer idActSubAgrupacion,
			Boolean existe_Pertenencia_Redes) {
		return (List<ActSubvencionable>) this.actSubvencionableDao.findAccionSubvencionableHijoPTT(idActSubAgrupacion,
				existe_Pertenencia_Redes);
	}

	public List<ActSubvencionable> findActuacionesMEC(Integer idConvocatoria) {
		return (List<ActSubvencionable>) this.actSubvencionableDao.findComboMEC(idConvocatoria);
	}

	/**
	 * Deletes a single row in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(ActSubvencionable actSubvencionable) {
		this.actSubvencionableDao.remove(actSubvencionable);
	}

	/**
	 * Finds a list of rows in the ActSubvencionable table.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ActSubvencionable>
	 */
	public List<ActSubvencionable> findAll(ActSubvencionable actSubvencionable, JQGridRequestDto jqGridRequestDto) {
		return (List<ActSubvencionable>) this.actSubvencionableDao.findAll(actSubvencionable, jqGridRequestDto);
	}

	/**
	 * Finds rows in the ActSubvencionable table using like.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ActSubvencionable>
	 */
	public List<ActSubvencionable> findAllLike(ActSubvencionable actSubvencionable, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<ActSubvencionable>) this.actSubvencionableDao.findAllLikePorcentaje(actSubvencionable,
				jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(ActSubvencionable filterActSubvencionable, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.actSubvencionableDao.removeMultiple(filterActSubvencionable, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ActSubvencionable>
	 */
	public JQGridResponseDto<ActSubvencionable> filter(ActSubvencionable filterActSubvencionable,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<ActSubvencionable> listaActSubvencionable = this.actSubvencionableDao.findAllLike(filterActSubvencionable,
				jqGridRequestDto, false);
		Long recordNum = this.actSubvencionableDao.findAllLikeCount(
				filterActSubvencionable != null ? filterActSubvencionable : new ActSubvencionable(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<ActSubvencionable>> reorderSelection = this.actSubvencionableDao
					.reorderSelection(filterActSubvencionable, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<ActSubvencionable>(jqGridRequestDto, recordNum, listaActSubvencionable,
					reorderSelection);
		}
		return new JQGridResponseDto<ActSubvencionable>(jqGridRequestDto, recordNum, listaActSubvencionable);
	}

	/**
	 * Filter method in the ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ActSubvencionable>
	 */
	public JQGridResponseDto<ActSubvencionable> filterPorcentaje(ActSubvencionable filterActSubvencionable,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<ActSubvencionable> listaActSubvencionable = this.actSubvencionableDao
				.findAllLikePorcentaje(filterActSubvencionable, jqGridRequestDto, false);
		Long recordNum = this.actSubvencionableDao.findAllLikeCount(
				filterActSubvencionable != null ? filterActSubvencionable : new ActSubvencionable(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<ActSubvencionable>> reorderSelection = this.actSubvencionableDao
					.reorderSelection(filterActSubvencionable, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<ActSubvencionable>(jqGridRequestDto, recordNum, listaActSubvencionable,
					reorderSelection);
		}
		return new JQGridResponseDto<ActSubvencionable>(jqGridRequestDto, recordNum, listaActSubvencionable);
	}

	/**
	 * Searches rows in the ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param searchActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ActSubvencionable>>
	 */
	public List<TableRowDto<ActSubvencionable>> search(ActSubvencionable filterActSubvencionable,
			ActSubvencionable searchActSubvencionable, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.actSubvencionableDao.search(filterActSubvencionable, searchActSubvencionable, jqGridRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(ActSubvencionable filterActSubvencionable, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.actSubvencionableDao.reorderSelection(filterActSubvencionable, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the ActSubvencionable table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<ActSubvencionable>>
	 */
	public JQGridResponseDto<JerarquiaDto<ActSubvencionable>> jerarquia(ActSubvencionable filterActSubvencionable,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<ActSubvencionable>> listaActSubvencionable = this.actSubvencionableDao
				.findAllLikeJerarquia(filterActSubvencionable, jqGridRequestDto);
		Long recordNum = this.actSubvencionableDao.findAllLikeCountJerarquia(filterActSubvencionable, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<ActSubvencionable>>(jqGridRequestDto, recordNum,
				listaActSubvencionable);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the ActSubvencionable
	 * table.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<ActSubvencionable>>
	 */
	public JQGridResponseDto<JerarquiaDto<ActSubvencionable>> jerarquiaChildren(
			ActSubvencionable filterActSubvencionable, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<ActSubvencionable>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<ActSubvencionable>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.actSubvencionableDao.findAllChild(filterActSubvencionable, jqGridRequestDto));
		return jqGridResponseDto;
	}

	/**
	 * Updates Importe_Disponible en accion subencionable table.
	 *
	 * @param idConvocatorias
	 *            Integer
	 * @return Convocatorias
	 */
	public ActSubvencionable updateImporteDisponible(ActSubvencionable ActSubvencionable) {

		return (ActSubvencionable) this.actSubvencionableDao.updateImporteDisponible(ActSubvencionable);

	}

	@Override
	public RelExpErrCal obtenerDescripcionActSub(RelExpErrCal relExpErrCal) {
		return this.actSubvencionableDao.obtenerDescripcionActSub(relExpErrCal);
	}

	public Integer obtenerIdentificadorAgrupacion(Integer idActuacionSubvencionable) {
		return (Integer) this.actSubvencionableDao.obtenerIdentificadorAgrupacion(idActuacionSubvencionable);

	}

	@Override
	public JQGridResponseDto<MarcarInspeccionableAct> filterSubActMarcarInspeccionable(Integer idExpediente,
			Convocatorias convocatoria, JQGridRequestDto jqGridRequestDto, boolean b) {

		List<MarcarInspeccionableAct> listaActSub = this.actSubvencionableDao
				.findSubActMarcarInspeccionable(idExpediente, convocatoria);

		Long recordNum = this.actSubvencionableDao.findAllLikeCountSubAct(idExpediente, false);

		return new JQGridResponseDto<MarcarInspeccionableAct>(jqGridRequestDto, recordNum, listaActSub);

	}

	@Override
	public JQGridResponseDto<MarcarInspeccionableAct> filterSubActMarcarInspeccionableEMCO(Integer idExpediente,
			JQGridRequestDto jqGridRequestDto, boolean b) {

		List<MarcarInspeccionableAct> listaActSub = this.actSubvencionableDao
				.findSubActMarcarInspeccionableEMCO(idExpediente);

		Long recordNum = this.actSubvencionableDao.findAllLikeCountSubActEMCO(idExpediente, false);

		return new JQGridResponseDto<MarcarInspeccionableAct>(jqGridRequestDto, recordNum, listaActSub);
	}

	@Override
	public List<ActSubvencionable> findActuacionesEMCO(Integer idConvocatoria, Integer idActSubHijo) {
		return (List<ActSubvencionable>) this.actSubvencionableDao.findComboEMCO(idConvocatoria, idActSubHijo);
	}

	@Override
	public List<ActSubvencionable> findAccionSubvencionableAsoEMCO(Integer idExpediente, Integer idConvocatoria) {
		return (List<ActSubvencionable>) this.actSubvencionableDao.findAccionSubvencionableAsoEMCO(idExpediente,
				idConvocatoria);
	}

	@Override
	public List<ActSubvencionable> getAccionSubvencionableAsoEMCONieto(Integer idActSub, Integer idExpediente) {
		return (List<ActSubvencionable>) this.actSubvencionableDao.getAccionSubvencionableAsoEMCONieto(idActSub,
				idExpediente);
	}

	@Override
	public JQGridResponseDto<MarcarInspeccionableAct> filterSubActMarcarInspeccionableDEC(Integer idExpediente,
			Convocatorias convocatoria, JQGridRequestDto jqGridRequestDto, boolean b, Integer idActSubPadre) {
		List<MarcarInspeccionableAct> listaActSub = this.actSubvencionableDao
				.findSubActMarcarInspeccionableDEC(idExpediente, convocatoria, idActSubPadre);

		Long recordNum = this.actSubvencionableDao.findAllLikeCountSubAct(idExpediente, false);

		return new JQGridResponseDto<MarcarInspeccionableAct>(jqGridRequestDto, recordNum, listaActSub);
	}

}