package com.ejie.ab60.service.actuacionesSubvencionables;

import com.ejie.ab60.model.actuacionesSubvencionables.RelActSubMotDen;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelActSubMotDenService  
 * 
 *  
 */

public interface RelActSubMotDenService {

	/**
	 * Inserts a single row in the RelActSubMotDen table.
	 *
	 * @param relActSubMotDen
	 *            RelActSubMotDen
	 * @return RelActSubMotDen
	 */
	RelActSubMotDen add(RelActSubMotDen relActSubMotDen);

	/**
	 * Updates a single row in the RelActSubMotDen table.
	 *
	 * @param relActSubMotDen
	 *            RelActSubMotDen
	 * @return RelActSubMotDen
	 */
	RelActSubMotDen update(RelActSubMotDen relActSubMotDen);

	/**
	 * Finds a single row in the RelActSubMotDen table.
	 *
	 * @param relActSubMotDen
	 *            RelActSubMotDen
	 * @return RelActSubMotDen
	 */
	RelActSubMotDen find(RelActSubMotDen relActSubMotDen);

	/**
	 * Saca los id de motivos de denegacion
	 *
	 * @param idRelActSubMotDen
	 *            Integer
	 *
	 * @return List<RelActSubMotDen>
	 */

	List<RelActSubMotDen> findIdsMotivosDenegaciones(Integer idRelActSubMotDen);

	/**
	 * Deletes a single row in the RelActSubMotDen table.
	 *
	 * @param relActSubMotDen
	 *            RelActSubMotDen
	 */
	void remove(RelActSubMotDen relActSubMotDen, Integer origen);

	/**
	 * Finds a list of rows in the RelActSubMotDen table.
	 *
	 * @param relActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelActSubMotDen>
	 */
	List<RelActSubMotDen> findAll(RelActSubMotDen relActSubMotDen, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelActSubMotDen table using like.
	 *
	 * @param relActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelActSubMotDen>
	 */
	List<RelActSubMotDen> findAllLike(RelActSubMotDen relActSubMotDen, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelActSubMotDen table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelActSubMotDen filterRelActSubMotDen, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelActSubMotDen table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelActSubMotDen>
	 */
	JQGridResponseDto<RelActSubMotDen> filter(RelActSubMotDen filterRelActSubMotDen, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelActSubMotDen table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param searchRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActSubMotDen>>
	 */
	List<TableRowDto<RelActSubMotDen>> search(RelActSubMotDen filterRelActSubMotDen,
			RelActSubMotDen searchRelActSubMotDen, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelActSubMotDen table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelActSubMotDen filterRelActSubMotDen, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelActSubMotDen table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelActSubMotDen>>
	 */
	JQGridResponseDto<JerarquiaDto<RelActSubMotDen>> jerarquia(RelActSubMotDen filterRelActSubMotDen,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelActSubMotDen
	 * table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelActSubMotDen>>
	 */
	JQGridResponseDto<JerarquiaDto<RelActSubMotDen>> jerarquiaChildren(RelActSubMotDen filterRelActSubMotDen,
			JQGridRequestDto jqGridRequestDto);

}
