package com.ejie.ab60.service.actuacionesSubvencionables;

import com.ejie.ab60.dao.actuacionesSubvencionables.RelActSubMotDenDao;
import com.ejie.ab60.model.actuacionesSubvencionables.RelActSubMotDen;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * RelActSubMotDenServiceImpl  
 * 
 *  
 */

@Service(value = "relActSubMotDenService")
public class RelActSubMotDenServiceImpl implements RelActSubMotDenService {

	@Autowired
	private RelActSubMotDenDao relActSubMotDenDao;

	/**
	 * Inserts a single row in the RelActSubMotDen table.
	 *
	 * @param relActSubMotDen
	 *            RelActSubMotDen
	 * @return RelActSubMotDen
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelActSubMotDen add(RelActSubMotDen relActSubMotDen) {
		return this.relActSubMotDenDao.add(relActSubMotDen);
	}

	/**
	 * Updates a single row in the RelActSubMotDen table.
	 *
	 * @param relActSubMotDen
	 *            RelActSubMotDen
	 * @return RelActSubMotDen
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelActSubMotDen update(RelActSubMotDen relActSubMotDen) {
		return this.relActSubMotDenDao.update(relActSubMotDen);
	}

	/**
	 * Finds a single row in the RelActSubMotDen table.
	 *
	 * @param relActSubMotDen
	 *            RelActSubMotDen
	 * @return RelActSubMotDen
	 */
	public RelActSubMotDen find(RelActSubMotDen relActSubMotDen) {
		return (RelActSubMotDen) this.relActSubMotDenDao.find(relActSubMotDen);
	}

	/**
	 * Saca los id de motivos de denegacion
	 *
	 * @param idRelActSubMotDen
	 *            Integer
	 *
	 * @return List<RelActSubMotDen>
	 */

	public List<RelActSubMotDen> findIdsMotivosDenegaciones(Integer idRelActSubMotDen) {
		return (List<RelActSubMotDen>) this.relActSubMotDenDao.findIdsMotivosDenegaciones(idRelActSubMotDen);
	}

	/**
	 * Deletes a single row in the RelActSubMotDen table.
	 *
	 * @param relActSubMotDen
	 *            RelActSubMotDen
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(RelActSubMotDen relActSubMotDen, Integer origen) {
		this.relActSubMotDenDao.remove(relActSubMotDen, origen);
	}

	/**
	 * Finds a list of rows in the RelActSubMotDen table.
	 *
	 * @param relActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelActSubMotDen>
	 */
	public List<RelActSubMotDen> findAll(RelActSubMotDen relActSubMotDen, JQGridRequestDto jqGridRequestDto) {
		return (List<RelActSubMotDen>) this.relActSubMotDenDao.findAll(relActSubMotDen, jqGridRequestDto);
	}

	/**
	 * Finds rows in the RelActSubMotDen table using like.
	 *
	 * @param relActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelActSubMotDen>
	 */
	public List<RelActSubMotDen> findAllLike(RelActSubMotDen relActSubMotDen, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<RelActSubMotDen>) this.relActSubMotDenDao.findAllLike(relActSubMotDen, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelActSubMotDen table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(RelActSubMotDen filterRelActSubMotDen, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.relActSubMotDenDao.removeMultiple(filterRelActSubMotDen, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the RelActSubMotDen table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelActSubMotDen>
	 */
	public JQGridResponseDto<RelActSubMotDen> filter(RelActSubMotDen filterRelActSubMotDen,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<RelActSubMotDen> listaRelActSubMotDen = this.relActSubMotDenDao.findAllLike(filterRelActSubMotDen,
				jqGridRequestDto, false);
		Long recordNum = this.relActSubMotDenDao
				.findAllLikeCount(filterRelActSubMotDen != null ? filterRelActSubMotDen : new RelActSubMotDen(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelActSubMotDen>> reorderSelection = this.relActSubMotDenDao
					.reorderSelection(filterRelActSubMotDen, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelActSubMotDen>(jqGridRequestDto, recordNum, listaRelActSubMotDen,
					reorderSelection);
		}
		return new JQGridResponseDto<RelActSubMotDen>(jqGridRequestDto, recordNum, listaRelActSubMotDen);
	}

	/**
	 * Searches rows in the RelActSubMotDen table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param searchRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActSubMotDen>>
	 */
	public List<TableRowDto<RelActSubMotDen>> search(RelActSubMotDen filterRelActSubMotDen,
			RelActSubMotDen searchRelActSubMotDen, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.relActSubMotDenDao.search(filterRelActSubMotDen, searchRelActSubMotDen, jqGridRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in RelActSubMotDen table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(RelActSubMotDen filterRelActSubMotDen, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.relActSubMotDenDao.reorderSelection(filterRelActSubMotDen, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelActSubMotDen table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelActSubMotDen>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelActSubMotDen>> jerarquia(RelActSubMotDen filterRelActSubMotDen,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<RelActSubMotDen>> listaRelActSubMotDen = this.relActSubMotDenDao
				.findAllLikeJerarquia(filterRelActSubMotDen, jqGridRequestDto);
		Long recordNum = this.relActSubMotDenDao.findAllLikeCountJerarquia(filterRelActSubMotDen, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<RelActSubMotDen>>(jqGridRequestDto, recordNum, listaRelActSubMotDen);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the RelActSubMotDen
	 * table.
	 *
	 * @param filterRelActSubMotDen
	 *            RelActSubMotDen
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelActSubMotDen>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelActSubMotDen>> jerarquiaChildren(RelActSubMotDen filterRelActSubMotDen,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<RelActSubMotDen>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<RelActSubMotDen>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.relActSubMotDenDao.findAllChild(filterRelActSubMotDen, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
