package com.ejie.ab60.service.actuacionesSubvencionables;

import com.ejie.ab60.model.actuacionesSubvencionables.RelActSubMotMin;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelActSubMotMinService  
 * 
 *  
 */

public interface RelActSubMotMinService {

	/**
	 * Inserts a single row in the RelActSubMotMin table.
	 *
	 * @param relActSubMotMin
	 *            RelActSubMotMin
	 * @return RelActSubMotMin
	 */
	RelActSubMotMin add(RelActSubMotMin relActSubMotMin);

	/**
	 * Updates a single row in the RelActSubMotMin table.
	 *
	 * @param relActSubMotMin
	 *            RelActSubMotMin
	 * @return RelActSubMotMin
	 */
	RelActSubMotMin update(RelActSubMotMin relActSubMotMin);

	/**
	 * Finds a single row in the RelActSubMotMin table.
	 *
	 * @param relActSubMotMin
	 *            RelActSubMotMin
	 * @return RelActSubMotMin
	 */
	RelActSubMotMin find(RelActSubMotMin relActSubMotMin);

	/**
	 * Deletes a single row in the RelActSubMotMin table.
	 *
	 * @param relActSubMotMin
	 *            RelActSubMotMin
	 */
	void remove(RelActSubMotMin relActSubMotMin, Integer origen);

	/**
	 * Saca los id de motivos de minoracion
	 *
	 * @param idRelActSubMotMin
	 *            Integer
	 * @param origenMotivosMinoracion
	 *
	 * @return List<RelActSubMotMin>
	 */

	List<RelActSubMotMin> findIdsMotivosMinoraciones(Integer idRelActSubMotMin, Integer origenMotivosMinoracion);

	/**
	 * Finds a list of rows in the RelActSubMotMin table.
	 *
	 * @param relActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelActSubMotMin>
	 */
	List<RelActSubMotMin> findAll(RelActSubMotMin relActSubMotMin, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelActSubMotMin table using like.
	 *
	 * @param relActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelActSubMotMin>
	 */
	List<RelActSubMotMin> findAllLike(RelActSubMotMin relActSubMotMin, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelActSubMotMin table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelActSubMotMin filterRelActSubMotMin, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelActSubMotMin table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelActSubMotMin>
	 */
	JQGridResponseDto<RelActSubMotMin> filter(RelActSubMotMin filterRelActSubMotMin, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelActSubMotMin table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param searchRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActSubMotMin>>
	 */
	List<TableRowDto<RelActSubMotMin>> search(RelActSubMotMin filterRelActSubMotMin,
			RelActSubMotMin searchRelActSubMotMin, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelActSubMotMin table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelActSubMotMin filterRelActSubMotMin, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelActSubMotMin table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelActSubMotMin>>
	 */
	JQGridResponseDto<JerarquiaDto<RelActSubMotMin>> jerarquia(RelActSubMotMin filterRelActSubMotMin,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelActSubMotMin
	 * table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelActSubMotMin>>
	 */
	JQGridResponseDto<JerarquiaDto<RelActSubMotMin>> jerarquiaChildren(RelActSubMotMin filterRelActSubMotMin,
			JQGridRequestDto jqGridRequestDto);

}
