package com.ejie.ab60.service.actuacionesSubvencionables;

import com.ejie.ab60.dao.actuacionesSubvencionables.RelActSubMotMinDao;
import com.ejie.ab60.model.actuacionesSubvencionables.RelActSubMotMin;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * RelActSubMotMinServiceImpl  
 * 
 *  
 */

@Service(value = "relActSubMotMinService")
public class RelActSubMotMinServiceImpl implements RelActSubMotMinService {

	@Autowired
	private RelActSubMotMinDao relActSubMotMinDao;

	/**
	 * Inserts a single row in the RelActSubMotMin table.
	 *
	 * @param relActSubMotMin
	 *            RelActSubMotMin
	 * @return RelActSubMotMin
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelActSubMotMin add(RelActSubMotMin relActSubMotMin) {
		return this.relActSubMotMinDao.add(relActSubMotMin);
	}

	/**
	 * Updates a single row in the RelActSubMotMin table.
	 *
	 * @param relActSubMotMin
	 *            RelActSubMotMin
	 * @return RelActSubMotMin
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelActSubMotMin update(RelActSubMotMin relActSubMotMin) {
		return this.relActSubMotMinDao.update(relActSubMotMin);
	}

	/**
	 * Finds a single row in the RelActSubMotMin table.
	 *
	 * @param relActSubMotMin
	 *            RelActSubMotMin
	 * @return RelActSubMotMin
	 */
	public RelActSubMotMin find(RelActSubMotMin relActSubMotMin) {
		return (RelActSubMotMin) this.relActSubMotMinDao.find(relActSubMotMin);
	}

	/**
	 * Deletes a single row in the RelActSubMotMin table.
	 *
	 * @param relActSubMotMin
	 *            RelActSubMotMin
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(RelActSubMotMin relActSubMotMin, Integer origen) {
		this.relActSubMotMinDao.remove(relActSubMotMin, origen);
	}

	/**
	 * Saca los id de motivos de minoracion
	 *
	 * @param idRelActSubMotMin
	 *            Integer
	 * 
	 * @return List<RelActSubMotMin>
	 */
	@Transactional(readOnly = true)
	public List<RelActSubMotMin> findIdsMotivosMinoraciones(Integer idRelActSubMotMin,
			Integer origenMotivosMinoracion) {
		return (List<RelActSubMotMin>) this.relActSubMotMinDao.findIdsMotivosMinoraciones(idRelActSubMotMin,
				origenMotivosMinoracion);
	}

	/**
	 * Finds a list of rows in the RelActSubMotMin table.
	 *
	 * @param relActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelActSubMotMin>
	 */
	public List<RelActSubMotMin> findAll(RelActSubMotMin relActSubMotMin, JQGridRequestDto jqGridRequestDto) {
		return (List<RelActSubMotMin>) this.relActSubMotMinDao.findAll(relActSubMotMin, jqGridRequestDto);
	}

	/**
	 * Finds rows in the RelActSubMotMin table using like.
	 *
	 * @param relActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelActSubMotMin>
	 */
	public List<RelActSubMotMin> findAllLike(RelActSubMotMin relActSubMotMin, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<RelActSubMotMin>) this.relActSubMotMinDao.findAllLike(relActSubMotMin, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelActSubMotMin table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(RelActSubMotMin filterRelActSubMotMin, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.relActSubMotMinDao.removeMultiple(filterRelActSubMotMin, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the RelActSubMotMin table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelActSubMotMin>
	 */
	public JQGridResponseDto<RelActSubMotMin> filter(RelActSubMotMin filterRelActSubMotMin,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<RelActSubMotMin> listaRelActSubMotMin = this.relActSubMotMinDao.findAllLike(filterRelActSubMotMin,
				jqGridRequestDto, false);
		Long recordNum = this.relActSubMotMinDao
				.findAllLikeCount(filterRelActSubMotMin != null ? filterRelActSubMotMin : new RelActSubMotMin(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelActSubMotMin>> reorderSelection = this.relActSubMotMinDao
					.reorderSelection(filterRelActSubMotMin, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelActSubMotMin>(jqGridRequestDto, recordNum, listaRelActSubMotMin,
					reorderSelection);
		}
		return new JQGridResponseDto<RelActSubMotMin>(jqGridRequestDto, recordNum, listaRelActSubMotMin);
	}

	/**
	 * Searches rows in the RelActSubMotMin table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param searchRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActSubMotMin>>
	 */
	public List<TableRowDto<RelActSubMotMin>> search(RelActSubMotMin filterRelActSubMotMin,
			RelActSubMotMin searchRelActSubMotMin, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.relActSubMotMinDao.search(filterRelActSubMotMin, searchRelActSubMotMin, jqGridRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in RelActSubMotMin table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(RelActSubMotMin filterRelActSubMotMin, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.relActSubMotMinDao.reorderSelection(filterRelActSubMotMin, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelActSubMotMin table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelActSubMotMin>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelActSubMotMin>> jerarquia(RelActSubMotMin filterRelActSubMotMin,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<RelActSubMotMin>> listaRelActSubMotMin = this.relActSubMotMinDao
				.findAllLikeJerarquia(filterRelActSubMotMin, jqGridRequestDto);
		Long recordNum = this.relActSubMotMinDao.findAllLikeCountJerarquia(filterRelActSubMotMin, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<RelActSubMotMin>>(jqGridRequestDto, recordNum, listaRelActSubMotMin);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the RelActSubMotMin
	 * table.
	 *
	 * @param filterRelActSubMotMin
	 *            RelActSubMotMin
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelActSubMotMin>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelActSubMotMin>> jerarquiaChildren(RelActSubMotMin filterRelActSubMotMin,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<RelActSubMotMin>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<RelActSubMotMin>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.relActSubMotMinDao.findAllChild(filterRelActSubMotMin, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
