package com.ejie.ab60.service.actuacionesSubvencionables;

import com.ejie.ab60.model.actuacionesSubvencionables.RelActSubSubact;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelActSubSubactService  
 * 
 *  
 */

public interface RelActSubSubactService {

	/**
	 * Inserts a single row in the RelActSubSubact table.
	 *
	 * @param relActSubSubact
	 *            RelActSubSubact
	 * @return RelActSubSubact
	 */
	RelActSubSubact add(RelActSubSubact relActSubSubact);

	/**
	 * Updates a single row in the RelActSubSubact table.
	 *
	 * @param relActSubSubact
	 *            RelActSubSubact
	 * @return RelActSubSubact
	 */
	RelActSubSubact update(RelActSubSubact relActSubSubact);

	/**
	 * Finds a single row in the RelActSubSubact table.
	 *
	 * @param relActSubSubact
	 *            RelActSubSubact
	 * @return RelActSubSubact
	 */
	RelActSubSubact find(RelActSubSubact relActSubSubact);

	/**
	 * Deletes a single row in the RelActSubSubact table.
	 *
	 * @param relActSubSubact
	 *            RelActSubSubact
	 */
	void remove(RelActSubSubact relActSubSubact);

	/**
	 * Encuentra los id de las actuaciones subvencionable dado un id
	 *
	 * @param Integer
	 *            idRelacion
	 * @return relactsubsubactList
	 */
	public List<RelActSubSubact> findIdActSubSubact(Integer idRelacion);

	/**
	 * Finds a list of rows in the RelActSubSubact table.
	 *
	 * @param relActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelActSubSubact>
	 */
	List<RelActSubSubact> findAll(RelActSubSubact relActSubSubact, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelActSubSubact table using like.
	 *
	 * @param relActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelActSubSubact>
	 */
	List<RelActSubSubact> findAllLike(RelActSubSubact relActSubSubact, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelActSubSubact table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelActSubSubact filterRelActSubSubact, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelActSubSubact table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelActSubSubact>
	 */
	JQGridResponseDto<RelActSubSubact> filter(RelActSubSubact filterRelActSubSubact, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelActSubSubact table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param searchRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActSubSubact>>
	 */
	List<TableRowDto<RelActSubSubact>> search(RelActSubSubact filterRelActSubSubact,
			RelActSubSubact searchRelActSubSubact, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelActSubSubact table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelActSubSubact filterRelActSubSubact, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelActSubSubact table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelActSubSubact>>
	 */
	JQGridResponseDto<JerarquiaDto<RelActSubSubact>> jerarquia(RelActSubSubact filterRelActSubSubact,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelActSubSubact
	 * table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelActSubSubact>>
	 */
	JQGridResponseDto<JerarquiaDto<RelActSubSubact>> jerarquiaChildren(RelActSubSubact filterRelActSubSubact,
			JQGridRequestDto jqGridRequestDto);

}
