package com.ejie.ab60.service.actuacionesSubvencionables;

import com.ejie.ab60.dao.actuacionesSubvencionables.RelActSubSubactDao;
import com.ejie.ab60.model.actuacionesSubvencionables.RelActSubSubact;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * RelActSubSubactServiceImpl  
 * 
 *  
 */

@Service(value = "relActSubSubactService")
public class RelActSubSubactServiceImpl implements RelActSubSubactService {

	@Autowired
	private RelActSubSubactDao relActSubSubactDao;

	/**
	 * Inserts a single row in the RelActSubSubact table.
	 *
	 * @param relActSubSubact
	 *            RelActSubSubact
	 * @return RelActSubSubact
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelActSubSubact add(RelActSubSubact relActSubSubact) {
		return this.relActSubSubactDao.add(relActSubSubact);
	}

	/**
	 * Updates a single row in the RelActSubSubact table.
	 *
	 * @param relActSubSubact
	 *            RelActSubSubact
	 * @return RelActSubSubact
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelActSubSubact update(RelActSubSubact relActSubSubact) {
		return this.relActSubSubactDao.update(relActSubSubact);
	}

	/**
	 * Finds a single row in the RelActSubSubact table.
	 *
	 * @param relActSubSubact
	 *            RelActSubSubact
	 * @return RelActSubSubact
	 */
	public RelActSubSubact find(RelActSubSubact relActSubSubact) {
		return (RelActSubSubact) this.relActSubSubactDao.find(relActSubSubact);
	}

	/**
	 * Deletes a single row in the RelActSubSubact table.
	 *
	 * @param relActSubSubact
	 *            RelActSubSubact
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(RelActSubSubact relActSubSubact) {
		this.relActSubSubactDao.remove(relActSubSubact);
	}

	/**
	 * Encuentra los id de las actuaciones subvencionable dado un id
	 *
	 * @param Integer
	 *            idRelacion
	 * @return relactsubsubactList
	 */
	public List<RelActSubSubact> findIdActSubSubact(Integer idRelacion) {
		return (List<RelActSubSubact>) this.relActSubSubactDao.findIdActSubSubact(idRelacion);

	}

	/**
	 * Finds a list of rows in the RelActSubSubact table.
	 *
	 * @param relActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelActSubSubact>
	 */
	public List<RelActSubSubact> findAll(RelActSubSubact relActSubSubact, JQGridRequestDto jqGridRequestDto) {
		return (List<RelActSubSubact>) this.relActSubSubactDao.findAll(relActSubSubact, jqGridRequestDto);
	}

	/**
	 * Finds rows in the RelActSubSubact table using like.
	 *
	 * @param relActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelActSubSubact>
	 */
	public List<RelActSubSubact> findAllLike(RelActSubSubact relActSubSubact, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<RelActSubSubact>) this.relActSubSubactDao.findAllLike(relActSubSubact, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelActSubSubact table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(RelActSubSubact filterRelActSubSubact, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.relActSubSubactDao.removeMultiple(filterRelActSubSubact, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the RelActSubSubact table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelActSubSubact>
	 */
	public JQGridResponseDto<RelActSubSubact> filter(RelActSubSubact filterRelActSubSubact,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<RelActSubSubact> listaRelActSubSubact = this.relActSubSubactDao.findAllLike(filterRelActSubSubact,
				jqGridRequestDto, false);
		Long recordNum = this.relActSubSubactDao
				.findAllLikeCount(filterRelActSubSubact != null ? filterRelActSubSubact : new RelActSubSubact(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelActSubSubact>> reorderSelection = this.relActSubSubactDao
					.reorderSelection(filterRelActSubSubact, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelActSubSubact>(jqGridRequestDto, recordNum, listaRelActSubSubact,
					reorderSelection);
		}
		return new JQGridResponseDto<RelActSubSubact>(jqGridRequestDto, recordNum, listaRelActSubSubact);
	}

	/**
	 * Searches rows in the RelActSubSubact table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param searchRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActSubSubact>>
	 */
	public List<TableRowDto<RelActSubSubact>> search(RelActSubSubact filterRelActSubSubact,
			RelActSubSubact searchRelActSubSubact, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.relActSubSubactDao.search(filterRelActSubSubact, searchRelActSubSubact, jqGridRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in RelActSubSubact table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(RelActSubSubact filterRelActSubSubact, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.relActSubSubactDao.reorderSelection(filterRelActSubSubact, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelActSubSubact table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelActSubSubact>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelActSubSubact>> jerarquia(RelActSubSubact filterRelActSubSubact,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<RelActSubSubact>> listaRelActSubSubact = this.relActSubSubactDao
				.findAllLikeJerarquia(filterRelActSubSubact, jqGridRequestDto);
		Long recordNum = this.relActSubSubactDao.findAllLikeCountJerarquia(filterRelActSubSubact, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<RelActSubSubact>>(jqGridRequestDto, recordNum, listaRelActSubSubact);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the RelActSubSubact
	 * table.
	 *
	 * @param filterRelActSubSubact
	 *            RelActSubSubact
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelActSubSubact>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelActSubSubact>> jerarquiaChildren(RelActSubSubact filterRelActSubSubact,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<RelActSubSubact>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<RelActSubSubact>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.relActSubSubactDao.findAllChild(filterRelActSubSubact, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
