package com.ejie.ab60.service.actuacionesSubvencionables;

import java.math.BigDecimal;
import java.util.List;

import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.ab60.model.estudioTecnico.EstudioTecnico;
import com.ejie.ab60.model.expedientes.MarcarInspeccionableAct;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpActSubService  
 * 
 *  
 */

public interface RelExpActSubService {

	/**
	 * Finds el ultimo id de la tabla in the RelExpActSub table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	RelExpActSub findUltimoId(Integer idExpediente, Integer idActSub);

	/**
	 * Sumo todos los importes de las Relaciones hijos de un expediente sin su
	 * padre.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return RelExpActSub
	 */
	RelExpActSub findRelExpActHijosPorExpediente(Integer idExpediente);

	/**
	 * Finds el ultimo id de la tabla in the RelExpActSub table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	RelExpActSub findLastId(Integer idExpediente, Integer idActSub);

	/**
	 * Finds el ultimo id de la tabla in the RelExpActSub table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	RelExpActSub findRelExpActSub(Integer idActSub, Integer idExpediente);

	/**
	 * Metod para hacer un update de estudio tecnico
	 * 
	 * @param tercero
	 * @return EstudioTecnico Bean resultante del proceso de creacion
	 */

	RelExpActSub saveDatos(Integer idExpediente, Integer idConvocatoria, RelExpActSub relExpActSub, Integer origen,
			Usuario usuario);

	/**
	 * Inserts a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */

	RelExpActSub add(RelExpActSub relExpActSub);

	/**
	 * Inserts a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	RelExpActSub anyadirRelacion(RelExpActSub relExpActSub);

	/**
	 * Updates a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	RelExpActSub update(RelExpActSub relExpActSub);

	/**
	 * Updates a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	RelExpActSub updatePTT(RelExpActSub relExpActSub);

	/**
	 * Updates de Importe Admitido in the RelExpActSub table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	RelExpActSub updateImporte(RelExpActSub relexpactsub);

	/**
	 * Updates Importe Admitido y presentado in the RelExpActSub table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	RelExpActSub updateImportePresentadoAdmtido(RelExpActSub relexpactsub);

	/**
	 * Updates Importe Admitido y presentado in the RelExpActSub table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	RelExpActSub updateImporteJusPresentadoAdmtido(RelExpActSub relexpactsub);

	/**
	 * Updates de Importe Admitido y importe presentado de la Relacion
	 * Expediente act subven Padre
	 * 
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */

	RelExpActSub updateImportePresentadoAdmtidoPadre(RelExpActSub relexpactsub);

	/**
	 * Updates de SUBVENCION_CALCULADA y PORCENTAJE in the RelExpActSub table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	RelExpActSub updateImporteSubvencionCalculada(RelExpActSub relexpactsub);

	/**
	 * Updates Importe Admitido y presentado in the RelExpActSub table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	RelExpActSub updateImportePorIdActSub(RelExpActSub relExpActSub, Integer idActSub);

	/**
	 * Finds a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	RelExpActSub find(RelExpActSub relExpActSub);

	/**
	 * Finds a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	RelExpActSub findIdActSub(Integer idRelExpActSub);

	/**
	 * Finds a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	Integer findIdActSubAgrupacionPorExpediente(Integer idExpediente);

	/**
	 * Finds a single row in the RelExpActSub table.
	 *
	 * @param idExpedientes,
	 *            IdCreiterio Integer, Integer
	 * @return RelExpActSub
	 */
	RelExpActSub findRelPorExpedientePorCriterio(Integer idExpedientes, Integer IdCriterio);

	/**
	 * Finds a single row in the RelExpActSub table.
	 *
	 * @param idExpedientes,
	 *            IdCreiterio Integer, Integer
	 * @return RelExpActSub
	 */
	RelExpActSub findRelPorExpedientePorCriterioPTT(Integer idExpedientes, Integer IdCriterio);

	/**
	 * Devuelve los totales de un RelExpActSub
	 *
	 * @param Integer
	 *            idRelacion
	 *
	 * @return RelExpActSub
	 */

	RelExpActSub findTotales(Integer idRelacion);

	/**
	 * Devuelve los totales de un RelExpActSub
	 * 
	 * @param idRelExpActSub
	 *
	 * @param Integer
	 *            idRelacion
	 *
	 * @return RelExpActSub
	 */

	RelExpActSub findTotalesJustificacion(Integer idRelacion, Integer idRelExpActSub);

	/**
	 * Devuelve los totales de un relacion de expedientes por actividad
	 * subcionable
	 *
	 * @param Integer
	 *            IdExpediente
	 *
	 * @return RelExpActSub
	 */
	RelExpActSub sumTotales(Integer idExpediente);

	/**
	 * Devuelve los totales de un relacion de expedientes por actividad
	 * subcionable
	 *
	 * @param Integer
	 *            IdExpediente
	 *
	 * @return RelExpActSub
	 */
	RelExpActSub sumTotalesJus(Integer idExpediente);

	/**
	 * Devuelve los totales de un relacion de expedientes por actividad
	 * subcionable
	 *
	 * @param Integer
	 *            IdExpediente
	 *
	 * @return RelExpActSub
	 */
	RelExpActSub sumEstudioActuacion(Integer idExpediente, Integer idActuacion);

	/**
	 * Deletes a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 */

	void remove(RelExpActSub relExpActSub);

	/**
	 * Finds a list of rows in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelExpActSub>
	 */
	List<RelExpActSub> findAll(RelExpActSub relExpActSub, JQGridRequestDto jqGridRequestDto);

	/**
	 * sacamos una lista de las relaciones de un expediente
	 *
	 * @param idExpediente
	 *            Integer
	 * @param idConvocatoria
	 *            Integer
	 * @param usuario
	 *            Usuario
	 * 
	 * 
	 * @throws Exception
	 */
	void ponerImportesNulosACero(Integer idExpediente, Integer idConvocatoria, Usuario usuario) throws Exception;

	/**
	 * Finds rows in the RelExpActSub table using like.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelExpActSub>
	 */
	List<RelExpActSub> findAllLike(RelExpActSub relExpActSub, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Sacamos la tabla de act subencionables por expediente y sus totales
	 *
	 * @param Integer
	 *            idExpediente
	 * @param Integer
	 *            idConvocatoria
	 * @return List<RelExpActSub>
	 */
	List<RelExpActSub> findRelEXpActSubPorExpedienteMET(Integer idExpediente, Integer idConvocatoria);

	List<RelExpActSub> findRelEXpActSubPorExpediente(Integer idExpediente);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	JQGridResponseDto<RelExpActSub> filter(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	JQGridResponseDto<RelExpActSub> filterEMET(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	JQGridResponseDto<RelExpActSub> filterCTP(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	JQGridResponseDto<RelExpActSub> filterPTT(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	JQGridResponseDto<RelExpActSub> filterDEC(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	JQGridResponseDto<RelExpActSub> filterEMCO(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	JQGridResponseDto<RelExpActSub> filterOTC(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	JQGridResponseDto<RelExpActSub> filterOMIC(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param searchRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpActSub>>
	 */
	List<TableRowDto<RelExpActSub>> search(RelExpActSub filterRelExpActSub, RelExpActSub searchRelExpActSub,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelExpActSub>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpActSub>> jerarquia(RelExpActSub filterRelExpActSub,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelExpActSub
	 * table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelExpActSub>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpActSub>> jerarquiaChildren(RelExpActSub filterRelExpActSub,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * findDetallePTT
	 * 
	 * @param idExpediente
	 * @param idConvocatoria
	 * @param idRelExpActSub
	 * @return
	 */
	RelExpActSub findDetallePTT(Integer idExpediente, Integer idConvocatoria, Integer idRelExpActSub);

	/**
	 * sumPTT
	 * 
	 * @param idConvocatoria
	 * @param idExpediente
	 * @return
	 */
	RelExpActSub sumPTT(Integer idConvocatoria, Integer idExpediente);

	/**
	 * anyadePTT
	 * 
	 * @param relExpActSub
	 * @param usuario
	 * @param idExpediente
	 * @param idConvocatoria
	 * @return
	 * @throws Exception
	 */
	RelExpActSub anyadePTT(RelExpActSub relExpActSub, Usuario usuario, Integer idExpediente, Integer idConvocatoria,
			Integer origen) throws Exception;

	/**
	 * borraPTT
	 * 
	 * @param relExpActSub
	 * @param idClavePrimaria
	 * @param idExpediente
	 * @param idConvocatoria
	 * @param usuario
	 * @return
	 * @throws Exception
	 */
	RelExpActSub borraPTT(RelExpActSub relExpActSub, Integer idClavePrimaria, Integer idExpediente,
			Integer idConvocatoria, Integer origen, Usuario usuario) throws Exception;

	/**
	 * modificaPTT
	 * 
	 * @param relExpActSub
	 * @param idClavePrimaria
	 * @param idExpediente
	 * @param idConvocatoria
	 * @param usuario
	 * @return
	 * @throws Exception
	 */
	RelExpActSub modificaPTT(RelExpActSub relExpActSub, Integer idExpediente, Integer idConvocatoria, Integer origen,
			Usuario usuario) throws Exception;

	/**
	 * buscaDEC
	 * 
	 * @param relExpActSub
	 * @param usuario
	 * @param idExpediente
	 * @param idConvocatoria
	 * @return
	 * @throws Exception
	 */
	RelExpActSub buscaDEC(RelExpActSub relExpActSub, Integer idExpediente, Integer idConvocatoria,
			Integer idClavePrimaria, Usuario usuario);

	/**
	 * anyadeDEC
	 * 
	 * @param relExpActSub
	 * @param usuario
	 * @param idExpediente
	 * @param idConvocatoria
	 * @return
	 * @throws Exception
	 */
	RelExpActSub anyadeDEC(RelExpActSub relExpActSub, Integer idExpediente, Integer idConvocatoria, Usuario usuario)
			throws Exception;

	/**
	 * modificaDEC
	 * 
	 * @param relExpActSub
	 * @param idExpediente
	 * @param idConvocatoria
	 * @param usuario
	 * @return
	 * @throws Exception
	 */
	RelExpActSub modificaDEC(RelExpActSub relExpActSub, Integer idConvocatoria, Integer idExpediente, Integer origen,
			Usuario usuario) throws Exception;

	/**
	 * borraDEC
	 * 
	 * @param relExpActSub
	 * @param idExpediente
	 * @param idConvocatoria
	 * @param usuario
	 * @return
	 * @throws Exception
	 */
	RelExpActSub borraDEC(RelExpActSub relExpActSub, Integer idConvocatoria, Integer idExpediente,
			Integer idClavePrimaria, Integer origen, Usuario usuario) throws Exception;

	/**
	 * modificaOTC
	 * 
	 * @param relExpActSub
	 * @param idExpediente
	 * @param idConvocatoria
	 * @param usuario
	 * @return
	 * @throws Exception
	 */
	RelExpActSub modificaOTC(RelExpActSub relExpActSub, Integer idExpediente, Integer idConvocatoria, Usuario usuario)
			throws Exception;

	/**
	 * modificaOTC
	 * 
	 * @param relExpActSub
	 * @param idExpediente
	 * @param usuario
	 * @return
	 * @throws Exception
	 */
	RelExpActSub modificaOMIC(RelExpActSub relExpActSub, Integer idExpediente, Usuario usuario) throws Exception;

	RelExpActSub buscaEMCO(RelExpActSub relExpActSub, Integer idExpediente, Integer idConvocatoria,
			Integer idClavePrimaria, Usuario usuario);

	JQGridResponseDto<RelExpActSub> filterJustificacion(RelExpActSub filterRelFacActSubvencionables,
			JQGridRequestDto jqGridRequestDto, boolean b);

	RelExpActSub saveDatosJustificacion(Integer idExpediente, Integer idConvocatoria, RelExpActSub relExpActSub,
			Integer origen, Usuario usuario);

	List<RelExpActSub> findExentoPorExpediente(Integer idExpediente);

	List<RelExpActSub> filterDECTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	List<RelExpActSub> filterOMICTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	List<MarcarInspeccionableAct> filterConConceptosTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	List<RelExpActSub> filterEMETTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	List<RelExpActSub> filterPTTTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	List<RelExpActSub> filterOTCTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	List<RelExpActSub> filterMECTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	List<RelExpActSub> filterJustificacionTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	void recalcularImportePresentado(Integer idExpediente, Integer exento);

	RelExpActSub modificaEMCO(RelExpActSub relExpActSub, Integer idConvocatoria, Integer idExpediente, Integer origen,
			Usuario usuario);

	RelExpActSub borraEMCO(RelExpActSub relExpActSub, Integer idConvocatoria, Integer idExpediente,
			Integer idClavePrimaria, int origen, Usuario usuario);

	RelExpActSub anyadeEMCO(RelExpActSub relExpActSub, Integer idExpediente, Integer idConvocatoria, Usuario usuario)
			throws Exception;

	void updateRelExpActSubEmpreEMCO(Integer idRelacion, Integer idActSubPadre, RelExpActSub relExpActSub,
			Integer idExpediente);

	RelExpActSub sumaImportesFacturasEMCO(Integer idExpediente, Integer idActSubPadre);

	void updateRelExpActSubEmprePadreEMCO(Integer idRelacion, Integer idActSubPadre, BigDecimal sumaImporteEMCO);

	Integer findRelExpActSubEmprePadreEMCO(Integer idActSubHijo);

	void updateDatosProyectoEMCO(Integer idExpediente, BigDecimal sumaImporteEMCO);

	void updateRelExpActSubPadreEMCO(Integer idRelacion, Integer idActSubHijo, RelExpActSub relExpActSub,
			Integer idExpediente);

	Integer findNuevoIdActSubHijo(Integer idRelacion);

	void updateRelExpActSubAbueloEMCO(EstudioTecnico estudioTecnico, Integer idActSubPadre);

	Integer findRelExpActSubEmpreHijoEMCO(Integer idCriterio);

	void updateRelExpActSubAdmitidoPadreEMCO(Integer idRelacion, Integer idActSubHijo, RelExpActSub relExpActSubAux,
			Integer idExpediente);

	Integer existenMasFacturas(Integer idActSubHijo, Integer idExpediente);

	void removeRelExpActSubPadreEMCO(Integer idActSubHijo, Integer idExpediente);

	List<RelExpActSub> filterEMCOTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto, boolean b,
			Integer idExpedientes);

	List<MarcarInspeccionableAct> filterConConceptosPTTTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto,
			boolean b);

	RelExpActSub modificaJustOTC(RelExpActSub relExpActSub, Integer idExpediente, Usuario usuario);

	List<RelExpActSub> filterEMCOEmpreTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto, boolean b,
			Integer idExpedientes);

	JQGridResponseDto<RelExpActSub> filterCOVIDT(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			boolean startsWith);

	RelExpActSub findRelPorExpedientePorCriterioEntidadBancaria(Integer idExpedientes, Integer idActSub,
			String entidadBancaria);

}
