package com.ejie.ab60.service.actuacionesSubvencionables;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.ResponseBody;

import com.ejie.ab60.comun.Constantes;
import com.ejie.ab60.dao.EntidadesBancariasDao;
import com.ejie.ab60.dao.OtrosIngresosDao;
import com.ejie.ab60.dao.DEC.ActAsociacionDao;
import com.ejie.ab60.dao.DEC.ActAyuntamientoDao;
import com.ejie.ab60.dao.MEC.FacturasDao;
import com.ejie.ab60.dao.PTT.ContratacionesPersonalDao;
import com.ejie.ab60.dao.PTT.GastosTuristicosDao;
import com.ejie.ab60.dao.PTT.PersonasContratadasDao;
import com.ejie.ab60.dao.PTT.PertenenciasRedesDao;
import com.ejie.ab60.dao.actuacionesSubvencionables.ActSubvencionableDao;
import com.ejie.ab60.dao.actuacionesSubvencionables.RelActSubMotDenDao;
import com.ejie.ab60.dao.actuacionesSubvencionables.RelActSubMotMinDao;
import com.ejie.ab60.dao.actuacionesSubvencionables.RelActSubSubactDao;
import com.ejie.ab60.dao.actuacionesSubvencionables.RelExpActSubDao;
import com.ejie.ab60.dao.convocatorias.ConvocatoriasDao;
import com.ejie.ab60.dao.estudioTecnico.ConceptosDao;
import com.ejie.ab60.dao.estudioTecnico.EstudioTecnicoDao;
import com.ejie.ab60.dao.justificacion.RelFacActSubvencionablesDao;
import com.ejie.ab60.model.EntidadesBancarias;
import com.ejie.ab60.model.OtrosIngresos;
import com.ejie.ab60.model.DEC.ActAsociacion;
import com.ejie.ab60.model.DEC.ActAyuntamiento;
import com.ejie.ab60.model.MEC.Facturas;
import com.ejie.ab60.model.PTT.ModalidadesContrato;
import com.ejie.ab60.model.PTT.PertenenciasRedes;
import com.ejie.ab60.model.PTT.ProductosTuristicos;
import com.ejie.ab60.model.actuacionesSubvencionables.ActSubvencionable;
import com.ejie.ab60.model.actuacionesSubvencionables.RelActSubMotDen;
import com.ejie.ab60.model.actuacionesSubvencionables.RelActSubMotMin;
import com.ejie.ab60.model.actuacionesSubvencionables.RelActSubSubact;
import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.ab60.model.estudioTecnico.Conceptos;
import com.ejie.ab60.model.estudioTecnico.EstudioTecnico;
import com.ejie.ab60.model.expedientes.MarcarInspeccionableAct;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.ab60.service.MEC.FacturasService;
import com.ejie.ab60.tramita.services.PifServiceImpl;
import com.ejie.ab60.util.UtilDate;
import com.ejie.ab60.util.exception.NegocioException;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpActSubServiceImpl  
 * 
 *  
 */

@Service(value = "relExpActSubService")
public class RelExpActSubServiceImpl implements RelExpActSubService {

	private static final Logger logger = LoggerFactory.getLogger(PifServiceImpl.class);
	private static final Logger Logger = LoggerFactory.getLogger(RelExpActSubServiceImpl.class);

	@Autowired
	private RelExpActSubDao relExpActSubDao;

	@Autowired
	private ContratacionesPersonalDao contratacionesPersonalDao;

	@Autowired
	private PersonasContratadasDao personasContratadasDao;

	@Autowired
	private EstudioTecnicoDao estudioTecnicoDao;

	@Autowired
	private ConceptosDao conceptosDao;

	@Autowired
	private PertenenciasRedesDao pertenenciasRedesDao;

	@Autowired
	private GastosTuristicosDao gastosTuristicosDao;

	@Autowired
	private ActSubvencionableDao actSubvencionableDao;

	@Autowired
	private ActAyuntamientoDao actAyuntamientoDao;

	@Autowired
	private ActAsociacionDao actAsociacionDao;

	@Autowired
	private ConvocatoriasDao convocatoriasDao;

	@Autowired
	private FacturasDao facturasDao;
	@Autowired
	private RelActSubSubactDao relActSubSubactDao;

	@Autowired
	private RelActSubMotMinDao relActSubMotMinDao;

	@Autowired
	private RelActSubMotDenDao relActSubMotDenDao;

	@Autowired
	private OtrosIngresosDao otrosIngresosDao;

	@Autowired
	private RelFacActSubvencionablesDao relFacActSubvencionablesDao;

	@Autowired
	private EntidadesBancariasDao entidadesBancariasDao;

	@Autowired
	private FacturasService facturasService;

	/**
	 * Finds el ultimo id de la tabla in the RelExpActSub table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	public RelExpActSub findUltimoId(Integer idExpediente, Integer idActSub) {
		RelExpActSub id = new RelExpActSub();
		RelExpActSub lastId = relExpActSubDao.findLastId(idExpediente, idActSub);
		if (null != lastId.getIdRelExpActSub() && 0 != lastId.getIdRelExpActSub()) {
			id = lastId;
		} else {
			id = relExpActSubDao.findUltimoId();
		}
		return (RelExpActSub) id;
	}

	/**
	 * Sumo todos los importes de las Relaciones hijos de un expediente sin su
	 * padre.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return RelExpActSub
	 */
	public RelExpActSub findRelExpActHijosPorExpediente(Integer idExpediente) {
		return (RelExpActSub) this.relExpActSubDao.findRelExpActHijosPorExpediente(idExpediente);

	}

	/**
	 * Finds el ultimo id de la tabla in the RelExpActSub table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	public RelExpActSub findRelExpActSub(Integer idActSub, Integer idExpediente) {
		return (RelExpActSub) relExpActSubDao.findRelExpActSub(idActSub, idExpediente);
	}

	/**
	 * Finds el ultimo id de la tabla in the RelExpActSub table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	public RelExpActSub findLastId(Integer idExpediente, Integer idActSub) {
		return (RelExpActSub) relExpActSubDao.findLastId(idExpediente, idActSub);
	}

	/**
	 * Metod para hacer un update de estudio tecnico
	 * 
	 * @param tercero
	 * @return EstudioTecnico Bean resultante del proceso de creacion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public @ResponseBody() RelExpActSub saveDatos(Integer idExpediente, Integer idConvocatoria,
			RelExpActSub relExpActSub, Integer origen, Usuario usuario) {

		Date fecha = new Date();
		RelExpActSub relExpActSubaux = new RelExpActSub();
		RelExpActSub relExpActSubAux2 = new RelExpActSub();
		RelExpActSub relExpActSubId = new RelExpActSub();
		EstudioTecnico estudioTecnico = new EstudioTecnico();
		RelActSubMotMin relActSubMotMin = new RelActSubMotMin();
		RelActSubMotDen relActSubMotDen = new RelActSubMotDen();
		Integer idRelacion = relExpActSub.getIdRelExpActSub();
		Integer idActSub = relExpActSub.getIdActSub();

		relExpActSub.setIdExpediente(idExpediente);
		relExpActSub.setFechaUltmodificacion(fecha);
		relExpActSub.setUsuarioUltmodificacion(usuario.getNombreUsuario());

		Integer idAgrupacionActSub = 0;

		if (idActSub != null) {
			idAgrupacionActSub = actSubvencionableDao.obtenerIdentificadorAgrupacion(idActSub);
		}

		if (relExpActSub.getComboDenegacion().size() != 0) {
			this.relFacActSubvencionablesDao.removeAdmitido(idExpediente, relExpActSub);
		}

		if (0 == idRelacion) {
			relExpActSubId = this.findUltimoId(idExpediente, idActSub);
			idRelacion = relExpActSubId.getIdRelExpActSub();
			relExpActSubaux.setIdRelExpActSub(relExpActSubId.getIdRelExpActSub());
			relExpActSubaux.setIdExpediente(idExpediente);
			relExpActSubaux.setIdActSub(idActSub);
			relExpActSubaux.setFechaRegistro(fecha);
			relExpActSubaux.setUsuarioRegistro(usuario.getNombreUsuario());

			RelExpActSub ultimaRelacionExistente = relExpActSubDao.findLastId(idExpediente, idActSub);
			if (!ultimaRelacionExistente.getIdRelExpActSub().equals(idRelacion)) {
				relExpActSubDao.add(relExpActSubaux);
			}
		}
		relExpActSub.setIdRelExpActSub(idRelacion);
		// Por cada actuacion subvencionable guarda ciertos campos
		if (idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Pertenencia_Redes) {
			PertenenciasRedes pertenenciasRedes = new PertenenciasRedes();
			pertenenciasRedes.setRelExpActSub(relExpActSub);
			pertenenciasRedes.setDenominacion(relExpActSub.getPertenenciasRedes().getDenominacion());
			pertenenciasRedesDao.updateDenominacionRedes(pertenenciasRedes);
		} else if (idAgrupacionActSub == Constantes.ID_AGRUPACION_CTP_Apoyo_Creacion
				|| idAgrupacionActSub == Constantes.ID_AGRUPACION_CTP_Actuaciones_Destinadas
				|| idAgrupacionActSub == Constantes.ID_AGRUPACION_CTP_Apoyo_Eventos) {
			insertarIdsActSubdeUnaActSub(relExpActSub, usuario, fecha, idRelacion);
		}

		Convocatorias convocatoria = new Convocatorias();
		convocatoria.setIdConvocatoria(idConvocatoria);
		convocatoria = convocatoriasDao.find(convocatoria);
		switch (convocatoria.getIdTipoAyuda()) {
		case Constantes.TIPO_AYUDA_MEC:
			Facturas facturasSum = this.facturasDao.findFacturasPorExpedientePorRelacion(idExpediente, idRelacion);
			sumatorioFacturasMec(relExpActSub, facturasSum);
			relExpActSubAux2 = this.sumTotales(idExpediente);
			break;
		case Constantes.TIPO_AYUDA_EMCO:
			Integer idActSubHijo = this.relExpActSubDao.findNuevoIdActSubHijo(idRelacion);
			Integer idActSubPadre = this.relExpActSubDao.findRelExpActSubEmprePadreEMCO(idActSubHijo);
			relExpActSubAux2 = this.relExpActSubDao.sumaImportesFacturasEMCO(idExpediente, idActSubPadre);
			break;
		case Constantes.TIPO_AYUDA_CTP:
		case Constantes.TIPO_AYUDA_EMET:
			Conceptos conceptosSumEMET = this.conceptosDao.findConceptosPorExpedientePorRelacion(idExpediente,
					idRelacion);
			sumatorioConceptos(relExpActSub, conceptosSumEMET);
			if (idAgrupacionActSub == Constantes.ID_AGRUPACION_EMET_Competitividad_Innovacion
					|| idAgrupacionActSub == Constantes.ID_AGRUPACION_EMET_Competitividad_Calidad
					|| idAgrupacionActSub == Constantes.ID_AGRUPACION_EMET_Competitividad_Oferta) {
				relExpActSubAux2.setIdRelExpActSub(idRelacion);
				relExpActSubAux2 = this.findRelExpActHijosPorExpediente(idExpediente);
			} else {
				relExpActSubAux2 = this.sumTotales(idExpediente);
			}
			break;
		case Constantes.TIPO_AYUDA_COVIDT:
		case Constantes.TIPO_AYUDA_COVIDM:
			relExpActSubAux2 = this.relExpActSubDao.sumImportesConceptos(idExpediente);
			break;
		default:
			break;
		}

		relActSubMotDen.setIdRelExpActSub(idRelacion);
		relActSubMotDenDao.remove(relActSubMotDen, origen);
		RelExpActSubServiceImpl.Logger
				.info("[Remove lista de motivos de denegacion respecto a una actuacion subvencionable] "
						+ relExpActSub.getComboDenegacion().size());
		for (int i = 0; i < relExpActSub.getComboDenegacion().size(); i++) {
			relActSubMotDen.setFechaRegistro(fecha);
			relActSubMotDen.setUsuarioRegistro(usuario.getNombreUsuario());
			relActSubMotDen.setIdMotivoDenegacion(
					Long.parseLong(relExpActSub.getComboDenegacion().get(i).getComboDenegacion()));
			relActSubMotDen.setIdRelExpActSub(idRelacion);
			relActSubMotDenDao.add(relActSubMotDen);
			RelExpActSubServiceImpl.logger
					.info("[obtener lista de id de comboMinoracion] " + relExpActSub.getComboDenegacion().size());
			// poner subvencion calcula y porceNtaje a null EN LA TABLA
			// relexpactsub si denegamos LA ACTUACION
			relExpActSub.setSubvencionCalculada(null);
			relExpActSub.setPorcentaje(null);

		}

		if (convocatoria.getIdTipoAyuda() == Constantes.TIPO_AYUDA_CTP
				|| convocatoria.getIdTipoAyuda() == Constantes.TIPO_AYUDA_EMET
				|| convocatoria.getIdTipoAyuda() == Constantes.TIPO_AYUDA_COVIDT
				|| convocatoria.getIdTipoAyuda() == Constantes.TIPO_AYUDA_COVIDM) {
			OtrosIngresos otrosIngresos = new OtrosIngresos();
			otrosIngresos.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
			otrosIngresos.setImporte(relExpActSub.getAyudaConcedida());
			otrosIngresos.setFase(Constantes.FASE_SOLICITUD);

			OtrosIngresos otrosIngresosAux = this.otrosIngresosDao.findByIdRelExpActSub(otrosIngresos);

			if (null != otrosIngresosAux) {
				otrosIngresosDao.updateImporte(otrosIngresos);
			} else {
				otrosIngresosDao.add(otrosIngresos);
			}
		}

		if ((convocatoria.getIdTipoAyuda() == Constantes.TIPO_AYUDA_COVIDT
				&& idAgrupacionActSub == Constantes.ID_AGRUPACION_ENTIDAD_BANCARIA_COVIDT)
				|| (convocatoria.getIdTipoAyuda() == Constantes.TIPO_AYUDA_COVIDM
						&& idAgrupacionActSub == Constantes.ID_AGRUPACION_ENTIDAD_BANCARIA_COVIDM)) {

			EntidadesBancarias entidadesBancarias = new EntidadesBancarias();
			entidadesBancarias.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
			EntidadesBancarias entidadesBancariasAux = this.entidadesBancariasDao
					.findByIdRelExpActSub(entidadesBancarias);

			if (entidadesBancariasAux != null) {
				this.relExpActSubDao.updateEntidadBancaria(relExpActSub);
			} else {
				entidadesBancarias.setEntidadBancaria(relExpActSub.getActSubvencionable().getEntidadBancaria());
				entidadesBancarias.setUsuarioRegistro(usuario.getNombreUsuario());
				this.entidadesBancariasDao.add(entidadesBancarias);
			}

		}

		relExpActSub = this.updateImporteSubvencionCalculada(relExpActSub);
		RelExpActSubServiceImpl.logger
				.info("[POST - filter] : Updatear subvencion calculada y porcenataje en  RelExpActSubs");
		relExpActSubAux2.setIdRelExpActSub(idRelacion);
		updatearImportesDatosProyecto(idExpediente, usuario, fecha, relExpActSubAux2, estudioTecnico);
		this.update(relExpActSub);
		RelExpActSubServiceImpl.logger.info("[POST - filter] : Updatear realcion actuacion subvencionable");
		// Remove motivos minoracion, para luego insertar los nuevos o dejarla
		// vacia
		relActSubMotMin.setIdRelExpActSub(idRelacion);
		relActSubMotMinDao.remove(relActSubMotMin, origen);
		RelExpActSubServiceImpl.logger
				.info("[Remove lista de motivos de minoracion respecto a una actuacion subvencionable] "
						+ relExpActSub.getComboMinoracion().size());
		for (int indice = 0; indice < relExpActSub.getComboMinoracion().size(); indice++) {
			relActSubMotMin.setFechaRegistro(fecha);
			relActSubMotMin.setUsuarioRegistro(usuario.getNombreUsuario());
			relActSubMotMin.setIdMotivoMinoracion(
					Long.parseLong(relExpActSub.getComboMinoracion().get(indice).getComboMinoracion()));
			relActSubMotMin.setIdRelExpActSub(idRelacion);
			relActSubMotMinDao.add(relActSubMotMin);
			RelExpActSubServiceImpl.logger
					.info("[obtener lista de id de comboMinoracion] " + relExpActSub.getComboMinoracion().size());

		}

		RelExpActSubServiceImpl.logger
				.info("[Updatear RelEXpACtSub el formulario de observaciones, notas y denegada o minorada");

		return relExpActSub;

	}

	private void updatearImportesDatosProyecto(Integer idExpediente, Usuario usuario, Date fecha,
			RelExpActSub relExpActSubAux2, EstudioTecnico estudioTecnico) {
		// Actualiazamos importe admitido de expediente
		estudioTecnico.setIdExpediente(idExpediente);
		estudioTecnico.setFechaUltmodificacion(fecha);
		estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
		estudioTecnico.setSubvencionCalculada(null);
		estudioTecnico.setSubvencionResuelta(null);
		if (null == relExpActSubAux2.getImporteAdmitido()) {
			estudioTecnico.setImporteAdmitido(null);
		} else {
			estudioTecnico.setImporteAdmitido(relExpActSubAux2.getImporteAdmitido());
		}
		if (null == relExpActSubAux2.getImportePresentado()) {
			estudioTecnico.setImportePresentado(null);
		} else {
			estudioTecnico.setImportePresentado(relExpActSubAux2.getImportePresentado());
		}
		estudioTecnicoDao.updateImporte(estudioTecnico);

		RelExpActSubServiceImpl.Logger.info("[Updatear los importes de datos proyecto]");
	}

	private void sumatorioConceptos(RelExpActSub relExpActSub, Conceptos conceptosSum) {
		if (null != conceptosSum) {
			if (null != conceptosSum.getImportePresentado()) {
				relExpActSub.setImportePresentado(conceptosSum.getImportePresentado());
			} else {

				relExpActSub.setImportePresentado(null);
			}
			if (null != conceptosSum.getImporteAdmitido()) {
				relExpActSub.setImporteAdmitido(conceptosSum.getImporteAdmitido());
			} else {
				relExpActSub.setImporteAdmitido(null);
			}

			this.updateImporte(relExpActSub);
		}
	}

	private void sumatorioFacturasMec(RelExpActSub relExpActSub, Facturas facturasSum) {
		if (null != facturasSum) {
			if (null != facturasSum.getImporte()) {
				relExpActSub.setImportePresentado(facturasSum.getImporte());
			} else {
				relExpActSub.setImportePresentado(null);
			}
			if (null != facturasSum.getImporteAdmitido()) {
				relExpActSub.setImporteAdmitido(facturasSum.getImporteAdmitido());
			} else {
				relExpActSub.setImporteAdmitido(null);
			}

			this.updateImportePresentadoAdmtido(relExpActSub);
		}
	}

	private void insertarIdsActSubdeUnaActSub(RelExpActSub relExpActSub, Usuario usuario, Date fecha,
			Integer idRelacion) {
		RelActSubSubact relActSubSubact = new RelActSubSubact();
		relActSubSubact.setIdRelExpActSub(idRelacion);
		List<Conceptos> listaConceptoss = conceptosDao.findConceptosPorRelExpActSub(idRelacion);

		relActSubSubactDao.remove(relActSubSubact);

		if (listaConceptoss.size() >= 0) {

			if (relExpActSub.getCriteriosRelActSubSubacts() != null) {
				RelExpActSubServiceImpl.Logger.info("[obtener lista de criterios de actuaciones subvencionables]");

				List<ActSubvencionable> lcriteriosRelActSubSubacts = new ArrayList<ActSubvencionable>();
				ActSubvencionable relIdcriterios = null;

				for (Integer relcriterio : relExpActSub.getCriteriosRelActSubSubacts()) {
					relIdcriterios = new ActSubvencionable();
					relIdcriterios.setIdActSub(relcriterio);

					lcriteriosRelActSubSubacts.add(relIdcriterios);
				}

				RelActSubSubact relActSubSubactAux = null;
				for (int i = 0; i < lcriteriosRelActSubSubacts.size(); i++) {
					// // crear un objeto
					relActSubSubactAux = new RelActSubSubact();
					relActSubSubactAux.setIdRelExpActSub(idRelacion);
					relActSubSubactAux.setActSubvencionable(lcriteriosRelActSubSubacts.get(i));
					relActSubSubactAux.setFechaRegistro(fecha);
					relActSubSubactAux.setUsuarioRegistro(usuario.getNombreUsuario());
					relActSubSubactDao.add(relActSubSubactAux);
					RelExpActSubServiceImpl.Logger.info("[Anadir lista de criterios de actuaciones subvencionables] ");
				}

			}
		}
	}

	/**
	 * Inserts a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpActSub add(RelExpActSub relExpActSub) {
		return this.relExpActSubDao.add(relExpActSub);
	}

	/**
	 * Inserts a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpActSub anyadirRelacion(RelExpActSub relExpActSub) {
		return this.relExpActSubDao.anyadirRelacion(relExpActSub);
	}

	/**
	 * Updates a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpActSub update(RelExpActSub relExpActSub) {
		return this.relExpActSubDao.update(relExpActSub);
	}

	/**
	 * Updates a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public RelExpActSub updatePTT(RelExpActSub relExpActSub) {
		return this.relExpActSubDao.updatePTT(relExpActSub);
	}

	/**
	 * Updates de Importe Admitido in the RelExpActSub table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpActSub updateImporte(RelExpActSub relexpactsub) {
		return this.relExpActSubDao.updateImporte(relexpactsub);
	}

	/**
	 * Updates de Importe Admitido y importe presentado in the RelExpActSub
	 * table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpActSub updateImportePresentadoAdmtido(RelExpActSub relexpactsub) {
		return this.relExpActSubDao.updateImportePresentadoAdmtido(relexpactsub);
	}

	/**
	 * Updates de Importe Admitido y importe presentado in the RelExpActSub
	 * table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpActSub updateImporteJusPresentadoAdmtido(RelExpActSub relexpactsub) {
		return this.relExpActSubDao.updateImporteJusPresentadoAdmtido(relexpactsub);
	}

	/**
	 * Updates de Importe Admitido y importe presentado de la Relacion
	 * Expediente act subven Padre
	 * 
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpActSub updateImportePresentadoAdmtidoPadre(RelExpActSub relexpactsub) {
		return this.relExpActSubDao.updateImportePresentadoAdmtidoPadre(relexpactsub);
	}

	/**
	 * Updates de SUBVENCION_CALCULADA y PORCENTAJE in the RelExpActSub table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpActSub updateImporteSubvencionCalculada(RelExpActSub relexpactsub) {
		return this.relExpActSubDao.updateImporteSubvencionCalculada(relexpactsub);
	}

	/**
	 * Updates de Importe Admitido y importe presentado in the RelExpActSub
	 * table.
	 *
	 * @param relexpactsub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpActSub updateImportePorIdActSub(RelExpActSub relExpActSub, Integer idActSub) {
		return this.relExpActSubDao.updateImportePorIdActSub(relExpActSub, idActSub);
	}

	/**
	 * Finds a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	public RelExpActSub find(RelExpActSub relExpActSub) {
		return (RelExpActSub) this.relExpActSubDao.find(relExpActSub);
	}

	/**
	 * Finds a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	public RelExpActSub findIdActSub(Integer idRelExpActSub) {
		return (RelExpActSub) this.relExpActSubDao.findIdActSub(idRelExpActSub);
	}

	/**
	 * Finds a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @return RelExpActSub
	 */
	public Integer findIdActSubAgrupacionPorExpediente(Integer idExpediente) {
		return (Integer) this.relExpActSubDao.findIdActSubAgrupacionPorExpediente(idExpediente);
	}

	/**
	 * Finds a single row in the RelExpActSub table.
	 *
	 * @param idExpedientes,
	 *            IdCreiterio Integer, Integer
	 * @return RelExpActSub
	 */
	public RelExpActSub findRelPorExpedientePorCriterio(Integer idExpedientes, Integer IdCriterio) {
		return (RelExpActSub) this.relExpActSubDao.findRelPorExpedientePorCriterio(idExpedientes, IdCriterio);
	}

	@Override
	public RelExpActSub findRelPorExpedientePorCriterioEntidadBancaria(Integer idExpedientes, Integer idActSub,
			String entidadBancaria) {
		return (RelExpActSub) this.relExpActSubDao.findRelPorExpedientePorCriterioEntidadBancaria(idExpedientes,
				idActSub, entidadBancaria);
	}

	/**
	 * Finds a single row in the RelExpActSub table.
	 *
	 * @param idExpedientes,
	 *            IdCreiterio Integer, Integer
	 * @return RelExpActSub
	 */
	public RelExpActSub findRelPorExpedientePorCriterioPTT(Integer idExpedientes, Integer IdCriterio) {
		return (RelExpActSub) this.relExpActSubDao.findRelPorExpedientePorCriterioPTT(idExpedientes, IdCriterio);
	}

	/**
	 * Devuelve los totales de un RelExpActSub
	 *
	 * @param Integer
	 *            IdRelacion
	 *
	 * @return RelExpActSub
	 */

	public RelExpActSub findTotales(Integer IdRelacion) {
		return (RelExpActSub) this.relExpActSubDao.findTotales(IdRelacion);

	}

	/**
	 * Devuelve los totales de un RelExpActSub
	 *
	 * @param Integer
	 *            IdRelacion
	 *
	 * @return RelExpActSub
	 */

	public RelExpActSub findTotalesJustificacion(Integer IdRelacion, Integer idRelExpActSub) {
		return (RelExpActSub) this.relExpActSubDao.findTotalesJustificacion(IdRelacion, idRelExpActSub);

	}

	/**
	 * Devuelve los totales de un relacion de expedientes por actividad
	 * subcionable
	 *
	 * @param Integer
	 *            IdExpediente
	 *
	 * @return RelExpActSub
	 */
	public RelExpActSub sumTotales(Integer idExpediente) {
		return (RelExpActSub) this.relExpActSubDao.sumTotales(idExpediente);
	}

	/**
	 * Devuelve los totales de un relacion de expedientes por actividad
	 * subcionable
	 *
	 * @param Integer
	 *            IdExpediente
	 *
	 * @return RelExpActSub
	 */
	public RelExpActSub sumTotalesJus(Integer idExpediente) {
		return (RelExpActSub) this.relExpActSubDao.sumTotalesJus(idExpediente);
	}

	/**
	 * Devuelve los totales de un relacion de expedientes por actividad
	 * subcionable
	 *
	 * @param Integer
	 *            IdExpediente
	 *
	 * @return RelExpActSub
	 */
	public RelExpActSub sumEstudioActuacion(Integer idExpediente, Integer idActuacion) {
		return (RelExpActSub) this.relExpActSubDao.sumEstudioActuacion(idExpediente, idActuacion);
	}

	/**
	 * sumPTT
	 * 
	 * @param idConvocatoria
	 * @param idExpediente
	 * @return
	 */
	@Override
	public RelExpActSub sumPTT(Integer idConvocatoria, Integer idExpediente) {
		return (RelExpActSub) this.relExpActSubDao.sumPTT(idConvocatoria, idExpediente);
	}

	/**
	 * Deletes a single row in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(RelExpActSub relExpActSub) {
		this.relExpActSubDao.remove(relExpActSub);
	}

	/**
	 * Finds a list of rows in the RelExpActSub table.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelExpActSub>
	 */
	public List<RelExpActSub> findAll(RelExpActSub relExpActSub, JQGridRequestDto jqGridRequestDto) {
		return (List<RelExpActSub>) this.relExpActSubDao.findAll(relExpActSub, jqGridRequestDto);
	}

	/**
	 * sacamos una lista de las relaciones de un expediente
	 *
	 * @param idExpediente
	 *            Integer
	 * 
	 * @param idConvocatoria
	 *            Integer
	 * @param usuario
	 *            Usuario
	 * @return List<RelExpActSub>
	 */
	@Override
	@Transactional
	public void ponerImportesNulosACero(Integer idExpediente, Integer idConvocatoria, Usuario usuario)
			throws Exception {

		Facturas factura = new Facturas();
		Conceptos concepto = new Conceptos();
		RelExpActSub relExpActSub = new RelExpActSub();
		List<RelExpActSub> relExpActSubList = new ArrayList();
		Date fecha = new Date();
		Convocatorias convocatoria = new Convocatorias();
		try {
			convocatoria.setIdConvocatoria(idConvocatoria);
			EstudioTecnico estudioTecnico = new EstudioTecnico();
			convocatoria = convocatoriasDao.find(convocatoria);

			switch (convocatoria.getIdTipoAyuda()) {
			case Constantes.TIPO_AYUDA_OTC:
			case Constantes.TIPO_AYUDA_OMIC:
			case Constantes.TIPO_AYUDA_DEC:
			case Constantes.TIPO_AYUDA_CTP:
			case Constantes.TIPO_AYUDA_MEC:
				relExpActSubList = relExpActSubDao.findRelEXpActSubPorExpediente(idExpediente);
				break;
			case Constantes.TIPO_AYUDA_EMET:
				relExpActSubList = relExpActSubDao.findRelEXpActSubPorExpedienteEMET(idExpediente, idConvocatoria);

				break;
			case Constantes.TIPO_AYUDA_PTT:
				relExpActSubList = relExpActSubDao.findRelEXpActSubPorExpedientePTT(idExpediente, idConvocatoria);
			default:
				break;
			}

			for (int indice = 0; indice < relExpActSubList.size(); indice++) {
				switch (convocatoria.getIdTipoAyuda()) {
				case Constantes.TIPO_AYUDA_MEC:
					List<Facturas> facturasList = facturasDao
							.findFacturasPorRelExpActSub(relExpActSubList.get(indice).getIdRelExpActSub());
					for (int index = 0; index < facturasList.size(); index++) {
						if (null == facturasList.get(index).getImporteAdmitido()
								&& null != facturasList.get(index).getImporte()) {
							factura.setIdFactura(facturasList.get(index).getIdFactura());
							factura.setImporteAdmitido(BigDecimal.ZERO);
							factura.setUsuarioUltmodificacion(usuario.getNombreUsuario());
							factura.setFechaUltmodificacion(fecha);
							facturasDao.updateImporteAdmitidoDeNullACero(factura);
						}
					}
					break;
				case Constantes.TIPO_AYUDA_DEC:
				case Constantes.TIPO_AYUDA_PTT:
				case Constantes.TIPO_AYUDA_CTP:
				case Constantes.TIPO_AYUDA_EMET:
					List<Conceptos> conceptosList = conceptosDao
							.findConceptosPorRelExpActSub(relExpActSubList.get(indice).getIdRelExpActSub());
					for (int index = 0; index < conceptosList.size(); index++) {
						if (null == conceptosList.get(index).getImporteAdmitido()
								&& null != conceptosList.get(index).getImportePresentado()) {
							concepto.setIdConcepto(conceptosList.get(index).getIdConcepto());
							concepto.setImporteAdmitido(BigDecimal.ZERO);
							concepto.setUsuarioUltmodificacion(usuario.getNombreUsuario());
							concepto.setFechaUltmodificacion(fecha);
							conceptosDao.updateImporteAdmitidoDeNullACero(concepto);
						}
					}
					break;

				default:
					break;
				}

				relExpActSub.setIdRelExpActSub(relExpActSubList.get(indice).getIdRelExpActSub());
				relExpActSub.setFechaUltmodificacion(fecha);
				relExpActSub.setUsuarioUltmodificacion(usuario.getNombreUsuario());
				relExpActSub.setSubvencionCalculada(relExpActSubList.get(indice).getSubvencionCalculada());
				relExpActSub.setPorcentaje(relExpActSubList.get(indice).getPorcentaje());
				relExpActSub.setIdExpediente(relExpActSubList.get(indice).getIdExpediente());

				if (null == relExpActSubList.get(indice).getImporteAdmitido()
						&& null != relExpActSubList.get(indice).getImportePresentado()) {
					relExpActSub.setImporteAdmitido(BigDecimal.ZERO);
					relExpActSub.setImportePresentado(relExpActSubList.get(indice).getImportePresentado());
					relExpActSubDao.updateImportePresentadoAdmtido(relExpActSub);

				} else if (null == relExpActSubList.get(indice).getImporteAdmitido()
						&& null == relExpActSubList.get(indice).getImportePresentado()) {
					relExpActSub.setImporteAdmitido(BigDecimal.ZERO);
					relExpActSub.setImportePresentado(BigDecimal.ZERO);
					relExpActSubDao.updateImportePresentadoAdmtido(relExpActSub);

				}

			}
			estudioTecnico = estudioTecnicoDao.findTotales(idExpediente);
			// Update tabla de datos del expediente
			estudioTecnico.setIdExpediente(idExpediente);
			estudioTecnico.setFechaUltmodificacion(fecha);
			estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			if (null == estudioTecnico.getImporteAdmitido() && null != estudioTecnico.getImportePresentado()) {
				estudioTecnico.setImporteAdmitido(BigDecimal.ZERO);
				estudioTecnicoDao.updateImporteAdmitidoPresentadodeNullaCero(estudioTecnico);
			} else if (null == estudioTecnico.getImporteAdmitido() && null == estudioTecnico.getImporteAdmitido()) {
				estudioTecnico.setImporteAdmitido(BigDecimal.ZERO);
				estudioTecnico.setImportePresentado(BigDecimal.ZERO);
				estudioTecnicoDao.updateImporteAdmitidoPresentadodeNullaCero(estudioTecnico);

			}
		} catch (Exception e) {
			logger.error(
					"error actualizando alguno de los importes de null a cero - estudio tecnico: " + e.getMessage());
			throw new Exception("error actualizando alguno de los importes", e);
		}

	}

	/**
	 * Finds rows in the RelExpActSub table using like.
	 *
	 * @param relExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelExpActSub>
	 */
	public List<RelExpActSub> findAllLike(RelExpActSub relExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<RelExpActSub>) this.relExpActSubDao.findAllLike(relExpActSub, jqGridRequestDto, startsWith);
	}

	/**
	 * Sacamos la tabla de act subencionables por expediente y sus totales
	 *
	 * @param Integer
	 *            idExpediente
	 * @param Integer
	 *            idConvocatoria
	 * @return List<RelExpActSub>
	 */
	public List<RelExpActSub> findRelEXpActSubPorExpedienteMET(Integer idExpediente, Integer idConvocatoria) {
		return (List<RelExpActSub>) this.relExpActSubDao.findRelEXpActSubPorExpedienteMEC(idExpediente, idConvocatoria);

	}

	public List<RelExpActSub> findRelEXpActSubPorExpediente(Integer idExpediente) {
		return (List<RelExpActSub>) this.relExpActSubDao.findRelEXpActSubPorExpediente(idExpediente);

	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.relExpActSubDao.removeMultiple(filterRelExpActSub, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	public JQGridResponseDto<RelExpActSub> filter(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {

		List<RelExpActSub> listaRelExpActSub = this.relExpActSubDao.findRelEXpActSubPorExpedienteMEC(
				filterRelExpActSub.getIdExpediente(), filterRelExpActSub.getIdconvocatoria());
		Long recordNum = this.relExpActSubDao
				.findAllLikeCount(filterRelExpActSub != null ? filterRelExpActSub : new RelExpActSub(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelExpActSub>> reorderSelection = this.relExpActSubDao.reorderSelection(filterRelExpActSub,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub,
					reorderSelection);
		}
		return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub);
	}

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	public JQGridResponseDto<RelExpActSub> filterEMET(RelExpActSub filterRelExpActSub,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {

		List<RelExpActSub> listaRelExpActSub = this.relExpActSubDao.findRelEXpActSubPorExpedienteEMET(
				filterRelExpActSub.getIdExpediente(), filterRelExpActSub.getIdconvocatoria());
		Long recordNum = this.relExpActSubDao
				.findAllLikeCount(filterRelExpActSub != null ? filterRelExpActSub : new RelExpActSub(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelExpActSub>> reorderSelection = this.relExpActSubDao.reorderSelection(filterRelExpActSub,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub,
					reorderSelection);
		}
		return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub);
	}

	/**
	 * Filter method in the RelExpActSub table para CTP
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	public JQGridResponseDto<RelExpActSub> filterCTP(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {

		List<RelExpActSub> listaRelExpActSub = this.relExpActSubDao.findRelEXpActSubPorExpedienteCTP(
				filterRelExpActSub.getIdExpediente(), filterRelExpActSub.getIdconvocatoria());
		Long recordNum = this.relExpActSubDao
				.findAllLikeCount(filterRelExpActSub != null ? filterRelExpActSub : new RelExpActSub(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelExpActSub>> reorderSelection = this.relExpActSubDao.reorderSelection(filterRelExpActSub,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub,
					reorderSelection);
		}
		return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub);
	}

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	public JQGridResponseDto<RelExpActSub> filterPTT(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {

		List<RelExpActSub> listaRelExpActSub = this.relExpActSubDao.findRelEXpActSubPorExpedientePTT(
				filterRelExpActSub.getIdExpediente(), filterRelExpActSub.getIdconvocatoria());
		Long recordNum = this.relExpActSubDao
				.findAllLikeCount(filterRelExpActSub != null ? filterRelExpActSub : new RelExpActSub(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelExpActSub>> reorderSelection = this.relExpActSubDao.reorderSelection(filterRelExpActSub,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub,
					reorderSelection);
		}
		return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub);
	}

	/**
	 * 
	 * @param idExpediente
	 * @param idConvocatoria
	 * @param idRelExpActSub
	 * @return
	 */
	@Override
	public RelExpActSub findDetallePTT(Integer idExpediente, Integer idConvocatoria, Integer idRelExpActSub) {
		return this.relExpActSubDao.findDetallePTT(idExpediente, idConvocatoria, idRelExpActSub);
	}

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	public JQGridResponseDto<RelExpActSub> filterDEC(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {

		List<RelExpActSub> listaRelExpActSub = this.relExpActSubDao
				.findRelEXpActSubPorExpedienteDEC(filterRelExpActSub.getIdExpediente());
		Long recordNum = this.relExpActSubDao
				.findAllLikeCount(filterRelExpActSub != null ? filterRelExpActSub : new RelExpActSub(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelExpActSub>> reorderSelection = this.relExpActSubDao.reorderSelection(filterRelExpActSub,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub,
					reorderSelection);
		}
		return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub);
	}

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	public JQGridResponseDto<RelExpActSub> filterEMCO(RelExpActSub filterRelExpActSub,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {

		List<RelExpActSub> listaRelExpActSub = this.relExpActSubDao
				.findRelEXpActSubPorExpedienteEMCO(filterRelExpActSub.getIdExpediente());
		Long recordNum = this.relExpActSubDao
				.findAllLikeCount(filterRelExpActSub != null ? filterRelExpActSub : new RelExpActSub(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelExpActSub>> reorderSelection = this.relExpActSubDao.reorderSelection(filterRelExpActSub,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub,
					reorderSelection);
		}
		return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub);
	}

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	public JQGridResponseDto<RelExpActSub> filterOTC(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {

		List<RelExpActSub> listaRelExpActSub = this.relExpActSubDao.findRelEXpActSubPorExpedienteMEC(
				filterRelExpActSub.getIdExpediente(), filterRelExpActSub.getIdconvocatoria());
		Long recordNum = this.relExpActSubDao
				.findAllLikeCount(filterRelExpActSub != null ? filterRelExpActSub : new RelExpActSub(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelExpActSub>> reorderSelection = this.relExpActSubDao.reorderSelection(filterRelExpActSub,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub,
					reorderSelection);
		}
		return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub);
	}

	/**
	 * Filter method in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpActSub>
	 */
	public JQGridResponseDto<RelExpActSub> filterOMIC(RelExpActSub filterRelExpActSub,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {

		List<RelExpActSub> listaRelExpActSub = this.relExpActSubDao
				.findRelEXpActSubPorExpedienteOMIC(filterRelExpActSub.getIdExpediente());
		Long recordNum = this.relExpActSubDao
				.findAllLikeCount(filterRelExpActSub != null ? filterRelExpActSub : new RelExpActSub(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelExpActSub>> reorderSelection = this.relExpActSubDao.reorderSelection(filterRelExpActSub,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub,
					reorderSelection);
		}

		return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub);
	}

	/**
	 * Searches rows in the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param searchRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpActSub>>
	 */
	public List<TableRowDto<RelExpActSub>> search(RelExpActSub filterRelExpActSub, RelExpActSub searchRelExpActSub,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.relExpActSubDao.search(filterRelExpActSub, searchRelExpActSub, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(RelExpActSub filterRelExpActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.relExpActSubDao.reorderSelection(filterRelExpActSub, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelExpActSub table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelExpActSub>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelExpActSub>> jerarquia(RelExpActSub filterRelExpActSub,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<RelExpActSub>> listaRelExpActSub = this.relExpActSubDao
				.findAllLikeJerarquia(filterRelExpActSub, jqGridRequestDto);
		Long recordNum = this.relExpActSubDao.findAllLikeCountJerarquia(filterRelExpActSub, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<RelExpActSub>>(jqGridRequestDto, recordNum, listaRelExpActSub);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the RelExpActSub
	 * table.
	 *
	 * @param filterRelExpActSub
	 *            RelExpActSub
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelExpActSub>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelExpActSub>> jerarquiaChildren(RelExpActSub filterRelExpActSub,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<RelExpActSub>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<RelExpActSub>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.relExpActSubDao.findAllChild(filterRelExpActSub, jqGridRequestDto));
		return jqGridResponseDto;
	}

	/**
	 * anyadePTT
	 * 
	 * @param relExpActSub
	 * @param usuario
	 * @param idExpediente
	 * @param idConvocatoria
	 * @return
	 * @throws Exception
	 */
	@Override
	@Transactional
	public RelExpActSub anyadePTT(RelExpActSub relExpActSub, Usuario usuario, Integer idExpediente,
			Integer idConvocatoria, Integer origen) throws Exception {
		try {
			relExpActSub.setFechaRegistro(new Date());

			relExpActSub.setUsuarioRegistro(usuario.getNombreUsuario());
			relExpActSub.setIdExpediente(idExpediente);
			ActSubvencionable actSubvencionablePTT = new ActSubvencionable();
			actSubvencionablePTT.setIdActSub(relExpActSub.getIdActSub());
			relExpActSub.setActSubvencionable(actSubvencionablePTT);

			RelActSubMotMin relActSubMotMin = new RelActSubMotMin();
			RelActSubMotDen relActSubMotDen = new RelActSubMotDen();
			relActSubMotDen.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
			relActSubMotDenDao.remove(relActSubMotDen, origen);
			relActSubMotMin.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
			relActSubMotMinDao.remove(relActSubMotMin, origen);

			Integer idAgrupacionActSub = null;

			if (null != relExpActSub.getIdActSub()) {
				idAgrupacionActSub = actSubvencionableDao.obtenerIdentificadorAgrupacion(relExpActSub.getIdActSub());
			}

			if (idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Contratacion_Temporal) {

				relExpActSub = this.relExpActSubDao.anyadirRelacion(relExpActSub);

				relExpActSub.getContratacionesPersonal().setFechaRegistro(new Date());
				relExpActSub.getContratacionesPersonal().setUsuarioRegistro(usuario.getNombreUsuario());
				relExpActSub.getContratacionesPersonal().setIdExpediente(idExpediente);
				relExpActSub.getContratacionesPersonal().setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
				this.contratacionesPersonalDao.add(relExpActSub.getContratacionesPersonal());
			} else if (idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_Calidad_Destinos
					|| idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_TIC
					|| idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_Ecoetiquetas_Europea
					|| idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_Compromiso_Accesibilidad
					|| idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_Compromiso_Codigo_Etico) {

				relExpActSub = this.relExpActSubDao.anyadirRelacion(relExpActSub);

				relExpActSub.getPersonasContratadas().setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
				relExpActSub.getPersonasContratadas().setFechaRegistro(new Date());
				relExpActSub.getPersonasContratadas().setUsuarioRegistro(usuario.getNombreUsuario());
				relExpActSub.getPersonasContratadas().setIdSexo(relExpActSub.getContratacionesPersonal().getIdSexo());
				relExpActSub.getPersonasContratadas().setNombrePC(relExpActSub.getContratacionesPersonal().getNombre());
				relExpActSub.getPersonasContratadas()
						.setApellido1PC(relExpActSub.getContratacionesPersonal().getApellido1());
				relExpActSub.getPersonasContratadas()
						.setApellido2PC(relExpActSub.getContratacionesPersonal().getApellido2());
				ModalidadesContrato modalidadesContrato = new ModalidadesContrato();
				modalidadesContrato
						.setIdModalidadContrato(relExpActSub.getContratacionesPersonal().getIdModalidadContrato());
				relExpActSub.getPersonasContratadas().setModalidadesContrato(modalidadesContrato);
				relExpActSub.getPersonasContratadas()
						.setEmpresaContratada(relExpActSub.getContratacionesPersonal().getEmpresaContratada());

				personasContratadasDao.add(relExpActSub.getPersonasContratadas());

			} else if (idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Pertenencia_Redes) {

				if (relExpActSub.getIdRelExpActSub() != null && relExpActSub.getIdRelExpActSub() != 0) {
					// esto es pq si ha añadido conceptos, ya se ha añadido la
					// relacion, hay que modificarla.
					relExpActSubDao.updatePTT(relExpActSub);

				} else {

					relExpActSub = this.relExpActSubDao.anyadirRelacion(relExpActSub);
				}

				RelExpActSub relExpActSubRedes = new RelExpActSub();

				relExpActSubRedes.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
				if (relExpActSub.getPertenenciasRedes() == null) {
					PertenenciasRedes pertenenciaRedes = new PertenenciasRedes();
					relExpActSub.setPertenenciasRedes(pertenenciaRedes);
				}
				relExpActSub.getPertenenciasRedes().setRelExpActSub(relExpActSubRedes);
				relExpActSub.getPertenenciasRedes().setFechaRegistro(new Date());
				relExpActSub.getPertenenciasRedes().setUsuarioRegistro(usuario.getNombreUsuario());
				this.pertenenciasRedesDao.add(relExpActSub.getPertenenciasRedes());

				// calculamos y actualizamos los importes
				Conceptos conceptos = this.conceptosDao
						.findSumConceptosPorRelExpActSub(relExpActSub.getIdRelExpActSub());
				relExpActSub.setImporteAdmitido(conceptos.getImporteAdmitido());
				relExpActSub.setImportePresentado(conceptos.getImportePresentado());
				relExpActSubDao.updatePTT(relExpActSub);

			}

			else if (idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Gastos_Creacion) {

				if (relExpActSub.getIdRelExpActSub() != null && relExpActSub.getIdRelExpActSub() != 0) {
					// esto es pq si ha añadido conceptos, ya se ha añadido la
					// relacion, hay que modificarla.
					relExpActSubDao.updatePTT(relExpActSub);

				} else {

					relExpActSub = this.relExpActSubDao.anyadirRelacion(relExpActSub);
				}

				RelExpActSub relExpActSubGT = new RelExpActSub();
				relExpActSubGT.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
				relExpActSub.getGastosTuristicos().setRelExpActSub(relExpActSubGT);
				relExpActSub.getGastosTuristicos().setFechaRegistro(new Date());
				relExpActSub.getGastosTuristicos().setUsuarioRegistro(usuario.getNombreUsuario());
				ProductosTuristicos productosTuristicos = new ProductosTuristicos();
				productosTuristicos
						.setIdProductoTuristico(relExpActSub.getProductosTuristicos().getIdProductoTuristico());
				relExpActSub.getGastosTuristicos().setProductosTuristicos(productosTuristicos);
				this.gastosTuristicosDao.add(relExpActSub.getGastosTuristicos());

				// calculamos y actualizamos los importes
				Conceptos conceptos = this.conceptosDao
						.findSumConceptosPorRelExpActSub(relExpActSub.getIdRelExpActSub());
				relExpActSub.setImporteAdmitido(conceptos.getImporteAdmitido());
				relExpActSub.setImportePresentado(conceptos.getImportePresentado());
				relExpActSubDao.updatePTT(relExpActSub);

			}

			try {

				// Update los importes en el padre
				// obtengo el padre
				ActSubvencionable actSubvencionable = actSubvencionableDao.findIdActSub(relExpActSub.getIdActSub());
				RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente,
						actSubvencionable.getIdActSubPadre());
				relExpActSubSuma.setIdExpediente(idExpediente);
				relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
				this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma, actSubvencionable.getIdActSubPadre());
				// Update los importes en datos proyecto(estudio tecnico)
				RelExpActSub relExpActSubTotalPTT = this.relExpActSubDao.sumPTT(idConvocatoria, idExpediente);
				EstudioTecnico estudioTecnicoPTT = new EstudioTecnico();
				estudioTecnicoPTT.setIdExpediente(idExpediente);
				estudioTecnicoPTT.setImportePresentado(relExpActSubTotalPTT.getImportePresentado());
				estudioTecnicoPTT.setImporteAdmitido(relExpActSubTotalPTT.getImporteAdmitido());
				estudioTecnicoPTT.setFechaUltmodificacion(new Date());
				estudioTecnicoPTT.setUsuarioUltmodificacion(usuario.getNombreUsuario());

				this.estudioTecnicoDao.updateImporte(estudioTecnicoPTT);

				for (int i = 0; i < relExpActSub.getComboDenegacion().size(); i++) {
					relActSubMotDen.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
					relActSubMotDen.setIdMotivoDenegacion(
							Long.parseLong(relExpActSub.getComboDenegacion().get(i).getComboDenegacion()));
					relActSubMotDen.setFechaRegistro(new Date());
					relActSubMotDen.setUsuarioRegistro(usuario.getNombreUsuario());
					relActSubMotDenDao.add(relActSubMotDen);

				}

				for (int indice = 0; indice < relExpActSub.getComboMinoracion().size(); indice++) {
					relActSubMotMin.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
					relActSubMotMin.setIdMotivoMinoracion(
							Long.parseLong(relExpActSub.getComboMinoracion().get(indice).getComboMinoracion()));
					relActSubMotMin.setFechaRegistro(new Date());
					relActSubMotMin.setUsuarioRegistro(usuario.getNombreUsuario());
					relActSubMotMinDao.add(relActSubMotMin);
				}
				// actualizo los importes de la subvencion calculada y
				// porcentaje a null
				RelExpActSub relExpActSubCalculada = new RelExpActSub();
				relExpActSubCalculada.setIdExpediente(idExpediente);
				relExpActSubCalculada.setUsuarioUltmodificacion(usuario.getNombreUsuario());
				relExpActSubCalculada.setFechaUltmodificacion(new Date());
				relExpActSubDao.updateImporteSubvencionCalculada(relExpActSubCalculada);

				OtrosIngresos otrosIngresos = new OtrosIngresos();
				otrosIngresos.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
				otrosIngresos.setImporte(relExpActSub.getAyudaConcedida());

				//// SET FASE A 1 POR VENIR DE ESTUDIO TECNICO ////
				otrosIngresos.setFase(1);
				/////////////////////////////////////////////////

				otrosIngresosDao.add(otrosIngresos);
			} catch (Exception e) {
				logger.error("error actualizando alguno de los importes - estudio tecnico de PTT: " + e.getMessage());
				throw new Exception("error actualizando alguno de los importes", e);

			}
		} catch (Exception e) {
			logger.error("Error actualizando el estudio tecnico de PTT: " + e.getMessage());
			throw new Exception("error actualizando el estudio tecnico de PTT", e);

		}
		return relExpActSub;
	}

	/**
	 * borraPTT
	 * 
	 * @param relExpActSub
	 * @param idClavePrimaria
	 * @param idExpediente
	 * @param idConvocatoria
	 * @param usuario
	 * @return
	 * @throws Exception
	 */
	@Override
	@Transactional
	public RelExpActSub borraPTT(RelExpActSub relExpActSub, Integer idClavePrimaria, Integer idExpediente,
			Integer idConvocatoria, Integer origen, Usuario usuario) throws Exception {
		try {
			RelActSubMotMin relActSubMotMin = new RelActSubMotMin();
			RelActSubMotDen relActSubMotDen = new RelActSubMotDen();

			relExpActSub.setIdRelExpActSub(idClavePrimaria);
			relExpActSub = relExpActSubDao.findIdActSub(idClavePrimaria);

			relActSubMotDen.setIdRelExpActSub(idClavePrimaria);
			relActSubMotDenDao.remove(relActSubMotDen, origen);
			relActSubMotMin.setIdRelExpActSub(idClavePrimaria);
			relActSubMotMinDao.remove(relActSubMotMin, origen);

			Integer idAgrupacionActSub = actSubvencionableDao
					.obtenerIdentificadorAgrupacion(relExpActSub.getActSubvencionable().getIdActSub());

			OtrosIngresos otrosIngresos = new OtrosIngresos();
			otrosIngresos.setIdRelExpActSub(idClavePrimaria);
			otrosIngresosDao.removeImporte(otrosIngresos);

			if (idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Contratacion_Temporal) {
				relExpActSub = relExpActSubDao.findDetallePTT(idExpediente, idConvocatoria, idClavePrimaria);

				this.contratacionesPersonalDao.removeByIdRelExpActSub(idClavePrimaria);
				this.relExpActSubDao.remove(relExpActSub);
			} else if (idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_Calidad_Destinos
					|| idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_TIC
					|| idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_Ecoetiquetas_Europea
					|| idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_Compromiso_Accesibilidad
					|| idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_Compromiso_Codigo_Etico) {
				relExpActSub = relExpActSubDao.findDetallePTT(idExpediente, idConvocatoria, idClavePrimaria);
				this.personasContratadasDao.removeByIdRelExpActSub(idClavePrimaria);
				this.relExpActSubDao.remove(relExpActSub);
			} else if (idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Pertenencia_Redes) {
				relExpActSub = relExpActSubDao.findDetallePTT(idExpediente, idConvocatoria, idClavePrimaria);
				this.pertenenciasRedesDao.remove(relExpActSub.getPertenenciasRedes());
				this.conceptosDao.removeByIdRelExpActSub(idClavePrimaria);
				this.relExpActSubDao.remove(relExpActSub);
			} else if (idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Gastos_Creacion) {
				relExpActSub = relExpActSubDao.findDetallePTT(idExpediente, idConvocatoria, idClavePrimaria);
				this.gastosTuristicosDao.remove(relExpActSub.getGastosTuristicos());
				this.conceptosDao.removeByIdRelExpActSub(idClavePrimaria);
				this.relExpActSubDao.remove(relExpActSub);
			}
			// Update los importes en el padre
			// obtengo el padre
			ActSubvencionable actSubvencionable = actSubvencionableDao
					.findIdActSub(relExpActSub.getActSubvencionable().getIdActSub());
			RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente,
					actSubvencionable.getIdActSubPadre());
			relExpActSubSuma.setIdExpediente(idExpediente);
			relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma, actSubvencionable.getIdActSubPadre());
			// Update los importes en datos proyecto(estudio tecnico)
			RelExpActSub relExpActSubTotalPTT = this.relExpActSubDao.sumPTT(idConvocatoria, idExpediente);
			EstudioTecnico estudioTecnicoPTT = new EstudioTecnico();
			estudioTecnicoPTT.setIdExpediente(idExpediente);
			estudioTecnicoPTT.setImportePresentado(relExpActSubTotalPTT.getImportePresentado());
			estudioTecnicoPTT.setImporteAdmitido(relExpActSubTotalPTT.getImporteAdmitido());
			estudioTecnicoPTT.setFechaUltmodificacion(new Date());
			estudioTecnicoPTT.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.estudioTecnicoDao.updateImporte(estudioTecnicoPTT);
			// actualizo los importes de la subvencion calculada y
			// porcentaje a null
			RelExpActSub relExpActSubCalculada = new RelExpActSub();
			relExpActSubCalculada.setIdExpediente(idExpediente);
			relExpActSubCalculada.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			relExpActSubCalculada.setFechaUltmodificacion(new Date());
			relExpActSubDao.updateImporteSubvencionCalculada(relExpActSubCalculada);
		} catch (Exception e) {
			logger.error("Error actualizando el estudio tecnico de PTT: " + e.getMessage());
			throw new Exception("error actualizando el estudio tecnico de PTT", e);

		}
		return relExpActSub;
	}

	/**
	 * modificaPTT
	 * 
	 * @param relExpActSub
	 * @param idExpediente
	 * @param idConvocatoria
	 * @param usuario
	 * @return
	 * @throws Exception
	 */
	@Transactional
	public RelExpActSub modificaPTT(RelExpActSub relExpActSub, Integer idExpediente, Integer idConvocatoria,
			Integer origen, Usuario usuario) throws Exception {

		Integer idAgrupacionActSub = actSubvencionableDao.obtenerIdentificadorAgrupacion(relExpActSub.getIdActSub());

		if (idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Contratacion_Temporal) {
			try {
				relExpActSub.setFechaUltmodificacion(new Date());
				relExpActSub.setUsuarioUltmodificacion(usuario.getNombreUsuario());
				relExpActSubDao.updatePTT(relExpActSub);
				relExpActSub.getContratacionesPersonal().setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
				relExpActSub.getContratacionesPersonal().setFechaUltmodificacion(new Date());
				relExpActSub.getContratacionesPersonal().setUsuarioUltmodificacion(usuario.getNombreUsuario());
				contratacionesPersonalDao.update(relExpActSub.getContratacionesPersonal());
			} catch (Exception e) {
				logger.error("Error actualizando el estudio tecnico de PTT: " + e.getMessage());
				throw new NegocioException("error.actualizando.generico");

			}
		} else if (idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_Calidad_Destinos
				|| idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_TIC
				|| idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_Ecoetiquetas_Europea
				|| idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_Compromiso_Accesibilidad
				|| idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Programa_Compromiso_Codigo_Etico) {
			try {
				relExpActSub.setFechaUltmodificacion(new Date());
				relExpActSub.setUsuarioUltmodificacion(usuario.getNombreUsuario());
				relExpActSubDao.updatePTT(relExpActSub);
				relExpActSub.getPersonasContratadas().setFechaUltimaModificacion(new Date());
				relExpActSub.getPersonasContratadas().setUsuarioUltimaModificacion(usuario.getNombreUsuario());
				relExpActSub.getPersonasContratadas().setIdSexo(relExpActSub.getContratacionesPersonal().getIdSexo());
				relExpActSub.getPersonasContratadas().setNombrePC(relExpActSub.getContratacionesPersonal().getNombre());
				relExpActSub.getPersonasContratadas()
						.setApellido1PC(relExpActSub.getContratacionesPersonal().getApellido1());
				relExpActSub.getPersonasContratadas()
						.setApellido2PC(relExpActSub.getContratacionesPersonal().getApellido2());
				ModalidadesContrato modalidadesContrato = new ModalidadesContrato();
				modalidadesContrato
						.setIdModalidadContrato(relExpActSub.getContratacionesPersonal().getIdModalidadContrato());
				relExpActSub.getPersonasContratadas().setModalidadesContrato(modalidadesContrato);
				relExpActSub.getPersonasContratadas()
						.setEmpresaContratada(relExpActSub.getContratacionesPersonal().getEmpresaContratada());
				personasContratadasDao.update(relExpActSub.getPersonasContratadas());
			} catch (Exception e) {
				logger.error("Error actualizando el estudio tecnico de PTT: " + e.getMessage());
				throw new NegocioException("error.actualizando.generico");

			}

		} else if (idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Pertenencia_Redes) {
			try {
				relExpActSub.setFechaUltmodificacion(new Date());
				relExpActSub.setUsuarioUltmodificacion(usuario.getNombreUsuario());
				relExpActSubDao.updatePTT(relExpActSub);
				relExpActSub.getPertenenciasRedes().setFechaUltimaModificacion(new Date());
				relExpActSub.getPertenenciasRedes().setUsuarioUltimaModificacion(usuario.getNombreUsuario());
				this.pertenenciasRedesDao.update(relExpActSub.getPertenenciasRedes());

				// calculamos y actualizamos los importes
				Conceptos conceptos = this.conceptosDao
						.findSumConceptosPorRelExpActSub(relExpActSub.getIdRelExpActSub());
				relExpActSub.setImporteAdmitido(conceptos.getImporteAdmitido());
				relExpActSub.setImportePresentado(conceptos.getImportePresentado());
				relExpActSubDao.updatePTT(relExpActSub);
			} catch (Exception e) {
				logger.error("Error actualizando el estudio tecnico de PTT: " + e.getMessage());
				throw new NegocioException("error.actualizando.generico");

			}

		} else if (idAgrupacionActSub == Constantes.ID_AGRUPACION_PTT_Gastos_Creacion) {
			try {
				relExpActSub.setFechaUltmodificacion(new Date());
				relExpActSub.setUsuarioUltmodificacion(usuario.getNombreUsuario());
				relExpActSubDao.updatePTT(relExpActSub);
				relExpActSub.getGastosTuristicos().setFechaUltimaModificacion(new Date());
				relExpActSub.getGastosTuristicos().setUsuarioUltimaModificacion(usuario.getNombreUsuario());
				RelExpActSub relExpActSubGT = new RelExpActSub();
				relExpActSubGT.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
				relExpActSub.getGastosTuristicos().setRelExpActSub(relExpActSubGT);
				relExpActSub.getGastosTuristicos().setProductosTuristicos(relExpActSub.getProductosTuristicos());
				this.gastosTuristicosDao.update(relExpActSub.getGastosTuristicos());

				// calculamos y actualizamos los importes
				Conceptos conceptos = this.conceptosDao
						.findSumConceptosPorRelExpActSub(relExpActSub.getIdRelExpActSub());
				relExpActSub.setImporteAdmitido(conceptos.getImporteAdmitido());
				relExpActSub.setImportePresentado(conceptos.getImportePresentado());
				relExpActSubDao.updatePTT(relExpActSub);
			} catch (Exception e) {
				logger.error("Error actualizando el estudio tecnico de PTT: " + e.getMessage());
				throw new NegocioException("error.actualizando.generico");

			}

		}

		try {
			Date fecha = new Date();
			RelActSubMotMin relActSubMotMin = new RelActSubMotMin();
			RelActSubMotDen relActSubMotDen = new RelActSubMotDen();

			if (relExpActSub.getComboDenegacion().size() != 0) {
				this.relFacActSubvencionablesDao.removeAdmitido(idExpediente, relExpActSub);
			}

			// Update los importes en el padre
			// obtengo el padre
			ActSubvencionable actSubvencionable = actSubvencionableDao.findIdActSub(relExpActSub.getIdActSub());
			RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente,
					actSubvencionable.getIdActSubPadre());
			relExpActSubSuma.setIdExpediente(idExpediente);
			relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma, actSubvencionable.getIdActSubPadre());

			// Update los importes en datos proyecto(estudio tecnico)
			RelExpActSub relExpActSubTotalPTT = this.relExpActSubDao.sumPTT(idConvocatoria, idExpediente);
			EstudioTecnico estudioTecnicoPTT = new EstudioTecnico();
			estudioTecnicoPTT.setIdExpediente(idExpediente);
			estudioTecnicoPTT.setImportePresentado(relExpActSubTotalPTT.getImportePresentado());
			estudioTecnicoPTT.setImporteAdmitido(relExpActSubTotalPTT.getImporteAdmitido());
			estudioTecnicoPTT.setFechaUltmodificacion(new Date());
			estudioTecnicoPTT.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.estudioTecnicoDao.updateImporte(estudioTecnicoPTT);

			relActSubMotDen.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
			relActSubMotDenDao.remove(relActSubMotDen, origen);
			for (int i = 0; i < relExpActSub.getComboDenegacion().size(); i++) {
				relActSubMotDen.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
				relActSubMotDen.setIdMotivoDenegacion(
						Long.parseLong(relExpActSub.getComboDenegacion().get(i).getComboDenegacion()));
				relActSubMotDen.setFechaRegistro(fecha);
				relActSubMotDen.setUsuarioRegistro(usuario.getNombreUsuario());
				relActSubMotDenDao.add(relActSubMotDen);

			}
			relActSubMotMin.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
			relActSubMotMinDao.remove(relActSubMotMin, origen);
			for (int indice = 0; indice < relExpActSub.getComboMinoracion().size(); indice++) {
				relActSubMotMin.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
				relActSubMotMin.setIdMotivoMinoracion(
						Long.parseLong(relExpActSub.getComboMinoracion().get(indice).getComboMinoracion()));
				relActSubMotMin.setFechaRegistro(fecha);
				relActSubMotMin.setUsuarioRegistro(usuario.getNombreUsuario());
				relActSubMotMinDao.add(relActSubMotMin);
			}

			// actualizo los importes de la subvencion calculada y porcentaje a
			// null
			RelExpActSub relExpActSubCalculada = new RelExpActSub();
			relExpActSubCalculada.setIdExpediente(idExpediente);
			relExpActSubCalculada.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			relExpActSubCalculada.setFechaUltmodificacion(new Date());
			relExpActSubDao.updateImporteSubvencionCalculada(relExpActSubCalculada);

			OtrosIngresos otrosIngresos = new OtrosIngresos();
			otrosIngresos.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
			otrosIngresos.setImporte(relExpActSub.getAyudaConcedida());
			otrosIngresos.setFase(Constantes.FASE_SOLICITUD);

			OtrosIngresos otrosIngresosAux = this.otrosIngresosDao.findByIdRelExpActSub(otrosIngresos);

			if (null != otrosIngresosAux) {
				otrosIngresosDao.updateImporte(otrosIngresos);
			} else {
				otrosIngresosDao.add(otrosIngresos);
			}

		} catch (Exception e) {
			logger.error("Error actualizando el estudio tecnico de PTT: " + e.getMessage());
			throw new NegocioException("error.actualizando.importes");

		}

		return relExpActSub;

	}

	/**
	 * buscaDEC
	 * 
	 * @param relExpActSub
	 * @param idExpediente
	 * @param idConvocatoria
	 * @param idClavePrimaria
	 * @param usuario
	 * @return
	 * @throws Exception
	 */

	@Transactional
	public RelExpActSub buscaDEC(RelExpActSub relExpActSub, Integer idExpediente, Integer idConvocatoria,
			Integer idClavePrimaria, Usuario usuario) {

		// Find los datos del ayuntamiento
		relExpActSub.setIdRelExpActSub(idClavePrimaria);
		RelExpActSub relExpActSubAux = this.relExpActSubDao.findIdActSub(idClavePrimaria);
		ActSubvencionable actSubvencionableAux = this.actSubvencionableDao
				.findIdActSub(relExpActSubAux.getActSubvencionable().getIdActSub());
		Integer idActSubPadre = actSubvencionableAux.getIdActSubPadre();

		relExpActSub = this.relExpActSubDao.findDEC(relExpActSub);

		Integer idAgrupacionActSubPadre = 0;
		if ((null != idActSubPadre) && (0 != (int) idActSubPadre)) {

			idAgrupacionActSubPadre = actSubvencionableDao.obtenerIdentificadorAgrupacion(idActSubPadre);
		}

		if (Constantes.ID_AGRUPACION_DEC_Asociacion != idAgrupacionActSubPadre) {
			if (null != relExpActSub.getActAyuntamiento()) {
				String fechaAdjudicacion = UtilDate
						.convertirFechaEnString(relExpActSub.getActAyuntamiento().getFechaAdjudicacion());
				String fechaInicioAyuntamiento = UtilDate
						.convertirFechaEnString(relExpActSub.getActAyuntamiento().getFechaInicio());
				String fechaFinAyuntamiento = UtilDate
						.convertirFechaEnString(relExpActSub.getActAyuntamiento().getFechaFin());

				relExpActSub.getActAyuntamiento().setFechaAdjudicacionStr(fechaAdjudicacion);
				relExpActSub.getActAyuntamiento().setFechaInicioStr(fechaInicioAyuntamiento);
				relExpActSub.getActAyuntamiento().setFechaFinStr(fechaFinAyuntamiento);
			}
		} else {
			if (null != relExpActSub.getActAsociacion()) {
				String fechaInicioAsociacion = UtilDate
						.convertirFechaEnString(relExpActSub.getActAsociacion().getFechaInicio());
				String fechaFinAsociacion = UtilDate
						.convertirFechaEnString(relExpActSub.getActAsociacion().getFechaFin());

				relExpActSub.getActAsociacion().setFechaInicioStr(fechaInicioAsociacion);
				relExpActSub.getActAsociacion().setFechaFinStr(fechaFinAsociacion);
			}
		}

		return relExpActSub;

	}

	@Transactional
	public RelExpActSub buscaEMCO(RelExpActSub relExpActSub, Integer idExpediente, Integer idConvocatoria,
			Integer idClavePrimaria, Usuario usuario) {

		// Find los datos del ayuntamiento
		relExpActSub.setIdRelExpActSub(idClavePrimaria);
		RelExpActSub relExpActSubAux = this.relExpActSubDao.findIdActSub(idClavePrimaria);
		ActSubvencionable actSubvencionableAux = this.actSubvencionableDao
				.findIdActSub(relExpActSubAux.getActSubvencionable().getIdActSub());
		Integer idActSubPadre = actSubvencionableAux.getIdActSubPadre();

		relExpActSub = this.relExpActSubDao.findEMCO(relExpActSub);

		Integer idAgrupacionActSubPadre = 0;
		if ((null != idActSubPadre) && (0 != (int) idActSubPadre)) {

			idAgrupacionActSubPadre = actSubvencionableDao.obtenerIdentificadorAgrupacion(idActSubPadre);
		}

		if (Constantes.ID_AGRUPACION_DEC_Asociacion != idAgrupacionActSubPadre) {
			if (null != relExpActSub.getActAyuntamiento()) {
				String fechaAdjudicacion = UtilDate
						.convertirFechaEnString(relExpActSub.getActAyuntamiento().getFechaAdjudicacion());
				String fechaInicioAyuntamiento = UtilDate
						.convertirFechaEnString(relExpActSub.getActAyuntamiento().getFechaInicio());
				String fechaFinAyuntamiento = UtilDate
						.convertirFechaEnString(relExpActSub.getActAyuntamiento().getFechaFin());

				relExpActSub.getActAyuntamiento().setFechaAdjudicacionStr(fechaAdjudicacion);
				relExpActSub.getActAyuntamiento().setFechaInicioStr(fechaInicioAyuntamiento);
				relExpActSub.getActAyuntamiento().setFechaFinStr(fechaFinAyuntamiento);
			}
		} else {
			if (null != relExpActSub.getActAsociacion()) {
				String fechaInicioAsociacion = UtilDate
						.convertirFechaEnString(relExpActSub.getActAsociacion().getFechaInicio());
				String fechaFinAsociacion = UtilDate
						.convertirFechaEnString(relExpActSub.getActAsociacion().getFechaFin());

				relExpActSub.getActAsociacion().setFechaInicioStr(fechaInicioAsociacion);
				relExpActSub.getActAsociacion().setFechaFinStr(fechaFinAsociacion);
			}
		}

		return relExpActSub;

	}

	/**
	 * anyadeDEC
	 * 
	 * @param relExpActSub
	 * @param idExpediente
	 * @param idConvocatoria
	 * @param usuario
	 * @return
	 * @throws Exception
	 */

	@Transactional
	public RelExpActSub anyadeDEC(RelExpActSub relExpActSub, Integer idExpediente, Integer idConvocatoria,
			Usuario usuario) throws Exception {

		Integer idActSub = relExpActSub.getActSubvencionable().getIdActSub();
		ActSubvencionable actSubvencionableAux = this.actSubvencionableDao.findIdActSub(idActSub);
		Integer idActSubPadre = actSubvencionableAux.getIdActSubPadre();
		this.relExpActSubDao.findRelEXpActSubPorExpedienteDEC(idExpediente);
		RelExpActSub findIdActSub = this.relExpActSubDao.findIdActSubPorExpedienteNotNull(idExpediente, idActSubPadre);
		relExpActSub.setIdExpediente(idExpediente);
		relExpActSub.setUsuarioRegistro(usuario.getNombreUsuario());

		Integer idAgrupacionActSubPadre = 0;
		if ((null != idActSubPadre) && (0 != (int) idActSubPadre)) {

			idAgrupacionActSubPadre = actSubvencionableDao.obtenerIdentificadorAgrupacion(idActSubPadre);
		}

		RelActSubMotMin relActSubMotMin = new RelActSubMotMin();
		RelActSubMotDen relActSubMotDen = new RelActSubMotDen();

		// Comprobar si existe relacion con la accion subvencionable padre
		if (Constantes.ID_AGRUPACION_DEC_Asociacion != idAgrupacionActSubPadre) {
			if (null == findIdActSub) {
				// Insertamos la relacion
				this.relExpActSubDao.anyadirRelacionPadre(relExpActSub);
			}

			// Insertar relacion del nieto
			ActSubvencionable actSubvencionable = new ActSubvencionable();
			actSubvencionable.setIdActSub(relExpActSub.getActSubvencionable().getIdActSub());
			relExpActSub.setActSubvencionable(actSubvencionable);
			RelExpActSub relExpActSubNieto = this.relExpActSubDao.anyadirRelacionDEC(relExpActSub);

			// Insertar un ayuntamiento con su relacion
			ActAyuntamiento actAyuntamiento = new ActAyuntamiento();
			actAyuntamiento = relExpActSub.getActAyuntamiento();
			actAyuntamiento.setRelExpActSub(new RelExpActSub(relExpActSubNieto.getIdRelExpActSub()));
			actAyuntamiento.setFechaRegistro(new Date());
			actAyuntamiento.setUsuarioRegistro(usuario.getNombreUsuario());
			actAyuntamiento.setFechaAdjudicacionStr(
					UtilDate.convertirStringEnStringFormateado(actAyuntamiento.getFechaAdjudicacionStr()));
			actAyuntamiento
					.setFechaInicioStr(UtilDate.convertirStringEnStringFormateado(actAyuntamiento.getFechaInicioStr()));
			actAyuntamiento
					.setFechaFinStr(UtilDate.convertirStringEnStringFormateado(actAyuntamiento.getFechaFinStr()));
			actAyuntamiento.setImporteTotal(relExpActSub.getImportePresentado());
			this.actAyuntamientoDao.add(actAyuntamiento);

			for (int i = 0; i < relExpActSub.getComboDenegacion().size(); i++) {
				relActSubMotDen.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
				relActSubMotDen.setIdMotivoDenegacion(
						Long.parseLong(relExpActSub.getComboDenegacion().get(i).getComboDenegacion()));
				relActSubMotDen.setFechaRegistro(new Date());
				relActSubMotDen.setUsuarioRegistro(usuario.getNombreUsuario());
				relActSubMotDenDao.add(relActSubMotDen);

			}

			for (int indice = 0; indice < relExpActSub.getComboMinoracion().size(); indice++) {
				relActSubMotMin.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
				relActSubMotMin.setIdMotivoMinoracion(
						Long.parseLong(relExpActSub.getComboMinoracion().get(indice).getComboMinoracion()));
				relActSubMotMin.setFechaRegistro(new Date());
				relActSubMotMin.setUsuarioRegistro(usuario.getNombreUsuario());
				relActSubMotMinDao.add(relActSubMotMin);
			}

			// Update los importes en la relacion que corresponda
			RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente, idActSubPadre);
			relExpActSubSuma.setIdExpediente(idExpediente);
			relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma, idActSubPadre);
			RelExpActSub subvencionPorcentaje = new RelExpActSub();
			subvencionPorcentaje.setIdExpediente(idExpediente);
			this.relExpActSubDao.updateSubvencionPorcentaje(subvencionPorcentaje);

			// Update la relacion total
			RelExpActSub relExpActSubTotal = this.relExpActSubDao.sumAyuntamiento(idActSubPadre, idExpediente,
					idConvocatoria);
			relExpActSubTotal.setIdExpediente(idExpediente);
			relExpActSubTotal.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			relExpActSubTotal = this.relExpActSubDao.updateImporteAyuntamiento(relExpActSubTotal, idActSubPadre);

			// Update los importes en datos proyecto(estudio tecnico)
			EstudioTecnico estudioTecnico = new EstudioTecnico();
			estudioTecnico.setIdExpediente(idExpediente);
			estudioTecnico.setImportePresentado(relExpActSubTotal.getImportePresentado());
			estudioTecnico.setImporteAdmitido(relExpActSubTotal.getImporteAdmitido());
			estudioTecnico.setFechaUltmodificacion(new Date());
			estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.estudioTecnicoDao.updateImporte(estudioTecnico);

		} else {

			// Insertar relacion del nieto
			relExpActSub.setIdExpediente(idExpediente);
			ActSubvencionable actSubvencionable = new ActSubvencionable();
			actSubvencionable.setIdActSub(relExpActSub.getActSubvencionable().getIdActSubComboHijo());
			relExpActSub.getActSubvencionable().setIdActSub(idActSub);
			RelExpActSub relExpActSubNieto = this.relExpActSubDao.anyadirRelacion(relExpActSub);

			// Insertar una asociacion con su relacion
			ActAsociacion actAsociacion = new ActAsociacion();
			actAsociacion = relExpActSub.getActAsociacion();
			actAsociacion.setRelExpActSub(new RelExpActSub(relExpActSubNieto.getIdRelExpActSub()));
			actAsociacion.setFechaRegistro(new Date());
			actAsociacion.setUsuarioRegistro(usuario.getNombreUsuario());
			actAsociacion
					.setFechaInicioStr(UtilDate.convertirStringEnStringFormateado(actAsociacion.getFechaInicioStr()));
			actAsociacion.setFechaFinStr(UtilDate.convertirStringEnStringFormateado(actAsociacion.getFechaFinStr()));
			this.actAsociacionDao.add(actAsociacion);

			for (int i = 0; i < relExpActSub.getComboDenegacion().size(); i++) {
				relActSubMotDen.setIdRelExpActSub(relExpActSubNieto.getIdRelExpActSub());
				relActSubMotDen.setIdMotivoDenegacion(
						Long.parseLong(relExpActSub.getComboDenegacion().get(i).getComboDenegacion()));
				relActSubMotDen.setFechaRegistro(new Date());
				relActSubMotDen.setUsuarioRegistro(usuario.getNombreUsuario());
				relActSubMotDenDao.add(relActSubMotDen);

			}

			for (int indice = 0; indice < relExpActSub.getComboMinoracion().size(); indice++) {
				relActSubMotMin.setIdRelExpActSub(relExpActSubNieto.getIdRelExpActSub());
				relActSubMotMin.setIdMotivoMinoracion(
						Long.parseLong(relExpActSub.getComboMinoracion().get(indice).getComboMinoracion()));
				relActSubMotMin.setFechaRegistro(new Date());
				relActSubMotMin.setUsuarioRegistro(usuario.getNombreUsuario());
				relActSubMotMinDao.add(relActSubMotMin);
			}

			// Update los importes en la relacion que corresponda
			RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente, idActSubPadre);
			relExpActSubSuma.setIdExpediente(idExpediente);
			relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma, idActSubPadre);
			RelExpActSub subvencionPorcentaje = new RelExpActSub();
			subvencionPorcentaje.setIdExpediente(idExpediente);
			this.relExpActSubDao.updateSubvencionPorcentaje(subvencionPorcentaje);

			// Update los importes en datos proyecto(estudio tecnico)
			EstudioTecnico estudioTecnico = new EstudioTecnico();
			estudioTecnico.setIdExpediente(idExpediente);
			estudioTecnico.setImportePresentado(relExpActSubSuma.getImportePresentado());
			estudioTecnico.setImporteAdmitido(relExpActSubSuma.getImporteAdmitido());
			estudioTecnico.setFechaUltmodificacion(new Date());
			estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.estudioTecnicoDao.updateImporte(estudioTecnico);
		}

		return relExpActSub;

	}

	@Transactional
	public RelExpActSub anyadeEMCO(RelExpActSub relExpActSub, Integer idExpediente, Integer idConvocatoria,
			Usuario usuario) throws Exception {

		Integer idActSub = relExpActSub.getActSubvencionable().getIdActSub();
		ActSubvencionable actSubvencionableAux = this.actSubvencionableDao.findIdActSub(idActSub);
		Integer idActSubPadre = actSubvencionableAux.getIdActSubPadre();
		this.relExpActSubDao.findRelEXpActSubPorExpedienteEMCO(idExpediente);
		RelExpActSub findIdActSub = this.relExpActSubDao.findIdActSubPorExpedienteNotNullEMCO(idExpediente,
				idActSubPadre);
		relExpActSub.setIdExpediente(idExpediente);
		relExpActSub.setUsuarioRegistro(usuario.getNombreUsuario());

		Integer idAgrupacionActSubPadre = 0;
		if ((null != idActSubPadre) && (0 != (int) idActSubPadre)) {

			idAgrupacionActSubPadre = actSubvencionableDao.obtenerIdentificadorAgrupacion(idActSubPadre);
		}

		RelActSubMotMin relActSubMotMin = new RelActSubMotMin();
		RelActSubMotDen relActSubMotDen = new RelActSubMotDen();

		// Comprobar si existe relacion con la accion subvencionable padre
		if (Constantes.ID_AGRUPACION_EMCO_AYUNTAMIENTO.equals(idAgrupacionActSubPadre)) {
			if (null == findIdActSub) {
				// Insertamos la relacion
				this.relExpActSubDao.anyadirRelacionPadre(relExpActSub);
			}

			// Insertar relacion del nieto
			ActSubvencionable actSubvencionable = new ActSubvencionable();
			actSubvencionable.setIdActSub(relExpActSub.getActSubvencionable().getIdActSub());
			relExpActSub.setActSubvencionable(actSubvencionable);
			RelExpActSub relExpActSubNieto = this.relExpActSubDao.anyadirRelacionEMCO(relExpActSub);

			// Insertar un ayuntamiento con su relacion
			ActAyuntamiento actAyuntamiento = new ActAyuntamiento();
			actAyuntamiento = relExpActSub.getActAyuntamiento();
			actAyuntamiento.setRelExpActSub(new RelExpActSub(relExpActSubNieto.getIdRelExpActSub()));
			actAyuntamiento.setFechaRegistro(new Date());
			actAyuntamiento.setUsuarioRegistro(usuario.getNombreUsuario());
			actAyuntamiento.setFechaAdjudicacionStr(
					UtilDate.convertirStringEnStringFormateado(actAyuntamiento.getFechaAdjudicacionStr()));
			actAyuntamiento
					.setFechaInicioStr(UtilDate.convertirStringEnStringFormateado(actAyuntamiento.getFechaInicioStr()));
			actAyuntamiento
					.setFechaFinStr(UtilDate.convertirStringEnStringFormateado(actAyuntamiento.getFechaFinStr()));
			actAyuntamiento.setImporteTotal(relExpActSub.getImportePresentado());
			this.actAyuntamientoDao.addEMCO(actAyuntamiento);

			for (int i = 0; i < relExpActSub.getComboDenegacion().size(); i++) {
				relActSubMotDen.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
				relActSubMotDen.setIdMotivoDenegacion(
						Long.parseLong(relExpActSub.getComboDenegacion().get(i).getComboDenegacion()));
				relActSubMotDen.setFechaRegistro(new Date());
				relActSubMotDen.setUsuarioRegistro(usuario.getNombreUsuario());
				relActSubMotDenDao.add(relActSubMotDen);

			}

			for (int indice = 0; indice < relExpActSub.getComboMinoracion().size(); indice++) {
				relActSubMotMin.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
				relActSubMotMin.setIdMotivoMinoracion(
						Long.parseLong(relExpActSub.getComboMinoracion().get(indice).getComboMinoracion()));
				relActSubMotMin.setFechaRegistro(new Date());
				relActSubMotMin.setUsuarioRegistro(usuario.getNombreUsuario());
				relActSubMotMinDao.add(relActSubMotMin);
			}

			// Update los importes en la relacion que corresponda
			RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente, idActSubPadre);
			relExpActSubSuma.setIdExpediente(idExpediente);
			relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma, idActSubPadre);
			RelExpActSub subvencionPorcentaje = new RelExpActSub();
			subvencionPorcentaje.setIdExpediente(idExpediente);
			this.relExpActSubDao.updateSubvencionPorcentaje(subvencionPorcentaje);

			// Update la relacion total
			RelExpActSub relExpActSubTotal = this.relExpActSubDao.sumAyuntamientoEMCO(idActSubPadre, idExpediente,
					idConvocatoria);
			relExpActSubTotal.setIdExpediente(idExpediente);
			relExpActSubTotal.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			relExpActSubTotal = this.relExpActSubDao.updateImporteAyuntamiento(relExpActSubTotal, idActSubPadre);

			// Update los importes en datos proyecto(estudio tecnico)
			EstudioTecnico estudioTecnico = new EstudioTecnico();
			estudioTecnico.setIdExpediente(idExpediente);
			estudioTecnico.setImportePresentado(relExpActSubTotal.getImportePresentado());
			estudioTecnico.setImporteAdmitido(relExpActSubTotal.getImporteAdmitido());
			estudioTecnico.setFechaUltmodificacion(new Date());
			estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.estudioTecnicoDao.updateImporte(estudioTecnico);

		} else {

			// Insertar relacion del nieto
			relExpActSub.setIdExpediente(idExpediente);
			ActSubvencionable actSubvencionable = new ActSubvencionable();
			actSubvencionable.setIdActSub(relExpActSub.getActSubvencionable().getIdActSubComboHijo());
			relExpActSub.getActSubvencionable().setIdActSub(idActSub);
			RelExpActSub relExpActSubNieto = this.relExpActSubDao.anyadirRelacion(relExpActSub);

			relExpActSubNieto.setIdExpediente(idExpediente);

			// Buscar si tiene padre
			Boolean existeRelacionPadre = this.relExpActSubDao.existeRelacionPadre(relExpActSubNieto);

			if (!existeRelacionPadre) {
				Integer nuevoPadre = this.relExpActSubDao
						.findRelExpActSubEmpreHijoEMCO(relExpActSubNieto.getActSubvencionable().getIdActSub());

				RelExpActSub relExpActSubAux = new RelExpActSub();
				relExpActSubAux.setIdExpediente(idExpediente);
				relExpActSubAux.setUsuarioRegistro(usuario.getNombreUsuario());
				relExpActSubAux.setActSubvencionable(new ActSubvencionable(nuevoPadre));
				this.relExpActSubDao.anyadirRelacion(relExpActSubAux);
			}

			for (int i = 0; i < relExpActSub.getComboDenegacion().size(); i++) {
				relActSubMotDen.setIdRelExpActSub(relExpActSubNieto.getIdRelExpActSub());
				relActSubMotDen.setIdMotivoDenegacion(
						Long.parseLong(relExpActSub.getComboDenegacion().get(i).getComboDenegacion()));
				relActSubMotDen.setFechaRegistro(new Date());
				relActSubMotDen.setUsuarioRegistro(usuario.getNombreUsuario());
				relActSubMotDenDao.add(relActSubMotDen);

			}

			for (int indice = 0; indice < relExpActSub.getComboMinoracion().size(); indice++) {
				relActSubMotMin.setIdRelExpActSub(relExpActSubNieto.getIdRelExpActSub());
				relActSubMotMin.setIdMotivoMinoracion(
						Long.parseLong(relExpActSub.getComboMinoracion().get(indice).getComboMinoracion()));
				relActSubMotMin.setFechaRegistro(new Date());
				relActSubMotMin.setUsuarioRegistro(usuario.getNombreUsuario());
				relActSubMotMinDao.add(relActSubMotMin);
			}
		}

		return relExpActSub;

	}

	/**
	 * modificaDEC
	 * 
	 * @param relExpActSub
	 * @param idExpediente
	 * @param idConvocatoria
	 * @param usuario
	 * @return
	 * @throws Exception
	 */
	@Override
	@Transactional
	public RelExpActSub modificaDEC(RelExpActSub relExpActSub, Integer idConvocatoria, Integer idExpediente,
			Integer origen, Usuario usuario) throws Exception {

		RelActSubMotMin relActSubMotMin = new RelActSubMotMin();
		RelActSubMotDen relActSubMotDen = new RelActSubMotDen();
		Integer idActSub = relExpActSub.getActSubvencionable().getIdActSub();

		ActSubvencionable actSubvencionableAux = this.actSubvencionableDao.findIdActSub(idActSub);
		Integer idActSubPadre = actSubvencionableAux.getIdActSubPadre();
		relExpActSub.setUsuarioUltmodificacion(usuario.getNombreUsuario());

		Integer idAgrupacionActSubPadre = 0;
		if ((null != idActSubPadre) && (0 != (int) idActSubPadre)) {

			idAgrupacionActSubPadre = actSubvencionableDao.obtenerIdentificadorAgrupacion(idActSubPadre);
		}

		if (relExpActSub.getComboDenegacion().size() != 0) {
			this.relFacActSubvencionablesDao.removeAdmitido(idExpediente, relExpActSub);
		}

		// Comprobar si existe relacion con la accion subvencionable padre
		if (Constantes.ID_AGRUPACION_DEC_Asociacion != idAgrupacionActSubPadre) {
			relExpActSub.getActAyuntamiento().setFechaAdjudicacionStr(UtilDate
					.convertirStringEnStringFormateado(relExpActSub.getActAyuntamiento().getFechaAdjudicacionStr()));
			relExpActSub.getActAyuntamiento().setFechaInicioStr(
					UtilDate.convertirStringEnStringFormateado(relExpActSub.getActAyuntamiento().getFechaInicioStr()));
			relExpActSub.getActAyuntamiento().setFechaFinStr(
					UtilDate.convertirStringEnStringFormateado(relExpActSub.getActAyuntamiento().getFechaFinStr()));
			relExpActSub.getActAyuntamiento().setImporteTotal(relExpActSub.getImportePresentado());
			this.actAyuntamientoDao.update(relExpActSub);
			relExpActSub.setIdExpediente(idExpediente);
			this.relExpActSubDao.updateDEC(relExpActSub);
			relExpActSub.setIdActSub(idActSubPadre);
			this.updateImportePresentadoAdmtidoPadre(relExpActSub);
			ActSubvencionable actSubvencionableAbuelo = this.actSubvencionableDao.findIdActSub(idActSubPadre);
			Integer idActSubAbuelo = actSubvencionableAbuelo.getIdActSubPadre();
			relExpActSub.setIdActSub(idActSubAbuelo);

			// Update los importes en la relacion que corresponda
			RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente, idActSubPadre);
			relExpActSubSuma.setIdExpediente(idExpediente);
			relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma, idActSubPadre);
			RelExpActSub subvencionPorcentaje = new RelExpActSub();
			subvencionPorcentaje.setIdExpediente(idExpediente);
			this.relExpActSubDao.updateSubvencionPorcentaje(subvencionPorcentaje);

			// Update la relacion total
			RelExpActSub relExpActSubTotal = this.relExpActSubDao.sumAyuntamiento(idActSubPadre, idExpediente,
					idConvocatoria);
			relExpActSubTotal.setIdExpediente(idExpediente);
			relExpActSubTotal.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			relExpActSubTotal = this.relExpActSubDao.updateImporteAyuntamiento(relExpActSubTotal, idActSubPadre);

			// Update los importes en datos proyecto(estudio tecnico)
			EstudioTecnico estudioTecnico = new EstudioTecnico();
			estudioTecnico.setIdExpediente(idExpediente);
			estudioTecnico.setImportePresentado(relExpActSubTotal.getImportePresentado());
			estudioTecnico.setImporteAdmitido(relExpActSubTotal.getImporteAdmitido());
			this.estudioTecnicoDao.updateImporte(estudioTecnico);

		} else {
			relExpActSub.getActAsociacion().setFechaInicioStr(
					UtilDate.convertirStringEnStringFormateado(relExpActSub.getActAsociacion().getFechaInicioStr()));
			relExpActSub.getActAsociacion().setFechaFinStr(
					UtilDate.convertirStringEnStringFormateado(relExpActSub.getActAsociacion().getFechaFinStr()));
			this.actAsociacionDao.update(relExpActSub);
			relExpActSub.setIdExpediente(idExpediente);
			this.relExpActSubDao.updateDECsinImportes(relExpActSub);

			// Update los importes en la relacion que corresponda
			RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente, idActSubPadre);
			relExpActSubSuma.setIdExpediente(idExpediente);
			relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma, idActSubPadre);

			RelExpActSub subvencionPorcentaje = new RelExpActSub();
			subvencionPorcentaje.setIdExpediente(idExpediente);
			this.relExpActSubDao.updateSubvencionPorcentaje(subvencionPorcentaje);

			// Update los importes en datos proyecto(estudio tecnico)
			EstudioTecnico estudioTecnico = new EstudioTecnico();
			estudioTecnico.setIdExpediente(idExpediente);
			estudioTecnico.setImportePresentado(relExpActSubSuma.getImportePresentado());
			estudioTecnico.setImporteAdmitido(relExpActSubSuma.getImporteAdmitido());
			this.estudioTecnicoDao.updateImporte(estudioTecnico);
		}
		relActSubMotDen.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
		relActSubMotDenDao.remove(relActSubMotDen, origen);
		for (int i = 0; i < relExpActSub.getComboDenegacion().size(); i++) {
			relActSubMotDen.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
			relActSubMotDen.setIdMotivoDenegacion(
					Long.parseLong(relExpActSub.getComboDenegacion().get(i).getComboDenegacion()));
			relActSubMotDen.setFechaRegistro(new Date());
			relActSubMotDen.setUsuarioRegistro(usuario.getNombreUsuario());
			relActSubMotDenDao.add(relActSubMotDen);

		}
		relActSubMotMin.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
		relActSubMotMinDao.remove(relActSubMotMin, origen);
		for (int indice = 0; indice < relExpActSub.getComboMinoracion().size(); indice++) {
			relActSubMotMin.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
			relActSubMotMin.setIdMotivoMinoracion(
					Long.parseLong(relExpActSub.getComboMinoracion().get(indice).getComboMinoracion()));
			relActSubMotMin.setFechaRegistro(new Date());
			relActSubMotMin.setUsuarioRegistro(usuario.getNombreUsuario());
			relActSubMotMinDao.add(relActSubMotMin);
		}

		return relExpActSub;

	}

	/**
	 * borraDEC
	 * 
	 * @param relExpActSub
	 * @param idConvocatoria
	 * @param idExpediente
	 * @param idClavePrimaria
	 * @param usuario
	 * @return
	 * @throws Exception
	 */
	@Override
	@Transactional
	public RelExpActSub borraDEC(RelExpActSub relExpActSub, Integer idConvocatoria, Integer idExpediente,
			Integer idClavePrimaria, Integer origen, Usuario usuario) throws Exception {

		RelActSubMotMin relActSubMotMin = new RelActSubMotMin();
		RelActSubMotDen relActSubMotDen = new RelActSubMotDen();

		Integer idActSubvencionableAgrupacion = this.relExpActSubDao.findIdActSubAgrupacionPorExpediente(idExpediente);
		if (Constantes.ID_AGRUPACION_DEC_Asociacion != idActSubvencionableAgrupacion) {
			// Encontrar el id para eliminar la relacion
			relExpActSub.setIdRelExpActSub(idClavePrimaria);
			ActAyuntamiento actAyuntamiento = this.actAyuntamientoDao.find(relExpActSub);
			Integer idRelacion = relExpActSub.getIdRelExpActSub();
			relExpActSub = this.relExpActSubDao.findIdActSub(idRelacion);
			Integer idActSub = relExpActSub.getActSubvencionable().getIdActSub();
			relExpActSub.setIdRelExpActSub(actAyuntamiento.getRelExpActSub().getIdRelExpActSub());

			relActSubMotDen.setIdRelExpActSub(idClavePrimaria);
			relActSubMotDenDao.remove(relActSubMotDen, origen);
			relActSubMotMin.setIdRelExpActSub(idClavePrimaria);
			relActSubMotMinDao.remove(relActSubMotMin, origen);

			// Eliminar el ayuntamiento
			this.actAyuntamientoDao.remove(actAyuntamiento);

			// Eliminar la relacion
			this.relExpActSubDao.remove(relExpActSub);

			// Update los importes en la relacion que corresponda
			ActSubvencionable actSubvencionable = this.actSubvencionableDao.findIdActSub(idActSub);
			Integer idActSubPadre = actSubvencionable.getIdActSubPadre();
			RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente, idActSubPadre);
			relExpActSubSuma.setIdExpediente(idExpediente);
			relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma, idActSubPadre);
			RelExpActSub subvencionPorcentaje = new RelExpActSub();
			subvencionPorcentaje.setIdExpediente(idExpediente);
			this.relExpActSubDao.updateSubvencionPorcentaje(subvencionPorcentaje);

			// Update la relacion total
			RelExpActSub relExpActSubTotal = this.relExpActSubDao.sumAyuntamiento(idActSubPadre, idExpediente,
					idConvocatoria);
			relExpActSubTotal.setIdExpediente(idExpediente);
			relExpActSubTotal.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			relExpActSubTotal = this.relExpActSubDao.updateImporteAyuntamiento(relExpActSubTotal, idActSubPadre);

			// Update los importes en datos proyecto(estudio tecnico)
			EstudioTecnico estudioTecnico = new EstudioTecnico();
			estudioTecnico.setIdExpediente(idExpediente);
			estudioTecnico.setImportePresentado(relExpActSubTotal.getImportePresentado());
			estudioTecnico.setImporteAdmitido(relExpActSubTotal.getImporteAdmitido());
			estudioTecnico.setFechaUltmodificacion(new Date());
			estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.estudioTecnicoDao.updateImporte(estudioTecnico);
		} else {
			List<Conceptos> listaConceptos = this.conceptosDao.findConceptosPorRelExpActSub(idClavePrimaria);
			if (listaConceptos.isEmpty()) {
				ActAsociacion actAsociacion = new ActAsociacion();
				relExpActSub = this.relExpActSubDao.findIdActSub(idClavePrimaria);
				Integer idActSub = relExpActSub.getActSubvencionable().getIdActSub();
				relExpActSub.setIdRelExpActSub(idClavePrimaria);
				actAsociacion.setRelExpActSub(relExpActSub);

				relActSubMotDen.setIdRelExpActSub(idClavePrimaria);
				relActSubMotDenDao.remove(relActSubMotDen, origen);
				relActSubMotMin.setIdRelExpActSub(idClavePrimaria);
				relActSubMotMinDao.remove(relActSubMotMin, origen);
				// Eliminar la asociacion
				this.actAsociacionDao.remove(actAsociacion);

				// Eliminar la relacion
				this.relExpActSubDao.remove(relExpActSub);

				// Update los importes en la relacion que corresponda
				ActSubvencionable actSubvencionable = this.actSubvencionableDao.findIdActSub(idActSub);
				Integer idActSubPadre = actSubvencionable.getIdActSubPadre();
				RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente, idActSubPadre);
				relExpActSubSuma.setIdExpediente(idExpediente);
				relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
				this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma, idActSubPadre);
				RelExpActSub subvencionPorcentaje = new RelExpActSub();
				subvencionPorcentaje.setIdExpediente(idExpediente);
				this.relExpActSubDao.updateSubvencionPorcentaje(subvencionPorcentaje);

				// Update los importes en datos proyecto(estudio tecnico)
				EstudioTecnico estudioTecnico = new EstudioTecnico();
				estudioTecnico.setIdExpediente(idExpediente);
				estudioTecnico.setImportePresentado(relExpActSubSuma.getImportePresentado());
				estudioTecnico.setImporteAdmitido(relExpActSubSuma.getImporteAdmitido());
				estudioTecnico.setFechaUltmodificacion(new Date());
				estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
				this.estudioTecnicoDao.updateImporte(estudioTecnico);
			} else {
				throw new NegocioException("error.conceptos");
			}
		}

		return relExpActSub;

	}

	/**
	 * modificaOTC
	 * 
	 * @param relExpActSub
	 * @param idExpediente
	 * @param idConvocatoria
	 * @param usuario
	 * @return
	 * @throws Exception
	 */
	@Override
	@Transactional
	public RelExpActSub modificaOTC(RelExpActSub relExpActSub, Integer idExpediente, Integer idConvocatoria,
			Usuario usuario) throws Exception {

		relExpActSub.setUsuarioUltmodificacion(usuario.getNombreUsuario());

		// Update los importes en la relacion que corresponda
		relExpActSub.setIdExpediente(idExpediente);
		this.relExpActSubDao.updateOTC(relExpActSub);

		// Sumamos los importes de la relacion que corresponda
		RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumOTC(relExpActSub.getIdRelExpActSub());

		// Update los importes en datos proyecto(estudio tecnico)
		EstudioTecnico estudioTecnico = new EstudioTecnico();
		estudioTecnico.setIdExpediente(idExpediente);
		estudioTecnico.setImportePresentado(relExpActSubSuma.getImportePresentado());
		estudioTecnico.setImporteAdmitido(relExpActSubSuma.getImporteAdmitido());
		estudioTecnico.setFechaUltmodificacion(new Date());
		estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
		this.estudioTecnicoDao.updateImporte(estudioTecnico);

		return relExpActSub;

	}

	/**
	 * modificaOMIC
	 * 
	 * @param relExpActSub
	 * @param idExpediente
	 * @param usuario
	 * @return
	 * @throws Exception
	 */
	@Override
	@Transactional
	public RelExpActSub modificaOMIC(RelExpActSub relExpActSub, Integer idExpediente, Usuario usuario)
			throws Exception {

		relExpActSub.setUsuarioUltmodificacion(usuario.getNombreUsuario());

		// // Update los importes en la relacion que corresponda
		relExpActSub.setIdExpediente(idExpediente);
		this.relExpActSubDao.updateOMIC(relExpActSub);

		if (relExpActSub.getActSubvencionable() != null
				&& relExpActSub.getActSubvencionable().getIdActSubPadre() != 0) {
			RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente,
					relExpActSub.getActSubvencionable().getIdActSubPadre());
			relExpActSubSuma.setIdExpediente(idExpediente);
			relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma,
					relExpActSub.getActSubvencionable().getIdActSubPadre());
		}

		// // Update los importes en datos proyecto(estudio tecnico)
		RelExpActSub relExpActSubTotalOMIC = this.relExpActSubDao.sumOMIC(idExpediente);
		EstudioTecnico estudioTecnico = new EstudioTecnico();
		estudioTecnico.setIdExpediente(idExpediente);
		estudioTecnico.setImportePresentado(relExpActSubTotalOMIC.getImportePresentado());
		estudioTecnico.setImporteAdmitido(relExpActSubTotalOMIC.getImporteAdmitido());
		estudioTecnico.setFechaUltmodificacion(new Date());
		estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
		this.estudioTecnicoDao.updateImporte(estudioTecnico);

		return relExpActSub;

	}

	public JQGridResponseDto<RelExpActSub> filterJustificacion(RelExpActSub filterRelFacActSubvencionables,
			JQGridRequestDto jqGridRequestDto, boolean startsWith) {
		List<RelExpActSub> listaRelFacActSubvencionables = this.relExpActSubDao
				.findAllLikeJustificacion(filterRelFacActSubvencionables, jqGridRequestDto, false);
		Long recordNum = this.relExpActSubDao.findAllLikeCountJustificacion(
				filterRelFacActSubvencionables != null ? filterRelFacActSubvencionables : new RelExpActSub(), false);

		return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelFacActSubvencionables);
	}

	@Override
	public RelExpActSub saveDatosJustificacion(Integer idExpediente, Integer idConvocatoria, RelExpActSub relExpActSub,
			Integer origen, Usuario usuario) {

		Date fecha = new Date();

		Convocatorias convocatoria = new Convocatorias();
		convocatoria.setIdConvocatoria(idConvocatoria);
		convocatoria = this.convocatoriasDao.find(convocatoria);

		RelActSubMotDen relActSubMotDen = new RelActSubMotDen();
		relActSubMotDen.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
		relActSubMotDenDao.remove(relActSubMotDen, origen);

		for (int i = 0; i < relExpActSub.getComboDenegacion().size(); i++) {
			relActSubMotDen.setFechaRegistro(fecha);
			relActSubMotDen.setUsuarioRegistro(usuario.getNombreUsuario());
			relActSubMotDen.setIdMotivoDenegacion(relExpActSub.getComboDenegacion().get(i).getIdMotivoDenegacion());
			relActSubMotDen.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
			relActSubMotDenDao.add(relActSubMotDen);
		}

		if (relExpActSub.getComboDenegacion().size() != 0) {
			this.relFacActSubvencionablesDao.removeAdmitidoJus(idExpediente, relExpActSub);
		}

		RelActSubMotMin relActSubMotMin = new RelActSubMotMin();
		relActSubMotMin.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
		relActSubMotMinDao.remove(relActSubMotMin, origen);

		for (int x = 0; x < relExpActSub.getComboMinoracion().size(); x++) {
			relActSubMotMin.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
			relActSubMotMin.setIdMotivoMinoracion(relExpActSub.getComboMinoracion().get(x).getIdMotivoMinoracion());
			relActSubMotMin.setUsuarioRegistro(usuario.getNombreUsuario());
			relActSubMotMin.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			relActSubMotMin.setFechaRegistro(fecha);
			relActSubMotMin.setFechaUltmodificacion(fecha);
			this.relActSubMotMinDao.add(relActSubMotMin);
		}

		OtrosIngresos otrosIngresos = new OtrosIngresos();
		otrosIngresos.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
		otrosIngresos.setImporte(relExpActSub.getAyudaConcedida());
		otrosIngresos.setFase(Constantes.FASE_JUSTIFICACION);

		OtrosIngresos otrosIngresosAux = this.otrosIngresosDao.findByIdRelExpActSub(otrosIngresos);

		if (null != otrosIngresosAux) {
			otrosIngresosDao.updateImporte(otrosIngresos);
		} else {
			otrosIngresosDao.add(otrosIngresos);
		}

		if (relExpActSub.getComboDenegacion().size() != 0) {
			relExpActSub.setCheckDenegacion(true);
		} else {
			relExpActSub.setCheckDenegacion(false);
		}

		if (relExpActSub.getComboMinoracion().size() != 0) {
			relExpActSub.setCheckMinoracion(true);
		} else {
			relExpActSub.setCheckMinoracion(false);
		}

		RelExpActSub relExpActSubAux = this.sumTotalesJus(idExpediente);
		this.facturasService.updatearImportesDatosProyecto(idExpediente, usuario, relExpActSubAux);

		return this.relExpActSubDao.saveDatosJustificacion(idExpediente, relExpActSub, usuario);
	}

	@Override
	public List<RelExpActSub> findExentoPorExpediente(Integer idExpediente) {
		return this.relExpActSubDao.findExentoPorExpediente(idExpediente);
	}

	@Override
	public List<RelExpActSub> filterDECTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {

		return (List<RelExpActSub>) this.relExpActSubDao.filterDECTer(filterActSub, jqGridRequestDto, false);
	}

	@Override
	public List<RelExpActSub> filterOMICTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {

		return (List<RelExpActSub>) this.relExpActSubDao.filterOMICTer(filterActSub, jqGridRequestDto, false);
	}

	@Override
	public List<MarcarInspeccionableAct> filterConConceptosTer(RelExpActSub filterActSub,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {

		return (List<MarcarInspeccionableAct>) this.relExpActSubDao.filterConConceptosTer(filterActSub,
				jqGridRequestDto, false);
	}

	@Override
	public List<RelExpActSub> filterEMETTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {

		return (List<RelExpActSub>) this.relExpActSubDao.filterEMETTer(filterActSub, jqGridRequestDto, false);
	}

	@Override
	public List<RelExpActSub> filterPTTTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {

		return (List<RelExpActSub>) this.relExpActSubDao.filterPTTTer(filterActSub, jqGridRequestDto, false);
	}

	@Override
	public List<RelExpActSub> filterOTCTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {

		return (List<RelExpActSub>) this.relExpActSubDao.filterOTCTer(filterActSub, jqGridRequestDto, false);
	}

	@Override
	public List<RelExpActSub> filterMECTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {

		return (List<RelExpActSub>) this.relExpActSubDao.filterMECTer(filterActSub, jqGridRequestDto, false);
	}

	@Override
	public List<RelExpActSub> filterJustificacionTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {

		return (List<RelExpActSub>) this.relExpActSubDao.filterJustificacionTer(filterActSub, jqGridRequestDto, false);
	}

	@Override
	public void recalcularImportePresentado(Integer idExpediente, Integer exento) {

		List<RelExpActSub> listaImportes = this.relExpActSubDao.importesPorExento(idExpediente, exento);

		if (listaImportes.size() != 0) {
			ActSubvencionable idActSubPadre = this.actSubvencionableDao
					.findIdActSub(listaImportes.get(0).getIdActSub());

			Float presentado = (float) 0;

			for (RelExpActSub relexpactsub : listaImportes) {
				this.relExpActSubDao.updateImportesPorExento(relexpactsub);

				if (relexpactsub.getImportePresentado() != null) {
					presentado = presentado
							+ relexpactsub.getImportePresentado().setScale(2, RoundingMode.DOWN).floatValue();
				}
			}

			BigDecimal presentadoTotal = new BigDecimal(presentado);

			RelExpActSub relExpActSubPadre = this.relExpActSubDao.findPorIdActSubPadre(idActSubPadre.getIdActSubPadre(),
					idExpediente);

			this.relExpActSubDao.updateImportesPadre(relExpActSubPadre, presentadoTotal);

			this.relExpActSubDao.updateImportesProyecto(presentadoTotal, idExpediente);
		}
	}

	public RelExpActSub modificaEMCO(RelExpActSub relExpActSub, Integer idConvocatoria, Integer idExpediente,
			Integer origen, Usuario usuario) {

		RelActSubMotMin relActSubMotMin = new RelActSubMotMin();
		RelActSubMotDen relActSubMotDen = new RelActSubMotDen();
		Integer idActSub = relExpActSub.getActSubvencionable().getIdActSub();

		ActSubvencionable actSubvencionableAux = this.actSubvencionableDao.findIdActSub(idActSub);
		Integer idActSubPadre = actSubvencionableAux.getIdActSubPadre();
		relExpActSub.setUsuarioUltmodificacion(usuario.getNombreUsuario());

		Integer idAgrupacionActSubPadre = 0;
		if ((null != idActSubPadre) && (0 != (int) idActSubPadre)) {

			idAgrupacionActSubPadre = actSubvencionableDao.obtenerIdentificadorAgrupacion(idActSubPadre);
		}

		// Comprobar si existe relacion con la accion subvencionable padre
		if (Constantes.ID_AGRUPACION_DEC_Asociacion != idAgrupacionActSubPadre) {
			relExpActSub.getActAyuntamiento().setFechaAdjudicacionStr(UtilDate
					.convertirStringEnStringFormateado(relExpActSub.getActAyuntamiento().getFechaAdjudicacionStr()));
			relExpActSub.getActAyuntamiento().setFechaInicioStr(
					UtilDate.convertirStringEnStringFormateado(relExpActSub.getActAyuntamiento().getFechaInicioStr()));
			relExpActSub.getActAyuntamiento().setFechaFinStr(
					UtilDate.convertirStringEnStringFormateado(relExpActSub.getActAyuntamiento().getFechaFinStr()));
			relExpActSub.getActAyuntamiento().setImporteTotal(relExpActSub.getImportePresentado());
			this.actAyuntamientoDao.updateEMCO(relExpActSub);
			relExpActSub.setIdExpediente(idExpediente);
			this.relExpActSubDao.updateEMCORelActSub(relExpActSub);
			relExpActSub.setIdActSub(idActSubPadre);
			this.updateImportePresentadoAdmtidoPadre(relExpActSub);
			ActSubvencionable actSubvencionableAbuelo = this.actSubvencionableDao.findIdActSub(idActSubPadre);
			Integer idActSubAbuelo = actSubvencionableAbuelo.getIdActSubPadre();
			relExpActSub.setIdActSub(idActSubAbuelo);

			// Update los importes en la relacion que corresponda
			RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente, idActSubPadre);
			relExpActSubSuma.setIdExpediente(idExpediente);
			relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma, idActSubPadre);
			RelExpActSub subvencionPorcentaje = new RelExpActSub();
			subvencionPorcentaje.setIdExpediente(idExpediente);
			this.relExpActSubDao.updateSubvencionPorcentaje(subvencionPorcentaje);

			// Update la relacion total
			RelExpActSub relExpActSubTotal = this.relExpActSubDao.sumAyuntamientoEMCO(idActSubPadre, idExpediente,
					idConvocatoria);
			relExpActSubTotal.setIdExpediente(idExpediente);
			relExpActSubTotal.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			relExpActSubTotal = this.relExpActSubDao.updateImporteAyuntamiento(relExpActSubTotal, idActSubPadre);

			// Update los importes en datos proyecto(estudio tecnico)
			EstudioTecnico estudioTecnico = new EstudioTecnico();
			estudioTecnico.setIdExpediente(idExpediente);
			estudioTecnico.setImportePresentado(relExpActSubTotal.getImportePresentado());
			estudioTecnico.setImporteAdmitido(relExpActSubTotal.getImporteAdmitido());
			this.estudioTecnicoDao.updateImporte(estudioTecnico);

		} else {
			relExpActSub.getActAsociacion().setFechaInicioStr(
					UtilDate.convertirStringEnStringFormateado(relExpActSub.getActAsociacion().getFechaInicioStr()));
			relExpActSub.getActAsociacion().setFechaFinStr(
					UtilDate.convertirStringEnStringFormateado(relExpActSub.getActAsociacion().getFechaFinStr()));
			this.actAsociacionDao.update(relExpActSub);
			relExpActSub.setIdExpediente(idExpediente);
			this.relExpActSubDao.updateDECsinImportes(relExpActSub);

			// Update los importes en la relacion que corresponda
			RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente, idActSubPadre);
			relExpActSubSuma.setIdExpediente(idExpediente);
			relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma, idActSubPadre);

			RelExpActSub subvencionPorcentaje = new RelExpActSub();
			subvencionPorcentaje.setIdExpediente(idExpediente);
			this.relExpActSubDao.updateSubvencionPorcentaje(subvencionPorcentaje);

			// Update los importes en datos proyecto(estudio tecnico)
			EstudioTecnico estudioTecnico = new EstudioTecnico();
			estudioTecnico.setIdExpediente(idExpediente);
			estudioTecnico.setImportePresentado(relExpActSubSuma.getImportePresentado());
			estudioTecnico.setImporteAdmitido(relExpActSubSuma.getImporteAdmitido());
			this.estudioTecnicoDao.updateImporte(estudioTecnico);
		}
		relActSubMotDen.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
		relActSubMotDenDao.remove(relActSubMotDen, origen);
		for (int i = 0; i < relExpActSub.getComboDenegacion().size(); i++) {
			relActSubMotDen.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
			relActSubMotDen.setIdMotivoDenegacion(
					Long.parseLong(relExpActSub.getComboDenegacion().get(i).getComboDenegacion()));
			relActSubMotDen.setFechaRegistro(new Date());
			relActSubMotDen.setUsuarioRegistro(usuario.getNombreUsuario());
			relActSubMotDenDao.add(relActSubMotDen);

		}
		relActSubMotMin.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
		relActSubMotMinDao.remove(relActSubMotMin, origen);
		for (int indice = 0; indice < relExpActSub.getComboMinoracion().size(); indice++) {
			relActSubMotMin.setIdRelExpActSub(relExpActSub.getIdRelExpActSub());
			relActSubMotMin.setIdMotivoMinoracion(
					Long.parseLong(relExpActSub.getComboMinoracion().get(indice).getComboMinoracion()));
			relActSubMotMin.setFechaRegistro(new Date());
			relActSubMotMin.setUsuarioRegistro(usuario.getNombreUsuario());
			relActSubMotMinDao.add(relActSubMotMin);
		}

		return relExpActSub;
	}

	@Override
	public RelExpActSub borraEMCO(RelExpActSub relExpActSub, Integer idConvocatoria, Integer idExpediente,
			Integer idClavePrimaria, int origen, Usuario usuario) {
		RelActSubMotMin relActSubMotMin = new RelActSubMotMin();
		RelActSubMotDen relActSubMotDen = new RelActSubMotDen();

		Integer idActSubvencionableAgrupacion = this.relExpActSubDao.findIdActSubAgrupacionPorExpediente(idExpediente);
		if (Constantes.ID_AGRUPACION_EMCO_AYUNTAMIENTO.equals(idActSubvencionableAgrupacion)) {
			// Encontrar el id para eliminar la relacion
			relExpActSub.setIdRelExpActSub(idClavePrimaria);
			ActAyuntamiento actAyuntamiento = this.actAyuntamientoDao.findEMCO(relExpActSub);
			Integer idRelacion = relExpActSub.getIdRelExpActSub();
			relExpActSub = this.relExpActSubDao.findIdActSub(idRelacion);
			Integer idActSub = relExpActSub.getActSubvencionable().getIdActSub();
			relExpActSub.setIdRelExpActSub(actAyuntamiento.getRelExpActSub().getIdRelExpActSub());

			relActSubMotDen.setIdRelExpActSub(idClavePrimaria);
			relActSubMotDenDao.remove(relActSubMotDen, origen);
			relActSubMotMin.setIdRelExpActSub(idClavePrimaria);
			relActSubMotMinDao.remove(relActSubMotMin, origen);

			// Eliminar el ayuntamiento
			this.actAyuntamientoDao.removeEMCO(actAyuntamiento);

			// Eliminar la relacion
			this.relExpActSubDao.remove(relExpActSub);

			// Update los importes en la relacion que corresponda
			ActSubvencionable actSubvencionable = this.actSubvencionableDao.findIdActSub(idActSub);
			Integer idActSubPadre = actSubvencionable.getIdActSubPadre();
			RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumEstudioActuacion(idExpediente, idActSubPadre);
			relExpActSubSuma.setIdExpediente(idExpediente);
			relExpActSubSuma.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.relExpActSubDao.updateImportePorIdActSub(relExpActSubSuma, idActSubPadre);
			RelExpActSub subvencionPorcentaje = new RelExpActSub();
			subvencionPorcentaje.setIdExpediente(idExpediente);
			this.relExpActSubDao.updateSubvencionPorcentaje(subvencionPorcentaje);

			// Update la relacion total
			RelExpActSub relExpActSubTotal = this.relExpActSubDao.sumAyuntamientoEMCO(idActSubPadre, idExpediente,
					idConvocatoria);
			relExpActSubTotal.setIdExpediente(idExpediente);
			relExpActSubTotal.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			relExpActSubTotal = this.relExpActSubDao.updateImporteAyuntamiento(relExpActSubTotal, idActSubPadre);

			// Update los importes en datos proyecto(estudio tecnico)
			EstudioTecnico estudioTecnico = new EstudioTecnico();
			estudioTecnico.setIdExpediente(idExpediente);
			estudioTecnico.setImportePresentado(relExpActSubTotal.getImportePresentado());
			estudioTecnico.setImporteAdmitido(relExpActSubTotal.getImporteAdmitido());
			estudioTecnico.setFechaUltmodificacion(new Date());
			estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			this.estudioTecnicoDao.updateImporte(estudioTecnico);
		} else {
			List<Facturas> listaConceptos = facturasDao.findFacturasPorRelExpActSub(idClavePrimaria);
			Date fecha = new Date();
			EstudioTecnico estudioTecnico = new EstudioTecnico();
			if (listaConceptos.isEmpty()) {
				// Primero borramos relacion de motivos de minoracion
				relActSubMotMin.setIdRelExpActSub(idClavePrimaria);
				relActSubMotMinDao.remove(relActSubMotMin, Constantes.ORIGEN_DENEGACION_MINORACION_FACTURAS);
				// Primero borramos relacion de motivos de denegacion
				relActSubMotDen.setIdRelExpActSub(idClavePrimaria);
				relActSubMotDenDao.remove(relActSubMotDen, Constantes.ORIGEN_DENEGACION_MINORACION_FACTURAS);

				relExpActSub.setIdRelExpActSub(idClavePrimaria);

				Integer idActSubHijo = this.relExpActSubDao.findNuevoIdActSubHijo(idClavePrimaria);

				relExpActSubDao.remove(relExpActSub);

				this.relExpActSubDao.removeRelExpActSubPadreEMCO(idActSubHijo, idExpediente);

			} else {
				throw new NegocioException("error.facturas");
			}
		}

		return relExpActSub;
	}

	@Override
	public void updateRelExpActSubEmpreEMCO(Integer idRelacion, Integer idActSubPadre, RelExpActSub relExpActSub,
			Integer idExpediente) {
		this.relExpActSubDao.updateRelExpActSubEmpreEMCO(idRelacion, idActSubPadre, relExpActSub, idExpediente);
	}

	@Override
	public RelExpActSub sumaImportesFacturasEMCO(Integer idRelacion, Integer idActSubPadre) {
		return this.relExpActSubDao.sumaImportesFacturasEMCO(idRelacion, idActSubPadre);
	}

	@Override
	public void updateRelExpActSubEmprePadreEMCO(Integer idExpediente, Integer idActSubPadre,
			BigDecimal sumaImporteEMCO) {
		this.relExpActSubDao.updateRelExpActSubEmprePadreEMCO(idActSubPadre, sumaImporteEMCO, idExpediente);
	}

	@Override
	public Integer findRelExpActSubEmprePadreEMCO(Integer idActSubHijo) {
		return this.relExpActSubDao.findRelExpActSubEmprePadreEMCO(idActSubHijo);
	}

	@Override
	public void updateDatosProyectoEMCO(Integer idExpediente, BigDecimal sumaImporteEMCO) {
		this.relExpActSubDao.updateDatosProyectoEMCO(idExpediente, sumaImporteEMCO);

	}

	@Override
	public void updateRelExpActSubPadreEMCO(Integer idRelacion, Integer idActSubHijo, RelExpActSub relExpActSub,
			Integer idExpediente) {
		this.relExpActSubDao.updateRelExpActSubPadreEMCO(idRelacion, idActSubHijo, idExpediente, relExpActSub);
	}

	@Override
	public Integer findNuevoIdActSubHijo(Integer idRelacion) {
		return this.relExpActSubDao.findNuevoIdActSubHijo(idRelacion);
	}

	public void updateRelExpActSubAbueloEMCO(EstudioTecnico estudioTecnico, Integer idActSubPadre) {
		this.relExpActSubDao.updateRelExpActSubAbueloEMCO(estudioTecnico, idActSubPadre);

	}

	@Override
	public Integer findRelExpActSubEmpreHijoEMCO(Integer idCriterio) {
		return this.relExpActSubDao.findRelExpActSubEmpreHijoEMCO(idCriterio);
	}

	@Override
	public void updateRelExpActSubAdmitidoPadreEMCO(Integer idRelacion, Integer idActSubHijo, RelExpActSub relExpActSub,
			Integer idExpediente) {
		this.relExpActSubDao.updateRelExpActSubAdmitidoPadreEMCO(idRelacion, idActSubHijo, idExpediente, relExpActSub);
	}

	@Override
	public Integer existenMasFacturas(Integer idActSubHijo, Integer idExpediente) {
		return this.relExpActSubDao.existenMasFacturas(idActSubHijo, idExpediente);
	}

	@Override
	public void removeRelExpActSubPadreEMCO(Integer idActSubHijo, Integer idExpediente) {
		this.relExpActSubDao.removeRelExpActSubPadreEMCO(idActSubHijo, idExpediente);
	}

	private void updatearImportesDatosProyecto(Integer idExpediente, Usuario usuario, EstudioTecnico estudioTecnico,
			Date fecha, RelExpActSub relExpActSubAux2) {
		// // Actualiazamos importe admitido de expediente
		estudioTecnico.setIdExpediente(idExpediente);
		estudioTecnico.setFechaUltmodificacion(fecha);
		estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
		estudioTecnico.setSubvencionCalculada(null);
		estudioTecnico.setSubvencionResuelta(null);
		//
		if (null == relExpActSubAux2.getImporteAdmitido()) {
			estudioTecnico.setImporteAdmitido(null);
		} else {
			estudioTecnico.setImporteAdmitido(relExpActSubAux2.getImporteAdmitido());
		}
		if (null == relExpActSubAux2.getImportePresentado()) {
			estudioTecnico.setImportePresentado(null);
		} else {
			estudioTecnico.setImportePresentado(relExpActSubAux2.getImportePresentado());
		}
		estudioTecnicoDao.updateImporte(estudioTecnico);
		logger.info("[POST] :Estudio tecico  updateado correctamente");
	}

	private void updatearImportesDatosProyectoEMCO(Integer idExpediente, Usuario usuario, EstudioTecnico estudioTecnico,
			Date fecha, RelExpActSub relExpActSubAux2, Integer idActSubPadre) {
		// // Actualiazamos importe admitido de expediente
		estudioTecnico.setIdExpediente(idExpediente);
		estudioTecnico.setFechaUltmodificacion(fecha);
		estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
		estudioTecnico.setSubvencionCalculada(null);
		estudioTecnico.setSubvencionResuelta(null);
		//
		if (null == relExpActSubAux2.getImporteAdmitido()) {
			estudioTecnico.setImporteAdmitido(null);
		} else {
			estudioTecnico.setImporteAdmitido(relExpActSubAux2.getImporteAdmitido());
		}
		if (null == relExpActSubAux2.getImportePresentado()) {
			estudioTecnico.setImportePresentado(null);
		} else {
			estudioTecnico.setImportePresentado(relExpActSubAux2.getImportePresentado());
		}
		this.relExpActSubDao.updateRelExpActSubAbueloEMCO(estudioTecnico, idActSubPadre);
		logger.info("[POST] :Estudio tecico  updateado correctamente");
	}

	@Override
	public List<RelExpActSub> filterEMCOTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto, boolean b,
			Integer idExpediente) {
		return (List<RelExpActSub>) this.relExpActSubDao.filterEMCOTer(filterActSub, jqGridRequestDto, false,
				idExpediente);
	}

	@Override
	public List<MarcarInspeccionableAct> filterConConceptosPTTTer(RelExpActSub filterActSub,
			JQGridRequestDto jqGridRequestDto, boolean b) {
		return (List<MarcarInspeccionableAct>) this.relExpActSubDao.filterConConceptosPTTTer(filterActSub,
				jqGridRequestDto, false);
	}

	@Override
	public RelExpActSub modificaJustOTC(RelExpActSub relExpActSub, Integer idExpediente, Usuario usuario) {
		relExpActSub.setUsuarioUltmodificacion(usuario.getNombreUsuario());

		// Update los importes en la relacion que corresponda
		relExpActSub.setIdExpediente(idExpediente);
		this.relExpActSubDao.updateJustOTC(relExpActSub);

		// Sumamos los importes de la relacion que corresponda
		RelExpActSub relExpActSubSuma = this.relExpActSubDao.sumJusOTC(relExpActSub.getIdExpediente());

		// Eliminamos importe calculado
		this.relExpActSubDao.eliminarImporteCalculado(relExpActSub.getIdExpediente());

		// Update los importes en datos proyecto(estudio tecnico)
		EstudioTecnico estudioTecnico = new EstudioTecnico();
		estudioTecnico.setIdExpediente(idExpediente);
		estudioTecnico.setImporteAdmitido(relExpActSubSuma.getImporteJustAdmitido());
		estudioTecnico.setFechaUltmodificacion(new Date());
		estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
		this.estudioTecnicoDao.updateImporteJusOTC(estudioTecnico);

		return relExpActSub;
	}

	@Override
	public List<RelExpActSub> filterEMCOEmpreTer(RelExpActSub filterActSub, JQGridRequestDto jqGridRequestDto,
			boolean b, Integer idExpedientes) {
		return (List<RelExpActSub>) this.relExpActSubDao.filterEMCOEmpreTer(filterActSub, jqGridRequestDto, false,
				idExpedientes);
	}

	@Override
	public JQGridResponseDto<RelExpActSub> filterCOVIDT(RelExpActSub filterRelExpActSub,
			JQGridRequestDto jqGridRequestDto, boolean startsWith) {
		List<RelExpActSub> listaRelExpActSub = this.relExpActSubDao.findRelEXpActSubPorExpedienteCOVIDT(
				filterRelExpActSub.getIdExpediente(), filterRelExpActSub.getIdconvocatoria());
		Long recordNum = this.relExpActSubDao
				.findAllLikeCount(filterRelExpActSub != null ? filterRelExpActSub : new RelExpActSub(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelExpActSub>> reorderSelection = this.relExpActSubDao.reorderSelection(filterRelExpActSub,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub,
					reorderSelection);
		}
		return new JQGridResponseDto<RelExpActSub>(jqGridRequestDto, recordNum, listaRelExpActSub);
	}
}
