package com.ejie.ab60.service.convocatorias;

import com.ejie.ab60.model.Idiomas;
import com.ejie.ab60.model.convocatorias.AplicacionesPresupuestarias;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * AplicacionesPresupuestariasService  
 * 
 *  
 */

public interface AplicacionesPresupuestariasService {

	/**
	 * Inserts a single row in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @return AplicacionesPresupuestarias
	 */
	AplicacionesPresupuestarias add(AplicacionesPresupuestarias aplicacionesPresupuestarias);

	/**
	 * Updates a single row in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @return AplicacionesPresupuestarias
	 */
	AplicacionesPresupuestarias update(AplicacionesPresupuestarias aplicacionesPresupuestarias) throws Exception;

	AplicacionesPresupuestarias updateImporteDisponible(AplicacionesPresupuestarias aplicacionesPresupuestarias);

	/**
	 * Finds a single row in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @return AplicacionesPresupuestarias
	 */
	AplicacionesPresupuestarias find(AplicacionesPresupuestarias aplicacionesPresupuestarias);

	/**
	 * Deletes a single row in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 */
	AplicacionesPresupuestarias remove(AplicacionesPresupuestarias aplicacionesPresupuestarias);

	/**
	 * Finds a list of rows in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<AplicacionesPresupuestarias>
	 */
	List<AplicacionesPresupuestarias> findAll(AplicacionesPresupuestarias aplicacionesPresupuestarias,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the AplicacionesPresupuestarias table using like.
	 *
	 * @param aplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<AplicacionesPresupuestarias>
	 */
	List<AplicacionesPresupuestarias> findAllLike(AplicacionesPresupuestarias aplicacionesPresupuestarias,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(AplicacionesPresupuestarias filterAplicacionesPresupuestarias,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<AplicacionesPresupuestarias>
	 */
	JQGridResponseDto<AplicacionesPresupuestarias> filter(AplicacionesPresupuestarias filterAplicacionesPresupuestarias,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param searchAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AplicacionesPresupuestarias>>
	 */
	List<TableRowDto<AplicacionesPresupuestarias>> search(AplicacionesPresupuestarias filterAplicacionesPresupuestarias,
			AplicacionesPresupuestarias searchAplicacionesPresupuestarias, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Reorder the selection made in AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(AplicacionesPresupuestarias filterAplicacionesPresupuestarias,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<AplicacionesPresupuestarias>>
	 */
	JQGridResponseDto<JerarquiaDto<AplicacionesPresupuestarias>> jerarquia(
			AplicacionesPresupuestarias filterAplicacionesPresupuestarias, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<AplicacionesPresupuestarias>>
	 */
	JQGridResponseDto<JerarquiaDto<AplicacionesPresupuestarias>> jerarquiaChildren(
			AplicacionesPresupuestarias filterAplicacionesPresupuestarias, JQGridRequestDto jqGridRequestDto);

}
