package com.ejie.ab60.service.convocatorias;

import com.ejie.ab60.dao.convocatorias.AplicacionesPresupuestariasDao;
import com.ejie.ab60.model.Idiomas;
import com.ejie.ab60.model.convocatorias.AplicacionesPresupuestarias;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * AplicacionesPresupuestariasServiceImpl  
 * 12:36:29.
 * 
 *  
 */

@Service(value = "aplicacionesPresupuestariasService")
public class AplicacionesPresupuestariasServiceImpl implements AplicacionesPresupuestariasService {

	@Autowired
	private AplicacionesPresupuestariasDao aplicacionesPresupuestariasDao;

	/**
	 * Inserts a single row in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @return AplicacionesPresupuestarias
	 */
	@Transactional(rollbackFor = Throwable.class)
	public AplicacionesPresupuestarias add(AplicacionesPresupuestarias aplicacionesPresupuestarias) {
		return this.aplicacionesPresupuestariasDao.add(aplicacionesPresupuestarias);
	}

	/**
	 * Updates a single row in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @return AplicacionesPresupuestarias
	 */
	@Transactional(rollbackFor = Throwable.class)
	public AplicacionesPresupuestarias update(AplicacionesPresupuestarias aplicacionesPresupuestarias)
			throws Exception {
		return this.aplicacionesPresupuestariasDao.update(aplicacionesPresupuestarias);
	}

	/**
	 * Updates a single row in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @return AplicacionesPresupuestarias
	 */
	@Transactional(rollbackFor = Throwable.class)
	public AplicacionesPresupuestarias updateImporteDisponible(
			AplicacionesPresupuestarias aplicacionesPresupuestarias) {
		return this.aplicacionesPresupuestariasDao.updateImporteDisponible(aplicacionesPresupuestarias);
	}

	/**
	 * Finds a single row in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @return AplicacionesPresupuestarias
	 */
	public AplicacionesPresupuestarias find(AplicacionesPresupuestarias aplicacionesPresupuestarias) {
		return (AplicacionesPresupuestarias) this.aplicacionesPresupuestariasDao.find(aplicacionesPresupuestarias);
	}

	/**
	 * Deletes a single row in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 */
	@Transactional(rollbackFor = Throwable.class)
	public AplicacionesPresupuestarias remove(AplicacionesPresupuestarias aplicacionesPresupuestarias) {
		this.aplicacionesPresupuestariasDao.remove(aplicacionesPresupuestarias);

		return aplicacionesPresupuestarias;
	}

	/**
	 * Finds a list of rows in the AplicacionesPresupuestarias table.
	 *
	 * @param aplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<AplicacionesPresupuestarias>
	 */
	public List<AplicacionesPresupuestarias> findAll(AplicacionesPresupuestarias aplicacionesPresupuestarias,
			JQGridRequestDto jqGridRequestDto) {
		return (List<AplicacionesPresupuestarias>) this.aplicacionesPresupuestariasDao
				.findAll(aplicacionesPresupuestarias, jqGridRequestDto);
	}

	/**
	 * Finds rows in the AplicacionesPresupuestarias table using like.
	 *
	 * @param aplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<AplicacionesPresupuestarias>
	 */
	public List<AplicacionesPresupuestarias> findAllLike(AplicacionesPresupuestarias aplicacionesPresupuestarias,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<AplicacionesPresupuestarias>) this.aplicacionesPresupuestariasDao
				.findAllLike(aplicacionesPresupuestarias, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(AplicacionesPresupuestarias filterAplicacionesPresupuestarias,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.aplicacionesPresupuestariasDao.removeMultiple(filterAplicacionesPresupuestarias, jqGridRequestDto,
				startsWith);
	}

	/**
	 * Filter method in the AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<AplicacionesPresupuestarias>
	 */
	public JQGridResponseDto<AplicacionesPresupuestarias> filter(
			AplicacionesPresupuestarias filterAplicacionesPresupuestarias, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<AplicacionesPresupuestarias> listaAplicacionesPresupuestarias = this.aplicacionesPresupuestariasDao
				.findAllLike(filterAplicacionesPresupuestarias, jqGridRequestDto, false);
		Long recordNum = this.aplicacionesPresupuestariasDao.findAllLikeCount(filterAplicacionesPresupuestarias != null
				? filterAplicacionesPresupuestarias : new AplicacionesPresupuestarias(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<AplicacionesPresupuestarias>> reorderSelection = this.aplicacionesPresupuestariasDao
					.reorderSelection(filterAplicacionesPresupuestarias, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<AplicacionesPresupuestarias>(jqGridRequestDto, recordNum,
					listaAplicacionesPresupuestarias, reorderSelection);
		}
		return new JQGridResponseDto<AplicacionesPresupuestarias>(jqGridRequestDto, recordNum,
				listaAplicacionesPresupuestarias);
	}

	/**
	 * Searches rows in the AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param searchAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<AplicacionesPresupuestarias>>
	 */
	public List<TableRowDto<AplicacionesPresupuestarias>> search(
			AplicacionesPresupuestarias filterAplicacionesPresupuestarias,
			AplicacionesPresupuestarias searchAplicacionesPresupuestarias, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.aplicacionesPresupuestariasDao.search(filterAplicacionesPresupuestarias,
				searchAplicacionesPresupuestarias, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(AplicacionesPresupuestarias filterAplicacionesPresupuestarias,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.aplicacionesPresupuestariasDao.reorderSelection(filterAplicacionesPresupuestarias, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<AplicacionesPresupuestarias>>
	 */
	public JQGridResponseDto<JerarquiaDto<AplicacionesPresupuestarias>> jerarquia(
			AplicacionesPresupuestarias filterAplicacionesPresupuestarias, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<JerarquiaDto<AplicacionesPresupuestarias>> listaAplicacionesPresupuestarias = this.aplicacionesPresupuestariasDao
				.findAllLikeJerarquia(filterAplicacionesPresupuestarias, jqGridRequestDto);
		Long recordNum = this.aplicacionesPresupuestariasDao
				.findAllLikeCountJerarquia(filterAplicacionesPresupuestarias, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<AplicacionesPresupuestarias>>(jqGridRequestDto, recordNum,
				listaAplicacionesPresupuestarias);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * AplicacionesPresupuestarias table.
	 *
	 * @param filterAplicacionesPresupuestarias
	 *            AplicacionesPresupuestarias
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<AplicacionesPresupuestarias>>
	 */
	public JQGridResponseDto<JerarquiaDto<AplicacionesPresupuestarias>> jerarquiaChildren(
			AplicacionesPresupuestarias filterAplicacionesPresupuestarias, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<AplicacionesPresupuestarias>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<AplicacionesPresupuestarias>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.aplicacionesPresupuestariasDao.findAllChild(filterAplicacionesPresupuestarias, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
