package com.ejie.ab60.service.convocatorias;

import com.ejie.ab60.model.convocatorias.DatosContables;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * DatosContablesService  
 * 
 *  
 */

public interface DatosContablesService {

	/**
	 * Inserts a single row in the DatosContables table.
	 *
	 * @param datosContables
	 *            DatosContables
	 * @return DatosContables
	 */
	DatosContables add(DatosContables datosContables);

	/**
	 * Updates a single row in the DatosContables table.
	 *
	 * @param datosContables
	 *            DatosContables
	 * @return DatosContables
	 */
	DatosContables update(DatosContables datosContables);

	/**
	 * Finds a single row in the DatosContables table.
	 *
	 * @param datosContables
	 *            DatosContables
	 * @return DatosContables
	 */
	DatosContables find(DatosContables datosContables);

	/**
	 * Finds a single row in the DatosContables table.
	 *
	 * @param datosContables
	 *            DatosContables
	 * @return DatosContables
	 */
	DatosContables findbyConvocatoria(DatosContables datosContables);

	/**
	 * Deletes a single row in the DatosContables table.
	 *
	 * @param datosContables
	 *            DatosContables
	 */
	void remove(DatosContables datosContables);

	/**
	 * Finds a list of rows in the DatosContables table.
	 *
	 * @param datosContables
	 *            DatosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<DatosContables>
	 */
	List<DatosContables> findAll(DatosContables datosContables, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the DatosContables table using like.
	 *
	 * @param datosContables
	 *            DatosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<DatosContables>
	 */
	List<DatosContables> findAllLike(DatosContables datosContables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the DatosContables table.
	 *
	 * @param filterDatosContables
	 *            DatosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(DatosContables filterDatosContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the DatosContables table.
	 *
	 * @param filterDatosContables
	 *            DatosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<DatosContables>
	 */
	JQGridResponseDto<DatosContables> filter(DatosContables filterDatosContables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the DatosContables table.
	 *
	 * @param filterDatosContables
	 *            DatosContables
	 * @param searchDatosContables
	 *            DatosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DatosContables>>
	 */
	List<TableRowDto<DatosContables>> search(DatosContables filterDatosContables, DatosContables searchDatosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in DatosContables table.
	 *
	 * @param filterDatosContables
	 *            DatosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(DatosContables filterDatosContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the DatosContables table.
	 *
	 * @param filterDatosContables
	 *            DatosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<DatosContables>>
	 */
	JQGridResponseDto<JerarquiaDto<DatosContables>> jerarquia(DatosContables filterDatosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the DatosContables
	 * table.
	 *
	 * @param filterDatosContables
	 *            DatosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<DatosContables>>
	 */
	JQGridResponseDto<JerarquiaDto<DatosContables>> jerarquiaChildren(DatosContables filterDatosContables,
			JQGridRequestDto jqGridRequestDto);

}
