package com.ejie.ab60.service.convocatorias;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.Idiomas;
import com.ejie.ab60.model.estudioTecnico.TecnicosResponsables;

/**
 * IdiomasService  
 * 
 *  
 */

public interface IdiomasService {

	/**
	 * Inserts a single row in the Idiomas table.
	 *
	 * @param idiomas
	 *            Idiomas
	 * @return Idiomas
	 */
	Idiomas add(Idiomas idiomas);

	/**
	 * Updates a single row in the Idiomas table.
	 *
	 * @param idiomas
	 *            Idiomas
	 * @return Idiomas
	 */
	Idiomas update(Idiomas idiomas);

	/**
	 * Finds a single row in the Idiomas table.
	 *
	 * @param idiomas
	 *            Idiomas
	 * @return Idiomas
	 */
	Idiomas find(Idiomas idiomas);

	/**
	 * Deletes a single row in the Idiomas table.
	 *
	 * @param idiomas
	 *            Idiomas
	 */
	void remove(Idiomas idiomas);

	/**
	 * Finds a list of rows in the Idiomas table.
	 *
	 * @param idiomas
	 *            Idiomas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Idiomas>
	 */
	List<Idiomas> findAll(Idiomas idiomas, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Idiomas table using like.
	 *
	 * @param idiomas
	 *            Idiomas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Idiomas>
	 */
	List<Idiomas> findAllLike(Idiomas idiomas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Idiomas table.
	 *
	 * @param filterIdiomas
	 *            Idiomas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Idiomas filterIdiomas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Idiomas table.
	 *
	 * @param filterIdiomas
	 *            Idiomas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Idiomas>
	 */
	JQGridResponseDto<Idiomas> filter(Idiomas filterIdiomas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the Idiomas table.
	 *
	 * @param filterIdiomas
	 *            Idiomas
	 * @param searchIdiomas
	 *            Idiomas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Idiomas>>
	 */
	List<TableRowDto<Idiomas>> search(Idiomas filterIdiomas, Idiomas searchIdiomas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Reorder the selection made in Idiomas table.
	 *
	 * @param filterIdiomas
	 *            Idiomas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Idiomas filterIdiomas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Idiomas table.
	 *
	 * @param filterIdiomas
	 *            Idiomas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Idiomas>>
	 */
	JQGridResponseDto<JerarquiaDto<Idiomas>> jerarquia(Idiomas filterIdiomas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Idiomas table.
	 *
	 * @param filterIdiomas
	 *            Idiomas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Idiomas>>
	 */
	JQGridResponseDto<JerarquiaDto<Idiomas>> jerarquiaChildren(Idiomas filterIdiomas,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the Idiomas table.
	 *
	 * 
	 * @return List<Idiomas>
	 */
	List<Idiomas> findIdioma();

}
