package com.ejie.ab60.service.convocatorias;

import java.util.List;
import java.util.ArrayList;
import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.convocatorias.AplicacionesPresupuestariasDao;
import com.ejie.ab60.dao.convocatorias.DatosContablesDao;
import com.ejie.ab60.dao.convocatorias.ReferenciasIntervencionDao;
import com.ejie.ab60.dao.justificacion.JustificacionDao;
import com.ejie.ab60.model.actuacionesSubvencionables.ActSubvencionable;
import com.ejie.ab60.model.convocatorias.AplicacionesPresupuestarias;
import com.ejie.ab60.model.convocatorias.DatosContables;
import com.ejie.ab60.model.convocatorias.InfDatosIkus;
import com.ejie.ab60.model.convocatorias.ReferenciasIntervencion;
import com.ejie.ab60.model.justificacion.Justificacion;
import com.ejie.ab60.model.usuario.Usuario;

@Service(value = "infContablesIkusService")
public class InfContablesIkusServiceImpl implements InfContablesIkusService {

	@Autowired
	private DatosContablesDao datosContablesDao;

	@Autowired
	private ReferenciasIntervencionDao referenciasIntervencionDao;

	@Autowired
	private AplicacionesPresupuestariasDao aplicacionesPresupuestariasDao;

	/**
	 * Metod para hacer un update de infcontablesikus
	 * 
	 * @param tercero
	 * @return InfContablesIkus Bean resultante del proceso de creacion
	 * @throws Exception
	 */

	public InfDatosIkus saveInfContablesIkus(InfDatosIkus infdatosikus, Usuario usuario, Integer idConvocatoria) {

		Date fecha = new Date();

		// Bloque DatosContables
		infdatosikus.getDatosContables().setIdConvocatoria(idConvocatoria);

		if (infdatosikus.getDatosContables().getIdDatoContable() == null
				|| infdatosikus.getDatosContables().getIdDatoContable() == 0) {
			// Insert
			infdatosikus.getDatosContables().setUsuarioRegistro(usuario.getNombreUsuario());
			infdatosikus.getDatosContables().setFechaRegistro(fecha);
			infdatosikus.setDatosContables(this.addDatosContables(infdatosikus.getDatosContables()));
		} else {
			// Update
			infdatosikus.getDatosContables().setFechaUltmodificacion(fecha);
			infdatosikus.getDatosContables().setUsuarioUltmodificacion(usuario.getNombreUsuario());
			infdatosikus.setDatosContables(this.updateDatosContables(infdatosikus.getDatosContables()));
		}

		/*
		 * AplicacionesPresupuestarias aplicacionPresu = new
		 * AplicacionesPresupuestarias();
		 * aplicacionPresu.setIdConvocatoria(idConvocatoria);
		 * 
		 * List<AplicacionesPresupuestarias> listAplicaciones =
		 * aplicacionesPresupuestariasDao.findAllLike(aplicacionPresu, null,
		 * false);
		 * 
		 * if (listAplicaciones != null && listAplicaciones.size() > 0) { //
		 * Bloque Referencia de Intervencion
		 * 
		 * if (infdatosikus.getRefIntervencion() != null) {
		 * infdatosikus.getRefIntervencion().setIdAplicacionPresupuestaria(
		 * infdatosikus.getIdAplicPresu()); if
		 * (infdatosikus.getRefIntervencion().getIdReferenciaIntervencion() ==
		 * null ||
		 * infdatosikus.getRefIntervencion().getIdReferenciaIntervencion() == 0)
		 * { // Insert
		 * infdatosikus.getRefIntervencion().setUsuarioRegistro(usuario.
		 * getNombreUsuario());
		 * infdatosikus.getRefIntervencion().setFechaRegistro(fecha);
		 * infdatosikus.setRefIntervencion(this.addReferenciasIntervencion(
		 * infdatosikus.getRefIntervencion())); } else { // Update
		 * infdatosikus.getRefIntervencion().setFechaUltmodificacion(fecha);
		 * infdatosikus.getRefIntervencion().setUsuarioUltmodificacion(usuario.
		 * getNombreUsuario()); infdatosikus
		 * .setRefIntervencion(this.updateReferenciasIntervencion(infdatosikus.
		 * getRefIntervencion())); } }
		 * 
		 * }
		 */

		return infdatosikus;
	}

	/**
	 * Updates a single row in the DatosContables table.
	 *
	 * @param datoscontables
	 *            DatosContables
	 * @return DatosContables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DatosContables updateDatosContables(DatosContables datosContables) {
		return this.datosContablesDao.update(datosContables);
	}

	/**
	 * Updates a single row in the DatosContables table.
	 *
	 * @param datoscontables
	 *            DatosContables
	 * @return DatosContables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DatosContables addDatosContables(DatosContables datosContables) {
		return this.datosContablesDao.add(datosContables);
	}

	/**
	 * Updates a single row in the ReferenciasIntervencion table.
	 *
	 * @param refIntervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public ReferenciasIntervencion addReferenciasIntervencion(ReferenciasIntervencion refIntervencion) {
		return this.referenciasIntervencionDao.add(refIntervencion);
	}

	/**
	 * Updates a single row in the ReferenciasIntervencion table.
	 *
	 * @param refIntervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public ReferenciasIntervencion updateReferenciasIntervencion(ReferenciasIntervencion refIntervencion) {
		return this.referenciasIntervencionDao.update(refIntervencion);
	}

}
