package com.ejie.ab60.service.convocatorias;

import com.ejie.ab60.model.convocatorias.ReferenciasIntervencion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * ReferenciasIntervencionService  
 * 
 *  
 */

public interface ReferenciasIntervencionService {

	/**
	 * Inserts a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	ReferenciasIntervencion add(ReferenciasIntervencion referenciasIntervencion);

	/**
	 * Updates a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	ReferenciasIntervencion update(ReferenciasIntervencion referenciasIntervencion);

	/**
	 * Finds a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	ReferenciasIntervencion find(ReferenciasIntervencion referenciasIntervencion);

	/**
	 * Finds a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	ReferenciasIntervencion findByAplicPresu(ReferenciasIntervencion referenciasIntervencion);

	/**
	 * Deletes a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 */
	void remove(ReferenciasIntervencion referenciasIntervencion);

	/**
	 * Deletes a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 */
	void removeByAplicacionPresu(ReferenciasIntervencion referenciasIntervencion);

	/**
	 * Finds a list of rows in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ReferenciasIntervencion>
	 */
	List<ReferenciasIntervencion> findAll(ReferenciasIntervencion referenciasIntervencion,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ReferenciasIntervencion table using like.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ReferenciasIntervencion>
	 */
	List<ReferenciasIntervencion> findAllLike(ReferenciasIntervencion referenciasIntervencion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ReferenciasIntervencion filterReferenciasIntervencion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ReferenciasIntervencion>
	 */
	JQGridResponseDto<ReferenciasIntervencion> filter(ReferenciasIntervencion filterReferenciasIntervencion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param searchReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ReferenciasIntervencion>>
	 */
	List<TableRowDto<ReferenciasIntervencion>> search(ReferenciasIntervencion filterReferenciasIntervencion,
			ReferenciasIntervencion searchReferenciasIntervencion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Reorder the selection made in ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(ReferenciasIntervencion filterReferenciasIntervencion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<ReferenciasIntervencion>>
	 */
	JQGridResponseDto<JerarquiaDto<ReferenciasIntervencion>> jerarquia(
			ReferenciasIntervencion filterReferenciasIntervencion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<ReferenciasIntervencion>>
	 */
	JQGridResponseDto<JerarquiaDto<ReferenciasIntervencion>> jerarquiaChildren(
			ReferenciasIntervencion filterReferenciasIntervencion, JQGridRequestDto jqGridRequestDto);

}
