package com.ejie.ab60.service.convocatorias;

import com.ejie.ab60.dao.convocatorias.ReferenciasIntervencionDao;
import com.ejie.ab60.model.convocatorias.ReferenciasIntervencion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * ReferenciasIntervencionServiceImpl  
 * 
 *  
 */

@Service(value = "referenciasIntervencionService")
public class ReferenciasIntervencionServiceImpl implements ReferenciasIntervencionService {

	@Autowired
	private ReferenciasIntervencionDao referenciasIntervencionDao;

	/**
	 * Inserts a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public ReferenciasIntervencion add(ReferenciasIntervencion referenciasIntervencion) {
		return this.referenciasIntervencionDao.add(referenciasIntervencion);
	}

	/**
	 * Updates a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public ReferenciasIntervencion update(ReferenciasIntervencion referenciasIntervencion) {
		return this.referenciasIntervencionDao.update(referenciasIntervencion);
	}

	/**
	 * Finds a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	public ReferenciasIntervencion find(ReferenciasIntervencion referenciasIntervencion) {
		return (ReferenciasIntervencion) this.referenciasIntervencionDao.find(referenciasIntervencion);
	}

	/**
	 * Finds a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 * @return ReferenciasIntervencion
	 */
	public ReferenciasIntervencion findByAplicPresu(ReferenciasIntervencion referenciasIntervencion) {
		return (ReferenciasIntervencion) this.referenciasIntervencionDao.findByAplicPresu(referenciasIntervencion);
	}

	/**
	 * Deletes a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(ReferenciasIntervencion referenciasIntervencion) {
		this.referenciasIntervencionDao.remove(referenciasIntervencion);
	}

	/**
	 * Deletes a single row in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void removeByAplicacionPresu(ReferenciasIntervencion referenciasIntervencion) {
		this.referenciasIntervencionDao.removeByAplicacionPresu(referenciasIntervencion);
	}

	/**
	 * Finds a list of rows in the ReferenciasIntervencion table.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ReferenciasIntervencion>
	 */
	public List<ReferenciasIntervencion> findAll(ReferenciasIntervencion referenciasIntervencion,
			JQGridRequestDto jqGridRequestDto) {
		return (List<ReferenciasIntervencion>) this.referenciasIntervencionDao.findAll(referenciasIntervencion,
				jqGridRequestDto);
	}

	/**
	 * Finds rows in the ReferenciasIntervencion table using like.
	 *
	 * @param referenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ReferenciasIntervencion>
	 */
	public List<ReferenciasIntervencion> findAllLike(ReferenciasIntervencion referenciasIntervencion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<ReferenciasIntervencion>) this.referenciasIntervencionDao.findAllLike(referenciasIntervencion,
				jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(ReferenciasIntervencion filterReferenciasIntervencion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.referenciasIntervencionDao.removeMultiple(filterReferenciasIntervencion, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ReferenciasIntervencion>
	 */
	public JQGridResponseDto<ReferenciasIntervencion> filter(ReferenciasIntervencion filterReferenciasIntervencion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<ReferenciasIntervencion> listaReferenciasIntervencion = this.referenciasIntervencionDao
				.findAllLike(filterReferenciasIntervencion, jqGridRequestDto, false);
		Long recordNum = this.referenciasIntervencionDao.findAllLikeCount(
				filterReferenciasIntervencion != null ? filterReferenciasIntervencion : new ReferenciasIntervencion(),
				false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<ReferenciasIntervencion>> reorderSelection = this.referenciasIntervencionDao
					.reorderSelection(filterReferenciasIntervencion, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<ReferenciasIntervencion>(jqGridRequestDto, recordNum,
					listaReferenciasIntervencion, reorderSelection);
		}
		return new JQGridResponseDto<ReferenciasIntervencion>(jqGridRequestDto, recordNum,
				listaReferenciasIntervencion);
	}

	/**
	 * Searches rows in the ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param searchReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ReferenciasIntervencion>>
	 */
	public List<TableRowDto<ReferenciasIntervencion>> search(ReferenciasIntervencion filterReferenciasIntervencion,
			ReferenciasIntervencion searchReferenciasIntervencion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.referenciasIntervencionDao.search(filterReferenciasIntervencion, searchReferenciasIntervencion,
				jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(ReferenciasIntervencion filterReferenciasIntervencion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.referenciasIntervencionDao.reorderSelection(filterReferenciasIntervencion, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<ReferenciasIntervencion>>
	 */
	public JQGridResponseDto<JerarquiaDto<ReferenciasIntervencion>> jerarquia(
			ReferenciasIntervencion filterReferenciasIntervencion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<JerarquiaDto<ReferenciasIntervencion>> listaReferenciasIntervencion = this.referenciasIntervencionDao
				.findAllLikeJerarquia(filterReferenciasIntervencion, jqGridRequestDto);
		Long recordNum = this.referenciasIntervencionDao.findAllLikeCountJerarquia(filterReferenciasIntervencion,
				jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<ReferenciasIntervencion>>(jqGridRequestDto, recordNum,
				listaReferenciasIntervencion);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * ReferenciasIntervencion table.
	 *
	 * @param filterReferenciasIntervencion
	 *            ReferenciasIntervencion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<ReferenciasIntervencion>>
	 */
	public JQGridResponseDto<JerarquiaDto<ReferenciasIntervencion>> jerarquiaChildren(
			ReferenciasIntervencion filterReferenciasIntervencion, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<ReferenciasIntervencion>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<ReferenciasIntervencion>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.referenciasIntervencionDao.findAllChild(filterReferenciasIntervencion, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
