package com.ejie.ab60.service.convocatorias;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.ab60.model.convocatorias.TiposAyuda;

/**
 * TiposAyudaService  
 * 
 *  
 */

public interface TiposAyudaService {

	/**
	 * Inserts a single row in the TiposAyuda table.
	 *
	 * @param tiposAyuda
	 *            TiposAyuda
	 * @return TiposAyuda
	 */
	TiposAyuda add(TiposAyuda tiposAyuda);

	/**
	 * Updates a single row in the TiposAyuda table.
	 *
	 * @param tiposAyuda
	 *            TiposAyuda
	 * @return TiposAyuda
	 */
	TiposAyuda update(TiposAyuda tiposAyuda);

	/**
	 * Finds a single row in the TiposAyuda table.
	 *
	 * @param tiposAyuda
	 *            TiposAyuda
	 * @return TiposAyuda
	 */
	TiposAyuda find(TiposAyuda tiposAyuda);

	/**
	 * Deletes a single row in the TiposAyuda table.
	 *
	 * @param tiposAyuda
	 *            TiposAyuda
	 */
	void remove(TiposAyuda tiposAyuda);

	/**
	 * Finds a list of rows in the TiposAyuda table.
	 *
	 * @param tiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TiposAyuda>
	 */
	List<TiposAyuda> findAll(TiposAyuda tiposAyuda, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposAyuda table using like.
	 *
	 * @param tiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposAyuda>
	 */
	List<TiposAyuda> findAllLike(TiposAyuda tiposAyuda, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposAyuda table.
	 *
	 * @param filterTiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposAyuda filterTiposAyuda, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the TiposAyuda table.
	 *
	 * @param filterTiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<TiposAyuda>
	 */
	JQGridResponseDto<TiposAyuda> filter(TiposAyuda filterTiposAyuda, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the TiposAyuda table.
	 *
	 * @param filterTiposAyuda
	 *            TiposAyuda
	 * @param searchTiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposAyuda>>
	 */
	List<TableRowDto<TiposAyuda>> search(TiposAyuda filterTiposAyuda, TiposAyuda searchTiposAyuda,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in TiposAyuda table.
	 *
	 * @param filterTiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(TiposAyuda filterTiposAyuda, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposAyuda table.
	 *
	 * @param filterTiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposAyuda>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposAyuda>> jerarquia(TiposAyuda filterTiposAyuda,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the TiposAyuda table.
	 *
	 * @param filterTiposAyuda
	 *            TiposAyuda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposAyuda>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposAyuda>> jerarquiaChildren(TiposAyuda filterTiposAyuda,
			JQGridRequestDto jqGridRequestDto);

	TiposAyuda findPLSQL(TiposAyuda tiposAyuda);

	String copiaConvocatoria(Convocatorias convocatorias);

}
