package com.ejie.ab60.service.convocatorias;

import java.util.List;

import com.ejie.ab60.model.convocatorias.TiposConvocatoria;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * TiposConvocatoriaService  
 * 
 *  
 */

public interface TiposConvocatoriaService {

	/**
	 * Inserts a single row in the TiposConvocatoria table.
	 *
	 * @param tiposConvocatoria
	 *            TiposConvocatoria
	 * @return TiposConvocatoria
	 */
	TiposConvocatoria add(TiposConvocatoria tiposConvocatoria);

	/**
	 * Updates a single row in the TiposConvocatoria table.
	 *
	 * @param tiposConvocatoria
	 *            TiposConvocatoria
	 * @return TiposConvocatoria
	 */
	TiposConvocatoria update(TiposConvocatoria tiposConvocatoria);

	/**
	 * Finds a single row in the TiposConvocatoria table.
	 *
	 * @param tiposConvocatoria
	 *            TiposConvocatoria
	 * @return TiposConvocatoria
	 */
	TiposConvocatoria find(TiposConvocatoria tiposConvocatoria);

	/**
	 * Finds a single row in the TiposConvocatoria table.
	 *
	 * @param tiposConvocatoria
	 *            TiposConvocatoria
	 * @return TiposConvocatoria
	 */
	TiposConvocatoria findNoConcursal(TiposConvocatoria tiposConvocatoria);

	/**
	 * Deletes a single row in the TiposConvocatoria table.
	 *
	 * @param tiposConvocatoria
	 *            TiposConvocatoria
	 */
	void remove(TiposConvocatoria tiposConvocatoria);

	/**
	 * Finds a list of rows in the TiposConvocatoria table.
	 *
	 * @param tiposConvocatoria
	 *            TiposConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TiposConvocatoria>
	 */
	List<TiposConvocatoria> findAll(TiposConvocatoria tiposConvocatoria, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposConvocatoria table using like.
	 *
	 * @param tiposConvocatoria
	 *            TiposConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposConvocatoria>
	 */
	List<TiposConvocatoria> findAllLike(TiposConvocatoria tiposConvocatoria, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposConvocatoria table.
	 *
	 * @param filterTiposConvocatoria
	 *            TiposConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposConvocatoria filterTiposConvocatoria, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the TiposConvocatoria table.
	 *
	 * @param filterTiposConvocatoria
	 *            TiposConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<TiposConvocatoria>
	 */
	JQGridResponseDto<TiposConvocatoria> filter(TiposConvocatoria filterTiposConvocatoria,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the TiposConvocatoria table.
	 *
	 * @param filterTiposConvocatoria
	 *            TiposConvocatoria
	 * @param searchTiposConvocatoria
	 *            TiposConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposConvocatoria>>
	 */
	List<TableRowDto<TiposConvocatoria>> search(TiposConvocatoria filterTiposConvocatoria,
			TiposConvocatoria searchTiposConvocatoria, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in TiposConvocatoria table.
	 *
	 * @param filterTiposConvocatoria
	 *            TiposConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(TiposConvocatoria filterTiposConvocatoria, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposConvocatoria table.
	 *
	 * @param filterTiposConvocatoria
	 *            TiposConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposConvocatoria>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposConvocatoria>> jerarquia(TiposConvocatoria filterTiposConvocatoria,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the TiposConvocatoria
	 * table.
	 *
	 * @param filterTiposConvocatoria
	 *            TiposConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposConvocatoria>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposConvocatoria>> jerarquiaChildren(TiposConvocatoria filterTiposConvocatoria,
			JQGridRequestDto jqGridRequestDto);

}
