package com.ejie.ab60.service.criteriosPuntuacion;

import java.util.List;

import com.ejie.ab60.model.criteriosPuntuacion.CriteriosPuntuacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * CriteriosPuntuacionService  
 * 
 *  
 */

public interface CriteriosPuntuacionService {

	/**
	 * Inserts a single row in the CriteriosPuntuacion table.
	 *
	 * @param criteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @return CriteriosPuntuacion
	 */
	CriteriosPuntuacion add(CriteriosPuntuacion criteriosPuntuacion);

	/**
	 * Updates a single row in the CriteriosPuntuacion table.
	 *
	 * @param criteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @return CriteriosPuntuacion
	 */
	CriteriosPuntuacion update(CriteriosPuntuacion criteriosPuntuacion);

	/**
	 * Finds a single row in the CriteriosPuntuacion table.
	 *
	 * @param criteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @return CriteriosPuntuacion
	 */
	CriteriosPuntuacion find(CriteriosPuntuacion criteriosPuntuacion);

	/**
	 * Lista de textos de criterios de puntuacion CriteriosPuntuacion table.
	 *
	 * @param Integer
	 *            idConvocatoria
	 * @return List<CriteriosPuntuacion>
	 */
	List<CriteriosPuntuacion> findTextoCriterio(Integer idConvocatoria);

	/**
	 * Lista de textos de criterios de puntuacion CriteriosPuntuacion table.
	 *
	 * @param Integer
	 *            idConvocatoria
	 * @return List<CriteriosPuntuacion>
	 */
	List<CriteriosPuntuacion> findTextoCriterioBEC(Integer idConvocatoria);

	/**
	 * Deletes a single row in the CriteriosPuntuacion table.
	 *
	 * @param criteriosPuntuacion
	 *            CriteriosPuntuacion
	 */
	void remove(CriteriosPuntuacion criteriosPuntuacion);

	/**
	 * Finds a list of rows in the CriteriosPuntuacion table.
	 *
	 * @param criteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<CriteriosPuntuacion>
	 */
	List<CriteriosPuntuacion> findAll(CriteriosPuntuacion criteriosPuntuacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the CriteriosPuntuacion table using like.
	 *
	 * @param criteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<CriteriosPuntuacion>
	 */
	List<CriteriosPuntuacion> findAllLike(CriteriosPuntuacion criteriosPuntuacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the CriteriosPuntuacion table.
	 *
	 * @param filterCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(CriteriosPuntuacion filterCriteriosPuntuacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the CriteriosPuntuacion table.
	 *
	 * @param filterCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<CriteriosPuntuacion>
	 */
	JQGridResponseDto<CriteriosPuntuacion> filter(CriteriosPuntuacion filterCriteriosPuntuacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the CriteriosPuntuacion table.
	 *
	 * @param filterCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param searchCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<CriteriosPuntuacion>>
	 */
	List<TableRowDto<CriteriosPuntuacion>> search(CriteriosPuntuacion filterCriteriosPuntuacion,
			CriteriosPuntuacion searchCriteriosPuntuacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in CriteriosPuntuacion table.
	 *
	 * @param filterCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(CriteriosPuntuacion filterCriteriosPuntuacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the CriteriosPuntuacion table.
	 *
	 * @param filterCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<CriteriosPuntuacion>>
	 */
	JQGridResponseDto<JerarquiaDto<CriteriosPuntuacion>> jerarquia(CriteriosPuntuacion filterCriteriosPuntuacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * CriteriosPuntuacion table.
	 *
	 * @param filterCriteriosPuntuacion
	 *            CriteriosPuntuacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<CriteriosPuntuacion>>
	 */
	JQGridResponseDto<JerarquiaDto<CriteriosPuntuacion>> jerarquiaChildren(
			CriteriosPuntuacion filterCriteriosPuntuacion, JQGridRequestDto jqGridRequestDto);

}
