package com.ejie.ab60.service.criteriosPuntuacion;

import java.util.List;

import com.ejie.ab60.model.criteriosPuntuacion.RelExpCriPun;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpCriPunService  
 * 
 *  
 */

public interface RelExpCriPunService {

	/**
	 * Inserts a single row in the RelExpCriPun table.
	 *
	 * @param relExpCriPun
	 *            RelExpCriPun
	 * @return RelExpCriPun
	 */
	RelExpCriPun add(RelExpCriPun relExpCriPun);

	/**
	 * Updates a single row in the RelExpCriPun table.
	 *
	 * @param relExpCriPun
	 *            RelExpCriPun
	 * @return RelExpCriPun
	 */
	RelExpCriPun update(RelExpCriPun relExpCriPun, Usuario usuario) throws Exception;

	/**
	 * Updates a single row in the RelExpCriPun table.
	 *
	 * @param relExpCriPun
	 *            RelExpCriPun
	 * @param idExpediente
	 *            Integer
	 * @param usuario
	 *            Usuario
	 * @return
	 * @throws Exception
	 */
	RelExpCriPun updatePuntuacionAdmitida(RelExpCriPun relExpCriPun, Integer idExpediente, Usuario usuario)
			throws Exception;

	/**
	 * Finds a single row in the RelExpCriPun table.
	 *
	 * @param relExpCriPun
	 *            RelExpCriPun
	 * @return RelExpCriPun
	 */
	RelExpCriPun find(RelExpCriPun relExpCriPun);

	/**
	 * Finds a single row in the RelExpCriPun table.
	 *
	 * @param relExpCriPun
	 *            RelExpCriPun
	 * @return RelExpCriPun
	 */
	RelExpCriPun findPuntTeorica(RelExpCriPun relExpCriPun);

	/**
	 * Deletes a single row in the RelExpCriPun table.
	 *
	 * @param relExpCriPun
	 *            RelExpCriPun
	 */
	void remove(RelExpCriPun relExpCriPun);

	/**
	 * Deletes a single row in the RelExpCriPun table.
	 *
	 * @param Integer
	 *            idExpediente
	 */
	void removeCriteriosPorExpediente(Integer idExpediente);

	/**
	 * Finds a list of rows in the RelExpCriPun table.
	 *
	 * @param relExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelExpCriPun>
	 */
	List<RelExpCriPun> findAll(RelExpCriPun relExpCriPun, JQGridRequestDto jqGridRequestDto);

	/**
	 * Lista de id de criterios de puntuacion de la RelExpCriPun table.
	 *
	 * @param Integer
	 *            idExpediente
	 * @return List
	 */
	List<RelExpCriPun> findIdsCriterio(Integer idExpediente);

	/**
	 * Finds rows in the RelExpCriPun table using like.
	 *
	 * @param relExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelExpCriPun>
	 * 
	 */
	List<RelExpCriPun> findAllLike(RelExpCriPun relExpCriPun, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelExpCriPun table.
	 *
	 * @param filterRelExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpCriPun filterRelExpCriPun, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelExpCriPun table.
	 *
	 * @param filterRelExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpCriPun>
	 */
	JQGridResponseDto<RelExpCriPun> filter(RelExpCriPun filterRelExpCriPun, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelExpCriPun table.
	 *
	 * @param filterRelExpCriPun
	 *            RelExpCriPun
	 * @param searchRelExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpCriPun>>
	 */
	List<TableRowDto<RelExpCriPun>> search(RelExpCriPun filterRelExpCriPun, RelExpCriPun searchRelExpCriPun,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelExpCriPun table.
	 *
	 * @param filterRelExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelExpCriPun filterRelExpCriPun, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelExpCriPun table.
	 *
	 * @param filterRelExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelExpCriPun>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpCriPun>> jerarquia(RelExpCriPun filterRelExpCriPun,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelExpCriPun
	 * table.
	 *
	 * @param filterRelExpCriPun
	 *            RelExpCriPun
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelExpCriPun>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpCriPun>> jerarquiaChildren(RelExpCriPun filterRelExpCriPun,
			JQGridRequestDto jqGridRequestDto);

}
