package com.ejie.ab60.service.criteriosPuntuacion;

import java.util.List;

import com.ejie.ab60.model.criteriosPuntuacion.TiposCriterio;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * TiposCriterioService  
 * 
 *  
 */

public interface TiposCriterioService {

	/**
	 * Inserts a single row in the TiposCriterio table.
	 *
	 * @param tiposCriterio
	 *            TiposCriterio
	 * @return TiposCriterio
	 */
	TiposCriterio add(TiposCriterio tiposCriterio);

	/**
	 * Updates a single row in the TiposCriterio table.
	 *
	 * @param tiposCriterio
	 *            TiposCriterio
	 * @return TiposCriterio
	 */
	TiposCriterio update(TiposCriterio tiposCriterio);

	/**
	 * Finds a single row in the TiposCriterio table.
	 *
	 * @param tiposCriterio
	 *            TiposCriterio
	 * @return TiposCriterio
	 */
	TiposCriterio find(TiposCriterio tiposCriterio);

	/**
	 * Deletes a single row in the TiposCriterio table.
	 *
	 * @param tiposCriterio
	 *            TiposCriterio
	 */
	void remove(TiposCriterio tiposCriterio);

	/**
	 * Finds a list of rows in the TiposCriterio table.
	 *
	 * @param tiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TiposCriterio>
	 */
	List<TiposCriterio> findAll(TiposCriterio tiposCriterio, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposCriterio table using like.
	 *
	 * @param tiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposCriterio>
	 */
	List<TiposCriterio> findAllLike(TiposCriterio tiposCriterio, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposCriterio table.
	 *
	 * @param filterTiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposCriterio filterTiposCriterio, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the TiposCriterio table.
	 *
	 * @param filterTiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<TiposCriterio>
	 */
	JQGridResponseDto<TiposCriterio> filter(TiposCriterio filterTiposCriterio, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the TiposCriterio table.
	 *
	 * @param filterTiposCriterio
	 *            TiposCriterio
	 * @param searchTiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposCriterio>>
	 */
	List<TableRowDto<TiposCriterio>> search(TiposCriterio filterTiposCriterio, TiposCriterio searchTiposCriterio,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in TiposCriterio table.
	 *
	 * @param filterTiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(TiposCriterio filterTiposCriterio, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposCriterio table.
	 *
	 * @param filterTiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposCriterio>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposCriterio>> jerarquia(TiposCriterio filterTiposCriterio,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the TiposCriterio
	 * table.
	 *
	 * @param filterTiposCriterio
	 *            TiposCriterio
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposCriterio>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposCriterio>> jerarquiaChildren(TiposCriterio filterTiposCriterio,
			JQGridRequestDto jqGridRequestDto);

}
