package com.ejie.ab60.service.estudioTecnico;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.estudioTecnico.DatosTerOmic;

/**
 * DatosTerOmicService  
 * 
 *  
 */

public interface DatosTerOmicService {

	/**
	 * Inserts a single row in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	DatosTerOmic add(DatosTerOmic datosTerOmic);

	/**
	 * Updates a single row in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	DatosTerOmic update(DatosTerOmic datosTerOmic);

	/**
	 * Updates a single row in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	DatosTerOmic updateByExpediente(DatosTerOmic datosTerOmic);

	/**
	 * Finds a single row in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	DatosTerOmic find(DatosTerOmic datosTerOmic);

	/**
	 * Finds a single row in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	DatosTerOmic findByExpediente(DatosTerOmic datosTerOmic);

	/**
	 * Deletes a single row in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 */
	void remove(DatosTerOmic datosTerOmic);

	/**
	 * Finds a list of rows in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<DatosTerOmic>
	 */
	List<DatosTerOmic> findAll(DatosTerOmic datosTerOmic, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the DatosTerOmic table using like.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<DatosTerOmic>
	 */
	List<DatosTerOmic> findAllLike(DatosTerOmic datosTerOmic, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the DatosTerOmic table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(DatosTerOmic filterDatosTerOmic, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the DatosTerOmic table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<DatosTerOmic>
	 */
	JQGridResponseDto<DatosTerOmic> filter(DatosTerOmic filterDatosTerOmic, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the DatosTerOmic table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param searchDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DatosTerOmic>>
	 */
	List<TableRowDto<DatosTerOmic>> search(DatosTerOmic filterDatosTerOmic, DatosTerOmic searchDatosTerOmic,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in DatosTerOmic table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(DatosTerOmic filterDatosTerOmic, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the DatosTerOmic table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<DatosTerOmic>>
	 */
	JQGridResponseDto<JerarquiaDto<DatosTerOmic>> jerarquia(DatosTerOmic filterDatosTerOmic,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the DatosTerOmic
	 * table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<DatosTerOmic>>
	 */
	JQGridResponseDto<JerarquiaDto<DatosTerOmic>> jerarquiaChildren(DatosTerOmic filterDatosTerOmic,
			JQGridRequestDto jqGridRequestDto);

}
