package com.ejie.ab60.service.estudioTecnico;

import com.ejie.ab60.dao.estudioTecnico.DatosTerOmicDao;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.model.estudioTecnico.DatosTerOmic;

/**
 * DatosTerOmicServiceImpl  
 * 
 *  
 */

@Service(value = "datosTerOmicService")
public class DatosTerOmicServiceImpl implements DatosTerOmicService {

	@Autowired
	private DatosTerOmicDao datosTerOmicDao;

	/**
	 * Inserts a single row in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DatosTerOmic add(DatosTerOmic datosTerOmic) {
		return this.datosTerOmicDao.add(datosTerOmic);
	}

	/**
	 * Updates a single row in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DatosTerOmic update(DatosTerOmic datosTerOmic) {
		return this.datosTerOmicDao.update(datosTerOmic);
	}

	/**
	 * Updates a single row in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DatosTerOmic updateByExpediente(DatosTerOmic datosTerOmic) {
		return this.datosTerOmicDao.updateByExpediente(datosTerOmic);
	}

	/**
	 * Finds a single row in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	public DatosTerOmic find(DatosTerOmic datosTerOmic) {
		return (DatosTerOmic) this.datosTerOmicDao.find(datosTerOmic);
	}

	/**
	 * Finds a single row in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @return DatosTerOmic
	 */
	public DatosTerOmic findByExpediente(DatosTerOmic datosTerOmic) {
		return (DatosTerOmic) this.datosTerOmicDao.findByExpediente(datosTerOmic);
	}

	/**
	 * Deletes a single row in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(DatosTerOmic datosTerOmic) {
		this.datosTerOmicDao.remove(datosTerOmic);
	}

	/**
	 * Finds a list of rows in the DatosTerOmic table.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<DatosTerOmic>
	 */
	public List<DatosTerOmic> findAll(DatosTerOmic datosTerOmic, JQGridRequestDto jqGridRequestDto) {
		return (List<DatosTerOmic>) this.datosTerOmicDao.findAll(datosTerOmic, jqGridRequestDto);
	}

	/**
	 * Finds rows in the DatosTerOmic table using like.
	 *
	 * @param datosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<DatosTerOmic>
	 */
	public List<DatosTerOmic> findAllLike(DatosTerOmic datosTerOmic, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<DatosTerOmic>) this.datosTerOmicDao.findAllLike(datosTerOmic, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the DatosTerOmic table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(DatosTerOmic filterDatosTerOmic, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.datosTerOmicDao.removeMultiple(filterDatosTerOmic, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the DatosTerOmic table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<DatosTerOmic>
	 */
	public JQGridResponseDto<DatosTerOmic> filter(DatosTerOmic filterDatosTerOmic, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<DatosTerOmic> listaDatosTerOmic = this.datosTerOmicDao.findAllLike(filterDatosTerOmic, jqGridRequestDto,
				false);
		Long recordNum = this.datosTerOmicDao
				.findAllLikeCount(filterDatosTerOmic != null ? filterDatosTerOmic : new DatosTerOmic(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<DatosTerOmic>> reorderSelection = this.datosTerOmicDao.reorderSelection(filterDatosTerOmic,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<DatosTerOmic>(jqGridRequestDto, recordNum, listaDatosTerOmic,
					reorderSelection);
		}
		return new JQGridResponseDto<DatosTerOmic>(jqGridRequestDto, recordNum, listaDatosTerOmic);
	}

	/**
	 * Searches rows in the DatosTerOmic table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param searchDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DatosTerOmic>>
	 */
	public List<TableRowDto<DatosTerOmic>> search(DatosTerOmic filterDatosTerOmic, DatosTerOmic searchDatosTerOmic,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.datosTerOmicDao.search(filterDatosTerOmic, searchDatosTerOmic, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in DatosTerOmic table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(DatosTerOmic filterDatosTerOmic, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.datosTerOmicDao.reorderSelection(filterDatosTerOmic, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the DatosTerOmic table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<DatosTerOmic>>
	 */
	public JQGridResponseDto<JerarquiaDto<DatosTerOmic>> jerarquia(DatosTerOmic filterDatosTerOmic,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<DatosTerOmic>> listaDatosTerOmic = this.datosTerOmicDao
				.findAllLikeJerarquia(filterDatosTerOmic, jqGridRequestDto);
		Long recordNum = this.datosTerOmicDao.findAllLikeCountJerarquia(filterDatosTerOmic, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<DatosTerOmic>>(jqGridRequestDto, recordNum, listaDatosTerOmic);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the DatosTerOmic
	 * table.
	 *
	 * @param filterDatosTerOmic
	 *            DatosTerOmic
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<DatosTerOmic>>
	 */
	public JQGridResponseDto<JerarquiaDto<DatosTerOmic>> jerarquiaChildren(DatosTerOmic filterDatosTerOmic,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<DatosTerOmic>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<DatosTerOmic>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.datosTerOmicDao.findAllChild(filterDatosTerOmic, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
