package com.ejie.ab60.service.estudioTecnico;

import com.ejie.ab60.model.estudioTecnico.ErroresCalculo;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * ErroresCalculoService  
 * 
 *  
 */

public interface ErroresCalculoService {

	/**
	 * Inserts a single row in the ErroresCalculo table.
	 *
	 * @param erroresCalculo
	 *            ErroresCalculo
	 * @return ErroresCalculo
	 */
	ErroresCalculo add(ErroresCalculo erroresCalculo);

	/**
	 * Updates a single row in the ErroresCalculo table.
	 *
	 * @param erroresCalculo
	 *            ErroresCalculo
	 * @return ErroresCalculo
	 */
	ErroresCalculo update(ErroresCalculo erroresCalculo);

	/**
	 * Finds a single row in the ErroresCalculo table.
	 *
	 * @param erroresCalculo
	 *            ErroresCalculo
	 * @return ErroresCalculo
	 */
	ErroresCalculo find(ErroresCalculo erroresCalculo);

	/**
	 * Deletes a single row in the ErroresCalculo table.
	 *
	 * @param erroresCalculo
	 *            ErroresCalculo
	 */
	void remove(ErroresCalculo erroresCalculo);

	/**
	 * Finds a list of rows in the ErroresCalculo table.
	 *
	 * @param erroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ErroresCalculo>
	 */
	List<ErroresCalculo> findAll(ErroresCalculo erroresCalculo, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ErroresCalculo table using like.
	 *
	 * @param erroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ErroresCalculo>
	 */
	List<ErroresCalculo> findAllLike(ErroresCalculo erroresCalculo, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the ErroresCalculo table.
	 *
	 * @param filterErroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(ErroresCalculo filterErroresCalculo, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the ErroresCalculo table.
	 *
	 * @param filterErroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ErroresCalculo>
	 */
	JQGridResponseDto<ErroresCalculo> filter(ErroresCalculo filterErroresCalculo, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the ErroresCalculo table.
	 *
	 * @param filterErroresCalculo
	 *            ErroresCalculo
	 * @param searchErroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ErroresCalculo>>
	 */
	List<TableRowDto<ErroresCalculo>> search(ErroresCalculo filterErroresCalculo, ErroresCalculo searchErroresCalculo,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in ErroresCalculo table.
	 *
	 * @param filterErroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(ErroresCalculo filterErroresCalculo, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the ErroresCalculo table.
	 *
	 * @param filterErroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<ErroresCalculo>>
	 */
	JQGridResponseDto<JerarquiaDto<ErroresCalculo>> jerarquia(ErroresCalculo filterErroresCalculo,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the ErroresCalculo
	 * table.
	 *
	 * @param filterErroresCalculo
	 *            ErroresCalculo
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<ErroresCalculo>>
	 */
	JQGridResponseDto<JerarquiaDto<ErroresCalculo>> jerarquiaChildren(ErroresCalculo filterErroresCalculo,
			JQGridRequestDto jqGridRequestDto);

}
