package com.ejie.ab60.service.estudioTecnico;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.estudioTecnico.Horarios;

/**
 * HorariosService  
 * 
 *  
 */

public interface HorariosService {

	/**
	 * Inserts a single row in the Horarios table.
	 *
	 * @param horarios
	 *            Horarios
	 * @return Horarios
	 */
	Horarios add(Horarios horarios);

	/**
	 * Updates a single row in the Horarios table.
	 *
	 * @param horarios
	 *            Horarios
	 * @return Horarios
	 */
	Horarios update(Horarios horarios);

	/**
	 * Finds a single row in the Horarios table.
	 *
	 * @param horarios
	 *            Horarios
	 * @return Horarios
	 */
	Horarios find(Horarios horarios);

	/**
	 * Deletes a single row in the Horarios table.
	 *
	 * @param horarios
	 *            Horarios
	 */
	void remove(Horarios horarios);

	/**
	 * Finds a list of rows in the Horarios table.
	 *
	 * @param horarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Horarios>
	 */
	List<Horarios> findAll(Horarios horarios, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the Horarios table.
	 *
	 * @param horarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Horarios>
	 */
	List<Horarios> findByPoblacion(Integer idPoblacion, Integer idConvocatoria);

	/**
	 * Finds rows in the Horarios table using like.
	 *
	 * @param horarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Horarios>
	 */
	List<Horarios> findAllLike(Horarios horarios, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Horarios table.
	 *
	 * @param filterHorarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Horarios filterHorarios, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Horarios table.
	 *
	 * @param filterHorarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Horarios>
	 */
	JQGridResponseDto<Horarios> filter(Horarios filterHorarios, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the Horarios table.
	 *
	 * @param filterHorarios
	 *            Horarios
	 * @param searchHorarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Horarios>>
	 */
	List<TableRowDto<Horarios>> search(Horarios filterHorarios, Horarios searchHorarios,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in Horarios table.
	 *
	 * @param filterHorarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Horarios filterHorarios, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Horarios table.
	 *
	 * @param filterHorarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Horarios>>
	 */
	JQGridResponseDto<JerarquiaDto<Horarios>> jerarquia(Horarios filterHorarios, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Horarios table.
	 *
	 * @param filterHorarios
	 *            Horarios
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Horarios>>
	 */
	JQGridResponseDto<JerarquiaDto<Horarios>> jerarquiaChildren(Horarios filterHorarios,
			JQGridRequestDto jqGridRequestDto);

}
