package com.ejie.ab60.service.estudioTecnico;

import com.ejie.ab60.model.estudioTecnico.MotivosDenegacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * MotivosDenegacionService  
 * 
 *  
 */

public interface MotivosDenegacionService {

	/**
	 * Inserts a single row in the MotivosDenegacion table.
	 *
	 * @param motivosDenegacion
	 *            MotivosDenegacion
	 * @return MotivosDenegacion
	 */
	MotivosDenegacion add(MotivosDenegacion motivosDenegacion);

	/**
	 * Updates a single row in the MotivosDenegacion table.
	 *
	 * @param motivosDenegacion
	 *            MotivosDenegacion
	 * @return MotivosDenegacion
	 */
	MotivosDenegacion update(MotivosDenegacion motivosDenegacion);

	/**
	 * Finds a single row in the MotivosDenegacion table.
	 *
	 * @param motivosDenegacion
	 *            MotivosDenegacion
	 * @return MotivosDenegacion
	 */
	MotivosDenegacion find(MotivosDenegacion motivosDenegacion);

	/**
	 * Deletes a single row in the MotivosDenegacion table.
	 *
	 * @param motivosDenegacion
	 *            MotivosDenegacion
	 */
	void remove(MotivosDenegacion motivosDenegacion);

	/**
	 * Finds a list of rows in the MotivosDenegacion table.
	 *
	 * @param motivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<MotivosDenegacion>
	 */
	List<MotivosDenegacion> findAll(MotivosDenegacion motivosDenegacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the MotivosDenegacion table using like.
	 *
	 * @param motivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<MotivosDenegacion>
	 */
	List<MotivosDenegacion> findAllLike(MotivosDenegacion motivosDenegacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finds a list of rows in the MotivosDenegacion table.
	 *
	 * 
	 * @return List<MotivosDenegacion>
	 */
	List<MotivosDenegacion> findDenegacionActSubvencionable(Integer idConvocatoria, Integer origen,
			Integer idRelExpActSub);

	/**
	 * Finds a list of rows in the MotivosDenegacion table.
	 *
	 * 
	 * @return List<MotivosDenegacion>
	 */
	List<MotivosDenegacion> findDenegacionFacturas(Integer idConvocatoria, Integer origen, Integer idFactura);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the MotivosDenegacion table.
	 *
	 * @param filterMotivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 */
	void removeMultiple(MotivosDenegacion filterMotivosDenegacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the MotivosDenegacion table.
	 *
	 * @param filterMotivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<MotivosDenegacion>
	 */
	JQGridResponseDto<MotivosDenegacion> filter(MotivosDenegacion filterMotivosDenegacion,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Searches rows in the MotivosDenegacion table.
	 *
	 * @param filterMotivosDenegacion
	 *            MotivosDenegacion
	 * @param searchMotivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosDenegacion>>
	 */
	List<TableRowDto<MotivosDenegacion>> search(MotivosDenegacion filterMotivosDenegacion,
			MotivosDenegacion searchMotivosDenegacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in MotivosDenegacion table.
	 *
	 * @param filterMotivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(MotivosDenegacion filterMotivosDenegacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the MotivosDenegacion table.
	 *
	 * @param filterMotivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<MotivosDenegacion>>
	 */
	JQGridResponseDto<JerarquiaDto<MotivosDenegacion>> jerarquia(MotivosDenegacion filterMotivosDenegacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the MotivosDenegacion
	 * table.
	 *
	 * @param filterMotivosDenegacion
	 *            MotivosDenegacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<MotivosDenegacion>>
	 */
	JQGridResponseDto<JerarquiaDto<MotivosDenegacion>> jerarquiaChildren(MotivosDenegacion filterMotivosDenegacion,
			JQGridRequestDto jqGridRequestDto);

}
