package com.ejie.ab60.service.estudioTecnico;

import java.util.List;

import com.ejie.ab60.model.estudioTecnico.MotivosDesestimacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * MotivosDesestimacionService  
 * 
 *  
 */

public interface MotivosDesestimacionService {

	/**
	 * Inserts a single row in the MotivosDesestimacion table.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @return MotivosDesestimacion
	 */
	MotivosDesestimacion add(MotivosDesestimacion motivosDesestimacion);

	/**
	 * Updates a single row in the MotivosDesestimacion table.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @return MotivosDesestimacion
	 */
	MotivosDesestimacion update(MotivosDesestimacion motivosDesestimacion);

	/**
	 * Finds a single row in the MotivosDesestimacion table.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @return MotivosDesestimacion
	 */
	MotivosDesestimacion find(MotivosDesestimacion motivosDesestimacion);

	/**
	 * Deletes a single row in the MotivosDesestimacion table.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 */
	void remove(MotivosDesestimacion motivosDesestimacion);

	/**
	 * Finds a list of rows in the MotivosDesestimacion table.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<MotivosDesestimacion>
	 */
	List<MotivosDesestimacion> findAll(MotivosDesestimacion motivosDesestimacion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the MotivosDesestimacion table using like.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<MotivosDesestimacion>
	 */
	List<MotivosDesestimacion> findAllLike(MotivosDesestimacion motivosDesestimacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(MotivosDesestimacion filterMotivosDesestimacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<MotivosDesestimacion>
	 */

	JQGridResponseDto<MotivosDesestimacion> filter(MotivosDesestimacion filterMotivosDesestimacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param searchMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosDesestimacion>>
	 */
	List<TableRowDto<MotivosDesestimacion>> search(MotivosDesestimacion filterMotivosDesestimacion,
			MotivosDesestimacion searchMotivosDesestimacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finds a list of rows in the TecnicosResponsables table.
	 *
	 * 
	 * @return List<TecnicosResponsables>
	 */
	List<MotivosDesestimacion> findMotivo();

	/**
	 * Reorder the selection made in MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(MotivosDesestimacion filterMotivosDesestimacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<MotivosDesestimacion>>
	 */
	JQGridResponseDto<JerarquiaDto<MotivosDesestimacion>> jerarquia(MotivosDesestimacion filterMotivosDesestimacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<MotivosDesestimacion>>
	 */
	JQGridResponseDto<JerarquiaDto<MotivosDesestimacion>> jerarquiaChildren(
			MotivosDesestimacion filterMotivosDesestimacion, JQGridRequestDto jqGridRequestDto);

}
