package com.ejie.ab60.service.estudioTecnico;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.estudioTecnico.MotivosDesestimacionDao;
import com.ejie.ab60.model.estudioTecnico.MotivosDesestimacion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * MotivosDesestimacionServiceImpl  
 * 
 *  
 */

@Service(value = "motivosDesestimacionService")
public class MotivosDesestimacionServiceImpl implements MotivosDesestimacionService {

	@Autowired
	private MotivosDesestimacionDao motivosDesestimacionDao;

	/**
	 * Inserts a single row in the MotivosDesestimacion table.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @return MotivosDesestimacion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public MotivosDesestimacion add(MotivosDesestimacion motivosDesestimacion) {
		return this.motivosDesestimacionDao.add(motivosDesestimacion);
	}

	/**
	 * Updates a single row in the MotivosDesestimacion table.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @return MotivosDesestimacion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public MotivosDesestimacion update(MotivosDesestimacion motivosDesestimacion) {
		return this.motivosDesestimacionDao.update(motivosDesestimacion);
	}

	/**
	 * Finds a single row in the MotivosDesestimacion table.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @return MotivosDesestimacion
	 */
	public MotivosDesestimacion find(MotivosDesestimacion motivosDesestimacion) {
		return (MotivosDesestimacion) this.motivosDesestimacionDao.find(motivosDesestimacion);
	}

	/**
	 * Deletes a single row in the MotivosDesestimacion table.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(MotivosDesestimacion motivosDesestimacion) {
		this.motivosDesestimacionDao.remove(motivosDesestimacion);
	}

	/**
	 * Finds a list of rows in the MotivosDesestimacion table.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<MotivosDesestimacion>
	 */
	public List<MotivosDesestimacion> findAll(MotivosDesestimacion motivosDesestimacion,
			JQGridRequestDto jqGridRequestDto) {
		return (List<MotivosDesestimacion>) this.motivosDesestimacionDao.findAll(motivosDesestimacion,
				jqGridRequestDto);
	}

	/**
	 * Finds rows in the MotivosDesestimacion table using like.
	 *
	 * @param motivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<MotivosDesestimacion>
	 */
	public List<MotivosDesestimacion> findAllLike(MotivosDesestimacion motivosDesestimacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<MotivosDesestimacion>) this.motivosDesestimacionDao.findAllLike(motivosDesestimacion,
				jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(MotivosDesestimacion filterMotivosDesestimacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.motivosDesestimacionDao.removeMultiple(filterMotivosDesestimacion, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<MotivosDesestimacion>
	 */
	public JQGridResponseDto<MotivosDesestimacion> filter(MotivosDesestimacion filterMotivosDesestimacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<MotivosDesestimacion> listaMotivosDesestimacion = this.motivosDesestimacionDao
				.findAllLike(filterMotivosDesestimacion, jqGridRequestDto, false);
		Long recordNum = this.motivosDesestimacionDao.findAllLikeCount(
				filterMotivosDesestimacion != null ? filterMotivosDesestimacion : new MotivosDesestimacion(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<MotivosDesestimacion>> reorderSelection = this.motivosDesestimacionDao
					.reorderSelection(filterMotivosDesestimacion, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<MotivosDesestimacion>(jqGridRequestDto, recordNum, listaMotivosDesestimacion,
					reorderSelection);
		}
		return new JQGridResponseDto<MotivosDesestimacion>(jqGridRequestDto, recordNum, listaMotivosDesestimacion);
	}

	/**
	 * Searches rows in the MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param searchMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosDesestimacion>>
	 */
	public List<TableRowDto<MotivosDesestimacion>> search(MotivosDesestimacion filterMotivosDesestimacion,
			MotivosDesestimacion searchMotivosDesestimacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.motivosDesestimacionDao.search(filterMotivosDesestimacion, searchMotivosDesestimacion,
				jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(MotivosDesestimacion filterMotivosDesestimacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.motivosDesestimacionDao.reorderSelection(filterMotivosDesestimacion, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<MotivosDesestimacion>>
	 */
	public JQGridResponseDto<JerarquiaDto<MotivosDesestimacion>> jerarquia(
			MotivosDesestimacion filterMotivosDesestimacion, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<MotivosDesestimacion>> listaMotivosDesestimacion = this.motivosDesestimacionDao
				.findAllLikeJerarquia(filterMotivosDesestimacion, jqGridRequestDto);
		Long recordNum = this.motivosDesestimacionDao.findAllLikeCountJerarquia(filterMotivosDesestimacion,
				jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<MotivosDesestimacion>>(jqGridRequestDto, recordNum,
				listaMotivosDesestimacion);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * MotivosDesestimacion table.
	 *
	 * @param filterMotivosDesestimacion
	 *            MotivosDesestimacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<MotivosDesestimacion>>
	 */
	public JQGridResponseDto<JerarquiaDto<MotivosDesestimacion>> jerarquiaChildren(
			MotivosDesestimacion filterMotivosDesestimacion, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<MotivosDesestimacion>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<MotivosDesestimacion>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.motivosDesestimacionDao.findAllChild(filterMotivosDesestimacion, jqGridRequestDto));
		return jqGridResponseDto;
	}

	/**
	 * Finds a list of rows in the Motivos table.
	 *
	 * 
	 * @return List<MotivosDesestimacion>
	 */
	public List<MotivosDesestimacion> findMotivo() {

		return (List<MotivosDesestimacion>) this.motivosDesestimacionDao.findMotivo();
	}

}
