package com.ejie.ab60.service.estudioTecnico;

import com.ejie.ab60.model.estudioTecnico.MotivosMinoracion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * MotivosMinoracionService  
 * 
 *  
 */

public interface MotivosMinoracionService {

	/**
	 * Inserts a single row in the MotivosMinoracion table.
	 *
	 * @param motivosMinoracion
	 *            MotivosMinoracion
	 * @return MotivosMinoracion
	 */
	MotivosMinoracion add(MotivosMinoracion motivosMinoracion);

	/**
	 * Updates a single row in the MotivosMinoracion table.
	 *
	 * @param motivosMinoracion
	 *            MotivosMinoracion
	 * @return MotivosMinoracion
	 */
	MotivosMinoracion update(MotivosMinoracion motivosMinoracion);

	/**
	 * Finds a single row in the MotivosMinoracion table.
	 *
	 * @param motivosMinoracion
	 *            MotivosMinoracion
	 * @return MotivosMinoracion
	 */
	MotivosMinoracion find(MotivosMinoracion motivosMinoracion);

	/**
	 * Deletes a single row in the MotivosMinoracion table.
	 *
	 * @param motivosMinoracion
	 *            MotivosMinoracion
	 */
	void remove(MotivosMinoracion motivosMinoracion);

	/**
	 * Finds a list of rows in the MotivosMinoracion table.
	 *
	 * @param motivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<MotivosMinoracion>
	 */
	List<MotivosMinoracion> findAll(MotivosMinoracion motivosMinoracion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the MotivosMinoracion table.
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @param origen
	 *            Integer
	 * @param idRelExpActSub
	 *            Integer
	 * 
	 * @return List<MotivosDenegacion>
	 */
	List<MotivosMinoracion> findMinoracionActSubvencionable(Integer idConvocatoria, Integer origen,
			Integer idRelExpActSub);

	/**
	 * Finds a list of rows in the MotivosMinoracion table.
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @param origen
	 *            Integer
	 * @param idFactura
	 *            Integer
	 * 
	 * @return List<MotivosDenegacion>
	 */
	List<MotivosMinoracion> findMinoracionFacturas(Integer idConvocatoria, Integer origen, Integer idFactura);

	/**
	 * Finds rows in the MotivosMinoracion table using like.
	 *
	 * @param motivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<MotivosMinoracion>
	 */
	List<MotivosMinoracion> findAllLike(MotivosMinoracion motivosMinoracion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the MotivosMinoracion table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(MotivosMinoracion filterMotivosMinoracion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the MotivosMinoracion table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<MotivosMinoracion>
	 */
	JQGridResponseDto<MotivosMinoracion> filter(MotivosMinoracion filterMotivosMinoracion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the MotivosMinoracion table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param searchMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosMinoracion>>
	 */
	List<TableRowDto<MotivosMinoracion>> search(MotivosMinoracion filterMotivosMinoracion,
			MotivosMinoracion searchMotivosMinoracion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in MotivosMinoracion table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(MotivosMinoracion filterMotivosMinoracion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the MotivosMinoracion table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<MotivosMinoracion>>
	 */
	JQGridResponseDto<JerarquiaDto<MotivosMinoracion>> jerarquia(MotivosMinoracion filterMotivosMinoracion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the MotivosMinoracion
	 * table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<MotivosMinoracion>>
	 */
	JQGridResponseDto<JerarquiaDto<MotivosMinoracion>> jerarquiaChildren(MotivosMinoracion filterMotivosMinoracion,
			JQGridRequestDto jqGridRequestDto);

}
