package com.ejie.ab60.service.estudioTecnico;

import com.ejie.ab60.dao.estudioTecnico.MotivosMinoracionDao;
import com.ejie.ab60.model.estudioTecnico.MotivosMinoracion;
import com.ejie.ab60.model.estudioTecnico.TecnicosResponsables;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * MotivosMinoracionServiceImpl  
 * 
 *  
 */

@Service(value = "motivosMinoracionService")
public class MotivosMinoracionServiceImpl implements MotivosMinoracionService {

	@Autowired
	private MotivosMinoracionDao motivosMinoracionDao;

	/**
	 * Inserts a single row in the MotivosMinoracion table.
	 *
	 * @param motivosMinoracion
	 *            MotivosMinoracion
	 * @return MotivosMinoracion
	 */
	@Override()
	@Transactional(rollbackFor = Throwable.class)
	public MotivosMinoracion add(MotivosMinoracion motivosMinoracion) {
		MotivosMinoracion motivosminoracionAux = motivosMinoracion;
		motivosminoracionAux = this.motivosMinoracionDao.add(motivosMinoracion);

		return motivosminoracionAux;
	}

	/**
	 * Updates a single row in the MotivosMinoracion table.
	 *
	 * @param motivosMinoracion
	 *            MotivosMinoracion
	 * @return MotivosMinoracion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public MotivosMinoracion update(MotivosMinoracion motivosMinoracion) {
		return this.motivosMinoracionDao.update(motivosMinoracion);
	}

	/**
	 * Finds a single row in the MotivosMinoracion table.
	 *
	 * @param motivosMinoracion
	 *            MotivosMinoracion
	 * @return MotivosMinoracion
	 */
	public MotivosMinoracion find(MotivosMinoracion motivosMinoracion) {
		return (MotivosMinoracion) this.motivosMinoracionDao.find(motivosMinoracion);
	}

	/**
	 * Finds a list of rows in the MotivosMinoracion table.
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @param origen
	 *            Integer
	 * @param idRelExpActSub
	 *            Integer
	 * 
	 * @return List<MotivosDenegacion>
	 */
	public List<MotivosMinoracion> findMinoracionActSubvencionable(Integer idConvocatoria, Integer origen,
			Integer idRelExpActSub) {
		return this.motivosMinoracionDao.findMinoracionActSubvencionable(idConvocatoria, origen, idRelExpActSub);
	}

	/**
	 * Finds a list of rows in the MotivosMinoracion table.
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @param origen
	 *            Integer
	 * @param idFactura
	 *            Integer
	 * 
	 * @return List<MotivosDenegacion>
	 */
	public List<MotivosMinoracion> findMinoracionFacturas(Integer idConvocatoria, Integer origen, Integer idFactura) {
		return this.motivosMinoracionDao.findMinoracionFacturas(idConvocatoria, origen, idFactura);
	}

	/**
	 * Deletes a single row in the MotivosMinoracion table.
	 *
	 * @param motivosMinoracion
	 *            MotivosMinoracion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(MotivosMinoracion motivosMinoracion) {
		this.motivosMinoracionDao.remove(motivosMinoracion);
	}

	/**
	 * Finds a list of rows in the MotivosMinoracion table.
	 *
	 * @param motivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<MotivosMinoracion>
	 */
	public List<MotivosMinoracion> findAll(MotivosMinoracion motivosMinoracion, JQGridRequestDto jqGridRequestDto) {
		return (List<MotivosMinoracion>) this.motivosMinoracionDao.findAll(motivosMinoracion, jqGridRequestDto);
	}

	/**
	 * Finds rows in the MotivosMinoracion table using like.
	 *
	 * @param motivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<MotivosMinoracion>
	 */
	public List<MotivosMinoracion> findAllLike(MotivosMinoracion motivosMinoracion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<MotivosMinoracion>) this.motivosMinoracionDao.findAllLike(motivosMinoracion, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the MotivosMinoracion table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(MotivosMinoracion filterMotivosMinoracion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.motivosMinoracionDao.removeMultiple(filterMotivosMinoracion, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the MotivosMinoracion table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<MotivosMinoracion>
	 */
	public JQGridResponseDto<MotivosMinoracion> filter(MotivosMinoracion filterMotivosMinoracion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<MotivosMinoracion> listaMotivosMinoracion = this.motivosMinoracionDao.findAllLike(filterMotivosMinoracion,
				jqGridRequestDto, false);
		Long recordNum = this.motivosMinoracionDao.findAllLikeCount(
				filterMotivosMinoracion != null ? filterMotivosMinoracion : new MotivosMinoracion(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<MotivosMinoracion>> reorderSelection = this.motivosMinoracionDao
					.reorderSelection(filterMotivosMinoracion, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<MotivosMinoracion>(jqGridRequestDto, recordNum, listaMotivosMinoracion,
					reorderSelection);
		}
		return new JQGridResponseDto<MotivosMinoracion>(jqGridRequestDto, recordNum, listaMotivosMinoracion);
	}

	/**
	 * Searches rows in the MotivosMinoracion table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param searchMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosMinoracion>>
	 */
	public List<TableRowDto<MotivosMinoracion>> search(MotivosMinoracion filterMotivosMinoracion,
			MotivosMinoracion searchMotivosMinoracion, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.motivosMinoracionDao.search(filterMotivosMinoracion, searchMotivosMinoracion, jqGridRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in MotivosMinoracion table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(MotivosMinoracion filterMotivosMinoracion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.motivosMinoracionDao.reorderSelection(filterMotivosMinoracion, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the MotivosMinoracion table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<MotivosMinoracion>>
	 */
	public JQGridResponseDto<JerarquiaDto<MotivosMinoracion>> jerarquia(MotivosMinoracion filterMotivosMinoracion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<MotivosMinoracion>> listaMotivosMinoracion = this.motivosMinoracionDao
				.findAllLikeJerarquia(filterMotivosMinoracion, jqGridRequestDto);
		Long recordNum = this.motivosMinoracionDao.findAllLikeCountJerarquia(filterMotivosMinoracion, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<MotivosMinoracion>>(jqGridRequestDto, recordNum,
				listaMotivosMinoracion);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the MotivosMinoracion
	 * table.
	 *
	 * @param filterMotivosMinoracion
	 *            MotivosMinoracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<MotivosMinoracion>>
	 */
	public JQGridResponseDto<JerarquiaDto<MotivosMinoracion>> jerarquiaChildren(
			MotivosMinoracion filterMotivosMinoracion, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<MotivosMinoracion>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<MotivosMinoracion>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.motivosMinoracionDao.findAllChild(filterMotivosMinoracion, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
