package com.ejie.ab60.service.estudioTecnico;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.ejie.ab60.model.estudioTecnico.OtrasAyudas;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * OtrasAyudasService  
 * 
 *  
 */

public interface OtrasAyudasService {

	/**
	 * Inserts a single row in the OtrasAyudas table.
	 *
	 * @param otrasAyudas
	 *            OtrasAyudas
	 * @return OtrasAyudas
	 */
	OtrasAyudas add(OtrasAyudas otrasAyudas);

	/**
	 * Inserts a single row in the OtrasAyudas table.
	 *
	 * @param httpRequest
	 *            HttpServletRequest
	 * @param idExpediente
	 *            Integer
	 * @param tipoOtraAyuda
	 *            Integer
	 * @param otrasAyudas
	 *            OtrasAyudas Bean que contiene la informacion con la que se va
	 *            a crear el nuevo registro.
	 * @return OtrasAyudas
	 */
	OtrasAyudas addConFiltro(HttpServletRequest httpRequest, Integer idExpediente, Integer tipoOtraAyuda,
			OtrasAyudas otrasAyudas, Usuario usuario);

	/**
	 * Updates a single row in the OtrasAyudas table.
	 *
	 * @param otrasAyudas
	 *            OtrasAyudas
	 * @return OtrasAyudas
	 */
	OtrasAyudas update(OtrasAyudas otrasAyudas);

	/**
	 * Updates a single row in the OtrasAyudas table.
	 *
	 * @param httpRequest
	 *            HttpServletRequest
	 * @param idExpediente
	 *            Integer
	 * @param tipoOtraAyuda
	 *            Integer
	 * @param otrasAyudas
	 *            OtrasAyudas
	 * @return OtrasAyudas
	 */
	OtrasAyudas editConFiltro(HttpServletRequest httpRequest, Integer idExpediente, Integer tipoOtraAyuda,
			OtrasAyudas otrasAyudas, Usuario usuario);

	/**
	 * Finds a single row in the OtrasAyudas table.
	 *
	 * @param otrasAyudas
	 *            OtrasAyudas
	 * @return OtrasAyudas
	 */
	OtrasAyudas find(OtrasAyudas otrasAyudas);

	/**
	 * Deletes a single row in the OtrasAyudas table.
	 *
	 * @param otrasAyudas
	 *            OtrasAyudas
	 */
	void remove(OtrasAyudas otrasAyudas);

	/**
	 * Deletes a single row in the OtrasAyudas table.
	 *
	 * @param idExpediente
	 *            Integer
	 * @param tipoOtraAyuda
	 *            Integer
	 * @param idOtraAyuda
	 *            Integer
	 */
	OtrasAyudas remove(Integer idExpediente, Integer tipoOtraAyuda, Integer idOtraAyuda);

	/**
	 * Finds a list of rows in the OtrasAyudas table.
	 *
	 * @param otrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<OtrasAyudas>
	 */
	List<OtrasAyudas> findAll(OtrasAyudas otrasAyudas, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the OtrasAyudas table using like.
	 *
	 * @param otrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<OtrasAyudas>
	 */
	List<OtrasAyudas> findAllLike(OtrasAyudas otrasAyudas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the OtrasAyudas table.
	 *
	 * @param filterOtrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(OtrasAyudas filterOtrasAyudas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the OtrasAyudas table.
	 *
	 * @param filterOtrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<OtrasAyudas>
	 */
	JQGridResponseDto<OtrasAyudas> filter(OtrasAyudas filterOtrasAyudas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the OtrasAyudas table.
	 *
	 * @param filterOtrasAyudas
	 *            OtrasAyudas
	 * @param searchOtrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OtrasAyudas>>
	 */
	List<TableRowDto<OtrasAyudas>> search(OtrasAyudas filterOtrasAyudas, OtrasAyudas searchOtrasAyudas,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in OtrasAyudas table.
	 *
	 * @param filterOtrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(OtrasAyudas filterOtrasAyudas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the OtrasAyudas table.
	 *
	 * @param filterOtrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<OtrasAyudas>>
	 */
	JQGridResponseDto<JerarquiaDto<OtrasAyudas>> jerarquia(OtrasAyudas filterOtrasAyudas,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the OtrasAyudas
	 * table.
	 *
	 * @param filterOtrasAyudas
	 *            OtrasAyudas
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<OtrasAyudas>>
	 */
	JQGridResponseDto<JerarquiaDto<OtrasAyudas>> jerarquiaChildren(OtrasAyudas filterOtrasAyudas,
			JQGridRequestDto jqGridRequestDto);

}
