package com.ejie.ab60.service.estudioTecnico;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.estudioTecnico.Poblaciones;

/**
 * PoblacionesService  
 * 
 *  
 */

public interface PoblacionesService {

	/**
	 * Inserts a single row in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @return Poblaciones
	 */
	Poblaciones add(Poblaciones poblaciones);

	/**
	 * Updates a single row in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @return Poblaciones
	 */
	Poblaciones update(Poblaciones poblaciones);

	/**
	 * Finds a single row in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @return Poblaciones
	 */
	Poblaciones find(Poblaciones poblaciones);

	/**
	 * Deletes a single row in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 */
	void remove(Poblaciones poblaciones);

	/**
	 * Finds a list of rows in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Poblaciones>
	 */
	List<Poblaciones> findAll(Poblaciones poblaciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Poblaciones>
	 */
	List<Poblaciones> findByConvocatoria(Integer idConvocatoria);

	/**
	 * Finds rows in the Poblaciones table using like.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Poblaciones>
	 */
	List<Poblaciones> findAllLike(Poblaciones poblaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Poblaciones table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Poblaciones filterPoblaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Poblaciones table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Poblaciones>
	 */
	JQGridResponseDto<Poblaciones> filter(Poblaciones filterPoblaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the Poblaciones table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param searchPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Poblaciones>>
	 */
	List<TableRowDto<Poblaciones>> search(Poblaciones filterPoblaciones, Poblaciones searchPoblaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in Poblaciones table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Poblaciones filterPoblaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Poblaciones table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Poblaciones>>
	 */
	JQGridResponseDto<JerarquiaDto<Poblaciones>> jerarquia(Poblaciones filterPoblaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Poblaciones
	 * table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Poblaciones>>
	 */
	JQGridResponseDto<JerarquiaDto<Poblaciones>> jerarquiaChildren(Poblaciones filterPoblaciones,
			JQGridRequestDto jqGridRequestDto);

}
