package com.ejie.ab60.service.estudioTecnico;

import com.ejie.ab60.dao.estudioTecnico.PoblacionesDao;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.model.estudioTecnico.Poblaciones;

/**
 * PoblacionesServiceImpl  
 * 
 *  
 */

@Service(value = "poblacionesService")
public class PoblacionesServiceImpl implements PoblacionesService {

	@Autowired
	private PoblacionesDao poblacionesDao;

	/**
	 * Inserts a single row in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @return Poblaciones
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Poblaciones add(Poblaciones poblaciones) {
		return this.poblacionesDao.add(poblaciones);
	}

	/**
	 * Updates a single row in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @return Poblaciones
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Poblaciones update(Poblaciones poblaciones) {
		return this.poblacionesDao.update(poblaciones);
	}

	/**
	 * Finds a single row in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @return Poblaciones
	 */
	public Poblaciones find(Poblaciones poblaciones) {
		return (Poblaciones) this.poblacionesDao.find(poblaciones);
	}

	/**
	 * Deletes a single row in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(Poblaciones poblaciones) {
		this.poblacionesDao.remove(poblaciones);
	}

	/**
	 * Finds a list of rows in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Poblaciones>
	 */
	public List<Poblaciones> findAll(Poblaciones poblaciones, JQGridRequestDto jqGridRequestDto) {
		return (List<Poblaciones>) this.poblacionesDao.findAll(poblaciones, jqGridRequestDto);
	}

	/**
	 * Finds a list of rows in the Poblaciones table.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Poblaciones>
	 */
	public List<Poblaciones> findByConvocatoria(Integer idConvocatoria) {
		return (List<Poblaciones>) this.poblacionesDao.findByConvocatoria(idConvocatoria);
	}

	/**
	 * Finds rows in the Poblaciones table using like.
	 *
	 * @param poblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Poblaciones>
	 */
	public List<Poblaciones> findAllLike(Poblaciones poblaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<Poblaciones>) this.poblacionesDao.findAllLike(poblaciones, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Poblaciones table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(Poblaciones filterPoblaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.poblacionesDao.removeMultiple(filterPoblaciones, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the Poblaciones table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Poblaciones>
	 */
	public JQGridResponseDto<Poblaciones> filter(Poblaciones filterPoblaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<Poblaciones> listaPoblaciones = this.poblacionesDao.findAllLike(filterPoblaciones, jqGridRequestDto,
				false);
		Long recordNum = this.poblacionesDao
				.findAllLikeCount(filterPoblaciones != null ? filterPoblaciones : new Poblaciones(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<Poblaciones>> reorderSelection = this.poblacionesDao.reorderSelection(filterPoblaciones,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<Poblaciones>(jqGridRequestDto, recordNum, listaPoblaciones, reorderSelection);
		}
		return new JQGridResponseDto<Poblaciones>(jqGridRequestDto, recordNum, listaPoblaciones);
	}

	/**
	 * Searches rows in the Poblaciones table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param searchPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Poblaciones>>
	 */
	public List<TableRowDto<Poblaciones>> search(Poblaciones filterPoblaciones, Poblaciones searchPoblaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.poblacionesDao.search(filterPoblaciones, searchPoblaciones, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in Poblaciones table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(Poblaciones filterPoblaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.poblacionesDao.reorderSelection(filterPoblaciones, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Poblaciones table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Poblaciones>>
	 */
	public JQGridResponseDto<JerarquiaDto<Poblaciones>> jerarquia(Poblaciones filterPoblaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<Poblaciones>> listaPoblaciones = this.poblacionesDao.findAllLikeJerarquia(filterPoblaciones,
				jqGridRequestDto);
		Long recordNum = this.poblacionesDao.findAllLikeCountJerarquia(filterPoblaciones, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<Poblaciones>>(jqGridRequestDto, recordNum, listaPoblaciones);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the Poblaciones
	 * table.
	 *
	 * @param filterPoblaciones
	 *            Poblaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Poblaciones>>
	 */
	public JQGridResponseDto<JerarquiaDto<Poblaciones>> jerarquiaChildren(Poblaciones filterPoblaciones,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<Poblaciones>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<Poblaciones>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.poblacionesDao.findAllChild(filterPoblaciones, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
