package com.ejie.ab60.service.estudioTecnico;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.estudioTecnico.RelExpErrCal;

/**
 * RelExpErrCalService  
 * 
 *  
 */

public interface RelExpErrCalService {

	/**
	 * Inserts a single row in the RelExpErrCal table.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 * @return RelExpErrCal
	 */
	RelExpErrCal add(RelExpErrCal relExpErrCal);

	/**
	 * Updates a single row in the RelExpErrCal table.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 * @return RelExpErrCal
	 */
	RelExpErrCal update(RelExpErrCal relExpErrCal);

	/**
	 * Finds a single row in the RelExpErrCal table.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 * @return RelExpErrCal
	 */
	RelExpErrCal find(RelExpErrCal relExpErrCal);

	/**
	 * Finds a single row in the RelExpErrCal table.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 * @return RelExpErrCal
	 */
	List<RelExpErrCal> findLimites(RelExpErrCal relexperrcal);

	/**
	 * Deletes a single row in the RelExpErrCal table.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 */
	void remove(RelExpErrCal relExpErrCal);

	/**
	 * Finds a list of rows in the RelExpErrCal table.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelExpErrCal>
	 */
	List<RelExpErrCal> findAll(RelExpErrCal relExpErrCal, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelExpErrCal table using like.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelExpErrCal>
	 */
	List<RelExpErrCal> findAllLike(RelExpErrCal relExpErrCal, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelExpErrCal table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpErrCal filterRelExpErrCal, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelExpErrCal table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpErrCal>
	 */
	JQGridResponseDto<RelExpErrCal> filter(RelExpErrCal filterRelExpErrCal, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelExpErrCal table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param searchRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpErrCal>>
	 */
	List<TableRowDto<RelExpErrCal>> search(RelExpErrCal filterRelExpErrCal, RelExpErrCal searchRelExpErrCal,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelExpErrCal table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelExpErrCal filterRelExpErrCal, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelExpErrCal table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelExpErrCal>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpErrCal>> jerarquia(RelExpErrCal filterRelExpErrCal,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelExpErrCal
	 * table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelExpErrCal>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpErrCal>> jerarquiaChildren(RelExpErrCal filterRelExpErrCal,
			JQGridRequestDto jqGridRequestDto);

}
