package com.ejie.ab60.service.estudioTecnico;

import com.ejie.ab60.dao.estudioTecnico.RelExpErrCalDao;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.model.estudioTecnico.RelExpErrCal;

/**
 * RelExpErrCalServiceImpl  
 * 
 *  
 */

@Service(value = "relExpErrCalService")
public class RelExpErrCalServiceImpl implements RelExpErrCalService {

	@Autowired
	private RelExpErrCalDao relExpErrCalDao;

	/**
	 * Inserts a single row in the RelExpErrCal table.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 * @return RelExpErrCal
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpErrCal add(RelExpErrCal relExpErrCal) {
		return this.relExpErrCalDao.add(relExpErrCal);
	}

	/**
	 * Updates a single row in the RelExpErrCal table.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 * @return RelExpErrCal
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelExpErrCal update(RelExpErrCal relExpErrCal) {
		return this.relExpErrCalDao.update(relExpErrCal);
	}

	/**
	 * Finds a single row in the RelExpErrCal table.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 * @return RelExpErrCal
	 */
	public RelExpErrCal find(RelExpErrCal relExpErrCal) {
		return (RelExpErrCal) this.relExpErrCalDao.find(relExpErrCal);
	}

	/**
	 * Finds a single row in the RelExpErrCal table.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 * @return RelExpErrCal
	 */
	public List<RelExpErrCal> findLimites(RelExpErrCal relexperrcal) {
		return (List<RelExpErrCal>) this.relExpErrCalDao.findLimites(relexperrcal);
	}

	/**
	 * Deletes a single row in the RelExpErrCal table.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(RelExpErrCal relExpErrCal) {
		this.relExpErrCalDao.remove(relExpErrCal);
	}

	/**
	 * Finds a list of rows in the RelExpErrCal table.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelExpErrCal>
	 */
	public List<RelExpErrCal> findAll(RelExpErrCal relExpErrCal, JQGridRequestDto jqGridRequestDto) {
		return (List<RelExpErrCal>) this.relExpErrCalDao.findAll(relExpErrCal, jqGridRequestDto);
	}

	/**
	 * Finds rows in the RelExpErrCal table using like.
	 *
	 * @param relExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelExpErrCal>
	 */
	public List<RelExpErrCal> findAllLike(RelExpErrCal relExpErrCal, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<RelExpErrCal>) this.relExpErrCalDao.findAllLike(relExpErrCal, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelExpErrCal table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(RelExpErrCal filterRelExpErrCal, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.relExpErrCalDao.removeMultiple(filterRelExpErrCal, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the RelExpErrCal table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpErrCal>
	 */
	public JQGridResponseDto<RelExpErrCal> filter(RelExpErrCal filterRelExpErrCal, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<RelExpErrCal> listaRelExpErrCal = this.relExpErrCalDao.findAllLike(filterRelExpErrCal, jqGridRequestDto,
				false);
		Long recordNum = this.relExpErrCalDao
				.findAllLikeCount(filterRelExpErrCal != null ? filterRelExpErrCal : new RelExpErrCal(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelExpErrCal>> reorderSelection = this.relExpErrCalDao.reorderSelection(filterRelExpErrCal,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelExpErrCal>(jqGridRequestDto, recordNum, listaRelExpErrCal,
					reorderSelection);
		}
		return new JQGridResponseDto<RelExpErrCal>(jqGridRequestDto, recordNum, listaRelExpErrCal);
	}

	/**
	 * Searches rows in the RelExpErrCal table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param searchRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpErrCal>>
	 */
	public List<TableRowDto<RelExpErrCal>> search(RelExpErrCal filterRelExpErrCal, RelExpErrCal searchRelExpErrCal,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.relExpErrCalDao.search(filterRelExpErrCal, searchRelExpErrCal, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in RelExpErrCal table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(RelExpErrCal filterRelExpErrCal, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.relExpErrCalDao.reorderSelection(filterRelExpErrCal, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelExpErrCal table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelExpErrCal>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelExpErrCal>> jerarquia(RelExpErrCal filterRelExpErrCal,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<RelExpErrCal>> listaRelExpErrCal = this.relExpErrCalDao
				.findAllLikeJerarquia(filterRelExpErrCal, jqGridRequestDto);
		Long recordNum = this.relExpErrCalDao.findAllLikeCountJerarquia(filterRelExpErrCal, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<RelExpErrCal>>(jqGridRequestDto, recordNum, listaRelExpErrCal);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the RelExpErrCal
	 * table.
	 *
	 * @param filterRelExpErrCal
	 *            RelExpErrCal
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelExpErrCal>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelExpErrCal>> jerarquiaChildren(RelExpErrCal filterRelExpErrCal,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<RelExpErrCal>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<RelExpErrCal>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.relExpErrCalDao.findAllChild(filterRelExpErrCal, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
