package com.ejie.ab60.service.estudioTecnico;

import java.util.List;

import com.ejie.ab60.model.estudioTecnico.TecnicosResponsables;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;

/**
 * TecnicosResponsablesService  
 * 
 *  
 */

public interface TecnicosResponsablesService {

	/**
	 * Inserts a single row in the TecnicosResponsables table.
	 *
	 * @param tecnicosResponsables
	 *            TecnicosResponsables
	 * @return TecnicosResponsables
	 */
	TecnicosResponsables add(TecnicosResponsables tecnicosResponsables);

	/**
	 * Updates a single row in the TecnicosResponsables table.
	 *
	 * @param tecnicosResponsables
	 *            TecnicosResponsables
	 * @return TecnicosResponsables
	 */
	TecnicosResponsables update(TecnicosResponsables tecnicosResponsables);

	/**
	 * Finds a single row in the TecnicosResponsables table.
	 *
	 * @param tecnicosResponsables
	 *            TecnicosResponsables
	 * @return TecnicosResponsables
	 */
	TecnicosResponsables find(TecnicosResponsables tecnicosResponsables);

	/**
	 * Deletes a single row in the TecnicosResponsables table.
	 *
	 * @param tecnicosResponsables
	 *            TecnicosResponsables
	 */
	void remove(TecnicosResponsables tecnicosResponsables);

	/**
	 * Finds a list of rows in the TecnicosResponsables table.
	 *
	 * @param tecnicosResponsables
	 *            TecnicosResponsables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TecnicosResponsables>
	 */
	List<TecnicosResponsables> findAll(TecnicosResponsables tecnicosResponsables, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the TecnicosResponsables table.
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param justificacion
	 *            boolean
	 * 
	 * @return List<TecnicosResponsables>
	 */
	List<TecnicosResponsables> findTecnico(Integer idConvocatoria, Integer idExpediente, boolean justificacion);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter method in the TecnicosResponsables table.
	 *
	 * @param filterTecnicosResponsables
	 *            TecnicosResponsables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<TecnicosResponsables>
	 */
	JQGridResponseDto<TecnicosResponsables> filter(TecnicosResponsables filterTecnicosResponsables,
			JQGridRequestDto jqGridRequestDto);

}
