package com.ejie.ab60.service.estudioTecnico;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.estudioTecnico.TiposGasto;

/**
 * TiposGastoService  
 * 
 *  
 */

public interface TiposGastoService {

	/**
	 * Inserts a single row in the TiposGasto table.
	 *
	 * @param tiposGasto
	 *            TiposGasto
	 * @return TiposGasto
	 */
	TiposGasto add(TiposGasto tiposGasto);

	/**
	 * Updates a single row in the TiposGasto table.
	 *
	 * @param tiposGasto
	 *            TiposGasto
	 * @return TiposGasto
	 */
	TiposGasto update(TiposGasto tiposGasto);

	/**
	 * Finds a single row in the TiposGasto table.
	 *
	 * @param tiposGasto
	 *            TiposGasto
	 * @return TiposGasto
	 */
	TiposGasto find(TiposGasto tiposGasto);

	/**
	 * Deletes a single row in the TiposGasto table.
	 *
	 * @param tiposGasto
	 *            TiposGasto
	 */
	void remove(TiposGasto tiposGasto);

	/**
	 * Finds a list of rows in the TiposGasto table.
	 *
	 * @param tiposGasto
	 *            TiposGasto
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TiposGasto>
	 */
	List<TiposGasto> findAll(TiposGasto tiposGasto, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the TiposGasto table filtrado por idActSub. Cada
	 * actuacion subvencionable muestra unos tipos
	 *
	 * @param idCriterio
	 *            Integer
	 * @param idConvocatoria
	 * 
	 * @return List<TiposGasto>
	 */
	List<TiposGasto> findTiposGasto(Integer idCriterio, Integer idConvocatoria);

	/**
	 * Finds rows in the TiposGasto table using like.
	 *
	 * @param tiposGasto
	 *            TiposGasto
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposGasto>
	 */
	List<TiposGasto> findAllLike(TiposGasto tiposGasto, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposGasto table.
	 *
	 * @param filterTiposGasto
	 *            TiposGasto
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposGasto filterTiposGasto, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the TiposGasto table.
	 *
	 * @param filterTiposGasto
	 *            TiposGasto
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<TiposGasto>
	 */
	JQGridResponseDto<TiposGasto> filter(TiposGasto filterTiposGasto, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the TiposGasto table.
	 *
	 * @param filterTiposGasto
	 *            TiposGasto
	 * @param searchTiposGasto
	 *            TiposGasto
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposGasto>>
	 */
	List<TableRowDto<TiposGasto>> search(TiposGasto filterTiposGasto, TiposGasto searchTiposGasto,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in TiposGasto table.
	 *
	 * @param filterTiposGasto
	 *            TiposGasto
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(TiposGasto filterTiposGasto, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposGasto table.
	 *
	 * @param filterTiposGasto
	 *            TiposGasto
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposGasto>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposGasto>> jerarquia(TiposGasto filterTiposGasto,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the TiposGasto table.
	 *
	 * @param filterTiposGasto
	 *            TiposGasto
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposGasto>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposGasto>> jerarquiaChildren(TiposGasto filterTiposGasto,
			JQGridRequestDto jqGridRequestDto);

}
