package com.ejie.ab60.service.estudioTecnico;

import java.util.List;

import com.ejie.ab60.model.estudioTecnico.TiposResultado;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * TiposResultadoService  
 * 
 *  
 */

public interface TiposResultadoService {

	/**
	 * Inserts a single row in the TiposResultado table.
	 *
	 * @param tiposResultado
	 *            TiposResultado
	 * @return TiposResultado
	 */
	TiposResultado add(TiposResultado tiposResultado);

	/**
	 * Updates a single row in the TiposResultado table.
	 *
	 * @param tiposResultado
	 *            TiposResultado
	 * @return TiposResultado
	 */
	TiposResultado update(TiposResultado tiposResultado);

	/**
	 * Finds a single row in the TiposResultado table.
	 *
	 * @param tiposResultado
	 *            TiposResultado
	 * @return TiposResultado
	 */
	TiposResultado find(TiposResultado tiposResultado);

	/**
	 * Finds a list of rows in the Resultados table.
	 *
	 * 
	 * @return List<TiposResultado>
	 */
	List<TiposResultado> findResultado();

	/**
	 * Deletes a single row in the TiposResultado table.
	 *
	 * @param tiposResultado
	 *            TiposResultado
	 */

	void remove(TiposResultado tiposResultado);

	/**
	 * Finds a list of rows in the TiposResultado table.
	 *
	 * @param tiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TiposResultado>
	 */
	List<TiposResultado> findAll(TiposResultado tiposResultado, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposResultado table using like.
	 *
	 * @param tiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposResultado>
	 */
	List<TiposResultado> findAllLike(TiposResultado tiposResultado, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposResultado table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposResultado filterTiposResultado, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the TiposResultado table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<TiposResultado>
	 */
	JQGridResponseDto<TiposResultado> filter(TiposResultado filterTiposResultado, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the TiposResultado table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param searchTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposResultado>>
	 */
	List<TableRowDto<TiposResultado>> search(TiposResultado filterTiposResultado, TiposResultado searchTiposResultado,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in TiposResultado table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(TiposResultado filterTiposResultado, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposResultado table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposResultado>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposResultado>> jerarquia(TiposResultado filterTiposResultado,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the TiposResultado
	 * table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposResultado>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposResultado>> jerarquiaChildren(TiposResultado filterTiposResultado,
			JQGridRequestDto jqGridRequestDto);

}
