package com.ejie.ab60.service.estudioTecnico;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.estudioTecnico.TiposResultadoDao;
import com.ejie.ab60.model.estudioTecnico.TiposResultado;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * TiposResultadoServiceImpl  
 * 
 *  
 */

@Service(value = "tiposResultadoService")
public class TiposResultadoServiceImpl implements TiposResultadoService {

	@Autowired
	private TiposResultadoDao tiposResultadoDao;

	/**
	 * Inserts a single row in the TiposResultado table.
	 *
	 * @param tiposResultado
	 *            TiposResultado
	 * @return TiposResultado
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposResultado add(TiposResultado tiposResultado) {
		return this.tiposResultadoDao.add(tiposResultado);
	}

	/**
	 * Updates a single row in the TiposResultado table.
	 *
	 * @param tiposResultado
	 *            TiposResultado
	 * @return TiposResultado
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposResultado update(TiposResultado tiposResultado) {
		return this.tiposResultadoDao.update(tiposResultado);
	}

	/**
	 * Finds a single row in the TiposResultado table.
	 *
	 * @param tiposResultado
	 *            TiposResultado
	 * @return TiposResultado
	 */
	public TiposResultado find(TiposResultado tiposResultado) {
		return (TiposResultado) this.tiposResultadoDao.find(tiposResultado);
	}

	/**
	 * Finds a list of rows in the Resultados table.
	 *
	 * 
	 * @return List<TiposResultado>
	 */
	public List<TiposResultado> findResultado() {
		return (List<TiposResultado>) this.tiposResultadoDao.findResultado();
	}

	/**
	 * Deletes a single row in the TiposResultado table.
	 *
	 * @param tiposResultado
	 *            TiposResultado
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(TiposResultado tiposResultado) {
		this.tiposResultadoDao.remove(tiposResultado);
	}

	/**
	 * Finds a list of rows in the TiposResultado table.
	 *
	 * @param tiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TiposResultado>
	 */
	public List<TiposResultado> findAll(TiposResultado tiposResultado, JQGridRequestDto jqGridRequestDto) {
		return (List<TiposResultado>) this.tiposResultadoDao.findAll(tiposResultado, jqGridRequestDto);
	}

	/**
	 * Finds rows in the TiposResultado table using like.
	 *
	 * @param tiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposResultado>
	 */
	public List<TiposResultado> findAllLike(TiposResultado tiposResultado, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<TiposResultado>) this.tiposResultadoDao.findAllLike(tiposResultado, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposResultado table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(TiposResultado filterTiposResultado, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.tiposResultadoDao.removeMultiple(filterTiposResultado, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the TiposResultado table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<TiposResultado>
	 */
	public JQGridResponseDto<TiposResultado> filter(TiposResultado filterTiposResultado,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<TiposResultado> listaTiposResultado = this.tiposResultadoDao.findAllLike(filterTiposResultado,
				jqGridRequestDto, false);
		Long recordNum = this.tiposResultadoDao
				.findAllLikeCount(filterTiposResultado != null ? filterTiposResultado : new TiposResultado(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<TiposResultado>> reorderSelection = this.tiposResultadoDao
					.reorderSelection(filterTiposResultado, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<TiposResultado>(jqGridRequestDto, recordNum, listaTiposResultado,
					reorderSelection);
		}
		return new JQGridResponseDto<TiposResultado>(jqGridRequestDto, recordNum, listaTiposResultado);
	}

	/**
	 * Searches rows in the TiposResultado table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param searchTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposResultado>>
	 */
	public List<TableRowDto<TiposResultado>> search(TiposResultado filterTiposResultado,
			TiposResultado searchTiposResultado, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.tiposResultadoDao.search(filterTiposResultado, searchTiposResultado, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in TiposResultado table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(TiposResultado filterTiposResultado, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.tiposResultadoDao.reorderSelection(filterTiposResultado, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposResultado table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposResultado>>
	 */
	public JQGridResponseDto<JerarquiaDto<TiposResultado>> jerarquia(TiposResultado filterTiposResultado,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<TiposResultado>> listaTiposResultado = this.tiposResultadoDao
				.findAllLikeJerarquia(filterTiposResultado, jqGridRequestDto);
		Long recordNum = this.tiposResultadoDao.findAllLikeCountJerarquia(filterTiposResultado, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<TiposResultado>>(jqGridRequestDto, recordNum, listaTiposResultado);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the TiposResultado
	 * table.
	 *
	 * @param filterTiposResultado
	 *            TiposResultado
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposResultado>>
	 */
	public JQGridResponseDto<JerarquiaDto<TiposResultado>> jerarquiaChildren(TiposResultado filterTiposResultado,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<TiposResultado>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<TiposResultado>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.tiposResultadoDao.findAllChild(filterTiposResultado, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
