package com.ejie.ab60.service.expedientes;

import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.model.expedientes.MarcarInspeccionable;
import com.ejie.ab60.model.expedientes.MarcarInspeccionableAct;

/**
 * TiposAsociacionService  
 * 
 *  
 */

public interface MarcarInspeccionableService {

	MarcarInspeccionable findInspeccionable(MarcarInspeccionable marcarInspeccionable);

	MarcarInspeccionableAct findInspeccionableAct(MarcarInspeccionableAct marcarInspeccionableAct);

	/**
	 * Actualizar los datos del proyecto con la informción del envío a
	 * inspección
	 * 
	 * @param marcarInspeccionable
	 *            MarcarInspeccionable
	 * @param tipoInspeccion
	 *            Integer
	 * 
	 * @return String
	 */
	String guardarMarcarInspeccionable(MarcarInspeccionable marcarInspeccionable, Integer tipoInspeccion,
			String respuesta);

	/**
	 * Actualizar los datos del proyecto con la informción del envío a
	 * inspección
	 * 
	 * @param marcarInspeccionableAct
	 *            MarcarInspeccionableAct
	 * 
	 * @return String
	 */
	String guardarMarcarInspeccionableAct(MarcarInspeccionableAct marcarInspeccionableAct, String respuesta);

	String findDatosProyectoPorId(Integer idExpediente, Integer tipoInspeccion);

}
