package com.ejie.ab60.service.expedientes;

import com.ejie.ab60.model.expedientes.RelExpInsSinExp;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelExpInsSinExpService  
 * 
 *  
 */

public interface RelExpInsSinExpService {

	/**
	 * Inserts a single row in the RelExpInsSinExp table.
	 *
	 * @param relExpInsSinExp
	 *            RelExpInsSinExp
	 * @return RelExpInsSinExp
	 */
	RelExpInsSinExp add(RelExpInsSinExp relExpInsSinExp);

	/**
	 * Updates a single row in the RelExpInsSinExp table.
	 *
	 * @param relExpInsSinExp
	 *            RelExpInsSinExp
	 * @return RelExpInsSinExp
	 */
	RelExpInsSinExp update(RelExpInsSinExp relExpInsSinExp);

	/**
	 * Finds a single row in the RelExpInsSinExp table.
	 *
	 * @param relExpInsSinExp
	 *            RelExpInsSinExp
	 * @return RelExpInsSinExp
	 */
	RelExpInsSinExp find(RelExpInsSinExp relExpInsSinExp);

	/**
	 * Deletes a single row in the RelExpInsSinExp table.
	 *
	 * @param relExpInsSinExp
	 *            RelExpInsSinExp
	 */
	void remove(RelExpInsSinExp relExpInsSinExp);

	/**
	 * Finds a list of rows in the RelExpInsSinExp table.
	 *
	 * @param relExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelExpInsSinExp>
	 */
	List<RelExpInsSinExp> findAll(RelExpInsSinExp relExpInsSinExp, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelExpInsSinExp table using like.
	 *
	 * @param relExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelExpInsSinExp>
	 */
	List<RelExpInsSinExp> findAllLike(RelExpInsSinExp relExpInsSinExp, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelExpInsSinExp table.
	 *
	 * @param filterRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpInsSinExp filterRelExpInsSinExp, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelExpInsSinExp table.
	 *
	 * @param filterRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpInsSinExp>
	 */
	JQGridResponseDto<RelExpInsSinExp> filter(RelExpInsSinExp filterRelExpInsSinExp, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelExpInsSinExp table.
	 *
	 * @param filterRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param searchRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpInsSinExp>>
	 */
	List<TableRowDto<RelExpInsSinExp>> search(RelExpInsSinExp filterRelExpInsSinExp,
			RelExpInsSinExp searchRelExpInsSinExp, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelExpInsSinExp table.
	 *
	 * @param filterRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelExpInsSinExp filterRelExpInsSinExp, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelExpInsSinExp table.
	 *
	 * @param filterRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelExpInsSinExp>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpInsSinExp>> jerarquia(RelExpInsSinExp filterRelExpInsSinExp,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelExpInsSinExp
	 * table.
	 *
	 * @param filterRelExpInsSinExp
	 *            RelExpInsSinExp
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelExpInsSinExp>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpInsSinExp>> jerarquiaChildren(RelExpInsSinExp filterRelExpInsSinExp,
			JQGridRequestDto jqGridRequestDto);

	JQGridResponseDto<RelExpInsSinExp> filterInspeccionesRelacionadasUbicacion(Integer idExpediente,
			JQGridRequestDto jqGridRequestDto);

}
