package com.ejie.ab60.service.justificacion;

import java.util.List;

import com.ejie.ab60.model.estudioTecnico.EstudioTecnico;
import com.ejie.ab60.model.expedientes.MarcarInspeccionable;
import com.ejie.ab60.model.justificacion.Justificacion;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * JustificacionService  
 * 
 *  
 */

public interface JustificacionService {

	/**
	 * Finds a single row in the Justificacion table.
	 *
	 * @param justificacion
	 *            Justificacion
	 * @return Justificacion
	 */
	Justificacion find(Justificacion justificacion);

	/**
	 * Deletes a single row in the Justificacion table.
	 *
	 * @param justificacion
	 *            Justificacion
	 */
	void remove(Justificacion justificacion);

	/**
	 * Metod para hacer un update de justificacion
	 * 
	 * @param tercero
	 * @return Justificacion Bean resultante del proceso de creacion
	 */
	Justificacion saveJustificacion(Justificacion justificacion, Usuario usuario, Integer idExpediente,
			Integer idConvocatoria);

	/**
	 * Select de todos los importes de Estudio de tecnico
	 *
	 * @param idExpediente
	 *            Integer
	 * @return EstudioTecnico
	 */
	Justificacion refescarImportes(Integer idExpediente);
}
