package com.ejie.ab60.service.justificacion;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.comun.Constantes;

import com.ejie.ab60.dao.CTP.ProyectosDao;
import com.ejie.ab60.dao.actuacionesSubvencionables.RelExpActSubDao;
import com.ejie.ab60.dao.criteriosPuntuacion.RelExpCriPunDao;
import com.ejie.ab60.dao.justificacion.JustificacionDao;
import com.ejie.ab60.model.CTP.AsociacionesSectoriales;
import com.ejie.ab60.model.CTP.Proyectos;
import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.ab60.model.criteriosPuntuacion.CriteriosPuntuacion;
import com.ejie.ab60.model.criteriosPuntuacion.RelExpCriPun;
import com.ejie.ab60.model.estudioTecnico.EstudioTecnico;
import com.ejie.ab60.model.expedientes.MarcarInspeccionable;
import com.ejie.ab60.model.justificacion.Justificacion;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.ab60.service.actuacionesSubvencionables.RelExpActSubService;
import com.ejie.ab60.service.convocatorias.ConvocatoriasService;
import com.ejie.ab60.service.estudioTecnico.EstudioTecnicoServiceImpl;
import com.ejie.ab60.service.repartoAyuda.RepartoAyudaService;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * JustificacionServiceImpl  
 * 
 *  
 */

@Service(value = "justificacionService")
public class JustificacionServiceImpl implements JustificacionService {

	private static final Logger logger = LoggerFactory.getLogger(JustificacionService.class);

	@Autowired
	private JustificacionDao justificacionDao;

	@Autowired
	private RepartoAyudaService repartoAyudaService;

	@Autowired
	private ConvocatoriasService convocatoriasService;
	@Autowired
	private RelExpActSubDao relExpActSubDao;

	@Autowired
	private RelExpActSubService relExpActSubService;
	@Autowired
	private RelExpCriPunDao relExpCriPunDao;

	@Autowired
	private ProyectosDao proyectosDao;

	/**
	 * Inserts a single row in the Justificacion table.
	 *
	 * @param justificacion
	 *            Justificacion
	 * @return Justificacion
	 */
	/*
	 * @Transactional(rollbackFor = Throwable.class) public Justificacion
	 * add(Justificacion justificacion) { return
	 * this.justificacionDao.add(justificacion); }
	 */

	/**
	 * Updates a single row in the Justificacion table.
	 *
	 * @param justificacion
	 *            Justificacion
	 * @return Justificacion
	 */
	/*
	 * @Transactional(rollbackFor = Throwable.class) public Justificacion
	 * update(Justificacion justificacion) { return
	 * this.justificacionDao.update(justificacion); }
	 */

	/**
	 * Update importes de Justificacion
	 *
	 * @param datosproyecto
	 *            Justificacion
	 * @return Justificacion
	 */
	/*
	 * @Transactional(rollbackFor = Throwable.class) public Justificacion
	 * updateImporte(Justificacion justificacion) { return
	 * this.justificacionDao.updateImporte(justificacion); }
	 */

	/**
	 * Update SUBVENCION_RESUELTA de Justificacion
	 *
	 * @param datosproyecto
	 *            Justificacion
	 * @return Justificacion
	 */
	/*
	 * public Justificacion updateSubvencionResuelta(Justificacion
	 * datosproyecto) { return
	 * this.justificacionDao.updateSubvencionResuelta(datosproyecto); }
	 */

	/**
	 * Update Habilitar subvencion resuelta de Justificacion
	 *
	 * @param datosproyecto
	 *            Justificacion
	 * @return Justificacion
	 */
	/*
	 * public Justificacion updateHabilitar(Justificacion datosproyecto) {
	 * return this.justificacionDao.updateHabilitar(datosproyecto); }
	 */

	/**
	 * Cambiar valor al campo expedienteValidado si validamos expediente.
	 *
	 * @param datosproyecto
	 *            Justificacion
	 * @return Justificacion
	 */
	/*
	 * public Justificacion updateExpedienteValidado(Justificacion
	 * datosproyecto) { return
	 * this.justificacionDao.updateExpedienteValidado(datosproyecto); }
	 */

	/**
	 * Update importeAdmitido de Justificacion
	 *
	 * @param datosproyecto
	 *            Justificacion
	 * @return Justificacion
	 */
	/*
	 * @Transactional(rollbackFor = Throwable.class) public Justificacion
	 * updateImporteAdmitido(Justificacion justificacion) { return
	 * this.justificacionDao.updateImporteAdmitido(justificacion); }
	 */

	/**
	 * Finds a single row in the Justificacion table. PARA CTP
	 *
	 * @param datosproyecto
	 *            Justificacion
	 * @return Justificacion
	 */

	/*
	 * public Justificacion findCTP(Justificacion justificacion) { return
	 * (Justificacion) this.justificacionDao.findCTP(justificacion); }
	 */

	/**
	 * Finds a single row in the Justificacion table.
	 *
	 * @param justificacion
	 *            Justificacion
	 * @return Justificacion
	 */
	public Justificacion find(Justificacion justificacion) {
		return (Justificacion) this.justificacionDao.find(justificacion);
	}

	/**
	 * Metod para hacer un update de estudio tecnico
	 * 
	 * @param tercero
	 * @return Justificacion Bean resultante del proceso de creacion
	 * @throws Exception
	 */

	public Justificacion saveJustificacion(Justificacion justificacion, Usuario usuario, Integer idExpediente,
			Integer idConvocatoria) {
		Date fecha = new Date();
		// Proyectos proyectos = estudioTecnico.getProyectos();

		if (justificacion.getBandera() != 0) {
			justificacion.setSubvencionResuelta(null);
			justificacion.setSubvencionJustificada(null);

			// Borarremos todo lo que haya referente a es idExpediente
			relExpCriPunDao.removeCriteriosPorExpediente(idExpediente);
			/*
			 * if (justificacion.getCriterios() != null) {
			 * EstudioTecnicoServiceImpl.logger.
			 * info("[obtener lista de criterios] ");
			 * 
			 * List<CriteriosPuntuacion> lcriterios = new
			 * ArrayList<CriteriosPuntuacion>(); CriteriosPuntuacion crit =
			 * null;
			 * 
			 * for (Integer criterio : estudioTecnico.getCriterios()) { crit =
			 * new CriteriosPuntuacion(); crit.setIdCriterio(criterio);
			 * lcriterios.add(crit); }
			 * 
			 * RelExpCriPun relExpCriPun = null; for (int i = 0; i <
			 * lcriterios.size(); i++) { // crear un objeto relExpCriPun = new
			 * RelExpCriPun(); relExpCriPun.setIdExpediente(idExpediente);
			 * relExpCriPun.setCriteriosPuntuacion(lcriterios.get(i));
			 * relExpCriPun.setFechaRegistro(fecha);
			 * 
			 * relExpCriPun.setUsuarioRegistro(usuario.getNombreUsuario());
			 * relExpCriPunDao.add(relExpCriPun);
			 * 
			 * EstudioTecnicoServiceImpl.logger.info("[Anyadir criterios] "); }
			 * 
			 * }
			 */
			// quitar sub calculada de relexpactsub
			RelExpActSub relExpActSub = new RelExpActSub();
			relExpActSub.setIdExpediente(idExpediente);
			relExpActSub.setFechaUltmodificacion(fecha);
			relExpActSub.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			relExpActSub.setSubvencionCalculada(null);
			relExpActSub.setPorcentaje(null);

			relExpActSub = this.relExpActSubDao.updateImporteSubvencionCalculada(relExpActSub);
			JustificacionServiceImpl.logger
					.info("[POST - filter] : Updatear subvencion calculada y porcenataje en  RelExpActSubs");

		}
		/*
		 * if (null != proyectos && null !=
		 * proyectos.getAsociacionesSectoriales()) {
		 * proyectos.setFechaUltmodificacion(fecha);
		 * proyectos.setUsuarioUltmodificacion(usuario.getNombreUsuario());
		 * proyectos.setIdExpediente(idExpediente); AsociacionesSectoriales
		 * asociacionesSectoriales = proyectos.getAsociacionesSectoriales();
		 * 
		 * asociacionesSectoriales
		 * .setIdAsociacion(estudioTecnico.getProyectos().
		 * getAsociacionesSectoriales().getIdAsociacion());
		 * proyectos.setAsociacionesSectoriales(asociacionesSectoriales);
		 * proyectosDao.updateIdAsociacion(proyectos);
		 * 
		 * }
		 */
		if (justificacion.getTecnicosResponsables() != null
				&& justificacion.getTecnicosResponsables().getIdTecnicoResponsable() == 0) {
			justificacion.getTecnicosResponsables().setIdTecnicoResponsable(null);
		}
		if (justificacion.getMotivosIncumplimiento() != null
				&& justificacion.getMotivosIncumplimiento().getIdMotivoIncumplimiento() == 0) {
			justificacion.getMotivosIncumplimiento().setIdMotivoIncumplimiento(null);
		}
		if (justificacion.getTiposResJus() != null && justificacion.getTiposResJus().getIdResJustificacion() == 0) {
			justificacion.getTiposResJus().setIdResJustificacion(null);
		}

		justificacion.setFechaUltmodificacion(fecha);
		justificacion.setUsuarioUltmodificacion(usuario.getNombreUsuario());

		justificacion
				.setFechaInformeStr(UtilDate.convertirStringEnStringFormateado(justificacion.getFechaInformeStr()));

		this.update(justificacion);

		JustificacionServiceImpl.logger.info("[Updatear expediente] ");

		if ((null != justificacion.getTiposResJus() && null != justificacion.getTiposResJus().getIdResJustificacion())
				&& (Constantes.IDRESULTADO_DESESTIMADA == justificacion.getTiposResJus().getIdResJustificacion())) {

			try {
				relExpActSubService.ponerImportesNulosACero(idExpediente, idConvocatoria, usuario);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}

		return justificacion;

	}

	/**
	 * Deletes a single row in the Justificacion table.
	 *
	 * @param justificacion
	 *            Justificacion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(Justificacion justificacion) {
		this.justificacionDao.remove(justificacion);
	}

	/**
	 * Updates a single row in the Justificacion table.
	 *
	 * @param justificacion
	 *            Justificacion
	 * @return Justificacion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Justificacion update(Justificacion justificacion) {
		return this.justificacionDao.update(justificacion);
	}

	/**
	 * Select de todos los importes de Estudio de tecnico
	 *
	 * @param idExpediente
	 *            Integer
	 * @return EstudioTecnico
	 */
	public Justificacion refescarImportes(Integer idExpediente) {
		return (Justificacion) this.justificacionDao.refescarImportes(idExpediente);
	}
}
