package com.ejie.ab60.service.justificacion;

import com.ejie.ab60.model.justificacion.MotivosIncumplimiento;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * MotivosIncumplimientoService  
 * 
 *  
 */

public interface MotivosIncumplimientoService {

	/**
	 * Inserts a single row in the MotivosIncumplimiento table.
	 *
	 * @param motivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @return MotivosIncumplimiento
	 */
	MotivosIncumplimiento add(MotivosIncumplimiento motivosIncumplimiento);

	/**
	 * Updates a single row in the MotivosIncumplimiento table.
	 *
	 * @param motivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @return MotivosIncumplimiento
	 */
	MotivosIncumplimiento update(MotivosIncumplimiento motivosIncumplimiento);

	/**
	 * Finds a single row in the MotivosIncumplimiento table.
	 *
	 * @param motivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @return MotivosIncumplimiento
	 */
	MotivosIncumplimiento find(MotivosIncumplimiento motivosIncumplimiento);

	/**
	 * Deletes a single row in the MotivosIncumplimiento table.
	 *
	 * @param motivosIncumplimiento
	 *            MotivosIncumplimiento
	 */
	void remove(MotivosIncumplimiento motivosIncumplimiento);

	/**
	 * Finds a list of rows in the MotivosIncumplimiento table.
	 *
	 * @param motivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<MotivosIncumplimiento>
	 */
	List<MotivosIncumplimiento> findAll(MotivosIncumplimiento motivosIncumplimiento, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the MotivosIncumplimiento table using like.
	 *
	 * @param motivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<MotivosIncumplimiento>
	 */
	List<MotivosIncumplimiento> findAllLike(MotivosIncumplimiento motivosIncumplimiento,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(MotivosIncumplimiento filterMotivosIncumplimiento, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<MotivosIncumplimiento>
	 */
	JQGridResponseDto<MotivosIncumplimiento> filter(MotivosIncumplimiento filterMotivosIncumplimiento,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param searchMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosIncumplimiento>>
	 */
	List<TableRowDto<MotivosIncumplimiento>> search(MotivosIncumplimiento filterMotivosIncumplimiento,
			MotivosIncumplimiento searchMotivosIncumplimiento, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(MotivosIncumplimiento filterMotivosIncumplimiento, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<MotivosIncumplimiento>>
	 */
	JQGridResponseDto<JerarquiaDto<MotivosIncumplimiento>> jerarquia(MotivosIncumplimiento filterMotivosIncumplimiento,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<MotivosIncumplimiento>>
	 */
	JQGridResponseDto<JerarquiaDto<MotivosIncumplimiento>> jerarquiaChildren(
			MotivosIncumplimiento filterMotivosIncumplimiento, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the TecnicosResponsables table.
	 *
	 * 
	 * @return List<TecnicosResponsables>
	 */
	List<MotivosIncumplimiento> findMotivo();

}
