package com.ejie.ab60.service.justificacion;

import com.ejie.ab60.dao.justificacion.MotivosIncumplimientoDao;
import com.ejie.ab60.model.justificacion.MotivosIncumplimiento;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * MotivosIncumplimientoServiceImpl  
 * 
 *  
 */

@Service(value = "motivosIncumplimientoService")
public class MotivosIncumplimientoServiceImpl implements MotivosIncumplimientoService {

	@Autowired
	private MotivosIncumplimientoDao motivosIncumplimientoDao;

	/**
	 * Inserts a single row in the MotivosIncumplimiento table.
	 *
	 * @param motivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @return MotivosIncumplimiento
	 */
	@Transactional(rollbackFor = Throwable.class)
	public MotivosIncumplimiento add(MotivosIncumplimiento motivosIncumplimiento) {
		return this.motivosIncumplimientoDao.add(motivosIncumplimiento);
	}

	/**
	 * Updates a single row in the MotivosIncumplimiento table.
	 *
	 * @param motivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @return MotivosIncumplimiento
	 */
	@Transactional(rollbackFor = Throwable.class)
	public MotivosIncumplimiento update(MotivosIncumplimiento motivosIncumplimiento) {
		return this.motivosIncumplimientoDao.update(motivosIncumplimiento);
	}

	/**
	 * Finds a single row in the MotivosIncumplimiento table.
	 *
	 * @param motivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @return MotivosIncumplimiento
	 */
	public MotivosIncumplimiento find(MotivosIncumplimiento motivosIncumplimiento) {
		return (MotivosIncumplimiento) this.motivosIncumplimientoDao.find(motivosIncumplimiento);
	}

	/**
	 * Deletes a single row in the MotivosIncumplimiento table.
	 *
	 * @param motivosIncumplimiento
	 *            MotivosIncumplimiento
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(MotivosIncumplimiento motivosIncumplimiento) {
		this.motivosIncumplimientoDao.remove(motivosIncumplimiento);
	}

	/**
	 * Finds a list of rows in the MotivosIncumplimiento table.
	 *
	 * @param motivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<MotivosIncumplimiento>
	 */
	public List<MotivosIncumplimiento> findAll(MotivosIncumplimiento motivosIncumplimiento,
			JQGridRequestDto jqGridRequestDto) {
		return (List<MotivosIncumplimiento>) this.motivosIncumplimientoDao.findAll(motivosIncumplimiento,
				jqGridRequestDto);
	}

	/**
	 * Finds rows in the MotivosIncumplimiento table using like.
	 *
	 * @param motivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<MotivosIncumplimiento>
	 */
	public List<MotivosIncumplimiento> findAllLike(MotivosIncumplimiento motivosIncumplimiento,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<MotivosIncumplimiento>) this.motivosIncumplimientoDao.findAllLike(motivosIncumplimiento,
				jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(MotivosIncumplimiento filterMotivosIncumplimiento, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.motivosIncumplimientoDao.removeMultiple(filterMotivosIncumplimiento, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<MotivosIncumplimiento>
	 */
	public JQGridResponseDto<MotivosIncumplimiento> filter(MotivosIncumplimiento filterMotivosIncumplimiento,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<MotivosIncumplimiento> listaMotivosIncumplimiento = this.motivosIncumplimientoDao
				.findAllLike(filterMotivosIncumplimiento, jqGridRequestDto, false);
		Long recordNum = this.motivosIncumplimientoDao.findAllLikeCount(
				filterMotivosIncumplimiento != null ? filterMotivosIncumplimiento : new MotivosIncumplimiento(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<MotivosIncumplimiento>> reorderSelection = this.motivosIncumplimientoDao
					.reorderSelection(filterMotivosIncumplimiento, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<MotivosIncumplimiento>(jqGridRequestDto, recordNum, listaMotivosIncumplimiento,
					reorderSelection);
		}
		return new JQGridResponseDto<MotivosIncumplimiento>(jqGridRequestDto, recordNum, listaMotivosIncumplimiento);
	}

	/**
	 * Searches rows in the MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param searchMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<MotivosIncumplimiento>>
	 */
	public List<TableRowDto<MotivosIncumplimiento>> search(MotivosIncumplimiento filterMotivosIncumplimiento,
			MotivosIncumplimiento searchMotivosIncumplimiento, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.motivosIncumplimientoDao.search(filterMotivosIncumplimiento, searchMotivosIncumplimiento,
				jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(MotivosIncumplimiento filterMotivosIncumplimiento, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.motivosIncumplimientoDao.reorderSelection(filterMotivosIncumplimiento, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<MotivosIncumplimiento>>
	 */
	public JQGridResponseDto<JerarquiaDto<MotivosIncumplimiento>> jerarquia(
			MotivosIncumplimiento filterMotivosIncumplimiento, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<MotivosIncumplimiento>> listaMotivosIncumplimiento = this.motivosIncumplimientoDao
				.findAllLikeJerarquia(filterMotivosIncumplimiento, jqGridRequestDto);
		Long recordNum = this.motivosIncumplimientoDao.findAllLikeCountJerarquia(filterMotivosIncumplimiento,
				jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<MotivosIncumplimiento>>(jqGridRequestDto, recordNum,
				listaMotivosIncumplimiento);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * MotivosIncumplimiento table.
	 *
	 * @param filterMotivosIncumplimiento
	 *            MotivosIncumplimiento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<MotivosIncumplimiento>>
	 */
	public JQGridResponseDto<JerarquiaDto<MotivosIncumplimiento>> jerarquiaChildren(
			MotivosIncumplimiento filterMotivosIncumplimiento, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<MotivosIncumplimiento>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<MotivosIncumplimiento>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.motivosIncumplimientoDao.findAllChild(filterMotivosIncumplimiento, jqGridRequestDto));
		return jqGridResponseDto;
	}

	/**
	 * Finds a list of rows in the Motivos table.
	 *
	 * 
	 * @return List<MotivosIncumplimiento>
	 */
	public List<MotivosIncumplimiento> findMotivo() {

		return (List<MotivosIncumplimiento>) this.motivosIncumplimientoDao.findMotivo();
	}

}
