package com.ejie.ab60.service.justificacion;

import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.ab60.model.justificacion.RelFacActSubvencionables;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelFacActSubvencionables  
 * 
 *  
 */

public interface RelFacActSubvencionablesService {

	/**
	 * Inserts a single row in the VActuacionesSubvencionables table.
	 *
	 * @param relFacActSubvencionables
	 *            VActuacionesSubvencionables
	 * @return VActuacionesSubvencionables
	 */
	RelFacActSubvencionables add(RelFacActSubvencionables relFacActSubvencionables);

	/**
	 * Updates a single row in the VActuacionesSubvencionables table.
	 *
	 * @param relFacActSubvencionables
	 *            VActuacionesSubvencionables
	 * @return VActuacionesSubvencionables
	 */
	RelFacActSubvencionables update(RelFacActSubvencionables relFacActSubvencionables);

	/**
	 * Finds a single row in the VActuacionesSubvencionables table.
	 *
	 * @param relFacActSubvencionables
	 *            VActuacionesSubvencionables
	 * @return VActuacionesSubvencionables
	 */
	RelFacActSubvencionables find(RelFacActSubvencionables relFacActSubvencionables);

	/**
	 * Deletes a single row in the VActuacionesSubvencionables table.
	 *
	 * @param relFacActSubvencionables
	 *            VActuacionesSubvencionables
	 */
	void remove(RelFacActSubvencionables relFacActSubvencionables);

	/**
	 * Finds a list of rows in the VActuacionesSubvencionables table.
	 *
	 * @param relFacActSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<VActuacionesSubvencionables>
	 */
	List<RelFacActSubvencionables> findAll(RelFacActSubvencionables relFacActSubvencionables,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the VActuacionesSubvencionables table using like.
	 *
	 * @param relFacActSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<VActuacionesSubvencionables>
	 */
	List<RelFacActSubvencionables> findAllLike(RelFacActSubvencionables relFacActSubvencionables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the VActuacionesSubvencionables table.
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelFacActSubvencionables filterVActuacionesSubvencionables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the VActuacionesSubvencionables table.
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<VActuacionesSubvencionables>
	 */
	JQGridResponseDto<RelFacActSubvencionables> filter(RelFacActSubvencionables filterVActuacionesSubvencionables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the VActuacionesSubvencionables table.
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param searchVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<VActuacionesSubvencionables>>
	 */
	List<TableRowDto<RelFacActSubvencionables>> search(RelFacActSubvencionables filterVActuacionesSubvencionables,
			RelFacActSubvencionables searchVActuacionesSubvencionables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Reorder the selection made in VActuacionesSubvencionables table.
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelFacActSubvencionables filterVActuacionesSubvencionables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the VActuacionesSubvencionables table.
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<VActuacionesSubvencionables>>
	 */
	JQGridResponseDto<JerarquiaDto<RelFacActSubvencionables>> jerarquia(
			RelFacActSubvencionables filterVActuacionesSubvencionables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * VActuacionesSubvencionables table.
	 *
	 * @param filterVActuacionesSubvencionables
	 *            VActuacionesSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<VActuacionesSubvencionables>>
	 */
	JQGridResponseDto<JerarquiaDto<RelFacActSubvencionables>> jerarquiaChildren(
			RelFacActSubvencionables filterVActuacionesSubvencionables, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the RelFacActSubvencionables table.
	 *
	 * @return List<RelFacActSubvencionables>
	 */
	public List<RelFacActSubvencionables> findActuaciones(Integer idExpediente);

}
