package com.ejie.ab60.service.justificacion;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.justificacion.RelFacActSubvencionablesDao;
import com.ejie.ab60.model.justificacion.RelFacActSubvencionables;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelFacActSubvencionablesServiceImpl  
 * 
 *  
 */

@Service(value = "RelFacActSubvencionablesService")
public class RelFacActSubvencionablesServiceImpl implements RelFacActSubvencionablesService {

	@Autowired
	private RelFacActSubvencionablesDao relFacActSubvencionablesDao;

	/**
	 * Inserts a single row in the RelFacActSubvencionables table.
	 *
	 * @param relFacActSubvencionables
	 *            RelFacActSubvencionables
	 * @return RelFacActSubvencionables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelFacActSubvencionables add(RelFacActSubvencionables relFacActSubvencionables) {
		return this.relFacActSubvencionablesDao.add(relFacActSubvencionables);
	}

	/**
	 * Updates a single row in the RelFacActSubvencionables table.
	 *
	 * @param relFacActSubvencionables
	 *            RelFacActSubvencionables
	 * @return RelFacActSubvencionables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelFacActSubvencionables update(RelFacActSubvencionables relFacActSubvencionables) {
		return this.relFacActSubvencionablesDao.update(relFacActSubvencionables);
	}

	/**
	 * Finds a single row in the RelFacActSubvencionables table.
	 *
	 * @param relFacActSubvencionables
	 *            RelFacActSubvencionables
	 * @return RelFacActSubvencionables
	 */
	public RelFacActSubvencionables find(RelFacActSubvencionables relFacActSubvencionables) {
		return (RelFacActSubvencionables) this.relFacActSubvencionablesDao.find(relFacActSubvencionables);
	}

	/**
	 * Deletes a single row in the RelFacActSubvencionables table.
	 *
	 * @param relFacActSubvencionables
	 *            RelFacActSubvencionables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(RelFacActSubvencionables relFacActSubvencionables) {
		this.relFacActSubvencionablesDao.remove(relFacActSubvencionables);
	}

	/**
	 * Finds a list of rows in the RelFacActSubvencionables table.
	 *
	 * @param relFacActSubvencionables
	 *            RelFacActSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelFacActSubvencionables>
	 */
	public List<RelFacActSubvencionables> findAll(RelFacActSubvencionables relFacActSubvencionables,
			JQGridRequestDto jqGridRequestDto) {
		return (List<RelFacActSubvencionables>) this.relFacActSubvencionablesDao.findAll(relFacActSubvencionables,
				jqGridRequestDto);
	}

	/**
	 * Finds rows in the RelFacActSubvencionables table using like.
	 *
	 * @param relFacActSubvencionables
	 *            RelFacActSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelFacActSubvencionables>
	 */
	public List<RelFacActSubvencionables> findAllLike(RelFacActSubvencionables relFacActSubvencionables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<RelFacActSubvencionables>) this.relFacActSubvencionablesDao.findAllLike(relFacActSubvencionables,
				jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelFacActSubvencionables table.
	 *
	 * @param filterRelFacActSubvencionables
	 *            RelFacActSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(RelFacActSubvencionables filterRelFacActSubvencionables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.relFacActSubvencionablesDao.removeMultiple(filterRelFacActSubvencionables, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the RelFacActSubvencionables table.
	 *
	 * @param filterRelFacActSubvencionables
	 *            RelFacActSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelFacActSubvencionables>
	 */
	public JQGridResponseDto<RelFacActSubvencionables> filter(RelFacActSubvencionables filterRelFacActSubvencionables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<RelFacActSubvencionables> listaRelFacActSubvencionables = this.relFacActSubvencionablesDao
				.findAllLike(filterRelFacActSubvencionables, jqGridRequestDto, false);
		Long recordNum = this.relFacActSubvencionablesDao.findAllLikeCount(filterRelFacActSubvencionables != null
				? filterRelFacActSubvencionables : new RelFacActSubvencionables(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelFacActSubvencionables>> reorderSelection = this.relFacActSubvencionablesDao
					.reorderSelection(filterRelFacActSubvencionables, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelFacActSubvencionables>(jqGridRequestDto, recordNum,
					listaRelFacActSubvencionables, reorderSelection);
		}
		return new JQGridResponseDto<RelFacActSubvencionables>(jqGridRequestDto, recordNum,
				listaRelFacActSubvencionables);
	}

	/**
	 * Searches rows in the RelFacActSubvencionables table.
	 *
	 * @param filterRelFacActSubvencionables
	 *            RelFacActSubvencionables
	 * @param searchRelFacActSubvencionables
	 *            RelFacActSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelFacActSubvencionables>>
	 */
	public List<TableRowDto<RelFacActSubvencionables>> search(RelFacActSubvencionables filterRelFacActSubvencionables,
			RelFacActSubvencionables searchRelFacActSubvencionables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.relFacActSubvencionablesDao.search(filterRelFacActSubvencionables, searchRelFacActSubvencionables,
				jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in RelFacActSubvencionables table.
	 *
	 * @param filterRelFacActSubvencionables
	 *            RelFacActSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(RelFacActSubvencionables filterRelFacActSubvencionables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.relFacActSubvencionablesDao.reorderSelection(filterRelFacActSubvencionables, jqGridRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelFacActSubvencionables table.
	 *
	 * @param filterRelFacActSubvencionables
	 *            RelFacActSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelFacActSubvencionables>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelFacActSubvencionables>> jerarquia(
			RelFacActSubvencionables filterRelFacActSubvencionables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<JerarquiaDto<RelFacActSubvencionables>> listaRelFacActSubvencionables = this.relFacActSubvencionablesDao
				.findAllLikeJerarquia(filterRelFacActSubvencionables, jqGridRequestDto);
		Long recordNum = this.relFacActSubvencionablesDao.findAllLikeCountJerarquia(filterRelFacActSubvencionables,
				jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<RelFacActSubvencionables>>(jqGridRequestDto, recordNum,
				listaRelFacActSubvencionables);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * RelFacActSubvencionables table.
	 *
	 * @param filterRelFacActSubvencionables
	 *            RelFacActSubvencionables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelFacActSubvencionables>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelFacActSubvencionables>> jerarquiaChildren(
			RelFacActSubvencionables filterRelFacActSubvencionables, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<RelFacActSubvencionables>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<RelFacActSubvencionables>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.relFacActSubvencionablesDao.findAllChild(filterRelFacActSubvencionables, jqGridRequestDto));
		return jqGridResponseDto;
	}

	/**
	 * Finds a list of rows in the RelFacActSubvencionables table.
	 *
	 * @return List<RelFacActSubvencionables>
	 */
	public List<RelFacActSubvencionables> findActuaciones(Integer idExpediente) {
		return (List<RelFacActSubvencionables>) this.relFacActSubvencionablesDao.findActuaciones(idExpediente);
	}
}
