package com.ejie.ab60.service.justificacion;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.justificacion.RelFacActSubvencionables;
import com.ejie.ab60.model.justificacion.RelTipGasCon;

/**
 * RelTipGasConService  
 * 
 *  
 */

public interface RelTipGasConService {

	/**
	 * Inserts a single row in the RelTipGasCon table.
	 *
	 * @param relTipGasCon
	 *            RelTipGasCon
	 * @return RelTipGasCon
	 */
	RelTipGasCon add(RelTipGasCon relTipGasCon);

	/**
	 * Updates a single row in the RelTipGasCon table.
	 *
	 * @param relTipGasCon
	 *            RelTipGasCon
	 * @return RelTipGasCon
	 */
	RelTipGasCon update(RelTipGasCon relTipGasCon);

	/**
	 * Finds a single row in the RelTipGasCon table.
	 *
	 * @param relTipGasCon
	 *            RelTipGasCon
	 * @return RelTipGasCon
	 */
	RelTipGasCon find(RelTipGasCon relTipGasCon);

	/**
	 * Deletes a single row in the RelTipGasCon table.
	 *
	 * @param relTipGasCon
	 *            RelTipGasCon
	 */
	void remove(RelTipGasCon relTipGasCon);

	/**
	 * Finds a list of rows in the RelTipGasCon table.
	 *
	 * @param relTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelTipGasCon>
	 */
	List<RelTipGasCon> findAll(RelTipGasCon relTipGasCon, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelTipGasCon table using like.
	 *
	 * @param relTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelTipGasCon>
	 */
	List<RelTipGasCon> findAllLike(RelTipGasCon relTipGasCon, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelTipGasCon table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelTipGasCon filterRelTipGasCon, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelTipGasCon table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelTipGasCon>
	 */
	JQGridResponseDto<RelTipGasCon> filter(RelTipGasCon filterRelTipGasCon, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelTipGasCon table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param searchRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelTipGasCon>>
	 */
	List<TableRowDto<RelTipGasCon>> search(RelTipGasCon filterRelTipGasCon, RelTipGasCon searchRelTipGasCon,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelTipGasCon table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelTipGasCon filterRelTipGasCon, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelTipGasCon table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelTipGasCon>>
	 */
	JQGridResponseDto<JerarquiaDto<RelTipGasCon>> jerarquia(RelTipGasCon filterRelTipGasCon,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelTipGasCon
	 * table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelTipGasCon>>
	 */
	JQGridResponseDto<JerarquiaDto<RelTipGasCon>> jerarquiaChildren(RelTipGasCon filterRelTipGasCon,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a list of rows in the RelTipGasCon table.
	 *
	 * @return List<RelTipGasCon>
	 */
	List<RelTipGasCon> findTipos(Integer idConvocatoria);

}
