package com.ejie.ab60.service.justificacion;

import com.ejie.ab60.dao.justificacion.RelTipGasConDao;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.model.justificacion.RelFacActSubvencionables;
import com.ejie.ab60.model.justificacion.RelTipGasCon;

/**
 * RelTipGasConServiceImpl  
 * 
 *  
 */

@Service(value = "relTipGasConService")
public class RelTipGasConServiceImpl implements RelTipGasConService {

	@Autowired
	private RelTipGasConDao relTipGasConDao;

	/**
	 * Inserts a single row in the RelTipGasCon table.
	 *
	 * @param relTipGasCon
	 *            RelTipGasCon
	 * @return RelTipGasCon
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelTipGasCon add(RelTipGasCon relTipGasCon) {
		return this.relTipGasConDao.add(relTipGasCon);
	}

	/**
	 * Updates a single row in the RelTipGasCon table.
	 *
	 * @param relTipGasCon
	 *            RelTipGasCon
	 * @return RelTipGasCon
	 */
	@Transactional(rollbackFor = Throwable.class)
	public RelTipGasCon update(RelTipGasCon relTipGasCon) {
		return this.relTipGasConDao.update(relTipGasCon);
	}

	/**
	 * Finds a single row in the RelTipGasCon table.
	 *
	 * @param relTipGasCon
	 *            RelTipGasCon
	 * @return RelTipGasCon
	 */
	public RelTipGasCon find(RelTipGasCon relTipGasCon) {
		return (RelTipGasCon) this.relTipGasConDao.find(relTipGasCon);
	}

	/**
	 * Deletes a single row in the RelTipGasCon table.
	 *
	 * @param relTipGasCon
	 *            RelTipGasCon
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(RelTipGasCon relTipGasCon) {
		this.relTipGasConDao.remove(relTipGasCon);
	}

	/**
	 * Finds a list of rows in the RelTipGasCon table.
	 *
	 * @param relTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelTipGasCon>
	 */
	public List<RelTipGasCon> findAll(RelTipGasCon relTipGasCon, JQGridRequestDto jqGridRequestDto) {
		return (List<RelTipGasCon>) this.relTipGasConDao.findAll(relTipGasCon, jqGridRequestDto);
	}

	/**
	 * Finds rows in the RelTipGasCon table using like.
	 *
	 * @param relTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelTipGasCon>
	 */
	public List<RelTipGasCon> findAllLike(RelTipGasCon relTipGasCon, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<RelTipGasCon>) this.relTipGasConDao.findAllLike(relTipGasCon, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelTipGasCon table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(RelTipGasCon filterRelTipGasCon, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.relTipGasConDao.removeMultiple(filterRelTipGasCon, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the RelTipGasCon table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelTipGasCon>
	 */
	public JQGridResponseDto<RelTipGasCon> filter(RelTipGasCon filterRelTipGasCon, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<RelTipGasCon> listaRelTipGasCon = this.relTipGasConDao.findAllLike(filterRelTipGasCon, jqGridRequestDto,
				false);
		Long recordNum = this.relTipGasConDao
				.findAllLikeCount(filterRelTipGasCon != null ? filterRelTipGasCon : new RelTipGasCon(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<RelTipGasCon>> reorderSelection = this.relTipGasConDao.reorderSelection(filterRelTipGasCon,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<RelTipGasCon>(jqGridRequestDto, recordNum, listaRelTipGasCon,
					reorderSelection);
		}
		return new JQGridResponseDto<RelTipGasCon>(jqGridRequestDto, recordNum, listaRelTipGasCon);
	}

	/**
	 * Searches rows in the RelTipGasCon table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param searchRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelTipGasCon>>
	 */
	public List<TableRowDto<RelTipGasCon>> search(RelTipGasCon filterRelTipGasCon, RelTipGasCon searchRelTipGasCon,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.relTipGasConDao.search(filterRelTipGasCon, searchRelTipGasCon, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in RelTipGasCon table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(RelTipGasCon filterRelTipGasCon, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.relTipGasConDao.reorderSelection(filterRelTipGasCon, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelTipGasCon table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelTipGasCon>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelTipGasCon>> jerarquia(RelTipGasCon filterRelTipGasCon,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<RelTipGasCon>> listaRelTipGasCon = this.relTipGasConDao
				.findAllLikeJerarquia(filterRelTipGasCon, jqGridRequestDto);
		Long recordNum = this.relTipGasConDao.findAllLikeCountJerarquia(filterRelTipGasCon, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<RelTipGasCon>>(jqGridRequestDto, recordNum, listaRelTipGasCon);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the RelTipGasCon
	 * table.
	 *
	 * @param filterRelTipGasCon
	 *            RelTipGasCon
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelTipGasCon>>
	 */
	public JQGridResponseDto<JerarquiaDto<RelTipGasCon>> jerarquiaChildren(RelTipGasCon filterRelTipGasCon,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<RelTipGasCon>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<RelTipGasCon>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.relTipGasConDao.findAllChild(filterRelTipGasCon, jqGridRequestDto));
		return jqGridResponseDto;
	}

	/**
	 * Finds a list of rows in the RelTipGasCon table.
	 *
	 * @return List<RelTipGasCon>
	 */
	public List<RelTipGasCon> findTipos(Integer idConvocatoria) {
		return (List<RelTipGasCon>) this.relTipGasConDao.findTipos(idConvocatoria);
	}

}
