package com.ejie.ab60.service.justificacion;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab60.model.estudioTecnico.TiposResultado;
import com.ejie.ab60.model.justificacion.TiposResJus;

/**
 * TiposResJusService  
 * 
 *  
 */

public interface TiposResJusService {

	/**
	 * Inserts a single row in the TiposResJus table.
	 *
	 * @param tiposResJus
	 *            TiposResJus
	 * @return TiposResJus
	 */
	TiposResJus add(TiposResJus tiposResJus);

	/**
	 * Updates a single row in the TiposResJus table.
	 *
	 * @param tiposResJus
	 *            TiposResJus
	 * @return TiposResJus
	 */
	TiposResJus update(TiposResJus tiposResJus);

	/**
	 * Finds a single row in the TiposResJus table.
	 *
	 * @param tiposResJus
	 *            TiposResJus
	 * @return TiposResJus
	 */
	TiposResJus find(TiposResJus tiposResJus);

	/**
	 * Deletes a single row in the TiposResJus table.
	 *
	 * @param tiposResJus
	 *            TiposResJus
	 */
	void remove(TiposResJus tiposResJus);

	/**
	 * Finds a list of rows in the Resultados table.
	 *
	 * 
	 * @return List<TiposResultado>
	 */
	List<TiposResJus> findResultado();

	/**
	 * Finds a list of rows in the TiposResJus table.
	 *
	 * @param tiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TiposResJus>
	 */
	List<TiposResJus> findAll(TiposResJus tiposResJus, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposResJus table using like.
	 *
	 * @param tiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposResJus>
	 */
	List<TiposResJus> findAllLike(TiposResJus tiposResJus, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposResJus table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposResJus filterTiposResJus, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the TiposResJus table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<TiposResJus>
	 */
	JQGridResponseDto<TiposResJus> filter(TiposResJus filterTiposResJus, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the TiposResJus table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param searchTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposResJus>>
	 */
	List<TableRowDto<TiposResJus>> search(TiposResJus filterTiposResJus, TiposResJus searchTiposResJus,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in TiposResJus table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(TiposResJus filterTiposResJus, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposResJus table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposResJus>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposResJus>> jerarquia(TiposResJus filterTiposResJus,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the TiposResJus
	 * table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposResJus>>
	 */
	JQGridResponseDto<JerarquiaDto<TiposResJus>> jerarquiaChildren(TiposResJus filterTiposResJus,
			JQGridRequestDto jqGridRequestDto);

}
