package com.ejie.ab60.service.justificacion;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab60.dao.justificacion.TiposResJusDao;
import com.ejie.ab60.model.estudioTecnico.TiposResultado;
import com.ejie.ab60.model.justificacion.TiposResJus;

/**
 * TiposResJusServiceImpl  
 * 
 *  
 */

@Service(value = "tiposResJusService")
public class TiposResJusServiceImpl implements TiposResJusService {

	@Autowired
	private TiposResJusDao tiposResJusDao;

	/**
	 * Inserts a single row in the TiposResJus table.
	 *
	 * @param tiposResJus
	 *            TiposResJus
	 * @return TiposResJus
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposResJus add(TiposResJus tiposResJus) {
		return this.tiposResJusDao.add(tiposResJus);
	}

	/**
	 * Updates a single row in the TiposResJus table.
	 *
	 * @param tiposResJus
	 *            TiposResJus
	 * @return TiposResJus
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposResJus update(TiposResJus tiposResJus) {
		return this.tiposResJusDao.update(tiposResJus);
	}

	/**
	 * Finds a single row in the TiposResJus table.
	 *
	 * @param tiposResJus
	 *            TiposResJus
	 * @return TiposResJus
	 */
	public TiposResJus find(TiposResJus tiposResJus) {
		return (TiposResJus) this.tiposResJusDao.find(tiposResJus);
	}

	/**
	 * Finds a list of rows in the Resultados table.
	 *
	 * 
	 * @return List<TiposResultado>
	 */
	public List<TiposResJus> findResultado() {
		return (List<TiposResJus>) this.tiposResJusDao.findResultado();
	}

	/**
	 * Deletes a single row in the TiposResJus table.
	 *
	 * @param tiposResJus
	 *            TiposResJus
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(TiposResJus tiposResJus) {
		this.tiposResJusDao.remove(tiposResJus);
	}

	/**
	 * Finds a list of rows in the TiposResJus table.
	 *
	 * @param tiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TiposResJus>
	 */
	public List<TiposResJus> findAll(TiposResJus tiposResJus, JQGridRequestDto jqGridRequestDto) {
		return (List<TiposResJus>) this.tiposResJusDao.findAll(tiposResJus, jqGridRequestDto);
	}

	/**
	 * Finds rows in the TiposResJus table using like.
	 *
	 * @param tiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposResJus>
	 */
	public List<TiposResJus> findAllLike(TiposResJus tiposResJus, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return (List<TiposResJus>) this.tiposResJusDao.findAllLike(tiposResJus, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposResJus table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(TiposResJus filterTiposResJus, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		this.tiposResJusDao.removeMultiple(filterTiposResJus, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the TiposResJus table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<TiposResJus>
	 */
	public JQGridResponseDto<TiposResJus> filter(TiposResJus filterTiposResJus, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<TiposResJus> listaTiposResJus = this.tiposResJusDao.findAllLike(filterTiposResJus, jqGridRequestDto,
				false);
		Long recordNum = this.tiposResJusDao
				.findAllLikeCount(filterTiposResJus != null ? filterTiposResJus : new TiposResJus(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<TiposResJus>> reorderSelection = this.tiposResJusDao.reorderSelection(filterTiposResJus,
					jqGridRequestDto, startsWith);
			return new JQGridResponseDto<TiposResJus>(jqGridRequestDto, recordNum, listaTiposResJus, reorderSelection);
		}
		return new JQGridResponseDto<TiposResJus>(jqGridRequestDto, recordNum, listaTiposResJus);
	}

	/**
	 * Searches rows in the TiposResJus table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param searchTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposResJus>>
	 */
	public List<TableRowDto<TiposResJus>> search(TiposResJus filterTiposResJus, TiposResJus searchTiposResJus,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.tiposResJusDao.search(filterTiposResJus, searchTiposResJus, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in TiposResJus table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(TiposResJus filterTiposResJus, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.tiposResJusDao.reorderSelection(filterTiposResJus, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposResJus table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposResJus>>
	 */
	public JQGridResponseDto<JerarquiaDto<TiposResJus>> jerarquia(TiposResJus filterTiposResJus,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<TiposResJus>> listaTiposResJus = this.tiposResJusDao.findAllLikeJerarquia(filterTiposResJus,
				jqGridRequestDto);
		Long recordNum = this.tiposResJusDao.findAllLikeCountJerarquia(filterTiposResJus, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<TiposResJus>>(jqGridRequestDto, recordNum, listaTiposResJus);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the TiposResJus
	 * table.
	 *
	 * @param filterTiposResJus
	 *            TiposResJus
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposResJus>>
	 */
	public JQGridResponseDto<JerarquiaDto<TiposResJus>> jerarquiaChildren(TiposResJus filterTiposResJus,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<TiposResJus>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<TiposResJus>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.tiposResJusDao.findAllChild(filterTiposResJus, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
