package com.ejie.ab60.service.moduloContable;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ejie.ab60.dao.moduloContable.DocContablesODao;
import com.ejie.ab60.model.moduloContable.DocContables;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * DocContablesServiceImpl  
 * 
 *  
 */

@Service(value = "docContablesOService")
public class DocContablesOServiceImpl implements DocContablesOService {

	@Autowired
	private DocContablesODao docContablesODao;

	/**
	 * Filter method in the DocContables table.
	 *
	 * @param filterDocContables
	 *            DocContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<DocContables>
	 */
	public JQGridResponseDto<DocContables> filter(DocContables filterDocContables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<DocContables> listaDocContables = this.docContablesODao.findAllLike(filterDocContables, jqGridRequestDto,
				false);
		Long recordNum = this.docContablesODao
				.findAllLikeCount(filterDocContables != null ? filterDocContables : new DocContables(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<DocContables>> reorderSelection = this.docContablesODao
					.reorderSelection(filterDocContables, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<DocContables>(jqGridRequestDto, recordNum, listaDocContables,
					reorderSelection);
		}
		return new JQGridResponseDto<DocContables>(jqGridRequestDto, recordNum, listaDocContables);
	}
}
