package com.ejie.ab60.service.moduloContable;

import com.ejie.ab60.model.moduloContable.DocumentosContables;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * DocumentosContablesService  
 * 
 *  
 */

public interface DocumentosContablesService {

	/**
	 * Inserts a single row in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 * @return DocumentosContables
	 */
	DocumentosContables add(DocumentosContables documentosContables);

	/**
	 * Updates a single row in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 * @return DocumentosContables
	 */
	DocumentosContables update(DocumentosContables documentosContables);

	DocumentosContables updateRegistrosDocContableMAK(DocumentosContables documentoscontables);

	DocumentosContables updateRegistrosDocContableREL(DocumentosContables documentoscontables);

	/**
	 * Finds a single row in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 * @return DocumentosContables
	 */
	DocumentosContables find(DocumentosContables documentosContables);

	/**
	 * Deletes a single row in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 */
	void remove(DocumentosContables documentosContables);

	/**
	 * Deletes a single row in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 */
	void removeByFicheroContable(DocumentosContables documentosContables);

	/**
	 * Finds a list of rows in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<DocumentosContables>
	 */
	List<DocumentosContables> findAll(DocumentosContables documentosContables, JQGridRequestDto jqGridRequestDto);

	List<DocumentosContables> findImporteAplicPresu(DocumentosContables documentoscontables);

	/**
	 * Finds rows in the DocumentosContables table using like.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<DocumentosContables>
	 */
	List<DocumentosContables> findAllLike(DocumentosContables documentosContables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	List<DocumentosContables> findAllLikeByFichero(DocumentosContables documentosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith, Integer idFichero);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the DocumentosContables table.
	 *
	 * @param filterDocumentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(DocumentosContables filterDocumentosContables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the DocumentosContables table.
	 *
	 * @param filterDocumentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<DocumentosContables>
	 */
	JQGridResponseDto<DocumentosContables> filter(DocumentosContables filterDocumentosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith, Integer idProcedimiento);

	JQGridResponseDto<DocumentosContables> filterDocumentos(DocumentosContables filterDocumentosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith, Integer idFicheroContable);

	JQGridResponseDto<DocumentosContables> filterArchivos(DocumentosContables filterDocumentosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith, List<String> lista, String tipoArchivoSeleccionado);

	/**
	 * Searches rows in the DocumentosContables table.
	 *
	 * @param filterDocumentosContables
	 *            DocumentosContables
	 * @param searchDocumentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DocumentosContables>>
	 */
	List<TableRowDto<DocumentosContables>> search(DocumentosContables filterDocumentosContables,
			DocumentosContables searchDocumentosContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in DocumentosContables table.
	 *
	 * @param filterDocumentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(DocumentosContables filterDocumentosContables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the DocumentosContables table.
	 *
	 * @param filterDocumentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<DocumentosContables>>
	 */
	JQGridResponseDto<JerarquiaDto<DocumentosContables>> jerarquia(DocumentosContables filterDocumentosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * DocumentosContables table.
	 *
	 * @param filterDocumentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<DocumentosContables>>
	 */
	JQGridResponseDto<JerarquiaDto<DocumentosContables>> jerarquiaChildren(
			DocumentosContables filterDocumentosContables, JQGridRequestDto jqGridRequestDto);

}
