package com.ejie.ab60.service.moduloContable;

import com.ejie.ab60.dao.convocatorias.ConvocatoriasDao;
import com.ejie.ab60.dao.moduloContable.DocumentosContablesDao;
import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.ab60.model.moduloContable.DocContables;
import com.ejie.ab60.model.moduloContable.DocumentosContables;
import com.ejie.ab60.service.convocatorias.ConvocatoriasService;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * DocumentosContablesServiceImpl  
 * 
 *  
 */

@Service(value = "documentosContablesService")
public class DocumentosContablesServiceImpl implements DocumentosContablesService {

	@Autowired
	private DocumentosContablesDao documentosContablesDao;

	@Autowired
	private ConvocatoriasDao convocatoriasDao;

	/**
	 * Inserts a single row in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 * @return DocumentosContables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DocumentosContables add(DocumentosContables documentosContables) {
		return this.documentosContablesDao.add(documentosContables);
	}

	/**
	 * Updates a single row in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 * @return DocumentosContables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DocumentosContables update(DocumentosContables documentosContables) {
		return this.documentosContablesDao.update(documentosContables);
	}

	/**
	 * Updates a single row in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 * @return DocumentosContables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DocumentosContables updateRegistrosDocContableMAK(DocumentosContables documentosContables) {
		return this.documentosContablesDao.updateRegistrosDocContableMAK(documentosContables);
	}

	/**
	 * Updates a single row in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 * @return DocumentosContables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DocumentosContables updateRegistrosDocContableREL(DocumentosContables documentosContables) {
		return this.documentosContablesDao.updateRegistrosDocContableREL(documentosContables);
	}

	/**
	 * Finds a single row in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 * @return DocumentosContables
	 */
	public DocumentosContables find(DocumentosContables documentosContables) {
		return (DocumentosContables) this.documentosContablesDao.find(documentosContables);
	}

	/**
	 * Deletes a single row in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(DocumentosContables documentosContables) {
		this.documentosContablesDao.remove(documentosContables);
	}

	/**
	 * Deletes a single row in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void removeByFicheroContable(DocumentosContables documentosContables) {
		this.documentosContablesDao.removeByFicheroContable(documentosContables);
	}

	/**
	 * Finds a list of rows in the DocumentosContables table.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<DocumentosContables>
	 */
	public List<DocumentosContables> findAll(DocumentosContables documentosContables,
			JQGridRequestDto jqGridRequestDto) {
		return (List<DocumentosContables>) this.documentosContablesDao.findAll(documentosContables, jqGridRequestDto);
	}

	public List<DocumentosContables> findImporteAplicPresu(DocumentosContables documentosContables) {
		return (List<DocumentosContables>) this.documentosContablesDao.findImporteAplicPresu(documentosContables);
	}

	/**
	 * Finds rows in the DocumentosContables table using like.
	 *
	 * @param documentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<DocumentosContables>
	 */
	public List<DocumentosContables> findAllLike(DocumentosContables documentosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<DocumentosContables>) this.documentosContablesDao.findAllLike(documentosContables,
				jqGridRequestDto, startsWith);
	}

	public List<DocumentosContables> findAllLikeByFichero(DocumentosContables documentosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith, Integer idFichero) {
		return (List<DocumentosContables>) this.documentosContablesDao.findAllLikeByFichero(documentosContables,
				jqGridRequestDto, startsWith, idFichero);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the DocumentosContables table.
	 *
	 * @param filterDocumentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(DocumentosContables filterDocumentosContables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.documentosContablesDao.removeMultiple(filterDocumentosContables, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the DocumentosContables table.
	 *
	 * @param filterDocumentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<DocumentosContables>
	 */
	public JQGridResponseDto<DocumentosContables> filter(DocumentosContables filterDocumentosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith, Integer idProcedimiento) {

		if (idProcedimiento == 0)
			idProcedimiento = null;

		// Convocatorias convo =
		// convocatoriasDao.findWithProcedimiento(idProcedimiento);
		filterDocumentosContables.setIdConvocatoria(idProcedimiento);

		List<DocumentosContables> listaDocumentosContables = this.documentosContablesDao
				.findAllLike(filterDocumentosContables, jqGridRequestDto, false);
		Long recordNum = this.documentosContablesDao.findAllLikeCount(
				filterDocumentosContables != null ? filterDocumentosContables : new DocumentosContables(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<DocumentosContables>> reorderSelection = this.documentosContablesDao
					.reorderSelection(filterDocumentosContables, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<DocumentosContables>(jqGridRequestDto, recordNum, listaDocumentosContables,
					reorderSelection);
		}
		return new JQGridResponseDto<DocumentosContables>(jqGridRequestDto, recordNum, listaDocumentosContables);
	}

	public JQGridResponseDto<DocumentosContables> filterDocumentos(DocumentosContables filterDocContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith, Integer idFicheroContable) {
		List<DocumentosContables> listaDocContables = this.documentosContablesDao
				.findAllLikeDocumentos(filterDocContables, jqGridRequestDto, false, idFicheroContable);
		Long recordNum = this.documentosContablesDao.findAllLikeCountDocumentos(
				filterDocContables != null ? filterDocContables : new DocumentosContables(), false, idFicheroContable);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<DocumentosContables>> reorderSelection = this.documentosContablesDao
					.reorderSelection(filterDocContables, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<DocumentosContables>(jqGridRequestDto, recordNum, listaDocContables,
					reorderSelection);
		}
		return new JQGridResponseDto<DocumentosContables>(jqGridRequestDto, recordNum, listaDocContables);
	}

	public JQGridResponseDto<DocumentosContables> filterArchivos(DocumentosContables filterDocContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith, List<String> lista, String tipoArchivoSeleccionado) {
		List<DocumentosContables> listaDocContables = this.documentosContablesDao
				.findAllLikeArchivos(filterDocContables, jqGridRequestDto, false, lista);

		for (int x = 0; x < listaDocContables.size(); x++) {
			listaDocContables.get(x).setTipoArchivoSeleccionado(tipoArchivoSeleccionado);
			listaDocContables.get(x).setEstado(true);
		}

		Long recordNum = this.documentosContablesDao.findAllLikeCountArchivos(
				filterDocContables != null ? filterDocContables : new DocumentosContables(), false, lista);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<DocumentosContables>> reorderSelection = this.documentosContablesDao
					.reorderSelection(filterDocContables, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<DocumentosContables>(jqGridRequestDto, recordNum, listaDocContables,
					reorderSelection);
		}
		return new JQGridResponseDto<DocumentosContables>(jqGridRequestDto, recordNum, listaDocContables);
	}

	/**
	 * Searches rows in the DocumentosContables table.
	 *
	 * @param filterDocumentosContables
	 *            DocumentosContables
	 * @param searchDocumentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DocumentosContables>>
	 */
	public List<TableRowDto<DocumentosContables>> search(DocumentosContables filterDocumentosContables,
			DocumentosContables searchDocumentosContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.documentosContablesDao.search(filterDocumentosContables, searchDocumentosContables,
				jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in DocumentosContables table.
	 *
	 * @param filterDocumentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(DocumentosContables filterDocumentosContables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.documentosContablesDao.reorderSelection(filterDocumentosContables, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the DocumentosContables table.
	 *
	 * @param filterDocumentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<DocumentosContables>>
	 */
	public JQGridResponseDto<JerarquiaDto<DocumentosContables>> jerarquia(DocumentosContables filterDocumentosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<DocumentosContables>> listaDocumentosContables = this.documentosContablesDao
				.findAllLikeJerarquia(filterDocumentosContables, jqGridRequestDto);
		Long recordNum = this.documentosContablesDao.findAllLikeCountJerarquia(filterDocumentosContables,
				jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<DocumentosContables>>(jqGridRequestDto, recordNum,
				listaDocumentosContables);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * DocumentosContables table.
	 *
	 * @param filterDocumentosContables
	 *            DocumentosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<DocumentosContables>>
	 */
	public JQGridResponseDto<JerarquiaDto<DocumentosContables>> jerarquiaChildren(
			DocumentosContables filterDocumentosContables, JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<DocumentosContables>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<DocumentosContables>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.documentosContablesDao.findAllChild(filterDocumentosContables, jqGridRequestDto));
		return jqGridResponseDto;
	}

}
