package com.ejie.ab60.service.moduloContable;

import com.ejie.ab60.model.moduloContable.FicherosContables;
import com.ejie.ab60.model.moduloContable.ModuloContable;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * FicherosContablesService  
 * 
 *  
 */

public interface FicherosContablesService {

	/**
	 * Inserts a single row in the FicherosContables table.
	 *
	 * @param ficherosContables
	 *            FicherosContables
	 * @return FicherosContables
	 */
	FicherosContables add(FicherosContables ficherosContables, Usuario usuario);

	/**
	 * Updates a single row in the FicherosContables table.
	 *
	 * @param ficherosContables
	 *            FicherosContables
	 * @return FicherosContables
	 */
	FicherosContables update(FicherosContables ficherosContables, Usuario usuario);

	/**
	 * Finds a single row in the FicherosContables table.
	 *
	 * @param ficherosContables
	 *            FicherosContables
	 * @return FicherosContables
	 */
	FicherosContables find(FicherosContables ficherosContables);

	/**
	 * Finds a single row in the FicherosContables table.
	 *
	 * @param ficherosContables
	 *            FicherosContables
	 * @return FicherosContables
	 */
	FicherosContables findNew(FicherosContables ficherosContables);

	/**
	 * Deletes a single row in the FicherosContables table.
	 *
	 * @param ficherosContables
	 *            FicherosContables
	 */
	void remove(FicherosContables ficherosContables);

	/**
	 * Finds a list of rows in the FicherosContables table.
	 *
	 * @param ficherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<FicherosContables>
	 */
	List<FicherosContables> findAll(FicherosContables ficherosContables, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the FicherosContables table using like.
	 *
	 * @param ficherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<FicherosContables>
	 */
	List<FicherosContables> findAllLike(FicherosContables ficherosContables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the FicherosContables table.
	 *
	 * @param filterFicherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(FicherosContables filterFicherosContables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the FicherosContables table.
	 *
	 * @param filterFicherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<FicherosContables>
	 */
	JQGridResponseDto<FicherosContables> filter(FicherosContables filterFicherosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the FicherosContables table.
	 *
	 * @param filterFicherosContables
	 *            FicherosContables
	 * @param searchFicherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<FicherosContables>>
	 */
	List<TableRowDto<FicherosContables>> search(FicherosContables filterFicherosContables,
			FicherosContables searchFicherosContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in FicherosContables table.
	 *
	 * @param filterFicherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(FicherosContables filterFicherosContables, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the FicherosContables table.
	 *
	 * @param filterFicherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<FicherosContables>>
	 */
	JQGridResponseDto<JerarquiaDto<FicherosContables>> jerarquia(FicherosContables filterFicherosContables,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the FicherosContables
	 * table.
	 *
	 * @param filterFicherosContables
	 *            FicherosContables
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<FicherosContables>>
	 */
	JQGridResponseDto<JerarquiaDto<FicherosContables>> jerarquiaChildren(FicherosContables filterFicherosContables,
			JQGridRequestDto jqGridRequestDto);

	ModuloContable saveDocumentoDO(ModuloContable moduloContable, Usuario usuario);

}
