package com.ejie.ab60.service.moduloContable;


import com.ejie.ab60.model.moduloContable.TiposDocContables;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * TiposDocContablesService  
 *  
 */

public interface TiposDocContablesService {

	/**
	 * Inserts a single row in the TiposDocContables table.
	 *
	 * @param tiposDocContables TiposDocContables
	 * @return TiposDocContables
	 */
    TiposDocContables add(TiposDocContables tiposDocContables);

	/**
	 * Updates a single row in the TiposDocContables table.
	 *
	 * @param tiposDocContables TiposDocContables
	 * @return TiposDocContables
	 */
	TiposDocContables update(TiposDocContables tiposDocContables);

	/**
	 * Finds a single row in the TiposDocContables table.
	 *
	 * @param tiposDocContables TiposDocContables
	 * @return TiposDocContables
	 */
	TiposDocContables find(TiposDocContables tiposDocContables);

	/**
	 * Deletes a single row in the TiposDocContables table.
	 *
	 * @param tiposDocContables TiposDocContables
	 */
	void remove(TiposDocContables tiposDocContables);

	/**
	 * Finds a list of rows in the TiposDocContables table.
	 *
	 * @param tiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<TiposDocContables>
	 */
	List<TiposDocContables> findAll(TiposDocContables tiposDocContables, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposDocContables table using like.
	 *
	 * @param tiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean	 
	 * @return List<TiposDocContables>
	 */
	List<TiposDocContables> findAllLike(TiposDocContables tiposDocContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	void removeMultiple(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
   
    
	/**
	 * Filter method in the TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<TiposDocContables>
	 */	
	JQGridResponseDto<TiposDocContables> filter(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
    
    /**
	 * Searches rows in the TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param searchTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<TiposDocContables>>
	 */	
    List<TableRowDto<TiposDocContables>> search(TiposDocContables filterTiposDocContables, TiposDocContables searchTiposDocContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /**
	 * Reorder the selection made in TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    Object reorderSelection(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposDocContables>>
	 */	
	JQGridResponseDto<JerarquiaDto<TiposDocContables>> jerarquia(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	/**
	 * Finder method for siblings rows in the hierarchical the TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposDocContables>>
	 */	
	JQGridResponseDto<JerarquiaDto<TiposDocContables>> jerarquiaChildren(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto);
    
}


