package com.ejie.ab60.service.moduloContable;
import com.ejie.ab60.dao.moduloContable.TiposDocContablesDao;
import com.ejie.ab60.model.moduloContable.TiposDocContables;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * TiposDocContablesServiceImpl  
 *  
 */

@Service(value = "tiposDocContablesService")
public class TiposDocContablesServiceImpl implements TiposDocContablesService {

	@Autowired
	private TiposDocContablesDao tiposDocContablesDao;

	/**
	 * Inserts a single row in the TiposDocContables table.
	 *
	 * @param tiposDocContables TiposDocContables
	 * @return TiposDocContables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposDocContables add(TiposDocContables tiposDocContables) {
		return this.tiposDocContablesDao.add(tiposDocContables);
	}

	/**
	 * Updates a single row in the TiposDocContables table.
	 *
	 * @param tiposDocContables TiposDocContables
	 * @return TiposDocContables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposDocContables update(TiposDocContables tiposDocContables) {
		return this.tiposDocContablesDao.update(tiposDocContables);
	 }

	/**
	 * Finds a single row in the TiposDocContables table.
	 *
	 * @param tiposDocContables TiposDocContables
	 * @return TiposDocContables
	 */
	public TiposDocContables find(TiposDocContables tiposDocContables) {
		return (TiposDocContables) this.tiposDocContablesDao.find(tiposDocContables);
	}
	
	/**
	 * Deletes a single row in the TiposDocContables table.
	 *
	 * @param tiposDocContables TiposDocContables
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(TiposDocContables tiposDocContables) {
		this.tiposDocContablesDao.remove(tiposDocContables);
	}

	/**
	 * Finds a list of rows in the TiposDocContables table.
	 *
	 * @param tiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<TiposDocContables>
	 */
	public List<TiposDocContables> findAll(TiposDocContables tiposDocContables, JQGridRequestDto jqGridRequestDto){
		return (List<TiposDocContables>) this.tiposDocContablesDao.findAll(tiposDocContables, jqGridRequestDto);
	}
    
	/**
	 * Finds rows in the TiposDocContables table using like.
	 *
	 * @param tiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean	 
	 * @return List<TiposDocContables>
	 */
	public List<TiposDocContables> findAllLike(TiposDocContables tiposDocContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith){
		return (List<TiposDocContables>) this.tiposDocContablesDao.findAllLike(tiposDocContables, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Removes rows from the TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	public void removeMultiple(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto,  Boolean startsWith){
		this.tiposDocContablesDao.removeMultiple(filterTiposDocContables, jqGridRequestDto, startsWith);
	}
        
	/**
	 * Filter method in the TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<TiposDocContables>
	 */	
	public JQGridResponseDto< TiposDocContables> filter(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto,  Boolean startsWith){
		List<TiposDocContables> listaTiposDocContables =  this.tiposDocContablesDao.findAllLike(filterTiposDocContables, jqGridRequestDto, false);
		Long recordNum =  this.tiposDocContablesDao.findAllLikeCount(filterTiposDocContables != null ? filterTiposDocContables: new TiposDocContables (),false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds()!=null){
			List< TableRowDto< TiposDocContables>> reorderSelection = this.tiposDocContablesDao.reorderSelection(filterTiposDocContables, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<TiposDocContables>(jqGridRequestDto, recordNum, listaTiposDocContables, reorderSelection);
		}
		return new JQGridResponseDto<TiposDocContables>(jqGridRequestDto, recordNum, listaTiposDocContables);   
	}
    
    /**
	 * Searches rows in the TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param searchTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<TiposDocContables>>
	 */	
    public List< TableRowDto< TiposDocContables>> search(TiposDocContables filterTiposDocContables, TiposDocContables searchTiposDocContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith){
		return this.tiposDocContablesDao.search(filterTiposDocContables, searchTiposDocContables, jqGridRequestDto, startsWith);
	}
    
    /**
	 * Reorder the selection made in TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    public Object reorderSelection(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith){
		return this.tiposDocContablesDao.reorderSelection(filterTiposDocContables, jqGridRequestDto, startsWith);
	}
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposDocContables>>
	 */	
	public JQGridResponseDto<JerarquiaDto<TiposDocContables>> jerarquia(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto, Boolean startsWith){
		List<JerarquiaDto<TiposDocContables>> listaTiposDocContables =  this.tiposDocContablesDao.findAllLikeJerarquia(filterTiposDocContables, jqGridRequestDto);
		Long recordNum = this.tiposDocContablesDao.findAllLikeCountJerarquia(filterTiposDocContables, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<TiposDocContables>>(jqGridRequestDto, recordNum, listaTiposDocContables);
	}
	
	/**
	 * Finder method for siblings rows in the hierarchical the TiposDocContables table.
	 *
	 * @param filterTiposDocContables TiposDocContables
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposDocContables>>
	 */	
	public JQGridResponseDto<JerarquiaDto<TiposDocContables>> jerarquiaChildren(TiposDocContables filterTiposDocContables, JQGridRequestDto jqGridRequestDto){
		JQGridResponseDto<JerarquiaDto<TiposDocContables>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<TiposDocContables>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN, this.tiposDocContablesDao.findAllChild(filterTiposDocContables, jqGridRequestDto));
		return jqGridResponseDto;
	}
	
	
}

