package com.ejie.ab60.service.pagos;

import java.util.List;

import com.ejie.ab60.model.pagos.PagosConvocatoria;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * PagosConvocatoriaService  
 * 
 *  
 */

public interface PagosConvocatoriaService {

	/**
	 * Inserts a single row in the PagosConvocatoria table.
	 *
	 * @param pagosConvocatoria
	 *            PagosConvocatoria
	 * @return PagosConvocatoria
	 */
	PagosConvocatoria add(PagosConvocatoria pagosConvocatoria);

	/**
	 * Updates a single row in the PagosConvocatoria table.
	 *
	 * @param pagosConvocatoria
	 *            PagosConvocatoria
	 * @return PagosConvocatoria
	 */
	PagosConvocatoria update(PagosConvocatoria pagosConvocatoria);

	/**
	 * Finds a single row in the PagosConvocatoria table.
	 *
	 * @param pagosConvocatoria
	 *            PagosConvocatoria
	 * @return PagosConvocatoria
	 */
	PagosConvocatoria find(PagosConvocatoria pagosConvocatoria);

	/**
	 * Deletes a single row in the PagosConvocatoria table.
	 *
	 * @param pagosConvocatoria
	 *            PagosConvocatoria
	 */
	void remove(PagosConvocatoria pagosConvocatoria);

	/**
	 * Finds a list of rows in the PagosConvocatoria table.
	 *
	 * @param pagosConvocatoria
	 *            PagosConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<PagosConvocatoria>
	 */
	List<PagosConvocatoria> findAll(PagosConvocatoria pagosConvocatoria, JQGridRequestDto jqGridRequestDto);

	List<PagosConvocatoria> findAllPagos(PagosConvocatoria pagosConvocatoria, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the PagosConvocatoria table using like.
	 *
	 * @param pagosConvocatoria
	 *            PagosConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<PagosConvocatoria>
	 */
	List<PagosConvocatoria> findAllLike(PagosConvocatoria pagosConvocatoria, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the PagosConvocatoria table.
	 *
	 * @param filterPagosConvocatoria
	 *            PagosConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(PagosConvocatoria filterPagosConvocatoria, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the PagosConvocatoria table.
	 *
	 * @param filterPagosConvocatoria
	 *            PagosConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<PagosConvocatoria>
	 */
	JQGridResponseDto<PagosConvocatoria> filter(PagosConvocatoria filterPagosConvocatoria,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the PagosConvocatoria table.
	 *
	 * @param filterPagosConvocatoria
	 *            PagosConvocatoria
	 * @param searchPagosConvocatoria
	 *            PagosConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<PagosConvocatoria>>
	 */
	List<TableRowDto<PagosConvocatoria>> search(PagosConvocatoria filterPagosConvocatoria,
			PagosConvocatoria searchPagosConvocatoria, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in PagosConvocatoria table.
	 *
	 * @param filterPagosConvocatoria
	 *            PagosConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(PagosConvocatoria filterPagosConvocatoria, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the PagosConvocatoria table.
	 *
	 * @param filterPagosConvocatoria
	 *            PagosConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<PagosConvocatoria>>
	 */
	JQGridResponseDto<JerarquiaDto<PagosConvocatoria>> jerarquia(PagosConvocatoria filterPagosConvocatoria,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the PagosConvocatoria
	 * table.
	 *
	 * @param filterPagosConvocatoria
	 *            PagosConvocatoria
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<PagosConvocatoria>>
	 */
	JQGridResponseDto<JerarquiaDto<PagosConvocatoria>> jerarquiaChildren(PagosConvocatoria filterPagosConvocatoria,
			JQGridRequestDto jqGridRequestDto);

}
