package com.ejie.ab60.service.pagos;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.ejie.ab60.model.pagos.PagosExpediente;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * PagosExpedienteService  
 * 
 *  
 */

public interface PagosExpedienteService {

	/**
	 * Inserts a single row in the PagosExpediente table.
	 *
	 * @param pagosExpediente
	 *            PagosExpediente
	 * @return PagosExpediente
	 */
	PagosExpediente add(PagosExpediente pagosExpediente);

	/**
	 * Updates a single row in the PagosExpediente table.
	 *
	 * @param pagosExpediente
	 *            PagosExpediente
	 * @param idExpediente
	 *            Integer
	 * @param httpRequest
	 *            HttpServletRequest
	 * @param usuario
	 *            Usuario
	 * @return PagosExpediente
	 */
	PagosExpediente add(PagosExpediente pagosExpediente, Integer idExpediente, HttpServletRequest httpRequest,
			Usuario usuario);

	/**
	 * Updates a single row in the PagosExpediente table.
	 *
	 * @param pagosExpediente
	 *            PagosExpediente
	 * @return PagosExpediente
	 */
	PagosExpediente update(PagosExpediente pagosExpediente);

	/**
	 * Updates a single row in the PagosExpediente table.
	 *
	 * @param pagosExpediente
	 *            PagosExpediente
	 * @param httpRequest
	 *            HttpServletRequest
	 * @param usuario
	 *            Usuario
	 * @return PagosExpediente
	 */
	PagosExpediente editPagos(PagosExpediente pagosExpediente, HttpServletRequest httpRequest, Usuario usuario);

	/**
	 * Updates a single row in the PagosExpediente table.
	 *
	 * @param pagosExpediente
	 *            PagosExpediente
	 * @return PagosExpediente
	 */
	PagosExpediente updatePagos(PagosExpediente pagosExpediente);

	/**
	 * Finds a single row in the PagosExpediente table.
	 *
	 * @param pagosExpediente
	 *            PagosExpediente
	 * @return PagosExpediente
	 */
	PagosExpediente find(PagosExpediente pagosExpediente);

	/**
	 * Finds a single row in the PagosExpediente table.
	 *
	 * @param pagosExpediente
	 *            PagosExpediente
	 * @return PagosExpediente
	 */
	PagosExpediente findPagos(PagosExpediente pagosExpediente);

	/**
	 * Deletes a single row in the PagosExpediente table.
	 *
	 * @param pagosExpediente
	 *            PagosExpediente
	 */
	void remove(PagosExpediente pagosExpediente);

	/**
	 * Deletes a single row in the PagosExpediente table.
	 *
	 * @param idPagoExpediente
	 *            Integer
	 * @return PagosExpediente
	 */
	PagosExpediente remove(Integer idPagoExpediente);

	/**
	 * Finds a list of rows in the PagosExpediente table.
	 *
	 * @param pagosExpediente
	 *            PagosExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<PagosExpediente>
	 */
	List<PagosExpediente> findAll(PagosExpediente pagosExpediente, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the PagosExpediente table using like.
	 *
	 * @param pagosExpediente
	 *            PagosExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<PagosExpediente>
	 */
	List<PagosExpediente> findAllLike(PagosExpediente pagosExpediente, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Finds rows in the PagosExpediente table using like.
	 *
	 * @param pagosExpediente
	 *            PagosExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<PagosExpediente>
	 */
	List<PagosExpediente> findAllLikeExportExcel(PagosExpediente pagosExpediente, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the PagosExpediente table.
	 *
	 * @param filterPagosExpediente
	 *            PagosExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(PagosExpediente filterPagosExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the PagosExpediente table.
	 *
	 * @param filterPagosExpediente
	 *            PagosExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<PagosExpediente>
	 */
	JQGridResponseDto<PagosExpediente> filter(PagosExpediente filterPagosExpediente, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the PagosExpediente table.
	 *
	 * @param filterPagosExpediente
	 *            PagosExpediente
	 * @param searchPagosExpediente
	 *            PagosExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<PagosExpediente>>
	 */
	List<TableRowDto<PagosExpediente>> search(PagosExpediente filterPagosExpediente,
			PagosExpediente searchPagosExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in PagosExpediente table.
	 *
	 * @param filterPagosExpediente
	 *            PagosExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(PagosExpediente filterPagosExpediente, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the PagosExpediente table.
	 *
	 * @param filterPagosExpediente
	 *            PagosExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<PagosExpediente>>
	 */
	JQGridResponseDto<JerarquiaDto<PagosExpediente>> jerarquia(PagosExpediente filterPagosExpediente,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the PagosExpediente
	 * table.
	 *
	 * @param filterPagosExpediente
	 *            PagosExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<PagosExpediente>>
	 */
	JQGridResponseDto<JerarquiaDto<PagosExpediente>> jerarquiaChildren(PagosExpediente filterPagosExpediente,
			JQGridRequestDto jqGridRequestDto);

}
