package com.ejie.ab60.service.parametros;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ejie.ab60.dao.parametros.ParametrosDao;
import com.ejie.ab60.model.parametros.Parametros;
import com.ejie.x38.dto.JQGridRequestDto;

/**
 * ParametrosServiceImpl  
 * 
 *  
 */

@Service(value = "parametrosService")
public class ParametrosServiceImpl implements ParametrosService {

	@Autowired
	private ParametrosDao parametrosDao;

	/**
	 * Finds a single row in the Parametros table.
	 *
	 * @param parametros
	 *            Parametros
	 * @return Parametros
	 */
	public Parametros find(Parametros parametros) {
		return (Parametros) this.parametrosDao.find(parametros);
	}

	/**
	 * Finds rows in the Parametros table using like.
	 *
	 * @param parametros
	 *            Parametros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Parametros>
	 */
	public List<Parametros> findAllLike(Parametros parametros, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return (List<Parametros>) this.parametrosDao.findAllLike(parametros, jqGridRequestDto, startsWith);
	}
}
