package com.ejie.ab60.service.plantillas;


import com.ejie.ab60.model.plantillas.RelPlaCam;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelPlaCamService  
 *  
 */

public interface RelPlaCamService {

	/**
	 * Inserts a single row in the RelPlaCam table.
	 *
	 * @param relPlaCam RelPlaCam
	 * @return RelPlaCam
	 */
    RelPlaCam add(RelPlaCam relPlaCam);

	/**
	 * Updates a single row in the RelPlaCam table.
	 *
	 * @param relPlaCam RelPlaCam
	 * @return RelPlaCam
	 */
	RelPlaCam update(RelPlaCam relPlaCam);

	/**
	 * Finds a single row in the RelPlaCam table.
	 *
	 * @param relPlaCam RelPlaCam
	 * @return RelPlaCam
	 */
	RelPlaCam find(RelPlaCam relPlaCam);

	/**
	 * Deletes a single row in the RelPlaCam table.
	 *
	 * @param relPlaCam RelPlaCam
	 */
	void remove(RelPlaCam relPlaCam);

	/**
	 * Finds a list of rows in the RelPlaCam table.
	 *
	 * @param relPlaCam RelPlaCam
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<RelPlaCam>
	 */
	List<RelPlaCam> findAll(RelPlaCam relPlaCam, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelPlaCam table using like.
	 *
	 * @param relPlaCam RelPlaCam
	 * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean	 
	 * @return List<RelPlaCam>
	 */
	List<RelPlaCam> findAllLike(RelPlaCam relPlaCam, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelPlaCam table.
	 *
	 * @param filterRelPlaCam RelPlaCam
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	void removeMultiple(RelPlaCam filterRelPlaCam, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
   
    
	/**
	 * Filter method in the RelPlaCam table.
	 *
	 * @param filterRelPlaCam RelPlaCam
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<RelPlaCam>
	 */	
	JQGridResponseDto<RelPlaCam> filter(RelPlaCam filterRelPlaCam, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
    
    /**
	 * Searches rows in the RelPlaCam table.
	 *
	 * @param filterRelPlaCam RelPlaCam
	 * @param searchRelPlaCam RelPlaCam
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<RelPlaCam>>
	 */	
    List<TableRowDto<RelPlaCam>> search(RelPlaCam filterRelPlaCam, RelPlaCam searchRelPlaCam, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /**
	 * Reorder the selection made in RelPlaCam table.
	 *
	 * @param filterRelPlaCam RelPlaCam
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    Object reorderSelection(RelPlaCam filterRelPlaCam, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the RelPlaCam table.
	 *
	 * @param filterRelPlaCam RelPlaCam
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelPlaCam>>
	 */	
	JQGridResponseDto<JerarquiaDto<RelPlaCam>> jerarquia(RelPlaCam filterRelPlaCam, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	/**
	 * Finder method for siblings rows in the hierarchical the RelPlaCam table.
	 *
	 * @param filterRelPlaCam RelPlaCam
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelPlaCam>>
	 */	
	JQGridResponseDto<JerarquiaDto<RelPlaCam>> jerarquiaChildren(RelPlaCam filterRelPlaCam, JQGridRequestDto jqGridRequestDto);
    
}


