package com.ejie.ab60.service.preguntasExpediente;


import com.ejie.ab60.model.preguntasExpediente.PreguntasExpediente;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * PreguntasExpedienteService  
 *  
 */

public interface PreguntasExpedienteService {

	/**
	 * Inserts a single row in the PreguntasExpediente table.
	 *
	 * @param preguntasExpediente PreguntasExpediente
	 * @return PreguntasExpediente
	 */
    PreguntasExpediente add(PreguntasExpediente preguntasExpediente);

	/**
	 * Updates a single row in the PreguntasExpediente table.
	 *
	 * @param preguntasExpediente PreguntasExpediente
	 * @return PreguntasExpediente
	 */
	PreguntasExpediente update(PreguntasExpediente preguntasExpediente);

	/**
	 * Finds a single row in the PreguntasExpediente table.
	 *
	 * @param preguntasExpediente PreguntasExpediente
	 * @return PreguntasExpediente
	 */
	PreguntasExpediente find(PreguntasExpediente preguntasExpediente);

	/**
	 * Deletes a single row in the PreguntasExpediente table.
	 *
	 * @param preguntasExpediente PreguntasExpediente
	 */
	void remove(PreguntasExpediente preguntasExpediente);

	/**
	 * Finds a list of rows in the PreguntasExpediente table.
	 *
	 * @param preguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<PreguntasExpediente>
	 */
	List<PreguntasExpediente> findAll(PreguntasExpediente preguntasExpediente, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the PreguntasExpediente table using like.
	 *
	 * @param preguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean	 
	 * @return List<PreguntasExpediente>
	 */
	List<PreguntasExpediente> findAllLike(PreguntasExpediente preguntasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	void removeMultiple(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
   
    
	/**
	 * Filter method in the PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<PreguntasExpediente>
	 */	
	JQGridResponseDto<PreguntasExpediente> filter(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
    
    /**
	 * Searches rows in the PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param searchPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<PreguntasExpediente>>
	 */	
    List<TableRowDto<PreguntasExpediente>> search(PreguntasExpediente filterPreguntasExpediente, PreguntasExpediente searchPreguntasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /**
	 * Reorder the selection made in PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    Object reorderSelection(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<JerarquiaDto<PreguntasExpediente>>
	 */	
	JQGridResponseDto<JerarquiaDto<PreguntasExpediente>> jerarquia(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	/**
	 * Finder method for siblings rows in the hierarchical the PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<PreguntasExpediente>>
	 */	
	JQGridResponseDto<JerarquiaDto<PreguntasExpediente>> jerarquiaChildren(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto);
    
}


