package com.ejie.ab60.service.preguntasExpediente;
import com.ejie.ab60.dao.preguntasExpediente.PreguntasExpedienteDao;
import com.ejie.ab60.model.preguntasExpediente.PreguntasExpediente;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * PreguntasExpedienteServiceImpl  
 *  
 */

@Service(value = "preguntasExpedienteService")
public class PreguntasExpedienteServiceImpl implements PreguntasExpedienteService {

	@Autowired
	private PreguntasExpedienteDao preguntasExpedienteDao;

	/**
	 * Inserts a single row in the PreguntasExpediente table.
	 *
	 * @param preguntasExpediente PreguntasExpediente
	 * @return PreguntasExpediente
	 */
	@Transactional(rollbackFor = Throwable.class)
	public PreguntasExpediente add(PreguntasExpediente preguntasExpediente) {
		return this.preguntasExpedienteDao.add(preguntasExpediente);
	}

	/**
	 * Updates a single row in the PreguntasExpediente table.
	 *
	 * @param preguntasExpediente PreguntasExpediente
	 * @return PreguntasExpediente
	 */
	@Transactional(rollbackFor = Throwable.class)
	public PreguntasExpediente update(PreguntasExpediente preguntasExpediente) {
		return this.preguntasExpedienteDao.update(preguntasExpediente);
	 }

	/**
	 * Finds a single row in the PreguntasExpediente table.
	 *
	 * @param preguntasExpediente PreguntasExpediente
	 * @return PreguntasExpediente
	 */
	public PreguntasExpediente find(PreguntasExpediente preguntasExpediente) {
		return (PreguntasExpediente) this.preguntasExpedienteDao.find(preguntasExpediente);
	}
	
	/**
	 * Deletes a single row in the PreguntasExpediente table.
	 *
	 * @param preguntasExpediente PreguntasExpediente
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(PreguntasExpediente preguntasExpediente) {
		this.preguntasExpedienteDao.remove(preguntasExpediente);
	}

	/**
	 * Finds a list of rows in the PreguntasExpediente table.
	 *
	 * @param preguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<PreguntasExpediente>
	 */
	public List<PreguntasExpediente> findAll(PreguntasExpediente preguntasExpediente, JQGridRequestDto jqGridRequestDto){
		return (List<PreguntasExpediente>) this.preguntasExpedienteDao.findAll(preguntasExpediente, jqGridRequestDto);
	}
    
	/**
	 * Finds rows in the PreguntasExpediente table using like.
	 *
	 * @param preguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean	 
	 * @return List<PreguntasExpediente>
	 */
	public List<PreguntasExpediente> findAllLike(PreguntasExpediente preguntasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith){
		return (List<PreguntasExpediente>) this.preguntasExpedienteDao.findAllLike(preguntasExpediente, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Removes rows from the PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	public void removeMultiple(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto,  Boolean startsWith){
		this.preguntasExpedienteDao.removeMultiple(filterPreguntasExpediente, jqGridRequestDto, startsWith);
	}
        
	/**
	 * Filter method in the PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<PreguntasExpediente>
	 */	
	public JQGridResponseDto< PreguntasExpediente> filter(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto,  Boolean startsWith){
		List<PreguntasExpediente> listaPreguntasExpediente =  this.preguntasExpedienteDao.findAllLike(filterPreguntasExpediente, jqGridRequestDto, false);
		Long recordNum =  this.preguntasExpedienteDao.findAllLikeCount(filterPreguntasExpediente != null ? filterPreguntasExpediente: new PreguntasExpediente (),false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds()!=null){
			List< TableRowDto< PreguntasExpediente>> reorderSelection = this.preguntasExpedienteDao.reorderSelection(filterPreguntasExpediente, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<PreguntasExpediente>(jqGridRequestDto, recordNum, listaPreguntasExpediente, reorderSelection);
		}
		return new JQGridResponseDto<PreguntasExpediente>(jqGridRequestDto, recordNum, listaPreguntasExpediente);   
	}
    
    /**
	 * Searches rows in the PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param searchPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<PreguntasExpediente>>
	 */	
    public List< TableRowDto< PreguntasExpediente>> search(PreguntasExpediente filterPreguntasExpediente, PreguntasExpediente searchPreguntasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith){
		return this.preguntasExpedienteDao.search(filterPreguntasExpediente, searchPreguntasExpediente, jqGridRequestDto, startsWith);
	}
    
    /**
	 * Reorder the selection made in PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    public Object reorderSelection(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith){
		return this.preguntasExpedienteDao.reorderSelection(filterPreguntasExpediente, jqGridRequestDto, startsWith);
	}
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<JerarquiaDto<PreguntasExpediente>>
	 */	
	public JQGridResponseDto<JerarquiaDto<PreguntasExpediente>> jerarquia(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith){
		List<JerarquiaDto<PreguntasExpediente>> listaPreguntasExpediente =  this.preguntasExpedienteDao.findAllLikeJerarquia(filterPreguntasExpediente, jqGridRequestDto);
		Long recordNum = this.preguntasExpedienteDao.findAllLikeCountJerarquia(filterPreguntasExpediente, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<PreguntasExpediente>>(jqGridRequestDto, recordNum, listaPreguntasExpediente);
	}
	
	/**
	 * Finder method for siblings rows in the hierarchical the PreguntasExpediente table.
	 *
	 * @param filterPreguntasExpediente PreguntasExpediente
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<PreguntasExpediente>>
	 */	
	public JQGridResponseDto<JerarquiaDto<PreguntasExpediente>> jerarquiaChildren(PreguntasExpediente filterPreguntasExpediente, JQGridRequestDto jqGridRequestDto){
		JQGridResponseDto<JerarquiaDto<PreguntasExpediente>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<PreguntasExpediente>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN, this.preguntasExpedienteDao.findAllChild(filterPreguntasExpediente, jqGridRequestDto));
		return jqGridResponseDto;
	}
	
	
}

