<%@page pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@include file="/WEB-INF/includeTemplate.inc"%>
<%@ taglib prefix="sec" uri="http://www.springframework.org/security/tags" %>

<script type="text/javascript">
	
	function accederMenuPrincipal (nombreControlador){
		if (null !=$("#controlCambios").val() && 1 == $("#controlCambios").val()) {
			// hay cambios en la pantalla, deberiamos mostrar mensaje de que hay cambios
			$.rup_messages("msgConfirm", {
				title:  $.rup.i18n.app.mensajes.titulo,
				message: $.rup.i18n.app.mensajes.calculo_sin_guardar,
				OKFunction: function(){
					$(".container #guardar").click();
					accederMenuPrincipalSubmit(nombreControlador);
				},
				CANCELFunction: function(){
					accederMenuPrincipalSubmit(nombreControlador);
				}
			});
		}else{
			// si no hay cambios, accedemos directamente al controller
			accederMenuPrincipalSubmit(nombreControlador);
		}	
	}	
	
	function accederMenuPrincipalSubmit(nombreControlador){
		if (nombreControlador == 'expedientes' || nombreControlador == 'listados')
		{
			$("#idExpediente").val("");
			$('#idConvocatoria').val("");
		}
		document.forms["initForm"].action = "/ab60WebAppWar/"+nombreControlador+"/maint"
		document.forms["initForm"].target = "_self";
		bloquearInterfaz();
		$("#initForm").submit();
	}
	
	function accederMenuConvocatoriaSubmit(nombreControlador){
		document.forms["initConvocatoriaForm"].action = "/ab60WebAppWar/"+nombreControlador+"/maint";
		document.forms["initConvocatoriaForm"].target = "_blank";
			
		$("#initConvocatoriaForm").submit();
	}
	
	function activarControlCambios(){
		
		$(":input").change(function(){
			$("#controlCambios").val(1);
		});
	}
	
	function logout(){
		$.rup_messages("msgConfirm", {
			title: $.rup.i18n.app.msg.logout,
			message: $.rup.i18n.app.msg.logoutConfirm,
			OKFunction: function() {
				window.location = "ab60WebAppWar/logout";
			}
		});
	}

</script>
 
 
 <div id="divNavBarPrincipal">
	<nav class="navbar navbar-default navbar-principal">
	  <div class="container">
		  <!-- Collect the nav links, forms, and other content for toggling -->
		   <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
				<ul id="menuApp" class="nav navbar-nav">
				  
				  <!-- Los tecnicos de comercio y turismo no pueden acceder a esta opcion de menu -->
				  <%@ taglib prefix="sec" uri="http://www.springframework.org/security/tags" %>
	
				<sec:authorize access="hasAnyRole('ROLE_AB60-IN-0001','ROLE_AB60-IN-0002',
								    'ROLE_AB60-IN-0004','ROLE_AB60-IN-0006')">
				  	<li id="mnFichaConvocatoria"><a  href="javascript:accederMenuPrincipal('convocatorias')"><spring:message code="fconvocatoria" /></a></li>
				</sec:authorize>
				  
				  <li id="mnFichaExpediente" class="hidden"><a  href="javascript:accederMenuPrincipal('relexpter')"><spring:message code="fexpediente" /></a></li>
				  <li id="mnFichaConsulta" class="dropdown">
					 <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false"><spring:message code="consulta" /> <span class="caret"></span></a>
					  <ul class="dropdown-menu">
						<li><a  href="javascript:accederMenuPrincipal('expedientes')"><spring:message code="busqueda" /></a></li>
						<li><a href="javascript:accederMenuPrincipal('listados')"><spring:message code="listados" /></a></li>
					  </ul>
					</li>
		        
				<sec:authorize access="hasAnyRole('ROLE_AB60-IN-0001','ROLE_AB60-IN-0002',
								    'ROLE_AB60-IN-0004','ROLE_AB60-IN-0006')">
								    
					<li id="menuTablasBasicas" class="dropdown">
					 <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false"><spring:message code="tablasBasicas" /> <span class="caret"></span></a>
					  <ul class="dropdown-menu">
						<li><a  href="javascript:accederMenuPrincipal('tecnicosresponsables')"><spring:message code="tablasBasicas.tecnicosResponsable" /></a></li>						
						<li><a  href="javascript:accederMenuPrincipal('motivosdenegacion')"><spring:message code="tablasBasicas.motivosDenegacion" /></a></li>
						<li><a  href="javascript:accederMenuPrincipal('motivosminoracion')"><spring:message code="tablasBasicas.motivosMinoracion" /></a></li>
					  </ul>
					</li>
								    
					<li id="mnModuloContable" class="hidden"><a href="javascript:accederMenuPrincipal('moduloContable')"><spring:message code="moduloContable.titulo" /></a></li>
					<li id="mnDatosConvocatoria" class="hidden"><a href="javascript:accederMenuConvocatoriaSubmit('convocatorias');"><i class="fa fa-external-link" aria-hidden="true"></i> <spring:message code="verMas" /></a></li>
				</sec:authorize>
 					<li id="mnUtilidades" class="dropdown hidden">
					 <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false"><spring:message code="utilidades.titulo" /> <span class="caret"></span></a>
					  <ul class="dropdown-menu">
						<li><a  href="javascript:accederMenuPrincipal('copiaConvocatoria');"><spring:message code="utilidades.copiaConvocatoria" /></a></li>
					  </ul>
					</li>	
				</ul>
				<ul class="nav navbar-nav navbar-right">
					<li class="dropdown">
					  <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false"><i class="fa fa-user-circle-o" aria-hidden="true"></i> ${usuario.nombreUsuario}<span class="caret"></span></a>
						<ul class="dropdown-menu">
							<li><a href="#"><i class="fa fa-question-circle" aria-hidden="true"></i><spring:message code="expediente.ayuda" /></a></li>
							<li role="separator" class="divider"></li>
							<li><a href="javascript:logout();"><i class="fa fa-sign-out" aria-hidden="true"></i><spring:message code="cerrarSesion" /></a></li>
						</ul>
					</li>
				</ul>
		   </div><!-- /.navbar-collapse -->
	  </div><!-- /.container-fluid -->
	</nav>
</div>

<div id="overlay"></div>