package com.ejie.ab60.control.actuacionesSubvencionables;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.servlet.ModelAndView;

import com.ejie.ab60.comun.Constantes;
import com.ejie.ab60.model.actuacionesSubvencionables.ActSubvencionable;
import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.ab60.model.expedientes.MarcarInspeccionableAct;
import com.ejie.ab60.model.inicio.InitForm;
import com.ejie.ab60.service.actuacionesSubvencionables.ActSubvencionableService;
import com.ejie.ab60.service.convocatorias.ConvocatoriasService;
import com.ejie.ab60.util.PermisosXLNETS;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.reports.ReportData;

/**
 * ActSubvencionableController  
 * 
 *  
 */

@Controller
@RequestMapping(value = "/actsubvencionable")

public class ActSubvencionableController {

	private static final Logger logger = LoggerFactory.getLogger(ActSubvencionableController.class);

	@Autowired
	private ActSubvencionableService actSubvencionableService;

	@Autowired
	private ConvocatoriasService convocatoriasService;

	@Autowired
	private ReloadableResourceBundleMessageSource appMessageSource;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idActSub
	 *            Integer
	 * @return ActSubvencionable Objeto correspondiente al identificador
	 *         indicado.
	 */
	@RequestMapping(value = "/{idConvocatoria}/{idActSub}", method = RequestMethod.GET)
	public @ResponseBody ActSubvencionable getPorcentaje(@PathVariable Integer idActSub) {
		ActSubvencionable actSubvencionable = new ActSubvencionable();
		actSubvencionable.setIdActSub(idActSub);
		actSubvencionable = this.actSubvencionableService.findPorcentaje(actSubvencionable);
		ActSubvencionableController.logger.info("[GET - findBy_PK] : Obtener ActSubvencionable por PK");
		return actSubvencionable;
	}

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idActSub
	 *            Integer
	 * @return ActSubvencionable Objeto correspondiente al identificador
	 *         indicado.
	 */
	@RequestMapping(value = "/getAccionSubvencionablePadre/{idConvocatoria}/{idExpediente}", method = RequestMethod.GET)
	public @ResponseBody List<ActSubvencionable> getAccionSubvencionablePadre(@PathVariable Integer idExpediente,
			@PathVariable Integer idConvocatoria) {
		return this.actSubvencionableService.findAccionSubvencionablePadre(idExpediente, idConvocatoria);
	}

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idActSub
	 *            Integer
	 * @return ActSubvencionable Objeto correspondiente al identificador
	 *         indicado.
	 */
	@RequestMapping(value = "/getAccionSubvencionablePadreDEC/{idConvocatoria}/{idExpediente}", method = RequestMethod.GET)
	public @ResponseBody List<ActSubvencionable> getAccionSubvencionableDEC(@PathVariable Integer idExpediente,
			@PathVariable Integer idConvocatoria) {
		return this.actSubvencionableService.findAccionSubvencionableDEC(idExpediente, idConvocatoria);
	}

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idActSub
	 *            Integer
	 * @return ActSubvencionable Objeto correspondiente al identificador
	 *         indicado.
	 */
	@RequestMapping(value = "/getAccionSubvencionablePadreEMCO/{idConvocatoria}/{idExpediente}", method = RequestMethod.GET)
	public @ResponseBody List<ActSubvencionable> getAccionSubvencionableEMCO(@PathVariable Integer idExpediente,
			@PathVariable Integer idConvocatoria) {
		return this.actSubvencionableService.findAccionSubvencionableEMCO(idExpediente, idConvocatoria);
	}

	@RequestMapping(value = "/getAccionSubvencionablePadreAsoEMCO/{idConvocatoria}/{idExpediente}", method = RequestMethod.GET)
	public @ResponseBody List<ActSubvencionable> getAccionSubvencionablePadreAsoEMCO(@PathVariable Integer idExpediente,
			@PathVariable Integer idConvocatoria) {
		return this.actSubvencionableService.findAccionSubvencionableAsoEMCO(idExpediente, idConvocatoria);
	}

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idActSub
	 *            Integer
	 * @return ActSubvencionable Objeto correspondiente al identificador
	 *         indicado.
	 */
	@RequestMapping(value = "/getActSubvencionablePadrePTT/{idConvocatoria}", method = RequestMethod.GET)
	public @ResponseBody List<ActSubvencionable> getAccionSubvencionablePadrePTT(@PathVariable Integer idConvocatoria) {

		return this.actSubvencionableService.findAccionSubvencionablePadrePTT(idConvocatoria);

	}

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idActSub
	 *            Integer
	 * @return ActSubvencionable Objeto correspondiente al identificador
	 *         indicado.
	 */
	@RequestMapping(value = "/getAccionSubvencionableNieto", method = RequestMethod.GET)
	public @ResponseBody List<ActSubvencionable> getAccionSubvencionableNieto(
			@RequestParam(value = "actSubvencionable.idActSubPadre") Integer idActSub) {

		return this.actSubvencionableService.findAccionSubvencionableNieto(idActSub);
	}

	@RequestMapping(value = "/getAccionSubvencionableAsoEMCONieto/{idExpediente}", method = RequestMethod.GET)
	public @ResponseBody List<ActSubvencionable> getAccionSubvencionableAsoEMCONieto(
			@RequestParam(value = "actSubvencionable.idActSubPadre") Integer idActSub,
			@PathVariable Integer idExpediente) {

		return this.actSubvencionableService.getAccionSubvencionableAsoEMCONieto(idActSub, idExpediente);
	}

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idActSubAgrupacion
	 *            Integer
	 * @param existe_Pertenencia_Redes
	 *            Boolean
	 * @return ActSubvencionable Objeto correspondiente al identificador
	 *         indicado.
	 */
	@RequestMapping(value = "/getActSubvencionableHijo/{existe_Pertenencia_Redes}", method = RequestMethod.GET)
	public @ResponseBody List<ActSubvencionable> getAccionSubvencionableHijo(
			@RequestParam(value = "actSubvencionable.identificadores") String identificadores,
			@PathVariable("existe_Pertenencia_Redes") String existe_Pertenencia_Redes) {

		String arrayIdenficadores[] = identificadores.split("/");

		Integer idActSub = 0;
		if (arrayIdenficadores.length > 0) {
			idActSub = Integer.parseInt(arrayIdenficadores[1]);

		}

		return this.actSubvencionableService.findAccionSubvencionableHijoPTT(idActSub,
				Boolean.parseBoolean(existe_Pertenencia_Redes));

	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable Bean que contiene la informacion con la que
	 *            se va a crear el nuevo registro.
	 * @return ActSubvencionable Bean resultante del proceso de creacion.
	 */
	@RequestMapping(value = "/{idConvocatoria}/{idExpediente}", method = RequestMethod.POST)
	public @ResponseBody ActSubvencionable add(@RequestBody() ActSubvencionable actSubvencionable,
			@PathVariable Integer idCriterio, @PathVariable Integer idConvocatoria) {
		actSubvencionable.setIdActSubPadre(idCriterio);
		Convocatorias convocatorias = new Convocatorias();
		convocatorias.setIdConvocatoria(idConvocatoria);
		actSubvencionable.setConvocatorias(convocatorias);
		ActSubvencionable actSubvencionableAux = this.actSubvencionableService.add(actSubvencionable);
		ActSubvencionableController.logger.info("[POST] : ActSubvencionable insertado correctamente");
		return actSubvencionableAux;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterActSubvencionable
	 *            ActSubvencionable Objeto que contiene los parametros de
	 *            filtrado utilizados en la busqueda.
	 * @return List<ActSubvencionable> Lista de objetos correspondientes a la
	 *         busqueda realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<ActSubvencionable> getAll(@ModelAttribute ActSubvencionable filterActSubvencionable) {
		ActSubvencionableController.logger.info("[GET - find_ALL] : Obtener ActSubvencionable por filtro");
		return this.actSubvencionableService.findAll(filterActSubvencionable, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param actSubvencionable
	 *            ActSubvencionable Bean que contiene la informacion a
	 *            modificar.
	 * @return ActSubvencionable Bean resultante de la modificacion.
	 */
	@RequestMapping(value = "/{idConvocatoria}", method = RequestMethod.PUT)
	public @ResponseBody ActSubvencionable edit(HttpServletRequest httpRequest, @PathVariable Integer idConvocatoria,
			@RequestBody ActSubvencionable actSubvencionable) {

		actSubvencionable.setFechaUltmodificacion(new Date());
		actSubvencionable.setUsuarioUltmodificacion(PermisosXLNETS.fncLogin(httpRequest));

		ActSubvencionableController.logger.info("[PUT] : ActSubvencionable actualizado correctamente");
		ActSubvencionable actSubvencionableAux = this.actSubvencionableService.update(actSubvencionable);

		return actSubvencionableAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idActSub
	 *            Integer Identificador del objeto que se desea eliminar.
	 * @return ActSubvencionable Bean eliminado.
	 */
	@RequestMapping(value = "/{idActSub}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody ActSubvencionable remove(@PathVariable Integer idActSub) {
		ActSubvencionable actSubvencionable = new ActSubvencionable();
		actSubvencionable.setIdActSub(idActSub);
		this.actSubvencionableService.remove(actSubvencionable);
		ActSubvencionableController.logger.info("[DELETE] : ActSubvencionable borrado correctamente");
		return actSubvencionable;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {
		ActSubvencionableController.logger.info("[GET - View] : actsubvencionable");
		return "actsubvencionable";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterActSubvencionable
	 *            ActSubvencionable Bean que contiene los parametros de filtrado
	 *            a emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<ActSubvencionable> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<ActSubvencionable> filter(
			@RequestJsonBody(param = "filter") ActSubvencionable filterActSubvencionable,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		ActSubvencionableController.logger.info("[POST - filter] : Obtener ActSubvencionables");
		return this.actSubvencionableService.filter(filterActSubvencionable, jqGridRequestDto, false);

	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterActSubvencionable
	 *            ActSubvencionable Bean que contiene los parametros de filtrado
	 *            a emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<ActSubvencionable> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/{idConvocatoria}/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<ActSubvencionable> filterPorcentaje(
			@RequestJsonBody(param = "filter") ActSubvencionable filterActSubvencionable,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto, @ModelAttribute(value = "initForm") InitForm initForm) {
		Convocatorias convocatorias = new Convocatorias();
		convocatorias.setIdConvocatoria(initForm.getIdConvocatoria());
		filterActSubvencionable.setConvocatorias(convocatorias);
		ActSubvencionableController.logger.info("[POST - filter] : Obtener ActSubvencionables");
		return this.actSubvencionableService.filterPorcentaje(filterActSubvencionable, jqGridRequestDto, false);

	}

	/**
	 * Operacion de busqueda del componente RUP_TABLE.
	 * 
	 * @param filterActSubvencionable
	 *            ActSubvencionable Bean que contiene los parametros de filtrado
	 *            a emplear.
	 * @param searchActSubvencionable
	 *            ActSubvencionable Bean que contiene los parametros de busqueda
	 *            a emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la búsqueda.
	 * @return TableRowDto<ActSubvencionable> Dto que contiene el resultado de
	 *         la busqueda realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<ActSubvencionable>> search(
			@RequestJsonBody(param = "filter") ActSubvencionable filterActSubvencionable,
			@RequestJsonBody(param = "search") ActSubvencionable searchActSubvencionable,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		ActSubvencionableController.logger.info("[POST - search] : Buscar ActSubvencionables");
		return this.actSubvencionableService.search(filterActSubvencionable, searchActSubvencionable, jqGridRequestDto,
				false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterActSubvencionable
	 *            ActSubvencionable Bean que contiene los parametros de filtrado
	 *            a emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(
			@RequestJsonBody(param = "filter") ActSubvencionable filterActSubvencionable,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		ActSubvencionableController.logger
				.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples ActSubvencionables");
		this.actSubvencionableService.removeMultiple(filterActSubvencionable, jqGridRequestDto, false);
		ActSubvencionableController.logger.info("All entities correctly deleted!");

		return jqGridRequestDto.getMultiselection().getSelectedIds();
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE - JERARQUIA
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE para presentar los
	 * registros mediante visualizacion jerarquica.
	 * 
	 * @param filterActSubvencionable
	 *            ActSubvencionable Bean que contiene los parametros de filtrado
	 *            a emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<JerarquiaDto<ActSubvencionable>> Dto que
	 *         contiene el resultado del filtrado realizado por el componente
	 *         RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquia/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<JerarquiaDto<ActSubvencionable>> jerarquia(
			@RequestJsonBody(param = "filter") ActSubvencionable filterActSubvencionable,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		ActSubvencionableController.logger.info("[POST - jerarquia] : Obtener ActSubvencionables jerarquia");
		return this.actSubvencionableService.jerarquia(filterActSubvencionable, jqGridRequestDto, false);
	}

	/**
	 * Recupera los hijos de los registros desplegados en la visualizacion
	 * jerarquica.
	 * 
	 * @param filterActSubvencionable
	 *            ActSubvencionable Bean que contiene los parametros de filtrado
	 *            a emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<JerarquiaDto<ActSubvencionable>> Dto que
	 *         contiene el resultado del filtrado realizado por el componente
	 *         RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquiaChildren", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<JerarquiaDto<ActSubvencionable>> jerarquiaChildren(
			@RequestJsonBody(param = "filter") ActSubvencionable filterActSubvencionable,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		ActSubvencionableController.logger.info("[POST - jerarquia] : Obtener ActSubvencionables jerarquia - Hijos");
		return this.actSubvencionableService.jerarquiaChildren(filterActSubvencionable, jqGridRequestDto);
	}

	/**
	 * Permite crear reportes xls o xlsx
	 * 
	 * @param filterDireccion
	 * @param jqGridRequestDto
	 * @param modelMap
	 * @param columns
	 * @param request
	 * @return
	 */

	@RequestMapping(value = { "{idConvocatoria}/xlsReport",
			"{idConvocatoria}/xlsxReport" }, method = RequestMethod.POST)
	protected ModelAndView getExcelPOI(@ModelAttribute ActSubvencionable filterActSubvencionable,
			@ModelAttribute JQGridRequestDto jqGridRequestDto, ModelMap modelMap,
			@ModelAttribute(value = "initForm") InitForm initForm,
			@RequestParam(value = "columns", required = false) String columns, HttpServletRequest request) {

		Locale locale = LocaleContextHolder.getLocale();

		Convocatorias convocatorias = new Convocatorias();
		convocatorias.setIdConvocatoria(initForm.getIdConvocatoria());
		filterActSubvencionable.setConvocatorias(convocatorias);

		columns = "[['descripcionCastellano','Descripcion'],['porcentajeActuacion','Porcentaje Actuaccion']]";

		// Acceso a BD para recuperar datos
		List<ActSubvencionable> listProgramasPage = this.actSubvencionableService.findAllLike(filterActSubvencionable,
				jqGridRequestDto, null);
		jqGridRequestDto.setPage(null);
		jqGridRequestDto.setRows(null);
		List<ActSubvencionable> listProgramasAll = this.actSubvencionableService.findAllLike(filterActSubvencionable,
				jqGridRequestDto, null);

		// Nombre fichero
		modelMap.put("fileName", "ActSubvencionableExcel");

		// Datos
		List<Object> reportData = new ArrayList<Object>();
		// Hoja 1
		ReportData<ActSubvencionable> usuarioExcelDataAll = new ReportData<ActSubvencionable>();
		// nombre hoja
		usuarioExcelDataAll
				.setSheetName(appMessageSource.getMessage("usuarioExcel.totalActSubConvocatoria", null, locale));
		// cabeceras hoja
		usuarioExcelDataAll.setHeaderNames(ReportData.parseColumns(columns));
		// datos hoja
		usuarioExcelDataAll.setModelData(listProgramasAll);
		reportData.add(usuarioExcelDataAll);
		// Hoja 2
		ReportData<ActSubvencionable> usuarioExcelDataPage = new ReportData<ActSubvencionable>();
		// nombre hoja
		usuarioExcelDataPage
				.setSheetName(appMessageSource.getMessage("usuarioExcel.actSubPag1Convocatoria", null, locale));
		// cabeceras hoja
		usuarioExcelDataPage.setHeaderNames(ReportData.parseColumns(columns));
		// datos hoja
		usuarioExcelDataPage.setModelData(listProgramasPage);
		reportData.add(usuarioExcelDataPage);
		modelMap.put("reportData", reportData);

		// Generación del XLS o XLSX
		if (request.getServletPath().indexOf("xlsReport") != -1) {
			return new ModelAndView("xlsReport", modelMap);
		} else {
			return new ModelAndView("xlsxReport", modelMap);
		}
	}

	/**
	 * FILTER PARA MODAL DESDE MARCAR COMO INSPECCIONABLE ACCESIBLE DESDE
	 * ESTUDIO TECNICO O JUSTIFICACION PARA ENVIO DE DATOS A AB79 A PARTIR DE
	 * WEBSERVICE
	 */

	@RequestMapping(value = "/marcarInspeccionable/{idExpediente}/{idConvocatoria}/{idActSubPadre}/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<MarcarInspeccionableAct> filter(
			@RequestJsonBody(param = "filter") ActSubvencionable filterActSub, @PathVariable Integer idExpediente,
			@PathVariable Integer idConvocatoria, @PathVariable Integer idActSubPadre,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {

		// filterFacturas.set
		ActSubvencionableController.logger.info("[POST - filter] : Obtener ActSubvencionables con ides");

		Convocatorias convocatoria = new Convocatorias();
		convocatoria.setIdConvocatoria(idConvocatoria);

		convocatoria = convocatoriasService.find(convocatoria);

		if (convocatoria.getIdTipoAyuda() == Constantes.TIPO_AYUDA_EMCO) {
			return this.actSubvencionableService.filterSubActMarcarInspeccionableEMCO(idExpediente, jqGridRequestDto,
					false);
		} else if (convocatoria.getIdTipoAyuda() == Constantes.TIPO_AYUDA_DEC) {
			return this.actSubvencionableService.filterSubActMarcarInspeccionableDEC(idExpediente, convocatoria,
					jqGridRequestDto, false, idActSubPadre);
		} else {
			return this.actSubvencionableService.filterSubActMarcarInspeccionable(idExpediente, convocatoria,
					jqGridRequestDto, false);
		}
	}

}