package com.ejie.ab60.control.convocatorias;

import java.math.BigDecimal;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.SessionAttributes;

import com.ejie.ab60.model.convocatorias.DatosContables;
import com.ejie.ab60.model.convocatorias.InfDatosIkus;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.ab60.service.convocatorias.InfContablesIkusService;

@Controller
@SessionAttributes("usuario")
@RequestMapping(value = "/infcontableikus")

public class InfContableIkusController {

	private static final Logger logger = LoggerFactory.getLogger(InfContableIkusController.class);

	@Autowired
	private InfContablesIkusService infContablesIkusService;

	/**
	 * Metod para hacer un update de datoscontables
	 * 
	 * @param tercero
	 * @return DatosContables Bean resultante del proceso de creacion
	 */

	@RequestMapping(value = "/save/{idConvocatoria}", method = RequestMethod.GET)
	public @ResponseBody() InfDatosIkus saveDatosContables(@PathVariable("idConvocatoria") Integer idConvocatoria,
			@RequestParam(value = "idDatosContables", required = true) Integer idDatosContables,
			@RequestParam(value = "institucionLOT", required = true) String institucionLOT,
			@RequestParam(value = "ejercicioLOT", required = true) String ejercicioLOT,
			@RequestParam(value = "seccionLOT", required = true) String seccionLOT,
			@RequestParam(value = "usuIkusLOT", required = true) String usuIkusLOT,
			@RequestParam(value = "idioma", required = true) Integer idioma,
			@RequestParam(value = "conceptoLOT", required = true) String conceptoLOT,
			@RequestParam(value = "importeLOT", required = true) String importeLOT,
			@RequestParam(value = "importeDisponibleLOT", required = true) String importeDisponibleLOT)
			throws Exception {
		InfContableIkusController.logger.info("entrar en save");

		Authentication aut = SecurityContextHolder.getContext().getAuthentication();
		Usuario usuario = new Usuario();
		String username = "";
		if (null != aut) {
			username = (String) aut.getPrincipal();
		}
		usuario.setNombreUsuario(username);

		/*
		 * if (infDatosIkus.getRefIntervencion() == null)
		 * infDatosIkus.setRefIntervencion(new ReferenciasIntervencion());
		 */

		InfDatosIkus infDatosIkus = new InfDatosIkus();

		DatosContables datoContable = new DatosContables();
		datoContable.setIdDatoContable(idDatosContables);
		datoContable.setInstitucion(institucionLOT);
		datoContable.setEjercicio(ejercicioLOT);
		datoContable.setSeccion(seccionLOT);
		datoContable.setUsuarioIkus(usuIkusLOT);
		datoContable.setIdIdioma(idioma);
		datoContable.setConceptoResumido(conceptoLOT);
		datoContable.setImporte(("".equals(importeLOT)) ? new BigDecimal(0) : new BigDecimal(importeLOT));
		datoContable.setImporteDisponible(
				("".equals(importeDisponibleLOT)) ? new BigDecimal(0) : new BigDecimal(importeDisponibleLOT));

		infDatosIkus.setDatosContables(datoContable);

		if (infDatosIkus.getDatosContables() == null)
			infDatosIkus.setDatosContables(new DatosContables());

		return this.infContablesIkusService.saveInfContablesIkus(infDatosIkus, usuario, idConvocatoria);

	}
}
