package com.ejie.ab60.control.copiaConvocatoria;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.SessionAttributes;

import com.ejie.ab60.control.moduloContable.ModuloContableController;
import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.ab60.model.inicio.InitForm;
import com.ejie.ab60.service.convocatorias.TiposAyudaService;

@Controller
@SessionAttributes("usuario")
@RequestMapping(value = "/copiaConvocatoria")
public class CopiaConvocatoriaController {

	private static final Logger logger = LoggerFactory.getLogger(ModuloContableController.class);

	@Autowired
	private TiposAyudaService tiposAyudaService;

	/**
	 * @param model
	 *            Model
	 * @param initForm
	 *            initForm
	 * 
	 * @return ModelAndView
	 * @throws Exception
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.POST)
	public String getFormEditMenu(Model model, @ModelAttribute(value = "initForm") InitForm initForm) {
		CopiaConvocatoriaController.logger.info("[GET - View] : copiaConvocatoria");

		Integer idConvocatoria = initForm.getIdConvocatoria();

		Convocatorias copiaConvocatoria = new Convocatorias();
		copiaConvocatoria.setIdProcedimiento(idConvocatoria);
		model.addAttribute("copiaConvocatoria", copiaConvocatoria);
		return "copiaConvocatoria";
	}

	@RequestMapping(value = "/copiar", method = RequestMethod.POST)
	public @ResponseBody() String copiar(@RequestBody() Convocatorias copiaConvocatoria) {
		CopiaConvocatoriaController.logger.info("[Inicio] : copiar");

		String msg = tiposAyudaService.copiaConvocatoria(copiaConvocatoria);
		CopiaConvocatoriaController.logger.info("[Fin] : copiar");
		return msg;
	}
}
