package com.ejie.ab60.control.estudioTecnico;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Properties;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.bind.annotation.SessionAttributes;
import org.springframework.web.servlet.ModelAndView;

import com.ejie.ab60.adaptadores.ab79WebServiceAdaptadorService;
import com.ejie.ab60.clientesWS.ab79WebService.Ab79Exception;
import com.ejie.ab60.comun.Constantes;
import com.ejie.ab60.comun.utilidades.config.Config;
import com.ejie.ab60.model.OtrosIngresos;
import com.ejie.ab60.model.RelExpIns;
import com.ejie.ab60.model.actuacionesSubvencionables.ActSubvencionable;
import com.ejie.ab60.model.actuacionesSubvencionables.RelExpActSub;
import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.ab60.model.criteriosPuntuacion.CriteriosPuntuacion;
import com.ejie.ab60.model.criteriosPuntuacion.RelExpCriPun;
import com.ejie.ab60.model.estudioTecnico.DatosTerOmic;
import com.ejie.ab60.model.estudioTecnico.EstudioTecnico;
import com.ejie.ab60.model.expedientes.Expedientes;
import com.ejie.ab60.model.expedientes.MarcarInspeccionable;
import com.ejie.ab60.model.expedientes.MarcarInspeccionableAct;
import com.ejie.ab60.model.inicio.InitForm;
import com.ejie.ab60.model.procedimientos.Procedimientos;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.ab60.service.OtrosIngresosService;
import com.ejie.ab60.service.RelExpInsService;
import com.ejie.ab60.service.actuacionesSubvencionables.ActSubvencionableService;
import com.ejie.ab60.service.actuacionesSubvencionables.RelExpActSubService;
import com.ejie.ab60.service.calculoAyuda.CalculoAyudaService;
import com.ejie.ab60.service.convocatorias.ConvocatoriasService;
import com.ejie.ab60.service.criteriosPuntuacion.CriteriosPuntuacionService;
import com.ejie.ab60.service.criteriosPuntuacion.RelExpCriPunService;
import com.ejie.ab60.service.estudioTecnico.DatosTerOmicService;
import com.ejie.ab60.service.estudioTecnico.EstudioTecnicoService;
import com.ejie.ab60.service.expedientes.ExpedientesService;
import com.ejie.ab60.service.procedimientos.ProcedimientosService;
import com.ejie.ab60.util.UtilDate;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.reports.ReportData;

/**
 * EstudioTecnicoController  
 * 
 *  
 */

@Controller
@SessionAttributes("usuario")
@RequestMapping(value = "/estudioTecnico")

public class EstudioTecnicoController {

	private static final Logger logger = LoggerFactory.getLogger(EstudioTecnicoController.class);

	@Autowired
	private EstudioTecnicoService estudioTecnicoService;
	@Autowired
	private CriteriosPuntuacionService criteriosPuntuacionService;
	@Autowired
	private RelExpCriPunService relExpCriPunSercive;

	@Autowired
	private ConvocatoriasService convocatoriasService;

	@Autowired
	private CalculoAyudaService calculoAyudaService;

	@Autowired
	private RelExpActSubService relExpActSubService;

	@Autowired
	private ActSubvencionableService actSubvencionableService;

	@Autowired
	private DatosTerOmicService datosTerOmicService;

	@Autowired
	private ProcedimientosService procedimientosService;

	@Autowired
	private ExpedientesService expedientesService;

	@Autowired
	private OtrosIngresosService otrosIngresosService;

	@Autowired
	private RelExpInsService relExpInsService;

	@Autowired
	private ab79WebServiceAdaptadorService ab79WebServiceAdaptadorService;

	@Resource
	private ReloadableResourceBundleMessageSource appMessageSource;

	/**
	 * Cargar la vista calculo de ayuda
	 * 
	 * @param model
	 *            Model
	 * @param request
	 *            request
	 * 
	 * @return ModelAndView
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.POST)
	public String init(Model model, @ModelAttribute(value = "initForm") InitForm initForm) {

		String idioma = LocaleContextHolder.getLocale().getLanguage();
		Integer idExpediente = initForm.getIdExpediente();
		Integer idConvocatoria = initForm.getIdConvocatoria();
		String expediente = initForm.getFolderNumber();

		String nombreExpediente = initForm.getFolderNumber();
		String tituloExpediente = initForm.getTituloExpediente();

		Procedimientos procedimiento = this.procedimientosService
				.find(new Procedimientos(initForm.getIdProcedimientoExpediente()));
		if (procedimiento != null) {
			model.addAttribute("procedimientoExpediente", procedimiento.getDescripcionConCodProcedure());
		}

		EstudioTecnico estudioTecnicoAux = new EstudioTecnico();
		EstudioTecnico estudioTecnico = new EstudioTecnico();
		estudioTecnicoAux.setIdExpediente(idExpediente);
		estudioTecnicoAux.setIdConvocatoria(idConvocatoria);
		Convocatorias convocatoria = new Convocatorias();
		convocatoria.setIdConvocatoria(idConvocatoria);
		convocatoria = convocatoriasService.find(convocatoria);
		Long tipoConvocatoria = convocatoria.getIdTipoConvocatoria();
		model.addAttribute("noConcursal", tipoConvocatoria);
		if (convocatoria.getIdTipoAyuda() == Constantes.TIPO_AYUDA_CTP) {
			estudioTecnico = this.estudioTecnicoService.findCTP(estudioTecnicoAux);
		} else {
			estudioTecnico = this.estudioTecnicoService.find(estudioTecnicoAux);
		}
		List<CriteriosPuntuacion> lcriterios = criteriosPuntuacionService.findTextoCriterio(idConvocatoria);
		List<RelExpCriPun> relExpCriPunList = relExpCriPunSercive.findIdsCriterio(idExpediente);

		EstudioTecnicoController.logger.info("[GET - findBy_PK] : Obtener EstudioTecnico por PK");

		model.addAttribute("idConvocatoria", idConvocatoria);
		model.addAttribute("lenguaje", idioma);
		model.addAttribute("idExpediente", idExpediente);
		model.addAttribute("nombreExpediente", nombreExpediente);
		model.addAttribute("tituloExpediente", tituloExpediente);
		model.addAttribute("Expediente", expediente);

		if (null != relExpCriPunList && !relExpCriPunList.isEmpty()) {
			model.addAttribute("listaIdsCriterios", relExpCriPunList);
		}
		model.addAttribute("listaCriterios", lcriterios);

		Properties prop = Config.loadProperties(Constantes.COD_APPL_CONFIG);
		String url = prop.getProperty("urlVerDocumento");
		url = url.replace("[folderID]", initForm.getFolderId());
		model.addAttribute("urlVerDocumentos", url);
		model.addAttribute("origenInspeccion", Constantes.ORIGEN_INSPECCION_ESTUDIO_TECNICO);
		model.addAttribute("inspeccionable", initForm.getInspeccionable());

		if (estudioTecnico == null) {

			estudioTecnico = new EstudioTecnico();
			if (convocatoria.getIdTipoAyuda() == Constantes.TIPO_AYUDA_OMIC) {
				DatosTerOmic datosterOmic = new DatosTerOmic();
				datosterOmic.setIdExpediente(idExpediente);
				datosterOmic = this.datosTerOmicService.findByExpediente(datosterOmic);

				if (datosterOmic == null) {
					estudioTecnico.setDatosTerOmic(new DatosTerOmic());
				} else {
					estudioTecnico.setDatosTerOmic(datosterOmic);
				}
			}
			model.addAttribute("datosExpediente", estudioTecnico);
		} else {

			model.addAttribute("idInspeccion", estudioTecnico.getRelExpIns().getIdInspeccion());
			String fechaInf = UtilDate.convertirFechaEnString(estudioTecnico.getFechaInforme());
			estudioTecnico.setFechaInformeStr(fechaInf);

			if (convocatoria.getIdTipoAyuda() == Constantes.TIPO_AYUDA_OMIC) {
				DatosTerOmic datosterOmic = new DatosTerOmic();
				datosterOmic.setIdExpediente(idExpediente);
				datosterOmic = this.datosTerOmicService.findByExpediente(datosterOmic);

				if (datosterOmic == null) {
					estudioTecnico.setDatosTerOmic(new DatosTerOmic());
				} else {
					estudioTecnico.setDatosTerOmic(datosterOmic);
				}
			}

			model.addAttribute("datosExpediente", estudioTecnico);
		}

		String retorno = "";
		Integer idAgrupacionActSubvencionable = null;
		List<RelExpActSub> exento = null;

		switch (convocatoria.getIdTipoAyuda()) {
		case Constantes.TIPO_AYUDA_MEC:
			retorno = "estudioTecnicoMEC";
			break;
		case Constantes.TIPO_AYUDA_BEC:
			retorno = "estudioTecnicoBEC";
			break;
		case Constantes.TIPO_AYUDA_OTC:
			retorno = "estudioTecnicoOTC";
			break;
		case Constantes.TIPO_AYUDA_DEC:
			idAgrupacionActSubvencionable = this.relExpActSubService.findIdActSubAgrupacionPorExpediente(idExpediente);
			exento = this.relExpActSubService.findExentoPorExpediente(idExpediente);
			model.addAttribute("exentoIva", convocatoria.isExentoIva());
			if (exento.size() == 0) {
				model.addAttribute("exento", 0);
			} else {
				model.addAttribute("exento", exento.get(0).getExento());
			}

			if (Constantes.ID_AGRUPACION_DEC_Asociacion != idAgrupacionActSubvencionable) {
				model.addAttribute("esAyuntamiento", 1);
			} else {
				model.addAttribute("esAyuntamiento", 0);
			}
			retorno = "estudioTecnicoDEC";
			break;
		case Constantes.TIPO_AYUDA_DIV:
			retorno = "estudioTecnicoDIV";
			break;
		case Constantes.TIPO_AYUDA_PTT:
			retorno = "estudioTecnicoPTT";
			break;
		case Constantes.TIPO_AYUDA_EMET:
			retorno = "estudioTecnicoEMET";
			break;
		case Constantes.TIPO_AYUDA_CTP:
			retorno = "estudioTecnicoCTP";
			break;
		case Constantes.TIPO_AYUDA_OMIC:
			retorno = "estudioTecnicoOMIC";
			break;
		case Constantes.TIPO_AYUDA_EMCO:
			idAgrupacionActSubvencionable = this.relExpActSubService.findIdActSubAgrupacionPorExpediente(idExpediente);
			if (Constantes.ID_AGRUPACION_EMCO_Emprendimiento != idAgrupacionActSubvencionable) {
				model.addAttribute("esAyuntamiento", 1);
			} else {
				model.addAttribute("esAyuntamiento", 0);
			}
			retorno = "estudioTecnicoEMCO";
			break;
		case Constantes.TIPO_AYUDA_COVIDT:
			retorno = "estudioTecnicoCOVIDT";
			break;
		case Constantes.TIPO_AYUDA_COVIDM:
			retorno = "estudioTecnicoCOVIDM";
			break;
		default:
			break;
		}

		return retorno;
	}

	/**
	 * Metod para hacer un update de estudio tecnico
	 * 
	 * @param tercero
	 * @return EstudioTecnico Bean resultante del proceso de creacion
	 */
	@RequestMapping(value = "/save/{idExpediente}/{idConvocatoria}", method = RequestMethod.POST)
	public @ResponseBody() EstudioTecnico saveEstudioTecnico(@RequestBody() EstudioTecnico estudioTecnico,
			@ModelAttribute(value = "usuario") Usuario usuario, @PathVariable Integer idExpediente,
			@PathVariable Integer idConvocatoria) throws Exception {

		return this.estudioTecnicoService.saveEstudioTecnico(estudioTecnico, usuario, idExpediente, idConvocatoria);

	}

	/**
	 * Devolvemos una lista de expedientes valiaddaos filtrado por convocatoria
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @return List<Expedientes>
	 */
	@RequestMapping(value = "/repartirDineroExpedientes/{idConvocatoria}/{idActSub}", method = RequestMethod.GET)
	public @ResponseBody() HashMap<String, String> repartirDineroExpedientes(
			@PathVariable("idConvocatoria") Integer idConvocatoria, @PathVariable("idActSub") Integer idActSub) {

		HashMap<String, String> retorno = new HashMap<String, String>();

		EstudioTecnicoController.logger.info("[GET - find_ALL] : obtener la lista de expediente por convocatoria ");
		String msg = estudioTecnicoService.listExpedientesValidados(idConvocatoria, idActSub);
		retorno.put("msg", msg);
		// se recupera el importe disponible para la actuacion subvencionable,
		// para actualizar la pantall
		ActSubvencionable actSub = new ActSubvencionable();
		actSub.setIdActSub(idActSub);
		actSub = this.actSubvencionableService.findImporteDisponible(actSub);

		if (actSub != null) {
			retorno.put("importe", actSub.getImporteDisponibleFormateado());
		}

		return retorno;
	}

	/**
	 * Anulamos el reparto de la ayuda para concursales filtrado por
	 * convocatoria
	 *
	 * @param idConvocatoria
	 *            Integer
	 * @return msg
	 * 
	 *         String
	 * @throws Exception
	 */
	@RequestMapping(value = "/anularReparto/{idConvocatoria}/{idActSub}", method = RequestMethod.GET)
	public @ResponseBody() HashMap<String, String> anularReparto(@PathVariable("idConvocatoria") Integer idConvocatoria,
			@PathVariable("idActSub") Integer idActSub) throws Exception {
		EstudioTecnicoController.logger.info("[GET - find_ALL] : obtener id procemiento de la convocatoria");

		HashMap<String, String> retorno = new HashMap<String, String>();

		estudioTecnicoService.anularReparto(idConvocatoria, idActSub);

		// se recupera el importe disponible para la actuacion subvencionable,
		// para actualizar la pantall
		ActSubvencionable actSub = new ActSubvencionable();
		actSub.setIdActSub(idActSub);
		actSub = this.actSubvencionableService.findImporteDisponible(actSub);

		if (actSub != null) {
			retorno.put("importe", actSub.getImporteDisponibleFormateado());
		}

		return retorno;
	}

	/**
	 * Metodo que llama al pl-sql de calcular ayuda
	 *
	 * 
	 * @param idConvocatoria
	 * 
	 * @param idExpediente
	 * @return Msg
	 */
	@RequestMapping(value = "/llamarPLSQL/{idConvocatoria}/{idExpediente}", method = RequestMethod.GET)
	public @ResponseBody() String calcularAyuda(@PathVariable Integer idConvocatoria,
			@PathVariable Integer idExpediente) {

		EstudioTecnicoController.logger.info("[GET - llamarPLSQL] : Obtener PL DE AYUDA");
		int inFase = 1;
		String msg = calculoAyudaService.calculoAyuda(idConvocatoria, idExpediente, inFase);
		return msg;

	}

	/**
	 * Validamos que esten los datos de datos de estudio rellenados y calculamos
	 * Calculamos la subvencion resuelta
	 * 
	 * 
	 * @param idExpediente
	 *            Integer
	 * @param idConvocatoria
	 *            Integer
	 * 
	 * 
	 */
	@RequestMapping(value = "/validar/{idExpediente}/{idConvocatoria}", method = RequestMethod.GET)
	public @ResponseBody EstudioTecnico pasarValidacion(@PathVariable Integer idExpediente,
			@PathVariable Integer idConvocatoria, @ModelAttribute(value = "usuario") Usuario usuario) {

		return this.estudioTecnicoService.pasarValidacion(idExpediente, idConvocatoria, usuario);
	}

	/**
	 * Validamos que esten los datos de datos de estudio rellenados de ayudas
	 * concursales
	 * 
	 * 
	 * @param idExpediente
	 *            Integer
	 * @param idConvocatoria
	 *            Integer
	 * 
	 * 
	 */
	@RequestMapping(value = "/validarConcursal/{idExpediente}/{idConvocatoria}", method = RequestMethod.GET)
	public @ResponseBody EstudioTecnico pasarValidacionConcursal(@PathVariable Integer idExpediente,
			@PathVariable Integer idConvocatoria, @ModelAttribute(value = "usuario") Usuario usuario) {

		EstudioTecnico estudioTecnico = new EstudioTecnico();
		EstudioTecnico estudioTecnicoAux = new EstudioTecnico();
		estudioTecnico.setIdExpediente(idExpediente);
		estudioTecnico = this.estudioTecnicoService.findDatosProyecto(estudioTecnico);
		EstudioTecnicoController.logger
				.info("[VALIDAR - findBy_PK] : Obtener datos del EstudioTecnico por idExpediente");
		if (null == estudioTecnico.getFechaInforme() || 0 == estudioTecnico.getIdTecnicoResponsable()) {
			EstudioTecnicoController.logger.info("[VALIDAR - findBy_PK] : Datos vacios o tecnico o fecha de informe");
		} else {
			Date fecha = new Date();

			estudioTecnicoAux.setIdExpediente(idExpediente);
			estudioTecnicoAux.setFechaUltmodificacion(fecha);
			estudioTecnicoAux.setUsuarioUltmodificacion(usuario.getNombreUsuario());
			estudioTecnicoAux.setExpedienteValidado(1);
			estudioTecnicoAux.setCargarSolSub(Constantes.NO_CARGAR_SOL_SUB);

			estudioTecnicoAux = this.estudioTecnicoService.updateExpedienteValidado(estudioTecnicoAux);
			EstudioTecnicoController.logger.info(
					"[VALIDAR - update datos de proyecto] : update  en datos de proeyecto tabla por idExpediente, poner expediente validado a 1 ");

		}

		return estudioTecnico;
	}

	/**
	 * Validamos que esten los datos de datos de estudio rellenados de ayudas
	 * concursales
	 * 
	 * 
	 * @param idExpediente
	 *            Integer
	 * @param idConvocatoria
	 *            Integer
	 * 
	 * 
	 */
	@RequestMapping(value = "/desValidarConcursal/{idExpediente}/{idConvocatoria}", method = RequestMethod.GET)
	public @ResponseBody EstudioTecnico desValidacionConcursal(@PathVariable Integer idExpediente,
			@PathVariable Integer idConvocatoria, @ModelAttribute(value = "usuario") Usuario usuario) {
		EstudioTecnico estudioTecnico = new EstudioTecnico();
		Date fecha = new Date();
		estudioTecnico.setIdExpediente(idExpediente);
		estudioTecnico.setFechaUltmodificacion(fecha);
		estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());
		estudioTecnico.setExpedienteValidado(0);
		estudioTecnico.setCargarSolSub(Constantes.NO_CARGAR_SOL_SUB);

		estudioTecnico = this.estudioTecnicoService.updateExpedienteValidado(estudioTecnico);
		EstudioTecnicoController.logger.info(
				"[VALIDAR - update datos de proyecto] : update  en datos de proyecto tabla por idExpediente, poner expediente validado a 0 ");
		return estudioTecnico;
	}

	/**
	 * Retonar el dinero a la canvocatoria al habilitar la ayuda
	 * 
	 * @param idExpediente
	 *            Integer
	 * @param idConvocatoria
	 *            Integer
	 * 
	 * 
	 */
	@RequestMapping(value = "/retornarDinero/{idExpediente}/{idConvocatoria}", method = RequestMethod.GET)
	public @ResponseBody EstudioTecnico habilitarCalculoAyuda(@PathVariable Integer idExpediente,
			@PathVariable Integer idConvocatoria, @ModelAttribute(value = "usuario") Usuario usuario) {

		Date fecha = new Date();
		EstudioTecnico estudioTecnico = new EstudioTecnico();
		EstudioTecnico estudioTecnicoAux = new EstudioTecnico();
		Convocatorias convocatorias = new Convocatorias();

		estudioTecnico.setIdExpediente(idExpediente);
		estudioTecnico.setFechaUltmodificacion(fecha);
		estudioTecnico.setUsuarioUltmodificacion(usuario.getNombreUsuario());

		convocatorias.setIdConvocatoria(idConvocatoria);
		convocatorias.setFechaUltmodificacion(fecha);
		convocatorias.setUsuarioUltmodificacion(usuario.getNombreUsuario());
		estudioTecnicoAux = this.estudioTecnicoService.retonarSubvencionResuelta(idExpediente, idConvocatoria);
		EstudioTecnicoController.logger.info(
				"[Sumar Dineros de subvencion - findBy_PK] : Obtener la suma a inserta en importe disponible en convocatorias");
		if (null != estudioTecnicoAux.getImporteFinal()) {

			// updateamos convocatora el importe disponible
			convocatorias.setImporteDisponible(estudioTecnicoAux.getImporteFinal());
			convocatoriasService.updateImporteDisponible(convocatorias);
		}
		estudioTecnico.setExpedienteValidado(0);
		estudioTecnico.setSubvencionResuelta(null);
		estudioTecnico.setImporteDisponible(estudioTecnicoAux.getImporteFinal());

		// si el tipo de importe = 1 falta por retornar la subvencion resuelta a
		// la accion sunvencionable del importe

		estudioTecnicoAux = this.estudioTecnicoService.retornarSubvencionResueltaPorAccionSubencionable(idExpediente);
		if (null != estudioTecnicoAux && null != estudioTecnicoAux.getImporteFinal()
				&& null != estudioTecnicoAux.getActSubvencionable()) {
			ActSubvencionable actSubvencionable = new ActSubvencionable();
			actSubvencionable.setImporteDisponible(estudioTecnicoAux.getImporteFinal());
			actSubvencionable.setIdActSub(estudioTecnicoAux.getActSubvencionable().getIdActSub());
			actSubvencionableService.updateImporteDisponible(actSubvencionable);
		}
		estudioTecnico = estudioTecnicoService.updateHabilitar(estudioTecnico);
		estudioTecnico.setImporteDisponible(estudioTecnicoAux.getImporteFinal());
		return estudioTecnico;
	}

	/**
	 * Sacamos los importe de admitido y presentado al cargar la pagina de
	 * estudio tecnico
	 * 
	 * @param idExpediente
	 *            Integer
	 * @return estudioTecnico Obj estudioTecnico
	 */
	@RequestMapping(value = "/{idExpediente}", method = RequestMethod.GET)
	public @ResponseBody EstudioTecnico get(@PathVariable Integer idExpediente) {

		EstudioTecnico estudioTecnico = new EstudioTecnico();
		estudioTecnico.setIdProyectoExpediente(idExpediente);

		estudioTecnico = this.estudioTecnicoService.findTotales(idExpediente);
		EstudioTecnicoController.logger.info("[GET - findBy_PK] : Obtener Totales de EstudioTecnico por PK");
		return estudioTecnico;
	}

	/**
	 * Actualiza los importe de expediente una vez que le damos al boton de
	 * calcular ayuda
	 *
	 * 
	 * @param idExpediente
	 *            Integer
	 * @return estudioTecnico Obj estudioTecnico
	 */
	@RequestMapping(value = "/refrescar/{idExpediente}", method = RequestMethod.GET)
	public @ResponseBody EstudioTecnico refrescarImportes(@PathVariable Integer idExpediente) {

		EstudioTecnico estudioTecnico = new EstudioTecnico();
		estudioTecnico.setIdProyectoExpediente(idExpediente);

		estudioTecnico = this.estudioTecnicoService.refescarImportes(idExpediente);
		EstudioTecnicoController.logger
				.info("[GET - findBy_PK] : Obtener todo los Totales de todo de EstudioTecnico por PK");
		return estudioTecnico;
	}

	@RequestMapping(value = "updateAyudaConcedida/{idRelExpActSub}", method = RequestMethod.POST)
	public @ResponseBody OtrosIngresos updateAyudaConcedida(@PathVariable Integer idRelExpActSub,
			@RequestBody BigDecimal ayudaConcedida) {
		OtrosIngresos otrosIngresos = new OtrosIngresos();
		otrosIngresos.setIdRelExpActSub(idRelExpActSub);
		otrosIngresos.setImporte(ayudaConcedida);
		otrosIngresos.setFase(Constantes.FASE_SOLICITUD);
		return this.otrosIngresosService.updateImporte(otrosIngresos);
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterEstudioTecnico
	 *            EstudioTecnico Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<EstudioTecnico> Lista de objetos correspondientes a la
	 *         busqueda realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<EstudioTecnico> getAll(@ModelAttribute EstudioTecnico filterEstudioTecnico) {
		EstudioTecnicoController.logger.info("[GET - find_ALL] : Obtener EstudioTecnico por filtro");
		return this.estudioTecnicoService.findAll(filterEstudioTecnico, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param estudioTecnico
	 *            EstudioTecnico Bean que contiene la informacion a modificar.
	 * @return EstudioTecnico Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody EstudioTecnico edit(@RequestBody EstudioTecnico estudioTecnico) {
		EstudioTecnico estudioTecnicoAux = this.estudioTecnicoService.update(estudioTecnico);
		EstudioTecnicoController.logger.info("[PUT] : EstudioTecnico actualizado correctamente");
		return estudioTecnicoAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param estudioTecnico
	 *            EstudioTecnico Bean que contiene la informacion con la que se
	 *            va a crear el nuevo registro.
	 * @return EstudioTecnico Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody EstudioTecnico add(@RequestBody EstudioTecnico estudioTecnico) {
		EstudioTecnico estudioTecnicoAux = this.estudioTecnicoService.add(estudioTecnico);
		EstudioTecnicoController.logger.info("[POST] : EstudioTecnico insertado correctamente");
		return estudioTecnicoAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idProyectoExpediente
	 *            Integer Identificador del objeto que se desea eliminar.
	 * @return EstudioTecnico Bean eliminado.
	 */
	@RequestMapping(value = "/{idProyectoExpediente}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody EstudioTecnico remove(@PathVariable Integer idProyectoExpediente) {
		EstudioTecnico estudioTecnico = new EstudioTecnico();
		estudioTecnico.setIdProyectoExpediente(idProyectoExpediente);
		this.estudioTecnicoService.remove(estudioTecnico);
		EstudioTecnicoController.logger.info("[DELETE] : EstudioTecnico borrado correctamente");
		return estudioTecnico;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterEstudioTecnico
	 *            EstudioTecnico Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<EstudioTecnico> Dto que contiene el resultado
	 *         del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<EstudioTecnico> filter(
			@RequestJsonBody(param = "filter") EstudioTecnico filterEstudioTecnico,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		EstudioTecnicoController.logger.info("[POST - filter] : Obtener EstudioTecnicos");
		return this.estudioTecnicoService.filter(filterEstudioTecnico, jqGridRequestDto, false);
	}

	/**
	 * Operacion de busqueda del componente RUP_TABLE.
	 * 
	 * @param filterEstudioTecnico
	 *            EstudioTecnico Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param searchEstudioTecnico
	 *            EstudioTecnico Bean que contiene los parametros de busqueda a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la búsqueda.
	 * @return TableRowDto<EstudioTecnico> Dto que contiene el resultado de la
	 *         busqueda realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<EstudioTecnico>> search(
			@RequestJsonBody(param = "filter") EstudioTecnico filterEstudioTecnico,
			@RequestJsonBody(param = "search") EstudioTecnico searchEstudioTecnico,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		EstudioTecnicoController.logger.info("[POST - search] : Buscar EstudioTecnicos");
		return this.estudioTecnicoService.search(filterEstudioTecnico, searchEstudioTecnico, jqGridRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterEstudioTecnico
	 *            EstudioTecnico Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(
			@RequestJsonBody(param = "filter") EstudioTecnico filterEstudioTecnico,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		EstudioTecnicoController.logger
				.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples EstudioTecnicos");
		this.estudioTecnicoService.removeMultiple(filterEstudioTecnico, jqGridRequestDto, false);
		EstudioTecnicoController.logger.info("All entities correctly deleted!");

		return jqGridRequestDto.getMultiselection().getSelectedIds();
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE - JERARQUIA
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE para presentar los
	 * registros mediante visualizacion jerarquica.
	 * 
	 * @param filterEstudioTecnico
	 *            EstudioTecnico Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<JerarquiaDto<EstudioTecnico>> Dto que contiene
	 *         el resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquia/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<JerarquiaDto<EstudioTecnico>> jerarquia(
			@RequestJsonBody(param = "filter") EstudioTecnico filterEstudioTecnico,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		EstudioTecnicoController.logger.info("[POST - jerarquia] : Obtener EstudioTecnicos jerarquia");
		return this.estudioTecnicoService.jerarquia(filterEstudioTecnico, jqGridRequestDto, false);
	}

	/**
	 * Recupera los hijos de los registros desplegados en la visualizacion
	 * jerarquica.
	 * 
	 * @param filterEstudioTecnico
	 *            EstudioTecnico Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<JerarquiaDto<EstudioTecnico>> Dto que contiene
	 *         el resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquiaChildren", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<JerarquiaDto<EstudioTecnico>> jerarquiaChildren(
			@RequestJsonBody(param = "filter") EstudioTecnico filterEstudioTecnico,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		EstudioTecnicoController.logger.info("[POST - jerarquia] : Obtener EstudioTecnicos jerarquia - Hijos");
		return this.estudioTecnicoService.jerarquiaChildren(filterEstudioTecnico, jqGridRequestDto);
	}

	@RequestMapping(value = { "/xlsReport/{idConvocatoria}/{idExpedientes}",
			"/xlsxReport/{idConvocatoria}/{idExpedientes}" }, method = RequestMethod.POST)
	protected ModelAndView getExcelPOI(@ModelAttribute RelExpActSub filterActSub,
			@ModelAttribute JQGridRequestDto jqGridRequestDto, ModelMap modelMap, @PathVariable Integer idConvocatoria,
			@PathVariable Integer idExpedientes, @RequestParam(value = "columns", required = false) String columns,
			HttpServletRequest request) {

		Locale locale = LocaleContextHolder.getLocale();

		filterActSub.setIdExpediente(idExpedientes);
		filterActSub.setIdconvocatoria(idConvocatoria);

		Expedientes expediente = new Expedientes();
		expediente.setIdExpediente(idExpedientes);
		expediente = this.expedientesService.find(expediente);

		Convocatorias convocatoria = new Convocatorias();
		convocatoria.setIdConvocatoria(idConvocatoria);

		convocatoria = convocatoriasService.find(convocatoria);

		List<RelExpActSub> listProgramasAll = null;
		List<MarcarInspeccionableAct> listProgramasAllConConceptos = null;
		List<MarcarInspeccionable> listProgramasAllConFacturas = null;

		jqGridRequestDto.setPage(null);
		jqGridRequestDto.setRows(null);

		// Hoja 1
		ReportData<Expedientes> usuarioExcelDataAll = new ReportData<Expedientes>();

		switch (convocatoria.getIdTipoAyuda()) {
		case Constantes.TIPO_AYUDA_OMIC:

			if (locale.getLanguage() == "es") {
				columns = "[['actSubvencionable.descripcionCastellano','"
						+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
						+ ",['importePresentadoMask','" + appMessageSource.getMessage("excel.presentado", null, locale)
						+ "']" + ",['importeAdmitidoMask','"
						+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
						+ ",['subvencionCalculadaMask','"
						+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']" + ",['porcentaje','"
						+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + ",['puntos','"
						+ appMessageSource.getMessage("excel.puntos", null, locale) + "']" + "]";
			} else {
				columns = "[['actSubvencionable.descripcionEuskera','"
						+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
						+ ",['importePresentadoMask','" + appMessageSource.getMessage("excel.presentado", null, locale)
						+ "']" + ",['importeAdmitidoMask','"
						+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
						+ ",['subvencionCalculadaMask','"
						+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
						+ ",['porcentajeMask','" + appMessageSource.getMessage("excel.porcentaje", null, locale) + "']"
						+ ",['puntos','" + appMessageSource.getMessage("excel.puntos", null, locale) + "']" + "]";
			}
			listProgramasAll = relExpActSubService.filterOMICTer(filterActSub, jqGridRequestDto, false);
			// nombre hoja
			usuarioExcelDataAll
					.setSheetName(appMessageSource.getMessage("usuarioExcel.estudioTecnicoOMIC", null, locale));

			// cabeceras hoja
			usuarioExcelDataAll.setHeaderNames(ReportData.parseColumns(columns));
			// datos hoja
			usuarioExcelDataAll.setModelData(listProgramasAll);

			break;
		case Constantes.TIPO_AYUDA_CTP:
			if (idConvocatoria == Constantes.CTP_2018) {
				if (locale.getLanguage() == "es") {
					columns = "[['actSubs.descripcionCastellano','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				} else {
					columns = "[['actSubs.descripcionEuskera','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				}
			} else {
				if (locale.getLanguage() == "es") {
					columns = "[['actSubs.descripcionCastellano','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.ayudaConcedidaMask','"
							+ appMessageSource.getMessage("excel.ayudaConcedida", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				} else {
					columns = "[['actSubs.descripcionEuskera','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.ayudaConcedidaMask','"
							+ appMessageSource.getMessage("excel.ayudaConcedida", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				}
			}

			listProgramasAllConConceptos = relExpActSubService.filterConConceptosTer(filterActSub, jqGridRequestDto,
					false);
			// nombre hoja
			usuarioExcelDataAll
					.setSheetName(appMessageSource.getMessage("usuarioExcel.estudioTecnicoCTP", null, locale));

			// cabeceras hoja
			usuarioExcelDataAll.setHeaderNames(ReportData.parseColumns(columns));
			// datos hoja
			usuarioExcelDataAll.setModelData(listProgramasAllConConceptos);

			break;
		case Constantes.TIPO_AYUDA_DEC:

			Integer idActSubPadre = this.procedimientosService.findIdActSubPadre(idExpedientes);

			if (idActSubPadre != Constantes.DEC_ASOCIACION) {

				columns = "[['actSubvencionableConcatenadaDEC','"
						+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
						+ ",['importePresentadoMask','" + appMessageSource.getMessage("excel.presentado", null, locale)
						+ "']" + ",['importeAdmitidoMask','"
						+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
						+ ",['subvencionCalculadaMask','"
						+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
						+ ",['porcentajeMask','" + appMessageSource.getMessage("excel.porcentaje", null, locale) + "']"
						+ "]";

				listProgramasAll = relExpActSubService.filterDECTer(filterActSub, jqGridRequestDto, false);
				// datos hoja
				usuarioExcelDataAll.setModelData(listProgramasAll);

			} else {
				if (locale.getLanguage() == "es") {
					columns = "[['actSubs.descripcionCastellano','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				} else {
					columns = "[['actSubs.descripcionEuskera','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				}

				listProgramasAllConConceptos = relExpActSubService.filterConConceptosTer(filterActSub, jqGridRequestDto,
						false);
				// datos hoja
				usuarioExcelDataAll.setModelData(listProgramasAllConConceptos);
			}

			// nombre hoja
			usuarioExcelDataAll
					.setSheetName(appMessageSource.getMessage("usuarioExcel.estudioTecnicoDEC", null, locale));

			// cabeceras hoja
			usuarioExcelDataAll.setHeaderNames(ReportData.parseColumns(columns));

			break;
		case Constantes.TIPO_AYUDA_EMET:
			if (idConvocatoria == Constantes.EMET_2018) {
				if (locale.getLanguage() == "es") {
					columns = "[['actSubs.descripcionCastellano','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				} else {
					columns = "[['actSubs.descripcionEuskera','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				}
			} else {
				if (locale.getLanguage() == "es") {
					columns = "[['actSubs.descripcionCastellano','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.ayudaConcedidaMask','"
							+ appMessageSource.getMessage("excel.ayudaConcedida", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				} else {
					columns = "[['actSubs.descripcionEuskera','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.ayudaConcedidaMask','"
							+ appMessageSource.getMessage("excel.ayudaConcedida", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				}
			}

			listProgramasAllConConceptos = relExpActSubService.filterConConceptosTer(filterActSub, jqGridRequestDto,
					false);
			// nombre hoja
			usuarioExcelDataAll
					.setSheetName(appMessageSource.getMessage("usuarioExcel.estudioTecnicoEMET", null, locale));

			// cabeceras hoja
			usuarioExcelDataAll.setHeaderNames(ReportData.parseColumns(columns));
			// datos hoja
			usuarioExcelDataAll.setModelData(listProgramasAllConConceptos);

			break;
		case Constantes.TIPO_AYUDA_PTT:
			if (idConvocatoria == Constantes.PTT_2018) {
				if (locale.getLanguage() == "es") {
					columns = "[['actSubs.descripcionCastellano','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				} else {
					columns = "[['actSubs.descripcionEuskera','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				}
			} else {
				if (locale.getLanguage() == "es") {
					columns = "[['actSubs.descripcionCastellano','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.ayudaConcedidaMask','"
							+ appMessageSource.getMessage("excel.ayudaConcedida", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				} else {
					columns = "[['actSubs.descripcionEuskera','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['conceptos.importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['conceptos.importeAdmitidoMask','"
							+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
							+ ",['relExpActSub.ayudaConcedidaMask','"
							+ appMessageSource.getMessage("excel.ayudaConcedida", null, locale) + "']"
							+ ",['relExpActSub.subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['relExpActSub.porcentajeMask','"
							+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";
				}
			}

			listProgramasAllConConceptos = relExpActSubService.filterConConceptosPTTTer(filterActSub, jqGridRequestDto,
					false);
			// nombre hoja
			usuarioExcelDataAll
					.setSheetName(appMessageSource.getMessage("usuarioExcel.estudioTecnicoPTT", null, locale));

			// cabeceras hoja
			usuarioExcelDataAll.setHeaderNames(ReportData.parseColumns(columns));
			// datos hoja
			usuarioExcelDataAll.setModelData(listProgramasAllConConceptos);

			break;
		case Constantes.TIPO_AYUDA_OTC:
			if (locale.getLanguage() == "es") {
				columns = "[['actSubvencionable.descripcionCastellano','"
						+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
						+ ",['importePresentadoMask','" + appMessageSource.getMessage("excel.presentado", null, locale)
						+ "']" + ",['importeAdmitidoMask','"
						+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
						+ ",['subvencionCalculadaMask','"
						+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
						+ ",['porcentajeMask','" + appMessageSource.getMessage("excel.porcentaje", null, locale) + "']"
						+ "]";
			} else {
				columns = "[['actSubvencionable.descripcionEuskera','"
						+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
						+ ",['importePresentadoMask','" + appMessageSource.getMessage("excel.presentado", null, locale)
						+ "']" + ",['importeAdmitidoMask','"
						+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
						+ ",['subvencionCalculadaMask','"
						+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
						+ ",['porcentajeMask','" + appMessageSource.getMessage("excel.porcentaje", null, locale) + "']"
						+ "]";
			}
			listProgramasAll = relExpActSubService.filterOTCTer(filterActSub, jqGridRequestDto, false);
			// nombre hoja
			usuarioExcelDataAll
					.setSheetName(appMessageSource.getMessage("usuarioExcel.estudioTecnicoOTC", null, locale));

			// cabeceras hoja
			usuarioExcelDataAll.setHeaderNames(ReportData.parseColumns(columns));
			// datos hoja
			usuarioExcelDataAll.setModelData(listProgramasAll);

			break;
		case Constantes.TIPO_AYUDA_MEC:
			if (locale.getLanguage() == "es") {
				columns = "[['actSubvencionable.descripcionCastellano','"
						+ appMessageSource.getMessage("excel.actSub", null, locale) + "']" + ",['factura.descripcion','"
						+ appMessageSource.getMessage("excel.concepto", null, locale) + "']"
						+ ",['importePresentadoMask','" + appMessageSource.getMessage("excel.presentado", null, locale)
						+ "']" + ",['importeAdmitidoMask','"
						+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
						+ ",['subvencionCalculadaMask','"
						+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
						+ ",['porcentajeMask','" + appMessageSource.getMessage("excel.porcentaje", null, locale) + "']"
						+ "]";
			} else {
				columns = "[['actSubvencionable.descripcionEuskera','"
						+ appMessageSource.getMessage("excel.actSub", null, locale) + "']" + ",['factura.descripcion','"
						+ appMessageSource.getMessage("excel.concepto", null, locale) + "']"
						+ ",['importePresentadoMask','" + appMessageSource.getMessage("excel.presentado", null, locale)
						+ "']" + ",['importeAdmitidoMask','"
						+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
						+ ",['subvencionCalculadaMask','"
						+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
						+ ",['porcentajeMask','" + appMessageSource.getMessage("excel.porcentaje", null, locale) + "']"
						+ "]";
			}
			listProgramasAll = relExpActSubService.filterMECTer(filterActSub, jqGridRequestDto, false);
			// nombre hoja
			usuarioExcelDataAll
					.setSheetName(appMessageSource.getMessage("usuarioExcel.estudioTecnicoMEC", null, locale));

			// cabeceras hoja
			usuarioExcelDataAll.setHeaderNames(ReportData.parseColumns(columns));
			// datos hoja
			usuarioExcelDataAll.setModelData(listProgramasAll);

			break;
		case Constantes.TIPO_AYUDA_EMCO:

			Integer idActSubPadreAux = this.procedimientosService.findIdActSubPadre(idExpedientes);

			if (Constantes.ID_AGRUPACION_EMCO_AYUNTAMIENTO.equals(idActSubPadreAux)) {
				if (locale.getLanguage() == "es") {
					columns = "[['actSubvencionable.descripcionCastellano','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['importeAdmitidoMask','" + appMessageSource.getMessage("excel.admitido", null, locale)
							+ "']" + ",['subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['porcentajeMask','" + appMessageSource.getMessage("excel.porcentaje", null, locale)
							+ "']" + "]";
				} else {
					columns = "[['actSubvencionable.descripcionEuskera','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['conceptos.concepto','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['importeAdmitidoMask','" + appMessageSource.getMessage("excel.admitido", null, locale)
							+ "']" + ",['subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['porcentajeMask','" + appMessageSource.getMessage("excel.porcentaje", null, locale)
							+ "']" + "]";
				}

				listProgramasAll = relExpActSubService.filterEMCOTer(filterActSub, jqGridRequestDto, false,
						idExpedientes);
				// datos hoja
				usuarioExcelDataAll.setModelData(listProgramasAll);

			} else {
				if (locale.getLanguage() == "es") {
					columns = "[['actSubvencionable.descripcionCastellano','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['factura.descripcion','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['importeAdmitidoMask','" + appMessageSource.getMessage("excel.admitido", null, locale)
							+ "']" + ",['subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['porcentajeMask','" + appMessageSource.getMessage("excel.porcentaje", null, locale)
							+ "']" + "]";
				} else {
					columns = "[['actSubvencionable.descripcionEuskera','"
							+ appMessageSource.getMessage("excel.actSub", null, locale) + "']"
							+ ",['factura.descripcion','" + appMessageSource.getMessage("excel.concepto", null, locale)
							+ "']" + ",['importePresentadoMask','"
							+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
							+ ",['importeAdmitidoMask','" + appMessageSource.getMessage("excel.admitido", null, locale)
							+ "']" + ",['subvencionCalculadaMask','"
							+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
							+ ",['porcentajeMask','" + appMessageSource.getMessage("excel.porcentaje", null, locale)
							+ "']" + "]";
				}

				listProgramasAll = relExpActSubService.filterEMCOEmpreTer(filterActSub, jqGridRequestDto, false,
						idExpedientes);
				// datos hoja
				usuarioExcelDataAll.setModelData(listProgramasAll);
			}

			// nombre hoja
			usuarioExcelDataAll
					.setSheetName(appMessageSource.getMessage("usuarioExcel.estudioTecnicoEMCO", null, locale));

			// cabeceras hoja
			usuarioExcelDataAll.setHeaderNames(ReportData.parseColumns(columns));

			break;
		case Constantes.TIPO_AYUDA_COVIDT:
		case Constantes.TIPO_AYUDA_COVIDM:

			columns = "[['actSubs.descripcionEntidadBancaria','"
					+ appMessageSource.getMessage("excel.actSub", null, locale) + "']" + ",['conceptos.concepto','"
					+ appMessageSource.getMessage("excel.concepto", null, locale) + "']"
					+ ",['conceptos.importePresentadoMask','"
					+ appMessageSource.getMessage("excel.presentado", null, locale) + "']"
					+ ",['conceptos.importeAdmitidoMask','"
					+ appMessageSource.getMessage("excel.admitido", null, locale) + "']"
					+ ",['relExpActSub.ayudaConcedidaMask','"
					+ appMessageSource.getMessage("excel.ayudaConcedida", null, locale) + "']"
					+ ",['relExpActSub.subvencionCalculadaMask','"
					+ appMessageSource.getMessage("excel.suvCalculada", null, locale) + "']"
					+ ",['relExpActSub.porcentajeMask','"
					+ appMessageSource.getMessage("excel.porcentaje", null, locale) + "']" + "]";

			listProgramasAllConConceptos = relExpActSubService.filterConConceptosTer(filterActSub, jqGridRequestDto,
					false);

			String nombreHojaCOVID = (Constantes.TIPO_AYUDA_COVIDT == convocatoria.getIdTipoAyuda())
					? "usuarioExcel.estudioTecnicoCOVIDT" : "usuarioExcel.estudioTecnicoCOVIDM";

			// nombre hoja
			usuarioExcelDataAll.setSheetName(appMessageSource.getMessage(nombreHojaCOVID, null, locale));

			// cabeceras hoja
			usuarioExcelDataAll.setHeaderNames(ReportData.parseColumns(columns));
			// datos hoja
			usuarioExcelDataAll.setModelData(listProgramasAllConConceptos);
			break;
		default:
			break;
		}

		// Datos
		String nombreFichero = null;
		if (locale.getLanguage() == "es") {
			nombreFichero = "Estudio_tecnico_" + expediente.getFolderNumber();
		} else {
			nombreFichero = "Azterketa_teknikoa_" + expediente.getFolderNumber();
		}

		// Nombre fichero
		modelMap.put("fileName", nombreFichero);

		List<Object> reportData = new ArrayList<Object>();
		reportData.add(usuarioExcelDataAll);
		modelMap.put("reportData", reportData);

		// Generación del XLS o XLSX
		if (request.getServletPath().indexOf("xlsReport") != -1) {
			return new ModelAndView("xlsReport", modelMap);
		} else {
			return new ModelAndView("xlsxReport", modelMap);
		}

	}

	@RequestMapping(value = "/eliminarInspeccion/{idInspeccion}", method = RequestMethod.POST)
	public @ResponseBody String eliminarInspeccion(@PathVariable Integer idInspeccion,
			@ModelAttribute("usuario") Usuario usuario) throws Ab79Exception {
		String respuesta = "";
		try {
			RelExpIns relExpIns = new RelExpIns();
			relExpIns.setIdInspeccion(idInspeccion);

			RelExpIns relExpInsAux = this.relExpInsService.findByIdInspeccion(relExpIns);

			respuesta = this.ab79WebServiceAdaptadorService
					.eliminarInspeccion(relExpInsAux.getIdentificadorInspeccion(), usuario.getNombreUsuario());
		} catch (Ab79Exception e) {

			Locale locale = LocaleContextHolder.getLocale();
			EstudioTecnicoController.logger.error("eliminarInspeccion - ERROR", e);

			if (locale.toString().equals(Constantes.CASTELLANO)) {
				return e.getFaultInfo().getMensajeCastellano();
			} else if (locale.toString().equals(Constantes.EUSKERA)) {
				return e.getFaultInfo().getMensajeEuskera();
			}

		}
		return respuesta;
	}
}
