package com.ejie.ab60.control.moduloContable;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.bind.annotation.SessionAttributes;
import org.springframework.web.servlet.ModelAndView;

import com.ejie.ab60.comun.CargarPropiedades;
import com.ejie.ab60.comun.Constantes;
import com.ejie.ab60.model.convocatorias.AplicacionesPresupuestarias;
import com.ejie.ab60.model.convocatorias.Convocatorias;
import com.ejie.ab60.model.moduloContable.DocContables;
import com.ejie.ab60.model.moduloContable.DocumentosContables;
import com.ejie.ab60.model.moduloContable.FicherosContables;
import com.ejie.ab60.model.moduloContable.ModuloContable;
import com.ejie.ab60.model.pagos.PagosConvocatoria;
import com.ejie.ab60.model.terceros.TiposDocumento;
import com.ejie.ab60.model.usuario.Usuario;
import com.ejie.ab60.service.convocatorias.AplicacionesPresupuestariasService;
import com.ejie.ab60.service.convocatorias.ConvocatoriasService;
import com.ejie.ab60.service.moduloContable.DocumentosContablesService;
import com.ejie.ab60.service.moduloContable.FicherosContablesService;
import com.ejie.ab60.service.pagos.PagosConvocatoriaService;
import com.ejie.ab60.tramita.adapter.PifAdapterService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;

/**
 * FicherosContablesController  
 * 
 *  
 */

@Controller
@SessionAttributes("usuario")
@RequestMapping(value = "/ficheroscontables")

public class FicherosContablesController {

	private static final Logger logger = LoggerFactory.getLogger(FicherosContablesController.class);
	public static final String TEMP_PATH = CargarPropiedades.getConfigAplicacion("TEMP.DIR");

	@Autowired
	private PifAdapterService pifAdapterService;

	@Autowired
	private FicherosContablesService ficherosContablesService;

	@Autowired
	private DocumentosContablesService documentosContablesService;

	@Autowired
	private ConvocatoriasService convocatoriasService;

	@Autowired
	private PagosConvocatoriaService pagosConvocatoriaService;

	@Autowired
	private AplicacionesPresupuestariasService aplicacionesPresupuestariasService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idConvocatoria
	 *            Integer
	 * @param idFicheroContable
	 *            Integer
	 * @return FicherosContables Objeto correspondiente al identificador
	 *         indicado.
	 */
	/*
	 * @RequestMapping(value = "/{idConvocatoria}/{idFicheroContable}", method =
	 * RequestMethod.GET) public @ResponseBody FicherosContables
	 * get(@PathVariable Integer idConvocatoria,
	 * 
	 * @PathVariable Integer idFicheroContable) { FicherosContables
	 * ficherosContables = new FicherosContables();
	 * ficherosContables.setIdFicheroContable(idFicheroContable);
	 * ficherosContables.setIdConvocatoria(idConvocatoria); if
	 * (idFicheroContable == 0) { ficherosContables =
	 * this.ficherosContablesService.findNew(ficherosContables); } else {
	 * ficherosContables =
	 * this.ficherosContablesService.find(ficherosContables); }
	 * FicherosContablesController.logger.
	 * info("[GET - findBy_PK] : Obtener FicherosContables por PK"); return
	 * ficherosContables; }
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idConvocatoria
	 *            Integer
	 * @param idFicheroContable
	 *            Integer
	 * @return FicherosContables Objeto correspondiente al identificador
	 *         indicado.
	 */
	/*
	 * @RequestMapping(value = "/{idConvocatoria}/{idFicheroContable}", method =
	 * RequestMethod.POST) public @ResponseBody FicherosContables
	 * getPost(@PathVariable Integer idConvocatoria,
	 * 
	 * @PathVariable Integer idFicheroContable) { FicherosContables
	 * ficherosContables = new FicherosContables();
	 * ficherosContables.setIdFicheroContable(idFicheroContable);
	 * ficherosContables.setIdConvocatoria(idConvocatoria); if
	 * (idFicheroContable == 0) { ficherosContables =
	 * this.ficherosContablesService.findNew(ficherosContables); } else {
	 * ficherosContables =
	 * this.ficherosContablesService.find(ficherosContables); }
	 * FicherosContablesController.logger.
	 * info("[GET - findBy_PK] : Obtener FicherosContables por PK"); return
	 * ficherosContables; }
	 */

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterFicherosContables
	 *            FicherosContables Objeto que contiene los parametros de
	 *            filtrado utilizados en la busqueda.
	 * @return List<FicherosContables> Lista de objetos correspondientes a la
	 *         busqueda realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<FicherosContables> getAll(@ModelAttribute FicherosContables filterFicherosContables) {
		FicherosContablesController.logger.info("[GET - find_ALL] : Obtener FicherosContables por filtro");
		return this.ficherosContablesService.findAll(filterFicherosContables, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param ficherosContables
	 *            FicherosContables Bean que contiene la informacion a
	 *            modificar.
	 * @return FicherosContables Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody FicherosContables edit(@RequestBody FicherosContables ficherosContables
	// ,@ModelAttribute(value = "usuario") Usuario usuario
	) {

		Authentication aut = SecurityContextHolder.getContext().getAuthentication();
		Usuario usuario = new Usuario();
		/** Dejamos el usuario logueado en session */
		String username = "";
		if (null != aut) {
			username = (String) aut.getPrincipal();
		}

		usuario.setNombreUsuario(username);

		FicherosContables ficherosContablesAux = this.ficherosContablesService.update(ficherosContables, usuario);
		FicherosContablesController.logger.info("[PUT] : FicherosContables actualizado correctamente");
		return ficherosContablesAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param ficherosContables
	 *            FicherosContables Bean que contiene la informacion con la que
	 *            se va a crear el nuevo registro.
	 * @return FicherosContables Bean resultante del proceso de creacion.
	 */
	@RequestMapping(value = "/save/{idTipoDocCon}", method = RequestMethod.POST)
	public @ResponseBody ModuloContable save(@RequestBody ModuloContable moduloContable,
			@PathVariable("idTipoDocCon") Integer idTipoDocCon
	// ,
	// @ModelAttribute(value = "usuario") Usuario usuario
	) {

		Authentication aut = SecurityContextHolder.getContext().getAuthentication();
		Usuario usuario = new Usuario();
		/** Dejamos el usuario logueado en session */
		String username = "";
		if (null != aut) {
			username = (String) aut.getPrincipal();
		}

		usuario.setNombreUsuario(username);
		Date fecha = new Date();

		// Hay que grabar los datos del fichero contable
		// Y despues los expedientes seleccionados que se van a grabar para
		// generar el documento contable
		moduloContable.getFicherosContables().setEstado(Constantes.ESTADO_FICHERO_LOT_NO_GENERADO);

		Convocatorias convo = new Convocatorias(moduloContable.getFicherosContables().getIdConvocatoria());
		convo = convocatoriasService.find(convo);

		moduloContable.getFicherosContables().setOrigenMaqueta(convo.getOrigenMaqueta());
		moduloContable.getFicherosContables().setTipoRegistro(String.valueOf(Constantes.TIPO_REGISTRO_CABECERA_LOT));
		FicherosContables ficherosContablesAux = this.ficherosContablesService
				.add(moduloContable.getFicherosContables(), usuario);

		for (DocContables docContable : moduloContable.getListaDocContables()) {
			DocumentosContables documentosContables = new DocumentosContables();

			documentosContables.setIdConvocatoria(moduloContable.getFicherosContables().getIdConvocatoria());
			documentosContables.setIdFicheroContable(ficherosContablesAux.getIdFicheroContable());
			documentosContables.setTipoRegistro("1");
			documentosContables.setTipoDocumento(new TiposDocumento(new Long(idTipoDocCon)));
			documentosContables.setIdExpediente(docContable.getIdExpediente());
			documentosContables.setNumeroExpediente(docContable.getExpediente());
			documentosContables.setEjercicioAplPre(docContable.getEjercicioAplPre());
			documentosContables.setAgrupacion(docContable.getAgrupacion());
			documentosContables.setGastoIngreso(docContable.getGastoIngreso());
			documentosContables.setSeccion(docContable.getSeccion());
			documentosContables.setServicio(docContable.getServicio());
			documentosContables.setCentro(docContable.getCentro());
			documentosContables.setTerritorio(docContable.getTerritorio());
			documentosContables.setCac(docContable.getCac());
			documentosContables.setSc(docContable.getSc());
			documentosContables.setPrograma(docContable.getPrograma());
			documentosContables.setPartida(docContable.getPartida());
			documentosContables.setLetraControl(docContable.getLetraControl());
			documentosContables.setEjercicioRefInt(docContable.getEjercicioRefInt());
			documentosContables.setAnyoOrigen(docContable.getAnyoOrigen());
			documentosContables.setNumero(docContable.getNumero());
			documentosContables.setDisponible(docContable.getDisponible());
			documentosContables.setObligacion(docContable.getObligacion());
			documentosContables.setFechaResolucion(docContable.getFechaResolucion());

			if (docContable.getConceptoResumido().length() > 80)
				documentosContables.setConceptoResumido(docContable.getConceptoResumido().substring(0, 80));
			else
				documentosContables.setConceptoResumido(docContable.getConceptoResumido());
			documentosContables.setTercero(docContable.getTercero());
			if (Constantes.TIPO_DOCUMENTO_CONTABLE_D.equals(String.valueOf(idTipoDocCon)))
				documentosContables.setImporte(docContable.getImportePago());
			else if (Constantes.TIPO_DOCUMENTO_CONTABLE_O.equals(String.valueOf(idTipoDocCon)))
				documentosContables.setImporte(docContable.getImporteSigPago());
			documentosContables.setUsuarioRegistro(usuario.getNombreUsuario());
			documentosContables.setFechaRegistro(fecha);
			if (Constantes.TIPO_DOCUMENTO_CONTABLE_D.equals(String.valueOf(idTipoDocCon)))
				documentosContables.setFechaDocumentoD(fecha);
			else if (Constantes.TIPO_DOCUMENTO_CONTABLE_O.equals(String.valueOf(idTipoDocCon)))
				documentosContables.setFechaDocumentoO(fecha);
			if (docContable.getIdPagoConvo() != null && docContable.getIdPagoConvo() == 0)
				docContable.setIdPagoConvo(null);
			// documentosContables.setIdPagoConvocatoria(docContable.getIdPagoConvo());
			documentosContables.setRefIntO(docContable.getRefIntO());
			documentosContables.setRefIntD(docContable.getRefIntD());
			if (Constantes.TIPO_DOCUMENTO_CONTABLE_D.equals(String.valueOf(idTipoDocCon)))
				documentosContables.setIdPagoConvocatoria(null);
			else if (Constantes.TIPO_DOCUMENTO_CONTABLE_O.equals(String.valueOf(idTipoDocCon)))
				documentosContables.setIdPagoConvocatoria(moduloContable.getDocContables().getIdPagoConvocatoria());

			if (Constantes.TIPO_DOCUMENTO_CONTABLE_D.equals(String.valueOf(idTipoDocCon))) {
				// Campos nuevos a guardar para el tipo documento D.
				documentosContables.setReferenciaContratacion(docContable.getReferenciaContratacion());
				documentosContables.setNumeroPlurianual(docContable.getNumeroPlurianual());
				documentosContables.setCodigoSubvencion(docContable.getCodigoSubvencion());
				documentosContables.setEjercicioCompromiso1(docContable.getEjercicioCompromiso1());
				documentosContables.setEjercicioCompromiso2(docContable.getEjercicioCompromiso2());
				documentosContables.setEjercicioCompromiso3(docContable.getEjercicioCompromiso3());
				documentosContables.setEjercicioCompromiso4(docContable.getEjercicioCompromiso4());
				documentosContables.setImporteCompromiso1(docContable.getImporteCompromiso1());
				documentosContables.setImporteCompromiso2(docContable.getImporteCompromiso2());
				documentosContables.setImporteCompromiso3(docContable.getImporteCompromiso3());
				documentosContables.setImporteCompromiso4(docContable.getImporteCompromiso4());
				documentosContables.setImporteCompromisoResto(docContable.getImporteCompromisoResto());
				documentosContables.setEjercicioMaquetaTercero(docContable.getEjercicioMaquetaTercero());
				documentosContables.setNumeroMaquetaTercero(docContable.getNumeroMaquetaTercero());
				documentosContables.setFechaResolucion(docContable.getFechaResolucion());

			} else if (Constantes.TIPO_DOCUMENTO_CONTABLE_O.equals(String.valueOf(idTipoDocCon))) {
				// Campos nuevos a guardar para el tipo documento O.
				documentosContables.setTipoOperacionGastos(docContable.getTipoOperacionGastos());
				documentosContables.setFechaLimiteJustificacion(docContable.getFechaLimiteJustificacion());
				documentosContables.setCuentaPCP(docContable.getCuentaPCP());
				documentosContables.setInmovilizado(docContable.getInmovilizado());
				documentosContables.setObligacion(docContable.getObligacion());
				documentosContables.setNumeroOrden(docContable.getNumeroOrden());
				documentosContables.setNumeroPlurianual(docContable.getNumeroPlurianual());
				documentosContables.setCodigoSubvencion(docContable.getCodigoSubvencion());
				documentosContables.setImporteCompromisoResto(docContable.getImporteCompromisoResto());
				documentosContables.setNumeroFactura(docContable.getNumeroFactura());
				documentosContables.setFechaFactura(docContable.getFechaFactura());
				documentosContables.setEjercicioEndoso(docContable.getEjercicioEndoso());
				documentosContables.setNumeroEndoso(docContable.getNumeroEndoso());
				documentosContables.setOtroPerceptor(docContable.getOtroPerceptor());
				documentosContables.setFechaVencimiento(docContable.getFechaVencimiento());
				documentosContables.setCodigoRetencion(docContable.getCodigoRetencion());
				documentosContables.setBaseRetencion(docContable.getBaseRetencion());
				documentosContables.setFormaPago(docContable.getFormaPago());
				documentosContables.setCuentaFinanciera(docContable.getCuentaFinanciera());
				documentosContables.setEjercicioMaquetaTercero(docContable.getEjercicioMaquetaTercero());
				documentosContables.setNumeroMaquetaTercero(docContable.getNumeroMaquetaTercero());
				documentosContables
						.setEjercicioMaquetaTerceroOtroPerceptor(docContable.getEjercicioMaquetaTerceroOtroPerceptor());
				documentosContables
						.setNumeroMaquetaTerceroOtroPerceptor(docContable.getNumeroMaquetaTerceroOtroPerceptor());
				documentosContables.setFechaInicioPeriodoPago(docContable.getFechaInicioPeriodoPago());
				documentosContables.setCodigoContrato(docContable.getCodigoContrato());
				documentosContables.setRegistroContable(docContable.getRegistroContable());

			} else if (Constantes.TIPO_DOCUMENTO_CONTABLE_DO.equals(String.valueOf(idTipoDocCon))) {
				// Campos nuevos a guardar para el tipo documento DO.
				documentosContables.setReferenciaContratacion(docContable.getReferenciaContratacion());
				documentosContables.setTipoOperacionGastos(docContable.getTipoOperacionGastos());
				documentosContables.setFechaLimiteJustificacion(docContable.getFechaLimiteJustificacion());
				documentosContables.setCuentaPCP(docContable.getCuentaPCP());
				documentosContables.setInmovilizado(docContable.getInmovilizado());
				documentosContables.setObligacion(docContable.getObligacion());
				documentosContables.setNumeroOrden(docContable.getNumeroOrden());
				documentosContables.setNumeroPlurianual(docContable.getNumeroPlurianual());
				documentosContables.setCodigoSubvencion(docContable.getCodigoSubvencion());
				documentosContables.setImporteCompromisoResto(docContable.getImporteCompromisoResto());
				documentosContables.setNumeroFactura(docContable.getNumeroFactura());
				documentosContables.setFechaFactura(docContable.getFechaFactura());
				documentosContables.setEjercicioEndoso(docContable.getEjercicioEndoso());
				documentosContables.setNumeroEndoso(docContable.getNumeroEndoso());
				documentosContables.setOtroPerceptor(docContable.getOtroPerceptor());
				documentosContables.setFechaVencimiento(docContable.getFechaVencimiento());
				documentosContables.setCodigoRetencion(docContable.getCodigoRetencion());
				documentosContables.setBaseRetencion(docContable.getBaseRetencion());
				documentosContables.setFormaPago(docContable.getFormaPago());
				documentosContables.setCuentaFinanciera(docContable.getCuentaFinanciera());
				documentosContables.setEjercicioMaquetaTercero(docContable.getEjercicioMaquetaTercero());
				documentosContables.setNumeroMaquetaTercero(docContable.getNumeroMaquetaTercero());
				documentosContables
						.setEjercicioMaquetaTerceroOtroPerceptor(docContable.getEjercicioMaquetaTerceroOtroPerceptor());
				documentosContables
						.setNumeroMaquetaTerceroOtroPerceptor(docContable.getNumeroMaquetaTerceroOtroPerceptor());
				documentosContables.setFechaInicioPeriodoPago(docContable.getFechaInicioPeriodoPago());
				documentosContables.setCodigoContrato(docContable.getCodigoContrato());
				documentosContables.setRegistroContable(docContable.getRegistroContable());
			}

			moduloContable.setDocContables(this.documentosContablesService.add(documentosContables));

			if (Constantes.TIPO_DOCUMENTO_CONTABLE_O.equals(idTipoDocCon)) {
				moduloContable.getDocContables().setFechaDocumentoO(fecha);
				moduloContable
						.setDocContables(this.documentosContablesService.update(moduloContable.getDocContables()));
			}

			// Hacemos update del importe disponible de la aplicación
			// presupuestaria
			AplicacionesPresupuestarias aplicPresu = new AplicacionesPresupuestarias();
			aplicPresu.setIdAplicacionPresupuestaria(docContable.getIdAplicPresu());
			aplicPresu.setImporteDisponible(docContable.getImporteDisponibleApl());

			this.aplicacionesPresupuestariasService.updateImporteDisponible(aplicPresu);

		}

		FicherosContablesController.logger.info("[POST] : FicherosContables insertado correctamente");

		return moduloContable;
	}

	@RequestMapping(value = "/saveDocumentoDO", method = RequestMethod.POST)
	public @ResponseBody ModuloContable saveDocumentoDO(@RequestBody ModuloContable moduloContable) {

		Authentication aut = SecurityContextHolder.getContext().getAuthentication();
		Usuario usuario = new Usuario();
		/** Dejamos el usuario logueado en session */
		String username = "";
		if (null != aut) {
			username = (String) aut.getPrincipal();
		}
		usuario.setNombreUsuario(username);

		moduloContable = this.ficherosContablesService.saveDocumentoDO(moduloContable, usuario);

		return moduloContable;

	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param ficherosContables
	 *            FicherosContables Bean que contiene la informacion con la que
	 *            se va a crear el nuevo registro.
	 * @return FicherosContables Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody FicherosContables add(@RequestBody FicherosContables ficherosContables// ,
	// @ModelAttribute(value = "usuario") Usuario usuario
	) {

		Authentication aut = SecurityContextHolder.getContext().getAuthentication();
		Usuario usuario = new Usuario();
		/** Dejamos el usuario logueado en session */
		String username = "";
		if (null != aut) {
			username = (String) aut.getPrincipal();
		}

		usuario.setNombreUsuario(username);

		FicherosContables ficherosContablesAux = this.ficherosContablesService.add(ficherosContables, usuario);
		FicherosContablesController.logger.info("[POST] : FicherosContables insertado correctamente");
		return ficherosContablesAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idFicheroContable
	 *            Integer Identificador del objeto que se desea eliminar.
	 * @return FicherosContables Bean eliminado.
	 */
	@RequestMapping(value = "/{idFicheroContable}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody FicherosContables remove(@PathVariable Integer idFicheroContable) {
		FicherosContables ficherosContables = new FicherosContables();
		ficherosContables.setIdFicheroContable(idFicheroContable);

		DocumentosContables documentosContablesAux = new DocumentosContables();
		documentosContablesAux.setIdFicheroContable(idFicheroContable);
		List<DocumentosContables> listaDocumentos = new ArrayList<DocumentosContables>();
		listaDocumentos = documentosContablesService.findImporteAplicPresu(documentosContablesAux);

		if (listaDocumentos != null && !listaDocumentos.isEmpty()) {
			for (int x = 0; x < listaDocumentos.size(); x++) {
				AplicacionesPresupuestarias aplic = new AplicacionesPresupuestarias();
				aplic.setIdAplicacionPresupuestaria(listaDocumentos.get(x).getIdAplicPresu());

				aplic = aplicacionesPresupuestariasService.find(aplic);
				BigDecimal importeActualizar = listaDocumentos.get(x).getImporte();
				aplic.setImporteDisponible(importeActualizar.add(aplic.getImporteDisponible()));

				aplicacionesPresupuestariasService.updateImporteDisponible(aplic);
			}
		}

		DocumentosContables documentoContables = new DocumentosContables();
		documentoContables.setIdFicheroContable(idFicheroContable);
		documentosContablesService.removeByFicheroContable(documentoContables);

		this.ficherosContablesService.remove(ficherosContables);
		FicherosContablesController.logger.info("[DELETE] : FicherosContables borrado correctamente");
		return ficherosContables;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	/*
	 * esto lo cambio para abrir la modal
	 * 
	 * @RequestMapping(value = "/maint", method = RequestMethod.GET) public
	 * String getFormEdit(Model model) { FicherosContablesController.logger.
	 * info("[GET - View] : ficheroscontables");
	 * 
	 * return "ficheroscontables"; }
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "/maint/{idConvocatoria}", method = RequestMethod.GET)
	public ModelAndView cargarModalFicherosContables(@PathVariable("idConvocatoria") Integer idConvocatoria,
			Model model) {
		FicherosContablesController.logger.info("[GET - View] : ficheroscontables");

		ModelAndView modelAndView = new ModelAndView("ficheroscontables");

		FicherosContables ficherosContables = new FicherosContables();
		ficherosContables.setIdConvocatoria(idConvocatoria);
		ficherosContables = this.ficherosContablesService.findNew(ficherosContables);

		FicherosContablesController.logger.info("[GET - findBy_PK] : Obtener FicherosContables por PK");

		ModuloContable moduloContable = new ModuloContable(idConvocatoria, new DocumentosContables(),
				ficherosContables);

		modelAndView.addObject("moduloContable", moduloContable);
		// modelAndView.addObject("editable", (editable == 0) ? false : true);

		return modelAndView;
	}

	@RequestMapping(value = "/buscar/{idConvocatoria}/{idFicheroContable}", method = RequestMethod.GET)
	public ModelAndView cargarModalEditarFicherosContables(@PathVariable("idConvocatoria") Integer idConvocatoria,
			@PathVariable("idFicheroContable") Integer idFicheroContable) {
		FicherosContablesController.logger.info("[GET - View] : ficheroscontables");

		ModelAndView modelAndView = new ModelAndView("ficheroscontablesconsulta");

		FicherosContables ficherosContables = new FicherosContables();
		ficherosContables.setIdConvocatoria(idConvocatoria);
		ficherosContables.setIdFicheroContable(idFicheroContable);
		ficherosContables = this.ficherosContablesService.find(ficherosContables);

		/*
		 * FicherosContables ficherosContablesAux = new FicherosContables();
		 * ficherosContablesAux.setIdFicheroContable(ficheroContable.
		 * getIdFicheroContable()); ficherosContablesAux =
		 * ficherosContablesService.find(ficherosContablesAux);
		 * ficheroContable.setNombreFichero(ficherosContablesAux.
		 * getNombreFichero());
		 */

		FicherosContablesController.logger.info("[GET - findBy_PK] : Obtener FicherosContables por PK");

		ModuloContable moduloContable = new ModuloContable(idConvocatoria, new DocumentosContables(),
				ficherosContables);

		DocumentosContables docContable = new DocumentosContables();
		docContable.setIdFicheroContable(ficherosContables.getIdFicheroContable());
		docContable.setIdConvocatoria(idConvocatoria);

		List<DocumentosContables> docContables = documentosContablesService.findAllLike(docContable,
				new JQGridRequestDto(), false);

		if (docContables != null && !docContables.isEmpty()) {
			PagosConvocatoria pagoConvo = new PagosConvocatoria(docContables.get(0).getIdPagoConvocatoria());

			pagoConvo = pagosConvocatoriaService.find(pagoConvo);
			modelAndView.addObject("pagoConvo", pagoConvo);
		}

		modelAndView.addObject("moduloContable", moduloContable);
		// modelAndView.addObject("editable", (editable == 0) ? false : true);

		return modelAndView;
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterFicherosContables
	 *            FicherosContables Bean que contiene los parametros de filtrado
	 *            a emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<FicherosContables> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/{idConvocatoria}/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<FicherosContables> filter(@PathVariable Integer idConvocatoria,
			@RequestJsonBody(param = "filter") FicherosContables filterFicherosContables,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		FicherosContablesController.logger.info("[POST - filter] : Obtener FicherosContabless");
		filterFicherosContables.setIdConvocatoria(idConvocatoria);
		return this.ficherosContablesService.filter(filterFicherosContables, jqGridRequestDto, false);
	}

	@RequestMapping(value = "/generarFicheroLOT/{idFichero}", method = RequestMethod.GET)
	public @ResponseBody String generarFicheroLOTDocumentoD(@PathVariable Integer idFichero) {
		FicherosContablesController.logger.info("[GET] : Generar fichero LOT");
		StringBuilder texto = new StringBuilder();

		FicherosContables ficheroContable = new FicherosContables();
		ficheroContable.setIdFicheroContable(idFichero);
		ficheroContable = ficherosContablesService.find(ficheroContable);

		String cabecera = "";

		// Montamos la cabecera del .LOT
		if (ficheroContable.getTipoRegistro().length() < 1) {
			cabecera = cabecera + " ";
		} else
			cabecera = cabecera + ficheroContable.getTipoRegistro();
		cabecera = montarCabeceraNum((ficheroContable.getInstitucion() == null) ? "" : ficheroContable.getInstitucion(),
				5, cabecera, "izq");
		cabecera = montarCabeceraNum((ficheroContable.getEjercicio() == null) ? "" : ficheroContable.getEjercicio(), 4,
				cabecera, "izq");
		cabecera = montarCabeceraNum((ficheroContable.getSeccion() == null) ? "" : ficheroContable.getSeccion(), 2,
				cabecera, "izq");
		cabecera = montarCabeceraStr(
				(ficheroContable.getOrigenMaqueta() == null) ? "" : ficheroContable.getOrigenMaqueta(), 3, cabecera,
				"izq");
		cabecera = montarCabeceraNum(
				(ficheroContable.getIdentificadorCinta() == null) ? "" : ficheroContable.getIdentificadorCinta(), 3,
				cabecera, "izq");
		cabecera = montarCabeceraStr((ficheroContable.getUsuario() == null) ? "" : ficheroContable.getUsuario(), 8,
				cabecera, "izq");
		if (ficheroContable.getIdIdioma() != null) {
			if (String.valueOf(ficheroContable.getIdIdioma()).length() < 1) {
				cabecera = cabecera + "0";
			} else {
				if (ficheroContable.getIdIdioma() == 6) // Castellano
					cabecera = cabecera + "0";
				else if (ficheroContable.getIdIdioma() == 5) // Euskera
					cabecera = cabecera + "1";
			}

		} else {
			cabecera = montarCabeceraNum("", 1, cabecera, "izq");
		}

		texto.append(cabecera);
		texto.append(System.getProperty("line.separator"));

		// Montamos los documentos contables del .LOT
		List<DocumentosContables> docContables = new ArrayList<DocumentosContables>();
		docContables = documentosContablesService.findAllLikeByFichero(new DocumentosContables(),
				new JQGridRequestDto(), null, idFichero);

		if (docContables != null) {
			for (int x = 0; x < docContables.size(); x++) {
				String dato = "";

				// Tipo de Registro
				dato = montarCabeceraStr(
						(docContables.get(x).getTipoRegistro() == null) ? "" : docContables.get(x).getTipoRegistro(), 1,
						dato, "izq");
				// Tipo Documento
				dato = montarCabeceraStr((docContables.get(x).getTipoDocumento().getDescripcionCastellano() == null)
						? "" : docContables.get(x).getTipoDocumento().getDescripcionCastellano(), 4, dato, "izq");
				// Nº Expediente
				dato = montarCabeceraStr((docContables.get(x).getNumeroExpediente() == null) ? ""
						: docContables.get(x).getNumeroExpediente(), 25, dato, "izq");
				// Referencia M. Contratación
				dato = montarCabeceraStr((docContables.get(x).getReferenciaContratacion() == null) ? ""
						: docContables.get(x).getReferenciaContratacion(), 20, dato, "izq");

				// Aplicación Presupuestaria

				// Ejercicio
				dato = montarCabeceraNum((docContables.get(x).getEjercicioAplPre() == null) ? ""
						: docContables.get(x).getEjercicioAplPre(), 4, dato, "der");
				// Agrupación
				dato = montarCabeceraNum(
						(docContables.get(x).getAgrupacion() == null) ? "" : docContables.get(x).getAgrupacion(), 1,
						dato, "der");
				// Gasto / Ingreso
				dato = montarCabeceraNum(
						(docContables.get(x).getGastoIngreso() == null) ? "" : docContables.get(x).getGastoIngreso(), 1,
						dato, "der");
				// Sección
				dato = montarCabeceraNum(
						(docContables.get(x).getSeccion() == null) ? "" : docContables.get(x).getSeccion(), 2, dato,
						"der");
				// Servicio
				dato = montarCabeceraNum(
						(docContables.get(x).getServicio() == null) ? "" : docContables.get(x).getServicio(), 2, dato,
						"der");
				// Centro
				dato = montarCabeceraNum(
						(docContables.get(x).getCentro() == null) ? "" : docContables.get(x).getCentro(), 4, dato,
						"der");
				// Territorio
				dato = montarCabeceraNum(
						(docContables.get(x).getTerritorio() == null) ? "" : docContables.get(x).getTerritorio(), 1,
						dato, "der");
				// CAC
				dato = montarCabeceraNum((docContables.get(x).getCac() == null) ? "" : docContables.get(x).getCac(), 3,
						dato, "der");
				// SC
				dato = montarCabeceraNum((docContables.get(x).getSc() == null) ? "" : docContables.get(x).getSc(), 2,
						dato, "der");
				// Programa
				dato = montarCabeceraNum(
						(docContables.get(x).getPrograma() == null) ? "" : docContables.get(x).getPrograma(), 5, dato,
						"der");
				// Partida
				dato = montarCabeceraNum(
						(docContables.get(x).getPartida() == null) ? "" : docContables.get(x).getPartida(), 3, dato,
						"der");
				// Letra de Control
				dato = montarCabeceraStr((docContables.get(x).getLetraControl() == null) ? ""
						: docContables.get(x).getLetraControl().toUpperCase(), 1, dato, "izq");

				// Referencia de Intervención

				// Ejercicio
				dato = montarCabeceraNum((docContables.get(x).getEjercicioRefInt() == null) ? ""
						: docContables.get(x).getEjercicioRefInt(), 4, dato, "der");
				// Año Origen
				dato = montarCabeceraNum(
						(docContables.get(x).getAnyoOrigen() == null) ? "" : docContables.get(x).getAnyoOrigen(), 4,
						dato, "der");
				// Nº Referencia Intervención
				dato = montarCabeceraNum(
						(docContables.get(x).getNumero() == null) ? "" : docContables.get(x).getNumero(), 6, dato,
						"der");
				// Disponible
				dato = montarCabeceraNum(
						(docContables.get(x).getDisponible() == null) ? "" : docContables.get(x).getDisponible(), 4,
						dato, "der");
				// Número de Plurianual
				dato = montarCabeceraStr((docContables.get(x).getNumeroPlurianual() == null) ? ""
						: docContables.get(x).getNumeroPlurianual(), 6, dato, "izq");
				// Código de Subvención
				dato = montarCabeceraStr((docContables.get(x).getCodigoSubvencion() == null) ? ""
						: docContables.get(x).getCodigoSubvencion(), 10, dato, "izq");
				// Concepto Resumido
				dato = montarCabeceraStr((docContables.get(x).getConceptoResumido() == null) ? ""
						: docContables.get(x).getConceptoResumido(), 80, dato, "izq");
				// Tercero
				dato = montarCabeceraStr(
						(docContables.get(x).getTercero() == null) ? "" : docContables.get(x).getTercero(), 13, dato,
						"izq");

				// Importe
				if (docContables.get(x).getImporte() != null) {
					String importe = String.valueOf(docContables.get(x).getImporte());
					if (importe.indexOf(".") >= 0) {
						String importeDecimales = importe.split("\\.")[1];
						if (importeDecimales.length() < 2) {
							importe += "0";
						}
						importe = importe.replace(".", "");
						dato = montarCabeceraStr(importe, 13, dato, "der");
					} else {
						if (importe.length() < 13) {
							dato = montarCabeceraStr(importe, 11, dato, "der");
							dato = dato + "00";
						} else {
							dato = dato + importe;
						}
					}
				} else {
					dato = montarCabeceraStr("", 13, dato, "der");
				}

				// Ejercicio Compromiso 1
				dato = montarCabeceraNum((docContables.get(x).getEjercicioCompromiso1() == null) ? ""
						: docContables.get(x).getEjercicioCompromiso1(), 4, dato, "der");
				// Ejercicio Compromiso 2
				dato = montarCabeceraNum((docContables.get(x).getEjercicioCompromiso2() == null) ? ""
						: docContables.get(x).getEjercicioCompromiso2(), 4, dato, "der");
				// Ejercicio Compromiso 3
				dato = montarCabeceraNum((docContables.get(x).getEjercicioCompromiso3() == null) ? ""
						: docContables.get(x).getEjercicioCompromiso3(), 4, dato, "der");
				// Ejercicio Compromiso 4
				dato = montarCabeceraNum((docContables.get(x).getEjercicioCompromiso4() == null) ? ""
						: docContables.get(x).getEjercicioCompromiso4(), 4, dato, "der");

				// Importe Compromiso 1
				dato = montarCabeceraNum((docContables.get(x).getImporteCompromiso1() == null) ? ""
						: docContables.get(x).getImporteCompromiso1(), 13, dato, "der");
				// Importe Compromiso 2
				dato = montarCabeceraNum((docContables.get(x).getImporteCompromiso2() == null) ? ""
						: docContables.get(x).getImporteCompromiso2(), 13, dato, "der");
				// Importe Compromiso 3
				dato = montarCabeceraNum((docContables.get(x).getImporteCompromiso3() == null) ? ""
						: docContables.get(x).getImporteCompromiso3(), 13, dato, "der");
				// Importe Compromiso 4
				dato = montarCabeceraNum((docContables.get(x).getImporteCompromiso4() == null) ? ""
						: docContables.get(x).getImporteCompromiso4(), 13, dato, "der");

				// Importe Compromiso Resto
				dato = montarCabeceraNum((docContables.get(x).getImporteCompromisoResto() == null) ? ""
						: docContables.get(x).getImporteCompromisoResto(), 13, dato, "der");
				// Ejercicio de Maqueta de tercero
				dato = montarCabeceraNum((docContables.get(x).getEjercicioMaquetaTercero() == null) ? ""
						: docContables.get(x).getEjercicioMaquetaTercero(), 4, dato, "der");
				// Nº de Maqueta de tercero
				dato = montarCabeceraNum((docContables.get(x).getNumeroMaquetaTercero() == null) ? ""
						: docContables.get(x).getNumeroMaquetaTercero(), 6, dato, "der");

				// Fecha de Concesión / Fecha de Resolución
				dato = montarCabeceraNum((docContables.get(x).getFechaResolucion() == null) ? ""
						: docContables.get(x).getFechaResolucion().toString(), 8, dato, "der");

				texto.append(dato);
				texto.append(System.getProperty("line.separator"));
			}
		}

		String oid = "";

		// Creamos el .LOT y lo subimos al PIF
		try {
			// String home = System.getProperty("user.home");
			// File file = new File(home + "/Downloads/" +
			// ficheroContable.getNombreFichero() + ".LOT");
			// FileWriter writer = new FileWriter(file);

			// writer.write(texto.toString());
			// writer.close();

			InputStream myInputStream = new ByteArrayInputStream(texto.toString().getBytes());

			oid = pifAdapterService.putFile(myInputStream, ficheroContable.getNombreFichero() + ".LOT", "ab60");

		} catch (Exception e) {
			FicherosContablesController.logger.error("[Exception]" + e.getMessage());
		}

		// cambiar estado en AB601AT00 a 1
		ficheroContable.setEstado(Constantes.ESTADO_FICHERO_LOT_GENERADO);
		Authentication aut = SecurityContextHolder.getContext().getAuthentication();
		Usuario usuario = new Usuario();
		String username = "";
		if (null != aut) {
			username = (String) aut.getPrincipal();
		}
		usuario.setNombreUsuario(username);
		ficheroContable = ficherosContablesService.update(ficheroContable, usuario);

		return oid;
	}

	@RequestMapping(value = "/generarFicheroLOTDocumentoO/{idFichero}", method = RequestMethod.GET)
	public @ResponseBody String generarFicheroLOTDocumentoO(@PathVariable Integer idFichero) {
		FicherosContablesController.logger.info("[GET] : Generar fichero LOT");
		StringBuilder texto = new StringBuilder();

		FicherosContables ficheroContable = new FicherosContables();
		ficheroContable.setIdFicheroContable(idFichero);
		ficheroContable = ficherosContablesService.find(ficheroContable);

		String cabecera = "";

		// Montamos la cabecera del .LOT
		if (ficheroContable.getTipoRegistro().length() < 1) {
			cabecera = cabecera + " ";
		} else
			cabecera = cabecera + ficheroContable.getTipoRegistro();
		cabecera = montarCabeceraNum((ficheroContable.getInstitucion() == null) ? "" : ficheroContable.getInstitucion(),
				5, cabecera, "izq");
		cabecera = montarCabeceraNum((ficheroContable.getEjercicio() == null) ? "" : ficheroContable.getEjercicio(), 4,
				cabecera, "izq");
		cabecera = montarCabeceraNum((ficheroContable.getSeccion() == null) ? "" : ficheroContable.getSeccion(), 2,
				cabecera, "izq");
		cabecera = montarCabeceraStr(
				(ficheroContable.getOrigenMaqueta() == null) ? "" : ficheroContable.getOrigenMaqueta(), 3, cabecera,
				"izq");
		cabecera = montarCabeceraNum(
				(ficheroContable.getIdentificadorCinta() == null) ? "" : ficheroContable.getIdentificadorCinta(), 3,
				cabecera, "izq");
		cabecera = montarCabeceraStr((ficheroContable.getUsuario() == null) ? "" : ficheroContable.getUsuario(), 8,
				cabecera, "izq");
		if (ficheroContable.getIdIdioma() != null) {
			if (String.valueOf(ficheroContable.getIdIdioma()).length() < 1) {
				cabecera = cabecera + "0";
			} else {
				if (ficheroContable.getIdIdioma() == 6) // Castellano
					cabecera = cabecera + "0";
				else if (ficheroContable.getIdIdioma() == 5) // Euskera
					cabecera = cabecera + "1";
			}

		} else {
			cabecera = montarCabeceraNum("", 1, cabecera, "izq");
		}

		texto.append(cabecera);
		texto.append(System.getProperty("line.separator"));

		// Montamos los documentos contables del .LOT
		List<DocumentosContables> docContables = new ArrayList<DocumentosContables>();
		docContables = documentosContablesService.findAllLikeByFichero(new DocumentosContables(),
				new JQGridRequestDto(), null, idFichero);

		if (docContables != null) {
			for (int x = 0; x < docContables.size(); x++) {
				String dato = "";

				// Tipo de Registro
				dato = montarCabeceraStr(
						(docContables.get(x).getTipoRegistro() == null) ? "" : docContables.get(x).getTipoRegistro(), 1,
						dato, "izq");
				// Tipo Documento
				dato = montarCabeceraStr((docContables.get(x).getTipoDocumento().getDescripcionCastellano() == null)
						? "" : docContables.get(x).getTipoDocumento().getDescripcionCastellano(), 4, dato, "izq");
				// Nº Expediente
				dato = montarCabeceraStr((docContables.get(x).getNumeroExpediente() == null) ? ""
						: docContables.get(x).getNumeroExpediente(), 25, dato, "izq");
				// Tipo de Operación de Gastos
				dato = montarCabeceraStr((docContables.get(x).getTipoOperacionGastos() == null) ? ""
						: docContables.get(x).getTipoOperacionGastos(), 1, dato, "izq");
				// Fecha Límite de Justificación
				dato = montarCabeceraStr((docContables.get(x).getFechaLimiteJustificacion() == null) ? ""
						: docContables.get(x).getFechaLimiteJustificacion().toString(), 8, dato, "izq");

				// Aplicación Presupuestaria

				// Ejercicio
				dato = montarCabeceraNum((docContables.get(x).getEjercicioAplPre() == null) ? ""
						: docContables.get(x).getEjercicioAplPre(), 4, dato, "der");
				// Agrupación
				dato = montarCabeceraNum(
						(docContables.get(x).getAgrupacion() == null) ? "" : docContables.get(x).getAgrupacion(), 1,
						dato, "der");
				// Gasto / Ingreso
				dato = montarCabeceraNum(
						(docContables.get(x).getGastoIngreso() == null) ? "" : docContables.get(x).getGastoIngreso(), 1,
						dato, "der");
				// Sección
				dato = montarCabeceraNum(
						(docContables.get(x).getSeccion() == null) ? "" : docContables.get(x).getSeccion(), 2, dato,
						"der");
				// Servicio
				dato = montarCabeceraNum(
						(docContables.get(x).getServicio() == null) ? "" : docContables.get(x).getServicio(), 2, dato,
						"der");
				// Centro
				dato = montarCabeceraNum(
						(docContables.get(x).getCentro() == null) ? "" : docContables.get(x).getCentro(), 4, dato,
						"der");
				// Territorio
				dato = montarCabeceraNum(
						(docContables.get(x).getTerritorio() == null) ? "" : docContables.get(x).getTerritorio(), 1,
						dato, "der");
				// CAC
				dato = montarCabeceraNum((docContables.get(x).getCac() == null) ? "" : docContables.get(x).getCac(), 3,
						dato, "der");
				// SC
				dato = montarCabeceraNum((docContables.get(x).getSc() == null) ? "" : docContables.get(x).getSc(), 2,
						dato, "der");
				// Programa
				dato = montarCabeceraNum(
						(docContables.get(x).getPrograma() == null) ? "" : docContables.get(x).getPrograma(), 5, dato,
						"der");
				// Partida
				dato = montarCabeceraNum(
						(docContables.get(x).getPartida() == null) ? "" : docContables.get(x).getPartida(), 3, dato,
						"der");
				// Letra de Control
				dato = montarCabeceraStr((docContables.get(x).getLetraControl() == null) ? ""
						: docContables.get(x).getLetraControl().toUpperCase(), 1, dato, "izq");
				// Cuenta PCP
				dato = montarCabeceraStr(
						(docContables.get(x).getCuentaPCP() == null) ? "" : docContables.get(x).getEjercicioRefInt(), 8,
						dato, "izq");
				// Inmovilizado
				dato = montarCabeceraStr(
						(docContables.get(x).getInmovilizado() == null) ? "" : docContables.get(x).getEjercicioRefInt(),
						14, dato, "izq");

				// Referencia de Intervención

				// Ejercicio
				dato = montarCabeceraNum((docContables.get(x).getEjercicioRefInt() == null) ? ""
						: docContables.get(x).getEjercicioRefInt(), 4, dato, "der");
				// Año Origen
				dato = montarCabeceraNum(
						(docContables.get(x).getAnyoOrigen() == null) ? "" : docContables.get(x).getAnyoOrigen(), 4,
						dato, "der");
				// Nº Referencia Intervención
				dato = montarCabeceraNum(
						(docContables.get(x).getNumero() == null) ? "" : docContables.get(x).getNumero(), 6, dato,
						"der");
				// Disponible
				dato = montarCabeceraNum(
						(docContables.get(x).getDisponible() == null) ? "" : docContables.get(x).getDisponible(), 4,
						dato, "der");
				// Obligación
				dato = montarCabeceraNum(
						(docContables.get(x).getObligacion() == null) ? "" : docContables.get(x).getObligacion(), 4,
						dato, "der");
				// Nº Orden
				dato = montarCabeceraStr(
						(docContables.get(x).getNumeroOrden() == null) ? "" : docContables.get(x).getNumeroOrden(), 4,
						dato, "izq");
				// Número de Plurianual
				dato = montarCabeceraStr((docContables.get(x).getNumeroPlurianual() == null) ? ""
						: docContables.get(x).getNumeroPlurianual(), 6, dato, "izq");
				// Código de Subvención
				dato = montarCabeceraStr((docContables.get(x).getCodigoSubvencion() == null) ? ""
						: docContables.get(x).getCodigoSubvencion(), 10, dato, "izq");
				// Nº de Factura
				dato = montarCabeceraStr(
						(docContables.get(x).getNumeroFactura() == null) ? "" : docContables.get(x).getNumeroFactura(),
						10, dato, "izq");
				// Fecha Factura
				dato = montarCabeceraStr((docContables.get(x).getFechaFactura() == null) ? ""
						: docContables.get(x).getFechaFactura().toString(), 8, dato, "izq");
				// Concepto Resumido
				dato = montarCabeceraStr((docContables.get(x).getConceptoResumido() == null) ? ""
						: docContables.get(x).getConceptoResumido(), 80, dato, "izq");
				// Tercero
				dato = montarCabeceraStr(
						(docContables.get(x).getTercero() == null) ? "" : docContables.get(x).getTercero(), 13, dato,
						"izq");

				// Importe
				if (docContables.get(x).getImporte() != null) {
					String importe = String.valueOf(docContables.get(x).getImporte());
					if (importe.indexOf(".") >= 0) {
						String importeDecimales = importe.split("\\.")[1];
						if (importeDecimales.length() < 2) {
							importe += "0";
						}
						importe = importe.replace(".", "");
						dato = montarCabeceraNum(importe, 13, dato, "der");
					} else {
						if (importe.length() < 13) {
							dato = montarCabeceraNum(importe, 11, dato, "der");
							dato = dato + "00";
						} else {
							dato = dato + importe;
						}
					}
				} else {
					dato = montarCabeceraNum("", 13, dato, "der");
				}

				// Ejercicio del Endoso
				dato = montarCabeceraNum((docContables.get(x).getEjercicioEndoso() == null) ? ""
						: docContables.get(x).getEjercicioEndoso(), 4, dato, "der");
				// Número de Endoso
				dato = montarCabeceraNum(
						(docContables.get(x).getNumeroEndoso() == null) ? "" : docContables.get(x).getNumeroEndoso(), 6,
						dato, "der");
				// Otro Perceptor
				dato = montarCabeceraStr(
						(docContables.get(x).getOtroPerceptor() == null) ? "" : docContables.get(x).getOtroPerceptor(),
						13, dato, "izq");
				// Fecha de Vencimiento
				dato = montarCabeceraNum((docContables.get(x).getFechaVencimiento() == null) ? ""
						: docContables.get(x).getFechaVencimiento().toString(), 8, dato, "der");
				// Código de Retención
				dato = montarCabeceraNum((docContables.get(x).getCodigoRetencion() == null) ? ""
						: docContables.get(x).getCodigoRetencion(), 3, dato, "der");
				// Base de Retención
				dato = montarCabeceraNum(
						(docContables.get(x).getBaseRetencion() == null) ? "" : docContables.get(x).getBaseRetencion(),
						13, dato, "der");
				// Forma de Pago
				dato = montarCabeceraStr(
						(docContables.get(x).getFormaPago() == null) ? "" : docContables.get(x).getFormaPago(), 1, dato,
						"izq");
				// Cuenta Financiera
				dato = montarCabeceraNum((docContables.get(x).getCuentaFinanciera() == null) ? ""
						: docContables.get(x).getCuentaFinanciera(), 10, dato, "der");
				// Nº de Maqueta de Tercero
				dato = montarCabeceraNum((docContables.get(x).getNumeroMaquetaTercero() == null) ? ""
						: docContables.get(x).getNumeroMaquetaTercero(), 10, dato, "der");
				// Nº de Maqueta de Otro Perceptor
				dato = montarCabeceraNum((docContables.get(x).getNumeroMaquetaTerceroOtroPerceptor() == null) ? ""
						: docContables.get(x).getNumeroMaquetaTerceroOtroPerceptor(), 10, dato, "der");
				// Código de Contrato
				dato = montarCabeceraStr((docContables.get(x).getCodigoContrato() == null) ? ""
						: docContables.get(x).getCodigoContrato(), 30, dato, "izq");
				// Registro Contable
				dato = montarCabeceraStr((docContables.get(x).getRegistroContable() == null) ? ""
						: docContables.get(x).getRegistroContable(), 10, dato, "izq");
				// Fecha de Concesión / Fecha de Resolución
				dato = montarCabeceraNum((docContables.get(x).getFechaResolucion() == null) ? ""
						: docContables.get(x).getFechaResolucion().toString(), 8, dato, "der");

				texto.append(dato);
				texto.append(System.getProperty("line.separator"));
			}
		}

		String oid = "";

		// Creamos el .LOT y lo subimos al PIF
		try {
			// String home = System.getProperty("user.home");
			// File file = new File(home + "/Downloads/" +
			// ficheroContable.getNombreFichero() + ".LOT");
			// FileWriter writer = new FileWriter(file);

			// writer.write(texto.toString());
			// writer.close();

			InputStream myInputStream = new ByteArrayInputStream(texto.toString().getBytes());

			oid = pifAdapterService.putFile(myInputStream, ficheroContable.getNombreFichero() + ".LOT", "ab60");

		} catch (Exception e) {
			FicherosContablesController.logger.error("[Exception]" + e.getMessage());
		}

		// cambiar estado en AB601AT00 a 1
		ficheroContable.setEstado(Constantes.ESTADO_FICHERO_LOT_GENERADO);
		Authentication aut = SecurityContextHolder.getContext().getAuthentication();
		Usuario usuario = new Usuario();
		String username = "";
		if (null != aut) {
			username = (String) aut.getPrincipal();
		}
		usuario.setNombreUsuario(username);
		ficheroContable = ficherosContablesService.update(ficheroContable, usuario);

		return oid;
	}

	@RequestMapping(value = "generarFicheroLOTDocumentoDO/{idFichero}", method = RequestMethod.GET)
	public @ResponseBody String generarFicheroLOTDocumentoDO(@PathVariable Integer idFichero) {
		FicherosContablesController.logger.info("[GET] : Genrerar fichero LOT Documento DO");
		StringBuilder texto = new StringBuilder();

		FicherosContables ficheroContable = new FicherosContables();
		ficheroContable.setIdFicheroContable(idFichero);
		ficheroContable = this.ficherosContablesService.find(ficheroContable);

		String cabecera = "";

		// Montamos la cabecera del fichero .LOT
		if (ficheroContable.getTipoRegistro().length() < 1) {
			cabecera += " ";
		} else {
			cabecera += ficheroContable.getTipoRegistro();
		}
		cabecera = montarCabeceraNum((ficheroContable.getInstitucion() == null) ? "" : ficheroContable.getInstitucion(),
				5, cabecera, "izq");
		cabecera = montarCabeceraNum((ficheroContable.getEjercicio() == null) ? "" : ficheroContable.getEjercicio(), 4,
				cabecera, "izq");
		cabecera = montarCabeceraNum((ficheroContable.getSeccion() == null) ? "" : ficheroContable.getSeccion(), 2,
				cabecera, "izq");
		cabecera = montarCabeceraStr(
				(ficheroContable.getOrigenMaqueta() == null) ? "" : ficheroContable.getOrigenMaqueta(), 3, cabecera,
				"izq");
		cabecera = montarCabeceraNum(
				(ficheroContable.getIdentificadorCinta() == null) ? "" : ficheroContable.getIdentificadorCinta(), 3,
				cabecera, "izq");
		cabecera = montarCabeceraStr((ficheroContable.getUsuario() == null) ? "" : ficheroContable.getUsuario(), 8,
				cabecera, "izq");
		cabecera = montarCabeceraNum(
				(ficheroContable.getIdIdioma() == null) ? "" : String.valueOf(ficheroContable.getIdIdioma()), 1,
				cabecera, "izq");

		texto.append(cabecera);
		texto.append(System.getProperty("line.separator"));

		// Montamos los documentos contables del fichero .LOT
		List<DocumentosContables> documentosContables = new ArrayList<DocumentosContables>();
		documentosContables = this.documentosContablesService.findAllLikeByFichero(new DocumentosContables(),
				new JQGridRequestDto(), null, idFichero);

		if (documentosContables != null) {
			for (int i = 0; i < documentosContables.size(); i++) {

				String datoContable = "";

				// Tipo de Registro
				datoContable = montarCabeceraStr((documentosContables.get(i).getTipoRegistro() == null) ? ""
						: documentosContables.get(i).getTipoRegistro(), 1, datoContable, "izq");
				// Tipo de documento
				datoContable = montarCabeceraStr(
						(documentosContables.get(i).getTipoDocumento().getDescripcionCastellano() == null) ? ""
								: documentosContables.get(i).getTipoDocumento().getDescripcionCastellano(),
						4, datoContable, "izq");
				// Nº Expediente
				datoContable = montarCabeceraStr((documentosContables.get(i).getNumeroExpediente() == null) ? ""
						: documentosContables.get(i).getNumeroExpediente(), 25, datoContable, "izq");
				// Referencia M. Contratación
				datoContable = montarCabeceraStr((documentosContables.get(i).getReferenciaContratacion() == null) ? ""
						: documentosContables.get(i).getReferenciaContratacion(), 20, datoContable, "izq");
				// Tipo de Operación de Gastos
				datoContable = montarCabeceraStr((documentosContables.get(i).getTipoOperacionGastos() == null) ? ""
						: documentosContables.get(i).getTipoOperacionGastos(), 1, datoContable, "izq");
				// Fecha Límite de Justificación
				datoContable = montarCabeceraStr(
						(documentosContables.get(i).getFechaLimiteJustificacion() == null) ? ""
								: documentosContables.get(i).getFechaLimiteJustificacion().toString(),
						8, datoContable, "izq");

				// Aplicación Presupuestaria

				// Ejercicio
				datoContable = montarCabeceraNum((documentosContables.get(i).getEjercicioAplPre() == null) ? ""
						: documentosContables.get(i).getEjercicioAplPre(), 4, datoContable, "der");
				// Agrupación
				datoContable = montarCabeceraNum((documentosContables.get(i).getAgrupacion() == null) ? ""
						: documentosContables.get(i).getAgrupacion(), 1, datoContable, "der");
				// Gastpo / Ingreso
				datoContable = montarCabeceraNum((documentosContables.get(i).getGastoIngreso() == null) ? ""
						: documentosContables.get(i).getGastoIngreso(), 1, datoContable, "der");
				// Sección
				datoContable = montarCabeceraNum((documentosContables.get(i).getSeccion() == null) ? ""
						: documentosContables.get(i).getSeccion(), 2, datoContable, "der");
				// Servicio
				datoContable = montarCabeceraNum((documentosContables.get(i).getServicio() == null) ? ""
						: documentosContables.get(i).getServicio(), 2, datoContable, "der");
				// Centro
				datoContable = montarCabeceraNum(
						(documentosContables.get(i).getCentro() == null) ? "" : documentosContables.get(i).getCentro(),
						4, datoContable, "der");
				// Territorio (provincia)
				datoContable = montarCabeceraNum((documentosContables.get(i).getTerritorio() == null) ? ""
						: documentosContables.get(i).getTerritorio(), 1, datoContable, "der");
				// CAC
				datoContable = montarCabeceraNum(
						(documentosContables.get(i).getCac() == null) ? "" : documentosContables.get(i).getCac(), 3,
						datoContable, "der");
				// SC
				datoContable = montarCabeceraNum(
						(documentosContables.get(i).getSc() == null) ? "" : documentosContables.get(i).getSc(), 2,
						datoContable, "der");
				// Programa
				datoContable = montarCabeceraNum((documentosContables.get(i).getPrograma() == null) ? ""
						: documentosContables.get(i).getPrograma(), 5, datoContable, "der");
				// Partida
				datoContable = montarCabeceraNum((documentosContables.get(i).getPartida() == null) ? ""
						: documentosContables.get(i).getPartida(), 3, datoContable, "der");
				// Letra de Control
				datoContable = montarCabeceraStr((documentosContables.get(i).getLetraControl() == null) ? ""
						: documentosContables.get(i).getLetraControl(), 1, datoContable, "izq");
				// Cuenta PCP
				datoContable = montarCabeceraStr((documentosContables.get(i).getCuentaPCP() == null) ? ""
						: documentosContables.get(i).getCuentaPCP(), 8, datoContable, "izq");
				// Inmovilizado
				datoContable = montarCabeceraStr((documentosContables.get(i).getInmovilizado() == null) ? ""
						: documentosContables.get(i).getInmovilizado(), 14, datoContable, "izq");

				// Referencia de Intervención

				// Ejercicio
				datoContable = montarCabeceraNum((documentosContables.get(i).getEjercicioRefInt() == null) ? ""
						: documentosContables.get(i).getEjercicioRefInt(), 4, datoContable, "izq");
				// Año Origen
				datoContable = montarCabeceraNum((documentosContables.get(i).getAnyoOrigen() == null) ? ""
						: documentosContables.get(i).getAnyoOrigen(), 4, datoContable, "der");
				// Nº de Referencia de Intervención
				datoContable = montarCabeceraNum(
						(documentosContables.get(i).getNumero() == null) ? "" : documentosContables.get(i).getNumero(),
						6, datoContable, "der");
				// Disponible
				datoContable = montarCabeceraNum((documentosContables.get(i).getDisponible() == null) ? ""
						: documentosContables.get(i).getDisponible(), 4, datoContable, "der");
				// Obligación
				datoContable = montarCabeceraNum((documentosContables.get(i).getObligacion() == null) ? ""
						: documentosContables.get(i).getObligacion(), 4, datoContable, "der");
				// Número de Orden
				datoContable = montarCabeceraStr((documentosContables.get(i).getNumeroOrden() == null) ? ""
						: documentosContables.get(i).getNumeroOrden(), 4, datoContable, "izq");
				// Número de Plurianual
				datoContable = montarCabeceraStr((documentosContables.get(i).getNumeroPlurianual() == null) ? ""
						: documentosContables.get(i).getNumeroPlurianual(), 6, datoContable, "izq");
				// Código de Subvención
				datoContable = montarCabeceraStr((documentosContables.get(i).getCodigoSubvencion() == null) ? ""
						: documentosContables.get(i).getCodigoSubvencion(), 10, datoContable, "izq");
				// Importe de Compromiso Resto
				datoContable = montarCabeceraStr((documentosContables.get(i).getImporteCompromisoResto() == null) ? ""
						: documentosContables.get(i).getImporteCompromisoResto(), 13, datoContable, "izq");
				// Número de Factura
				datoContable = montarCabeceraStr((documentosContables.get(i).getNumeroFactura() == null) ? ""
						: documentosContables.get(i).getNumeroFactura(), 10, datoContable, "izq");
				// Fecha de Factura
				datoContable = montarCabeceraStr((documentosContables.get(i).getFechaFactura() == null) ? ""
						: documentosContables.get(i).getFechaFactura().toString(), 8, datoContable, "izq");
				// Concepto Resumido
				datoContable = montarCabeceraStr((documentosContables.get(i).getConceptoResumido() == null) ? ""
						: documentosContables.get(i).getConceptoResumido(), 80, datoContable, "izq");
				// Tercero
				datoContable = montarCabeceraStr((documentosContables.get(i).getTercero() == null) ? ""
						: documentosContables.get(i).getTercero(), 13, datoContable, "izq");

				// Importe
				if (documentosContables.get(i).getImporte() != null) {
					String importe = String.valueOf(documentosContables.get(i).getImporte());
					if (importe.indexOf(".") >= 0) {
						String importeDecimales = importe.split("\\.")[1];
						if (importeDecimales.length() < 2) {
							importe += "0";
						}
						importe = importe.replace(".", "");
						datoContable = montarCabeceraNum(importe, 13, datoContable, "der");
					} else {
						if (importe.length() < 13) {
							datoContable = montarCabeceraNum(importe, 11, datoContable, "der");
							datoContable += "00";
						} else {
							datoContable += importe;
						}
					}
				} else {
					datoContable = montarCabeceraNum("", 13, datoContable, "der");
				}

				// Ejercicio del Endoso
				datoContable = montarCabeceraNum((documentosContables.get(i).getEjercicioEndoso() == null) ? ""
						: documentosContables.get(i).getEjercicioEndoso(), 4, datoContable, "der");
				// Número de Endoso
				datoContable = montarCabeceraNum((documentosContables.get(i).getNumeroEndoso() == null) ? ""
						: documentosContables.get(i).getNumeroEndoso(), 6, datoContable, "der");
				// Otro Perceptor
				datoContable = montarCabeceraStr((documentosContables.get(i).getOtroPerceptor() == null) ? ""
						: documentosContables.get(i).getOtroPerceptor(), 13, datoContable, "izq");
				// Fecha de Vencimiento
				datoContable = montarCabeceraNum((documentosContables.get(i).getFechaVencimiento() == null) ? ""
						: documentosContables.get(i).getFechaVencimiento().toString(), 8, datoContable, "der");
				// Código de Retención
				datoContable = montarCabeceraNum((documentosContables.get(i).getCodigoRetencion() == null) ? ""
						: documentosContables.get(i).getCodigoRetencion(), 3, datoContable, "der");
				// Base de Retención
				datoContable = montarCabeceraNum((documentosContables.get(i).getBaseRetencion() == null) ? ""
						: documentosContables.get(i).getBaseRetencion(), 13, datoContable, "der");
				// Forma de Pago
				datoContable = montarCabeceraStr((documentosContables.get(i).getFormaPago() == null) ? ""
						: documentosContables.get(i).getFormaPago(), 1, datoContable, "izq");
				// Cuenta Financiera
				datoContable = montarCabeceraStr((documentosContables.get(i).getCuentaFinanciera() == null) ? ""
						: documentosContables.get(i).getCuentaFinanciera(), 10, datoContable, "izq");
				// Ejercicio de Maqueta de Tercero
				datoContable = montarCabeceraNum((documentosContables.get(i).getEjercicioMaquetaTercero() == null) ? ""
						: documentosContables.get(i).getEjercicioMaquetaTercero(), 4, datoContable, "der");
				// Nº de Maqueta de Tercero
				datoContable = montarCabeceraNum((documentosContables.get(i).getNumeroMaquetaTercero() == null) ? ""
						: documentosContables.get(i).getNumeroMaquetaTercero(), 6, datoContable, "der");
				// Ejercicio de Maqueta de Otro Perceptor
				datoContable = montarCabeceraNum(
						(documentosContables.get(i).getEjercicioMaquetaTerceroOtroPerceptor() == null) ? ""
								: documentosContables.get(i).getEjercicioMaquetaTerceroOtroPerceptor(),
						4, datoContable, "der");
				// Nº de Maqueta de Otro Perceptor
				datoContable = montarCabeceraNum(
						(documentosContables.get(i).getNumeroMaquetaTerceroOtroPerceptor() == null) ? ""
								: documentosContables.get(i).getNumeroMaquetaTerceroOtroPerceptor(),
						6, datoContable, "der");
				// Fecha de Inicio Periodo de Pago
				datoContable = montarCabeceraNum(
						(documentosContables.get(i).getFechaInicioPeriodoPago() == null) ? ""
								: documentosContables.get(i).getFechaInicioPeriodoPago().toString(),
						8, datoContable, "der");
				// Código de Contrato
				datoContable = montarCabeceraStr((documentosContables.get(i).getCodigoContrato() == null) ? ""
						: documentosContables.get(i).getCodigoContrato(), 30, datoContable, "izq");
				// Registro Contable
				datoContable = montarCabeceraStr((documentosContables.get(i).getRegistroContable() == null) ? ""
						: documentosContables.get(i).getRegistroContable(), 10, datoContable, "izq");
				// Fecha Concesión / Fecha Resolución
				datoContable = montarCabeceraNum((documentosContables.get(i).getFechaResolucion() == null) ? ""
						: documentosContables.get(i).getFechaResolucion().toString(), 8, datoContable, "der");

				texto.append(datoContable);
				texto.append(System.getProperty("line.separator"));

			}

		}

		String oid = "";

		// Creamos el fichero .LOT y lo subimos al pif

		try {

			InputStream is = new ByteArrayInputStream(texto.toString().getBytes());
			oid = this.pifAdapterService.putFile(is, ficheroContable.getNombreFichero() + ".LOT", "ab60");

		} catch (Exception e) {
			FicherosContablesController.logger.error("[Exception] : " + e.getMessage());
		}

		// Cambiar el estado del ficheroContable a 1
		ficheroContable.setEstado(Constantes.ESTADO_FICHERO_LOT_GENERADO);
		Authentication aut = SecurityContextHolder.getContext().getAuthentication();
		Usuario usuario = new Usuario();
		String username = "";
		if (null != aut) {
			username = (String) aut.getPrincipal();
		}
		usuario.setNombreUsuario(username);
		ficheroContable = this.ficherosContablesService.update(ficheroContable, usuario);

		return oid;

	}

	@RequestMapping(value = "/descargar", method = RequestMethod.POST)
	public @ResponseBody String descargar(HttpServletResponse httpResponse,
			@ModelAttribute ModuloContable moduloContable) throws Exception {

		String rutaPIF = moduloContable.getRutaPIF();
		BufferedInputStream contenidoXml = this.pifAdapterService.getFile(rutaPIF);
		int numRead;
		final int bufferSize = 1024;
		byte[] buffer = new byte[bufferSize];
		ByteArrayOutputStream outString = new ByteArrayOutputStream();
		try {
			while ((numRead = contenidoXml.read(buffer)) != -1) {
				outString.write(buffer, 0, numRead);
			}
		} finally {
			contenidoXml.close();
		}
		byte[] strbase64Doc1 = outString.toByteArray();

		String nombreDocumento = rutaPIF.substring(rutaPIF.lastIndexOf("/") + 1).trim().replaceAll("\"", "");
		httpResponse.setHeader("Content-Disposition", "attachment; filename=\"" + nombreDocumento + "\"");
		Cookie cookie = new Cookie("fileDownload", "true");
		cookie.setMaxAge(2);
		cookie.setPath("/");
		httpResponse.addCookie(cookie);
		httpResponse.setContentType("application/rtf");
		// httpResponse.setContentType("application/vnd.ms-excel");

		httpResponse.setContentLength(strbase64Doc1.length);
		httpResponse.getOutputStream().write(strbase64Doc1);

		httpResponse.getOutputStream().flush();
		httpResponse.getOutputStream().close();
		return null;
	}

	public String montarCabeceraNum(String valor, Integer num, String cabecera, String lado) {
		if (String.valueOf(valor).length() < num) {
			if ("izq".equals(lado)) {
				cabecera = cabecera + valor;
			}
			for (int x = 1; x <= (num - String.valueOf(valor).length()); x++) {
				cabecera = cabecera + "0";
			}
			if ("der".equals(lado)) {
				cabecera = cabecera + valor;
			}
		} else
			cabecera = cabecera + valor;

		return cabecera;
	}

	public String montarCabeceraStr(String valor, Integer num, String cabecera, String lado) {
		if (String.valueOf(valor).length() < num) {
			if ("izq".equals(lado)) {
				cabecera = cabecera + valor;
			}
			for (int x = 1; x <= (num - String.valueOf(valor).length()); x++) {
				cabecera = cabecera + " ";
			}
			if ("der".equals(lado)) {
				cabecera = cabecera + valor;
			}

		} else
			cabecera = cabecera + valor;

		return cabecera;
	}

}
