package com.ejie.ab60.control.preguntasExpediente;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import com.ejie.ab60.model.preguntasExpediente.TiposPreguntas;
import com.ejie.ab60.service.preguntasExpediente.TiposPreguntasService;

/**
 * PreguntasExpedienteController  
 * 
 *  
 */

@Controller
@RequestMapping(value = "/tipospreguntas")

public class TiposPreguntasController {

	private static final Logger logger = LoggerFactory.getLogger(TiposPreguntasController.class);

	@Autowired
	private TiposPreguntasService tiposPreguntasService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterTiposPreguntas
	 *            TiposPreguntas Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<TiposPreguntas> Lista de objetos correspondientes a la
	 *         busqueda realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<TiposPreguntas> getAll(@ModelAttribute TiposPreguntas filterTiposPreguntas) {
		TiposPreguntasController.logger.info("[GET - find_ALL] : Obtener TiposPreguntas por filtro");
		return this.tiposPreguntasService.findAll(filterTiposPreguntas, null);
	}

}
